(function(modules) {
    var installedModules = {};
    function __webpack_require__(moduleId) {
        if (installedModules[moduleId]) {
            return installedModules[moduleId].exports;
        }
        var module = installedModules[moduleId] = {
            i: moduleId,
            l: false,
            exports: {}
        };
        modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
        module.l = true;
        return module.exports;
    }
    __webpack_require__.m = modules;
    __webpack_require__.c = installedModules;
    __webpack_require__.d = function(exports, name, getter) {
        if (!__webpack_require__.o(exports, name)) {
            Object.defineProperty(exports, name, {
                enumerable: true,
                get: getter
            });
        }
    };
    __webpack_require__.r = function(exports) {
        if (typeof Symbol !== "undefined" && Symbol.toStringTag) {
            Object.defineProperty(exports, Symbol.toStringTag, {
                value: "Module"
            });
        }
        Object.defineProperty(exports, "__esModule", {
            value: true
        });
    };
    __webpack_require__.t = function(value, mode) {
        if (mode & 1) value = __webpack_require__(value);
        if (mode & 8) return value;
        if (mode & 4 && typeof value === "object" && value && value.__esModule) return value;
        var ns = Object.create(null);
        __webpack_require__.r(ns);
        Object.defineProperty(ns, "default", {
            enumerable: true,
            value
        });
        if (mode & 2 && typeof value != "string") for (var key in value) __webpack_require__.d(ns, key, function(key) {
            return value[key];
        }.bind(null, key));
        return ns;
    };
    __webpack_require__.n = function(module) {
        var getter = module && module.__esModule ? function getDefault() {
            return module["default"];
        } : function getModuleExports() {
            return module;
        };
        __webpack_require__.d(getter, "a", getter);
        return getter;
    };
    __webpack_require__.o = function(object, property) {
        return Object.prototype.hasOwnProperty.call(object, property);
    };
    __webpack_require__.p = "";
    return __webpack_require__(__webpack_require__.s = 253);
})([ function(module, exports) {
    module.exports = require("stream");
}, function(module, exports) {
    module.exports = require("util");
}, function(module, exports, __webpack_require__) {
    "use strict";
    const IPC = __webpack_require__(247);
    class IPCModule extends IPC {
        constructor() {
            super();
            Object.defineProperty(this, "IPC", {
                enumerable: true,
                writable: false,
                value: IPC
            });
        }
    }
    module.exports = new IPCModule;
}, function(module, exports) {
    module.exports = require("fs");
}, function(module, exports) {
    module.exports = require("path");
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.DEFAULT_ALIGNMENT = exports.XXHASH_SEED = exports.NO_MATCHING_FILE_MSG = exports.CHUNK_SIZE = exports.RETRY_BASE_TIMEOUT = exports.SPEED_WINDOW = exports.PROGRESS_EMISSION_INTERVAL = void 0;
    exports.PROGRESS_EMISSION_INTERVAL = 1e3 / 4;
    exports.SPEED_WINDOW = 2;
    exports.RETRY_BASE_TIMEOUT = 100;
    exports.CHUNK_SIZE = 1024 ** 2;
    exports.NO_MATCHING_FILE_MSG = "Can't find a matching file in this zip archive";
    exports.XXHASH_SEED = 1163150152;
    exports.DEFAULT_ALIGNMENT = 512;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.once = exports.every = exports.sumBy = exports.maxBy = exports.minBy = exports.delay = exports.fromCallback = exports.asCallback = exports.difference = exports.sparseStreamToBuffer = exports.streamToBuffer = void 0;
    const aligned_lockable_buffer_1 = __webpack_require__(12);
    function streamToBuffer(stream) {
        return new Promise((resolve, reject) => {
            const chunks = [];
            stream.on("error", reject);
            stream.on("data", async chunk => {
                let data;
                if (aligned_lockable_buffer_1.isAlignedLockableBuffer(chunk)) {
                    const unlock = await chunk.rlock();
                    try {
                        data = Buffer.allocUnsafe(chunk.length);
                        chunk.copy(data);
                    } finally {
                        unlock();
                    }
                } else {
                    data = chunk;
                }
                chunks.push(data);
            });
            stream.on("end", () => {
                resolve(Buffer.concat(chunks));
            });
            stream.resume();
        });
    }
    exports.streamToBuffer = streamToBuffer;
    async function sparseStreamToBuffer(stream) {
        const chunks = [];
        await new Promise((resolve, reject) => {
            stream.on("error", reject);
            stream.on("end", resolve);
            stream.on("data", async chunk => {
                if (aligned_lockable_buffer_1.isAlignedLockableBuffer(chunk.buffer)) {
                    let unlock;
                    try {
                        unlock = await chunk.buffer.rlock();
                    } catch (error) {
                        reject(error);
                        return;
                    }
                    let data;
                    try {
                        data = Buffer.allocUnsafe(chunk.buffer.length);
                        chunk.buffer.copy(data);
                    } finally {
                        unlock();
                    }
                    chunk.buffer = data;
                }
                chunks.push(chunk);
            });
        });
        if (chunks.length === 0) {
            return Buffer.alloc(0);
        }
        const lastChunk = chunks[chunks.length - 1];
        const result = Buffer.alloc(lastChunk.position + lastChunk.buffer.length);
        for (const chunk of chunks) {
            chunk.buffer.copy(result, chunk.position);
        }
        return result;
    }
    exports.sparseStreamToBuffer = sparseStreamToBuffer;
    function difference(setA, setB) {
        const _difference = new Set(setA);
        for (const elem of setB) {
            _difference.delete(elem);
        }
        return _difference;
    }
    exports.difference = difference;
    async function asCallback(promise, callback) {
        try {
            const value = await promise;
            callback(null, value);
        } catch (error) {
            callback(error);
        }
    }
    exports.asCallback = asCallback;
    async function fromCallback(fn) {
        return await new Promise((resolve, reject) => {
            fn((error, result) => {
                if (error != null) {
                    reject(error);
                } else {
                    resolve(result);
                }
            });
        });
    }
    exports.fromCallback = fromCallback;
    async function delay(ms) {
        await new Promise(resolve => {
            setTimeout(resolve, ms);
        });
    }
    exports.delay = delay;
    function minBy(things, iteratee) {
        let result;
        let minimum;
        for (const t of things) {
            const value = iteratee(t);
            if (minimum === undefined || value < minimum) {
                minimum = value;
                result = t;
            }
        }
        return result;
    }
    exports.minBy = minBy;
    function maxBy(things, iteratee) {
        return minBy(things, t => -iteratee(t));
    }
    exports.maxBy = maxBy;
    function sumBy(things, iteratee) {
        let result = 0;
        for (const t of things) {
            result += iteratee(t);
        }
        return result;
    }
    exports.sumBy = sumBy;
    function every(things) {
        for (const t of things) {
            if (!t) {
                return false;
            }
        }
        return true;
    }
    exports.every = every;
    function once(fn) {
        let ran = false;
        let result;
        return () => {
            if (!ran) {
                result = fn();
                ran = true;
            }
            return result;
        };
    }
    exports.once = once;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.SourceDestination = exports.SparseStreamVerifier = exports.StreamVerifier = exports.Verifier = exports.SourceDestinationFs = exports.createHasher = exports.ProgressHashStream = exports.CountingHashStream = void 0;
    const events_1 = __webpack_require__(9);
    const fileType = __webpack_require__(126);
    const partitioninfo_1 = __webpack_require__(33);
    const path_1 = __webpack_require__(4);
    const process_1 = __webpack_require__(43);
    const xxhash_1 = __webpack_require__(72);
    const aligned_lockable_buffer_1 = __webpack_require__(12);
    const constants_1 = __webpack_require__(5);
    const errors_1 = __webpack_require__(8);
    const sparse_filter_stream_1 = __webpack_require__(34);
    const sparse_read_stream_1 = __webpack_require__(50);
    const utils_1 = __webpack_require__(6);
    const progress_1 = __webpack_require__(13);
    const BITS = process_1.arch === "x64" || process_1.arch === "aarch64" ? 64 : 32;
    class CountingHashStream extends xxhash_1.Stream {
        constructor() {
            super(...arguments);
            this.bytesWritten = 0;
        }
        async __transform(chunk, encoding) {
            const unlock = aligned_lockable_buffer_1.isAlignedLockableBuffer(chunk) ? await chunk.rlock() : undefined;
            try {
                await utils_1.fromCallback(callback => {
                    super._transform(chunk, encoding, callback);
                });
            } finally {
                unlock === null || unlock === void 0 ? void 0 : unlock();
            }
            this.bytesWritten += chunk.length;
        }
        _transform(chunk, encoding, callback) {
            utils_1.asCallback(this.__transform(chunk, encoding), callback);
        }
    }
    exports.CountingHashStream = CountingHashStream;
    exports.ProgressHashStream = progress_1.makeClassEmitProgressEvents(CountingHashStream, "bytesWritten", "bytesWritten");
    function createHasher() {
        const hasher = new exports.ProgressHashStream(constants_1.XXHASH_SEED, BITS, "buffer");
        hasher.on("finish", async () => {
            const checksum = (await utils_1.streamToBuffer(hasher)).toString("hex");
            hasher.emit("checksum", checksum);
        });
        return hasher;
    }
    exports.createHasher = createHasher;
    class SourceDestinationFs {
        constructor(source) {
            this.source = source;
        }
        open(_path, _options, callback) {
            callback(null, 1);
        }
        close(_fd, callback) {
            callback(null);
        }
        fstat(_fd, callback) {
            this.source.getMetadata().then(metadata => {
                if (metadata.size === undefined) {
                    callback(new Error("No size"));
                    return;
                }
                callback(null, {
                    size: metadata.size
                });
            }).catch(callback);
        }
        read(_fd, buffer, bufferOffset, length, sourceOffset, callback) {
            this.source.read(buffer, bufferOffset, length, sourceOffset).then(res => {
                callback(null, res.bytesRead, res.buffer);
            }).catch(callback);
        }
    }
    exports.SourceDestinationFs = SourceDestinationFs;
    class Verifier extends events_1.EventEmitter {
        constructor() {
            super(...arguments);
            this.progress = {
                bytes: 0,
                position: 0,
                speed: 0,
                averageSpeed: 0
            };
        }
        handleEventsAndPipe(stream, meter) {
            meter.on("progress", progress => {
                this.progress = progress;
                this.emit("progress", progress);
            });
            stream.on("end", this.emit.bind(this, "end"));
            meter.on("finish", this.emit.bind(this, "finish"));
            stream.once("error", () => {
                stream.unpipe(meter);
                meter.end();
            });
            stream.pipe(meter);
        }
    }
    exports.Verifier = Verifier;
    class StreamVerifier extends Verifier {
        constructor(source, checksum, size) {
            super();
            this.source = source;
            this.checksum = checksum;
            this.size = size;
        }
        async run() {
            const stream = await this.source.createReadStream({
                end: this.size - 1,
                alignment: this.source.getAlignment()
            });
            stream.on("error", this.emit.bind(this, "error"));
            const hasher = createHasher();
            hasher.on("error", this.emit.bind(this, "error"));
            hasher.on("checksum", streamChecksum => {
                if (streamChecksum !== this.checksum) {
                    this.emit("error", new errors_1.ChecksumVerificationError(`Source and destination checksums do not match: ${this.checksum} !== ${streamChecksum}`, streamChecksum, this.checksum));
                }
            });
            this.handleEventsAndPipe(stream, hasher);
        }
    }
    exports.StreamVerifier = StreamVerifier;
    class SparseStreamVerifier extends Verifier {
        constructor(source, blocks) {
            super();
            this.source = source;
            this.blocks = blocks;
        }
        async run() {
            const alignment = this.source.getAlignment();
            let stream;
            if (await this.source.canRead()) {
                stream = new sparse_read_stream_1.SparseReadStream({
                    source: this.source,
                    blocks: this.blocks,
                    chunkSize: constants_1.CHUNK_SIZE,
                    verify: true,
                    generateChecksums: false,
                    alignment,
                    numBuffers: 2
                });
                stream.on("error", this.emit.bind(this, "error"));
            } else if (await this.source.canCreateReadStream()) {
                const originalStream = await this.source.createReadStream();
                originalStream.once("error", error => {
                    originalStream.unpipe(transform);
                    this.emit("error", error);
                });
                const transform = new sparse_filter_stream_1.SparseFilterStream({
                    blocks: this.blocks,
                    verify: true,
                    generateChecksums: false
                });
                transform.once("error", error => {
                    originalStream.unpipe(transform);
                    if (typeof originalStream.destroy === "function") {
                        originalStream.destroy();
                    }
                    this.emit("error", error);
                });
                originalStream.pipe(transform);
                stream = transform;
            } else {
                throw new errors_1.NotCapable;
            }
            const meter = new progress_1.ProgressWritable({
                objectMode: true
            });
            this.handleEventsAndPipe(stream, meter);
        }
    }
    exports.SparseStreamVerifier = SparseStreamVerifier;
    class SourceDestination extends events_1.EventEmitter {
        constructor() {
            super(...arguments);
            this.isOpen = false;
        }
        static register(Cls) {
            if (Cls.mimetype !== undefined) {
                SourceDestination.mimetypes.set(Cls.mimetype, Cls);
            }
        }
        getAlignment() {
            return undefined;
        }
        async canRead() {
            return false;
        }
        async canWrite() {
            return false;
        }
        async canCreateReadStream() {
            return false;
        }
        async canCreateSparseReadStream() {
            return false;
        }
        async canCreateWriteStream() {
            return false;
        }
        async canCreateSparseWriteStream() {
            return false;
        }
        async getMetadata() {
            if (this.metadata === undefined) {
                this.metadata = await this._getMetadata();
            }
            return this.metadata;
        }
        async _getMetadata() {
            return {};
        }
        async read(_buffer, _bufferOffset, _length, _sourceOffset) {
            throw new errors_1.NotCapable;
        }
        async write(_buffer, _bufferOffset, _length, _fileOffset) {
            throw new errors_1.NotCapable;
        }
        async createReadStream(_options = {}) {
            throw new errors_1.NotCapable;
        }
        async createSparseReadStream(_options = {}) {
            throw new errors_1.NotCapable;
        }
        async getBlocks() {
            throw new errors_1.NotCapable;
        }
        async createWriteStream(_options = {}) {
            throw new errors_1.NotCapable;
        }
        async createSparseWriteStream(_options = {}) {
            throw new errors_1.NotCapable;
        }
        async open() {
            if (!this.isOpen) {
                await this._open();
                this.isOpen = true;
            }
        }
        async close() {
            if (this.isOpen) {
                await this._close();
                this.isOpen = false;
            }
        }
        async _open() {}
        async _close() {}
        createVerifier(checksumOrBlocks, size) {
            if (Array.isArray(checksumOrBlocks)) {
                for (const block of checksumOrBlocks) {
                    if (block.checksumType === undefined || block.checksum === undefined) {
                        throw new Error("Block is missing checksum or checksumType attributes, can not create verifier");
                    }
                }
                return new SparseStreamVerifier(this, checksumOrBlocks);
            } else {
                if (size === undefined) {
                    throw new Error("A size argument is required for creating a stream checksum verifier");
                }
                return new StreamVerifier(this, checksumOrBlocks, size);
            }
        }
        async getMimeTypeFromName() {
            const metadata = await this.getMetadata();
            if (metadata.name === undefined) {
                return;
            }
            const extension = path_1.extname(metadata.name).toLowerCase();
            if (extension === ".dmg") {
                return "application/x-apple-diskimage";
            }
        }
        async getMimeTypeFromContent() {
            let stream;
            try {
                stream = await this.createReadStream({
                    end: 263,
                    alignment: this.getAlignment()
                });
            } catch (error) {
                if (error instanceof errors_1.NotCapable) {
                    return;
                }
                throw error;
            }
            const ft = fileType(await utils_1.streamToBuffer(stream));
            if (ft !== null) {
                return ft.mime;
            }
        }
        async getInnerSourceHelper(mimetype) {
            if (mimetype === undefined) {
                return this;
            }
            const Cls = SourceDestination.mimetypes.get(mimetype);
            if (Cls === undefined) {
                return this;
            }
            if (Cls.requiresRandomReadableSource && !await this.canRead()) {
                throw new errors_1.NotCapable(`Can not read a ${Cls.name} from a ${this.constructor.name}.`);
            }
            const innerSource = new Cls(this);
            return innerSource.getInnerSource();
        }
        async getInnerSource() {
            await this.open();
            const metadata = await this.getMetadata();
            if (metadata.isEtch === true) {
                return this;
            }
            let mimetype = await this.getMimeTypeFromName();
            if (mimetype !== undefined) {
                try {
                    return await this.getInnerSourceHelper(mimetype);
                } catch (error) {
                    if (error instanceof errors_1.NotCapable) {
                        throw error;
                    }
                }
            }
            mimetype = await this.getMimeTypeFromContent();
            return this.getInnerSourceHelper(mimetype);
        }
        async getPartitionTable() {
            const stream = await this.createReadStream({
                end: 34 * 512,
                alignment: this.getAlignment()
            });
            const buffer = await utils_1.streamToBuffer(stream);
            try {
                return await partitioninfo_1.getPartitions(buffer, {
                    getLogical: false
                });
            } catch (_a) {}
        }
    }
    exports.SourceDestination = SourceDestination;
    SourceDestination.imageExtensions = [ "img", "iso", "bin", "dsk", "hddimg", "raw", "dmg", "sdcard", "rpi-sdimg", "wic" ];
    SourceDestination.mimetypes = new Map;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.isTransientError = exports.BlocksVerificationError = exports.ChecksumVerificationError = exports.VerificationError = exports.NotCapable = void 0;
    const process_1 = __webpack_require__(43);
    class NotCapable extends Error {}
    exports.NotCapable = NotCapable;
    class VerificationError extends Error {
        constructor() {
            super(...arguments);
            this.code = "EVALIDATION";
        }
    }
    exports.VerificationError = VerificationError;
    class ChecksumVerificationError extends VerificationError {
        constructor(message, checksum, expectedChecksum) {
            super(message);
            this.checksum = checksum;
            this.expectedChecksum = expectedChecksum;
        }
    }
    exports.ChecksumVerificationError = ChecksumVerificationError;
    function blocksVerificationErrorMessage(blocksWithChecksum, checksum) {
        const start = blocksWithChecksum.blocks[0].offset;
        const lastBlock = blocksWithChecksum.blocks[blocksWithChecksum.blocks.length - 1];
        const end = lastBlock.offset + lastBlock.length - 1;
        return `Checksum does not match for range [${start}, ${end}]: "${blocksWithChecksum.checksum}" != "${checksum}"`;
    }
    class BlocksVerificationError extends VerificationError {
        constructor(blocks, checksum) {
            super(blocksVerificationErrorMessage(blocks, checksum));
            this.blocks = blocks;
            this.checksum = checksum;
        }
    }
    exports.BlocksVerificationError = BlocksVerificationError;
    function isTransientError(error) {
        if (process_1.platform === "darwin") {
            return error.code === "ENXIO" || error.code === "EBUSY";
        } else if (process_1.platform === "linux") {
            return error.code === "EIO" || error.code === "EBUSY";
        } else if (process_1.platform === "win32") {
            return error.code === "ENOENT" || error.code === "UNKNOWN";
        }
        return false;
    }
    exports.isTransientError = isTransientError;
}, function(module, exports) {
    module.exports = require("events");
}, function(module, exports, __webpack_require__) {
    "use strict";
    var bind = __webpack_require__(92);
    var toString = Object.prototype.toString;
    function isArray(val) {
        return toString.call(val) === "[object Array]";
    }
    function isUndefined(val) {
        return typeof val === "undefined";
    }
    function isBuffer(val) {
        return val !== null && !isUndefined(val) && val.constructor !== null && !isUndefined(val.constructor) && typeof val.constructor.isBuffer === "function" && val.constructor.isBuffer(val);
    }
    function isArrayBuffer(val) {
        return toString.call(val) === "[object ArrayBuffer]";
    }
    function isFormData(val) {
        return typeof FormData !== "undefined" && val instanceof FormData;
    }
    function isArrayBufferView(val) {
        var result;
        if (typeof ArrayBuffer !== "undefined" && ArrayBuffer.isView) {
            result = ArrayBuffer.isView(val);
        } else {
            result = val && val.buffer && val.buffer instanceof ArrayBuffer;
        }
        return result;
    }
    function isString(val) {
        return typeof val === "string";
    }
    function isNumber(val) {
        return typeof val === "number";
    }
    function isObject(val) {
        return val !== null && typeof val === "object";
    }
    function isDate(val) {
        return toString.call(val) === "[object Date]";
    }
    function isFile(val) {
        return toString.call(val) === "[object File]";
    }
    function isBlob(val) {
        return toString.call(val) === "[object Blob]";
    }
    function isFunction(val) {
        return toString.call(val) === "[object Function]";
    }
    function isStream(val) {
        return isObject(val) && isFunction(val.pipe);
    }
    function isURLSearchParams(val) {
        return typeof URLSearchParams !== "undefined" && val instanceof URLSearchParams;
    }
    function trim(str) {
        return str.replace(/^\s*/, "").replace(/\s*$/, "");
    }
    function isStandardBrowserEnv() {
        if (typeof navigator !== "undefined" && (navigator.product === "ReactNative" || navigator.product === "NativeScript" || navigator.product === "NS")) {
            return false;
        }
        return typeof window !== "undefined" && typeof document !== "undefined";
    }
    function forEach(obj, fn) {
        if (obj === null || typeof obj === "undefined") {
            return;
        }
        if (typeof obj !== "object") {
            obj = [ obj ];
        }
        if (isArray(obj)) {
            for (var i = 0, l = obj.length; i < l; i++) {
                fn.call(null, obj[i], i, obj);
            }
        } else {
            for (var key in obj) {
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    fn.call(null, obj[key], key, obj);
                }
            }
        }
    }
    function merge() {
        var result = {};
        function assignValue(val, key) {
            if (typeof result[key] === "object" && typeof val === "object") {
                result[key] = merge(result[key], val);
            } else {
                result[key] = val;
            }
        }
        for (var i = 0, l = arguments.length; i < l; i++) {
            forEach(arguments[i], assignValue);
        }
        return result;
    }
    function deepMerge() {
        var result = {};
        function assignValue(val, key) {
            if (typeof result[key] === "object" && typeof val === "object") {
                result[key] = deepMerge(result[key], val);
            } else if (typeof val === "object") {
                result[key] = deepMerge({}, val);
            } else {
                result[key] = val;
            }
        }
        for (var i = 0, l = arguments.length; i < l; i++) {
            forEach(arguments[i], assignValue);
        }
        return result;
    }
    function extend(a, b, thisArg) {
        forEach(b, (function assignValue(val, key) {
            if (thisArg && typeof val === "function") {
                a[key] = bind(val, thisArg);
            } else {
                a[key] = val;
            }
        }));
        return a;
    }
    module.exports = {
        isArray,
        isArrayBuffer,
        isBuffer,
        isFormData,
        isArrayBufferView,
        isString,
        isNumber,
        isObject,
        isUndefined,
        isDate,
        isFile,
        isBlob,
        isFunction,
        isStream,
        isURLSearchParams,
        isStandardBrowserEnv,
        forEach,
        merge,
        deepMerge,
        extend,
        trim
    };
}, function(module, exports) {
    module.exports = require("os");
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.AlignedReadableState = exports.isAlignedLockableBuffer = exports.createBuffer = void 0;
    const direct_io_1 = __webpack_require__(29);
    const RWMutex = __webpack_require__(120);
    function alignedLockableBufferSlice(start, end) {
        const slice = Buffer.prototype.slice.call(this, start, end);
        return attachMutex(slice, this.alignment, this.lock, this.rlock);
    }
    function attachMutex(buf, alignment, lock, rlock) {
        const buffer = buf;
        buffer.alignment = alignment;
        buffer.lock = lock;
        buffer.rlock = rlock;
        buffer.slice = alignedLockableBufferSlice;
        return buffer;
    }
    function createBuffer(size, alignment) {
        const mutex = new RWMutex;
        return attachMutex(direct_io_1.getAlignedBuffer(size, alignment), alignment, mutex.lock.bind(mutex), mutex.rlock.bind(mutex));
    }
    exports.createBuffer = createBuffer;
    function isAlignedLockableBuffer(buffer) {
        return "rlock" in buffer;
    }
    exports.isAlignedLockableBuffer = isAlignedLockableBuffer;
    class AlignedReadableState {
        constructor(bufferSize, alignment, numBuffers) {
            this.bufferSize = bufferSize;
            this.alignment = alignment;
            this.numBuffers = numBuffers;
            this.currentBufferIndex = 0;
            this.buffers = new Array(numBuffers);
        }
        getCurrentBuffer() {
            let buffer = this.buffers[this.currentBufferIndex];
            if (buffer === undefined) {
                buffer = createBuffer(this.bufferSize, this.alignment);
                this.buffers[this.currentBufferIndex] = buffer;
            }
            this.currentBufferIndex = (this.currentBufferIndex + 1) % this.numBuffers;
            return buffer;
        }
    }
    exports.AlignedReadableState = AlignedReadableState;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.ProgressWritable = exports.CountingWritable = exports.makeClassEmitProgressEvents = void 0;
    const stream_1 = __webpack_require__(0);
    const constants_1 = __webpack_require__(5);
    const speedometer_1 = __webpack_require__(125);
    function makeClassEmitProgressEvents(Cls, attribute, positionAttribute, interval = constants_1.PROGRESS_EMISSION_INTERVAL) {
        return class extends Cls {
            constructor(...args) {
                super(...args);
                const startTime = Date.now();
                const meter = new speedometer_1.Speedometer(constants_1.SPEED_WINDOW);
                const state = {
                    position: 0,
                    bytes: 0,
                    speed: 0,
                    averageSpeed: 0
                };
                let attributeValue = this[attribute];
                const update = () => {
                    const newValue = this[attribute];
                    const attributeDelta = newValue - attributeValue;
                    if (attributeDelta === 0) {
                        return;
                    }
                    attributeValue = newValue;
                    state.bytes += attributeDelta;
                    const position = this[positionAttribute];
                    if (position !== undefined) {
                        state.position = position;
                    }
                    state.speed = meter.speed(attributeDelta);
                    state.averageSpeed = state.bytes / (Date.now() - startTime) * 1e3;
                    this.emit("progress", state);
                };
                const timer = setInterval(update, interval);
                const clear = () => {
                    clearInterval(timer);
                };
                this.once("error", clear);
                this.once("finish", clear);
                this.once("finish", update);
                this.once("end", clear);
                this.once("end", update);
            }
        };
    }
    exports.makeClassEmitProgressEvents = makeClassEmitProgressEvents;
    class CountingWritable extends stream_1.Writable {
        constructor() {
            super(...arguments);
            this.bytesWritten = 0;
        }
        _write(chunk, _enc, callback) {
            if (Buffer.isBuffer(chunk)) {
                this.bytesWritten = this.position = this.bytesWritten + chunk.length;
            } else {
                this.bytesWritten += chunk.buffer.length;
                this.position = chunk.position + chunk.buffer.length;
            }
            callback();
        }
    }
    exports.CountingWritable = CountingWritable;
    exports.ProgressWritable = makeClassEmitProgressEvents(CountingWritable, "bytesWritten", "position");
}, function(module, exports, __webpack_require__) {
    function MBR(buffer, start, end) {
        if (!(this instanceof MBR) || this.format === "MBR") {
            return MBR.parse(buffer, start, end);
        }
        this.partitions = [];
        this.code = [];
        for (var i = 0; i < this.partitionEntries; i++) {
            this.partitions.push(new MBR.Partition);
        }
        if (Buffer.isBuffer(buffer)) {
            this.parse(buffer, start, end);
        }
    }
    MBR.TABLE_OFFSET = 446;
    MBR.PARTITION_ENTRIES = 4;
    MBR.Partition = __webpack_require__(130);
    MBR.Code = __webpack_require__(131);
    MBR.parse = function(buffer, start, end) {
        var buffer = buffer.slice(start, end);
        var format = MBR.detectFormat(buffer);
        return new MBR[format](buffer);
    };
    MBR.detectFormat = function(buffer) {
        if (!Buffer.isBuffer(buffer)) throw new TypeError("Argument must be a Buffer");
        if (buffer.length < 512) throw new Error("Buffer too small (must be at least 512 bytes)");
        if (buffer.readUInt16LE(510) !== 43605) {
            throw new SyntaxError("Invalid MBR boot signature. Expected 0xAA55, " + "but saw 0x" + buffer.readUInt16LE(510).toString(16).toUpperCase());
        }
        if (buffer[380] === 90 && buffer[381] === 165) {
            return "AST";
        } else if (buffer[252] === 170 && buffer[253] === 85) {
            return "DM";
        } else if (buffer.readUIntBE(2, 6) === 86059724325970) {
            return "NEWLDR";
        } else if (buffer[428] === 120 && buffer[429] === 86) {
            return "AAP";
        } else if (buffer[218] === 0 && buffer[219] === 0) {
            return "MODERN";
        } else {
            return "CLASSIC";
        }
    };
    MBR.createBuffer = function() {
        var buffer = new Buffer(512);
        buffer.fill(0);
        buffer[510] = 85;
        buffer[511] = 170;
        return buffer;
    };
    MBR.isExtendedPartition = function(partition) {
        return MBR.Partition.isExtended(partition.type);
    };
    MBR.prototype = {
        constructor: MBR,
        get buffer() {
            throw new Error("Not implemented");
        },
        set buffer(value) {
            throw new Error("Not implemented");
        },
        get format() {
            return this.constructor.name.toUpperCase();
        },
        get tableOffset() {
            return this.constructor.TABLE_OFFSET;
        },
        get partitionEntries() {
            return this.constructor.PARTITION_ENTRIES;
        },
        parse: function(buffer, start, end) {
            this.buffer = buffer.slice(start, end);
        },
        getEFIPart: function() {
            var i = 0;
            var part = null;
            for (var i = 0; i < this.partitions.length; i++) {
                part = this.partitions[i];
                if (part.type === 238 || part.type === 239) {
                    return part;
                }
            }
            return null;
        }
    };
    module.exports = MBR;
    MBR.CLASSIC = __webpack_require__(132);
    MBR.MODERN = __webpack_require__(133);
    MBR.AAP = __webpack_require__(134);
    MBR.NEWLDR = __webpack_require__(136);
    MBR.AST = __webpack_require__(138);
    MBR.DM = __webpack_require__(139);
}, function(module, exports) {
    function describe(object) {
        return Object.getOwnPropertyNames(object).reduce((function(desc, key) {
            desc[key] = Object.getOwnPropertyDescriptor(object, key);
            return desc;
        }), Object.create(null));
    }
    function inherit(ctor, sctor) {
        ctor.prototype = Object.create(sctor.prototype, describe(ctor.prototype));
    }
    module.exports = inherit;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.BLOCK = exports.CHECKSUM_TYPE = exports.SECTOR_SIZE = void 0;
    exports.SECTOR_SIZE = 512;
    var CHECKSUM_TYPE;
    (function(CHECKSUM_TYPE) {
        CHECKSUM_TYPE[CHECKSUM_TYPE["NONE"] = 0] = "NONE";
        CHECKSUM_TYPE[CHECKSUM_TYPE["CRC32"] = 2] = "CRC32";
    })(CHECKSUM_TYPE = exports.CHECKSUM_TYPE || (exports.CHECKSUM_TYPE = {}));
    var BLOCK;
    (function(BLOCK) {
        BLOCK[BLOCK["ZEROFILL"] = 0] = "ZEROFILL";
        BLOCK[BLOCK["RAW"] = 1] = "RAW";
        BLOCK[BLOCK["FREE"] = 2] = "FREE";
        BLOCK[BLOCK["UDCO"] = 2147483652] = "UDCO";
        BLOCK[BLOCK["UDZO"] = 2147483653] = "UDZO";
        BLOCK[BLOCK["UDBZ"] = 2147483654] = "UDBZ";
        BLOCK[BLOCK["LZFSE"] = 2147483655] = "LZFSE";
        BLOCK[BLOCK["COMMENT"] = 2147483646] = "COMMENT";
        BLOCK[BLOCK["TERMINATOR"] = 4294967295] = "TERMINATOR";
    })(BLOCK = exports.BLOCK || (exports.BLOCK = {}));
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.CompressedSource = exports.getRootStream = exports.isSourceTransform = void 0;
    const path_1 = __webpack_require__(4);
    const errors_1 = __webpack_require__(8);
    const stream_limiter_1 = __webpack_require__(32);
    const source_source_1 = __webpack_require__(24);
    function isSourceTransform(stream) {
        return stream.sourceStream !== undefined;
    }
    exports.isSourceTransform = isSourceTransform;
    function getRootStream(stream) {
        while (isSourceTransform(stream)) {
            stream = stream.sourceStream;
        }
        return stream;
    }
    exports.getRootStream = getRootStream;
    class CompressedSource extends source_source_1.SourceSource {
        async getSize() {
            return;
        }
        async canCreateReadStream() {
            return true;
        }
        async createReadStream({emitProgress = false, start = 0, end} = {}) {
            if (start !== 0) {
                throw new errors_1.NotCapable;
            }
            const stream = await this.source.createReadStream({
                emitProgress
            });
            const transform = this.createTransform();
            stream.pipe(transform);
            transform.sourceStream = stream;
            if (end !== undefined) {
                const limiter = new stream_limiter_1.StreamLimiter(transform, end + 1);
                limiter.sourceStream = transform;
                limiter.on("finish", () => {
                    stream.on("error", err => {
                        if (err.code !== "EBADF") {
                            throw err;
                        }
                    });
                });
                return limiter;
            }
            return transform;
        }
        async getSizeFromPartitionTable() {
            try {
                const partitions = await this.getPartitionTable();
                if (partitions !== undefined) {
                    const lastByte = Math.max(...partitions.partitions.map(({offset, size}) => offset + size));
                    if (lastByte !== -Infinity) {
                        return lastByte;
                    }
                }
            } catch (error) {}
        }
        async _getMetadata() {
            const sourceMetadata = await this.source.getMetadata();
            const compressedSize = sourceMetadata.compressedSize || sourceMetadata.size;
            const size = await this.getSize();
            let name;
            if (sourceMetadata.name !== undefined) {
                name = path_1.basename(sourceMetadata.name, path_1.extname(sourceMetadata.name));
            }
            return {
                isCompressed: true,
                name,
                size: size === null || size === void 0 ? void 0 : size.size,
                compressedSize,
                isSizeEstimated: size === null || size === void 0 ? void 0 : size.isEstimated
            };
        }
    }
    exports.CompressedSource = CompressedSource;
}, function(module, exports) {
    module.exports = require("zlib");
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.blocksLength = exports.createSparseReaderStateIterator = void 0;
    const crypto_1 = __webpack_require__(20);
    const constants_1 = __webpack_require__(5);
    const errors_1 = __webpack_require__(8);
    const lazy_1 = __webpack_require__(35);
    function createHasher(checksumType) {
        if (checksumType === "crc32") {
            return lazy_1.getCrc().createHash();
        } else if (checksumType === "sha1" || checksumType === "sha256") {
            return crypto_1.createHash(checksumType);
        } else if (checksumType === "xxhash32") {
            const xxHash = lazy_1.getXXHash();
            return new xxHash(constants_1.XXHASH_SEED);
        } else if (checksumType === "xxhash64") {
            const {XXHash64} = lazy_1.getXXHash();
            return new XXHash64(constants_1.XXHASH_SEED);
        }
    }
    function* createSparseReaderStateIterator(blocks, verify, generateChecksums) {
        if (verify && generateChecksums) {
            throw new Error("verify and generateChecksums are mutually exclusive");
        }
        if (generateChecksums) {
            for (const block of blocks) {
                if (block.checksumType === undefined) {
                    throw new Error("All blocks must have a checksumType if generateChecksums is true");
                }
            }
        }
        for (const block of blocks) {
            const hasher = createHasher(block.checksumType);
            for (const subBlock of block.blocks) {
                yield {
                    block,
                    subBlock,
                    hasher
                };
            }
            verifyOrGenerateChecksum(hasher, block, verify, generateChecksums);
        }
    }
    exports.createSparseReaderStateIterator = createSparseReaderStateIterator;
    function verifyOrGenerateChecksum(hasher, blocks, verify, generateChecksums) {
        if (hasher !== undefined) {
            const checksum = hasher.digest("hex");
            if (generateChecksums) {
                blocks.checksum = checksum;
            } else if (verify && blocks.checksum !== checksum) {
                throw new errors_1.BlocksVerificationError(blocks, checksum);
            }
        }
    }
    function blocksLength(blocks) {
        let sum = 0;
        for (const block of blocks) {
            for (const blk of block.blocks) {
                sum += blk.length;
            }
        }
        return sum;
    }
    exports.blocksLength = blocksLength;
}, function(module, exports) {
    module.exports = require("crypto");
}, function(module, exports, __webpack_require__) {
    var S = __webpack_require__(25), _xok = __webpack_require__(159);
    exports.allocBuffer = Buffer.alloc || function(len, val) {
        var b = Buffer(len);
        if (arguments.length > 1) b.fill(val);
        return b;
    };
    exports.bufferFrom = Buffer.from || function(arg0, arg1) {
        return arguments.length > 1 ? Buffer(arg0, arg1) : Buffer(arg0);
    };
    exports.workaroundTessel380 = !Buffer.from && function() {
        var b = Buffer([ 0 ]), s = b.slice(0);
        return (s[0] = 255) !== b[0];
    }();
    var oldslice;
    if (!Buffer.alloc && Buffer(5).slice(10).length < 0) oldslice = Buffer.prototype.slice, 
    Buffer.prototype.slice = function(s, e) {
        if (s > this.length) s = this.length;
        return arguments.length > 1 ? oldslice.call(this, s, e) : oldslice.call(this, s);
    };
    exports.absoluteSteps = function(path) {
        var steps = [];
        path.split("/").forEach((function(str) {
            if (str === "..") steps.pop(); else if (str && str !== ".") steps.push(str);
        }));
        return steps.map(exports.longname);
    };
    exports.absolutePath = function(path) {
        return "/" + exports.absoluteSteps(path).join("/");
    };
    exports.parseFlags = function(flags) {
        var info, _dir;
        if (flags[0] === "\\") {
            flags = flags.slice(1);
            _dir = true;
        }
        switch (flags) {
          case "r":
            info = {
                read: true,
                write: false,
                create: false
            };
            break;

          case "r+":
            info = {
                read: true,
                write: true,
                create: false
            };
            break;

          case "rs":
            info = {
                read: true,
                write: false,
                create: false,
                sync: true
            };
            break;

          case "rs+":
            info = {
                read: true,
                write: true,
                create: false,
                sync: true
            };
            break;

          case "w":
            info = {
                read: false,
                write: true,
                create: true,
                truncate: true
            };
            break;

          case "wx":
            info = {
                read: false,
                write: true,
                create: true,
                exclusive: true
            };
            break;

          case "w+":
            info = {
                read: true,
                write: true,
                create: true,
                truncate: true
            };
            break;

          case "wx+":
            info = {
                read: true,
                write: true,
                create: true,
                exclusive: true
            };
            break;

          case "a":
            info = {
                read: false,
                write: true,
                create: true,
                append: true
            };
            break;

          case "ax":
            info = {
                read: false,
                write: true,
                create: true,
                append: true,
                exclusive: true
            };
            break;

          case "a+":
            info = {
                read: true,
                write: true,
                create: true,
                append: true
            };
            break;

          case "ax+":
            info = {
                read: true,
                write: true,
                create: true,
                append: true,
                exclusive: true
            };
            break;

          default:
            throw Error("Uknown mode: " + flags);
        }
        if (info.sync) throw Error("Mode not implemented.");
        if (_dir) info._openDir = true;
        return info;
    };
    var _snInvalid = /[^A-Z0-9$%'-_@~`!(){}^#&.]/g;
    exports.shortname = function(name) {
        var lossy = false;
        name = name.toUpperCase().replace(/ /g, "").replace(/^\.+/, "");
        name = name.replace(_snInvalid, (function() {
            lossy = true;
            return "_";
        }));
        var parts = name.split("."), basis3 = parts.pop(), basis8 = parts.join("");
        if (!parts.length) {
            basis8 = basis3;
            basis3 = "   ";
        }
        if (basis8.length > 8) {
            basis8 = basis8.slice(0, 8);
            lossy = true;
        } else while (basis8.length < 8) basis8 += " ";
        if (basis3.length > 3) {
            basis3 = basis3.slice(0, 3);
            lossy = true;
        } else while (basis3.length < 3) basis3 += " ";
        return {
            filename: basis8,
            extension: basis3,
            _lossy: lossy
        };
        return {
            basis: [ basis8, basis3 ],
            lossy
        };
    };
    var _lnInvalid = /[^a-zA-Z0-9$%'-_@~`!(){}^#&.+,;=[\] ]/g;
    exports.longname = function(name) {
        name = name.trim().replace(/\.+$/, "").replace(_lnInvalid, (function(c) {
            if (c.length > 1) throw Error("Internal problem: unexpected match length!");
            if (c.charCodeAt(0) > 127) return c; else throw Error("Invalid character " + JSON.stringify(c) + " in name.");
            lossy = true;
            return "_";
        }));
        if (name.length > 255) throw Error("Name is too long.");
        return name;
    };
    function nameChkSum(sum, c) {
        return (sum & 1 ? 128 : 0) + (sum >>> 1) + c & 255;
    }
    function reduceBuffer(buf, start, end, fn, res) {
        for (var i = start; i < end; ++i) {
            res = fn(res, buf[i]);
        }
        return res;
    }
    exports.checksumName = function(buf, off) {
        off || (off = 0);
        var len = S.dirEntry.fields["Name"].size;
        return reduceBuffer(buf, off, off + len, nameChkSum, 0);
    };
    exports.fmtHex = function(n, ff) {
        return (1 + ff + n).toString(16).slice(1);
    };
    exports.delayedCall = function(fn) {
        if (!fn) throw Error("No function provided!");
        var ctx = this, args = Array.prototype.slice.call(arguments, 1);
        setImmediate((function() {
            fn.apply(ctx, args);
        }));
    };
    exports.adjustedPos = function(vol, pos, bytes) {
        var _pos = {
            chain: pos.chain,
            sector: pos.sector,
            offset: pos.offset + bytes
        }, secSize = vol._sectorSize;
        while (_pos.offset >= secSize) {
            _pos.sector += 1;
            _pos.offset -= secSize;
        }
        return _pos;
    };
    exports.extend = _xok;
    var _prevDbg = Date.now(), _thresh = 50;
    function log(level) {
        if (level < log.level) return;
        var now = Date.now(), diff = now - _prevDbg;
        arguments[0] = (diff < _thresh ? " " : "") + diff.toFixed(0) + "ms";
        console.log.apply(console, arguments);
        _prevDbg = now;
    }
    log.DBG = -4;
    log.INFO = -3;
    log.WARN = -2;
    log.ERR = -1;
    log.level = log.WARN;
    exports.log = log;
}, function(module, __webpack_exports__, __webpack_require__) {
    "use strict";
    __webpack_require__.r(__webpack_exports__);
    __webpack_require__.d(__webpack_exports__, "__extends", (function() {
        return __extends;
    }));
    __webpack_require__.d(__webpack_exports__, "__assign", (function() {
        return __assign;
    }));
    __webpack_require__.d(__webpack_exports__, "__rest", (function() {
        return __rest;
    }));
    __webpack_require__.d(__webpack_exports__, "__decorate", (function() {
        return __decorate;
    }));
    __webpack_require__.d(__webpack_exports__, "__param", (function() {
        return __param;
    }));
    __webpack_require__.d(__webpack_exports__, "__metadata", (function() {
        return __metadata;
    }));
    __webpack_require__.d(__webpack_exports__, "__awaiter", (function() {
        return __awaiter;
    }));
    __webpack_require__.d(__webpack_exports__, "__generator", (function() {
        return __generator;
    }));
    __webpack_require__.d(__webpack_exports__, "__createBinding", (function() {
        return __createBinding;
    }));
    __webpack_require__.d(__webpack_exports__, "__exportStar", (function() {
        return __exportStar;
    }));
    __webpack_require__.d(__webpack_exports__, "__values", (function() {
        return __values;
    }));
    __webpack_require__.d(__webpack_exports__, "__read", (function() {
        return __read;
    }));
    __webpack_require__.d(__webpack_exports__, "__spread", (function() {
        return __spread;
    }));
    __webpack_require__.d(__webpack_exports__, "__spreadArrays", (function() {
        return __spreadArrays;
    }));
    __webpack_require__.d(__webpack_exports__, "__await", (function() {
        return __await;
    }));
    __webpack_require__.d(__webpack_exports__, "__asyncGenerator", (function() {
        return __asyncGenerator;
    }));
    __webpack_require__.d(__webpack_exports__, "__asyncDelegator", (function() {
        return __asyncDelegator;
    }));
    __webpack_require__.d(__webpack_exports__, "__asyncValues", (function() {
        return __asyncValues;
    }));
    __webpack_require__.d(__webpack_exports__, "__makeTemplateObject", (function() {
        return __makeTemplateObject;
    }));
    __webpack_require__.d(__webpack_exports__, "__importStar", (function() {
        return __importStar;
    }));
    __webpack_require__.d(__webpack_exports__, "__importDefault", (function() {
        return __importDefault;
    }));
    __webpack_require__.d(__webpack_exports__, "__classPrivateFieldGet", (function() {
        return __classPrivateFieldGet;
    }));
    __webpack_require__.d(__webpack_exports__, "__classPrivateFieldSet", (function() {
        return __classPrivateFieldSet;
    }));
    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf || {
            __proto__: []
        } instanceof Array && function(d, b) {
            d.__proto__ = b;
        } || function(d, b) {
            for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
        };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() {
            this.constructor = d;
        }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __);
    }
    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
        }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc); else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function(target, key) {
            decorator(target, key, paramIndex);
        };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) {
            return value instanceof P ? value : new P((function(resolve) {
                resolve(value);
            }));
        }
        return new (P || (P = Promise))((function(resolve, reject) {
            function fulfilled(value) {
                try {
                    step(generator.next(value));
                } catch (e) {
                    reject(e);
                }
            }
            function rejected(value) {
                try {
                    step(generator["throw"](value));
                } catch (e) {
                    reject(e);
                }
            }
            function step(result) {
                result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
            }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        }));
    }
    function __generator(thisArg, body) {
        var _ = {
            label: 0,
            sent: function() {
                if (t[0] & 1) throw t[1];
                return t[1];
            },
            trys: [],
            ops: []
        }, f, y, t, g;
        return g = {
            next: verb(0),
            throw: verb(1),
            return: verb(2)
        }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
            return this;
        }), g;
        function verb(n) {
            return function(v) {
                return step([ n, v ]);
            };
        }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 
                0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [ op[0] & 2, t.value ];
                switch (op[0]) {
                  case 0:
                  case 1:
                    t = op;
                    break;

                  case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };

                  case 5:
                    _.label++;
                    y = op[1];
                    op = [ 0 ];
                    continue;

                  case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;

                  default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
                }
                op = body.call(thisArg, _);
            } catch (e) {
                op = [ 6, e ];
                y = 0;
            } finally {
                f = t = 0;
            }
            if (op[0] & 5) throw op[1];
            return {
                value: op[0] ? op[1] : void 0,
                done: true
            };
        }
    }
    var __createBinding = Object.create ? function(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        Object.defineProperty(o, k2, {
            enumerable: true,
            get: function() {
                return m[k];
            }
        });
    } : function(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    };
    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) __createBinding(exports, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function() {
                if (o && i >= o.length) o = void 0;
                return {
                    value: o && o[i++],
                    done: !o
                };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        } catch (error) {
            e = {
                error
            };
        } finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            } finally {
                if (e) throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++) for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, 
        k++) r[k] = a[j];
        return r;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function() {
            return this;
        }, i;
        function verb(n) {
            if (g[n]) i[n] = function(v) {
                return new Promise((function(a, b) {
                    q.push([ n, v, a, b ]) > 1 || resume(n, v);
                }));
            };
        }
        function resume(n, v) {
            try {
                step(g[n](v));
            } catch (e) {
                settle(q[0][3], e);
            }
        }
        function step(r) {
            r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r);
        }
        function fulfill(value) {
            resume("next", value);
        }
        function reject(value) {
            resume("throw", value);
        }
        function settle(f, v) {
            if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]);
        }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", (function(e) {
            throw e;
        })), verb("return"), i[Symbol.iterator] = function() {
            return this;
        }, i;
        function verb(n, f) {
            i[n] = o[n] ? function(v) {
                return (p = !p) ? {
                    value: __await(o[n](v)),
                    done: n === "return"
                } : f ? f(v) : v;
            } : f;
        }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), 
        i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function() {
            return this;
        }, i);
        function verb(n) {
            i[n] = o[n] && function(v) {
                return new Promise((function(resolve, reject) {
                    v = o[n](v), settle(resolve, reject, v.done, v.value);
                }));
            };
        }
        function settle(resolve, reject, d, v) {
            Promise.resolve(v).then((function(v) {
                resolve({
                    value: v,
                    done: d
                });
            }), reject);
        }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", {
                value: raw
            });
        } else {
            cooked.raw = raw;
        }
        return cooked;
    }
    var __setModuleDefault = Object.create ? function(o, v) {
        Object.defineProperty(o, "default", {
            enumerable: true,
            value: v
        });
    } : function(o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return mod && mod.__esModule ? mod : {
            default: mod
        };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    const tslib_1 = __webpack_require__(22);
    tslib_1.__exportStar(__webpack_require__(38), exports);
    tslib_1.__exportStar(__webpack_require__(185), exports);
    tslib_1.__exportStar(__webpack_require__(75), exports);
    tslib_1.__exportStar(__webpack_require__(17), exports);
    tslib_1.__exportStar(__webpack_require__(188), exports);
    tslib_1.__exportStar(__webpack_require__(81), exports);
    tslib_1.__exportStar(__webpack_require__(199), exports);
    tslib_1.__exportStar(__webpack_require__(54), exports);
    tslib_1.__exportStar(__webpack_require__(91), exports);
    tslib_1.__exportStar(__webpack_require__(218), exports);
    tslib_1.__exportStar(__webpack_require__(79), exports);
    tslib_1.__exportStar(__webpack_require__(13), exports);
    tslib_1.__exportStar(__webpack_require__(219), exports);
    tslib_1.__exportStar(__webpack_require__(7), exports);
    tslib_1.__exportStar(__webpack_require__(24), exports);
    tslib_1.__exportStar(__webpack_require__(242), exports);
    tslib_1.__exportStar(__webpack_require__(80), exports);
    tslib_1.__exportStar(__webpack_require__(243), exports);
    tslib_1.__exportStar(__webpack_require__(105), exports);
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.SourceSource = void 0;
    const source_destination_1 = __webpack_require__(7);
    class SourceSource extends source_destination_1.SourceDestination {
        constructor(source) {
            super();
            this.source = source;
        }
        async _open() {
            await this.source.open();
        }
        async _close() {
            await this.source.close();
        }
    }
    exports.SourceSource = SourceSource;
    SourceSource.requiresRandomReadableSource = false;
}, function(module, exports, __webpack_require__) {
    var _ = __webpack_require__(158), __ = __webpack_require__(21);
    var bootBase = _.struct([ _.byte("jmpBoot", 3), _.char("OEMName", 8), _.uint16le("BytsPerSec"), _.uint8("SecPerClus"), _.uint16le("ResvdSecCnt"), _.uint8("NumFATs"), _.uint16le("RootEntCnt"), _.uint16le("TotSec16"), _.uint8("Media"), _.uint16le("FATSz16"), _.uint16le("SecPerTrk"), _.uint16le("NumHeads"), _.uint32le("HiddSec"), _.uint32le("TotSec32") ]);
    var bootInfo = _.struct([ _.uint8("DrvNum"), _.uint8("Reserved1"), _.uint8("BootSig"), _.uint32le("VolID"), _.char("VolLab", 11), _.char("FilSysType", 8) ]);
    exports.boot16 = _.struct([ bootBase, bootInfo ]);
    exports.boot32 = _.struct([ bootBase, _.uint32le("FATSz32"), _.struct("ExtFlags", [ _.ubit("NumActiveFAT", 4), _.ubit("_reserved1", 3), _.bool("MirroredFAT"), _.ubit("_reserved2", 8) ].reverse()), _.struct("FSVer", [ _.uint8("Major"), _.uint8("Minor") ]), _.uint32le("RootClus"), _.uint16le("FSInfo"), _.uint16le("BkBootSec"), _.byte("Reserved", 12), bootInfo ]);
    var _time = _.struct([ _.ubit("hours", 5), _.ubit("minutes", 6), _.ubit("seconds_2", 5) ]), time = {
        valueFromBytes: function(buf, off) {
            off || (off = {
                bytes: 0
            });
            var _buf = __.bufferFrom([ buf[off.bytes + 1], buf[off.bytes + 0] ]), val = _time.valueFromBytes(_buf);
            off.bytes += this.size;
            return val;
        },
        bytesFromValue: function(val, buf, off) {
            val || (val = {
                hours: 0,
                minutes: 0,
                seconds_2: 0
            });
            buf || (buf = __.allocBuffer(this.size));
            off || (off = {
                bytes: 0
            });
            var _buf = _time.bytesFromValue(val);
            buf[off.bytes + 1] = _buf[0];
            buf[off.bytes + 0] = _buf[1];
            off.bytes += this.size;
            return buf;
        },
        size: _time.size
    };
    var _date = _.struct([ _.ubit("year", 7), _.ubit("month", 4), _.ubit("day", 5) ]), date = {
        valueFromBytes: function(buf, off) {
            off || (off = {
                bytes: 0
            });
            var _buf = __.bufferFrom([ buf[off.bytes + 1], buf[off.bytes + 0] ]), val = _date.valueFromBytes(_buf);
            off.bytes += this.size;
            return val;
        },
        bytesFromValue: function(val, buf, off) {
            val || (val = {
                year: 0,
                month: 0,
                day: 0
            });
            buf || (buf = __.allocBuffer(this.size));
            off || (off = {
                bytes: 0
            });
            var _buf = _date.bytesFromValue(val);
            buf[off.bytes + 1] = _buf[0];
            buf[off.bytes + 0] = _buf[1];
            off.bytes += this.size;
            return buf;
        },
        size: _date.size
    };
    exports.dirEntry = _.struct([ _.struct("Name", [ _.char("filename", 8), _.char("extension", 3) ]), _.struct("Attr", [ _.bool("readonly"), _.bool("hidden"), _.bool("system"), _.bool("volume_id"), _.bool("directory"), _.bool("archive"), _.ubit("reserved", 2) ].reverse()), _.byte("NTRes", 1), _.uint8("CrtTimeTenth"), _.struct("CrtTime", [ time ]), _.struct("CrtDate", [ date ]), _.struct("LstAccDate", [ date ]), _.uint16le("FstClusHI"), _.struct("WrtTime", [ time ]), _.struct("WrtDate", [ date ]), _.uint16le("FstClusLO"), _.uint32le("FileSize") ]);
    exports.entryDoneFlag = 0;
    exports.entryFreeFlag = 229;
    exports.entryIsE5Flag = 5;
    exports.dirEntry_simple = _.struct([ _.struct("Name", [ _.char("filename", 8), _.char("extension", 3) ]), _.padTo(exports.dirEntry.size) ]);
    exports.lastLongFlag = 64;
    exports.longDirFlag = 15;
    exports.longDirEntry = _.struct([ _.uint8("Ord"), _.char16le("Name1", 10), _.uint8("Attr_raw"), _.uint8("Type"), _.uint8("Chksum"), _.char16le("Name2", 12), _.uint16le("FstClusLO"), _.char16le("Name3", 4) ]);
    if (exports.longDirEntry.size !== exports.dirEntry.size) throw Error("Structs ain't right!");
    exports.fatField = {
        fat12: _.struct("Status", [ _.ubit("field0bc", 8), _.ubit("field1c", 4), _.ubit("field0a", 4), _.ubit("field1ab", 8) ]),
        fat16: _.uint16le("Status"),
        fat32: _.uint32le("Status")
    };
    exports.fatPrefix = {
        fat12: 3840,
        fat16: 65280,
        fat32: 268435200
    };
    exports.fatStat = {
        free: 0,
        _undef: 1,
        rsvMin: 240,
        bad: 247,
        eofMin: 248,
        eof: 255
    };
    exports._I = {
        RUSR: 256,
        WUSR: 128,
        XUSR: 64,
        RGRP: 32,
        WGRP: 16,
        XGRP: 8,
        ROTH: 4,
        WOTH: 2,
        XOTH: 1,
        SUID: 2048,
        SGID: 1024,
        SVTX: 512,
        FDIR: 16384,
        FREG: 32768
    };
    exports._I.RWXU = exports._I.RUSR | exports._I.WUSR | exports._I.XUSR;
    exports._I.RWXG = exports._I.RGRP | exports._I.WGRP | exports._I.XGRP;
    exports._I.RWXO = exports._I.ROTH | exports._I.WOTH | exports._I.XOTH;
    exports._I._sss = exports._I.SUID | exports._I.SGID | exports._I.SVTX;
    exports._I._chmoddable = exports._I.RWXU | exports._I.RWXG | exports._I.RWXO | exports._I._sss;
    var _errors = {
        IO: "Input/output error",
        NOENT: "No such file or directory",
        INVAL: "Invalid argument",
        EXIST: "File exists",
        NAMETOOLONG: "Filename too long",
        NOSPC: "No space left on device",
        NOSYS: "Function not supported",
        ROFS: "ROFLCopter file system",
        NOTDIR: "Not a directory",
        BADF: "Bad file descriptor",
        EXIST: "File exists",
        ISDIR: "Is a directory",
        ACCES: "Permission denied",
        NOSYS: "Function not implemented",
        _TODO: "Not implemented yet!"
    };
    exports.err = {};
    Object.keys(_errors).forEach((function(sym) {
        var msg = _errors[sym];
        exports.err[sym] = function() {
            var e = new Error(msg);
            e.code = sym;
            return e;
        };
    }));
}, function(module, exports, __webpack_require__) {
    "use strict";
    if (typeof process === "undefined" || process.type === "renderer" || process.browser === true || process.__nwjs) {
        module.exports = __webpack_require__(163);
    } else {
        module.exports = __webpack_require__(164);
    }
}, function(module, exports, __webpack_require__) {
    const JSON_DATE_PATTERN = /^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}(\.\d{1,3})?Z$/;
    class Plist {
        constructor() {
            this.data = {};
        }
        get(keyPath) {
            var path = keyPath.split(".");
            var key = path.pop();
            var objRef = this.data;
            var pathComp = null;
            while (pathComp = path.shift()) {
                if (objRef[pathComp] == null) return undefined;
                objRef = objRef[pathComp];
            }
            return objRef[key];
        }
        set(keyPath, value) {
            var path = keyPath.split(".");
            var key = path.pop();
            var objRef = this.data;
            var pathComp = null;
            while (pathComp = path.shift()) {
                if (objRef[pathComp] == null) return undefined;
                objRef = objRef[pathComp];
            }
            return objRef[key] = value;
        }
        replace(keyPath, value) {
            if (this.get(keyPath) !== undefined) {
                this.set(keyPath, value);
                return true;
            }
            return false;
        }
        delete(keyPath) {
            this.data[keyPath] = undefined;
            delete this.data[keyPath];
        }
        parse(buffer, offset, length) {
            offset = offset || 0;
            length = length || buffer.length - offset;
            if (buffer.indexOf(Plist.SIGNATURE_BINARY, offset) === offset) {
                return this.parseBinary(buffer, offset, length);
            } else if (buffer.indexOf(Plist.SIGNATURE_XML, offset) === offset) {
                return this.parseXML(buffer, offset, length);
            } else if (buffer.indexOf(Plist.SIGNATURE_JSON, offset) === offset) {
                return this.fromJSON(buffer.slice(offset, offset + length));
            }
            throw new Error(`Invalid property list signature at offset 0x${offset.toString(16)}`);
            return this;
        }
        parseBinary(buffer, offset, length) {
            this.data = Plist.binary.parse(buffer, offset, length);
            return this;
        }
        parseXML(buffer, offset, length) {
            this.data = Plist.xml.parse(buffer, offset, length);
            return this;
        }
        fromJSON(value) {
            this.data = null;
            if (typeof value === "string") {
                this.data = JSON.parse(value, Plist.reviver);
            } else if (Buffer.isBuffer(value)) {
                this.data = JSON.parse(value.toString("utf8"), Plist.reviver);
            } else {
                this.data = JSON.parse(JSON.stringify(value), Plist.reviver);
            }
            return this;
        }
        toJSON() {
            return this.data;
        }
        toString() {
            return Plist.xml.write(this.data);
        }
        write(buffer, offset, encoding) {
            encoding = encoding || "binary";
            switch (encoding) {
              case "binary":
                return Plist.binary.write(this.data, buffer, offset);

              case "xml":
                return Buffer.from(this.toString());

              case "json":
                return Buffer.from(JSON.stringify(this.data));

              default:
                throw new Error(`Unknown encoding ${encoding}`);
            }
        }
    }
    module.exports = Plist;
    Plist.SIGNATURE_BINARY = "bplist";
    Plist.SIGNATURE_XML = "<?xml ";
    Plist.SIGNATURE_JSON = "{";
    Plist.EPOCH = 9783072e5;
    Plist.DOCTYPE = {
        "1.0": '<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">'
    };
    Plist.xml = {
        parse: __webpack_require__(190),
        write: __webpack_require__(192)
    };
    Plist.binary = {
        parse: __webpack_require__(194),
        write: __webpack_require__(195)
    };
    Plist.reviver = function(key, value) {
        var isBuffer = typeof value === "object" && !Array.isArray(value) && value.type === "Buffer" && Array.isArray(value.data);
        if (isBuffer) {
            return Buffer.from(value.data);
        }
        if (typeof value == "string" && JSON_DATE_PATTERN.test(value)) {
            return new Date(value);
        }
        return value;
    };
    Plist.fromJSON = function(value) {
        return (new Plist).fromJSON(value);
    };
    Plist.parse = function(buffer, offset) {
        return (new Plist).parse(buffer, offset);
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.freeSpace = exports.withTmpFile = exports.tmpFile = exports.cleanupTmpFiles = void 0;
    const checkDiskSpace = __webpack_require__(167);
    const crypto_1 = __webpack_require__(20);
    const fs_1 = __webpack_require__(3);
    const os_1 = __webpack_require__(11);
    const path_1 = __webpack_require__(4);
    const TMP_RANDOM_BYTES = 6;
    const TMP_DIR = path_1.join(os_1.tmpdir(), "etcher");
    const TRIES = 5;
    function randomFilePath() {
        return path_1.join(TMP_DIR, `${crypto_1.randomBytes(TMP_RANDOM_BYTES).toString("hex")}.tmp`);
    }
    async function cleanupTmpFiles(olderThan = Date.now()) {
        let dirents = [];
        try {
            dirents = await fs_1.promises.readdir(TMP_DIR, {
                withFileTypes: true
            });
        } catch (_a) {
            return;
        }
        for (const dirent of dirents) {
            if (dirent.isFile()) {
                const filename = path_1.join(TMP_DIR, dirent.name);
                try {
                    const stats = await fs_1.promises.stat(filename);
                    if (stats.ctime.getTime() <= olderThan) {
                        await fs_1.promises.unlink(filename);
                    }
                } catch (_b) {}
            }
        }
    }
    exports.cleanupTmpFiles = cleanupTmpFiles;
    async function createTmpRoot() {
        try {
            await fs_1.promises.mkdir(TMP_DIR, {
                recursive: true
            });
        } catch (error) {
            if (error.code === "EEXIST" && !(await fs_1.promises.stat(TMP_DIR)).isDirectory()) {
                await fs_1.promises.unlink(TMP_DIR);
                await fs_1.promises.mkdir(TMP_DIR, {
                    recursive: true
                });
            }
        }
    }
    async function tmpFile(keepOpen = true) {
        await createTmpRoot();
        let fileHandle;
        let path;
        let ok = false;
        for (let i = 0; i < TRIES; i++) {
            path = randomFilePath();
            try {
                fileHandle = await fs_1.promises.open(path, "wx+");
                ok = true;
                break;
            } catch (error) {
                if (error.code !== "EEXIST") {
                    throw error;
                }
            }
        }
        if (!ok) {
            throw new Error(`Could not generate a temporary filename in ${TRIES} tries`);
        }
        if (!keepOpen && fileHandle !== undefined) {
            await fileHandle.close();
            fileHandle = undefined;
        }
        return {
            fileHandle,
            path
        };
    }
    exports.tmpFile = tmpFile;
    async function withTmpFile(keepOpen = true, fn) {
        const result = await tmpFile(keepOpen);
        try {
            return await fn(result);
        } finally {
            if (keepOpen && result.fileHandle !== undefined) {
                await result.fileHandle.close();
            }
            await fs_1.promises.unlink(result.path);
        }
    }
    exports.withTmpFile = withTmpFile;
    async function freeSpace() {
        try {
            return (await checkDiskSpace(TMP_DIR)).free;
        } catch (error) {
            console.warn(`Could not check free disk space in "${TMP_DIR}": ${error}`);
            return 0;
        }
    }
    exports.freeSpace = freeSpace;
}, function(module, exports) {
    module.exports = require("./modules/@ronomon/direct-io/binding.node");
}, function(module, exports) {
    module.exports = require("tty");
}, function(module, exports, __webpack_require__) {
    "use strict";
    const os = __webpack_require__(11);
    const hasFlag = __webpack_require__(124);
    const env = process.env;
    let forceColor;
    if (hasFlag("no-color") || hasFlag("no-colors") || hasFlag("color=false")) {
        forceColor = false;
    } else if (hasFlag("color") || hasFlag("colors") || hasFlag("color=true") || hasFlag("color=always")) {
        forceColor = true;
    }
    if ("FORCE_COLOR" in env) {
        forceColor = env.FORCE_COLOR.length === 0 || parseInt(env.FORCE_COLOR, 10) !== 0;
    }
    function translateLevel(level) {
        if (level === 0) {
            return false;
        }
        return {
            level,
            hasBasic: true,
            has256: level >= 2,
            has16m: level >= 3
        };
    }
    function supportsColor(stream) {
        if (forceColor === false) {
            return 0;
        }
        if (hasFlag("color=16m") || hasFlag("color=full") || hasFlag("color=truecolor")) {
            return 3;
        }
        if (hasFlag("color=256")) {
            return 2;
        }
        if (stream && !stream.isTTY && forceColor !== true) {
            return 0;
        }
        const min = forceColor ? 1 : 0;
        if (process.platform === "win32") {
            const osRelease = os.release().split(".");
            if (Number(process.versions.node.split(".")[0]) >= 8 && Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
                return Number(osRelease[2]) >= 14931 ? 3 : 2;
            }
            return 1;
        }
        if ("CI" in env) {
            if ([ "TRAVIS", "CIRCLECI", "APPVEYOR", "GITLAB_CI" ].some(sign => sign in env) || env.CI_NAME === "codeship") {
                return 1;
            }
            return min;
        }
        if ("TEAMCITY_VERSION" in env) {
            return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env.TEAMCITY_VERSION) ? 1 : 0;
        }
        if (env.COLORTERM === "truecolor") {
            return 3;
        }
        if ("TERM_PROGRAM" in env) {
            const version = parseInt((env.TERM_PROGRAM_VERSION || "").split(".")[0], 10);
            switch (env.TERM_PROGRAM) {
              case "iTerm.app":
                return version >= 3 ? 3 : 2;

              case "Apple_Terminal":
                return 2;
            }
        }
        if (/-256(color)?$/i.test(env.TERM)) {
            return 2;
        }
        if (/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(env.TERM)) {
            return 1;
        }
        if ("COLORTERM" in env) {
            return 1;
        }
        if (env.TERM === "dumb") {
            return min;
        }
        return min;
    }
    function getSupportLevel(stream) {
        const level = supportsColor(stream);
        return translateLevel(level);
    }
    module.exports = {
        supportsColor: getSupportLevel,
        stdout: getSupportLevel(process.stdout),
        stderr: getSupportLevel(process.stderr)
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.StreamLimiter = void 0;
    const stream_1 = __webpack_require__(0);
    const zlib = __webpack_require__(18);
    const compressed_source_1 = __webpack_require__(17);
    class StreamLimiter extends stream_1.Transform {
        constructor(stream, maxBytes) {
            super();
            this.stream = stream;
            this.maxBytes = maxBytes;
            this.stream.on("error", this.emit.bind(this, "error"));
            this.stream.pipe(this);
        }
        _transform(buffer, _encoding, callback) {
            const length = Math.min(buffer.length, this.maxBytes);
            if (length > 0) {
                this.push(buffer.slice(0, length));
            }
            this.maxBytes -= length;
            if (this.maxBytes === 0) {
                this.stream.unpipe(this);
                this.push(null);
                this.emit("finish");
                compressed_source_1.getRootStream(this.stream).emit("end");
                if (this.stream.close !== undefined) {
                    if (!(this.stream instanceof zlib.Gunzip)) {
                        this.stream.close();
                    }
                } else if (this.stream.destroy !== undefined) {
                    if (this.stream.constructor.name !== "JSLzmaStream") {
                        this.stream.destroy();
                    }
                }
            }
            callback();
        }
    }
    exports.StreamLimiter = StreamLimiter;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.getPartitions = exports.get = exports.PartitionNotFound = void 0;
    const file_disk_1 = __webpack_require__(46);
    const GPT = __webpack_require__(68);
    const MBR = __webpack_require__(14);
    const typed_error_1 = __webpack_require__(71);
    const MBR_SIZE = 512;
    const GPT_SIZE = 512 * 41;
    const GPT_PROTECTIVE_MBR = 238;
    const MBR_LAST_PRIMARY_PARTITION = 4;
    const MBR_FIRST_LOGICAL_PARTITION = 5;
    function mbrPartitionDict(p, offset, index) {
        return {
            offset: offset + p.byteOffset(),
            size: p.byteSize(),
            type: p.type,
            index
        };
    }
    function gptPartitionDict(gpt, p, index) {
        return {
            offset: p.firstLBA * gpt.blockSize,
            size: (p.lastLBA - p.firstLBA + 1) * gpt.blockSize,
            type: p.type,
            guid: p.guid,
            name: p.name,
            index
        };
    }
    function getPartitionsFromMBRBuf(buf) {
        return new MBR(buf).partitions.filter(p => p.type);
    }
    async function readFromDisk(disk, offset, size) {
        const {buffer} = await disk.read(Buffer.alloc(size), 0, size, offset);
        return buffer;
    }
    async function getLogicalPartitions(disk, index, offset, extendedPartitionOffset, limit) {
        if (extendedPartitionOffset === undefined) {
            extendedPartitionOffset = offset;
        }
        if (limit === undefined) {
            limit = Infinity;
        }
        const result = [];
        if (limit <= 0) {
            return result;
        }
        const buf = await readFromDisk(disk, offset, MBR_SIZE);
        for (const p of getPartitionsFromMBRBuf(buf)) {
            if (!p.extended) {
                result.push(mbrPartitionDict(p, offset, index));
            } else if (limit > 0) {
                const logicalPartitions = await getLogicalPartitions(disk, index + 1, extendedPartitionOffset + p.byteOffset(), extendedPartitionOffset, limit - 1);
                result.push(...logicalPartitions);
                return result;
            }
        }
        return result;
    }
    function detectGPT(buffer) {
        let blockSize = MBR_SIZE;
        let lastError;
        while (blockSize <= 4096) {
            try {
                return GPT.parse(buffer.slice(blockSize));
            } catch (error) {
                lastError = error;
            }
            blockSize *= 2;
        }
        throw lastError;
    }
    async function getDiskPartitions(disk, {offset, includeExtended, getLogical}) {
        let extended = null;
        const mbrBuf = await readFromDisk(disk, offset, MBR_SIZE);
        const partitions = getPartitionsFromMBRBuf(mbrBuf);
        if (partitions.length >= 1 && partitions[0].type === GPT_PROTECTIVE_MBR) {
            const gptBuf = await readFromDisk(disk, 0, GPT_SIZE);
            const gpt = detectGPT(gptBuf);
            return {
                type: "gpt",
                partitions: gpt.partitions.map((partition, index) => gptPartitionDict(gpt, partition, index + 1))
            };
        } else {
            const mbrPartitions = [];
            for (let index = 0; index < partitions.length; index++) {
                const p = partitions[index];
                if (p.extended) {
                    extended = p;
                    if (includeExtended) {
                        mbrPartitions.push(mbrPartitionDict(p, offset, index + 1));
                    }
                } else {
                    mbrPartitions.push(mbrPartitionDict(p, offset, index + 1));
                }
            }
            if (extended != null && getLogical) {
                const logicalPartitions = await getLogicalPartitions(disk, MBR_FIRST_LOGICAL_PARTITION, extended.byteOffset());
                mbrPartitions.push(...logicalPartitions);
            }
            return {
                type: "mbr",
                partitions: mbrPartitions
            };
        }
    }
    class PartitionNotFound extends typed_error_1.TypedError {
        constructor(partitionNumber) {
            super(`Partition not found: ${partitionNumber}.`);
        }
    }
    exports.PartitionNotFound = PartitionNotFound;
    async function getPartition(disk, partitionNumber) {
        if (partitionNumber < 1) {
            throw new Error("The partition number must be at least 1.");
        }
        const info = await getDiskPartitions(disk, {
            includeExtended: true,
            offset: 0,
            getLogical: false
        });
        if (info.type === "gpt") {
            if (info.partitions.length < partitionNumber) {
                throw new PartitionNotFound(partitionNumber);
            } else {
                return info.partitions[partitionNumber - 1];
            }
        }
        if (partitionNumber <= MBR_LAST_PRIMARY_PARTITION) {
            if (partitionNumber <= info.partitions.length) {
                return info.partitions[partitionNumber - 1];
            } else {
                throw new PartitionNotFound(partitionNumber);
            }
        }
        const extended = info.partitions.find(p => MBR.Partition.isExtended(p.type));
        if (!extended) {
            throw new PartitionNotFound(partitionNumber);
        } else {
            const logicalPartitionPosition = partitionNumber - MBR_FIRST_LOGICAL_PARTITION;
            const logicalPartitions = await getLogicalPartitions(disk, MBR_FIRST_LOGICAL_PARTITION, extended.offset, extended.offset, logicalPartitionPosition + 1);
            if (logicalPartitionPosition < logicalPartitions.length) {
                return logicalPartitions[logicalPartitionPosition];
            } else {
                throw new PartitionNotFound(partitionNumber);
            }
        }
    }
    function isString(x) {
        return typeof x === "string";
    }
    async function callWithDisk(fn, pathOrBufferOrDisk, arg) {
        if (isString(pathOrBufferOrDisk)) {
            return await file_disk_1.withOpenFile(pathOrBufferOrDisk, "r", async fd => await fn(new file_disk_1.FileDisk(fd), arg));
        } else if (Buffer.isBuffer(pathOrBufferOrDisk)) {
            return await fn(new file_disk_1.BufferDisk(pathOrBufferOrDisk), arg);
        } else {
            return await fn(pathOrBufferOrDisk, arg);
        }
    }
    async function get(disk, partitionNumber) {
        return await callWithDisk(getPartition, disk, partitionNumber);
    }
    exports.get = get;
    async function getPartitions(disk, {offset = 0, includeExtended = true, getLogical = true} = {
        offset: 0,
        includeExtended: true,
        getLogical: true
    }) {
        return await callWithDisk(getDiskPartitions, disk, {
            offset,
            includeExtended,
            getLogical
        });
    }
    exports.getPartitions = getPartitions;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.SparseFilterStream = void 0;
    const stream_1 = __webpack_require__(0);
    const shared_1 = __webpack_require__(19);
    class SparseFilterStream extends stream_1.Transform {
        constructor({blocks, verify, generateChecksums}) {
            super({
                objectMode: true
            });
            this.position = 0;
            this.blocks = blocks;
            this.stateIterator = shared_1.createSparseReaderStateIterator(blocks, verify, generateChecksums);
            this.nextBlock();
        }
        nextBlock() {
            this.state = this.stateIterator.next().value;
        }
        _transform(chunk, _encoding, callback) {
            let error;
            try {
                this.__transform(chunk);
            } catch (err) {
                error = err;
            }
            callback(error);
        }
        __transform(buffer) {
            while (true) {
                if (this.state === undefined) {
                    this.position += buffer.length;
                    return;
                }
                if (this.position >= this.state.subBlock.offset + this.state.subBlock.length) {
                    this.nextBlock();
                    continue;
                }
                if (buffer.length === 0) {
                    return;
                }
                if (this.position < this.state.subBlock.offset) {
                    const toSkip = Math.min(this.state.subBlock.offset - this.position, buffer.length);
                    this.position += toSkip;
                    if (toSkip >= buffer.length) {
                        return;
                    }
                    buffer = buffer.slice(toSkip);
                }
                const bytesLeftInBlock = this.state.subBlock.offset + this.state.subBlock.length - this.position;
                const length = Math.min(bytesLeftInBlock, buffer.length);
                const bufferToPush = buffer.slice(0, length);
                if (this.state.hasher !== undefined) {
                    this.state.hasher.update(bufferToPush);
                }
                this.push({
                    buffer: bufferToPush,
                    position: this.position
                });
                this.position += length;
                buffer = buffer.slice(length);
            }
        }
    }
    exports.SparseFilterStream = SparseFilterStream;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.getCrc = exports.getUnmountDisk = exports.getXXHash = exports.getRaspberrypiUsbboot = void 0;
    const util_1 = __webpack_require__(1);
    const utils_1 = __webpack_require__(6);
    exports.getRaspberrypiUsbboot = utils_1.once(() => {
        try {
            return __webpack_require__(141);
        } catch (e) {
            console.warn("Failed to import node-raspberrypi-usbboot:", e);
        }
    });
    exports.getXXHash = utils_1.once(() => __webpack_require__(72));
    exports.getUnmountDisk = utils_1.once(() => util_1.promisify(__webpack_require__(147).unmountDisk));
    exports.getCrc = utils_1.once(() => __webpack_require__(47));
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.interact = void 0;
    const ext2fs = __webpack_require__(149);
    const fatfs = __webpack_require__(156);
    const file_disk_1 = __webpack_require__(46);
    const partitioninfo = __webpack_require__(33);
    const typed_error_1 = __webpack_require__(71);
    const util_1 = __webpack_require__(1);
    class MountError extends typed_error_1.TypedError {}
    const SECTOR_SIZE = 512;
    async function runInFat(disk, offset, size, fn) {
        function sectorPosition(sector) {
            return offset + sector * SECTOR_SIZE;
        }
        const fat = fatfs.createFileSystem({
            sectorSize: SECTOR_SIZE,
            numSectors: size / SECTOR_SIZE,
            readSectors: async (sector, dest, callback) => {
                try {
                    const {bytesRead, buffer} = await disk.read(dest, 0, dest.length, sectorPosition(sector));
                    callback(null, bytesRead, buffer);
                } catch (e) {
                    callback(e);
                }
            },
            writeSectors: async (sector, data, callback) => {
                try {
                    const {bytesWritten, buffer} = await disk.write(data, 0, data.length, sectorPosition(sector));
                    callback(null, bytesWritten, buffer);
                } catch (e) {
                    callback(e);
                }
            }
        });
        await new Promise((function(resolve, reject) {
            fat.on("error", e => {
                reject(new MountError(e));
            });
            fat.on("ready", resolve);
        }));
        return await fn(fat);
    }
    const mountAsync = util_1.promisify(ext2fs.mount);
    const umountAsync = util_1.promisify(ext2fs.umount);
    async function runInExt(disk, offset, fn) {
        let fs;
        try {
            fs = await mountAsync(disk, {
                offset
            });
        } catch (e) {
            throw new MountError(e);
        }
        try {
            return await fn(fs);
        } finally {
            await umountAsync(fs);
        }
    }
    async function tryInteract(disk, offset, size, fn) {
        try {
            return await runInExt(disk, offset, fn);
        } catch (e) {
            if (!(e instanceof MountError)) {
                throw e;
            }
            try {
                return await runInFat(disk, offset, size, fn);
            } catch (e2) {
                if (!(e instanceof MountError)) {
                    throw e;
                }
                throw new Error("Unsupported filesystem.");
            }
        }
    }
    async function getPartitionOffset(disk, partition) {
        if (partition === undefined) {
            const size = await disk.getCapacity();
            return {
                offset: 0,
                size
            };
        } else {
            return await partitioninfo.get(disk, partition);
        }
    }
    async function diskInteract(disk, partition, fn) {
        const {offset, size} = await getPartitionOffset(disk, partition);
        return await tryInteract(disk, offset, size, fn);
    }
    async function interact(disk, partition, fn) {
        if (typeof disk === "string") {
            return await file_disk_1.withOpenFile(disk, "r+", async handle => {
                disk = new file_disk_1.FileDisk(handle);
                return await diskInteract(disk, partition, fn);
            });
        } else if (disk instanceof file_disk_1.Disk) {
            return await diskInteract(disk, partition, fn);
        } else {
            throw new Error("image must be a String (file path) or a Disk instance");
        }
    }
    exports.interact = interact;
}, function(module, exports) {
    module.exports = require("buffer");
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.BlockDevice = void 0;
    const direct_io_1 = __webpack_require__(29);
    const fs_1 = __webpack_require__(3);
    const os_1 = __webpack_require__(11);
    const block_write_stream_1 = __webpack_require__(165);
    const constants_1 = __webpack_require__(5);
    const diskpart_1 = __webpack_require__(166);
    const lazy_1 = __webpack_require__(35);
    const sparse_write_stream_1 = __webpack_require__(53);
    const utils_1 = __webpack_require__(6);
    const file_1 = __webpack_require__(54);
    const UNMOUNT_ON_SUCCESS_TIMEOUT_MS = 2e3;
    const WIN32_FIRST_BYTES_TO_KEEP = 64 * 1024;
    class BlockDevice extends file_1.File {
        constructor({drive, unmountOnSuccess = false, write = false, direct = true}) {
            super({
                path: drive.raw,
                write
            });
            this.emitsProgress = false;
            this.drive = drive;
            this.unmountOnSuccess = unmountOnSuccess;
            this.oDirect = direct;
            this.alignment = Math.min(drive.blockSize || constants_1.DEFAULT_ALIGNMENT, 4 * 1024 ** 2);
        }
        getAlignment() {
            if (this.oDirect) {
                return this.alignment;
            }
        }
        getOpenFlags() {
            let flags = this.oWrite ? fs_1.constants.O_RDWR : fs_1.constants.O_RDONLY;
            if (this.oDirect) {
                flags |= fs_1.constants.O_DIRECT | fs_1.constants.O_SYNC;
            }
            if (this.oWrite) {
                const plat = os_1.platform();
                if (plat === "linux") {
                    flags |= fs_1.constants.O_EXCL;
                } else if (plat === "darwin") {
                    flags |= direct_io_1.O_EXLOCK;
                }
            }
            return flags;
        }
        get isSystem() {
            return this.drive.isSystem;
        }
        get raw() {
            return this.drive.raw;
        }
        get device() {
            return this.drive.device;
        }
        get devicePath() {
            return this.drive.devicePath;
        }
        get description() {
            return this.drive.description;
        }
        get mountpoints() {
            return this.drive.mountpoints;
        }
        get size() {
            return this.drive.size;
        }
        async _getMetadata() {
            return {
                size: this.drive.size || undefined,
                name: this.drive.device
            };
        }
        async canWrite() {
            return !this.drive.isReadOnly;
        }
        async canCreateWriteStream() {
            return !this.drive.isReadOnly;
        }
        async canCreateSparseWriteStream() {
            return !this.drive.isReadOnly;
        }
        async createWriteStream({highWaterMark} = {}) {
            const stream = new block_write_stream_1.ProgressBlockWriteStream({
                destination: this,
                delayFirstBuffer: os_1.platform() === "win32",
                highWaterMark
            });
            stream.on("finish", stream.emit.bind(stream, "done"));
            return stream;
        }
        async createSparseWriteStream({highWaterMark} = {}) {
            const stream = new sparse_write_stream_1.ProgressSparseWriteStream({
                destination: this,
                firstBytesToKeep: os_1.platform() === "win32" ? WIN32_FIRST_BYTES_TO_KEEP : 0,
                highWaterMark
            });
            stream.on("finish", stream.emit.bind(stream, "done"));
            return stream;
        }
        async _open() {
            const plat = os_1.platform();
            if (plat !== "win32") {
                const unmountDisk = lazy_1.getUnmountDisk();
                await unmountDisk(this.drive.device);
            }
            await diskpart_1.clean(this.drive.device);
            await super._open();
            if (plat === "darwin") {
                await utils_1.fromCallback(cb => {
                    direct_io_1.setF_NOCACHE(this.fileHandle.fd, 1, cb);
                });
            }
        }
        async _close() {
            await super._close();
            if (this.unmountOnSuccess) {
                await utils_1.delay(UNMOUNT_ON_SUCCESS_TIMEOUT_MS);
                const unmountDisk = lazy_1.getUnmountDisk();
                await unmountDisk(this.drive.device);
            }
        }
        offsetIsAligned(offset) {
            return offset % this.alignment === 0;
        }
        alignOffsetBefore(offset) {
            return Math.floor(offset / this.alignment) * this.alignment;
        }
        alignOffsetAfter(offset) {
            return Math.ceil(offset / this.alignment) * this.alignment;
        }
        async alignedRead(buffer, bufferOffset, length, sourceOffset) {
            const start = this.alignOffsetBefore(sourceOffset);
            const end = this.alignOffsetAfter(sourceOffset + length);
            const alignedBuffer = direct_io_1.getAlignedBuffer(end - start, this.alignment);
            const {bytesRead} = await super.read(alignedBuffer, 0, alignedBuffer.length, start);
            const offset = sourceOffset - start;
            alignedBuffer.copy(buffer, bufferOffset, offset, offset + length);
            return {
                buffer,
                bytesRead: Math.min(length, bytesRead - offset)
            };
        }
        read(buffer, bufferOffset, length, sourceOffset) {
            if (!(this.offsetIsAligned(sourceOffset) && this.offsetIsAligned(length))) {
                return this.alignedRead(buffer, bufferOffset, length, sourceOffset);
            } else {
                return super.read(buffer, bufferOffset, length, sourceOffset);
            }
        }
        async alignedWrite(buffer, bufferOffset, length, fileOffset) {
            const start = this.alignOffsetBefore(fileOffset);
            const end = this.alignOffsetAfter(fileOffset + length);
            const alignedBuffer = direct_io_1.getAlignedBuffer(end - start, this.alignment);
            await super.read(alignedBuffer, 0, alignedBuffer.length, start);
            const offset = fileOffset - start;
            buffer.copy(alignedBuffer, offset, bufferOffset, length);
            await super.write(alignedBuffer, 0, alignedBuffer.length, start);
            return {
                buffer,
                bytesWritten: length
            };
        }
        write(buffer, bufferOffset, length, fileOffset) {
            if (!(this.offsetIsAligned(fileOffset) && this.offsetIsAligned(length))) {
                return this.alignedWrite(buffer, bufferOffset, length, fileOffset);
            } else {
                return super.write(buffer, bufferOffset, length, fileOffset);
            }
        }
    }
    exports.BlockDevice = BlockDevice;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.Adapter = void 0;
    const events_1 = __webpack_require__(9);
    class Adapter extends events_1.EventEmitter {}
    exports.Adapter = Adapter;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.writeBE = exports.readBE = void 0;
    const MAX_UINT32 = Math.pow(2, 32);
    function readBE(buffer, offset) {
        offset = offset || 0;
        const hi = buffer.readUInt32BE(offset);
        const lo = buffer.readUInt32BE(offset + 4);
        return hi * MAX_UINT32 + lo;
    }
    exports.readBE = readBE;
    function writeBE(buffer, value, offset) {
        offset = offset || 0;
        const hi = value / MAX_UINT32;
        const lo = value - hi * MAX_UINT32;
        buffer.writeUInt32BE(hi, offset);
        buffer.writeUInt32BE(lo, offset + 4);
        return offset + 8;
    }
    exports.writeBE = writeBE;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.streamToBuffer = exports.ZeroStream = exports.blockDecompressor = exports.blockGenerator = exports.withOpenImage = void 0;
    const adc = __webpack_require__(56);
    const fs_1 = __webpack_require__(3);
    const stream_1 = __webpack_require__(0);
    const bz2 = __webpack_require__(82);
    const zlib = __webpack_require__(18);
    const constants_1 = __webpack_require__(16);
    const image_1 = __webpack_require__(86);
    async function withOpenImage(filePath, fn) {
        const handle = await fs_1.promises.open(filePath, "r");
        try {
            const image = new image_1.Image({
                size: (await handle.stat()).size,
                createReadStream: async (start = 0, end = Infinity) => fs_1.createReadStream("", {
                    fd: handle.fd,
                    autoClose: false,
                    start,
                    end
                })
            });
            await image.ready;
            return await fn(image);
        } finally {
            await handle.close();
        }
    }
    exports.withOpenImage = withOpenImage;
    function* blockGenerator(image, exclude = []) {
        for (const entry of image.resourceFork.blkx) {
            for (const block of entry.map.blocks) {
                if (!exclude.includes(block.type)) {
                    yield {
                        entry,
                        block
                    };
                }
            }
        }
    }
    exports.blockGenerator = blockGenerator;
    function blockDecompressor(type, inputStream) {
        if (type === constants_1.BLOCK.RAW) {
            return inputStream;
        } else if (type === constants_1.BLOCK.UDZO) {
            return inputStream.pipe(zlib.createInflate());
        } else if (type === constants_1.BLOCK.UDBZ) {
            return inputStream.pipe(bz2());
        } else if (type === constants_1.BLOCK.UDCO) {
            return inputStream.pipe(new adc.Decompressor);
        } else if (type === constants_1.BLOCK.LZFSE) {
            throw new Error("Unsupported compression method: LZFSE");
        }
        throw new Error(`Unknown compression method for type "0x${type.toString(16)}"`);
    }
    exports.blockDecompressor = blockDecompressor;
    class ZeroStream extends stream_1.Readable {
        constructor(length = Infinity, blank) {
            super();
            this.length = length;
            this.blank = blank !== null && blank !== void 0 ? blank : Buffer.alloc(64 * 1024);
        }
        _read() {
            if (this.length >= this.blank.length) {
                this.push(this.blank);
                this.length -= this.blank.length;
            } else if (this.length > 0) {
                this.push(this.blank.slice(0, this.length));
                this.length = 0;
            } else {
                this.push(null);
            }
        }
    }
    exports.ZeroStream = ZeroStream;
    function streamToBuffer(stream) {
        const chunks = [];
        return new Promise((resolve, reject) => {
            stream.on("data", buf => {
                chunks.push(buf);
            });
            stream.on("end", () => {
                resolve(Buffer.concat(chunks));
            });
            stream.on("error", reject);
        });
    }
    exports.streamToBuffer = streamToBuffer;
}, function(module, exports, __webpack_require__) {
    module.exports = __webpack_require__(200);
}, function(module, exports) {
    module.exports = require("process");
}, function(module, exports) {
    var s = 1e3;
    var m = s * 60;
    var h = m * 60;
    var d = h * 24;
    var w = d * 7;
    var y = d * 365.25;
    module.exports = function(val, options) {
        options = options || {};
        var type = typeof val;
        if (type === "string" && val.length > 0) {
            return parse(val);
        } else if (type === "number" && isFinite(val)) {
            return options.long ? fmtLong(val) : fmtShort(val);
        }
        throw new Error("val is not a non-empty string or a valid number. val=" + JSON.stringify(val));
    };
    function parse(str) {
        str = String(str);
        if (str.length > 100) {
            return;
        }
        var match = /^(-?(?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|weeks?|w|years?|yrs?|y)?$/i.exec(str);
        if (!match) {
            return;
        }
        var n = parseFloat(match[1]);
        var type = (match[2] || "ms").toLowerCase();
        switch (type) {
          case "years":
          case "year":
          case "yrs":
          case "yr":
          case "y":
            return n * y;

          case "weeks":
          case "week":
          case "w":
            return n * w;

          case "days":
          case "day":
          case "d":
            return n * d;

          case "hours":
          case "hour":
          case "hrs":
          case "hr":
          case "h":
            return n * h;

          case "minutes":
          case "minute":
          case "mins":
          case "min":
          case "m":
            return n * m;

          case "seconds":
          case "second":
          case "secs":
          case "sec":
          case "s":
            return n * s;

          case "milliseconds":
          case "millisecond":
          case "msecs":
          case "msec":
          case "ms":
            return n;

          default:
            return undefined;
        }
    }
    function fmtShort(ms) {
        var msAbs = Math.abs(ms);
        if (msAbs >= d) {
            return Math.round(ms / d) + "d";
        }
        if (msAbs >= h) {
            return Math.round(ms / h) + "h";
        }
        if (msAbs >= m) {
            return Math.round(ms / m) + "m";
        }
        if (msAbs >= s) {
            return Math.round(ms / s) + "s";
        }
        return ms + "ms";
    }
    function fmtLong(ms) {
        var msAbs = Math.abs(ms);
        if (msAbs >= d) {
            return plural(ms, msAbs, d, "day");
        }
        if (msAbs >= h) {
            return plural(ms, msAbs, h, "hour");
        }
        if (msAbs >= m) {
            return plural(ms, msAbs, m, "minute");
        }
        if (msAbs >= s) {
            return plural(ms, msAbs, s, "second");
        }
        return ms + " ms";
    }
    function plural(ms, msAbs, n, name) {
        var isPlural = msAbs >= n * 1.5;
        return Math.round(ms / n) + " " + name + (isPlural ? "s" : "");
    }
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.BlockTransformStream = void 0;
    const stream_1 = __webpack_require__(0);
    const aligned_lockable_buffer_1 = __webpack_require__(12);
    const constants_1 = __webpack_require__(5);
    const utils_1 = __webpack_require__(6);
    class BlockTransformStream extends stream_1.Transform {
        constructor({chunkSize, alignment, numBuffers = 2}) {
            super({
                objectMode: true,
                highWaterMark: numBuffers - 1
            });
            this.bytesRead = 0;
            this.bytesWritten = 0;
            this.currentBufferPosition = 0;
            this.alignedReadableState = new aligned_lockable_buffer_1.AlignedReadableState(chunkSize, alignment, numBuffers);
        }
        __flush() {
            this.unlockCurrentBuffer();
            if (this.currentBufferPosition !== this.currentBuffer.length) {
                this.push(this.currentBuffer.slice(0, this.currentBufferPosition));
            } else {
                this.push(this.currentBuffer);
            }
            this.bytesWritten += this.currentBufferPosition;
            this.currentBufferPosition = 0;
        }
        async pushChunk(chunk) {
            if (chunk.length === 0) {
                return;
            }
            if (this.currentBufferPosition === 0) {
                this.currentBuffer = this.alignedReadableState.getCurrentBuffer();
                this.unlockCurrentBuffer = await this.currentBuffer.lock();
            }
            const lengthToCopy = Math.min(chunk.length, this.currentBuffer.length - this.currentBufferPosition);
            chunk.copy(this.currentBuffer, this.currentBufferPosition, 0, lengthToCopy);
            this.currentBufferPosition += lengthToCopy;
            this.bytesRead += lengthToCopy;
            if (this.currentBufferPosition === this.currentBuffer.length) {
                this.__flush();
            }
            if (lengthToCopy < chunk.length) {
                await this.pushChunk(chunk.slice(lengthToCopy));
            }
        }
        _transform(chunk, _encoding, callback) {
            utils_1.asCallback(this.pushChunk(chunk), callback);
        }
        _flush(callback) {
            try {
                this.__flush();
                callback();
            } catch (error) {
                callback(error);
            }
        }
        static alignIfNeeded(stream, alignment, numBuffers) {
            if (alignment === undefined) {
                return stream;
            }
            const transform = new BlockTransformStream({
                chunkSize: constants_1.CHUNK_SIZE,
                alignment,
                numBuffers
            });
            stream.on("error", transform.emit.bind(transform, "error"));
            stream.pipe(transform);
            return transform;
        }
    }
    exports.BlockTransformStream = BlockTransformStream;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.BufferDisk = exports.FileDisk = exports.Disk = exports.withOpenFile = exports.DiskStream = exports.DiskChunk = exports.DiscardDiskChunk = exports.BufferDiskChunk = void 0;
    const fs_1 = __webpack_require__(3);
    const stream_1 = __webpack_require__(0);
    const diskchunk_1 = __webpack_require__(127);
    Object.defineProperty(exports, "BufferDiskChunk", {
        enumerable: true,
        get: function() {
            return diskchunk_1.BufferDiskChunk;
        }
    });
    Object.defineProperty(exports, "DiscardDiskChunk", {
        enumerable: true,
        get: function() {
            return diskchunk_1.DiscardDiskChunk;
        }
    });
    Object.defineProperty(exports, "DiskChunk", {
        enumerable: true,
        get: function() {
            return diskchunk_1.DiskChunk;
        }
    });
    const interval_intersection_1 = __webpack_require__(67);
    const mapped_ranges_1 = __webpack_require__(128);
    const MIN_HIGH_WATER_MARK = 16;
    const DEFAULT_HIGH_WATER_MARK = 16384;
    class DiskStream extends stream_1.Readable {
        constructor(disk, capacity, highWaterMark, position) {
            super({
                highWaterMark: Math.max(highWaterMark, MIN_HIGH_WATER_MARK)
            });
            this.disk = disk;
            this.capacity = capacity;
            this.position = position;
            this.isReading = false;
        }
        async __read(size) {
            if (this.isReading) {
                return;
            }
            this.isReading = true;
            while (this.isReading) {
                const length = Math.min(size, this.capacity - this.position);
                if (length <= 0) {
                    this.isReading = this.push(null);
                    return;
                }
                let bytesRead;
                let buffer;
                try {
                    ({bytesRead, buffer} = await this.disk.read(Buffer.allocUnsafe(length), 0, length, this.position));
                } catch (err) {
                    this.emit("error", err);
                    return;
                }
                this.position += bytesRead;
                this.isReading = this.push(buffer);
            }
        }
        _read(size) {
            this.__read(size);
        }
    }
    exports.DiskStream = DiskStream;
    class DiskTransformStream extends stream_1.Transform {
        constructor(disk) {
            super();
            this.disk = disk;
            this.position = 0;
            this.chunks = this.getKnownChunks();
            this.currentChunk = this.chunks.next().value;
        }
        * getKnownChunks() {
            for (const chunk of this.disk.knownChunks) {
                if (chunk instanceof diskchunk_1.BufferDiskChunk) {
                    yield chunk;
                }
            }
        }
        _transform(chunk, _enc, cb) {
            const start = this.position;
            const end = start + chunk.length - 1;
            const interval = [ start, end ];
            while (this.currentChunk) {
                if (interval_intersection_1.intervalIntersection(this.currentChunk.interval(), interval)) {
                    const buf = this.currentChunk.data();
                    const startShift = this.currentChunk.start - start;
                    const endShift = this.currentChunk.end - end;
                    const sourceStart = startShift < 0 ? -startShift : 0;
                    const sourceEnd = buf.length - Math.max(endShift, 0);
                    const targetStart = Math.max(startShift, 0);
                    buf.copy(chunk, targetStart, sourceStart, sourceEnd);
                }
                if (this.currentChunk.end > end) {
                    break;
                } else {
                    this.currentChunk = this.chunks.next().value;
                }
            }
            this.push(chunk);
            this.position = end + 1;
            cb();
        }
    }
    async function withOpenFile(path, flags, fn) {
        const handle = await fs_1.promises.open(path, flags);
        try {
            return await fn(handle);
        } finally {
            await handle.close();
        }
    }
    exports.withOpenFile = withOpenFile;
    class Disk {
        constructor(readOnly = false, recordWrites = false, recordReads = false, discardIsZero = true) {
            this.readOnly = readOnly;
            this.recordWrites = recordWrites;
            this.recordReads = recordReads;
            this.discardIsZero = discardIsZero;
            this.knownChunks = [];
            this.capacity = null;
        }
        getTransformStream() {
            return new DiskTransformStream(this);
        }
        async read(buffer, _bufferOffset, length, fileOffset) {
            const plan = this.createReadPlan(fileOffset, length);
            return await this.readAccordingToPlan(buffer, plan);
        }
        async write(buffer, bufferOffset, length, fileOffset) {
            if (this.recordWrites) {
                const chunk = new diskchunk_1.BufferDiskChunk(buffer.slice(bufferOffset, bufferOffset + length), fileOffset);
                await this.insertDiskChunk(chunk);
            } else {
                const chunk = new diskchunk_1.DiscardDiskChunk(fileOffset, length);
                await this.insertDiskChunk(chunk, false);
            }
            if (this.readOnly) {
                return {
                    bytesWritten: length,
                    buffer
                };
            } else {
                return await this._write(buffer, bufferOffset, length, fileOffset);
            }
        }
        async flush() {
            if (!this.readOnly) {
                return await this._flush();
            }
        }
        async discard(offset, length) {
            await this.insertDiskChunk(new diskchunk_1.DiscardDiskChunk(offset, length));
        }
        async getCapacity() {
            if (this.capacity === null) {
                this.capacity = await this._getCapacity();
            }
            return this.capacity;
        }
        async getStream(position = 0, length = null, highWaterMark = DEFAULT_HIGH_WATER_MARK) {
            let end = await this.getCapacity();
            if (length !== null) {
                end = Math.min(position + length, end);
            }
            return new DiskStream(this, end, highWaterMark, position);
        }
        getDiscardedChunks() {
            return this.knownChunks.filter(chunk => chunk instanceof diskchunk_1.DiscardDiskChunk);
        }
        async getRanges(blockSize) {
            return Array.from(await mapped_ranges_1.getRanges(this, blockSize));
        }
        async insertDiskChunk(chunk, insert = true) {
            const capacity = await this.getCapacity();
            if (chunk.start < 0 || chunk.end > capacity) {
                return;
            }
            let insertAt = 0;
            for (let i = 0; i < this.knownChunks.length; i++) {
                const other = this.knownChunks[i];
                if (other.start > chunk.end) {
                    break;
                }
                if (other.start < chunk.start) {
                    insertAt = i + 1;
                } else {
                    insertAt = i;
                }
                if (!chunk.intersects(other)) {
                    continue;
                } else if (other.includedIn(chunk)) {
                    this.knownChunks.splice(i, 1);
                    i--;
                } else {
                    const newChunks = other.cut(chunk);
                    this.knownChunks.splice(i, 1, ...newChunks);
                    i += newChunks.length - 1;
                }
            }
            if (insert) {
                this.knownChunks.splice(insertAt, 0, chunk);
            }
        }
        createReadPlan(offset, length) {
            const end = offset + length - 1;
            const interval = [ offset, end ];
            let chunks = this.knownChunks;
            if (!this.discardIsZero) {
                chunks = chunks.filter(c => !(c instanceof diskchunk_1.DiscardDiskChunk));
            }
            const intersections = [];
            chunks.forEach(c => {
                const inter = interval_intersection_1.intervalIntersection(interval, c.interval());
                if (inter !== null) {
                    intersections.push(c.slice(inter[0], inter[1]));
                }
            });
            if (intersections.length === 0) {
                return [ interval ];
            }
            const readPlan = [];
            let chunk;
            for (chunk of intersections) {
                if (offset < chunk.start) {
                    readPlan.push([ offset, chunk.start - 1 ]);
                }
                readPlan.push(chunk);
                offset = chunk.end + 1;
            }
            if (chunk && end > chunk.end) {
                readPlan.push([ chunk.end + 1, end ]);
            }
            return readPlan;
        }
        async readAccordingToPlan(buffer, plan) {
            let offset = 0;
            for (const entry of plan) {
                if (entry instanceof diskchunk_1.DiskChunk) {
                    const data = entry.data();
                    const length = Math.min(data.length, buffer.length - offset);
                    data.copy(buffer, offset, 0, length);
                    offset += length;
                } else {
                    const length = entry[1] - entry[0] + 1;
                    await this._read(buffer, offset, length, entry[0]);
                    if (this.recordReads) {
                        const chunk = new diskchunk_1.BufferDiskChunk(Buffer.from(buffer.slice(offset, offset + length)), entry[0]);
                        await this.insertDiskChunk(chunk);
                    }
                    offset += length;
                }
            }
            return {
                bytesRead: offset,
                buffer
            };
        }
    }
    exports.Disk = Disk;
    class FileDisk extends Disk {
        constructor(handle, readOnly = false, recordWrites = false, recordReads = false, discardIsZero = true) {
            super(readOnly, recordWrites, recordReads, discardIsZero);
            this.handle = handle;
        }
        async _getCapacity() {
            const stats = await this.handle.stat();
            return stats.size;
        }
        async _read(buffer, bufferOffset, length, fileOffset) {
            return await this.handle.read(buffer, bufferOffset, length, fileOffset);
        }
        async _write(buffer, bufferOffset, length, fileOffset) {
            return await this.handle.write(buffer, bufferOffset, length, fileOffset);
        }
        async _flush() {
            await this.handle.datasync();
        }
    }
    exports.FileDisk = FileDisk;
    class BufferDisk extends Disk {
        constructor(buffer, readOnly = false, recordWrites = false, recordReads = false, discardIsZero = true) {
            super(readOnly, recordWrites, recordReads, discardIsZero);
            this.buffer = buffer;
        }
        async _getCapacity() {
            return this.buffer.length;
        }
        async _read(buffer, bufferOffset, length, fileOffset) {
            const bytesRead = this.buffer.copy(buffer, bufferOffset, fileOffset, fileOffset + length);
            return {
                buffer,
                bytesRead
            };
        }
        async _write(buffer, bufferOffset, length, fileOffset) {
            const bytesWritten = buffer.copy(this.buffer, fileOffset, bufferOffset, bufferOffset + length);
            return {
                buffer,
                bytesWritten
            };
        }
        async _flush() {}
    }
    exports.BufferDisk = BufferDisk;
}, function(module, exports, __webpack_require__) {
    "use strict";
    var stream = __webpack_require__(0);
    function crc32(buffer, seed, table) {
        var crc = seed ^ -1;
        var length = buffer.length - 15;
        var TABLE = table || crc32.TABLE.DEFAULT;
        var i = 0;
        while (i < length) {
            crc = crc >>> 8 ^ TABLE[255 & (crc ^ buffer[i++])];
            crc = crc >>> 8 ^ TABLE[255 & (crc ^ buffer[i++])];
            crc = crc >>> 8 ^ TABLE[255 & (crc ^ buffer[i++])];
            crc = crc >>> 8 ^ TABLE[255 & (crc ^ buffer[i++])];
            crc = crc >>> 8 ^ TABLE[255 & (crc ^ buffer[i++])];
            crc = crc >>> 8 ^ TABLE[255 & (crc ^ buffer[i++])];
            crc = crc >>> 8 ^ TABLE[255 & (crc ^ buffer[i++])];
            crc = crc >>> 8 ^ TABLE[255 & (crc ^ buffer[i++])];
            crc = crc >>> 8 ^ TABLE[255 & (crc ^ buffer[i++])];
            crc = crc >>> 8 ^ TABLE[255 & (crc ^ buffer[i++])];
            crc = crc >>> 8 ^ TABLE[255 & (crc ^ buffer[i++])];
            crc = crc >>> 8 ^ TABLE[255 & (crc ^ buffer[i++])];
            crc = crc >>> 8 ^ TABLE[255 & (crc ^ buffer[i++])];
            crc = crc >>> 8 ^ TABLE[255 & (crc ^ buffer[i++])];
            crc = crc >>> 8 ^ TABLE[255 & (crc ^ buffer[i++])];
            crc = crc >>> 8 ^ TABLE[255 & (crc ^ buffer[i++])];
        }
        length = length + 15;
        while (i < length) crc = crc >>> 8 ^ TABLE[(crc ^ buffer[i++]) & 255];
        return crc ^ -1;
    }
    module.exports = crc32;
    crc32.TABLE = {
        DEFAULT: new Int32Array([ 0, 1996959894, 3993919788, 2567524794, 124634137, 1886057615, 3915621685, 2657392035, 249268274, 2044508324, 3772115230, 2547177864, 162941995, 2125561021, 3887607047, 2428444049, 498536548, 1789927666, 4089016648, 2227061214, 450548861, 1843258603, 4107580753, 2211677639, 325883990, 1684777152, 4251122042, 2321926636, 335633487, 1661365465, 4195302755, 2366115317, 997073096, 1281953886, 3579855332, 2724688242, 1006888145, 1258607687, 3524101629, 2768942443, 901097722, 1119000684, 3686517206, 2898065728, 853044451, 1172266101, 3705015759, 2882616665, 651767980, 1373503546, 3369554304, 3218104598, 565507253, 1454621731, 3485111705, 3099436303, 671266974, 1594198024, 3322730930, 2970347812, 795835527, 1483230225, 3244367275, 3060149565, 1994146192, 31158534, 2563907772, 4023717930, 1907459465, 112637215, 2680153253, 3904427059, 2013776290, 251722036, 2517215374, 3775830040, 2137656763, 141376813, 2439277719, 3865271297, 1802195444, 476864866, 2238001368, 4066508878, 1812370925, 453092731, 2181625025, 4111451223, 1706088902, 314042704, 2344532202, 4240017532, 1658658271, 366619977, 2362670323, 4224994405, 1303535960, 984961486, 2747007092, 3569037538, 1256170817, 1037604311, 2765210733, 3554079995, 1131014506, 879679996, 2909243462, 3663771856, 1141124467, 855842277, 2852801631, 3708648649, 1342533948, 654459306, 3188396048, 3373015174, 1466479909, 544179635, 3110523913, 3462522015, 1591671054, 702138776, 2966460450, 3352799412, 1504918807, 783551873, 3082640443, 3233442989, 3988292384, 2596254646, 62317068, 1957810842, 3939845945, 2647816111, 81470997, 1943803523, 3814918930, 2489596804, 225274430, 2053790376, 3826175755, 2466906013, 167816743, 2097651377, 4027552580, 2265490386, 503444072, 1762050814, 4150417245, 2154129355, 426522225, 1852507879, 4275313526, 2312317920, 282753626, 1742555852, 4189708143, 2394877945, 397917763, 1622183637, 3604390888, 2714866558, 953729732, 1340076626, 3518719985, 2797360999, 1068828381, 1219638859, 3624741850, 2936675148, 906185462, 1090812512, 3747672003, 2825379669, 829329135, 1181335161, 3412177804, 3160834842, 628085408, 1382605366, 3423369109, 3138078467, 570562233, 1426400815, 3317316542, 2998733608, 733239954, 1555261956, 3268935591, 3050360625, 752459403, 1541320221, 2607071920, 3965973030, 1969922972, 40735498, 2617837225, 3943577151, 1913087877, 83908371, 2512341634, 3803740692, 2075208622, 213261112, 2463272603, 3855990285, 2094854071, 198958881, 2262029012, 4057260610, 1759359992, 534414190, 2176718541, 4139329115, 1873836001, 414664567, 2282248934, 4279200368, 1711684554, 285281116, 2405801727, 4167216745, 1634467795, 376229701, 2685067896, 3608007406, 1308918612, 956543938, 2808555105, 3495958263, 1231636301, 1047427035, 2932959818, 3654703836, 1088359270, 936918e3, 2847714899, 3736837829, 1202900863, 817233897, 3183342108, 3401237130, 1404277552, 615818150, 3134207493, 3453421203, 1423857449, 601450431, 3009837614, 3294710456, 1567103746, 711928724, 3020668471, 3272380065, 1510334235, 755167117 ]),
        CASTAGNOLI: new Int32Array([ 0, 4067132163, 3778769143, 324072436, 3348797215, 904991772, 648144872, 3570033899, 2329499855, 2024987596, 1809983544, 2575936315, 1296289744, 3207089363, 2893594407, 1578318884, 274646895, 3795141740, 4049975192, 51262619, 3619967088, 632279923, 922689671, 3298075524, 2592579488, 1760304291, 2075979607, 2312596564, 1562183871, 2943781820, 3156637768, 1313733451, 549293790, 3537243613, 3246849577, 871202090, 3878099393, 357341890, 102525238, 4101499445, 2858735121, 1477399826, 1264559846, 3107202533, 1845379342, 2677391885, 2361733625, 2125378298, 820201905, 3263744690, 3520608582, 598981189, 4151959214, 85089709, 373468761, 3827903834, 3124367742, 1213305469, 1526817161, 2842354314, 2107672161, 2412447074, 2627466902, 1861252501, 1098587580, 3004210879, 2688576843, 1378610760, 2262928035, 1955203488, 1742404180, 2511436119, 3416409459, 969524848, 714683780, 3639785095, 205050476, 4266873199, 3976438427, 526918040, 1361435347, 2739821008, 2954799652, 1114974503, 2529119692, 1691668175, 2005155131, 2247081528, 3690758684, 697762079, 986182379, 3366744552, 476452099, 3993867776, 4250756596, 255256311, 1640403810, 2477592673, 2164122517, 1922457750, 2791048317, 1412925310, 1197962378, 3037525897, 3944729517, 427051182, 170179418, 4165941337, 746937522, 3740196785, 3451792453, 1070968646, 1905808397, 2213795598, 2426610938, 1657317369, 3053634322, 1147748369, 1463399397, 2773627110, 4215344322, 153784257, 444234805, 3893493558, 1021025245, 3467647198, 3722505002, 797665321, 2197175160, 1889384571, 1674398607, 2443626636, 1164749927, 3070701412, 2757221520, 1446797203, 137323447, 4198817972, 3910406976, 461344835, 3484808360, 1037989803, 781091935, 3705997148, 2460548119, 1623424788, 1939049696, 2180517859, 1429367560, 2807687179, 3020495871, 1180866812, 410100952, 3927582683, 4182430767, 186734380, 3756733383, 763408580, 1053836080, 3434856499, 2722870694, 1344288421, 1131464017, 2971354706, 1708204729, 2545590714, 2229949006, 1988219213, 680717673, 3673779818, 3383336350, 1002577565, 4010310262, 493091189, 238226049, 4233660802, 2987750089, 1082061258, 1395524158, 2705686845, 1972364758, 2279892693, 2494862625, 1725896226, 952904198, 3399985413, 3656866545, 731699698, 4283874585, 222117402, 510512622, 3959836397, 3280807620, 837199303, 582374963, 3504198960, 68661723, 4135334616, 3844915500, 390545967, 1230274059, 3141532936, 2825850620, 1510247935, 2395924756, 2091215383, 1878366691, 2644384480, 3553878443, 565732008, 854102364, 3229815391, 340358836, 3861050807, 4117890627, 119113024, 1493875044, 2875275879, 3090270611, 1247431312, 2660249211, 1828433272, 2141937292, 2378227087, 3811616794, 291187481, 34330861, 4032846830, 615137029, 3603020806, 3314634738, 939183345, 1776939221, 2609017814, 2295496738, 2058945313, 2926798794, 1545135305, 1330124605, 3173225534, 4084100981, 17165430, 307568514, 3762199681, 888469610, 3332340585, 3587147933, 665062302, 2042050490, 2346497209, 2559330125, 1793573966, 3190661285, 1279665062, 1595330642, 2910671697 ])
    };
    crc32.Hash = class CRC32Stream extends stream.Transform {
        constructor(options) {
            super(options);
            this.bytesRead = 0;
            this.bytesWritten = 0;
            this.crc = options && options.seed != null ? options.seed : 0;
            this.crcTable = options && (options.table || crc32.TABLE.DEFAULT);
        }
        update(data, encoding) {
            this.write(data, encoding);
            return this;
        }
        digest(encoding) {
            var buffer = Buffer.alloc(4, 0);
            buffer.writeInt32BE(this.crc, 0);
            return encoding == null ? buffer : buffer.toString(encoding);
        }
        _transform(chunk, _, next) {
            this.bytesRead += chunk.length;
            this.crc = crc32(chunk, this.crc, this.crcTable);
            next();
        }
        _flush(done) {
            this.push(this.digest());
            this.bytesWritten += 4;
            done();
        }
    };
    crc32.createHash = function createHash() {
        return new crc32.Hash;
    };
}, function(module, exports) {
    function CHS(cylinder, head, sector) {
        if (!(this instanceof CHS)) return new CHS(cylinder, head, sector);
        if (Buffer.isBuffer(cylinder)) return CHS.fromBuffer(cylinder);
        this.cylinder = cylinder & 1023;
        this.head = head & 255;
        this.sector = sector & 63;
    }
    CHS.fromBuffer = function(buffer, offset) {
        return (new CHS).parse(buffer, offset);
    };
    CHS.fromLBA = function(lba, hpt, spt) {
        return (new CHS).setLBA(lba, hpt, spt);
    };
    CHS.prototype = {
        constructor: CHS,
        set buffer(value) {
            return this.parse(value);
        },
        get buffer() {
            return this.toBuffer();
        },
        setLBA: function(lba, hpt, spt) {
            this.cylinder = lba / (spt * hpt) | 0;
            this.head = lba / spt % hpt;
            this.sector = lba % spt + 1;
            return this;
        },
        getLBA: function(hpt, spt) {
            return (this.cylinder * hpt + this.head) * spt + (this.sector - 1);
        },
        toLBA: function(hpt, spt) {
            return this.getLBA(hpt, spt);
        },
        clone: function() {
            return new CHS(this.cylinder, this.head, this.sector);
        },
        copy: function(target) {
            target.cylinder = this.cylinder;
            target.head = this.head;
            target.sector = this.sector;
            return target;
        },
        parse: function(buffer, offset) {
            if (!Buffer.isBuffer(buffer)) throw new TypeError("Value must be a buffer");
            offset = offset || 0;
            return this.fromNumber(buffer.readUIntLE(offset, 3));
        },
        write: function(buffer, offset) {
            offset = offset || 0;
            buffer.writeUIntLE(this.toNumber(), offset, 3);
            return buffer;
        },
        toBuffer: function() {
            return this.write(Buffer.alloc(3));
        },
        fromNumber: function(value) {
            this.head = (value & 16711680) >>> 16;
            this.cylinder = (value & 65472) >>> 6;
            this.sector = value & 63;
            return this;
        },
        toNumber: function() {
            var value = (this.head & 255) << 16;
            value = value | this.cylinder << 6 & 65472;
            value = value | this.sector & 63;
            return value;
        }
    };
    module.exports = CHS;
}, function(module, exports, __webpack_require__) {
    if (typeof process === "undefined" || process.type === "renderer" || process.browser === true || process.__nwjs) {
        module.exports = __webpack_require__(144);
    } else {
        module.exports = __webpack_require__(145);
    }
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.SparseReadStream = void 0;
    const stream_1 = __webpack_require__(0);
    const aligned_lockable_buffer_1 = __webpack_require__(12);
    const shared_1 = __webpack_require__(19);
    class SparseReadStream extends stream_1.Readable {
        constructor({source, blocks, chunkSize, verify, generateChecksums, alignment, numBuffers = 2}) {
            super({
                objectMode: true,
                highWaterMark: numBuffers - 1
            });
            this.positionInBlock = 0;
            this.source = source;
            this.blocks = blocks;
            this.chunkSize = chunkSize;
            if (alignment !== undefined) {
                this.alignedReadableState = new aligned_lockable_buffer_1.AlignedReadableState(chunkSize, alignment, numBuffers);
            }
            this.stateIterator = shared_1.createSparseReaderStateIterator(blocks, verify, generateChecksums);
            this.nextBlock();
        }
        async _read() {
            try {
                this.push(await this.__read());
            } catch (error) {
                this.emit("error", error);
                this.push(null);
            }
        }
        nextBlock() {
            this.state = this.stateIterator.next().value;
            this.positionInBlock = 0;
        }
        async __read() {
            var _a;
            if (this.state === undefined) {
                return null;
            }
            const length = Math.min(this.chunkSize, this.state.subBlock.length - this.positionInBlock);
            const buffer = this.alignedReadableState !== undefined ? this.alignedReadableState.getCurrentBuffer().slice(0, length) : Buffer.allocUnsafe(length);
            const unlock = aligned_lockable_buffer_1.isAlignedLockableBuffer(buffer) ? await buffer.lock() : undefined;
            try {
                await this.source.read(buffer, 0, length, this.state.subBlock.offset + this.positionInBlock);
                (_a = this.state.hasher) === null || _a === void 0 ? void 0 : _a.update(buffer);
            } finally {
                unlock === null || unlock === void 0 ? void 0 : unlock();
            }
            const chunk = {
                buffer,
                position: this.state.subBlock.offset + this.positionInBlock
            };
            this.positionInBlock += length;
            if (this.positionInBlock === this.state.subBlock.length) {
                this.nextBlock();
            }
            return chunk;
        }
    }
    exports.SparseReadStream = SparseReadStream;
}, function(module, exports) {
    module.exports = {
        E2FS_BLK_OPEN: 0,
        E2FS_BLK_CLOSE: 1,
        E2FS_BLK_READ: 2,
        E2FS_BLK_WRITE: 3,
        E2FS_BLK_FLUSH: 4,
        E2FS_BLK_DISCARD: 10,
        E2FS_BLK_CACHE_READAHEAD: 11,
        E2FS_BLK_ZEROOUT: 12,
        EINVAL: -22
    };
}, function(module, exports) {
    module.exports = require("child_process");
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.ProgressSparseWriteStream = exports.SparseWriteStream = void 0;
    const direct_io_1 = __webpack_require__(29);
    const stream_1 = __webpack_require__(0);
    const aligned_lockable_buffer_1 = __webpack_require__(12);
    const constants_1 = __webpack_require__(5);
    const errors_1 = __webpack_require__(8);
    const progress_1 = __webpack_require__(13);
    const utils_1 = __webpack_require__(6);
    class SparseWriteStream extends stream_1.Writable {
        constructor({destination, highWaterMark, firstBytesToKeep = 0, maxRetries = 5}) {
            super({
                objectMode: true,
                highWaterMark
            });
            this.bytesWritten = 0;
            this._firstChunks = [];
            this.destination = destination;
            this.firstBytesToKeep = firstBytesToKeep;
            this.maxRetries = maxRetries;
        }
        async writeChunk(chunk, flushing = false) {
            let retries = 0;
            while (true) {
                try {
                    this.position = chunk.position;
                    await this.destination.write(chunk.buffer, 0, chunk.buffer.length, chunk.position);
                    if (!flushing) {
                        this.position += chunk.buffer.length;
                        this.bytesWritten += chunk.buffer.length;
                    }
                    return;
                } catch (error) {
                    if (errors_1.isTransientError(error)) {
                        if (retries < this.maxRetries) {
                            retries += 1;
                            await utils_1.delay(constants_1.RETRY_BASE_TIMEOUT * retries);
                            continue;
                        }
                        error.code = "EUNPLUGGED";
                    }
                    throw error;
                }
            }
        }
        copyChunk(chunk) {
            if (aligned_lockable_buffer_1.isAlignedLockableBuffer(chunk.buffer)) {
                const buffer = direct_io_1.getAlignedBuffer(chunk.buffer.length, chunk.buffer.alignment);
                chunk.buffer.copy(buffer);
                return {
                    position: chunk.position,
                    buffer
                };
            } else {
                return chunk;
            }
        }
        async __write(chunk) {
            const unlock = aligned_lockable_buffer_1.isAlignedLockableBuffer(chunk.buffer) ? await chunk.buffer.rlock() : undefined;
            try {
                if (chunk.position < this.firstBytesToKeep) {
                    const end = chunk.position + chunk.buffer.length;
                    if (end <= this.firstBytesToKeep) {
                        this._firstChunks.push(this.copyChunk(chunk));
                        this.position = chunk.position + chunk.buffer.length;
                        this.bytesWritten += chunk.buffer.length;
                    } else {
                        const difference = this.firstBytesToKeep - chunk.position;
                        this._firstChunks.push(this.copyChunk({
                            position: chunk.position,
                            buffer: chunk.buffer.slice(0, difference)
                        }));
                        this.position = this.firstBytesToKeep;
                        this.bytesWritten += difference;
                        const remainingBuffer = chunk.buffer.slice(difference);
                        await this.writeChunk({
                            position: this.firstBytesToKeep,
                            buffer: remainingBuffer
                        });
                    }
                } else {
                    await this.writeChunk(chunk);
                }
            } finally {
                unlock === null || unlock === void 0 ? void 0 : unlock();
            }
        }
        _write(chunk, _enc, callback) {
            utils_1.asCallback(this.__write(chunk), callback);
        }
        async __final() {
            try {
                for (const chunk of this._firstChunks) {
                    await this.writeChunk(chunk, true);
                }
            } catch (error) {
                this.destroy();
                throw error;
            }
        }
        _final(callback) {
            utils_1.asCallback(this.__final(), callback);
        }
    }
    exports.SparseWriteStream = SparseWriteStream;
    exports.ProgressSparseWriteStream = progress_1.makeClassEmitProgressEvents(SparseWriteStream, "bytesWritten", "position");
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.File = exports.ProgressWriteStream = void 0;
    const fs_1 = __webpack_require__(3);
    const path_1 = __webpack_require__(4);
    const progress_1 = __webpack_require__(13);
    const source_destination_1 = __webpack_require__(7);
    const block_read_stream_1 = __webpack_require__(65);
    const sparse_write_stream_1 = __webpack_require__(53);
    exports.ProgressWriteStream = progress_1.makeClassEmitProgressEvents(fs_1.WriteStream, "bytesWritten", "bytesWritten");
    const READ_TRIES = 5;
    const readEndMarker = Buffer.from(`not the correct data ${Math.random()}`);
    class File extends source_destination_1.SourceDestination {
        constructor({path, write = false}) {
            super();
            this.path = path;
            this.oWrite = write;
        }
        getOpenFlags() {
            return this.oWrite ? fs_1.constants.O_CREAT | fs_1.constants.O_RDWR : fs_1.constants.O_RDONLY;
        }
        async canRead() {
            return true;
        }
        async canWrite() {
            return this.oWrite;
        }
        async canCreateReadStream() {
            return true;
        }
        canCreateWriteStream() {
            return this.canWrite();
        }
        canCreateSparseWriteStream() {
            return this.canWrite();
        }
        async _getMetadata() {
            return {
                size: (await fs_1.promises.stat(this.path)).size,
                name: path_1.basename(this.path)
            };
        }
        async read(buffer, bufferOffset, length, sourceOffset) {
            let result;
            let tries = READ_TRIES;
            const markerPosition = bufferOffset + length - readEndMarker.length;
            if (length >= readEndMarker.length) {
                readEndMarker.copy(buffer, markerPosition);
            }
            do {
                if (tries < READ_TRIES) {
                    console.warn("Incomplete read", {
                        path: this.path,
                        bufferOffset,
                        length,
                        sourceOffset,
                        bufferLength: buffer.length
                    });
                }
                result = await this.fileHandle.read(buffer, bufferOffset, length, sourceOffset);
                tries -= 1;
            } while (tries > 0 && length >= readEndMarker.length && result.bytesRead === length && readEndMarker.compare(buffer, markerPosition, markerPosition + readEndMarker.length) === 0);
            return result;
        }
        write(buffer, bufferOffset, length, fileOffset) {
            return this.fileHandle.write(buffer, bufferOffset, length, fileOffset);
        }
        async createReadStream({emitProgress = false, start = 0, end, alignment, numBuffers} = {}) {
            await this.open();
            const metadata = await this.getMetadata();
            if (metadata.size !== 0) {
                const lastByte = metadata.size - 1;
                end = end === undefined ? lastByte : Math.min(end, lastByte);
            }
            if (emitProgress) {
                return new block_read_stream_1.ProgressBlockReadStream({
                    source: this,
                    alignment,
                    start,
                    end,
                    numBuffers
                });
            } else {
                return new block_read_stream_1.BlockReadStream({
                    source: this,
                    alignment,
                    start,
                    end,
                    numBuffers
                });
            }
        }
        async createWriteStream({highWaterMark} = {}) {
            const stream = new exports.ProgressWriteStream(null, {
                fd: this.fileHandle.fd,
                autoClose: false,
                highWaterMark
            });
            stream.on("finish", stream.emit.bind(stream, "done"));
            return stream;
        }
        async createSparseWriteStream({highWaterMark} = {}) {
            const stream = new sparse_write_stream_1.ProgressSparseWriteStream({
                destination: this,
                highWaterMark
            });
            stream.on("finish", stream.emit.bind(stream, "done"));
            return stream;
        }
        async _open() {
            this.fileHandle = await fs_1.promises.open(this.path, this.getOpenFlags());
        }
        async _close() {
            await this.fileHandle.close();
        }
    }
    exports.File = File;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.Checksum = void 0;
    const constants_1 = __webpack_require__(16);
    class Checksum {
        constructor() {
            this.type = constants_1.CHECKSUM_TYPE.NONE;
            this.bits = 0;
            this.value = "";
        }
        static parse(buffer, offset) {
            return (new Checksum).parse(buffer, offset);
        }
        parse(buffer, offset = 0) {
            this.type = buffer.readUInt32BE(offset + 0);
            this.bits = buffer.readUInt32BE(offset + 4);
            this.value = buffer.toString("hex", offset + 8, offset + 8 + this.bits / 8);
            return this;
        }
        write(buffer, offset = 0) {
            buffer = buffer || Buffer.alloc(Checksum.SIZE + offset);
            buffer.writeUInt32BE(this.type, offset + 0);
            buffer.writeUInt32BE(this.bits, offset + 4);
            buffer.write(this.value, offset + 8, this.bits / 8, "hex");
            return buffer;
        }
    }
    exports.Checksum = Checksum;
    Checksum.SIZE = 128;
}, function(module, exports, __webpack_require__) {
    var ADC = module.exports;
    ADC.CHUNK_DATA = 128;
    ADC.CHUNK_THREE = 64;
    ADC.CHUNK_TWO = 63;
    ADC.getChunkType = function(byte) {
        if ((byte & 128) === 128) return ADC.CHUNK_DATA;
        if ((byte & 64) === 64) return ADC.CHUNK_THREE;
        return ADC.CHUNK_TWO;
    };
    ADC.getChunkLength = function(byte) {
        var chunkType = ADC.getChunkType(byte);
        switch (chunkType) {
          case ADC.CHUNK_DATA:
            return (byte & 127) + 1;

          case ADC.CHUNK_THREE:
            return (byte & 63) + 4;

          case ADC.CHUNK_TWO:
            return ((byte & 60) >> 2) + 3;

          default:
            return -1;
        }
    };
    ADC.getSequenceLength = function(byte) {
        var chunkType = ADC.getChunkType(byte);
        switch (chunkType) {
          case ADC.CHUNK_DATA:
            return (byte & 127) + 2;

          case ADC.CHUNK_THREE:
            return 3;

          case ADC.CHUNK_TWO:
            return 2;

          default:
            return 0;
        }
    };
    ADC.getOffset = function(buffer, position) {
        var chunkType = ADC.getChunkType(buffer[position]);
        switch (chunkType) {
          case ADC.CHUNK_DATA:
            return 0;

          case ADC.CHUNK_THREE:
            return (buffer[position + 1] << 8) + buffer[position + 2];

          case ADC.CHUNK_TWO:
            return ((buffer[position] & 3) << 8) + buffer[position + 1];

          default:
            return -1;
        }
    };
    ADC.decompress = __webpack_require__(196);
    ADC.Decompressor = __webpack_require__(197);
    ADC.createDecompress = function(options) {
        return new ADC.Decompressor(options);
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    var utils = __webpack_require__(10);
    var settle = __webpack_require__(206);
    var buildFullPath = __webpack_require__(207);
    var buildURL = __webpack_require__(93);
    var http = __webpack_require__(98);
    var https = __webpack_require__(99);
    var httpFollow = __webpack_require__(100).http;
    var httpsFollow = __webpack_require__(100).https;
    var url = __webpack_require__(58);
    var zlib = __webpack_require__(18);
    var pkg = __webpack_require__(214);
    var createError = __webpack_require__(96);
    var enhanceError = __webpack_require__(97);
    var isHttps = /https:?/;
    module.exports = function httpAdapter(config) {
        return new Promise((function dispatchHttpRequest(resolvePromise, rejectPromise) {
            var resolve = function resolve(value) {
                resolvePromise(value);
            };
            var reject = function reject(value) {
                rejectPromise(value);
            };
            var data = config.data;
            var headers = config.headers;
            if (!headers["User-Agent"] && !headers["user-agent"]) {
                headers["User-Agent"] = "axios/" + pkg.version;
            }
            if (data && !utils.isStream(data)) {
                if (Buffer.isBuffer(data)) {} else if (utils.isArrayBuffer(data)) {
                    data = Buffer.from(new Uint8Array(data));
                } else if (utils.isString(data)) {
                    data = Buffer.from(data, "utf-8");
                } else {
                    return reject(createError("Data after transformation must be a string, an ArrayBuffer, a Buffer, or a Stream", config));
                }
                headers["Content-Length"] = data.length;
            }
            var auth = undefined;
            if (config.auth) {
                var username = config.auth.username || "";
                var password = config.auth.password || "";
                auth = username + ":" + password;
            }
            var fullPath = buildFullPath(config.baseURL, config.url);
            var parsed = url.parse(fullPath);
            var protocol = parsed.protocol || "http:";
            if (!auth && parsed.auth) {
                var urlAuth = parsed.auth.split(":");
                var urlUsername = urlAuth[0] || "";
                var urlPassword = urlAuth[1] || "";
                auth = urlUsername + ":" + urlPassword;
            }
            if (auth) {
                delete headers.Authorization;
            }
            var isHttpsRequest = isHttps.test(protocol);
            var agent = isHttpsRequest ? config.httpsAgent : config.httpAgent;
            var options = {
                path: buildURL(parsed.path, config.params, config.paramsSerializer).replace(/^\?/, ""),
                method: config.method.toUpperCase(),
                headers,
                agent,
                agents: {
                    http: config.httpAgent,
                    https: config.httpsAgent
                },
                auth
            };
            if (config.socketPath) {
                options.socketPath = config.socketPath;
            } else {
                options.hostname = parsed.hostname;
                options.port = parsed.port;
            }
            var proxy = config.proxy;
            if (!proxy && proxy !== false) {
                var proxyEnv = protocol.slice(0, -1) + "_proxy";
                var proxyUrl = process.env[proxyEnv] || process.env[proxyEnv.toUpperCase()];
                if (proxyUrl) {
                    var parsedProxyUrl = url.parse(proxyUrl);
                    var noProxyEnv = process.env.no_proxy || process.env.NO_PROXY;
                    var shouldProxy = true;
                    if (noProxyEnv) {
                        var noProxy = noProxyEnv.split(",").map((function trim(s) {
                            return s.trim();
                        }));
                        shouldProxy = !noProxy.some((function proxyMatch(proxyElement) {
                            if (!proxyElement) {
                                return false;
                            }
                            if (proxyElement === "*") {
                                return true;
                            }
                            if (proxyElement[0] === "." && parsed.hostname.substr(parsed.hostname.length - proxyElement.length) === proxyElement) {
                                return true;
                            }
                            return parsed.hostname === proxyElement;
                        }));
                    }
                    if (shouldProxy) {
                        proxy = {
                            host: parsedProxyUrl.hostname,
                            port: parsedProxyUrl.port
                        };
                        if (parsedProxyUrl.auth) {
                            var proxyUrlAuth = parsedProxyUrl.auth.split(":");
                            proxy.auth = {
                                username: proxyUrlAuth[0],
                                password: proxyUrlAuth[1]
                            };
                        }
                    }
                }
            }
            if (proxy) {
                options.hostname = proxy.host;
                options.host = proxy.host;
                options.headers.host = parsed.hostname + (parsed.port ? ":" + parsed.port : "");
                options.port = proxy.port;
                options.path = protocol + "//" + parsed.hostname + (parsed.port ? ":" + parsed.port : "") + options.path;
                if (proxy.auth) {
                    var base64 = Buffer.from(proxy.auth.username + ":" + proxy.auth.password, "utf8").toString("base64");
                    options.headers["Proxy-Authorization"] = "Basic " + base64;
                }
            }
            var transport;
            var isHttpsProxy = isHttpsRequest && (proxy ? isHttps.test(proxy.protocol) : true);
            if (config.transport) {
                transport = config.transport;
            } else if (config.maxRedirects === 0) {
                transport = isHttpsProxy ? https : http;
            } else {
                if (config.maxRedirects) {
                    options.maxRedirects = config.maxRedirects;
                }
                transport = isHttpsProxy ? httpsFollow : httpFollow;
            }
            if (config.maxContentLength && config.maxContentLength > -1) {
                options.maxBodyLength = config.maxContentLength;
            }
            var req = transport.request(options, (function handleResponse(res) {
                if (req.aborted) return;
                var stream = res;
                switch (res.headers["content-encoding"]) {
                  case "gzip":
                  case "compress":
                  case "deflate":
                    stream = res.statusCode === 204 ? stream : stream.pipe(zlib.createUnzip());
                    delete res.headers["content-encoding"];
                    break;
                }
                var lastRequest = res.req || req;
                var response = {
                    status: res.statusCode,
                    statusText: res.statusMessage,
                    headers: res.headers,
                    config,
                    request: lastRequest
                };
                if (config.responseType === "stream") {
                    response.data = stream;
                    settle(resolve, reject, response);
                } else {
                    var responseBuffer = [];
                    stream.on("data", (function handleStreamData(chunk) {
                        responseBuffer.push(chunk);
                        if (config.maxContentLength > -1 && Buffer.concat(responseBuffer).length > config.maxContentLength) {
                            stream.destroy();
                            reject(createError("maxContentLength size of " + config.maxContentLength + " exceeded", config, null, lastRequest));
                        }
                    }));
                    stream.on("error", (function handleStreamError(err) {
                        if (req.aborted) return;
                        reject(enhanceError(err, config, null, lastRequest));
                    }));
                    stream.on("end", (function handleStreamEnd() {
                        var responseData = Buffer.concat(responseBuffer);
                        if (config.responseType !== "arraybuffer") {
                            responseData = responseData.toString(config.responseEncoding);
                        }
                        response.data = responseData;
                        settle(resolve, reject, response);
                    }));
                }
            }));
            req.on("error", (function handleRequestError(err) {
                if (req.aborted) return;
                reject(enhanceError(err, config, null, req));
            }));
            if (config.timeout) {
                req.setTimeout(config.timeout, (function handleRequestTimeout() {
                    req.abort();
                    reject(createError("timeout of " + config.timeout + "ms exceeded", config, "ECONNABORTED", req));
                }));
            }
            if (config.cancelToken) {
                config.cancelToken.promise.then((function onCanceled(cancel) {
                    if (req.aborted) return;
                    req.abort();
                    reject(cancel);
                }));
            }
            if (utils.isStream(data)) {
                data.on("error", (function handleStreamError(err) {
                    reject(enhanceError(err, config, null, req));
                })).pipe(req);
            } else {
                req.end(data);
            }
        }));
    };
}, function(module, exports) {
    module.exports = require("url");
}, function(module, exports, __webpack_require__) {
    var isArray = __webpack_require__(60).isArray;
    module.exports = {
        copyOptions: function(options) {
            var key, copy = {};
            for (key in options) {
                if (options.hasOwnProperty(key)) {
                    copy[key] = options[key];
                }
            }
            return copy;
        },
        ensureFlagExists: function(item, options) {
            if (!(item in options) || typeof options[item] !== "boolean") {
                options[item] = false;
            }
        },
        ensureSpacesExists: function(options) {
            if (!("spaces" in options) || typeof options.spaces !== "number" && typeof options.spaces !== "string") {
                options.spaces = 0;
            }
        },
        ensureAlwaysArrayExists: function(options) {
            if (!("alwaysArray" in options) || typeof options.alwaysArray !== "boolean" && !isArray(options.alwaysArray)) {
                options.alwaysArray = false;
            }
        },
        ensureKeyExists: function(key, options) {
            if (!(key + "Key" in options) || typeof options[key + "Key"] !== "string") {
                options[key + "Key"] = options.compact ? "_" + key : key;
            }
        },
        checkFnExists: function(key, options) {
            return key + "Fn" in options;
        }
    };
}, function(module, exports) {
    module.exports = {
        isArray: function(value) {
            if (Array.isArray) {
                return Array.isArray(value);
            }
            return Object.prototype.toString.call(value) === "[object Array]";
        }
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.Chunk = void 0;
    class Chunk {
        constructor(buffer, position) {
            this.buffer = buffer;
            this.position = position;
        }
        get length() {
            return this.buffer.length;
        }
    }
    exports.Chunk = Chunk;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.ReadRangeError = exports.ReadRange = void 0;
    class ReadRange {
        constructor(range, blockSize) {
            this.range = range;
            this.offset = 0;
            this.checksum = range.checksum;
            this.start = range.start * blockSize;
            this.end = (range.end + 1) * blockSize;
            this.length = range.length * blockSize;
            this.startLBA = range.start;
            this.endLBA = range.end;
        }
    }
    exports.ReadRange = ReadRange;
    class ReadRangeError extends Error {
        constructor(message, range, checksum) {
            super(message);
            this.range = range;
            this.checksum = checksum;
        }
    }
    exports.ReadRangeError = ReadRangeError;
}, function(module, exports, __webpack_require__) {
    "use strict";
    function EventPubSub() {
        this._events_ = {};
        this.publish = this.trigger = this.emit = emit;
        this.subscribe = this.on = on;
        this.once = once;
        this.unSubscribe = this.off = off;
        this.emit$ = emit$;
        function on(type, handler, once) {
            if (!handler) {
                throw new ReferenceError("handler not defined.");
            }
            if (!this._events_[type]) {
                this._events_[type] = [];
            }
            if (once) {
                handler._once_ = once;
            }
            this._events_[type].push(handler);
            return this;
        }
        function once(type, handler) {
            return this.on(type, handler, true);
        }
        function off(type, handler) {
            if (!this._events_[type]) {
                return this;
            }
            if (!handler) {
                throw new ReferenceError('handler not defined. if you wish to remove all handlers from the event please pass "*" as the handler');
            }
            if (handler == "*") {
                delete this._events_[type];
                return this;
            }
            var handlers = this._events_[type];
            while (handlers.includes(handler)) {
                handlers.splice(handlers.indexOf(handler), 1);
            }
            if (handlers.length < 1) {
                delete this._events_[type];
            }
            return this;
        }
        function emit(type) {
            this.emit$.apply(this, arguments);
            if (!this._events_[type]) {
                return this;
            }
            arguments.splice = Array.prototype.splice;
            arguments.splice(0, 1);
            var handlers = this._events_[type];
            var onceHandled = [];
            for (var i in handlers) {
                var handler = handlers[i];
                handler.apply(this, arguments);
                if (handler._once_) {
                    onceHandled.push(handler);
                }
            }
            for (var i in onceHandled) {
                this.off(type, onceHandled[i]);
            }
            return this;
        }
        function emit$(type, args) {
            if (!this._events_["*"]) {
                return this;
            }
            var catchAll = this._events_["*"];
            args.shift = Array.prototype.shift;
            args.shift(type);
            for (var handler of catchAll) {
                handler.apply(this, args);
            }
            return this;
        }
        return this;
    }
    if (!Array.prototype.includes) {
        Array.prototype.includes = function(searchElement) {
            "use strict";
            if (this == null) {
                throw new TypeError("Array.prototype.includes called on null or undefined");
            }
            var O = Object(this);
            var len = parseInt(O.length, 10) || 0;
            if (len === 0) {
                return false;
            }
            var n = parseInt(arguments[1], 10) || 0;
            var k;
            if (n >= 0) {
                k = n;
            } else {
                k = len + n;
                if (k < 0) {
                    k = 0;
                }
            }
            var currentElement;
            while (k < len) {
                currentElement = O[k];
                if (searchElement === currentElement || searchElement !== searchElement && currentElement !== currentElement) {
                    return true;
                }
                k++;
            }
            return false;
        };
    }
    module.exports = EventPubSub;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.utils = exports.sparseStream = exports.sourceDestination = exports.scanner = exports.multiWrite = exports.errors = exports.constants = void 0;
    const constants = __webpack_require__(5);
    exports.constants = constants;
    const errors = __webpack_require__(8);
    exports.errors = errors;
    const multiWrite = __webpack_require__(119);
    exports.multiWrite = multiWrite;
    const scanner = __webpack_require__(173);
    exports.scanner = scanner;
    const sourceDestination = __webpack_require__(23);
    exports.sourceDestination = sourceDestination;
    const sparseStream = __webpack_require__(246);
    exports.sparseStream = sparseStream;
    const utils = __webpack_require__(6);
    exports.utils = utils;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.ProgressBlockReadStream = exports.BlockReadStream = void 0;
    const stream_1 = __webpack_require__(0);
    const aligned_lockable_buffer_1 = __webpack_require__(12);
    const constants_1 = __webpack_require__(5);
    const errors_1 = __webpack_require__(8);
    const progress_1 = __webpack_require__(13);
    const utils_1 = __webpack_require__(6);
    class BlockReadStream extends stream_1.Readable {
        constructor({source, alignment, start = 0, end = Infinity, chunkSize = constants_1.CHUNK_SIZE, maxRetries = 5, numBuffers = 2}) {
            super({
                objectMode: true,
                highWaterMark: numBuffers - 1
            });
            this.bytesRead = 0;
            this.source = source;
            this.alignment = alignment;
            this.bytesRead = start;
            this.end = end;
            this.chunkSize = chunkSize;
            this.maxRetries = maxRetries;
            if (alignment !== undefined) {
                this.chunkSize = Math.max(Math.floor(chunkSize / alignment) * alignment, alignment);
                this.alignedReadableState = new aligned_lockable_buffer_1.AlignedReadableState(chunkSize, alignment, numBuffers);
            }
        }
        async tryRead(buffer) {
            let retries = 0;
            while (true) {
                try {
                    return await this.source.read(buffer, 0, buffer.length, this.bytesRead);
                } catch (error) {
                    if (errors_1.isTransientError(error)) {
                        if (retries < this.maxRetries) {
                            retries += 1;
                            await utils_1.delay(constants_1.RETRY_BASE_TIMEOUT * retries);
                            continue;
                        }
                        error.code = "EUNPLUGGED";
                    }
                    throw error;
                }
            }
        }
        async _read() {
            if (this.bytesRead > this.end) {
                this.push(null);
                return;
            }
            let buffer = this.alignment !== undefined ? this.alignedReadableState.getCurrentBuffer() : Buffer.allocUnsafe(this.chunkSize);
            const toRead = this.end - this.bytesRead + 1;
            if (toRead < buffer.length) {
                buffer = buffer.slice(0, toRead);
            }
            try {
                let unlock;
                if (aligned_lockable_buffer_1.isAlignedLockableBuffer(buffer)) {
                    unlock = await buffer.lock();
                }
                let bytesRead;
                try {
                    ({bytesRead} = await this.tryRead(buffer));
                } finally {
                    unlock === null || unlock === void 0 ? void 0 : unlock();
                }
                this.bytesRead += bytesRead;
                if (bytesRead !== 0) {
                    this.push(buffer.slice(0, bytesRead));
                } else {
                    this.push(null);
                }
            } catch (error) {
                this.emit("error", error);
            }
        }
    }
    exports.BlockReadStream = BlockReadStream;
    exports.ProgressBlockReadStream = progress_1.makeClassEmitProgressEvents(BlockReadStream, "bytesRead", "bytesRead");
}, function(module, exports, __webpack_require__) {
    "use strict";
    function setup(env) {
        createDebug.debug = createDebug;
        createDebug.default = createDebug;
        createDebug.coerce = coerce;
        createDebug.disable = disable;
        createDebug.enable = enable;
        createDebug.enabled = enabled;
        createDebug.humanize = __webpack_require__(44);
        Object.keys(env).forEach((function(key) {
            createDebug[key] = env[key];
        }));
        createDebug.instances = [];
        createDebug.names = [];
        createDebug.skips = [];
        createDebug.formatters = {};
        function selectColor(namespace) {
            var hash = 0;
            for (var i = 0; i < namespace.length; i++) {
                hash = (hash << 5) - hash + namespace.charCodeAt(i);
                hash |= 0;
            }
            return createDebug.colors[Math.abs(hash) % createDebug.colors.length];
        }
        createDebug.selectColor = selectColor;
        function createDebug(namespace) {
            var prevTime;
            function debug() {
                if (!debug.enabled) {
                    return;
                }
                for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
                    args[_key] = arguments[_key];
                }
                var self = debug;
                var curr = Number(new Date);
                var ms = curr - (prevTime || curr);
                self.diff = ms;
                self.prev = prevTime;
                self.curr = curr;
                prevTime = curr;
                args[0] = createDebug.coerce(args[0]);
                if (typeof args[0] !== "string") {
                    args.unshift("%O");
                }
                var index = 0;
                args[0] = args[0].replace(/%([a-zA-Z%])/g, (function(match, format) {
                    if (match === "%%") {
                        return match;
                    }
                    index++;
                    var formatter = createDebug.formatters[format];
                    if (typeof formatter === "function") {
                        var val = args[index];
                        match = formatter.call(self, val);
                        args.splice(index, 1);
                        index--;
                    }
                    return match;
                }));
                createDebug.formatArgs.call(self, args);
                var logFn = self.log || createDebug.log;
                logFn.apply(self, args);
            }
            debug.namespace = namespace;
            debug.enabled = createDebug.enabled(namespace);
            debug.useColors = createDebug.useColors();
            debug.color = selectColor(namespace);
            debug.destroy = destroy;
            debug.extend = extend;
            if (typeof createDebug.init === "function") {
                createDebug.init(debug);
            }
            createDebug.instances.push(debug);
            return debug;
        }
        function destroy() {
            var index = createDebug.instances.indexOf(this);
            if (index !== -1) {
                createDebug.instances.splice(index, 1);
                return true;
            }
            return false;
        }
        function extend(namespace, delimiter) {
            return createDebug(this.namespace + (typeof delimiter === "undefined" ? ":" : delimiter) + namespace);
        }
        function enable(namespaces) {
            createDebug.save(namespaces);
            createDebug.names = [];
            createDebug.skips = [];
            var i;
            var split = (typeof namespaces === "string" ? namespaces : "").split(/[\s,]+/);
            var len = split.length;
            for (i = 0; i < len; i++) {
                if (!split[i]) {
                    continue;
                }
                namespaces = split[i].replace(/\*/g, ".*?");
                if (namespaces[0] === "-") {
                    createDebug.skips.push(new RegExp("^" + namespaces.substr(1) + "$"));
                } else {
                    createDebug.names.push(new RegExp("^" + namespaces + "$"));
                }
            }
            for (i = 0; i < createDebug.instances.length; i++) {
                var instance = createDebug.instances[i];
                instance.enabled = createDebug.enabled(instance.namespace);
            }
        }
        function disable() {
            createDebug.enable("");
        }
        function enabled(name) {
            if (name[name.length - 1] === "*") {
                return true;
            }
            var i;
            var len;
            for (i = 0, len = createDebug.skips.length; i < len; i++) {
                if (createDebug.skips[i].test(name)) {
                    return false;
                }
            }
            for (i = 0, len = createDebug.names.length; i < len; i++) {
                if (createDebug.names[i].test(name)) {
                    return true;
                }
            }
            return false;
        }
        function coerce(val) {
            if (val instanceof Error) {
                return val.stack || val.message;
            }
            return val;
        }
        createDebug.enable(createDebug.load());
        return createDebug;
    }
    module.exports = setup;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.intervalIntersection = void 0;
    function intervalIntersection(a, b) {
        const start = Math.max(a[0], b[0]);
        const end = Math.min(a[1], b[1]);
        if (start > end) {
            return null;
        }
        return [ start, end ];
    }
    exports.intervalIntersection = intervalIntersection;
}, function(module, exports, __webpack_require__) {
    var crc32 = __webpack_require__(47);
    var uint64 = __webpack_require__(69);
    function GPT(options) {
        if (!(this instanceof GPT)) {
            return new GPT(options);
        }
        options = options != null ? options : {};
        this.blockSize = options.blockSize || 512;
        this.guid = options.guid || GPT.GUID.ZERO;
        this.revision = options.revision || 65536;
        this.headerSize = options.headerSize || GPT.HEADER_SIZE;
        this.headerChecksum = 0;
        this.currentLBA = options.currentLBA || 1;
        this.backupLBA = options.backupLBA || 0;
        this.firstLBA = options.firstLBA || 34;
        this.lastLBA = options.lastLBA || 0;
        this.tableOffset = options.tableOffset || GPT.TABLE_OFFSET;
        this.entries = options.entries || GPT.TABLE_ENTRIES;
        this.entrySize = options.entrySize || GPT.TABLE_ENTRY_SIZE;
        this.tableChecksum = 0;
        this.partitions = [];
    }
    module.exports = GPT;
    GPT.SIGNATURE = "EFI PART";
    GPT.HEADER_SIZE = 92;
    GPT.TABLE_OFFSET = 2;
    GPT.TABLE_MIN_SIZE = 16384;
    GPT.TABLE_ENTRIES = 128;
    GPT.TABLE_ENTRY_SIZE = 128;
    GPT.GUID = __webpack_require__(70);
    GPT.PartitionEntry = __webpack_require__(129);
    GPT.parse = function(buffer, offset) {
        return (new GPT).parse(buffer, offset);
    };
    GPT.parseBackup = function(buffer, offset) {
        return (new GPT).parseBackup(buffer, offset);
    };
    function align(value, boundary) {
        return value + (boundary - value % boundary) % boundary;
    }
    GPT.prototype = {
        constructor: GPT,
        get tableSize() {
            return Math.max(align(this.entrySize * this.entries, this.blockSize), GPT.TABLE_MIN_SIZE);
        },
        verify() {
            return this.verifyHeader() && this.verifyTable();
        },
        verifyHeader() {
            return this.checksumHeader() === this.headerChecksum;
        },
        verifyTable() {
            return this.checksumTable() === this.tableChecksum;
        },
        checksumHeader(buffer, offset) {
            offset = offset || 0;
            buffer = buffer || this.writeHeader(null, 0, true);
            var storedChecksum = buffer.readUInt32LE(offset + 16);
            buffer.writeUInt32LE(0, offset + 16);
            var checksum = crc32(buffer) >>> 0;
            buffer.writeUInt32LE(storedChecksum, offset + 16);
            return checksum;
        },
        checksumTable(buffer, offset) {
            var tableSize = this.tableSize;
            offset = offset || 0;
            if (buffer == null) {
                buffer = Buffer.alloc(tableSize);
                this.writeTable(this.partitions, buffer, offset);
            } else if (buffer.length - offset >= tableSize) {
                buffer = buffer.length !== tableSize ? buffer.slice(offset, offset + tableSize) : buffer;
            } else {
                throw new Error(`Buffer smaller than table size (${buffer.length - offset} < ${tableSize})`);
            }
            return crc32(buffer) >>> 0;
        },
        parse(buffer, offset) {
            offset = offset || 0;
            this.partitions.length = 0;
            this.parseHeader(buffer, offset);
            var tableOffset = (this.tableOffset - this.currentLBA) * this.blockSize;
            this.parseTable(buffer, offset + tableOffset, offset + tableOffset + this.tableSize);
            return this;
        },
        parseBackup(buffer, offset) {
            offset = offset || 0;
            this.partitions.length = 0;
            this.parseHeader(buffer, offset + this.tableSize);
            this.parseTable(buffer, offset, offset + this.tableSize);
            return this;
        },
        parseHeader(buffer, offset) {
            offset = offset || 0;
            if (buffer.length - offset < GPT.HEADER_SIZE) {
                throw new Error(`Buffer too small: Minimum header size is ${GPT.HEADER_SIZE} bytes, got ${buffer.length - offset} bytes`);
            }
            var signature = buffer.toString("ascii", offset + 0, offset + 8);
            if (signature !== GPT.SIGNATURE) {
                throw new Error(`Invalid signature: Expected "${GPT.SIGNATURE}", saw "${signature}"`);
            }
            this.revision = buffer.readUInt32LE(offset + 8);
            this.headerSize = buffer.readUInt32LE(offset + 12);
            this.headerChecksum = buffer.readUInt32LE(offset + 16);
            this.currentLBA = uint64.readLE(buffer, offset + 24);
            this.backupLBA = uint64.readLE(buffer, offset + 32);
            this.firstLBA = uint64.readLE(buffer, offset + 40);
            this.lastLBA = uint64.readLE(buffer, offset + 48);
            this.guid = GPT.GUID.toString(buffer, offset + 56);
            this.tableOffset = uint64.readLE(buffer, offset + 72);
            this.entries = buffer.readUInt32LE(offset + 80);
            this.entrySize = buffer.readUInt32LE(offset + 84);
            this.tableChecksum = buffer.readUInt32LE(offset + 88);
            return this;
        },
        parseTable(buffer, offset, end) {
            offset = offset || 0;
            end = Math.min(end || buffer.length, buffer.length);
            var part = null;
            for (var i = 0; i < this.entries && offset + this.entrySize <= end; i++) {
                part = GPT.PartitionEntry.parse(buffer, offset);
                if (!part.isEmpty()) {
                    this.partitions.push(part);
                }
                offset += this.entrySize;
            }
            return this;
        },
        write(buffer, offset) {
            var tableOffset = (this.tableOffset - this.currentLBA) * this.blockSize;
            var length = this.blockSize + this.tableSize;
            offset = offset || 0;
            buffer = buffer || Buffer.alloc(offset + length, 0);
            this.writeTable(this.partitions, buffer, offset + tableOffset);
            this.tableChecksum = this.checksumTable(buffer, offset + tableOffset);
            this.writeHeader(buffer, offset);
            return buffer;
        },
        writeBackup(buffer, offset) {
            var tableSize = this.tableSize;
            var length = this.blockSize + tableSize;
            offset = offset || 0;
            buffer = buffer || Buffer.alloc(offset + length);
            this.writeTable(this.partitions, buffer, offset);
            this.tableChecksum = this.checksumTable(buffer, offset);
            this.writeHeader(buffer, offset + tableSize);
            return buffer;
        },
        writeBackupFromPrimary(buffer, offset) {
            var currentLBA = this.currentLBA;
            var backupLBA = this.backupLBA;
            var tableOffset = this.tableOffset;
            this.backupLBA = currentLBA;
            this.currentLBA = backupLBA;
            this.tableOffset = this.currentLBA - this.tableSize / this.blockSize;
            var output = this.writeBackup(buffer, offset);
            this.backupLBA = backupLBA;
            this.currentLBA = currentLBA;
            this.tableOffset = tableOffset;
            return output;
        },
        writeHeader(buffer, offset, noChecksum) {
            offset = offset || 0;
            buffer = buffer || Buffer.alloc(offset + this.headerSize);
            buffer.write(GPT.SIGNATURE, offset + 0, offset + 8, "ascii");
            buffer.writeUInt32LE(this.revision, offset + 8);
            buffer.writeUInt32LE(this.headerSize, offset + 12);
            buffer.writeUInt32LE(this.headerChecksum, offset + 16);
            uint64.writeLE(buffer, this.currentLBA, offset + 24);
            uint64.writeLE(buffer, this.backupLBA, offset + 32);
            uint64.writeLE(buffer, this.firstLBA, offset + 40);
            uint64.writeLE(buffer, this.lastLBA, offset + 48);
            GPT.GUID.write(this.guid, buffer, offset + 56);
            uint64.writeLE(buffer, this.tableOffset, offset + 72);
            buffer.writeUInt32LE(this.entries, offset + 80);
            buffer.writeUInt32LE(this.entrySize, offset + 84);
            buffer.writeUInt32LE(this.tableChecksum, offset + 88);
            if (!noChecksum) {
                this.headerChecksum = this.checksumHeader(buffer.slice(offset, offset + this.headerSize));
                buffer.writeUInt32LE(this.headerChecksum, offset + 16);
            }
            return buffer;
        },
        writeTable(entries, buffer, offset) {
            offset = offset || 0;
            buffer = buffer || Buffer.alloc(offset + this.entrySize * entries.length);
            for (var i = 0; i < entries.length; i++) {
                entries[i].write(buffer, offset + i * this.entrySize);
            }
            return buffer;
        }
    };
}, function(module, exports) {
    var uint64 = module.exports;
    var MAX_UINT32 = Math.pow(2, 32);
    uint64.readLE = function(buffer, offset) {
        offset = offset || 0;
        var hi = buffer.readUInt32LE(offset + 4);
        var lo = buffer.readUInt32LE(offset);
        return hi * MAX_UINT32 + lo;
    };
    uint64.writeLE = function(buffer, value, offset) {
        offset = offset || 0;
        var hi = Math.floor(value / MAX_UINT32);
        var lo = value - hi * MAX_UINT32;
        buffer.writeUInt32LE(hi, offset + 4);
        buffer.writeUInt32LE(lo, offset);
        return offset + 8;
    };
    uint64.readBE = function(buffer, offset) {
        offset = offset || 0;
        var hi = buffer.readUInt32BE(offset);
        var lo = buffer.readUInt32BE(offset + 4);
        return hi * MAX_UINT32 + lo;
    };
    uint64.writeBE = function(buffer, value, offset) {
        offset = offset || 0;
        var hi = Math.floor(value / MAX_UINT32);
        var lo = value - hi * MAX_UINT32;
        buffer.writeUInt32BE(hi, offset);
        buffer.writeUInt32BE(lo, offset + 4);
        return offset + 8;
    };
}, function(module, exports) {
    var GUID = module.exports;
    GUID.ZERO = "00000000-0000-0000-0000-000000000000";
    GUID.HEX = [];
    GUID.DEC = new Map;
    void function() {
        var hex = "";
        for (var i = 0; i < 256; i++) {
            hex = (i + 256).toString(16).substr(1).toUpperCase();
            GUID.HEX[i] = hex;
            GUID.DEC.set(hex, i);
        }
    }();
    GUID.toString = function(buffer, offset) {
        offset = offset || 0;
        var guid = GUID.HEX[buffer[offset + 3]] + GUID.HEX[buffer[offset + 2]] + GUID.HEX[buffer[offset + 1]] + GUID.HEX[buffer[offset + 0]] + "-" + GUID.HEX[buffer[offset + 5]] + GUID.HEX[buffer[offset + 4]] + "-" + GUID.HEX[buffer[offset + 7]] + GUID.HEX[buffer[offset + 6]] + "-" + GUID.HEX[buffer[offset + 8]] + GUID.HEX[buffer[offset + 9]] + "-" + GUID.HEX[buffer[offset + 10]] + GUID.HEX[buffer[offset + 11]] + GUID.HEX[buffer[offset + 12]] + GUID.HEX[buffer[offset + 13]] + GUID.HEX[buffer[offset + 14]] + GUID.HEX[buffer[offset + 15]];
        return guid.toUpperCase();
    };
    GUID.write = function(value, buffer, offset) {
        offset = offset || 0;
        buffer = buffer || Buffer.allocUnsafe(offset + 16);
        var pattern = /[0-9A-F]{2}/g;
        var values = value.toUpperCase().match(pattern);
        buffer[offset + 3] = GUID.DEC.get(values[0]);
        buffer[offset + 2] = GUID.DEC.get(values[1]);
        buffer[offset + 1] = GUID.DEC.get(values[2]);
        buffer[offset + 0] = GUID.DEC.get(values[3]);
        buffer[offset + 5] = GUID.DEC.get(values[4]);
        buffer[offset + 4] = GUID.DEC.get(values[5]);
        buffer[offset + 7] = GUID.DEC.get(values[6]);
        buffer[offset + 6] = GUID.DEC.get(values[7]);
        buffer[offset + 8] = GUID.DEC.get(values[8]);
        buffer[offset + 9] = GUID.DEC.get(values[9]);
        buffer[offset + 10] = GUID.DEC.get(values[10]);
        buffer[offset + 11] = GUID.DEC.get(values[11]);
        buffer[offset + 12] = GUID.DEC.get(values[12]);
        buffer[offset + 13] = GUID.DEC.get(values[13]);
        buffer[offset + 14] = GUID.DEC.get(values[14]);
        buffer[offset + 15] = GUID.DEC.get(values[15]);
        return buffer;
    };
    module.exports = GUID;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.TypedError = void 0;
    let getStackTrace;
    if (Error.captureStackTrace != null) {
        const captureStackTrace = Error.captureStackTrace;
        getStackTrace = e => {
            captureStackTrace(e, e.constructor);
        };
    } else {
        getStackTrace = (e, err) => {
            if (!(err instanceof Error)) {
                err = new Error(err);
            }
            if (err.stack != null) {
                e.stack = err.stack;
            }
        };
    }
    class TypedError extends Error {
        constructor(err = "") {
            super();
            this.stack = "";
            if (err instanceof Error) {
                this.message = err.message;
            } else {
                this.message = err;
            }
            Object.setPrototypeOf(this, new.target.prototype);
            this.name = this.constructor.name;
            getStackTrace(this, err);
        }
    }
    exports.TypedError = TypedError;
}, function(module, exports, __webpack_require__) {
    var TransformStream = __webpack_require__(0).Transform;
    var inherits = __webpack_require__(1).inherits;
    var addon = __webpack_require__(140);
    var XXHash32 = addon.XXHash32;
    var XXHash64 = addon.XXHash64;
    module.exports = XXHash32;
    module.exports.Stream = Stream;
    module.exports.XXHash64 = XXHash64;
    module.exports.hash64 = XXHash64.hash;
    function Stream(seed, bits, outEnc) {
        TransformStream.call(this);
        if (typeof bits === "string") {
            outEnc = bits;
            bits = undefined;
        } else if (outEnc && typeof outEnc !== "string" && !Buffer.isBuffer(outEnc)) {
            outEnc = "buffer";
        }
        this._outEnc = outEnc;
        if (bits === 32 || bits === undefined) this._hash = new XXHash32(seed); else if (bits === 64) this._hash = new XXHash64(seed); else throw new Error("Bad bits argument");
        var rs = this._readableState;
        rs.objectMode = true;
        rs.highWaterMark = 2;
    }
    inherits(Stream, TransformStream);
    Stream.prototype._transform = function(chunk, encoding, callback) {
        this._hash.update(chunk);
        callback();
    };
    Stream.prototype._flush = function(callback) {
        if (this._outEnc !== undefined) this.push(this._hash.digest(this._outEnc)); else this.push(this._hash.digest());
        callback();
    };
}, function(module, exports) {
    module.exports = {
        find: () => {}
    };
}, function(module, exports, __webpack_require__) {
    function setup(env) {
        createDebug.debug = createDebug;
        createDebug.default = createDebug;
        createDebug.coerce = coerce;
        createDebug.disable = disable;
        createDebug.enable = enable;
        createDebug.enabled = enabled;
        createDebug.humanize = __webpack_require__(44);
        Object.keys(env).forEach(key => {
            createDebug[key] = env[key];
        });
        createDebug.instances = [];
        createDebug.names = [];
        createDebug.skips = [];
        createDebug.formatters = {};
        function selectColor(namespace) {
            let hash = 0;
            for (let i = 0; i < namespace.length; i++) {
                hash = (hash << 5) - hash + namespace.charCodeAt(i);
                hash |= 0;
            }
            return createDebug.colors[Math.abs(hash) % createDebug.colors.length];
        }
        createDebug.selectColor = selectColor;
        function createDebug(namespace) {
            let prevTime;
            function debug(...args) {
                if (!debug.enabled) {
                    return;
                }
                const self = debug;
                const curr = Number(new Date);
                const ms = curr - (prevTime || curr);
                self.diff = ms;
                self.prev = prevTime;
                self.curr = curr;
                prevTime = curr;
                args[0] = createDebug.coerce(args[0]);
                if (typeof args[0] !== "string") {
                    args.unshift("%O");
                }
                let index = 0;
                args[0] = args[0].replace(/%([a-zA-Z%])/g, (match, format) => {
                    if (match === "%%") {
                        return match;
                    }
                    index++;
                    const formatter = createDebug.formatters[format];
                    if (typeof formatter === "function") {
                        const val = args[index];
                        match = formatter.call(self, val);
                        args.splice(index, 1);
                        index--;
                    }
                    return match;
                });
                createDebug.formatArgs.call(self, args);
                const logFn = self.log || createDebug.log;
                logFn.apply(self, args);
            }
            debug.namespace = namespace;
            debug.enabled = createDebug.enabled(namespace);
            debug.useColors = createDebug.useColors();
            debug.color = createDebug.selectColor(namespace);
            debug.destroy = destroy;
            debug.extend = extend;
            if (typeof createDebug.init === "function") {
                createDebug.init(debug);
            }
            createDebug.instances.push(debug);
            return debug;
        }
        function destroy() {
            const index = createDebug.instances.indexOf(this);
            if (index !== -1) {
                createDebug.instances.splice(index, 1);
                return true;
            }
            return false;
        }
        function extend(namespace, delimiter) {
            const newDebug = createDebug(this.namespace + (typeof delimiter === "undefined" ? ":" : delimiter) + namespace);
            newDebug.log = this.log;
            return newDebug;
        }
        function enable(namespaces) {
            createDebug.save(namespaces);
            createDebug.names = [];
            createDebug.skips = [];
            let i;
            const split = (typeof namespaces === "string" ? namespaces : "").split(/[\s,]+/);
            const len = split.length;
            for (i = 0; i < len; i++) {
                if (!split[i]) {
                    continue;
                }
                namespaces = split[i].replace(/\*/g, ".*?");
                if (namespaces[0] === "-") {
                    createDebug.skips.push(new RegExp("^" + namespaces.substr(1) + "$"));
                } else {
                    createDebug.names.push(new RegExp("^" + namespaces + "$"));
                }
            }
            for (i = 0; i < createDebug.instances.length; i++) {
                const instance = createDebug.instances[i];
                instance.enabled = createDebug.enabled(instance.namespace);
            }
        }
        function disable() {
            const namespaces = [ ...createDebug.names.map(toNamespace), ...createDebug.skips.map(toNamespace).map(namespace => "-" + namespace) ].join(",");
            createDebug.enable("");
            return namespaces;
        }
        function enabled(name) {
            if (name[name.length - 1] === "*") {
                return true;
            }
            let i;
            let len;
            for (i = 0, len = createDebug.skips.length; i < len; i++) {
                if (createDebug.skips[i].test(name)) {
                    return false;
                }
            }
            for (i = 0, len = createDebug.names.length; i < len; i++) {
                if (createDebug.names[i].test(name)) {
                    return true;
                }
            }
            return false;
        }
        function toNamespace(regexp) {
            return regexp.toString().substring(2, regexp.toString().length - 2).replace(/\.\*\?$/, "*");
        }
        function coerce(val) {
            if (val instanceof Error) {
                return val.stack || val.message;
            }
            return val;
        }
        createDebug.enable(createDebug.load());
        return createDebug;
    }
    module.exports = setup;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.ConfiguredSource = exports.SourceDisk = void 0;
    const balena_image_fs_1 = __webpack_require__(36);
    const _debug = __webpack_require__(26);
    const file_disk_1 = __webpack_require__(46);
    const partitioninfo_1 = __webpack_require__(33);
    const util_1 = __webpack_require__(1);
    const constants_1 = __webpack_require__(5);
    const errors_1 = __webpack_require__(8);
    const shared_1 = __webpack_require__(19);
    const sparse_filter_stream_1 = __webpack_require__(34);
    const sparse_read_stream_1 = __webpack_require__(50);
    const block_device_1 = __webpack_require__(38);
    const source_source_1 = __webpack_require__(24);
    const configure_1 = __webpack_require__(168);
    const debug = _debug("etcher-sdk:configured-source");
    class SourceDisk extends file_disk_1.Disk {
        constructor(source) {
            super(true, true, true, true);
            this.source = source;
            if (source instanceof block_device_1.BlockDevice && source.oDirect) {
                throw new Error("Can't create a SourceDisk from a BlockDevice opened with O_DIRECT");
            }
        }
        async _getCapacity() {
            const size = (await this.source.getMetadata()).size;
            if (size === undefined) {
                throw new errors_1.NotCapable;
            }
            return size;
        }
        async _read(buffer, bufferOffset, length, fileOffset) {
            return await this.source.read(buffer, bufferOffset, length, fileOffset);
        }
        async _write(_buffer, _bufferOffset, _length, _fileOffset) {
            throw new Error("Can't write to a SourceDisk");
        }
        async _flush() {}
    }
    exports.SourceDisk = SourceDisk;
    class ConfiguredSource extends source_source_1.SourceSource {
        constructor({source, shouldTrimPartitions, createStreamFromDisk, configure, checksumType = "xxhash64", chunkSize = constants_1.CHUNK_SIZE}) {
            super(source);
            this.shouldTrimPartitions = shouldTrimPartitions;
            this.createStreamFromDisk = createStreamFromDisk;
            this.checksumType = checksumType;
            this.chunkSize = chunkSize;
            this.disk = new SourceDisk(source);
            if (configure === "legacy") {
                this.configure = configure_1.configure;
            } else {
                this.configure = configure;
            }
        }
        async getBlocks() {
            const blocks = await this.disk.getRanges(this.chunkSize);
            if (blocks.length) {
                const lastBlock = blocks[blocks.length - 1];
                const metadata = await this.source.getMetadata();
                const overflow = lastBlock.offset + lastBlock.length - metadata.size;
                if (overflow > 0) {
                    lastBlock.length -= overflow;
                }
            }
            return blocks.map(block => ({
                blocks: [ block ]
            }));
        }
        async getBlocksWithChecksumType(generateChecksums) {
            let blocks = await this.getBlocks();
            if (generateChecksums) {
                blocks = blocks.map(block => ({
                    ...block,
                    checksumType: this.checksumType
                }));
            }
            return blocks;
        }
        async canRead() {
            return true;
        }
        async canCreateReadStream() {
            return true;
        }
        async canCreateSparseReadStream() {
            return true;
        }
        async read(buffer, bufferOffset, length, sourceOffset) {
            return await this.disk.read(buffer, bufferOffset, length, sourceOffset);
        }
        async createReadStream(options) {
            const imageStream = await this.source.createReadStream(options);
            const transform = this.disk.getTransformStream();
            imageStream.on("error", err => {
                transform.emit("error", err);
            });
            imageStream.pipe(transform);
            return transform;
        }
        async createSparseReadStreamFromDisk(generateChecksums, alignment, numBuffers = 2) {
            return new sparse_read_stream_1.SparseReadStream({
                source: this,
                blocks: await this.getBlocksWithChecksumType(generateChecksums),
                chunkSize: constants_1.CHUNK_SIZE,
                verify: false,
                generateChecksums,
                alignment,
                numBuffers
            });
        }
        async createSparseReadStreamFromStream(generateChecksums, alignment, numBuffers = 2) {
            const stream = await this.createReadStream({
                alignment,
                numBuffers
            });
            const transform = new sparse_filter_stream_1.SparseFilterStream({
                blocks: await this.getBlocksWithChecksumType(generateChecksums),
                verify: false,
                generateChecksums
            });
            stream.on("error", transform.emit.bind(transform, "error"));
            stream.pipe(transform);
            return transform;
        }
        async createSparseReadStream({generateChecksums = false, alignment, numBuffers = 2} = {}) {
            if (this.createStreamFromDisk) {
                return await this.createSparseReadStreamFromDisk(generateChecksums, alignment, numBuffers);
            } else {
                return await this.createSparseReadStreamFromStream(generateChecksums, alignment, numBuffers);
            }
        }
        async _getMetadata() {
            const sourceMetadata = await this.source.getMetadata();
            const blocks = await this.getBlocks();
            const blockmappedSize = shared_1.blocksLength(blocks);
            return {
                ...sourceMetadata,
                blocks,
                blockmappedSize
            };
        }
        async trimPartitions() {
            let partitions;
            try {
                ({partitions} = await partitioninfo_1.getPartitions(this.disk, {
                    includeExtended: false
                }));
            } catch (error) {
                debug("Couldn't read partition table", error);
                return;
            }
            for (const partition of partitions) {
                try {
                    await balena_image_fs_1.interact(this.disk, partition.index, async fs => {
                        if (fs.trim !== undefined) {
                            await util_1.promisify(fs.trim)();
                        }
                    });
                } catch (_a) {}
            }
            const discards = this.disk.getDiscardedChunks();
            const discardedBytes = discards.map(d => d.end - d.start + 1).reduce((a, b) => a + b, 0);
            const metadata = await this.getMetadata();
            if (metadata.size !== undefined) {
                const percentage = Math.round(discardedBytes / metadata.size * 100);
                debug(`discarded ${discards.length} chunks, ${discardedBytes} bytes, ${percentage}% of the image`);
            }
        }
        async _open() {
            await super._open();
            if (this.configure !== undefined) {
                await this.configure(this.disk);
            }
            if (this.shouldTrimPartitions) {
                await this.trimPartitions();
            }
            this.disk.recordReads = false;
        }
        async _close() {
            await super._close();
        }
    }
    exports.ConfiguredSource = ConfiguredSource;
}, function(module, exports) {
    module.exports = require("./modules/ext2fs/build/Release/bindings.node");
}, function(module, exports, __webpack_require__) {
    var S = __webpack_require__(25), _ = __webpack_require__(21);
    function _baseChain(vol) {
        var chain = {};
        chain.sectorSize = vol._sectorSize;
        function posFromOffset(off) {
            var secSize = chain.sectorSize, offset = off % secSize, sector = (off - offset) / secSize;
            return {
                sector,
                offset
            };
        }
        var sectorCache = vol._makeCache();
        Object.defineProperty(chain, "cacheAdvice", {
            enumerable: true,
            get: function() {
                return sectorCache.advice();
            },
            set: function(v) {
                sectorCache.advice(v);
            }
        });
        chain._vol_readSectors = vol._readSectors.bind(vol, sectorCache);
        chain._vol_writeSectors = vol._writeSectors.bind(vol, sectorCache);
        chain.readFromPosition = function(targetPos, buffer, cb) {
            if (typeof targetPos === "number") targetPos = posFromOffset(targetPos);
            if (typeof buffer === "number") buffer = _.allocBuffer(buffer);
            if (targetPos.offset) chain.readSectors(targetPos.sector, _.allocBuffer(chain.sectorSize), (function(e, d) {
                if (e || !d) cb(e, 0, buffer); else {
                    var dBeg = targetPos.offset, dEnd = dBeg + buffer.length;
                    d.copy(buffer, 0, dBeg, dEnd);
                    if (dEnd > d.length) readMain(); else cb(null, buffer.length, buffer);
                }
            })); else readMain();
            function readMain() {
                var prefaceLen = targetPos.offset && chain.sectorSize - targetPos.offset, trailerLen = (buffer.length - prefaceLen) % chain.sectorSize, mainSector = prefaceLen ? targetPos.sector + 1 : targetPos.sector, mainBuffer = trailerLen ? buffer.slice(prefaceLen, -trailerLen) : buffer.slice(prefaceLen);
                if (mainBuffer.length) chain.readSectors(mainSector, mainBuffer, (function(e, d) {
                    if (e || !d) cb(e, prefaceLen, buffer); else if (!trailerLen) cb(null, buffer.length, buffer); else readTrailer();
                })); else readTrailer();
                function readTrailer() {
                    var trailerSector = mainSector + mainBuffer.length / chain.sectorSize;
                    chain.readSectors(trailerSector, _.allocBuffer(chain.sectorSize), (function(e, d) {
                        if (e || !d) cb(e, buffer.length - trailerLen, buffer); else {
                            d.copy(buffer, buffer.length - trailerLen, 0, trailerLen);
                            cb(null, buffer.length, buffer);
                        }
                    }));
                }
            }
        };
        chain.writeToPosition = function(targetPos, data, cb) {
            _.log(_.log.DBG, "WRITING", data.length, "bytes at", targetPos, "in", this.toJSON(), data);
            if (typeof targetPos === "number") targetPos = posFromOffset(targetPos);
            var prefaceBuffer = targetPos.offset ? data.slice(0, chain.sectorSize - targetPos.offset) : null;
            if (prefaceBuffer) _modifySector(targetPos.sector, targetPos.offset, prefaceBuffer, (function(e) {
                if (e) cb(e); else if (prefaceBuffer.length < data.length) writeMain(); else cb();
            })); else writeMain();
            function writeMain() {
                var prefaceLen = prefaceBuffer ? prefaceBuffer.length : 0, trailerLen = (data.length - prefaceLen) % chain.sectorSize, mainSector = prefaceLen ? targetPos.sector + 1 : targetPos.sector, mainBuffer = trailerLen ? data.slice(prefaceLen, -trailerLen) : data.slice(prefaceLen);
                if (mainBuffer.length) chain.writeSectors(mainSector, mainBuffer, (function(e) {
                    if (e) cb(e); else if (!trailerLen) cb(); else writeTrailer();
                })); else writeTrailer();
                function writeTrailer() {
                    var trailerSector = mainSector + mainBuffer.length / chain.sectorSize, trailerBuffer = data.slice(data.length - trailerLen);
                    _modifySector(trailerSector, 0, trailerBuffer, cb);
                }
            }
            function _modifySector(sec, off, data, cb) {
                chain.readSectors(sec, _.allocBuffer(chain.sectorSize), (function(e, orig) {
                    if (e) return cb(e);
                    orig || (orig = _.allocBuffer(chain.sectorSize, 0));
                    data.copy(orig, off);
                    chain.writeSectors(sec, orig, cb);
                }));
            }
        };
        return chain;
    }
    exports.clusterChain = function(vol, firstCluster, _parent) {
        var chain = _baseChain(vol), cache = [ firstCluster ];
        chain.firstCluster = firstCluster;
        function _cacheIsComplete() {
            return cache[cache.length - 1] === "eof";
        }
        function extendCacheToInclude(i, cb) {
            if (i < cache.length) cb(null, cache[i]); else if (_cacheIsComplete()) cb(null, "eof"); else vol.fetchFromFAT(cache[cache.length - 1], (function(e, d) {
                if (e) cb(e); else if (typeof d === "string" && d !== "eof") cb(S.err.IO()); else {
                    cache.push(d);
                    extendCacheToInclude(i, cb);
                }
            }));
        }
        function expandChainToLength(clusterCount, cb) {
            if (!_cacheIsComplete()) throw Error("Must be called only when cache is complete!"); else cache.pop();
            function addCluster(clustersNeeded, lastCluster) {
                if (!clustersNeeded) cache.push("eof"), cb(); else vol.allocateInFAT(lastCluster, (function(e, newCluster) {
                    if (e) cb(e); else vol.storeToFAT(lastCluster, newCluster, (function(e) {
                        if (e) return cb(e);
                        cache.push(newCluster);
                        addCluster(clustersNeeded - 1, newCluster);
                    }));
                }));
            }
            addCluster(clusterCount - cache.length, cache[cache.length - 1]);
        }
        function shrinkChainToLength(clusterCount, cb) {
            if (!_cacheIsComplete()) throw Error("Must be called only when cache is complete!"); else cache.pop();
            function removeClusters(count, cb) {
                if (!count) cache.push("eof"), cb(); else vol.storeToFAT(cache.pop(), "free", (function(e) {
                    if (e) cb(e); else removeClusters(count - 1, cb);
                }));
            }
            if (clusterCount) removeClusters(cache.length - clusterCount, cb); else removeClusters(cache.length - 1, cb);
        }
        function determineSectorGroups(sectorIdx, numSectors, alloc, cb) {
            var sectorOffset = sectorIdx % vol._sectorsPerCluster, clusterIdx = (sectorIdx - sectorOffset) / vol._sectorsPerCluster, numClusters = Math.ceil((numSectors + sectorOffset) / vol._sectorsPerCluster), chainLength = clusterIdx + numClusters;
            extendCacheToInclude(chainLength - 1, (function(e, c) {
                if (e) cb(e); else if (c === "eof" && alloc) expandChainToLength(chainLength, (function(e) {
                    if (e) cb(e); else _determineSectorGroups();
                })); else _determineSectorGroups();
            }));
            function _determineSectorGroups() {
                var groups = [], _group = null;
                for (var i = clusterIdx; i < chainLength; ++i) {
                    var c = i < cache.length ? cache[i] : "eof";
                    if (c === "eof") break; else if (_group && c !== _group._nextCluster) {
                        groups.push(_group);
                        _group = null;
                    }
                    if (!_group) _group = {
                        _nextCluster: c + 1,
                        firstSector: vol._firstSectorOfCluster(c) + sectorOffset,
                        numSectors: vol._sectorsPerCluster - sectorOffset
                    }; else {
                        _group._nextCluster += 1;
                        _group.numSectors += vol._sectorsPerCluster;
                    }
                    sectorOffset = 0;
                }
                if (_group) groups.push(_group);
                cb(null, groups, i === chainLength);
            }
        }
        chain.readSectors = function(i, dest, cb) {
            var groupOffset = 0, groupsPending;
            determineSectorGroups(i, dest.length / chain.sectorSize, false, (function(e, groups, complete) {
                if (e) cb(e); else if (!complete) groupsPending = -1, _pastEOF(cb); else if (groupsPending = groups.length) groups.forEach((function(group) {
                    var groupLength = group.numSectors * chain.sectorSize, groupBuffer = dest.slice(groupOffset, groupOffset += groupLength);
                    chain._vol_readSectors(group.firstSector, groupBuffer, (function(e, d) {
                        if (e && groupsPending !== -1) groupsPending = -1, cb(e); else if (--groupsPending === 0) cb(null, dest);
                    }));
                })); else cb(null, dest);
            }));
        };
        chain.writeSectors = function(i, data, cb) {
            var groupOffset = 0, groupsPending;
            determineSectorGroups(i, data.length / chain.sectorSize, true, (function(e, groups) {
                if (e) cb(e); else if (groupsPending = groups.length) groups.forEach((function(group) {
                    var groupLength = group.numSectors * chain.sectorSize, groupBuffer = data.slice(groupOffset, groupOffset += groupLength);
                    chain._vol_writeSectors(group.firstSector, groupBuffer, (function(e) {
                        if (e && groupsPending !== -1) groupsPending = -1, cb(e); else if (--groupsPending === 0) cb();
                    }));
                })); else cb();
            }));
        };
        chain.truncate = function(numSectors, cb) {
            extendCacheToInclude(Infinity, (function(e, c) {
                if (e) return cb(e);
                var currentLength = cache.length - 1, clustersNeeded = Math.ceil(numSectors / vol._sectorsPerCluster);
                if (clustersNeeded < currentLength) shrinkChainToLength(clustersNeeded, cb); else if (clustersNeeded > currentLength) expandChainToLength(clustersNeeded, cb); else cb();
            }));
        };
        chain.toJSON = function() {
            return {
                firstCluster
            };
        };
        return chain;
    };
    exports.sectorChain = function(vol, firstSector, numSectors) {
        var chain = _baseChain(vol);
        chain.firstSector = firstSector;
        chain.numSectors = numSectors;
        chain.readSectors = function(i, dest, cb) {
            if (i < numSectors) chain._vol_readSectors(firstSector + i, dest, cb); else _pastEOF(cb);
        };
        chain.writeSectors = function(i, data, cb) {
            if (i < numSectors) chain._vol_writeSectors(firstSector + i, data, cb); else _.delayedCall(cb, S.err.NOSPC());
        };
        chain.truncate = function(i, cb) {
            _.delayedCall(cb, S.err.INVAL());
        };
        chain.toJSON = function() {
            return {
                firstSector,
                numSectors
            };
        };
        return chain;
    };
    function _pastEOF(cb) {
        _.delayedCall(cb, null, null);
    }
}, function(module, exports, __webpack_require__) {
    "use strict";
    function setup(env) {
        createDebug.debug = createDebug;
        createDebug.default = createDebug;
        createDebug.coerce = coerce;
        createDebug.disable = disable;
        createDebug.enable = enable;
        createDebug.enabled = enabled;
        createDebug.humanize = __webpack_require__(44);
        Object.keys(env).forEach((function(key) {
            createDebug[key] = env[key];
        }));
        createDebug.instances = [];
        createDebug.names = [];
        createDebug.skips = [];
        createDebug.formatters = {};
        function selectColor(namespace) {
            var hash = 0;
            for (var i = 0; i < namespace.length; i++) {
                hash = (hash << 5) - hash + namespace.charCodeAt(i);
                hash |= 0;
            }
            return createDebug.colors[Math.abs(hash) % createDebug.colors.length];
        }
        createDebug.selectColor = selectColor;
        function createDebug(namespace) {
            var prevTime;
            function debug() {
                if (!debug.enabled) {
                    return;
                }
                for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
                    args[_key] = arguments[_key];
                }
                var self = debug;
                var curr = Number(new Date);
                var ms = curr - (prevTime || curr);
                self.diff = ms;
                self.prev = prevTime;
                self.curr = curr;
                prevTime = curr;
                args[0] = createDebug.coerce(args[0]);
                if (typeof args[0] !== "string") {
                    args.unshift("%O");
                }
                var index = 0;
                args[0] = args[0].replace(/%([a-zA-Z%])/g, (function(match, format) {
                    if (match === "%%") {
                        return match;
                    }
                    index++;
                    var formatter = createDebug.formatters[format];
                    if (typeof formatter === "function") {
                        var val = args[index];
                        match = formatter.call(self, val);
                        args.splice(index, 1);
                        index--;
                    }
                    return match;
                }));
                createDebug.formatArgs.call(self, args);
                var logFn = self.log || createDebug.log;
                logFn.apply(self, args);
            }
            debug.namespace = namespace;
            debug.enabled = createDebug.enabled(namespace);
            debug.useColors = createDebug.useColors();
            debug.color = selectColor(namespace);
            debug.destroy = destroy;
            debug.extend = extend;
            if (typeof createDebug.init === "function") {
                createDebug.init(debug);
            }
            createDebug.instances.push(debug);
            return debug;
        }
        function destroy() {
            var index = createDebug.instances.indexOf(this);
            if (index !== -1) {
                createDebug.instances.splice(index, 1);
                return true;
            }
            return false;
        }
        function extend(namespace, delimiter) {
            return createDebug(this.namespace + (typeof delimiter === "undefined" ? ":" : delimiter) + namespace);
        }
        function enable(namespaces) {
            createDebug.save(namespaces);
            createDebug.names = [];
            createDebug.skips = [];
            var i;
            var split = (typeof namespaces === "string" ? namespaces : "").split(/[\s,]+/);
            var len = split.length;
            for (i = 0; i < len; i++) {
                if (!split[i]) {
                    continue;
                }
                namespaces = split[i].replace(/\*/g, ".*?");
                if (namespaces[0] === "-") {
                    createDebug.skips.push(new RegExp("^" + namespaces.substr(1) + "$"));
                } else {
                    createDebug.names.push(new RegExp("^" + namespaces + "$"));
                }
            }
            for (i = 0; i < createDebug.instances.length; i++) {
                var instance = createDebug.instances[i];
                instance.enabled = createDebug.enabled(instance.namespace);
            }
        }
        function disable() {
            createDebug.enable("");
        }
        function enabled(name) {
            if (name[name.length - 1] === "*") {
                return true;
            }
            var i;
            var len;
            for (i = 0, len = createDebug.skips.length; i < len; i++) {
                if (createDebug.skips[i].test(name)) {
                    return false;
                }
            }
            for (i = 0, len = createDebug.names.length; i < len; i++) {
                if (createDebug.names[i].test(name)) {
                    return true;
                }
            }
            return false;
        }
        function coerce(val) {
            if (val instanceof Error) {
                return val.stack || val.message;
            }
            return val;
        }
        createDebug.enable(createDebug.load());
        return createDebug;
    }
    module.exports = setup;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.MultiDestination = exports.MultiDestinationVerifier = exports.MultiDestinationError = void 0;
    const events_1 = __webpack_require__(9);
    const stream_1 = __webpack_require__(0);
    const constants_1 = __webpack_require__(5);
    const errors_1 = __webpack_require__(8);
    const utils_1 = __webpack_require__(6);
    const block_device_1 = __webpack_require__(38);
    const source_destination_1 = __webpack_require__(7);
    function isntNull(x) {
        return x !== null;
    }
    class MultiDestinationError extends Error {
        constructor(error, destination) {
            super();
            this.error = error;
            this.destination = destination;
        }
    }
    exports.MultiDestinationError = MultiDestinationError;
    class MultiDestinationVerifier extends source_destination_1.Verifier {
        constructor(source, checksumOrBlocks, size) {
            super();
            this.verifiers = new Set;
            for (const dest of source.activeDestinations) {
                const verifier = dest.createVerifier(checksumOrBlocks, size);
                verifier.on("error", error => {
                    this.oneVerifierFinished(verifier);
                    source.destinationError(dest, error, this);
                });
                verifier.on("finish", () => {
                    this.oneVerifierFinished(verifier);
                });
                this.verifiers.add(verifier);
            }
        }
        oneVerifierFinished(verifier) {
            if (!this.verifiers.has(verifier)) {
                return;
            }
            if (this.verifiers.size === 1) {
                clearInterval(this.timer);
                this.emitProgress();
                this.emit("finish");
            }
            this.verifiers.delete(verifier);
        }
        emitProgress() {
            const verifier = utils_1.minBy(this.verifiers, v => v.progress.bytes);
            if (verifier !== undefined) {
                this.emit("progress", verifier.progress);
            }
        }
        async run() {
            if (this.verifiers.size === 0) {
                this.emit("finish");
                return;
            }
            this.timer = setInterval(this.emitProgress.bind(this), constants_1.PROGRESS_EMISSION_INTERVAL);
            for (const verifier of this.verifiers) {
                verifier.run();
            }
        }
    }
    exports.MultiDestinationVerifier = MultiDestinationVerifier;
    class MultiDestination extends source_destination_1.SourceDestination {
        constructor(destinations) {
            super();
            this.destinations = new Set;
            this.erroredDestinations = new Set;
            if (destinations.length === 0) {
                throw new Error("At least one destination is required");
            }
            for (const destination of destinations) {
                this.destinations.add(destination);
            }
        }
        getAlignment() {
            let max;
            for (const destination of this.destinations.values()) {
                if (destination instanceof block_device_1.BlockDevice && (max === undefined || destination.alignment > max)) {
                    max = destination.alignment;
                }
            }
            return max;
        }
        destinationError(destination, error, stream) {
            if (!(error instanceof errors_1.VerificationError)) {
                this.erroredDestinations.add(destination);
            }
            error = new MultiDestinationError(error, destination);
            if (stream !== undefined) {
                stream.emit("fail", error);
            } else {
                this.emit("fail", error);
            }
        }
        get activeDestinations() {
            return utils_1.difference(this.destinations, this.erroredDestinations);
        }
        async can(methodName) {
            return utils_1.every(await Promise.all(Array.from(this.activeDestinations).map(destination => destination[methodName]())));
        }
        canRead() {
            return this.can("canRead");
        }
        canWrite() {
            return this.can("canWrite");
        }
        canCreateReadStream() {
            return this.can("canCreateReadStream");
        }
        canCreateSparseReadStream() {
            return this.can("canCreateSparseReadStream");
        }
        canCreateWriteStream() {
            return this.can("canCreateWriteStream");
        }
        canCreateSparseWriteStream() {
            return this.can("canCreateSparseWriteStream");
        }
        read(buffer, bufferOffset, length, sourceOffset) {
            return Array.from(this.activeDestinations)[0].read(buffer, bufferOffset, length, sourceOffset);
        }
        async write(buffer, bufferOffset, length, fileOffset) {
            const results = await Promise.all(Array.from(this.activeDestinations).map(destination => destination.write(buffer, bufferOffset, length, fileOffset)));
            return results[0];
        }
        createReadStream(options) {
            return Array.from(this.activeDestinations)[0].createReadStream(options);
        }
        createSparseReadStream(options) {
            return Array.from(this.activeDestinations)[0].createSparseReadStream(options);
        }
        async createStream(methodName, ...args) {
            const passthrough = new stream_1.PassThrough({
                objectMode: methodName === "createSparseWriteStream"
            });
            const listeners = this.activeDestinations.size + 1;
            if (listeners > events_1.EventEmitter.defaultMaxListeners) {
                passthrough.setMaxListeners(listeners);
            }
            const progresses = new Map;
            let interval;
            function oneStreamFinished(stream) {
                if (!progresses.has(stream)) {
                    return;
                }
                if (progresses.size === 1) {
                    clearInterval(interval);
                    emitProgress();
                    passthrough.emit("done");
                }
                progresses.delete(stream);
            }
            function emitProgress() {
                const leastAdvancedProgress = utils_1.minBy(Array.from(progresses.values()).filter(isntNull), p => p.position);
                if (leastAdvancedProgress !== undefined) {
                    passthrough.emit("progress", leastAdvancedProgress);
                }
            }
            await Promise.all(Array.from(this.activeDestinations).map(async destination => {
                const stream = await destination[methodName](...args);
                progresses.set(stream, null);
                stream.on("progress", progressEvent => {
                    progresses.set(stream, progressEvent);
                    if (interval === undefined) {
                        interval = setInterval(emitProgress, constants_1.PROGRESS_EMISSION_INTERVAL);
                    }
                });
                stream.on("error", error => {
                    this.destinationError(destination, error, passthrough);
                    oneStreamFinished(stream);
                });
                stream.on("finish", oneStreamFinished.bind(null, stream));
                passthrough.pipe(stream);
            }));
            passthrough.on("pipe", () => {
                if (this.activeDestinations.size === 0) {
                    passthrough.emit("done");
                }
            });
            return passthrough;
        }
        createWriteStream(...args) {
            return this.createStream("createWriteStream", ...args);
        }
        createSparseWriteStream(...args) {
            return this.createStream("createSparseWriteStream", ...args);
        }
        createVerifier(checksumOrBlocks, size) {
            return new MultiDestinationVerifier(this, checksumOrBlocks, size);
        }
        async _open() {
            await Promise.all(Array.from(this.destinations).map(async destination => {
                try {
                    await destination.open();
                } catch (error) {
                    this.destinationError(destination, error);
                }
            }));
        }
        async _close() {
            await Promise.all(Array.from(this.destinations).map(async destination => {
                try {
                    await destination.close();
                } catch (error) {
                    this.destinationError(destination, error);
                }
            }));
        }
    }
    exports.MultiDestination = MultiDestination;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.UsbbootDrive = void 0;
    const source_destination_1 = __webpack_require__(7);
    class UsbbootDrive extends source_destination_1.SourceDestination {
        constructor(usbDevice) {
            super();
            this.usbDevice = usbDevice;
            this.raw = null;
            this.displayName = "Initializing device";
            this.device = null;
            this.devicePath = null;
            this.icon = "loading";
            this.isSystem = false;
            this.description = "Compute Module";
            this.mountpoints = [];
            this.isReadOnly = false;
            this.disabled = true;
            this.size = null;
            this.emitsProgress = true;
            usbDevice.on("progress", this.emit.bind(this, "progress"));
        }
    }
    exports.UsbbootDrive = UsbbootDrive;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.DriverlessDevice = void 0;
    const source_destination_1 = __webpack_require__(7);
    class DriverlessDevice extends source_destination_1.SourceDestination {
        constructor(driverlessDevice) {
            super();
            this.accessible = false;
            this.raw = null;
            this.device = null;
            this.devicePath = null;
            this.isSystem = false;
            this.mountpoints = [];
            this.size = null;
            this.emitsProgress = false;
            this.description = "";
            this.deviceDescriptor = {
                idVendor: driverlessDevice.vid,
                idProduct: driverlessDevice.pid
            };
        }
    }
    exports.DriverlessDevice = DriverlessDevice;
}, function(module, exports, __webpack_require__) {
    var stream = __webpack_require__(0);
    var bz2 = __webpack_require__(186);
    var bitIterator = __webpack_require__(187);
    class Unbzip2Stream extends stream.Transform {
        constructor(options) {
            super(options);
            this.queue = [];
            this.hasBytes = 0;
            this.blockSize = 0;
            this.done = false;
            this.bitReader = null;
            this.streamCRC = null;
        }
        _decompressAndQueue() {
            if (this.destroyed) return false;
            try {
                return this._decompressBlock();
            } catch (error) {
                this.destroy(error);
                return false;
            }
        }
        _decompressBlock() {
            if (!this.blockSize) {
                this.blockSize = bz2.header(this.bitReader);
                return true;
            } else {
                var length = 1e5 * this.blockSize;
                var buffer = new Int32Array(length);
                var bytes = [];
                var push = value => {
                    bytes.push(value);
                };
                this.streamCRC = bz2.decompress(this.bitReader, push, buffer, length, this.streamCRC);
                if (this.streamCRC === null) {
                    this.blockSize = 0;
                    return false;
                } else {
                    this.push(Buffer.from(bytes));
                    return true;
                }
            }
        }
        _transform(chunk, encoding, next) {
            this.queue.push(chunk);
            this.hasBytes += chunk.length;
            if (this.bitReader == null) {
                this.bitReader = bitIterator(() => this.queue.shift());
            }
            while (!this.destroyed && this.hasBytes - this.bitReader.bytesRead + 1 >= (25e3 + 1e5 * this.blockSize || 4)) {
                this._decompressAndQueue();
            }
            process.nextTick(next);
        }
        _flush(next) {
            while (!this.destroyed && this.hasBytes > this.bitReader.bytesRead) {
                this._decompressAndQueue();
            }
            if (this.destroyed) {
                return;
            }
            if (this.streamCRC !== null) {
                this.destroy(new Error("input stream ended prematurely"));
            }
            this.push(null);
        }
    }
    module.exports = function unbzip2Stream(options) {
        return new Unbzip2Stream(options);
    };
    module.exports.Stream = Unbzip2Stream;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.Block = void 0;
    const constants_1 = __webpack_require__(16);
    const uint64_1 = __webpack_require__(40);
    class Block {
        constructor() {
            this.type = 0;
            this.description = "UNKNOWN";
            this.comment = "";
            this.sectorNumber = 0;
            this.sectorCount = 0;
            this.compressedOffset = 0;
            this.compressedLength = 0;
        }
        static getDescription(type) {
            switch (type) {
              case constants_1.BLOCK.ZEROFILL:
                return "ZEROFILL";
                break;

              case constants_1.BLOCK.RAW:
                return "UDRW (raw)";
                break;

              case constants_1.BLOCK.FREE:
                return "FREE (unallocated)";
                break;

              case constants_1.BLOCK.UDCO:
                return "UDCO (adc-compressed)";
                break;

              case constants_1.BLOCK.UDZO:
                return "UDZO (zlib-compressed)";
                break;

              case constants_1.BLOCK.UDBZ:
                return "UDBZ (bzip2-compressed)";
                break;

              case constants_1.BLOCK.COMMENT:
                return "COMMENT";
                break;

              case constants_1.BLOCK.TERMINATOR:
                return "TERMINATOR";
                break;

              default:
                return "UNKNOWN";
                break;
            }
        }
        static parse(buffer, offset = 0) {
            return (new Block).parse(buffer, offset);
        }
        parse(buffer, offset = 0) {
            this.type = buffer.readUInt32BE(offset + 0);
            this.description = Block.getDescription(this.type);
            this.comment = buffer.toString("ascii", offset + 4, offset + 8).replace(/\u0000/g, "");
            this.sectorNumber = uint64_1.readBE(buffer, offset + 8);
            this.sectorCount = uint64_1.readBE(buffer, offset + 16);
            this.compressedOffset = uint64_1.readBE(buffer, offset + 24);
            this.compressedLength = uint64_1.readBE(buffer, offset + 32);
            return this;
        }
        write(buffer, offset = 0) {
            buffer.writeUInt32BE(this.type, offset + 0);
            buffer.write(this.comment, offset + 4, 4, "ascii");
            uint64_1.writeBE(buffer, this.sectorNumber, offset + 8);
            uint64_1.writeBE(buffer, this.sectorCount, offset + 16);
            uint64_1.writeBE(buffer, this.compressedOffset, offset + 24);
            uint64_1.writeBE(buffer, this.compressedLength, offset + 32);
            return buffer;
        }
    }
    exports.Block = Block;
    Block.SIZE = 40;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.BlockMap = void 0;
    const checksum_1 = __webpack_require__(55);
    const uint64_1 = __webpack_require__(40);
    const block_1 = __webpack_require__(83);
    class BlockMap {
        constructor() {
            this.signature = 0;
            this.version = 0;
            this.sectorNumber = 0;
            this.sectorCount = 0;
            this.dataOffset = 0;
            this.buffersNeeded = 0;
            this.blockDescriptorCount = 0;
            this.reserved1 = 0;
            this.reserved2 = 0;
            this.reserved3 = 0;
            this.reserved4 = 0;
            this.reserved5 = 0;
            this.reserved6 = 0;
            this.checksum = new checksum_1.Checksum;
            this.blockCount = 0;
            this.blocks = [];
        }
        static parse(buffer, offset = 0) {
            return (new BlockMap).parse(buffer, offset);
        }
        parse(buffer, offset = 0) {
            this.signature = buffer.readUInt32BE(offset + 0);
            if (this.signature !== BlockMap.SIGNATURE) {
                const expected = BlockMap.SIGNATURE.toString(16);
                const actual = this.signature.toString(16);
                throw new Error(`Invalid block map signature: Expected 0x${expected}, saw 0x${actual}`);
            }
            this.version = buffer.readUInt32BE(offset + 4);
            this.sectorNumber = uint64_1.readBE(buffer, offset + 8);
            this.sectorCount = uint64_1.readBE(buffer, offset + 16);
            this.dataOffset = uint64_1.readBE(buffer, offset + 24);
            this.buffersNeeded = buffer.readUInt32BE(offset + 32);
            this.blockDescriptorCount = buffer.readUInt32BE(offset + 36);
            this.reserved1 = buffer.readUInt32BE(offset + 40);
            this.reserved2 = buffer.readUInt32BE(offset + 44);
            this.reserved3 = buffer.readUInt32BE(offset + 48);
            this.reserved4 = buffer.readUInt32BE(offset + 52);
            this.reserved5 = buffer.readUInt32BE(offset + 56);
            this.reserved6 = buffer.readUInt32BE(offset + 60);
            this.checksum.parse(buffer, offset + 64);
            this.blockCount = buffer.readUInt32BE(offset + 200);
            this.blocks = [];
            for (let i = 0; i < this.blockCount; i++) {
                this.blocks.push(block_1.Block.parse(buffer, BlockMap.SIZE + i * block_1.Block.SIZE + offset));
            }
            return this;
        }
        write(buffer, offset = 0) {
            const length = BlockMap.SIZE + this.blocks.length * block_1.Block.SIZE;
            offset = offset || 0;
            buffer = buffer || Buffer.alloc(length + offset);
            this.blockCount = this.blocks.length;
            buffer.writeUInt32BE(this.signature, offset + 0);
            buffer.writeUInt32BE(this.version, offset + 4);
            uint64_1.writeBE(buffer, this.sectorNumber, offset + 8);
            uint64_1.writeBE(buffer, this.sectorCount, offset + 16);
            uint64_1.writeBE(buffer, this.dataOffset, offset + 24);
            buffer.writeUInt32BE(this.buffersNeeded, offset + 32);
            buffer.writeUInt32BE(this.blockDescriptorCount, offset + 36);
            buffer.writeUInt32BE(this.reserved1, offset + 40);
            buffer.writeUInt32BE(this.reserved2, offset + 44);
            buffer.writeUInt32BE(this.reserved3, offset + 48);
            buffer.writeUInt32BE(this.reserved4, offset + 52);
            buffer.writeUInt32BE(this.reserved5, offset + 56);
            buffer.writeUInt32BE(this.reserved6, offset + 60);
            this.checksum.write(buffer, offset + 64);
            buffer.writeUInt32BE(this.blockCount, offset + 200);
            for (let i = 0; i < this.blockCount; i++) {
                this.blocks[i].write(buffer, BlockMap.SIZE + i * block_1.Block.SIZE + offset);
            }
            return buffer;
        }
    }
    exports.BlockMap = BlockMap;
    BlockMap.SIZE = 204;
    BlockMap.SIGNATURE = 1835627368;
    BlockMap.VERSION = 1;
    BlockMap.Block = block_1.Block;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.Footer = void 0;
    const checksum_1 = __webpack_require__(55);
    const uint64_1 = __webpack_require__(40);
    class Footer {
        constructor() {
            this.signature = Footer.SIGNATURE;
            this.version = 0;
            this.headerSize = 0;
            this.flags = 0;
            this.runningDataForkOffset = 0;
            this.dataForkOffset = 0;
            this.dataForkLength = 0;
            this.resourceForkOffset = 0;
            this.resourceForkLength = 0;
            this.segmentNumber = 0;
            this.segmentCount = 0;
            this.segmentId = Buffer.alloc(16);
            this.dataChecksum = new checksum_1.Checksum;
            this.xmlOffset = 0;
            this.xmlLength = 0;
            this.reserved1 = Buffer.alloc(120);
            this.checksum = new checksum_1.Checksum;
            this.imageVariant = 0;
            this.sectorCount = 0;
            this.reserved2 = 0;
            this.reserved3 = 0;
            this.reserved4 = 0;
        }
        static parse(buffer, offset = 0) {
            return (new Footer).parse(buffer, offset);
        }
        parse(buffer, offset = 0) {
            this.signature = buffer.readUInt32BE(offset + 0);
            if (this.signature !== Footer.SIGNATURE) {
                const expected = Footer.SIGNATURE.toString(16);
                const actual = this.signature.toString(16);
                throw new Error(`Invalid footer signature: Expected 0x${expected}, saw 0x${actual}`);
            }
            this.version = buffer.readUInt32BE(offset + 4);
            this.headerSize = buffer.readUInt32BE(offset + 8);
            this.flags = buffer.readUInt32BE(offset + 12);
            this.runningDataForkOffset = uint64_1.readBE(buffer, offset + 16);
            this.dataForkOffset = uint64_1.readBE(buffer, offset + 24);
            this.dataForkLength = uint64_1.readBE(buffer, offset + 32);
            this.resourceForkOffset = uint64_1.readBE(buffer, offset + 40);
            this.resourceForkLength = uint64_1.readBE(buffer, offset + 48);
            this.segmentNumber = buffer.readUInt32BE(offset + 56);
            this.segmentCount = buffer.readUInt32BE(offset + 60);
            buffer.copy(this.segmentId, 0, offset + 64, offset + 64 + 16);
            this.dataChecksum.parse(buffer, offset + 80);
            this.xmlOffset = uint64_1.readBE(buffer, offset + 216);
            this.xmlLength = uint64_1.readBE(buffer, offset + 224);
            buffer.copy(this.reserved1, 0, offset + 232, offset + 232 + 120);
            this.checksum.parse(buffer, offset + 352);
            this.imageVariant = buffer.readUInt32BE(offset + 488);
            this.sectorCount = uint64_1.readBE(buffer, offset + 492);
            this.reserved2 = buffer.readUInt32BE(offset + 500);
            this.reserved3 = buffer.readUInt32BE(offset + 504);
            this.reserved4 = buffer.readUInt32BE(offset + 508);
            return this;
        }
        write(buffer, offset = 0) {
            buffer = buffer || Buffer.alloc(Footer.SIZE + offset);
            buffer.writeUInt32BE(this.signature, offset + 0);
            buffer.writeUInt32BE(this.version, offset + 4);
            buffer.writeUInt32BE(this.headerSize, offset + 8);
            buffer.writeUInt32BE(this.flags, offset + 12);
            uint64_1.writeBE(buffer, this.runningDataForkOffset, offset + 16);
            uint64_1.writeBE(buffer, this.dataForkOffset, offset + 24);
            uint64_1.writeBE(buffer, this.dataForkLength, offset + 32);
            uint64_1.writeBE(buffer, this.resourceForkOffset, offset + 40);
            uint64_1.writeBE(buffer, this.resourceForkLength, offset + 48);
            buffer.writeUInt32BE(this.segmentNumber, offset + 56);
            buffer.writeUInt32BE(this.segmentCount, offset + 60);
            this.segmentId.copy(buffer, offset + 64);
            this.dataChecksum.write(buffer, offset + 80);
            uint64_1.writeBE(buffer, this.xmlOffset, offset + 216);
            uint64_1.writeBE(buffer, this.xmlLength, offset + 224);
            this.reserved1.copy(buffer, offset + 232);
            this.checksum.write(buffer, offset + 352);
            buffer.writeUInt32BE(this.imageVariant, offset + 488);
            uint64_1.writeBE(buffer, this.sectorCount, offset + 492);
            buffer.writeUInt32BE(this.reserved2, offset + 500);
            buffer.writeUInt32BE(this.reserved3, offset + 504);
            buffer.writeUInt32BE(this.reserved4, offset + 508);
            return buffer;
        }
    }
    exports.Footer = Footer;
    Footer.SIZE = 512;
    Footer.SIGNATURE = 1802464377;
    Footer.VERSION = 4;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.Image = void 0;
    const plist = __webpack_require__(27);
    const crc32 = __webpack_require__(47);
    const stream_1 = __webpack_require__(0);
    const blockmap_1 = __webpack_require__(84);
    const constants_1 = __webpack_require__(16);
    const footer_1 = __webpack_require__(85);
    const readstream_1 = __webpack_require__(89);
    const sparse_readstream_1 = __webpack_require__(90);
    const utils_1 = __webpack_require__(41);
    class Image {
        constructor(fs) {
            this.fs = fs;
            this.resourceFork = {
                blkx: [],
                nsiz: [],
                cSum: [],
                plst: [],
                size: []
            };
            this.ready = this.open();
        }
        async open() {
            await this.readFooter();
            await this.readPropertyList();
        }
        static parseBlkx(blkx) {
            return blkx.map(block => ({
                id: +block["ID"],
                attributes: +block["Attributes"],
                name: block["Name"],
                coreFoundationName: block["CFName"],
                map: blockmap_1.BlockMap.parse(block["Data"])
            }));
        }
        static parseNsiz(nsiz) {
            return nsiz.map(block => ({
                id: +block["ID"],
                attributes: +block["Attributes"],
                name: block["Name"],
                data: plist.parse(block["Data"].toString()).data
            }));
        }
        static parsePlst(plst) {
            return plst.map(block => ({
                id: +block["ID"],
                attributes: +block["Attributes"],
                name: block["Name"],
                data: block["Data"]
            }));
        }
        static parseCsum(plst) {
            return plst.map(block => ({
                id: +block["ID"],
                attributes: +block["Attributes"],
                name: block["Name"],
                data: {
                    unknown: block["Data"].readUInt16LE(0),
                    type: block["Data"].readUInt32LE(2),
                    value: block["Data"].toString("hex", 6)
                }
            }));
        }
        static parseSize(size) {
            return size.map(block => ({
                id: +block["ID"],
                attributes: +block["Attributes"],
                name: block["Name"],
                data: block["Data"]
            }));
        }
        async createReadStream(end = Infinity) {
            await this.ready;
            return stream_1.Readable.from(readstream_1.readStream(this, end));
        }
        async createSparseReadStream() {
            await this.ready;
            return stream_1.Readable.from(sparse_readstream_1.sparseReadStream(this));
        }
        async getUncompressedSize() {
            await this.ready;
            return this.resourceFork.blkx.reduce((size, resource) => resource.map.blocks.reduce((s, block) => s + block.sectorCount * constants_1.SECTOR_SIZE, size), 0);
        }
        async getMappedSize() {
            await this.ready;
            return this.resourceFork.blkx.reduce((size, resource) => resource.map.blocks.reduce((s, block) => {
                if (block.type !== constants_1.BLOCK.ZEROFILL && block.type !== constants_1.BLOCK.FREE) {
                    return s + block.sectorCount * constants_1.SECTOR_SIZE;
                } else {
                    return s;
                }
            }, size), 0);
        }
        async verifyData() {
            await this.ready;
            if (this.footer === undefined) {
                throw new Error("Must read footer before calling verifyData");
            }
            if (!this.footer.dataChecksum || this.footer.dataChecksum.type === constants_1.CHECKSUM_TYPE.NONE) {
                return null;
            }
            let hash;
            let checksum = "";
            if (this.footer.dataChecksum.type === constants_1.CHECKSUM_TYPE.CRC32) {
                hash = new crc32.Hash({
                    encoding: "hex"
                });
            } else {
                throw new Error(`Unknown or unsupported checksum type "${this.footer.dataChecksum.type}"`);
            }
            const readable = await this.fs.createReadStream(this.footer.dataForkOffset, this.footer.dataForkOffset + this.footer.dataForkLength - 1);
            return await new Promise((resolve, reject) => {
                readable.on("error", reject).pipe(hash).on("error", reject).on("readable", (function() {
                    let chunk = this.read();
                    while (chunk) {
                        checksum += chunk;
                        chunk = this.read();
                    }
                })).on("end", () => {
                    var _a, _b;
                    resolve(checksum === ((_b = (_a = this.footer) === null || _a === void 0 ? void 0 : _a.dataChecksum) === null || _b === void 0 ? void 0 : _b.value));
                });
            });
        }
        async readFooter() {
            const length = footer_1.Footer.SIZE;
            const position = this.fs.size - footer_1.Footer.SIZE;
            const buffer = await utils_1.streamToBuffer(await this.fs.createReadStream(position, position + length - 1));
            this.footer = footer_1.Footer.parse(buffer);
            return this.footer;
        }
        async readPropertyList() {
            if (this.footer === undefined) {
                throw new Error("Must read footer before property list");
            }
            const length = this.footer.xmlLength;
            const position = this.footer.xmlOffset;
            const buffer = await utils_1.streamToBuffer(await this.fs.createReadStream(position, position + length - 1));
            const data = plist.parse(buffer.toString()).data;
            const resourceFork = data["resource-fork"];
            if (resourceFork.blkx) {
                this.resourceFork.blkx = Image.parseBlkx(resourceFork.blkx);
            }
            if (resourceFork.nsiz) {
                this.resourceFork.nsiz = Image.parseNsiz(resourceFork.nsiz);
            }
            if (resourceFork.cSum) {
                this.resourceFork.cSum = Image.parseCsum(resourceFork.cSum);
            }
            if (resourceFork.plst) {
                this.resourceFork.plst = Image.parsePlst(resourceFork.plst);
            }
            if (resourceFork.size) {
                this.resourceFork.size = Image.parseSize(resourceFork.size);
            }
            return this.resourceFork;
        }
    }
    exports.Image = Image;
}, function(module, exports, __webpack_require__) {
    (function(sax) {
        sax.parser = function(strict, opt) {
            return new SAXParser(strict, opt);
        };
        sax.SAXParser = SAXParser;
        sax.SAXStream = SAXStream;
        sax.createStream = createStream;
        sax.MAX_BUFFER_LENGTH = 64 * 1024;
        var buffers = [ "comment", "sgmlDecl", "textNode", "tagName", "doctype", "procInstName", "procInstBody", "entity", "attribName", "attribValue", "cdata", "script" ];
        sax.EVENTS = [ "text", "processinginstruction", "sgmldeclaration", "doctype", "comment", "opentagstart", "attribute", "opentag", "closetag", "opencdata", "cdata", "closecdata", "error", "end", "ready", "script", "opennamespace", "closenamespace" ];
        function SAXParser(strict, opt) {
            if (!(this instanceof SAXParser)) {
                return new SAXParser(strict, opt);
            }
            var parser = this;
            clearBuffers(parser);
            parser.q = parser.c = "";
            parser.bufferCheckPosition = sax.MAX_BUFFER_LENGTH;
            parser.opt = opt || {};
            parser.opt.lowercase = parser.opt.lowercase || parser.opt.lowercasetags;
            parser.looseCase = parser.opt.lowercase ? "toLowerCase" : "toUpperCase";
            parser.tags = [];
            parser.closed = parser.closedRoot = parser.sawRoot = false;
            parser.tag = parser.error = null;
            parser.strict = !!strict;
            parser.noscript = !!(strict || parser.opt.noscript);
            parser.state = S.BEGIN;
            parser.strictEntities = parser.opt.strictEntities;
            parser.ENTITIES = parser.strictEntities ? Object.create(sax.XML_ENTITIES) : Object.create(sax.ENTITIES);
            parser.attribList = [];
            if (parser.opt.xmlns) {
                parser.ns = Object.create(rootNS);
            }
            parser.trackPosition = parser.opt.position !== false;
            if (parser.trackPosition) {
                parser.position = parser.line = parser.column = 0;
            }
            emit(parser, "onready");
        }
        if (!Object.create) {
            Object.create = function(o) {
                function F() {}
                F.prototype = o;
                var newf = new F;
                return newf;
            };
        }
        if (!Object.keys) {
            Object.keys = function(o) {
                var a = [];
                for (var i in o) if (o.hasOwnProperty(i)) a.push(i);
                return a;
            };
        }
        function checkBufferLength(parser) {
            var maxAllowed = Math.max(sax.MAX_BUFFER_LENGTH, 10);
            var maxActual = 0;
            for (var i = 0, l = buffers.length; i < l; i++) {
                var len = parser[buffers[i]].length;
                if (len > maxAllowed) {
                    switch (buffers[i]) {
                      case "textNode":
                        closeText(parser);
                        break;

                      case "cdata":
                        emitNode(parser, "oncdata", parser.cdata);
                        parser.cdata = "";
                        break;

                      case "script":
                        emitNode(parser, "onscript", parser.script);
                        parser.script = "";
                        break;

                      default:
                        error(parser, "Max buffer length exceeded: " + buffers[i]);
                    }
                }
                maxActual = Math.max(maxActual, len);
            }
            var m = sax.MAX_BUFFER_LENGTH - maxActual;
            parser.bufferCheckPosition = m + parser.position;
        }
        function clearBuffers(parser) {
            for (var i = 0, l = buffers.length; i < l; i++) {
                parser[buffers[i]] = "";
            }
        }
        function flushBuffers(parser) {
            closeText(parser);
            if (parser.cdata !== "") {
                emitNode(parser, "oncdata", parser.cdata);
                parser.cdata = "";
            }
            if (parser.script !== "") {
                emitNode(parser, "onscript", parser.script);
                parser.script = "";
            }
        }
        SAXParser.prototype = {
            end: function() {
                end(this);
            },
            write,
            resume: function() {
                this.error = null;
                return this;
            },
            close: function() {
                return this.write(null);
            },
            flush: function() {
                flushBuffers(this);
            }
        };
        var Stream;
        try {
            Stream = __webpack_require__(0).Stream;
        } catch (ex) {
            Stream = function() {};
        }
        var streamWraps = sax.EVENTS.filter((function(ev) {
            return ev !== "error" && ev !== "end";
        }));
        function createStream(strict, opt) {
            return new SAXStream(strict, opt);
        }
        function SAXStream(strict, opt) {
            if (!(this instanceof SAXStream)) {
                return new SAXStream(strict, opt);
            }
            Stream.apply(this);
            this._parser = new SAXParser(strict, opt);
            this.writable = true;
            this.readable = true;
            var me = this;
            this._parser.onend = function() {
                me.emit("end");
            };
            this._parser.onerror = function(er) {
                me.emit("error", er);
                me._parser.error = null;
            };
            this._decoder = null;
            streamWraps.forEach((function(ev) {
                Object.defineProperty(me, "on" + ev, {
                    get: function() {
                        return me._parser["on" + ev];
                    },
                    set: function(h) {
                        if (!h) {
                            me.removeAllListeners(ev);
                            me._parser["on" + ev] = h;
                            return h;
                        }
                        me.on(ev, h);
                    },
                    enumerable: true,
                    configurable: false
                });
            }));
        }
        SAXStream.prototype = Object.create(Stream.prototype, {
            constructor: {
                value: SAXStream
            }
        });
        SAXStream.prototype.write = function(data) {
            if (typeof Buffer === "function" && typeof Buffer.isBuffer === "function" && Buffer.isBuffer(data)) {
                if (!this._decoder) {
                    var SD = __webpack_require__(191).StringDecoder;
                    this._decoder = new SD("utf8");
                }
                data = this._decoder.write(data);
            }
            this._parser.write(data.toString());
            this.emit("data", data);
            return true;
        };
        SAXStream.prototype.end = function(chunk) {
            if (chunk && chunk.length) {
                this.write(chunk);
            }
            this._parser.end();
            return true;
        };
        SAXStream.prototype.on = function(ev, handler) {
            var me = this;
            if (!me._parser["on" + ev] && streamWraps.indexOf(ev) !== -1) {
                me._parser["on" + ev] = function() {
                    var args = arguments.length === 1 ? [ arguments[0] ] : Array.apply(null, arguments);
                    args.splice(0, 0, ev);
                    me.emit.apply(me, args);
                };
            }
            return Stream.prototype.on.call(me, ev, handler);
        };
        var CDATA = "[CDATA[";
        var DOCTYPE = "DOCTYPE";
        var XML_NAMESPACE = "http://www.w3.org/XML/1998/namespace";
        var XMLNS_NAMESPACE = "http://www.w3.org/2000/xmlns/";
        var rootNS = {
            xml: XML_NAMESPACE,
            xmlns: XMLNS_NAMESPACE
        };
        var nameStart = /[:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/;
        var nameBody = /[:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\u00B7\u0300-\u036F\u203F-\u2040.\d-]/;
        var entityStart = /[#:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/;
        var entityBody = /[#:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\u00B7\u0300-\u036F\u203F-\u2040.\d-]/;
        function isWhitespace(c) {
            return c === " " || c === "\n" || c === "\r" || c === "\t";
        }
        function isQuote(c) {
            return c === '"' || c === "'";
        }
        function isAttribEnd(c) {
            return c === ">" || isWhitespace(c);
        }
        function isMatch(regex, c) {
            return regex.test(c);
        }
        function notMatch(regex, c) {
            return !isMatch(regex, c);
        }
        var S = 0;
        sax.STATE = {
            BEGIN: S++,
            BEGIN_WHITESPACE: S++,
            TEXT: S++,
            TEXT_ENTITY: S++,
            OPEN_WAKA: S++,
            SGML_DECL: S++,
            SGML_DECL_QUOTED: S++,
            DOCTYPE: S++,
            DOCTYPE_QUOTED: S++,
            DOCTYPE_DTD: S++,
            DOCTYPE_DTD_QUOTED: S++,
            COMMENT_STARTING: S++,
            COMMENT: S++,
            COMMENT_ENDING: S++,
            COMMENT_ENDED: S++,
            CDATA: S++,
            CDATA_ENDING: S++,
            CDATA_ENDING_2: S++,
            PROC_INST: S++,
            PROC_INST_BODY: S++,
            PROC_INST_ENDING: S++,
            OPEN_TAG: S++,
            OPEN_TAG_SLASH: S++,
            ATTRIB: S++,
            ATTRIB_NAME: S++,
            ATTRIB_NAME_SAW_WHITE: S++,
            ATTRIB_VALUE: S++,
            ATTRIB_VALUE_QUOTED: S++,
            ATTRIB_VALUE_CLOSED: S++,
            ATTRIB_VALUE_UNQUOTED: S++,
            ATTRIB_VALUE_ENTITY_Q: S++,
            ATTRIB_VALUE_ENTITY_U: S++,
            CLOSE_TAG: S++,
            CLOSE_TAG_SAW_WHITE: S++,
            SCRIPT: S++,
            SCRIPT_ENDING: S++
        };
        sax.XML_ENTITIES = {
            amp: "&",
            gt: ">",
            lt: "<",
            quot: '"',
            apos: "'"
        };
        sax.ENTITIES = {
            amp: "&",
            gt: ">",
            lt: "<",
            quot: '"',
            apos: "'",
            AElig: 198,
            Aacute: 193,
            Acirc: 194,
            Agrave: 192,
            Aring: 197,
            Atilde: 195,
            Auml: 196,
            Ccedil: 199,
            ETH: 208,
            Eacute: 201,
            Ecirc: 202,
            Egrave: 200,
            Euml: 203,
            Iacute: 205,
            Icirc: 206,
            Igrave: 204,
            Iuml: 207,
            Ntilde: 209,
            Oacute: 211,
            Ocirc: 212,
            Ograve: 210,
            Oslash: 216,
            Otilde: 213,
            Ouml: 214,
            THORN: 222,
            Uacute: 218,
            Ucirc: 219,
            Ugrave: 217,
            Uuml: 220,
            Yacute: 221,
            aacute: 225,
            acirc: 226,
            aelig: 230,
            agrave: 224,
            aring: 229,
            atilde: 227,
            auml: 228,
            ccedil: 231,
            eacute: 233,
            ecirc: 234,
            egrave: 232,
            eth: 240,
            euml: 235,
            iacute: 237,
            icirc: 238,
            igrave: 236,
            iuml: 239,
            ntilde: 241,
            oacute: 243,
            ocirc: 244,
            ograve: 242,
            oslash: 248,
            otilde: 245,
            ouml: 246,
            szlig: 223,
            thorn: 254,
            uacute: 250,
            ucirc: 251,
            ugrave: 249,
            uuml: 252,
            yacute: 253,
            yuml: 255,
            copy: 169,
            reg: 174,
            nbsp: 160,
            iexcl: 161,
            cent: 162,
            pound: 163,
            curren: 164,
            yen: 165,
            brvbar: 166,
            sect: 167,
            uml: 168,
            ordf: 170,
            laquo: 171,
            not: 172,
            shy: 173,
            macr: 175,
            deg: 176,
            plusmn: 177,
            sup1: 185,
            sup2: 178,
            sup3: 179,
            acute: 180,
            micro: 181,
            para: 182,
            middot: 183,
            cedil: 184,
            ordm: 186,
            raquo: 187,
            frac14: 188,
            frac12: 189,
            frac34: 190,
            iquest: 191,
            times: 215,
            divide: 247,
            OElig: 338,
            oelig: 339,
            Scaron: 352,
            scaron: 353,
            Yuml: 376,
            fnof: 402,
            circ: 710,
            tilde: 732,
            Alpha: 913,
            Beta: 914,
            Gamma: 915,
            Delta: 916,
            Epsilon: 917,
            Zeta: 918,
            Eta: 919,
            Theta: 920,
            Iota: 921,
            Kappa: 922,
            Lambda: 923,
            Mu: 924,
            Nu: 925,
            Xi: 926,
            Omicron: 927,
            Pi: 928,
            Rho: 929,
            Sigma: 931,
            Tau: 932,
            Upsilon: 933,
            Phi: 934,
            Chi: 935,
            Psi: 936,
            Omega: 937,
            alpha: 945,
            beta: 946,
            gamma: 947,
            delta: 948,
            epsilon: 949,
            zeta: 950,
            eta: 951,
            theta: 952,
            iota: 953,
            kappa: 954,
            lambda: 955,
            mu: 956,
            nu: 957,
            xi: 958,
            omicron: 959,
            pi: 960,
            rho: 961,
            sigmaf: 962,
            sigma: 963,
            tau: 964,
            upsilon: 965,
            phi: 966,
            chi: 967,
            psi: 968,
            omega: 969,
            thetasym: 977,
            upsih: 978,
            piv: 982,
            ensp: 8194,
            emsp: 8195,
            thinsp: 8201,
            zwnj: 8204,
            zwj: 8205,
            lrm: 8206,
            rlm: 8207,
            ndash: 8211,
            mdash: 8212,
            lsquo: 8216,
            rsquo: 8217,
            sbquo: 8218,
            ldquo: 8220,
            rdquo: 8221,
            bdquo: 8222,
            dagger: 8224,
            Dagger: 8225,
            bull: 8226,
            hellip: 8230,
            permil: 8240,
            prime: 8242,
            Prime: 8243,
            lsaquo: 8249,
            rsaquo: 8250,
            oline: 8254,
            frasl: 8260,
            euro: 8364,
            image: 8465,
            weierp: 8472,
            real: 8476,
            trade: 8482,
            alefsym: 8501,
            larr: 8592,
            uarr: 8593,
            rarr: 8594,
            darr: 8595,
            harr: 8596,
            crarr: 8629,
            lArr: 8656,
            uArr: 8657,
            rArr: 8658,
            dArr: 8659,
            hArr: 8660,
            forall: 8704,
            part: 8706,
            exist: 8707,
            empty: 8709,
            nabla: 8711,
            isin: 8712,
            notin: 8713,
            ni: 8715,
            prod: 8719,
            sum: 8721,
            minus: 8722,
            lowast: 8727,
            radic: 8730,
            prop: 8733,
            infin: 8734,
            ang: 8736,
            and: 8743,
            or: 8744,
            cap: 8745,
            cup: 8746,
            int: 8747,
            there4: 8756,
            sim: 8764,
            cong: 8773,
            asymp: 8776,
            ne: 8800,
            equiv: 8801,
            le: 8804,
            ge: 8805,
            sub: 8834,
            sup: 8835,
            nsub: 8836,
            sube: 8838,
            supe: 8839,
            oplus: 8853,
            otimes: 8855,
            perp: 8869,
            sdot: 8901,
            lceil: 8968,
            rceil: 8969,
            lfloor: 8970,
            rfloor: 8971,
            lang: 9001,
            rang: 9002,
            loz: 9674,
            spades: 9824,
            clubs: 9827,
            hearts: 9829,
            diams: 9830
        };
        Object.keys(sax.ENTITIES).forEach((function(key) {
            var e = sax.ENTITIES[key];
            var s = typeof e === "number" ? String.fromCharCode(e) : e;
            sax.ENTITIES[key] = s;
        }));
        for (var s in sax.STATE) {
            sax.STATE[sax.STATE[s]] = s;
        }
        S = sax.STATE;
        function emit(parser, event, data) {
            parser[event] && parser[event](data);
        }
        function emitNode(parser, nodeType, data) {
            if (parser.textNode) closeText(parser);
            emit(parser, nodeType, data);
        }
        function closeText(parser) {
            parser.textNode = textopts(parser.opt, parser.textNode);
            if (parser.textNode) emit(parser, "ontext", parser.textNode);
            parser.textNode = "";
        }
        function textopts(opt, text) {
            if (opt.trim) text = text.trim();
            if (opt.normalize) text = text.replace(/\s+/g, " ");
            return text;
        }
        function error(parser, er) {
            closeText(parser);
            if (parser.trackPosition) {
                er += "\nLine: " + parser.line + "\nColumn: " + parser.column + "\nChar: " + parser.c;
            }
            er = new Error(er);
            parser.error = er;
            emit(parser, "onerror", er);
            return parser;
        }
        function end(parser) {
            if (parser.sawRoot && !parser.closedRoot) strictFail(parser, "Unclosed root tag");
            if (parser.state !== S.BEGIN && parser.state !== S.BEGIN_WHITESPACE && parser.state !== S.TEXT) {
                error(parser, "Unexpected end");
            }
            closeText(parser);
            parser.c = "";
            parser.closed = true;
            emit(parser, "onend");
            SAXParser.call(parser, parser.strict, parser.opt);
            return parser;
        }
        function strictFail(parser, message) {
            if (typeof parser !== "object" || !(parser instanceof SAXParser)) {
                throw new Error("bad call to strictFail");
            }
            if (parser.strict) {
                error(parser, message);
            }
        }
        function newTag(parser) {
            if (!parser.strict) parser.tagName = parser.tagName[parser.looseCase]();
            var parent = parser.tags[parser.tags.length - 1] || parser;
            var tag = parser.tag = {
                name: parser.tagName,
                attributes: {}
            };
            if (parser.opt.xmlns) {
                tag.ns = parent.ns;
            }
            parser.attribList.length = 0;
            emitNode(parser, "onopentagstart", tag);
        }
        function qname(name, attribute) {
            var i = name.indexOf(":");
            var qualName = i < 0 ? [ "", name ] : name.split(":");
            var prefix = qualName[0];
            var local = qualName[1];
            if (attribute && name === "xmlns") {
                prefix = "xmlns";
                local = "";
            }
            return {
                prefix,
                local
            };
        }
        function attrib(parser) {
            if (!parser.strict) {
                parser.attribName = parser.attribName[parser.looseCase]();
            }
            if (parser.attribList.indexOf(parser.attribName) !== -1 || parser.tag.attributes.hasOwnProperty(parser.attribName)) {
                parser.attribName = parser.attribValue = "";
                return;
            }
            if (parser.opt.xmlns) {
                var qn = qname(parser.attribName, true);
                var prefix = qn.prefix;
                var local = qn.local;
                if (prefix === "xmlns") {
                    if (local === "xml" && parser.attribValue !== XML_NAMESPACE) {
                        strictFail(parser, "xml: prefix must be bound to " + XML_NAMESPACE + "\n" + "Actual: " + parser.attribValue);
                    } else if (local === "xmlns" && parser.attribValue !== XMLNS_NAMESPACE) {
                        strictFail(parser, "xmlns: prefix must be bound to " + XMLNS_NAMESPACE + "\n" + "Actual: " + parser.attribValue);
                    } else {
                        var tag = parser.tag;
                        var parent = parser.tags[parser.tags.length - 1] || parser;
                        if (tag.ns === parent.ns) {
                            tag.ns = Object.create(parent.ns);
                        }
                        tag.ns[local] = parser.attribValue;
                    }
                }
                parser.attribList.push([ parser.attribName, parser.attribValue ]);
            } else {
                parser.tag.attributes[parser.attribName] = parser.attribValue;
                emitNode(parser, "onattribute", {
                    name: parser.attribName,
                    value: parser.attribValue
                });
            }
            parser.attribName = parser.attribValue = "";
        }
        function openTag(parser, selfClosing) {
            if (parser.opt.xmlns) {
                var tag = parser.tag;
                var qn = qname(parser.tagName);
                tag.prefix = qn.prefix;
                tag.local = qn.local;
                tag.uri = tag.ns[qn.prefix] || "";
                if (tag.prefix && !tag.uri) {
                    strictFail(parser, "Unbound namespace prefix: " + JSON.stringify(parser.tagName));
                    tag.uri = qn.prefix;
                }
                var parent = parser.tags[parser.tags.length - 1] || parser;
                if (tag.ns && parent.ns !== tag.ns) {
                    Object.keys(tag.ns).forEach((function(p) {
                        emitNode(parser, "onopennamespace", {
                            prefix: p,
                            uri: tag.ns[p]
                        });
                    }));
                }
                for (var i = 0, l = parser.attribList.length; i < l; i++) {
                    var nv = parser.attribList[i];
                    var name = nv[0];
                    var value = nv[1];
                    var qualName = qname(name, true);
                    var prefix = qualName.prefix;
                    var local = qualName.local;
                    var uri = prefix === "" ? "" : tag.ns[prefix] || "";
                    var a = {
                        name,
                        value,
                        prefix,
                        local,
                        uri
                    };
                    if (prefix && prefix !== "xmlns" && !uri) {
                        strictFail(parser, "Unbound namespace prefix: " + JSON.stringify(prefix));
                        a.uri = prefix;
                    }
                    parser.tag.attributes[name] = a;
                    emitNode(parser, "onattribute", a);
                }
                parser.attribList.length = 0;
            }
            parser.tag.isSelfClosing = !!selfClosing;
            parser.sawRoot = true;
            parser.tags.push(parser.tag);
            emitNode(parser, "onopentag", parser.tag);
            if (!selfClosing) {
                if (!parser.noscript && parser.tagName.toLowerCase() === "script") {
                    parser.state = S.SCRIPT;
                } else {
                    parser.state = S.TEXT;
                }
                parser.tag = null;
                parser.tagName = "";
            }
            parser.attribName = parser.attribValue = "";
            parser.attribList.length = 0;
        }
        function closeTag(parser) {
            if (!parser.tagName) {
                strictFail(parser, "Weird empty close tag.");
                parser.textNode += "</>";
                parser.state = S.TEXT;
                return;
            }
            if (parser.script) {
                if (parser.tagName !== "script") {
                    parser.script += "</" + parser.tagName + ">";
                    parser.tagName = "";
                    parser.state = S.SCRIPT;
                    return;
                }
                emitNode(parser, "onscript", parser.script);
                parser.script = "";
            }
            var t = parser.tags.length;
            var tagName = parser.tagName;
            if (!parser.strict) {
                tagName = tagName[parser.looseCase]();
            }
            var closeTo = tagName;
            while (t--) {
                var close = parser.tags[t];
                if (close.name !== closeTo) {
                    strictFail(parser, "Unexpected close tag");
                } else {
                    break;
                }
            }
            if (t < 0) {
                strictFail(parser, "Unmatched closing tag: " + parser.tagName);
                parser.textNode += "</" + parser.tagName + ">";
                parser.state = S.TEXT;
                return;
            }
            parser.tagName = tagName;
            var s = parser.tags.length;
            while (s-- > t) {
                var tag = parser.tag = parser.tags.pop();
                parser.tagName = parser.tag.name;
                emitNode(parser, "onclosetag", parser.tagName);
                var x = {};
                for (var i in tag.ns) {
                    x[i] = tag.ns[i];
                }
                var parent = parser.tags[parser.tags.length - 1] || parser;
                if (parser.opt.xmlns && tag.ns !== parent.ns) {
                    Object.keys(tag.ns).forEach((function(p) {
                        var n = tag.ns[p];
                        emitNode(parser, "onclosenamespace", {
                            prefix: p,
                            uri: n
                        });
                    }));
                }
            }
            if (t === 0) parser.closedRoot = true;
            parser.tagName = parser.attribValue = parser.attribName = "";
            parser.attribList.length = 0;
            parser.state = S.TEXT;
        }
        function parseEntity(parser) {
            var entity = parser.entity;
            var entityLC = entity.toLowerCase();
            var num;
            var numStr = "";
            if (parser.ENTITIES[entity]) {
                return parser.ENTITIES[entity];
            }
            if (parser.ENTITIES[entityLC]) {
                return parser.ENTITIES[entityLC];
            }
            entity = entityLC;
            if (entity.charAt(0) === "#") {
                if (entity.charAt(1) === "x") {
                    entity = entity.slice(2);
                    num = parseInt(entity, 16);
                    numStr = num.toString(16);
                } else {
                    entity = entity.slice(1);
                    num = parseInt(entity, 10);
                    numStr = num.toString(10);
                }
            }
            entity = entity.replace(/^0+/, "");
            if (isNaN(num) || numStr.toLowerCase() !== entity) {
                strictFail(parser, "Invalid character entity");
                return "&" + parser.entity + ";";
            }
            return String.fromCodePoint(num);
        }
        function beginWhiteSpace(parser, c) {
            if (c === "<") {
                parser.state = S.OPEN_WAKA;
                parser.startTagPosition = parser.position;
            } else if (!isWhitespace(c)) {
                strictFail(parser, "Non-whitespace before first tag.");
                parser.textNode = c;
                parser.state = S.TEXT;
            }
        }
        function charAt(chunk, i) {
            var result = "";
            if (i < chunk.length) {
                result = chunk.charAt(i);
            }
            return result;
        }
        function write(chunk) {
            var parser = this;
            if (this.error) {
                throw this.error;
            }
            if (parser.closed) {
                return error(parser, "Cannot write after close. Assign an onready handler.");
            }
            if (chunk === null) {
                return end(parser);
            }
            if (typeof chunk === "object") {
                chunk = chunk.toString();
            }
            var i = 0;
            var c = "";
            while (true) {
                c = charAt(chunk, i++);
                parser.c = c;
                if (!c) {
                    break;
                }
                if (parser.trackPosition) {
                    parser.position++;
                    if (c === "\n") {
                        parser.line++;
                        parser.column = 0;
                    } else {
                        parser.column++;
                    }
                }
                switch (parser.state) {
                  case S.BEGIN:
                    parser.state = S.BEGIN_WHITESPACE;
                    if (c === "\ufeff") {
                        continue;
                    }
                    beginWhiteSpace(parser, c);
                    continue;

                  case S.BEGIN_WHITESPACE:
                    beginWhiteSpace(parser, c);
                    continue;

                  case S.TEXT:
                    if (parser.sawRoot && !parser.closedRoot) {
                        var starti = i - 1;
                        while (c && c !== "<" && c !== "&") {
                            c = charAt(chunk, i++);
                            if (c && parser.trackPosition) {
                                parser.position++;
                                if (c === "\n") {
                                    parser.line++;
                                    parser.column = 0;
                                } else {
                                    parser.column++;
                                }
                            }
                        }
                        parser.textNode += chunk.substring(starti, i - 1);
                    }
                    if (c === "<" && !(parser.sawRoot && parser.closedRoot && !parser.strict)) {
                        parser.state = S.OPEN_WAKA;
                        parser.startTagPosition = parser.position;
                    } else {
                        if (!isWhitespace(c) && (!parser.sawRoot || parser.closedRoot)) {
                            strictFail(parser, "Text data outside of root node.");
                        }
                        if (c === "&") {
                            parser.state = S.TEXT_ENTITY;
                        } else {
                            parser.textNode += c;
                        }
                    }
                    continue;

                  case S.SCRIPT:
                    if (c === "<") {
                        parser.state = S.SCRIPT_ENDING;
                    } else {
                        parser.script += c;
                    }
                    continue;

                  case S.SCRIPT_ENDING:
                    if (c === "/") {
                        parser.state = S.CLOSE_TAG;
                    } else {
                        parser.script += "<" + c;
                        parser.state = S.SCRIPT;
                    }
                    continue;

                  case S.OPEN_WAKA:
                    if (c === "!") {
                        parser.state = S.SGML_DECL;
                        parser.sgmlDecl = "";
                    } else if (isWhitespace(c)) {} else if (isMatch(nameStart, c)) {
                        parser.state = S.OPEN_TAG;
                        parser.tagName = c;
                    } else if (c === "/") {
                        parser.state = S.CLOSE_TAG;
                        parser.tagName = "";
                    } else if (c === "?") {
                        parser.state = S.PROC_INST;
                        parser.procInstName = parser.procInstBody = "";
                    } else {
                        strictFail(parser, "Unencoded <");
                        if (parser.startTagPosition + 1 < parser.position) {
                            var pad = parser.position - parser.startTagPosition;
                            c = new Array(pad).join(" ") + c;
                        }
                        parser.textNode += "<" + c;
                        parser.state = S.TEXT;
                    }
                    continue;

                  case S.SGML_DECL:
                    if ((parser.sgmlDecl + c).toUpperCase() === CDATA) {
                        emitNode(parser, "onopencdata");
                        parser.state = S.CDATA;
                        parser.sgmlDecl = "";
                        parser.cdata = "";
                    } else if (parser.sgmlDecl + c === "--") {
                        parser.state = S.COMMENT;
                        parser.comment = "";
                        parser.sgmlDecl = "";
                    } else if ((parser.sgmlDecl + c).toUpperCase() === DOCTYPE) {
                        parser.state = S.DOCTYPE;
                        if (parser.doctype || parser.sawRoot) {
                            strictFail(parser, "Inappropriately located doctype declaration");
                        }
                        parser.doctype = "";
                        parser.sgmlDecl = "";
                    } else if (c === ">") {
                        emitNode(parser, "onsgmldeclaration", parser.sgmlDecl);
                        parser.sgmlDecl = "";
                        parser.state = S.TEXT;
                    } else if (isQuote(c)) {
                        parser.state = S.SGML_DECL_QUOTED;
                        parser.sgmlDecl += c;
                    } else {
                        parser.sgmlDecl += c;
                    }
                    continue;

                  case S.SGML_DECL_QUOTED:
                    if (c === parser.q) {
                        parser.state = S.SGML_DECL;
                        parser.q = "";
                    }
                    parser.sgmlDecl += c;
                    continue;

                  case S.DOCTYPE:
                    if (c === ">") {
                        parser.state = S.TEXT;
                        emitNode(parser, "ondoctype", parser.doctype);
                        parser.doctype = true;
                    } else {
                        parser.doctype += c;
                        if (c === "[") {
                            parser.state = S.DOCTYPE_DTD;
                        } else if (isQuote(c)) {
                            parser.state = S.DOCTYPE_QUOTED;
                            parser.q = c;
                        }
                    }
                    continue;

                  case S.DOCTYPE_QUOTED:
                    parser.doctype += c;
                    if (c === parser.q) {
                        parser.q = "";
                        parser.state = S.DOCTYPE;
                    }
                    continue;

                  case S.DOCTYPE_DTD:
                    parser.doctype += c;
                    if (c === "]") {
                        parser.state = S.DOCTYPE;
                    } else if (isQuote(c)) {
                        parser.state = S.DOCTYPE_DTD_QUOTED;
                        parser.q = c;
                    }
                    continue;

                  case S.DOCTYPE_DTD_QUOTED:
                    parser.doctype += c;
                    if (c === parser.q) {
                        parser.state = S.DOCTYPE_DTD;
                        parser.q = "";
                    }
                    continue;

                  case S.COMMENT:
                    if (c === "-") {
                        parser.state = S.COMMENT_ENDING;
                    } else {
                        parser.comment += c;
                    }
                    continue;

                  case S.COMMENT_ENDING:
                    if (c === "-") {
                        parser.state = S.COMMENT_ENDED;
                        parser.comment = textopts(parser.opt, parser.comment);
                        if (parser.comment) {
                            emitNode(parser, "oncomment", parser.comment);
                        }
                        parser.comment = "";
                    } else {
                        parser.comment += "-" + c;
                        parser.state = S.COMMENT;
                    }
                    continue;

                  case S.COMMENT_ENDED:
                    if (c !== ">") {
                        strictFail(parser, "Malformed comment");
                        parser.comment += "--" + c;
                        parser.state = S.COMMENT;
                    } else {
                        parser.state = S.TEXT;
                    }
                    continue;

                  case S.CDATA:
                    if (c === "]") {
                        parser.state = S.CDATA_ENDING;
                    } else {
                        parser.cdata += c;
                    }
                    continue;

                  case S.CDATA_ENDING:
                    if (c === "]") {
                        parser.state = S.CDATA_ENDING_2;
                    } else {
                        parser.cdata += "]" + c;
                        parser.state = S.CDATA;
                    }
                    continue;

                  case S.CDATA_ENDING_2:
                    if (c === ">") {
                        if (parser.cdata) {
                            emitNode(parser, "oncdata", parser.cdata);
                        }
                        emitNode(parser, "onclosecdata");
                        parser.cdata = "";
                        parser.state = S.TEXT;
                    } else if (c === "]") {
                        parser.cdata += "]";
                    } else {
                        parser.cdata += "]]" + c;
                        parser.state = S.CDATA;
                    }
                    continue;

                  case S.PROC_INST:
                    if (c === "?") {
                        parser.state = S.PROC_INST_ENDING;
                    } else if (isWhitespace(c)) {
                        parser.state = S.PROC_INST_BODY;
                    } else {
                        parser.procInstName += c;
                    }
                    continue;

                  case S.PROC_INST_BODY:
                    if (!parser.procInstBody && isWhitespace(c)) {
                        continue;
                    } else if (c === "?") {
                        parser.state = S.PROC_INST_ENDING;
                    } else {
                        parser.procInstBody += c;
                    }
                    continue;

                  case S.PROC_INST_ENDING:
                    if (c === ">") {
                        emitNode(parser, "onprocessinginstruction", {
                            name: parser.procInstName,
                            body: parser.procInstBody
                        });
                        parser.procInstName = parser.procInstBody = "";
                        parser.state = S.TEXT;
                    } else {
                        parser.procInstBody += "?" + c;
                        parser.state = S.PROC_INST_BODY;
                    }
                    continue;

                  case S.OPEN_TAG:
                    if (isMatch(nameBody, c)) {
                        parser.tagName += c;
                    } else {
                        newTag(parser);
                        if (c === ">") {
                            openTag(parser);
                        } else if (c === "/") {
                            parser.state = S.OPEN_TAG_SLASH;
                        } else {
                            if (!isWhitespace(c)) {
                                strictFail(parser, "Invalid character in tag name");
                            }
                            parser.state = S.ATTRIB;
                        }
                    }
                    continue;

                  case S.OPEN_TAG_SLASH:
                    if (c === ">") {
                        openTag(parser, true);
                        closeTag(parser);
                    } else {
                        strictFail(parser, "Forward-slash in opening tag not followed by >");
                        parser.state = S.ATTRIB;
                    }
                    continue;

                  case S.ATTRIB:
                    if (isWhitespace(c)) {
                        continue;
                    } else if (c === ">") {
                        openTag(parser);
                    } else if (c === "/") {
                        parser.state = S.OPEN_TAG_SLASH;
                    } else if (isMatch(nameStart, c)) {
                        parser.attribName = c;
                        parser.attribValue = "";
                        parser.state = S.ATTRIB_NAME;
                    } else {
                        strictFail(parser, "Invalid attribute name");
                    }
                    continue;

                  case S.ATTRIB_NAME:
                    if (c === "=") {
                        parser.state = S.ATTRIB_VALUE;
                    } else if (c === ">") {
                        strictFail(parser, "Attribute without value");
                        parser.attribValue = parser.attribName;
                        attrib(parser);
                        openTag(parser);
                    } else if (isWhitespace(c)) {
                        parser.state = S.ATTRIB_NAME_SAW_WHITE;
                    } else if (isMatch(nameBody, c)) {
                        parser.attribName += c;
                    } else {
                        strictFail(parser, "Invalid attribute name");
                    }
                    continue;

                  case S.ATTRIB_NAME_SAW_WHITE:
                    if (c === "=") {
                        parser.state = S.ATTRIB_VALUE;
                    } else if (isWhitespace(c)) {
                        continue;
                    } else {
                        strictFail(parser, "Attribute without value");
                        parser.tag.attributes[parser.attribName] = "";
                        parser.attribValue = "";
                        emitNode(parser, "onattribute", {
                            name: parser.attribName,
                            value: ""
                        });
                        parser.attribName = "";
                        if (c === ">") {
                            openTag(parser);
                        } else if (isMatch(nameStart, c)) {
                            parser.attribName = c;
                            parser.state = S.ATTRIB_NAME;
                        } else {
                            strictFail(parser, "Invalid attribute name");
                            parser.state = S.ATTRIB;
                        }
                    }
                    continue;

                  case S.ATTRIB_VALUE:
                    if (isWhitespace(c)) {
                        continue;
                    } else if (isQuote(c)) {
                        parser.q = c;
                        parser.state = S.ATTRIB_VALUE_QUOTED;
                    } else {
                        strictFail(parser, "Unquoted attribute value");
                        parser.state = S.ATTRIB_VALUE_UNQUOTED;
                        parser.attribValue = c;
                    }
                    continue;

                  case S.ATTRIB_VALUE_QUOTED:
                    if (c !== parser.q) {
                        if (c === "&") {
                            parser.state = S.ATTRIB_VALUE_ENTITY_Q;
                        } else {
                            parser.attribValue += c;
                        }
                        continue;
                    }
                    attrib(parser);
                    parser.q = "";
                    parser.state = S.ATTRIB_VALUE_CLOSED;
                    continue;

                  case S.ATTRIB_VALUE_CLOSED:
                    if (isWhitespace(c)) {
                        parser.state = S.ATTRIB;
                    } else if (c === ">") {
                        openTag(parser);
                    } else if (c === "/") {
                        parser.state = S.OPEN_TAG_SLASH;
                    } else if (isMatch(nameStart, c)) {
                        strictFail(parser, "No whitespace between attributes");
                        parser.attribName = c;
                        parser.attribValue = "";
                        parser.state = S.ATTRIB_NAME;
                    } else {
                        strictFail(parser, "Invalid attribute name");
                    }
                    continue;

                  case S.ATTRIB_VALUE_UNQUOTED:
                    if (!isAttribEnd(c)) {
                        if (c === "&") {
                            parser.state = S.ATTRIB_VALUE_ENTITY_U;
                        } else {
                            parser.attribValue += c;
                        }
                        continue;
                    }
                    attrib(parser);
                    if (c === ">") {
                        openTag(parser);
                    } else {
                        parser.state = S.ATTRIB;
                    }
                    continue;

                  case S.CLOSE_TAG:
                    if (!parser.tagName) {
                        if (isWhitespace(c)) {
                            continue;
                        } else if (notMatch(nameStart, c)) {
                            if (parser.script) {
                                parser.script += "</" + c;
                                parser.state = S.SCRIPT;
                            } else {
                                strictFail(parser, "Invalid tagname in closing tag.");
                            }
                        } else {
                            parser.tagName = c;
                        }
                    } else if (c === ">") {
                        closeTag(parser);
                    } else if (isMatch(nameBody, c)) {
                        parser.tagName += c;
                    } else if (parser.script) {
                        parser.script += "</" + parser.tagName;
                        parser.tagName = "";
                        parser.state = S.SCRIPT;
                    } else {
                        if (!isWhitespace(c)) {
                            strictFail(parser, "Invalid tagname in closing tag");
                        }
                        parser.state = S.CLOSE_TAG_SAW_WHITE;
                    }
                    continue;

                  case S.CLOSE_TAG_SAW_WHITE:
                    if (isWhitespace(c)) {
                        continue;
                    }
                    if (c === ">") {
                        closeTag(parser);
                    } else {
                        strictFail(parser, "Invalid characters in closing tag");
                    }
                    continue;

                  case S.TEXT_ENTITY:
                  case S.ATTRIB_VALUE_ENTITY_Q:
                  case S.ATTRIB_VALUE_ENTITY_U:
                    var returnState;
                    var buffer;
                    switch (parser.state) {
                      case S.TEXT_ENTITY:
                        returnState = S.TEXT;
                        buffer = "textNode";
                        break;

                      case S.ATTRIB_VALUE_ENTITY_Q:
                        returnState = S.ATTRIB_VALUE_QUOTED;
                        buffer = "attribValue";
                        break;

                      case S.ATTRIB_VALUE_ENTITY_U:
                        returnState = S.ATTRIB_VALUE_UNQUOTED;
                        buffer = "attribValue";
                        break;
                    }
                    if (c === ";") {
                        parser[buffer] += parseEntity(parser);
                        parser.entity = "";
                        parser.state = returnState;
                    } else if (isMatch(parser.entity.length ? entityBody : entityStart, c)) {
                        parser.entity += c;
                    } else {
                        strictFail(parser, "Invalid character in entity name");
                        parser[buffer] += "&" + parser.entity + c;
                        parser.entity = "";
                        parser.state = returnState;
                    }
                    continue;

                  default:
                    throw new Error(parser, "Unknown state: " + parser.state);
                }
            }
            if (parser.position >= parser.bufferCheckPosition) {
                checkBufferLength(parser);
            }
            return parser;
        }
        if (!String.fromCodePoint) {
            (function() {
                var stringFromCharCode = String.fromCharCode;
                var floor = Math.floor;
                var fromCodePoint = function() {
                    var MAX_SIZE = 16384;
                    var codeUnits = [];
                    var highSurrogate;
                    var lowSurrogate;
                    var index = -1;
                    var length = arguments.length;
                    if (!length) {
                        return "";
                    }
                    var result = "";
                    while (++index < length) {
                        var codePoint = Number(arguments[index]);
                        if (!isFinite(codePoint) || codePoint < 0 || codePoint > 1114111 || floor(codePoint) !== codePoint) {
                            throw RangeError("Invalid code point: " + codePoint);
                        }
                        if (codePoint <= 65535) {
                            codeUnits.push(codePoint);
                        } else {
                            codePoint -= 65536;
                            highSurrogate = (codePoint >> 10) + 55296;
                            lowSurrogate = codePoint % 1024 + 56320;
                            codeUnits.push(highSurrogate, lowSurrogate);
                        }
                        if (index + 1 === length || codeUnits.length > MAX_SIZE) {
                            result += stringFromCharCode.apply(null, codeUnits);
                            codeUnits.length = 0;
                        }
                    }
                    return result;
                };
                if (Object.defineProperty) {
                    Object.defineProperty(String, "fromCodePoint", {
                        value: fromCodePoint,
                        configurable: true,
                        writable: true
                    });
                } else {
                    String.fromCodePoint = fromCodePoint;
                }
            })();
        }
    })(false ? undefined : exports);
}, function(module, exports) {
    var buffer = module.exports;
    var hasBigIntMethods = typeof Buffer.prototype.readBigUInt64BE == "function";
    if (hasBigIntMethods) {
        buffer.readBigUInt64BE = function(buffer, offset) {
            return buffer.readBigUInt64BE(offset);
        };
        buffer.writeBigUInt64BE = function(buffer, value, offset) {
            return buffer.writeBigUInt64BE(value, offset);
        };
        buffer.readBigUInt64LE = function(buffer, offset) {
            return buffer.readBigUInt64LE(offset);
        };
        buffer.writeBigUInt64LE = function(buffer, value, offset) {
            return buffer.writeBigUInt64LE(value, offset);
        };
        buffer.readBigInt64BE = function(buffer, offset) {
            return buffer.readBigInt64BE(offset);
        };
        buffer.writeBigInt64BE = function(buffer, value, offset) {
            return buffer.writeBigInt64BE(value, offset);
        };
        buffer.readBigInt64LE = function(buffer, offset) {
            return buffer.readBigInt64LE(offset);
        };
        buffer.writeBigInt64LE = function(buffer, value, offset) {
            return buffer.writeBigInt64LE(value, offset);
        };
    } else {
        buffer.readBigUInt64BE = function(buffer, offset) {
            offset = offset || 0;
            var hi = buffer.readUInt32BE(offset);
            var lo = buffer.readUInt32BE(offset + 4);
            return (BigInt(hi) << BigInt(32)) + BigInt(lo);
        };
        buffer.writeBigUInt64BE = function(buffer, value, offset) {
            offset = offset || 0;
            var hi = BigInt(value) >> BigInt(32);
            var lo = BigInt(value) - (hi << BigInt(32));
            buffer.writeUInt32BE(Number(hi), offset);
            buffer.writeUInt32BE(Number(lo), offset + 4);
            return offset + 8;
        };
        buffer.readBigUInt64LE = function(buffer, offset) {
            offset = offset || 0;
            var hi = buffer.readUInt32LE(offset + 4);
            var lo = buffer.readUInt32LE(offset);
            return (BigInt(hi) << BigInt(32)) + BigInt(lo);
        };
        buffer.writeBigUInt64LE = function(buffer, value, offset) {
            offset = offset || 0;
            var hi = BigInt(value) >> BigInt(32);
            var lo = BigInt(value) - (hi << BigInt(32));
            buffer.writeUInt32LE(Number(hi), offset + 4);
            buffer.writeUInt32LE(Number(lo), offset);
            return offset + 8;
        };
        buffer.readBigInt64BE = function(buffer, offset) {
            offset = offset || 0;
            var hi = buffer.readInt32BE(offset);
            var lo = buffer.readUInt32BE(offset + 4);
            return (BigInt(hi) << BigInt(32)) + BigInt(lo);
        };
        buffer.writeBigInt64BE = function(buffer, value, offset) {
            offset = offset || 0;
            var hi = BigInt(value) >> BigInt(32);
            var lo = BigInt(value) - (hi << BigInt(32));
            buffer.writeInt32BE(Number(hi), offset);
            buffer.writeUInt32BE(Number(lo), offset + 4);
            return offset + 8;
        };
        buffer.readBigInt64LE = function(buffer, offset) {
            offset = offset || 0;
            var hi = buffer.readInt32LE(offset + 4);
            var lo = buffer.readUInt32LE(offset);
            return (BigInt(hi) << BigInt(32)) + BigInt(lo);
        };
        buffer.writeBigInt64LE = function(buffer, value, offset) {
            offset = offset || 0;
            var hi = BigInt(value) >> BigInt(32);
            var lo = BigInt(value) - (hi << BigInt(32));
            buffer.writeUInt32LE(Number(hi), offset + 4);
            buffer.writeInt32LE(Number(lo), offset);
            return offset + 8;
        };
    }
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.readStream = void 0;
    const constants_1 = __webpack_require__(16);
    const utils_1 = __webpack_require__(41);
    const EXCLUDE = [ constants_1.BLOCK.COMMENT, constants_1.BLOCK.TERMINATOR ];
    async function* readStream(image, end) {
        let remaining = end + 1;
        for (const {block} of utils_1.blockGenerator(image, EXCLUDE)) {
            if (remaining <= 0) {
                return;
            }
            if (block.type === constants_1.BLOCK.ZEROFILL || block.type === constants_1.BLOCK.FREE) {
                const size = Math.min(block.sectorCount * constants_1.SECTOR_SIZE, remaining);
                yield* new utils_1.ZeroStream(size);
                remaining -= size;
            } else {
                const offset = image.footer.dataForkOffset + block.compressedOffset;
                const length = block.compressedLength;
                const inputStream = await image.fs.createReadStream(offset, offset + length - 1);
                for await (let chunk of utils_1.blockDecompressor(block.type, inputStream)) {
                    if (chunk.length > remaining) {
                        chunk = chunk.slice(0, remaining);
                    }
                    yield chunk;
                    remaining -= chunk.length;
                }
            }
        }
    }
    exports.readStream = readStream;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.sparseReadStream = void 0;
    const constants_1 = __webpack_require__(16);
    const utils_1 = __webpack_require__(41);
    const EXCLUDE = [ constants_1.BLOCK.COMMENT, constants_1.BLOCK.TERMINATOR, constants_1.BLOCK.FREE ];
    async function* sparseReadStream(image) {
        for (const {entry, block} of utils_1.blockGenerator(image, EXCLUDE)) {
            let position = entry.map.sectorNumber * constants_1.SECTOR_SIZE + block.sectorNumber * constants_1.SECTOR_SIZE;
            if (block.type === constants_1.BLOCK.ZEROFILL) {
                const size = block.sectorCount * constants_1.SECTOR_SIZE;
                for await (const buffer of new utils_1.ZeroStream(size)) {
                    yield {
                        buffer,
                        position
                    };
                    position += buffer.length;
                }
            } else {
                const offset = image.footer.dataForkOffset + block.compressedOffset;
                const length = block.compressedLength;
                const inputStream = await image.fs.createReadStream(offset, offset + length - 1);
                const stream = utils_1.blockDecompressor(block.type, inputStream);
                for await (const buffer of stream) {
                    yield {
                        buffer,
                        position
                    };
                    position += buffer.length;
                }
            }
        }
    }
    exports.sparseReadStream = sparseReadStream;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.Http = void 0;
    const axios_1 = __webpack_require__(42);
    const axiosNodeAdapter = __webpack_require__(57);
    const path_1 = __webpack_require__(4);
    const querystring_1 = __webpack_require__(217);
    const url_1 = __webpack_require__(58);
    const stream_limiter_1 = __webpack_require__(32);
    const source_destination_1 = __webpack_require__(7);
    axios_1.default.defaults.adapter = axiosNodeAdapter;
    class Http extends source_destination_1.SourceDestination {
        constructor({url, avoidRandomAccess = false}) {
            super();
            this.url = url;
            this.avoidRandomAccess = avoidRandomAccess;
            this.ready = this.getInfo();
        }
        async getInfo() {
            try {
                let response;
                try {
                    response = await axios_1.default({
                        method: "head",
                        url: this.url
                    });
                } catch (error) {
                    response = await axios_1.default({
                        method: "get",
                        url: this.url,
                        responseType: "stream"
                    });
                    response.data.destroy();
                }
                this.redirectUrl = response.request.res.responseUrl;
                this.size = parseInt(response.headers["content-length"], 10);
                if (Number.isNaN(this.size)) {
                    this.size = undefined;
                }
                this.acceptsRange = response.headers["accept-ranges"] === "bytes";
            } catch (error) {
                this.error = error;
            }
        }
        async canRead() {
            await this.ready;
            if (this.error) {
                throw this.error;
            }
            return !this.avoidRandomAccess && this.acceptsRange;
        }
        async canCreateReadStream() {
            return true;
        }
        async _getMetadata() {
            await this.ready;
            if (this.error) {
                throw this.error;
            }
            let name;
            const pathname = url_1.parse(this.redirectUrl).pathname;
            if (pathname !== undefined) {
                name = path_1.basename(querystring_1.unescape(pathname));
            }
            return {
                size: this.size,
                name
            };
        }
        getRange(start = 0, end) {
            let range = `bytes=${start}-`;
            if (end !== undefined) {
                range += end;
            }
            return range;
        }
        async read(buffer, bufferOffset, length, sourceOffset) {
            const response = await axios_1.default({
                method: "get",
                url: this.redirectUrl,
                responseType: "arraybuffer",
                headers: {
                    Range: this.getRange(sourceOffset, sourceOffset + length - 1)
                }
            });
            const bytesRead = response.data.length;
            response.data.copy(buffer, bufferOffset);
            return {
                bytesRead,
                buffer
            };
        }
        async createReadStream({emitProgress = false, start = 0, end} = {}) {
            const response = await axios_1.default({
                method: "get",
                url: this.redirectUrl,
                headers: {
                    Range: this.getRange(start, end)
                },
                responseType: "stream"
            });
            if (emitProgress) {
                let bytes = 0;
                let lastTime = Date.now();
                response.data.on("data", chunk => {
                    const now = Date.now();
                    const length = chunk.length;
                    bytes += length;
                    const speed = length / ((now - lastTime) / 1e3);
                    lastTime = now;
                    response.data.emit("progress", {
                        position: bytes,
                        bytes,
                        speed
                    });
                });
                response.data.pause();
            }
            if (end !== undefined) {
                return new stream_limiter_1.StreamLimiter(response.data, end - start + 1);
            }
            return response.data;
        }
    }
    exports.Http = Http;
}, function(module, exports, __webpack_require__) {
    "use strict";
    module.exports = function bind(fn, thisArg) {
        return function wrap() {
            var args = new Array(arguments.length);
            for (var i = 0; i < args.length; i++) {
                args[i] = arguments[i];
            }
            return fn.apply(thisArg, args);
        };
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    var utils = __webpack_require__(10);
    function encode(val) {
        return encodeURIComponent(val).replace(/%40/gi, "@").replace(/%3A/gi, ":").replace(/%24/g, "$").replace(/%2C/gi, ",").replace(/%20/g, "+").replace(/%5B/gi, "[").replace(/%5D/gi, "]");
    }
    module.exports = function buildURL(url, params, paramsSerializer) {
        if (!params) {
            return url;
        }
        var serializedParams;
        if (paramsSerializer) {
            serializedParams = paramsSerializer(params);
        } else if (utils.isURLSearchParams(params)) {
            serializedParams = params.toString();
        } else {
            var parts = [];
            utils.forEach(params, (function serialize(val, key) {
                if (val === null || typeof val === "undefined") {
                    return;
                }
                if (utils.isArray(val)) {
                    key = key + "[]";
                } else {
                    val = [ val ];
                }
                utils.forEach(val, (function parseValue(v) {
                    if (utils.isDate(v)) {
                        v = v.toISOString();
                    } else if (utils.isObject(v)) {
                        v = JSON.stringify(v);
                    }
                    parts.push(encode(key) + "=" + encode(v));
                }));
            }));
            serializedParams = parts.join("&");
        }
        if (serializedParams) {
            var hashmarkIndex = url.indexOf("#");
            if (hashmarkIndex !== -1) {
                url = url.slice(0, hashmarkIndex);
            }
            url += (url.indexOf("?") === -1 ? "?" : "&") + serializedParams;
        }
        return url;
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    module.exports = function isCancel(value) {
        return !!(value && value.__CANCEL__);
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    var utils = __webpack_require__(10);
    var normalizeHeaderName = __webpack_require__(205);
    var DEFAULT_CONTENT_TYPE = {
        "Content-Type": "application/x-www-form-urlencoded"
    };
    function setContentTypeIfUnset(headers, value) {
        if (!utils.isUndefined(headers) && utils.isUndefined(headers["Content-Type"])) {
            headers["Content-Type"] = value;
        }
    }
    function getDefaultAdapter() {
        var adapter;
        if (typeof XMLHttpRequest !== "undefined") {
            adapter = __webpack_require__(57);
        } else if (typeof process !== "undefined" && Object.prototype.toString.call(process) === "[object process]") {
            adapter = __webpack_require__(57);
        }
        return adapter;
    }
    var defaults = {
        adapter: getDefaultAdapter(),
        transformRequest: [ function transformRequest(data, headers) {
            normalizeHeaderName(headers, "Accept");
            normalizeHeaderName(headers, "Content-Type");
            if (utils.isFormData(data) || utils.isArrayBuffer(data) || utils.isBuffer(data) || utils.isStream(data) || utils.isFile(data) || utils.isBlob(data)) {
                return data;
            }
            if (utils.isArrayBufferView(data)) {
                return data.buffer;
            }
            if (utils.isURLSearchParams(data)) {
                setContentTypeIfUnset(headers, "application/x-www-form-urlencoded;charset=utf-8");
                return data.toString();
            }
            if (utils.isObject(data)) {
                setContentTypeIfUnset(headers, "application/json;charset=utf-8");
                return JSON.stringify(data);
            }
            return data;
        } ],
        transformResponse: [ function transformResponse(data) {
            if (typeof data === "string") {
                try {
                    data = JSON.parse(data);
                } catch (e) {}
            }
            return data;
        } ],
        timeout: 0,
        xsrfCookieName: "XSRF-TOKEN",
        xsrfHeaderName: "X-XSRF-TOKEN",
        maxContentLength: -1,
        validateStatus: function validateStatus(status) {
            return status >= 200 && status < 300;
        }
    };
    defaults.headers = {
        common: {
            Accept: "application/json, text/plain, */*"
        }
    };
    utils.forEach([ "delete", "get", "head" ], (function forEachMethodNoData(method) {
        defaults.headers[method] = {};
    }));
    utils.forEach([ "post", "put", "patch" ], (function forEachMethodWithData(method) {
        defaults.headers[method] = utils.merge(DEFAULT_CONTENT_TYPE);
    }));
    module.exports = defaults;
}, function(module, exports, __webpack_require__) {
    "use strict";
    var enhanceError = __webpack_require__(97);
    module.exports = function createError(message, config, code, request, response) {
        var error = new Error(message);
        return enhanceError(error, config, code, request, response);
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    module.exports = function enhanceError(error, config, code, request, response) {
        error.config = config;
        if (code) {
            error.code = code;
        }
        error.request = request;
        error.response = response;
        error.isAxiosError = true;
        error.toJSON = function() {
            return {
                message: this.message,
                name: this.name,
                description: this.description,
                number: this.number,
                fileName: this.fileName,
                lineNumber: this.lineNumber,
                columnNumber: this.columnNumber,
                stack: this.stack,
                config: this.config,
                code: this.code
            };
        };
        return error;
    };
}, function(module, exports) {
    module.exports = require("http");
}, function(module, exports) {
    module.exports = require("https");
}, function(module, exports, __webpack_require__) {
    var url = __webpack_require__(58);
    var http = __webpack_require__(98);
    var https = __webpack_require__(99);
    var assert = __webpack_require__(101);
    var Writable = __webpack_require__(0).Writable;
    var debug = __webpack_require__(210)("follow-redirects");
    var SAFE_METHODS = {
        GET: true,
        HEAD: true,
        OPTIONS: true,
        TRACE: true
    };
    var eventHandlers = Object.create(null);
    [ "abort", "aborted", "error", "socket", "timeout" ].forEach((function(event) {
        eventHandlers[event] = function(arg) {
            this._redirectable.emit(event, arg);
        };
    }));
    function RedirectableRequest(options, responseCallback) {
        Writable.call(this);
        options.headers = options.headers || {};
        this._options = options;
        this._redirectCount = 0;
        this._redirects = [];
        this._requestBodyLength = 0;
        this._requestBodyBuffers = [];
        if (options.host) {
            if (!options.hostname) {
                options.hostname = options.host;
            }
            delete options.host;
        }
        if (responseCallback) {
            this.on("response", responseCallback);
        }
        var self = this;
        this._onNativeResponse = function(response) {
            self._processResponse(response);
        };
        if (!options.pathname && options.path) {
            var searchPos = options.path.indexOf("?");
            if (searchPos < 0) {
                options.pathname = options.path;
            } else {
                options.pathname = options.path.substring(0, searchPos);
                options.search = options.path.substring(searchPos);
            }
        }
        this._performRequest();
    }
    RedirectableRequest.prototype = Object.create(Writable.prototype);
    RedirectableRequest.prototype.write = function(data, encoding, callback) {
        if (!(typeof data === "string" || typeof data === "object" && "length" in data)) {
            throw new Error("data should be a string, Buffer or Uint8Array");
        }
        if (typeof encoding === "function") {
            callback = encoding;
            encoding = null;
        }
        if (data.length === 0) {
            if (callback) {
                callback();
            }
            return;
        }
        if (this._requestBodyLength + data.length <= this._options.maxBodyLength) {
            this._requestBodyLength += data.length;
            this._requestBodyBuffers.push({
                data,
                encoding
            });
            this._currentRequest.write(data, encoding, callback);
        } else {
            this.emit("error", new Error("Request body larger than maxBodyLength limit"));
            this.abort();
        }
    };
    RedirectableRequest.prototype.end = function(data, encoding, callback) {
        if (typeof data === "function") {
            callback = data;
            data = encoding = null;
        } else if (typeof encoding === "function") {
            callback = encoding;
            encoding = null;
        }
        var currentRequest = this._currentRequest;
        this.write(data || "", encoding, (function() {
            currentRequest.end(null, null, callback);
        }));
    };
    RedirectableRequest.prototype.setHeader = function(name, value) {
        this._options.headers[name] = value;
        this._currentRequest.setHeader(name, value);
    };
    RedirectableRequest.prototype.removeHeader = function(name) {
        delete this._options.headers[name];
        this._currentRequest.removeHeader(name);
    };
    [ "abort", "flushHeaders", "getHeader", "setNoDelay", "setSocketKeepAlive", "setTimeout" ].forEach((function(method) {
        RedirectableRequest.prototype[method] = function(a, b) {
            return this._currentRequest[method](a, b);
        };
    }));
    [ "aborted", "connection", "socket" ].forEach((function(property) {
        Object.defineProperty(RedirectableRequest.prototype, property, {
            get: function() {
                return this._currentRequest[property];
            }
        });
    }));
    RedirectableRequest.prototype._performRequest = function() {
        var protocol = this._options.protocol;
        var nativeProtocol = this._options.nativeProtocols[protocol];
        if (!nativeProtocol) {
            this.emit("error", new Error("Unsupported protocol " + protocol));
            return;
        }
        if (this._options.agents) {
            var scheme = protocol.substr(0, protocol.length - 1);
            this._options.agent = this._options.agents[scheme];
        }
        var request = this._currentRequest = nativeProtocol.request(this._options, this._onNativeResponse);
        this._currentUrl = url.format(this._options);
        request._redirectable = this;
        for (var event in eventHandlers) {
            if (event) {
                request.on(event, eventHandlers[event]);
            }
        }
        if (this._isRedirect) {
            var i = 0;
            var buffers = this._requestBodyBuffers;
            (function writeNext() {
                if (i < buffers.length) {
                    var buffer = buffers[i++];
                    request.write(buffer.data, buffer.encoding, writeNext);
                } else {
                    request.end();
                }
            })();
        }
    };
    RedirectableRequest.prototype._processResponse = function(response) {
        if (this._options.trackRedirects) {
            this._redirects.push({
                url: this._currentUrl,
                headers: response.headers,
                statusCode: response.statusCode
            });
        }
        var location = response.headers.location;
        if (location && this._options.followRedirects !== false && response.statusCode >= 300 && response.statusCode < 400) {
            if (++this._redirectCount > this._options.maxRedirects) {
                this.emit("error", new Error("Max redirects exceeded."));
                return;
            }
            var header;
            var headers = this._options.headers;
            if (response.statusCode !== 307 && !(this._options.method in SAFE_METHODS)) {
                this._options.method = "GET";
                this._requestBodyBuffers = [];
                for (header in headers) {
                    if (/^content-/i.test(header)) {
                        delete headers[header];
                    }
                }
            }
            if (!this._isRedirect) {
                for (header in headers) {
                    if (/^host$/i.test(header)) {
                        delete headers[header];
                    }
                }
            }
            var redirectUrl = url.resolve(this._currentUrl, location);
            debug("redirecting to", redirectUrl);
            Object.assign(this._options, url.parse(redirectUrl));
            this._isRedirect = true;
            this._performRequest();
            response.destroy();
        } else {
            response.responseUrl = this._currentUrl;
            response.redirects = this._redirects;
            this.emit("response", response);
            this._requestBodyBuffers = [];
        }
    };
    function wrap(protocols) {
        var exports = {
            maxRedirects: 21,
            maxBodyLength: 10 * 1024 * 1024
        };
        var nativeProtocols = {};
        Object.keys(protocols).forEach((function(scheme) {
            var protocol = scheme + ":";
            var nativeProtocol = nativeProtocols[protocol] = protocols[scheme];
            var wrappedProtocol = exports[scheme] = Object.create(nativeProtocol);
            wrappedProtocol.request = function(options, callback) {
                if (typeof options === "string") {
                    options = url.parse(options);
                    options.maxRedirects = exports.maxRedirects;
                } else {
                    options = Object.assign({
                        protocol,
                        maxRedirects: exports.maxRedirects,
                        maxBodyLength: exports.maxBodyLength
                    }, options);
                }
                options.nativeProtocols = nativeProtocols;
                assert.equal(options.protocol, protocol, "protocol mismatch");
                debug("options", options);
                return new RedirectableRequest(options, callback);
            };
            wrappedProtocol.get = function(options, callback) {
                var request = wrappedProtocol.request(options, callback);
                request.end();
                return request;
            };
        }));
        return exports;
    }
    module.exports = wrap({
        http,
        https
    });
    module.exports.wrap = wrap;
}, function(module, exports) {
    module.exports = require("assert");
}, function(module, exports, __webpack_require__) {
    exports = module.exports = createDebug.debug = createDebug["default"] = createDebug;
    exports.coerce = coerce;
    exports.disable = disable;
    exports.enable = enable;
    exports.enabled = enabled;
    exports.humanize = __webpack_require__(212);
    exports.instances = [];
    exports.names = [];
    exports.skips = [];
    exports.formatters = {};
    function selectColor(namespace) {
        var hash = 0, i;
        for (i in namespace) {
            hash = (hash << 5) - hash + namespace.charCodeAt(i);
            hash |= 0;
        }
        return exports.colors[Math.abs(hash) % exports.colors.length];
    }
    function createDebug(namespace) {
        var prevTime;
        function debug() {
            if (!debug.enabled) return;
            var self = debug;
            var curr = +new Date;
            var ms = curr - (prevTime || curr);
            self.diff = ms;
            self.prev = prevTime;
            self.curr = curr;
            prevTime = curr;
            var args = new Array(arguments.length);
            for (var i = 0; i < args.length; i++) {
                args[i] = arguments[i];
            }
            args[0] = exports.coerce(args[0]);
            if ("string" !== typeof args[0]) {
                args.unshift("%O");
            }
            var index = 0;
            args[0] = args[0].replace(/%([a-zA-Z%])/g, (function(match, format) {
                if (match === "%%") return match;
                index++;
                var formatter = exports.formatters[format];
                if ("function" === typeof formatter) {
                    var val = args[index];
                    match = formatter.call(self, val);
                    args.splice(index, 1);
                    index--;
                }
                return match;
            }));
            exports.formatArgs.call(self, args);
            var logFn = debug.log || exports.log || console.log.bind(console);
            logFn.apply(self, args);
        }
        debug.namespace = namespace;
        debug.enabled = exports.enabled(namespace);
        debug.useColors = exports.useColors();
        debug.color = selectColor(namespace);
        debug.destroy = destroy;
        if ("function" === typeof exports.init) {
            exports.init(debug);
        }
        exports.instances.push(debug);
        return debug;
    }
    function destroy() {
        var index = exports.instances.indexOf(this);
        if (index !== -1) {
            exports.instances.splice(index, 1);
            return true;
        } else {
            return false;
        }
    }
    function enable(namespaces) {
        exports.save(namespaces);
        exports.names = [];
        exports.skips = [];
        var i;
        var split = (typeof namespaces === "string" ? namespaces : "").split(/[\s,]+/);
        var len = split.length;
        for (i = 0; i < len; i++) {
            if (!split[i]) continue;
            namespaces = split[i].replace(/\*/g, ".*?");
            if (namespaces[0] === "-") {
                exports.skips.push(new RegExp("^" + namespaces.substr(1) + "$"));
            } else {
                exports.names.push(new RegExp("^" + namespaces + "$"));
            }
        }
        for (i = 0; i < exports.instances.length; i++) {
            var instance = exports.instances[i];
            instance.enabled = exports.enabled(instance.namespace);
        }
    }
    function disable() {
        exports.enable("");
    }
    function enabled(name) {
        if (name[name.length - 1] === "*") {
            return true;
        }
        var i, len;
        for (i = 0, len = exports.skips.length; i < len; i++) {
            if (exports.skips[i].test(name)) {
                return false;
            }
        }
        for (i = 0, len = exports.names.length; i < len; i++) {
            if (exports.names[i].test(name)) {
                return true;
            }
        }
        return false;
    }
    function coerce(val) {
        if (val instanceof Error) return val.stack || val.message;
        return val;
    }
}, function(module, exports, __webpack_require__) {
    "use strict";
    var utils = __webpack_require__(10);
    module.exports = function mergeConfig(config1, config2) {
        config2 = config2 || {};
        var config = {};
        var valueFromConfig2Keys = [ "url", "method", "params", "data" ];
        var mergeDeepPropertiesKeys = [ "headers", "auth", "proxy" ];
        var defaultToConfig2Keys = [ "baseURL", "url", "transformRequest", "transformResponse", "paramsSerializer", "timeout", "withCredentials", "adapter", "responseType", "xsrfCookieName", "xsrfHeaderName", "onUploadProgress", "onDownloadProgress", "maxContentLength", "validateStatus", "maxRedirects", "httpAgent", "httpsAgent", "cancelToken", "socketPath" ];
        utils.forEach(valueFromConfig2Keys, (function valueFromConfig2(prop) {
            if (typeof config2[prop] !== "undefined") {
                config[prop] = config2[prop];
            }
        }));
        utils.forEach(mergeDeepPropertiesKeys, (function mergeDeepProperties(prop) {
            if (utils.isObject(config2[prop])) {
                config[prop] = utils.deepMerge(config1[prop], config2[prop]);
            } else if (typeof config2[prop] !== "undefined") {
                config[prop] = config2[prop];
            } else if (utils.isObject(config1[prop])) {
                config[prop] = utils.deepMerge(config1[prop]);
            } else if (typeof config1[prop] !== "undefined") {
                config[prop] = config1[prop];
            }
        }));
        utils.forEach(defaultToConfig2Keys, (function defaultToConfig2(prop) {
            if (typeof config2[prop] !== "undefined") {
                config[prop] = config2[prop];
            } else if (typeof config1[prop] !== "undefined") {
                config[prop] = config1[prop];
            }
        }));
        var axiosKeys = valueFromConfig2Keys.concat(mergeDeepPropertiesKeys).concat(defaultToConfig2Keys);
        var otherKeys = Object.keys(config2).filter((function filterAxiosKeys(key) {
            return axiosKeys.indexOf(key) === -1;
        }));
        utils.forEach(otherKeys, (function otherKeysDefaultToConfig2(prop) {
            if (typeof config2[prop] !== "undefined") {
                config[prop] = config2[prop];
            } else if (typeof config1[prop] !== "undefined") {
                config[prop] = config1[prop];
            }
        }));
        return config;
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    function Cancel(message) {
        this.message = message;
    }
    Cancel.prototype.toString = function toString() {
        return "Cancel" + (this.message ? ": " + this.message : "");
    };
    Cancel.prototype.__CANCEL__ = true;
    module.exports = Cancel;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.ZipSource = exports.RandomAccessZipSource = exports.StreamZipSource = exports.matchSupportedExtensions = void 0;
    const blockmap_1 = __webpack_require__(220);
    const path_1 = __webpack_require__(4);
    const stream_1 = __webpack_require__(0);
    const yauzl_1 = __webpack_require__(226);
    const constants_1 = __webpack_require__(5);
    const zip_1 = __webpack_require__(230);
    const source_destination_1 = __webpack_require__(7);
    const source_source_1 = __webpack_require__(24);
    const block_transform_stream_1 = __webpack_require__(45);
    const errors_1 = __webpack_require__(8);
    const shared_1 = __webpack_require__(19);
    const sparse_filter_stream_1 = __webpack_require__(34);
    const stream_limiter_1 = __webpack_require__(32);
    const utils_1 = __webpack_require__(6);
    function blockmapToBlocks(blockmap) {
        return blockmap.ranges.map(range => {
            const offset = range.start * blockmap.blockSize;
            const length = (range.end - range.start + 1) * blockmap.blockSize;
            const checksum = range.checksum;
            const checksumType = blockmap.checksumType === "sha1" || blockmap.checksumType === "sha256" ? blockmap.checksumType : undefined;
            return {
                checksum,
                checksumType,
                blocks: [ {
                    offset,
                    length
                } ]
            };
        });
    }
    function matchSupportedExtensions(filename) {
        const extension = path_1.posix.extname(filename);
        return extension.length > 1 && source_destination_1.SourceDestination.imageExtensions.includes(extension.slice(1));
    }
    exports.matchSupportedExtensions = matchSupportedExtensions;
    class StreamZipSource extends source_source_1.SourceSource {
        constructor(source, match = matchSupportedExtensions) {
            super(source);
            this.match = match;
        }
        async canCreateReadStream() {
            return true;
        }
        async getEntry() {
            if (this.entry === undefined) {
                const entry = await zip_1.getFileStreamFromZipStream(await this.source.createReadStream(), this.match);
                this.entry = entry;
                const onData = () => {
                    entry.removeListener("data", onData);
                    this.entry = undefined;
                };
                entry.on("data", onData);
                entry.pause();
            }
            return this.entry;
        }
        async createReadStream({start = 0, end} = {}) {
            if (start !== 0) {
                throw new errors_1.NotCapable;
            }
            const stream = await this.getEntry();
            if (end !== undefined) {
                const transform = new stream_limiter_1.StreamLimiter(stream, end + 1);
                return transform;
            }
            return stream;
        }
        async _getMetadata() {
            const entry = await this.getEntry();
            return {
                size: entry.size,
                compressedSize: entry.compressedSize,
                name: path_1.posix.basename(entry.path)
            };
        }
    }
    exports.StreamZipSource = StreamZipSource;
    class SourceRandomAccessReader extends yauzl_1.RandomAccessReader {
        constructor(source) {
            super();
            this.source = source;
        }
        _readStreamForRange(start, end) {
            const passthrough = new stream_1.PassThrough;
            this.source.createReadStream({
                start,
                end: end - 1
            }).then(stream => {
                stream.on("error", passthrough.emit.bind(passthrough, "error"));
                stream.pipe(passthrough);
            }).catch(passthrough.emit.bind(passthrough, "error"));
            return passthrough;
        }
    }
    class RandomAccessZipSource extends source_source_1.SourceSource {
        constructor(source, match = matchSupportedExtensions) {
            super(source);
            this.match = match;
            this.entries = [];
            this.ready = this.init();
        }
        async init() {
            await this.source.open();
            const sourceMetadata = await this.source.getMetadata();
            const reader = new SourceRandomAccessReader(this.source);
            this.zip = await utils_1.fromCallback(callback => {
                if (sourceMetadata.size === undefined) {
                    throw new errors_1.NotCapable;
                }
                yauzl_1.fromRandomAccessReader(reader, sourceMetadata.size, {
                    autoClose: false
                }, callback);
            });
            this.zip.on("entry", entry => {
                this.entries.push(entry);
            });
            await new Promise((resolve, reject) => {
                this.zip.on("end", resolve);
                this.zip.on("error", reject);
            });
        }
        async canCreateReadStream() {
            return true;
        }
        async canCreateSparseReadStream() {
            const metadata = await this.getMetadata();
            return metadata.blockMap !== undefined;
        }
        async getEntries() {
            await this.ready;
            return this.entries;
        }
        async getImageEntry() {
            const entries = (await this.getEntries()).filter(e => this.match(e.fileName));
            const entry = utils_1.maxBy(entries, e => e.uncompressedSize);
            if (entry === undefined) {
                throw new Error(constants_1.NO_MATCHING_FILE_MSG);
            }
            if (entry.compressionMethod !== 0 && entry.compressionMethod !== 8) {
                throw new Error(`unsupported compression method: ${entry.compressionMethod}`);
            }
            return entry;
        }
        async _open() {
            await this.ready;
            await this.getImageEntry();
        }
        async getEntryByName(name) {
            const entries = await this.getEntries();
            for (const entry of entries) {
                if (entry.fileName === name) {
                    return entry;
                }
            }
        }
        async getStream(name) {
            const entry = await this.getEntryByName(name);
            if (entry !== undefined) {
                return await utils_1.fromCallback(callback => {
                    this.zip.openReadStream(entry, callback);
                });
            }
        }
        async getString(name) {
            const stream = await this.getStream(name);
            if (stream !== undefined) {
                const buffer = await utils_1.streamToBuffer(stream);
                return buffer.toString();
            }
        }
        async getJson(name) {
            const data = await this.getString(name);
            if (data !== undefined) {
                return JSON.parse(data);
            }
        }
        async createReadStream({start = 0, end, alignment, numBuffers}) {
            if (start !== 0) {
                throw new errors_1.NotCapable;
            }
            const entry = await this.getImageEntry();
            const stream = await this.getStream(entry.fileName);
            if (stream === undefined) {
                throw new errors_1.NotCapable;
            }
            if (end !== undefined) {
                const transform = new stream_limiter_1.StreamLimiter(stream, end + 1);
                return block_transform_stream_1.BlockTransformStream.alignIfNeeded(transform, alignment, numBuffers);
            }
            return block_transform_stream_1.BlockTransformStream.alignIfNeeded(stream, alignment, numBuffers);
        }
        async createSparseReadStream({generateChecksums = false, alignment, numBuffers} = {}) {
            const metadata = await this.getMetadata();
            if (metadata.blocks === undefined) {
                throw new errors_1.NotCapable;
            }
            const transform = new sparse_filter_stream_1.SparseFilterStream({
                blocks: metadata.blocks,
                verify: !generateChecksums,
                generateChecksums
            });
            const stream = await this.createReadStream({
                alignment,
                numBuffers
            });
            stream.pipe(transform);
            return transform;
        }
        async _getMetadata() {
            const entry = await this.getImageEntry();
            const result = {
                size: entry.uncompressedSize,
                compressedSize: entry.compressedSize
            };
            const prefix = path_1.posix.join(path_1.posix.dirname(entry.fileName), ".meta");
            result.logo = await this.getString(path_1.posix.join(prefix, "logo.svg"));
            result.instructions = await this.getString(path_1.posix.join(prefix, "instructions.markdown"));
            const blockMap = await this.getString(path_1.posix.join(prefix, "image.bmap"));
            if (blockMap !== undefined) {
                result.blockMap = blockmap_1.BlockMap.parse(blockMap);
                result.blocks = blockmapToBlocks(result.blockMap);
                result.blockmappedSize = shared_1.blocksLength(result.blocks);
            }
            let manifest;
            try {
                manifest = await this.getJson(path_1.posix.join(prefix, "manifest.json"));
            } catch (error) {
                throw new Error("Invalid archive manifest.json");
            }
            let name;
            if (manifest !== undefined) {
                name = manifest.name;
                for (const key of RandomAccessZipSource.manifestFields) {
                    result[key] = manifest[key];
                }
            }
            result.name = name || path_1.posix.basename(entry.fileName);
            if (result.logo || result.instructions || result.blockMap || manifest) {
                result.isEtch = true;
            }
            return result;
        }
    }
    exports.RandomAccessZipSource = RandomAccessZipSource;
    RandomAccessZipSource.manifestFields = [ "bytesToZeroOutFromTheBeginning", "checksum", "checksumType", "recommendedDriveSize", "releaseNotesUrl", "supportUrl", "url", "version" ];
    class ZipSource extends source_source_1.SourceSource {
        constructor(source, preferStreamSource = false, match = matchSupportedExtensions) {
            super(source);
            this.preferStreamSource = preferStreamSource;
            this.match = match;
            this.ready = this.prepare();
        }
        async prepare() {
            if (!this.preferStreamSource && await this.source.canRead()) {
                this.implementation = new RandomAccessZipSource(this.source, this.match);
            } else {
                this.implementation = new StreamZipSource(this.source, this.match);
            }
        }
        async canCreateReadStream() {
            await this.ready;
            return await this.implementation.canCreateReadStream();
        }
        async open() {
            await this.ready;
            return await this.implementation.open();
        }
        async canCreateSparseReadStream() {
            await this.ready;
            return await this.implementation.canCreateSparseReadStream();
        }
        async createReadStream({emitProgress = false, start = 0, end, alignment, numBuffers} = {}) {
            await this.ready;
            const stream = await this.implementation.createReadStream({
                emitProgress,
                start,
                end
            });
            return block_transform_stream_1.BlockTransformStream.alignIfNeeded(stream, alignment, numBuffers);
        }
        async createSparseReadStream({generateChecksums = false, alignment, numBuffers} = {}) {
            await this.ready;
            return await this.implementation.createSparseReadStream({
                generateChecksums,
                alignment,
                numBuffers
            });
        }
        async _getMetadata() {
            await this.ready;
            const metadata = await this.implementation.getMetadata();
            return {
                ...metadata,
                isCompressed: true
            };
        }
    }
    exports.ZipSource = ZipSource;
    ZipSource.mimetype = "application/zip";
    source_destination_1.SourceDestination.register(ZipSource);
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.BlockMap = void 0;
    const crypto_1 = __webpack_require__(20);
    const xml_js_1 = __webpack_require__(107);
    const parse_1 = __webpack_require__(110);
    const range_1 = __webpack_require__(111);
    function xmlTag(tag, text) {
        return xml_js_1.js2xml({
            [tag]: {
                _text: text
            }
        }, {
            compact: true
        });
    }
    class BlockMap {
        constructor(options = {}) {
            this.version = options.version || "2.0";
            this.imageSize = options.imageSize || 0;
            this.blockSize = options.blockSize || 4096;
            this.blocksCount = options.blocksCount || 0;
            this.mappedBlocksCount = options.mappedBlocksCount || 0;
            this.checksum = options.checksum;
            this.checksumType = options.checksumType || "sha256";
            this.ranges = (options.ranges || []).map(range_1.Range.from);
        }
        injectChecksum(bmap) {
            const checksum = this.checksum || "";
            const zerofill = xmlTag("BmapFileChecksum", checksum.replace(/./g, "0"));
            const value = bmap.replace(xmlTag("BmapFileChecksum", checksum), zerofill);
            const digest = crypto_1.createHash(this.checksumType).update(value).digest("hex");
            return value.replace(zerofill, xmlTag("BmapFileChecksum", digest));
        }
        static fromJSON(data) {
            const options = typeof data === "string" ? JSON.parse(data) : data;
            return new BlockMap(options);
        }
        toString() {
            const ranges2 = this.ranges.map(range => {
                const blockRange = range.start !== range.end ? range.start + "-" + range.end : range.start;
                return {
                    _attributes: {
                        chksum: range.checksum
                    },
                    _text: blockRange
                };
            });
            const data2 = {
                _declaration: {
                    _attributes: {
                        version: "1.0",
                        encoding: "UTF-8"
                    }
                },
                bmap: {
                    _attributes: {
                        version: "2.0"
                    },
                    ImageSize: {
                        _text: this.imageSize
                    },
                    BlockSize: {
                        _text: this.blockSize
                    },
                    BlocksCount: {
                        _text: this.blocksCount
                    },
                    MappedBlocksCount: {
                        _text: this.mappedBlocksCount
                    },
                    ChecksumType: {
                        _text: this.checksumType
                    },
                    BmapFileChecksum: {
                        _text: this.checksum
                    },
                    BlockMap: {
                        Range: ranges2
                    }
                }
            };
            const bmap2 = xml_js_1.js2xml(data2, {
                compact: true,
                spaces: 2
            }) + "\n";
            return this.injectChecksum(bmap2);
        }
        static parse(value, verify = true) {
            return new BlockMap(parse_1.parse(value, verify));
        }
    }
    exports.BlockMap = BlockMap;
    BlockMap.versions = [ "1.2", "1.3", "1.4", "2.0" ];
}, function(module, exports, __webpack_require__) {
    var xml2js = __webpack_require__(108);
    var xml2json = __webpack_require__(221);
    var js2xml = __webpack_require__(109);
    var json2xml = __webpack_require__(222);
    module.exports = {
        xml2js,
        xml2json,
        js2xml,
        json2xml
    };
}, function(module, exports, __webpack_require__) {
    var sax = __webpack_require__(87);
    var expat = {
        on: function() {},
        parse: function() {}
    };
    var helper = __webpack_require__(59);
    var isArray = __webpack_require__(60).isArray;
    var options;
    var pureJsParser = true;
    var currentElement;
    function validateOptions(userOptions) {
        options = helper.copyOptions(userOptions);
        helper.ensureFlagExists("ignoreDeclaration", options);
        helper.ensureFlagExists("ignoreInstruction", options);
        helper.ensureFlagExists("ignoreAttributes", options);
        helper.ensureFlagExists("ignoreText", options);
        helper.ensureFlagExists("ignoreComment", options);
        helper.ensureFlagExists("ignoreCdata", options);
        helper.ensureFlagExists("ignoreDoctype", options);
        helper.ensureFlagExists("compact", options);
        helper.ensureFlagExists("alwaysChildren", options);
        helper.ensureFlagExists("addParent", options);
        helper.ensureFlagExists("trim", options);
        helper.ensureFlagExists("nativeType", options);
        helper.ensureFlagExists("nativeTypeAttributes", options);
        helper.ensureFlagExists("sanitize", options);
        helper.ensureFlagExists("instructionHasAttributes", options);
        helper.ensureFlagExists("captureSpacesBetweenElements", options);
        helper.ensureAlwaysArrayExists(options);
        helper.ensureKeyExists("declaration", options);
        helper.ensureKeyExists("instruction", options);
        helper.ensureKeyExists("attributes", options);
        helper.ensureKeyExists("text", options);
        helper.ensureKeyExists("comment", options);
        helper.ensureKeyExists("cdata", options);
        helper.ensureKeyExists("doctype", options);
        helper.ensureKeyExists("type", options);
        helper.ensureKeyExists("name", options);
        helper.ensureKeyExists("elements", options);
        helper.ensureKeyExists("parent", options);
        helper.checkFnExists("doctype", options);
        helper.checkFnExists("instruction", options);
        helper.checkFnExists("cdata", options);
        helper.checkFnExists("comment", options);
        helper.checkFnExists("text", options);
        helper.checkFnExists("instructionName", options);
        helper.checkFnExists("elementName", options);
        helper.checkFnExists("attributeName", options);
        helper.checkFnExists("attributeValue", options);
        helper.checkFnExists("attributes", options);
        return options;
    }
    function nativeType(value) {
        var nValue = Number(value);
        if (!isNaN(nValue)) {
            return nValue;
        }
        var bValue = value.toLowerCase();
        if (bValue === "true") {
            return true;
        } else if (bValue === "false") {
            return false;
        }
        return value;
    }
    function addField(type, value) {
        var key;
        if (options.compact) {
            if (!currentElement[options[type + "Key"]] && (isArray(options.alwaysArray) ? options.alwaysArray.indexOf(options[type + "Key"]) !== -1 : options.alwaysArray)) {
                currentElement[options[type + "Key"]] = [];
            }
            if (currentElement[options[type + "Key"]] && !isArray(currentElement[options[type + "Key"]])) {
                currentElement[options[type + "Key"]] = [ currentElement[options[type + "Key"]] ];
            }
            if (type + "Fn" in options && typeof value === "string") {
                value = options[type + "Fn"](value, currentElement);
            }
            if (type === "instruction" && ("instructionFn" in options || "instructionNameFn" in options)) {
                for (key in value) {
                    if (value.hasOwnProperty(key)) {
                        if ("instructionFn" in options) {
                            value[key] = options.instructionFn(value[key], key, currentElement);
                        } else {
                            var temp = value[key];
                            delete value[key];
                            value[options.instructionNameFn(key, temp, currentElement)] = temp;
                        }
                    }
                }
            }
            if (isArray(currentElement[options[type + "Key"]])) {
                currentElement[options[type + "Key"]].push(value);
            } else {
                currentElement[options[type + "Key"]] = value;
            }
        } else {
            if (!currentElement[options.elementsKey]) {
                currentElement[options.elementsKey] = [];
            }
            var element = {};
            element[options.typeKey] = type;
            if (type === "instruction") {
                for (key in value) {
                    if (value.hasOwnProperty(key)) {
                        break;
                    }
                }
                element[options.nameKey] = "instructionNameFn" in options ? options.instructionNameFn(key, value, currentElement) : key;
                if (options.instructionHasAttributes) {
                    element[options.attributesKey] = value[key][options.attributesKey];
                    if ("instructionFn" in options) {
                        element[options.attributesKey] = options.instructionFn(element[options.attributesKey], key, currentElement);
                    }
                } else {
                    if ("instructionFn" in options) {
                        value[key] = options.instructionFn(value[key], key, currentElement);
                    }
                    element[options.instructionKey] = value[key];
                }
            } else {
                if (type + "Fn" in options) {
                    value = options[type + "Fn"](value, currentElement);
                }
                element[options[type + "Key"]] = value;
            }
            if (options.addParent) {
                element[options.parentKey] = currentElement;
            }
            currentElement[options.elementsKey].push(element);
        }
    }
    function manipulateAttributes(attributes) {
        if ("attributesFn" in options && attributes) {
            attributes = options.attributesFn(attributes, currentElement);
        }
        if ((options.trim || "attributeValueFn" in options || "attributeNameFn" in options || options.nativeTypeAttributes) && attributes) {
            var key;
            for (key in attributes) {
                if (attributes.hasOwnProperty(key)) {
                    if (options.trim) attributes[key] = attributes[key].trim();
                    if (options.nativeTypeAttributes) {
                        attributes[key] = nativeType(attributes[key]);
                    }
                    if ("attributeValueFn" in options) attributes[key] = options.attributeValueFn(attributes[key], key, currentElement);
                    if ("attributeNameFn" in options) {
                        var temp = attributes[key];
                        delete attributes[key];
                        attributes[options.attributeNameFn(key, attributes[key], currentElement)] = temp;
                    }
                }
            }
        }
        return attributes;
    }
    function onInstruction(instruction) {
        var attributes = {};
        if (instruction.body && (instruction.name.toLowerCase() === "xml" || options.instructionHasAttributes)) {
            var attrsRegExp = /([\w:-]+)\s*=\s*(?:"([^"]*)"|'([^']*)'|(\w+))\s*/g;
            var match;
            while ((match = attrsRegExp.exec(instruction.body)) !== null) {
                attributes[match[1]] = match[2] || match[3] || match[4];
            }
            attributes = manipulateAttributes(attributes);
        }
        if (instruction.name.toLowerCase() === "xml") {
            if (options.ignoreDeclaration) {
                return;
            }
            currentElement[options.declarationKey] = {};
            if (Object.keys(attributes).length) {
                currentElement[options.declarationKey][options.attributesKey] = attributes;
            }
            if (options.addParent) {
                currentElement[options.declarationKey][options.parentKey] = currentElement;
            }
        } else {
            if (options.ignoreInstruction) {
                return;
            }
            if (options.trim) {
                instruction.body = instruction.body.trim();
            }
            var value = {};
            if (options.instructionHasAttributes && Object.keys(attributes).length) {
                value[instruction.name] = {};
                value[instruction.name][options.attributesKey] = attributes;
            } else {
                value[instruction.name] = instruction.body;
            }
            addField("instruction", value);
        }
    }
    function onStartElement(name, attributes) {
        var element;
        if (typeof name === "object") {
            attributes = name.attributes;
            name = name.name;
        }
        attributes = manipulateAttributes(attributes);
        if ("elementNameFn" in options) {
            name = options.elementNameFn(name, currentElement);
        }
        if (options.compact) {
            element = {};
            if (!options.ignoreAttributes && attributes && Object.keys(attributes).length) {
                element[options.attributesKey] = {};
                var key;
                for (key in attributes) {
                    if (attributes.hasOwnProperty(key)) {
                        element[options.attributesKey][key] = attributes[key];
                    }
                }
            }
            if (!(name in currentElement) && (isArray(options.alwaysArray) ? options.alwaysArray.indexOf(name) !== -1 : options.alwaysArray)) {
                currentElement[name] = [];
            }
            if (currentElement[name] && !isArray(currentElement[name])) {
                currentElement[name] = [ currentElement[name] ];
            }
            if (isArray(currentElement[name])) {
                currentElement[name].push(element);
            } else {
                currentElement[name] = element;
            }
        } else {
            if (!currentElement[options.elementsKey]) {
                currentElement[options.elementsKey] = [];
            }
            element = {};
            element[options.typeKey] = "element";
            element[options.nameKey] = name;
            if (!options.ignoreAttributes && attributes && Object.keys(attributes).length) {
                element[options.attributesKey] = attributes;
            }
            if (options.alwaysChildren) {
                element[options.elementsKey] = [];
            }
            currentElement[options.elementsKey].push(element);
        }
        element[options.parentKey] = currentElement;
        currentElement = element;
    }
    function onText(text) {
        if (options.ignoreText) {
            return;
        }
        if (!text.trim() && !options.captureSpacesBetweenElements) {
            return;
        }
        if (options.trim) {
            text = text.trim();
        }
        if (options.nativeType) {
            text = nativeType(text);
        }
        if (options.sanitize) {
            text = text.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
        }
        addField("text", text);
    }
    function onComment(comment) {
        if (options.ignoreComment) {
            return;
        }
        if (options.trim) {
            comment = comment.trim();
        }
        addField("comment", comment);
    }
    function onEndElement(name) {
        var parentElement = currentElement[options.parentKey];
        if (!options.addParent) {
            delete currentElement[options.parentKey];
        }
        currentElement = parentElement;
    }
    function onCdata(cdata) {
        if (options.ignoreCdata) {
            return;
        }
        if (options.trim) {
            cdata = cdata.trim();
        }
        addField("cdata", cdata);
    }
    function onDoctype(doctype) {
        if (options.ignoreDoctype) {
            return;
        }
        doctype = doctype.replace(/^ /, "");
        if (options.trim) {
            doctype = doctype.trim();
        }
        addField("doctype", doctype);
    }
    function onError(error) {
        error.note = error;
    }
    module.exports = function(xml, userOptions) {
        var parser = pureJsParser ? sax.parser(true, {}) : parser = new expat.Parser("UTF-8");
        var result = {};
        currentElement = result;
        options = validateOptions(userOptions);
        if (pureJsParser) {
            parser.opt = {
                strictEntities: true
            };
            parser.onopentag = onStartElement;
            parser.ontext = onText;
            parser.oncomment = onComment;
            parser.onclosetag = onEndElement;
            parser.onerror = onError;
            parser.oncdata = onCdata;
            parser.ondoctype = onDoctype;
            parser.onprocessinginstruction = onInstruction;
        } else {
            parser.on("startElement", onStartElement);
            parser.on("text", onText);
            parser.on("comment", onComment);
            parser.on("endElement", onEndElement);
            parser.on("error", onError);
        }
        if (pureJsParser) {
            parser.write(xml).close();
        } else {
            if (!parser.parse(xml)) {
                throw new Error("XML parsing error: " + parser.getError());
            }
        }
        if (result[options.elementsKey]) {
            var temp = result[options.elementsKey];
            delete result[options.elementsKey];
            result[options.elementsKey] = temp;
            delete result.text;
        }
        return result;
    };
}, function(module, exports, __webpack_require__) {
    var helper = __webpack_require__(59);
    var isArray = __webpack_require__(60).isArray;
    var currentElement, currentElementName;
    function validateOptions(userOptions) {
        var options = helper.copyOptions(userOptions);
        helper.ensureFlagExists("ignoreDeclaration", options);
        helper.ensureFlagExists("ignoreInstruction", options);
        helper.ensureFlagExists("ignoreAttributes", options);
        helper.ensureFlagExists("ignoreText", options);
        helper.ensureFlagExists("ignoreComment", options);
        helper.ensureFlagExists("ignoreCdata", options);
        helper.ensureFlagExists("ignoreDoctype", options);
        helper.ensureFlagExists("compact", options);
        helper.ensureFlagExists("indentText", options);
        helper.ensureFlagExists("indentCdata", options);
        helper.ensureFlagExists("indentAttributes", options);
        helper.ensureFlagExists("indentInstruction", options);
        helper.ensureFlagExists("fullTagEmptyElement", options);
        helper.ensureFlagExists("noQuotesForNativeAttributes", options);
        helper.ensureSpacesExists(options);
        if (typeof options.spaces === "number") {
            options.spaces = Array(options.spaces + 1).join(" ");
        }
        helper.ensureKeyExists("declaration", options);
        helper.ensureKeyExists("instruction", options);
        helper.ensureKeyExists("attributes", options);
        helper.ensureKeyExists("text", options);
        helper.ensureKeyExists("comment", options);
        helper.ensureKeyExists("cdata", options);
        helper.ensureKeyExists("doctype", options);
        helper.ensureKeyExists("type", options);
        helper.ensureKeyExists("name", options);
        helper.ensureKeyExists("elements", options);
        helper.checkFnExists("doctype", options);
        helper.checkFnExists("instruction", options);
        helper.checkFnExists("cdata", options);
        helper.checkFnExists("comment", options);
        helper.checkFnExists("text", options);
        helper.checkFnExists("instructionName", options);
        helper.checkFnExists("elementName", options);
        helper.checkFnExists("attributeName", options);
        helper.checkFnExists("attributeValue", options);
        helper.checkFnExists("attributes", options);
        helper.checkFnExists("fullTagEmptyElement", options);
        return options;
    }
    function writeIndentation(options, depth, firstLine) {
        return (!firstLine && options.spaces ? "\n" : "") + Array(depth + 1).join(options.spaces);
    }
    function writeAttributes(attributes, options, depth) {
        if (options.ignoreAttributes) {
            return "";
        }
        if ("attributesFn" in options) {
            attributes = options.attributesFn(attributes, currentElementName, currentElement);
        }
        var key, attr, attrName, quote, result = [];
        for (key in attributes) {
            if (attributes.hasOwnProperty(key) && attributes[key] !== null && attributes[key] !== undefined) {
                quote = options.noQuotesForNativeAttributes && typeof attributes[key] !== "string" ? "" : '"';
                attr = "" + attributes[key];
                attr = attr.replace(/"/g, "&quot;");
                attrName = "attributeNameFn" in options ? options.attributeNameFn(key, attr, currentElementName, currentElement) : key;
                result.push(options.spaces && options.indentAttributes ? writeIndentation(options, depth + 1, false) : " ");
                result.push(attrName + "=" + quote + ("attributeValueFn" in options ? options.attributeValueFn(attr, key, currentElementName, currentElement) : attr) + quote);
            }
        }
        if (attributes && Object.keys(attributes).length && options.spaces && options.indentAttributes) {
            result.push(writeIndentation(options, depth, false));
        }
        return result.join("");
    }
    function writeDeclaration(declaration, options, depth) {
        currentElement = declaration;
        currentElementName = "xml";
        return options.ignoreDeclaration ? "" : "<?" + "xml" + writeAttributes(declaration[options.attributesKey], options, depth) + "?>";
    }
    function writeInstruction(instruction, options, depth) {
        if (options.ignoreInstruction) {
            return "";
        }
        var key;
        for (key in instruction) {
            if (instruction.hasOwnProperty(key)) {
                break;
            }
        }
        var instructionName = "instructionNameFn" in options ? options.instructionNameFn(key, instruction[key], currentElementName, currentElement) : key;
        if (typeof instruction[key] === "object") {
            currentElement = instruction;
            currentElementName = instructionName;
            return "<?" + instructionName + writeAttributes(instruction[key][options.attributesKey], options, depth) + "?>";
        } else {
            var instructionValue = instruction[key] ? instruction[key] : "";
            if ("instructionFn" in options) instructionValue = options.instructionFn(instructionValue, key, currentElementName, currentElement);
            return "<?" + instructionName + (instructionValue ? " " + instructionValue : "") + "?>";
        }
    }
    function writeComment(comment, options) {
        return options.ignoreComment ? "" : "\x3c!--" + ("commentFn" in options ? options.commentFn(comment, currentElementName, currentElement) : comment) + "--\x3e";
    }
    function writeCdata(cdata, options) {
        return options.ignoreCdata ? "" : "<![CDATA[" + ("cdataFn" in options ? options.cdataFn(cdata, currentElementName, currentElement) : cdata.replace("]]>", "]]]]><![CDATA[>")) + "]]>";
    }
    function writeDoctype(doctype, options) {
        return options.ignoreDoctype ? "" : "<!DOCTYPE " + ("doctypeFn" in options ? options.doctypeFn(doctype, currentElementName, currentElement) : doctype) + ">";
    }
    function writeText(text, options) {
        if (options.ignoreText) return "";
        text = "" + text;
        text = text.replace(/&amp;/g, "&");
        text = text.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
        return "textFn" in options ? options.textFn(text, currentElementName, currentElement) : text;
    }
    function hasContent(element, options) {
        var i;
        if (element.elements && element.elements.length) {
            for (i = 0; i < element.elements.length; ++i) {
                switch (element.elements[i][options.typeKey]) {
                  case "text":
                    if (options.indentText) {
                        return true;
                    }
                    break;

                  case "cdata":
                    if (options.indentCdata) {
                        return true;
                    }
                    break;

                  case "instruction":
                    if (options.indentInstruction) {
                        return true;
                    }
                    break;

                  case "doctype":
                  case "comment":
                  case "element":
                    return true;

                  default:
                    return true;
                }
            }
        }
        return false;
    }
    function writeElement(element, options, depth) {
        currentElement = element;
        currentElementName = element.name;
        var xml = [], elementName = "elementNameFn" in options ? options.elementNameFn(element.name, element) : element.name;
        xml.push("<" + elementName);
        if (element[options.attributesKey]) {
            xml.push(writeAttributes(element[options.attributesKey], options, depth));
        }
        var withClosingTag = element[options.elementsKey] && element[options.elementsKey].length || element[options.attributesKey] && element[options.attributesKey]["xml:space"] === "preserve";
        if (!withClosingTag) {
            if ("fullTagEmptyElementFn" in options) {
                withClosingTag = options.fullTagEmptyElementFn(element.name, element);
            } else {
                withClosingTag = options.fullTagEmptyElement;
            }
        }
        if (withClosingTag) {
            xml.push(">");
            if (element[options.elementsKey] && element[options.elementsKey].length) {
                xml.push(writeElements(element[options.elementsKey], options, depth + 1));
                currentElement = element;
                currentElementName = element.name;
            }
            xml.push(options.spaces && hasContent(element, options) ? "\n" + Array(depth + 1).join(options.spaces) : "");
            xml.push("</" + elementName + ">");
        } else {
            xml.push("/>");
        }
        return xml.join("");
    }
    function writeElements(elements, options, depth, firstLine) {
        return elements.reduce((function(xml, element) {
            var indent = writeIndentation(options, depth, firstLine && !xml);
            switch (element.type) {
              case "element":
                return xml + indent + writeElement(element, options, depth);

              case "comment":
                return xml + indent + writeComment(element[options.commentKey], options);

              case "doctype":
                return xml + indent + writeDoctype(element[options.doctypeKey], options);

              case "cdata":
                return xml + (options.indentCdata ? indent : "") + writeCdata(element[options.cdataKey], options);

              case "text":
                return xml + (options.indentText ? indent : "") + writeText(element[options.textKey], options);

              case "instruction":
                var instruction = {};
                instruction[element[options.nameKey]] = element[options.attributesKey] ? element : element[options.instructionKey];
                return xml + (options.indentInstruction ? indent : "") + writeInstruction(instruction, options, depth);
            }
        }), "");
    }
    function hasContentCompact(element, options, anyContent) {
        var key;
        for (key in element) {
            if (element.hasOwnProperty(key)) {
                switch (key) {
                  case options.parentKey:
                  case options.attributesKey:
                    break;

                  case options.textKey:
                    if (options.indentText || anyContent) {
                        return true;
                    }
                    break;

                  case options.cdataKey:
                    if (options.indentCdata || anyContent) {
                        return true;
                    }
                    break;

                  case options.instructionKey:
                    if (options.indentInstruction || anyContent) {
                        return true;
                    }
                    break;

                  case options.doctypeKey:
                  case options.commentKey:
                    return true;

                  default:
                    return true;
                }
            }
        }
        return false;
    }
    function writeElementCompact(element, name, options, depth, indent) {
        currentElement = element;
        currentElementName = name;
        var elementName = "elementNameFn" in options ? options.elementNameFn(name, element) : name;
        if (typeof element === "undefined" || element === null || element === "") {
            return "fullTagEmptyElementFn" in options && options.fullTagEmptyElementFn(name, element) || options.fullTagEmptyElement ? "<" + elementName + "></" + elementName + ">" : "<" + elementName + "/>";
        }
        var xml = [];
        if (name) {
            xml.push("<" + elementName);
            if (typeof element !== "object") {
                xml.push(">" + writeText(element, options) + "</" + elementName + ">");
                return xml.join("");
            }
            if (element[options.attributesKey]) {
                xml.push(writeAttributes(element[options.attributesKey], options, depth));
            }
            var withClosingTag = hasContentCompact(element, options, true) || element[options.attributesKey] && element[options.attributesKey]["xml:space"] === "preserve";
            if (!withClosingTag) {
                if ("fullTagEmptyElementFn" in options) {
                    withClosingTag = options.fullTagEmptyElementFn(name, element);
                } else {
                    withClosingTag = options.fullTagEmptyElement;
                }
            }
            if (withClosingTag) {
                xml.push(">");
            } else {
                xml.push("/>");
                return xml.join("");
            }
        }
        xml.push(writeElementsCompact(element, options, depth + 1, false));
        currentElement = element;
        currentElementName = name;
        if (name) {
            xml.push((indent ? writeIndentation(options, depth, false) : "") + "</" + elementName + ">");
        }
        return xml.join("");
    }
    function writeElementsCompact(element, options, depth, firstLine) {
        var i, key, nodes, xml = [];
        for (key in element) {
            if (element.hasOwnProperty(key)) {
                nodes = isArray(element[key]) ? element[key] : [ element[key] ];
                for (i = 0; i < nodes.length; ++i) {
                    switch (key) {
                      case options.declarationKey:
                        xml.push(writeDeclaration(nodes[i], options, depth));
                        break;

                      case options.instructionKey:
                        xml.push((options.indentInstruction ? writeIndentation(options, depth, firstLine) : "") + writeInstruction(nodes[i], options, depth));
                        break;

                      case options.attributesKey:
                      case options.parentKey:
                        break;

                      case options.textKey:
                        xml.push((options.indentText ? writeIndentation(options, depth, firstLine) : "") + writeText(nodes[i], options));
                        break;

                      case options.cdataKey:
                        xml.push((options.indentCdata ? writeIndentation(options, depth, firstLine) : "") + writeCdata(nodes[i], options));
                        break;

                      case options.doctypeKey:
                        xml.push(writeIndentation(options, depth, firstLine) + writeDoctype(nodes[i], options));
                        break;

                      case options.commentKey:
                        xml.push(writeIndentation(options, depth, firstLine) + writeComment(nodes[i], options));
                        break;

                      default:
                        xml.push(writeIndentation(options, depth, firstLine) + writeElementCompact(nodes[i], key, options, depth, hasContentCompact(nodes[i], options)));
                    }
                    firstLine = firstLine && !xml.length;
                }
            }
        }
        return xml.join("");
    }
    module.exports = function(js, options) {
        options = validateOptions(options);
        var xml = [];
        currentElement = js;
        currentElementName = "_root_";
        if (options.compact) {
            xml.push(writeElementsCompact(js, options, 0, true));
        } else {
            if (js[options.declarationKey]) {
                xml.push(writeDeclaration(js[options.declarationKey], options, 0));
            }
            if (js[options.elementsKey] && js[options.elementsKey].length) {
                xml.push(writeElements(js[options.elementsKey], options, 0, !xml.length));
            }
        }
        return xml.join("");
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.parse = void 0;
    const crypto_1 = __webpack_require__(20);
    const xml_js_1 = __webpack_require__(107);
    const blockmap_1 = __webpack_require__(106);
    function firstChild(element, name) {
        if (element.elements !== undefined) {
            return element.elements.find(e => e.name === name);
        }
    }
    function firstChildThrow(element, name) {
        const result = firstChild(element, name);
        if (result === undefined) {
            throw new Error(`Missing tag "${name}"`);
        }
        return result;
    }
    function getAttribute(element, name) {
        if (element.attributes !== undefined) {
            return element.attributes[name];
        }
    }
    function getAttributeThrow(element, name) {
        const result = getAttribute(element, name);
        if (result === undefined) {
            throw new Error(`Missing attribute "${name}"`);
        }
        return result;
    }
    function getText(element) {
        if (Array.isArray(element)) {
            return element.map(getText).join("");
        }
        if (element.type === "element") {
            return getText(element.elements || []);
        }
        if (element.type === "text" && element.text !== undefined) {
            return "" + element.text;
        }
        return "";
    }
    function textContentThrow(element, name) {
        return getText(firstChildThrow(element, name)).trim();
    }
    function textContent(element, name) {
        const child = firstChild(element, name);
        if (child !== undefined) {
            return getText(child).trim();
        }
    }
    function getRanges(element) {
        const ranges = [];
        for (const node of element.elements || []) {
            if (node.type === "element" && node.name !== undefined && node.name.toLowerCase() === "range") {
                const [start, end] = getText(node).trim().split("-");
                const checksum = getAttribute(node, "sha1") || getAttribute(node, "chksum");
                if (checksum === undefined) {
                    throw new Error("No checksum in range");
                }
                if (typeof checksum !== "string") {
                    throw new Error("Checksum is not a string");
                }
                const range = {
                    start: parseInt(start, 10),
                    end: parseInt(end || start, 10),
                    checksum
                };
                ranges.push(range);
            }
        }
        return ranges;
    }
    function maskChecksum(value) {
        const pattern = /BmapFileChecksum/.test(value) ? /(<BmapFileChecksum>\s*)([a-z0-9]+)(\s*<\/BmapFileChecksum>)/i : /(<BmapFileSHA1>\s*)([a-z0-9]+)(\s*<\/BmapFileSHA1>)/i;
        return value.replace(pattern, (_match, start, checksum, end) => start + checksum.replace(/./g, "0") + end);
    }
    function parse(value, verify = true) {
        value = value.toString();
        const data = xml_js_1.xml2js(value, {
            compact: false
        });
        const bmap = firstChildThrow(data, "bmap");
        const version = getAttributeThrow(bmap, "version");
        if (typeof version !== "string") {
            throw new Error(`Version is not a string: ${version}`);
        }
        if (!blockmap_1.BlockMap.versions.includes(version)) {
            throw new Error(`Unsupported block map version "${version}"`);
        }
        const imageSize = parseInt(textContentThrow(bmap, "ImageSize"), 10);
        const blockSize = parseInt(textContentThrow(bmap, "BlockSize"), 10);
        const blocksCount = parseInt(textContentThrow(bmap, "BlocksCount"), 10);
        const mappedBlocksCount = parseInt(textContentThrow(bmap, "MappedBlocksCount"), 10);
        const checksum = textContent(bmap, "BmapFileChecksum") || textContent(bmap, "BmapFileSHA1");
        const checksumType = textContent(bmap, "ChecksumType") || "sha1";
        const map = firstChildThrow(bmap, "BlockMap");
        const ranges = getRanges(map);
        if (verify && checksum !== undefined) {
            const file = maskChecksum(value);
            const digest = crypto_1.createHash(checksumType).update(file).digest("hex");
            if (checksum !== digest) {
                throw new Error(`File checksum mismatch: ${checksum} != ${digest}`);
            }
        }
        return {
            version,
            imageSize,
            blockSize,
            blocksCount,
            mappedBlocksCount,
            checksum,
            checksumType,
            ranges
        };
    }
    exports.parse = parse;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.Range = void 0;
    class Range {
        constructor(start = 0, end = 0, checksum) {
            this.start = start;
            this.end = end;
            this.checksum = checksum;
        }
        static from(value) {
            return new Range(value.start, value.end, value.checksum);
        }
        get length() {
            return this.end - this.start + 1;
        }
        set length(value) {
            this.end = this.start + value - 1;
        }
    }
    exports.Range = Range;
}, function(module, exports, __webpack_require__) {
    "use strict";
    var binary = __webpack_require__(233);
    var stream = __webpack_require__(0);
    var util = __webpack_require__(1);
    var zlib = __webpack_require__(18);
    var MatcherStream = __webpack_require__(238);
    var Entry = __webpack_require__(239);
    const states = {
        STREAM_START: 0,
        START: 1,
        LOCAL_FILE_HEADER: 2,
        LOCAL_FILE_HEADER_SUFFIX: 3,
        FILE_DATA: 4,
        FILE_DATA_END: 5,
        DATA_DESCRIPTOR: 6,
        CENTRAL_DIRECTORY_FILE_HEADER: 7,
        CENTRAL_DIRECTORY_FILE_HEADER_SUFFIX: 8,
        CDIR64_END: 9,
        CDIR64_END_DATA_SECTOR: 10,
        CDIR64_LOCATOR: 11,
        CENTRAL_DIRECTORY_END: 12,
        CENTRAL_DIRECTORY_END_COMMENT: 13,
        TRAILING_JUNK: 14,
        ERROR: 99
    };
    const FOUR_GIGS = 4294967296;
    const SIG_LOCAL_FILE_HEADER = 67324752;
    const SIG_DATA_DESCRIPTOR = 134695760;
    const SIG_CDIR_RECORD = 33639248;
    const SIG_CDIR64_RECORD_END = 101075792;
    const SIG_CDIR64_LOCATOR_END = 117853008;
    const SIG_CDIR_RECORD_END = 101010256;
    function UnzipStream(options) {
        if (!(this instanceof UnzipStream)) {
            return new UnzipStream(options);
        }
        stream.Transform.call(this);
        this.options = options || {};
        this.data = new Buffer("");
        this.state = states.STREAM_START;
        this.skippedBytes = 0;
        this.parsedEntity = null;
        this.outStreamInfo = {};
    }
    util.inherits(UnzipStream, stream.Transform);
    UnzipStream.prototype.processDataChunk = function(chunk) {
        var requiredLength;
        switch (this.state) {
          case states.STREAM_START:
          case states.START:
            requiredLength = 4;
            break;

          case states.LOCAL_FILE_HEADER:
            requiredLength = 26;
            break;

          case states.LOCAL_FILE_HEADER_SUFFIX:
            requiredLength = this.parsedEntity.fileNameLength + this.parsedEntity.extraFieldLength;
            break;

          case states.DATA_DESCRIPTOR:
            requiredLength = 12;
            break;

          case states.CENTRAL_DIRECTORY_FILE_HEADER:
            requiredLength = 42;
            break;

          case states.CENTRAL_DIRECTORY_FILE_HEADER_SUFFIX:
            requiredLength = this.parsedEntity.fileNameLength + this.parsedEntity.extraFieldLength + this.parsedEntity.fileCommentLength;
            break;

          case states.CDIR64_END:
            requiredLength = 52;
            break;

          case states.CDIR64_END_DATA_SECTOR:
            requiredLength = this.parsedEntity.centralDirectoryRecordSize - 44;
            break;

          case states.CDIR64_LOCATOR:
            requiredLength = 16;
            break;

          case states.CENTRAL_DIRECTORY_END:
            requiredLength = 18;
            break;

          case states.CENTRAL_DIRECTORY_END_COMMENT:
            requiredLength = this.parsedEntity.commentLength;
            break;

          case states.FILE_DATA:
            return 0;

          case states.FILE_DATA_END:
            return 0;

          case states.TRAILING_JUNK:
            if (this.options.debug) console.log("found", chunk.length, "bytes of TRAILING_JUNK");
            return chunk.length;

          default:
            return chunk.length;
        }
        var chunkLength = chunk.length;
        if (chunkLength < requiredLength) {
            return 0;
        }
        switch (this.state) {
          case states.STREAM_START:
          case states.START:
            var signature = chunk.readUInt32LE(0);
            switch (signature) {
              case SIG_LOCAL_FILE_HEADER:
                this.state = states.LOCAL_FILE_HEADER;
                break;

              case SIG_CDIR_RECORD:
                this.state = states.CENTRAL_DIRECTORY_FILE_HEADER;
                break;

              case SIG_CDIR64_RECORD_END:
                this.state = states.CDIR64_END;
                break;

              case SIG_CDIR64_LOCATOR_END:
                this.state = states.CDIR64_LOCATOR;
                break;

              case SIG_CDIR_RECORD_END:
                this.state = states.CENTRAL_DIRECTORY_END;
                break;

              default:
                var isStreamStart = this.state === states.STREAM_START;
                if (!isStreamStart && (signature & 65535) !== 19280 && this.skippedBytes < 26) {
                    var remaining = signature;
                    var toSkip = 4;
                    for (var i = 1; i < 4 && remaining !== 0; i++) {
                        remaining = remaining >>> 8;
                        if ((remaining & 255) === 80) {
                            toSkip = i;
                            break;
                        }
                    }
                    this.skippedBytes += toSkip;
                    if (this.options.debug) console.log("Skipped", this.skippedBytes, "bytes");
                    return toSkip;
                }
                this.state = states.ERROR;
                var errMsg = isStreamStart ? "Not a valid zip file" : "Invalid signature in zip file";
                if (this.options.debug) {
                    var sig = chunk.readUInt32LE(0);
                    var asString;
                    try {
                        asString = chunk.slice(0, 4).toString();
                    } catch (e) {}
                    console.log("Unexpected signature in zip file: 0x" + sig.toString(16), '"' + asString + '", skipped', this.skippedBytes, "bytes");
                }
                this.emit("error", new Error(errMsg));
                return chunk.length;
            }
            this.skippedBytes = 0;
            return requiredLength;

          case states.LOCAL_FILE_HEADER:
            this.parsedEntity = this._readFile(chunk);
            this.state = states.LOCAL_FILE_HEADER_SUFFIX;
            return requiredLength;

          case states.LOCAL_FILE_HEADER_SUFFIX:
            var entry = new Entry;
            var isUtf8 = (this.parsedEntity.flags & 2048) !== 0;
            entry.path = this._decodeString(chunk.slice(0, this.parsedEntity.fileNameLength), isUtf8);
            var extraDataBuffer = chunk.slice(this.parsedEntity.fileNameLength, this.parsedEntity.fileNameLength + this.parsedEntity.extraFieldLength);
            var extra = this._readExtraFields(extraDataBuffer);
            if (extra && extra.parsed) {
                if (extra.parsed.path && !isUtf8) {
                    entry.path = extra.parsed.path;
                }
                if (Number.isFinite(extra.parsed.uncompressedSize) && this.parsedEntity.uncompressedSize === FOUR_GIGS - 1) {
                    this.parsedEntity.uncompressedSize = extra.parsed.uncompressedSize;
                }
                if (Number.isFinite(extra.parsed.compressedSize) && this.parsedEntity.compressedSize === FOUR_GIGS - 1) {
                    this.parsedEntity.compressedSize = extra.parsed.compressedSize;
                }
            }
            this.parsedEntity.extra = extra.parsed || {};
            if (this.options.debug) {
                const debugObj = Object.assign({}, this.parsedEntity, {
                    path: entry.path,
                    flags: "0x" + this.parsedEntity.flags.toString(16),
                    extraFields: extra && extra.debug
                });
                console.log("decoded LOCAL_FILE_HEADER:", JSON.stringify(debugObj, null, 2));
            }
            this._prepareOutStream(this.parsedEntity, entry);
            this.emit("entry", entry);
            this.state = states.FILE_DATA;
            return requiredLength;

          case states.CENTRAL_DIRECTORY_FILE_HEADER:
            this.parsedEntity = this._readCentralDirectoryEntry(chunk);
            this.state = states.CENTRAL_DIRECTORY_FILE_HEADER_SUFFIX;
            return requiredLength;

          case states.CENTRAL_DIRECTORY_FILE_HEADER_SUFFIX:
            var isUtf8 = (this.parsedEntity.flags & 2048) !== 0;
            var path = this._decodeString(chunk.slice(0, this.parsedEntity.fileNameLength), isUtf8);
            var extraDataBuffer = chunk.slice(this.parsedEntity.fileNameLength, this.parsedEntity.fileNameLength + this.parsedEntity.extraFieldLength);
            var extra = this._readExtraFields(extraDataBuffer);
            if (extra && extra.parsed && extra.parsed.path && !isUtf8) {
                path = extra.parsed.path;
            }
            this.parsedEntity.extra = extra.parsed;
            var isUnix = (this.parsedEntity.versionMadeBy & 65280) >> 8 === 3;
            var unixAttrs, isSymlink;
            if (isUnix) {
                unixAttrs = this.parsedEntity.externalFileAttributes >>> 16;
                var fileType = unixAttrs >>> 12;
                isSymlink = (fileType & 10) === 10;
            }
            if (this.options.debug) {
                const debugObj = Object.assign({}, this.parsedEntity, {
                    path,
                    flags: "0x" + this.parsedEntity.flags.toString(16),
                    unixAttrs: unixAttrs && "0" + unixAttrs.toString(8),
                    isSymlink,
                    extraFields: extra.debug
                });
                console.log("decoded CENTRAL_DIRECTORY_FILE_HEADER:", JSON.stringify(debugObj, null, 2));
            }
            this.state = states.START;
            return requiredLength;

          case states.CDIR64_END:
            this.parsedEntity = this._readEndOfCentralDirectory64(chunk);
            if (this.options.debug) {
                console.log("decoded CDIR64_END_RECORD:", this.parsedEntity);
            }
            this.state = states.CDIR64_END_DATA_SECTOR;
            return requiredLength;

          case states.CDIR64_END_DATA_SECTOR:
            this.state = states.START;
            return requiredLength;

          case states.CDIR64_LOCATOR:
            this.state = states.START;
            return requiredLength;

          case states.CENTRAL_DIRECTORY_END:
            this.parsedEntity = this._readEndOfCentralDirectory(chunk);
            if (this.options.debug) {
                console.log("decoded CENTRAL_DIRECTORY_END:", this.parsedEntity);
            }
            this.state = states.CENTRAL_DIRECTORY_END_COMMENT;
            return requiredLength;

          case states.CENTRAL_DIRECTORY_END_COMMENT:
            if (this.options.debug) {
                console.log("decoded CENTRAL_DIRECTORY_END_COMMENT:", chunk.slice(0, requiredLength).toString());
            }
            this.state = states.TRAILING_JUNK;
            return requiredLength;

          case states.ERROR:
            return chunk.length;

          default:
            console.log("didn't handle state #", this.state, "discarding");
            return chunk.length;
        }
    };
    UnzipStream.prototype._prepareOutStream = function(vars, entry) {
        var self = this;
        var isDirectory = vars.uncompressedSize === 0 && /[\/\\]$/.test(entry.path);
        entry.path = entry.path.replace(/^([/\\]*[.]+[/\\]+)*[/\\]*/, "");
        entry.type = isDirectory ? "Directory" : "File";
        entry.isDirectory = isDirectory;
        var fileSizeKnown = !(vars.flags & 8);
        if (fileSizeKnown) {
            entry.size = vars.uncompressedSize;
        }
        var isVersionSupported = vars.versionsNeededToExtract <= 45;
        this.outStreamInfo = {
            stream: null,
            limit: fileSizeKnown ? vars.compressedSize : -1,
            written: 0
        };
        if (!fileSizeKnown) {
            var pattern = new Buffer(4);
            pattern.writeUInt32LE(SIG_DATA_DESCRIPTOR, 0);
            var zip64Mode = vars.extra.zip64Mode;
            var extraSize = zip64Mode ? 20 : 12;
            var searchPattern = {
                pattern,
                requiredExtraSize: extraSize
            };
            var matcherStream = new MatcherStream(searchPattern, (function(matchedChunk, sizeSoFar) {
                var vars = self._readDataDescriptor(matchedChunk, zip64Mode);
                var compressedSizeMatches = vars.compressedSize === sizeSoFar;
                if (!zip64Mode && !compressedSizeMatches && sizeSoFar >= FOUR_GIGS) {
                    var overflown = sizeSoFar - FOUR_GIGS;
                    while (overflown >= 0) {
                        compressedSizeMatches = vars.compressedSize === overflown;
                        if (compressedSizeMatches) break;
                        overflown -= FOUR_GIGS;
                    }
                }
                if (!compressedSizeMatches) {
                    return;
                }
                self.state = states.FILE_DATA_END;
                var sliceOffset = zip64Mode ? 24 : 16;
                if (self.data.length > 0) {
                    self.data = Buffer.concat([ matchedChunk.slice(sliceOffset), self.data ]);
                } else {
                    self.data = matchedChunk.slice(sliceOffset);
                }
                return true;
            }));
            this.outStreamInfo.stream = matcherStream;
        } else {
            this.outStreamInfo.stream = new stream.PassThrough;
        }
        var isEncrypted = vars.flags & 1 || vars.flags & 64;
        if (isEncrypted || !isVersionSupported) {
            var message = isEncrypted ? "Encrypted files are not supported!" : "Zip version " + Math.floor(vars.versionsNeededToExtract / 10) + "." + vars.versionsNeededToExtract % 10 + " is not supported";
            entry.skip = true;
            setImmediate(() => {
                entry.emit("error", new Error(message));
            });
            this.outStreamInfo.stream.pipe((new Entry).autodrain());
            return;
        }
        var isCompressed = vars.compressionMethod > 0;
        if (isCompressed) {
            var inflater = zlib.createInflateRaw();
            inflater.on("error", (function(err) {
                self.state = states.ERROR;
                self.emit("error", err);
            }));
            this.outStreamInfo.stream.pipe(inflater).pipe(entry);
        } else {
            this.outStreamInfo.stream.pipe(entry);
        }
        if (this._drainAllEntries) {
            entry.autodrain();
        }
    };
    UnzipStream.prototype._readFile = function(data) {
        var vars = binary.parse(data).word16lu("versionsNeededToExtract").word16lu("flags").word16lu("compressionMethod").word16lu("lastModifiedTime").word16lu("lastModifiedDate").word32lu("crc32").word32lu("compressedSize").word32lu("uncompressedSize").word16lu("fileNameLength").word16lu("extraFieldLength").vars;
        return vars;
    };
    UnzipStream.prototype._readExtraFields = function(data) {
        var extra = {};
        var result = {
            parsed: extra
        };
        if (this.options.debug) {
            result.debug = [];
        }
        var index = 0;
        while (index < data.length) {
            var vars = binary.parse(data).skip(index).word16lu("extraId").word16lu("extraSize").vars;
            index += 4;
            var fieldType = undefined;
            switch (vars.extraId) {
              case 1:
                fieldType = "Zip64 extended information extra field";
                var z64vars = binary.parse(data.slice(index, index + vars.extraSize)).word64lu("uncompressedSize").word64lu("compressedSize").word64lu("offsetToLocalHeader").word32lu("diskStartNumber").vars;
                if (z64vars.uncompressedSize !== null) {
                    extra.uncompressedSize = z64vars.uncompressedSize;
                }
                if (z64vars.compressedSize !== null) {
                    extra.compressedSize = z64vars.compressedSize;
                }
                extra.zip64Mode = true;
                break;

              case 10:
                fieldType = "NTFS extra field";
                break;

              case 21589:
                fieldType = "extended timestamp";
                var timestampFields = data.readUInt8(index);
                var offset = 1;
                if (timestampFields & 1) {
                    extra.mtime = new Date(data.readUInt32LE(index + offset) * 1e3);
                    offset += 4;
                }
                if (timestampFields & 2) {
                    extra.atime = new Date(data.readUInt32LE(index + offset) * 1e3);
                    offset += 4;
                }
                if (timestampFields & 4) {
                    extra.ctime = new Date(data.readUInt32LE(index + offset) * 1e3);
                }
                break;

              case 28789:
                fieldType = "Info-ZIP Unicode Path Extra Field";
                var fieldVer = data.readUInt8(index);
                if (fieldVer === 1) {
                    var offset = 1;
                    var nameCrc32 = data.readUInt32LE(index + offset);
                    offset += 4;
                    var pathBuffer = data.slice(index + offset);
                    extra.path = pathBuffer.toString();
                }
                break;

              case 13:
              case 22613:
                fieldType = vars.extraId === 13 ? "PKWARE Unix" : "Info-ZIP UNIX (type 1)";
                var offset = 0;
                if (vars.extraSize >= 8) {
                    var atime = new Date(data.readUInt32LE(index + offset) * 1e3);
                    offset += 4;
                    var mtime = new Date(data.readUInt32LE(index + offset) * 1e3);
                    offset += 4;
                    extra.atime = atime;
                    extra.mtime = mtime;
                    if (vars.extraSize >= 12) {
                        var uid = data.readUInt16LE(index + offset);
                        offset += 2;
                        var gid = data.readUInt16LE(index + offset);
                        offset += 2;
                        extra.uid = uid;
                        extra.gid = gid;
                    }
                }
                break;

              case 30805:
                fieldType = "Info-ZIP UNIX (type 2)";
                var offset = 0;
                if (vars.extraSize >= 4) {
                    var uid = data.readUInt16LE(index + offset);
                    offset += 2;
                    var gid = data.readUInt16LE(index + offset);
                    offset += 2;
                    extra.uid = uid;
                    extra.gid = gid;
                }
                break;

              case 30837:
                fieldType = "Info-ZIP New Unix";
                var offset = 0;
                var extraVer = data.readUInt8(index);
                offset += 1;
                if (extraVer === 1) {
                    var uidSize = data.readUInt8(index + offset);
                    offset += 1;
                    if (uidSize <= 6) {
                        extra.uid = data.readUIntLE(index + offset, uidSize);
                    }
                    offset += uidSize;
                    var gidSize = data.readUInt8(index + offset);
                    offset += 1;
                    if (gidSize <= 6) {
                        extra.gid = data.readUIntLE(index + offset, gidSize);
                    }
                }
                break;

              case 30062:
                fieldType = "ASi Unix";
                var offset = 0;
                if (vars.extraSize >= 14) {
                    var crc = data.readUInt32LE(index + offset);
                    offset += 4;
                    var mode = data.readUInt16LE(index + offset);
                    offset += 2;
                    var sizdev = data.readUInt32LE(index + offset);
                    offset += 4;
                    var uid = data.readUInt16LE(index + offset);
                    offset += 2;
                    var gid = data.readUInt16LE(index + offset);
                    offset += 2;
                    extra.mode = mode;
                    extra.uid = uid;
                    extra.gid = gid;
                    if (vars.extraSize > 14) {
                        var start = index + offset;
                        var end = index + vars.extraSize - 14;
                        var symlinkName = this._decodeString(data.slice(start, end));
                        extra.symlink = symlinkName;
                    }
                }
                break;
            }
            if (this.options.debug) {
                result.debug.push({
                    extraId: "0x" + vars.extraId.toString(16),
                    description: fieldType,
                    data: data.slice(index, index + vars.extraSize).inspect()
                });
            }
            index += vars.extraSize;
        }
        return result;
    };
    UnzipStream.prototype._readDataDescriptor = function(data, zip64Mode) {
        if (zip64Mode) {
            var vars = binary.parse(data).word32lu("dataDescriptorSignature").word32lu("crc32").word64lu("compressedSize").word64lu("uncompressedSize").vars;
            return vars;
        }
        var vars = binary.parse(data).word32lu("dataDescriptorSignature").word32lu("crc32").word32lu("compressedSize").word32lu("uncompressedSize").vars;
        return vars;
    };
    UnzipStream.prototype._readCentralDirectoryEntry = function(data) {
        var vars = binary.parse(data).word16lu("versionMadeBy").word16lu("versionsNeededToExtract").word16lu("flags").word16lu("compressionMethod").word16lu("lastModifiedTime").word16lu("lastModifiedDate").word32lu("crc32").word32lu("compressedSize").word32lu("uncompressedSize").word16lu("fileNameLength").word16lu("extraFieldLength").word16lu("fileCommentLength").word16lu("diskNumber").word16lu("internalFileAttributes").word32lu("externalFileAttributes").word32lu("offsetToLocalFileHeader").vars;
        return vars;
    };
    UnzipStream.prototype._readEndOfCentralDirectory64 = function(data) {
        var vars = binary.parse(data).word64lu("centralDirectoryRecordSize").word16lu("versionMadeBy").word16lu("versionsNeededToExtract").word32lu("diskNumber").word32lu("diskNumberWithCentralDirectoryStart").word64lu("centralDirectoryEntries").word64lu("totalCentralDirectoryEntries").word64lu("sizeOfCentralDirectory").word64lu("offsetToStartOfCentralDirectory").vars;
        return vars;
    };
    UnzipStream.prototype._readEndOfCentralDirectory = function(data) {
        var vars = binary.parse(data).word16lu("diskNumber").word16lu("diskStart").word16lu("centralDirectoryEntries").word16lu("totalCentralDirectoryEntries").word32lu("sizeOfCentralDirectory").word32lu("offsetToStartOfCentralDirectory").word16lu("commentLength").vars;
        return vars;
    };
    const cp437 = "\0☺☻♥♦♣♠•◘○◙♂♀♪♫☼►◄↕‼¶§▬↨↑↓→←∟↔▲▼ !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~⌂ÇüéâäàåçêëèïîìÄÅÉæÆôöòûùÿÖÜ¢£¥₧ƒáíóúñÑªº¿⌐¬½¼¡«»░▒▓│┤╡╢╖╕╣║╗╝╜╛┐└┴┬├─┼╞╟╚╔╩╦╠═╬╧╨╤╥╙╘╒╓╫╪┘┌█▄▌▐▀αßΓπΣσµτΦΘΩδ∞φε∩≡±≥≤⌠⌡÷≈°∙·√ⁿ²■ ";
    UnzipStream.prototype._decodeString = function(buffer, isUtf8) {
        if (isUtf8) {
            return buffer.toString("utf8");
        }
        if (this.options.decodeString) {
            return this.options.decodeString(buffer);
        }
        let result = "";
        for (var i = 0; i < buffer.length; i++) {
            result += cp437[buffer[i]];
        }
        return result;
    };
    UnzipStream.prototype._parseOrOutput = function(encoding, cb) {
        var consume;
        while ((consume = this.processDataChunk(this.data)) > 0) {
            this.data = this.data.slice(consume);
            if (this.data.length === 0) break;
        }
        if (this.state === states.FILE_DATA) {
            if (this.outStreamInfo.limit >= 0) {
                var remaining = this.outStreamInfo.limit - this.outStreamInfo.written;
                var packet;
                if (remaining < this.data.length) {
                    packet = this.data.slice(0, remaining);
                    this.data = this.data.slice(remaining);
                } else {
                    packet = this.data;
                    this.data = new Buffer("");
                }
                this.outStreamInfo.written += packet.length;
                if (this.outStreamInfo.limit === this.outStreamInfo.written) {
                    this.state = states.START;
                    this.outStreamInfo.stream.end(packet, encoding, cb);
                } else {
                    this.outStreamInfo.stream.write(packet, encoding, cb);
                }
            } else {
                var packet = this.data;
                this.data = new Buffer("");
                this.outStreamInfo.written += packet.length;
                var outputStream = this.outStreamInfo.stream;
                outputStream.write(packet, encoding, () => {
                    if (this.state === states.FILE_DATA_END) {
                        this.state = states.START;
                        return outputStream.end(cb);
                    }
                    cb();
                });
            }
            return;
        }
        cb();
    };
    UnzipStream.prototype.drainAll = function() {
        this._drainAllEntries = true;
    };
    UnzipStream.prototype._transform = function(chunk, encoding, cb) {
        var self = this;
        if (self.data.length > 0) {
            self.data = Buffer.concat([ self.data, chunk ]);
        } else {
            self.data = chunk;
        }
        var startDataLength = self.data.length;
        var done = function() {
            if (self.data.length > 0 && self.data.length < startDataLength) {
                startDataLength = self.data.length;
                self._parseOrOutput(encoding, done);
                return;
            }
            cb();
        };
        self._parseOrOutput(encoding, done);
    };
    UnzipStream.prototype._flush = function(cb) {
        var self = this;
        if (self.data.length > 0) {
            self._parseOrOutput("buffer", (function() {
                if (self.data.length > 0) return setImmediate((function() {
                    self._flush(cb);
                }));
                cb();
            }));
            return;
        }
        if (self.state === states.FILE_DATA) {
            return cb(new Error("Stream finished in an invalid state, uncompression failed"));
        }
        setImmediate(cb);
    };
    module.exports = UnzipStream;
}, function(module, exports, __webpack_require__) {
    "use strict";
    const os = __webpack_require__(11);
    class Defaults {
        constructor() {
            this.appspace = "app.";
            this.socketRoot = "/tmp/";
            this.id = os.hostname();
            this.encoding = "utf8";
            this.rawBuffer = false;
            this.sync = false;
            this.unlink = true;
            this.delimiter = "\f";
            this.silent = false;
            this.logDepth = 5;
            this.logInColor = true;
            this.logger = console.log.bind(console);
            this.maxConnections = 100;
            this.retry = 500;
            this.maxRetries = Infinity;
            this.stopRetrying = false;
            this.IPType = getIPType();
            this.tls = false;
            this.networkHost = this.IPType == "IPv6" ? "::1" : "127.0.0.1";
            this.networkPort = 8e3;
            this.interface = {
                localAddress: false,
                localPort: false,
                family: false,
                hints: false,
                lookup: false
            };
        }
    }
    function getIPType() {
        const networkInterfaces = os.networkInterfaces();
        let IPType = "";
        if (networkInterfaces && Array.isArray(networkInterfaces) && networkInterfaces.length > 0) {
            IPType = networkInterfaces[Object.keys(networkInterfaces)[0]][0].family;
        }
        return IPType;
    }
    module.exports = Defaults;
}, function(module, exports) {
    module.exports = require("net");
}, function(module, exports) {
    module.exports = require("tls");
}, function(module, exports, __webpack_require__) {
    "use strict";
    const Defaults = __webpack_require__(113);
    class Parser {
        constructor(config) {
            if (!config) {
                config = new Defaults;
            }
            this.delimiter = config.delimiter;
        }
        format(message) {
            if (!message.data && message.data !== false && message.data !== 0) {
                message.data = {};
            }
            if (message.data["_maxListeners"]) {
                message.data = {};
            }
            message = message.JSON + this.delimiter;
            return message;
        }
        parse(data) {
            let events = data.split(this.delimiter);
            events.pop();
            return events;
        }
    }
    module.exports = Parser;
}, function(module, exports) {
    function Message() {
        Object.defineProperties(this, {
            data: {
                enumerable: true,
                get: getData,
                set: setData
            },
            type: {
                enumerable: true,
                get: getType,
                set: setType
            },
            load: {
                enumarable: true,
                writable: false,
                value: parse
            },
            JSON: {
                enumerable: true,
                get: getJSON
            }
        });
        var type = "";
        var data = {};
        function getType() {
            return type;
        }
        function getData() {
            return data;
        }
        function getJSON() {
            return JSON.stringify({
                type,
                data
            });
        }
        function setType(value) {
            type = value;
        }
        function setData(value) {
            data = value;
        }
        function parse(message) {
            try {
                var message = JSON.parse(message);
                type = message.type;
                data = message.data;
            } catch (err) {
                var badMessage = message;
                type = "error", data = {
                    message: "Invalid JSON response format",
                    err,
                    response: badMessage
                };
            }
        }
    }
    module.exports = Message;
}, function(module, exports, __webpack_require__) {
    "use strict";
    let EventPubSub = __webpack_require__(63);
    if (process.version[1] > 5) {
        EventPubSub = __webpack_require__(250);
    }
    module.exports = EventPubSub;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.pipeSourceToDestinations = exports.decompressThenFlash = void 0;
    const fs_1 = __webpack_require__(3);
    const path_1 = __webpack_require__(4);
    const block_read_stream_1 = __webpack_require__(65);
    const block_transform_stream_1 = __webpack_require__(45);
    const constants_1 = __webpack_require__(5);
    const compressed_source_1 = __webpack_require__(17);
    const configured_source_1 = __webpack_require__(75);
    const file_1 = __webpack_require__(54);
    const multi_destination_1 = __webpack_require__(79);
    const source_destination_1 = __webpack_require__(7);
    const tmp_1 = __webpack_require__(28);
    function getEta(current, total, speed) {
        return speed === 0 ? undefined : (total - current) / speed;
    }
    function isWorthDecompressing(filename = "") {
        return [ ".img", ".bin", ".hddimg", ".raw", ".sdcard", ".rpi-sdimg", ".wic" ].includes(path_1.extname(filename));
    }
    function defaultEnoughSpaceForDecompression(free, imageSize) {
        return imageSize === undefined ? false : imageSize < Math.min(free / 2, 5 * 1024 ** 3);
    }
    async function decompressThenFlash({source, destinations, onFail, onProgress, verify = false, numBuffers = 16, decompressFirst = false, trim = false, configure, enoughSpaceForDecompression = defaultEnoughSpaceForDecompression}) {
        for (const d of destinations) {
            d.open();
        }
        source = await source.getInnerSource();
        const sourceMetadata = await source.getMetadata();
        const enoughDiskSpaceAvailable = enoughSpaceForDecompression(await tmp_1.freeSpace(), sourceMetadata.size);
        let decompressedFilePath;
        try {
            if (decompressFirst && sourceMetadata.isCompressed && isWorthDecompressing(sourceMetadata.name) && enoughDiskSpaceAvailable) {
                ({path: decompressedFilePath} = await tmp_1.tmpFile(false));
                const decompressedSource = new file_1.File({
                    path: decompressedFilePath,
                    write: true
                });
                await decompressedSource.open();
                const inputStream = await source.createReadStream();
                const outputStream = await decompressedSource.createWriteStream();
                await new Promise((resolve, reject) => {
                    outputStream.on("done", resolve);
                    outputStream.on("error", reject);
                    inputStream.on("error", reject);
                    const state = {
                        active: 0,
                        failed: 0,
                        type: "decompressing"
                    };
                    const [$onProgress, onRootStreamProgress] = createCompleteOnProgress(onProgress, sourceMetadata, state, false);
                    compressed_source_1.getRootStream(inputStream).on("progress", onRootStreamProgress);
                    outputStream.on("progress", $onProgress);
                    inputStream.pipe(outputStream);
                });
                source = decompressedSource;
            }
            if ((trim || configure !== undefined) && !(source instanceof configured_source_1.ConfiguredSource)) {
                if (!await source.canRead()) {
                    console.warn("Can't configure or trim a source that is not randomly readable, skipping");
                } else {
                    source = new configured_source_1.ConfiguredSource({
                        source,
                        shouldTrimPartitions: trim,
                        createStreamFromDisk: decompressFirst || !sourceMetadata.isCompressed,
                        configure
                    });
                    await source.open();
                }
            }
            return await pipeSourceToDestinations({
                source,
                destinations,
                onFail,
                onProgress,
                verify,
                numBuffers
            });
        } finally {
            if (decompressedFilePath) {
                await fs_1.promises.unlink(decompressedFilePath);
            }
        }
    }
    exports.decompressThenFlash = decompressThenFlash;
    function createCompleteOnProgress(onProgress, sourceMetadata, state, sparse) {
        function $onProgress(progress) {
            if (sourceMetadata.size !== undefined && state.size === undefined) {
                state.size = sourceMetadata.size;
            }
            let size;
            let percentage;
            let eta;
            if (sparse) {
                size = state.blockmappedSize;
                state.bytesWritten = progress.bytes;
            } else {
                size = state.size;
                state.bytesWritten = progress.position;
            }
            if (size !== undefined && state.bytesWritten !== undefined && state.bytesWritten <= size) {
                percentage = state.bytesWritten / size * 100;
                eta = getEta(state.bytesWritten, size, progress.speed);
            } else if (state.rootStreamSpeed !== undefined && state.rootStreamPosition !== undefined && state.compressedSize !== undefined) {
                percentage = state.rootStreamPosition / state.compressedSize * 100;
                eta = getEta(state.rootStreamPosition, state.compressedSize, state.rootStreamSpeed);
            }
            const result = {
                ...progress,
                ...state,
                percentage,
                eta
            };
            onProgress(result);
        }
        function onRootStreamProgress(progress) {
            state.rootStreamPosition = progress.position;
            state.rootStreamSpeed = progress.speed;
            state.rootStreamAverageSpeed = progress.averageSpeed;
        }
        return [ $onProgress, onRootStreamProgress ];
    }
    async function pipeSourceToDestinations({source, destinations, onFail, onProgress, verify = false, numBuffers = 16}) {
        if (numBuffers < 2) {
            numBuffers = 2;
        }
        const destination = new multi_destination_1.MultiDestination(destinations);
        const failures = new Map;
        const state = {
            active: destination.destinations.size,
            failed: 0,
            type: "flashing"
        };
        destination.on("fail", _onFail);
        await Promise.all([ source.open(), destination.open() ]);
        const [sourceMetadata, sparseSource, sparseDestination] = await Promise.all([ source.getMetadata(), source.canCreateSparseReadStream(), destination.canCreateSparseWriteStream() ]);
        const sparse = sparseSource && sparseDestination;
        state.sparse = sparse;
        state.size = sourceMetadata.size;
        state.compressedSize = sourceMetadata.compressedSize;
        state.blockmappedSize = sourceMetadata.blockmappedSize;
        function updateState(step) {
            if (step !== undefined) {
                state.type = step;
            }
            state.failed = failures.size;
            state.active = destination.destinations.size - state.failed;
        }
        function _onFail(error) {
            failures.set(error.destination, error.error);
            updateState();
            onFail(error.destination, error.error);
        }
        const [$onProgress, onRootStreamProgress] = createCompleteOnProgress(onProgress, sourceMetadata, state, sparse);
        if (sparse) {
            await pipeSparseSourceToDestination(source, destination, verify, numBuffers, updateState, _onFail, $onProgress, onRootStreamProgress);
        } else {
            await pipeRegularSourceToDestination(source, sourceMetadata, destination, verify, numBuffers, updateState, _onFail, $onProgress, onRootStreamProgress);
        }
        updateState("finished");
        await Promise.all([ source.close(), destination.close() ]);
        return {
            sourceMetadata,
            failures,
            bytesWritten: state.bytesWritten || 0
        };
    }
    exports.pipeSourceToDestinations = pipeSourceToDestinations;
    function notUndefined(x) {
        return x !== undefined;
    }
    function getAlignment(...devices) {
        const alignments = devices.map(d => d.getAlignment()).filter(notUndefined);
        if (alignments.length) {
            return Math.max(...alignments);
        }
    }
    async function pipeRegularSourceToDestination(source, sourceMetadata, destination, verify, numBuffers, updateState, onFail, onProgress, onRootStreamProgress) {
        let lastPosition = 0;
        const emitSourceProgress = sourceMetadata.size === undefined || sourceMetadata.isSizeEstimated;
        const alignment = getAlignment(source, destination);
        const highWaterMark = alignment === undefined ? undefined : numBuffers - 1;
        const [sourceStream, destinationStream] = await Promise.all([ source.createReadStream({
            emitProgress: emitSourceProgress,
            alignment,
            numBuffers
        }), destination.createWriteStream({
            highWaterMark
        }) ]);
        compressed_source_1.getRootStream(sourceStream).on("progress", progress => {
            onRootStreamProgress(progress);
        });
        const checksum = await new Promise((resolve, reject) => {
            let result;
            let done = false;
            let hasher;
            function maybeDone(maybeChecksum) {
                if (maybeChecksum !== undefined) {
                    result = maybeChecksum;
                } else {
                    done = true;
                }
                if (done && (!verify || destination.activeDestinations.size === 0 || result !== undefined)) {
                    if (hasher !== undefined) {
                        sourceStream.unpipe(hasher);
                        hasher.end();
                    }
                    resolve(result);
                }
            }
            sourceStream.once("error", reject);
            destinationStream.on("fail", onFail);
            destinationStream.once("error", reject);
            if (verify) {
                hasher = source_destination_1.createHasher();
                hasher.once("checksum", maybeDone);
                sourceStream.pipe(hasher);
            }
            destinationStream.once("done", maybeDone);
            destinationStream.on("progress", progress => {
                lastPosition = progress.position;
                onProgress(progress);
            });
            if (alignment !== undefined && !(sourceStream instanceof block_read_stream_1.BlockReadStream || sourceStream instanceof block_transform_stream_1.BlockTransformStream)) {
                sourceStream.pipe(new block_transform_stream_1.BlockTransformStream({
                    chunkSize: constants_1.CHUNK_SIZE,
                    alignment,
                    numBuffers
                })).pipe(destinationStream);
            } else {
                sourceStream.pipe(destinationStream);
            }
        });
        if (sourceMetadata.size === undefined || sourceMetadata.isSizeEstimated === true) {
            sourceMetadata.size = lastPosition;
            sourceMetadata.isSizeEstimated = false;
        }
        if (verify && checksum) {
            updateState("verifying");
            const verifier = destination.createVerifier(checksum, lastPosition);
            await runVerifier(verifier, onFail, onProgress);
        }
    }
    async function pipeSparseSourceToDestination(source, destination, verify, numBuffers, updateState, onFail, onProgress, onRootStreamProgress) {
        const alignment = getAlignment(source, destination);
        const highWaterMark = alignment === undefined ? undefined : numBuffers - 1;
        const [sourceStream, destinationStream] = await Promise.all([ source.createSparseReadStream({
            generateChecksums: verify,
            alignment,
            numBuffers
        }), destination.createSparseWriteStream({
            highWaterMark
        }) ]);
        compressed_source_1.getRootStream(sourceStream).on("progress", progress => {
            onRootStreamProgress(progress);
        });
        await new Promise((resolve, reject) => {
            sourceStream.once("error", reject);
            destinationStream.once("error", reject);
            destinationStream.once("done", resolve);
            destinationStream.on("fail", onFail);
            destinationStream.on("progress", onProgress);
            sourceStream.pipe(destinationStream);
        });
        if (verify) {
            updateState("verifying");
            const verifier = destination.createVerifier(sourceStream.blocks);
            await runVerifier(verifier, onFail, onProgress);
        }
    }
    async function runVerifier(verifier, onFail, onProgress) {
        await new Promise((resolve, reject) => {
            verifier.once("error", reject);
            verifier.once("finish", resolve);
            verifier.on("fail", onFail);
            verifier.on("progress", onProgress);
            verifier.run();
        });
    }
}, function(module, exports, __webpack_require__) {
    "use strict";
    function _interopDefault(ex) {
        return ex && typeof ex === "object" && "default" in ex ? ex["default"] : ex;
    }
    var _debug = _interopDefault(__webpack_require__(121));
    const debug = _debug("rwmutex");
    class Mutex {
        constructor(label = "") {
            this.label = label;
            this._rlockId = 0;
            this._rlocks = [];
        }
        lock() {
            if (this._lock) {
                return this._lock.then(() => this.lock());
            }
            if (this._rlocks.length) {
                return Promise.all(this._rlocks).then(() => this.lock());
            }
            let resolve, unlocked = false;
            const promise = new Promise(r => resolve = r);
            const unlock = () => {
                if (unlocked) return;
                unlocked = true;
                if (this._lock === promise) delete this._lock;
                debug("unlock", this.label);
                resolve();
            };
            debug("lock", this.label);
            this._lock = promise;
            return Promise.resolve(unlock);
        }
        rlock() {
            if (this._lock) {
                return this._lock.then(() => this.rlock());
            }
            let resolve, unlocked = false;
            const promise = new Promise(r => resolve = r);
            const unlock = () => {
                if (unlocked) return;
                unlocked = true;
                const index = this._rlocks.indexOf(promise);
                if (index > -1) this._rlocks.splice(index, 1);
                debug("runlock", this.label, id);
                resolve();
            };
            const id = this._rlockId++;
            debug("rlock", this.label, id);
            this._rlocks.push(promise);
            return Promise.resolve(unlock);
        }
    }
    module.exports = Mutex;
}, function(module, exports, __webpack_require__) {
    "use strict";
    if (typeof process === "undefined" || process.type === "renderer" || process.browser === true || process.__nwjs) {
        module.exports = __webpack_require__(122);
    } else {
        module.exports = __webpack_require__(123);
    }
}, function(module, exports, __webpack_require__) {
    "use strict";
    function _typeof(obj) {
        if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
            _typeof = function _typeof(obj) {
                return typeof obj;
            };
        } else {
            _typeof = function _typeof(obj) {
                return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
            };
        }
        return _typeof(obj);
    }
    exports.log = log;
    exports.formatArgs = formatArgs;
    exports.save = save;
    exports.load = load;
    exports.useColors = useColors;
    exports.storage = localstorage();
    exports.colors = [ "#0000CC", "#0000FF", "#0033CC", "#0033FF", "#0066CC", "#0066FF", "#0099CC", "#0099FF", "#00CC00", "#00CC33", "#00CC66", "#00CC99", "#00CCCC", "#00CCFF", "#3300CC", "#3300FF", "#3333CC", "#3333FF", "#3366CC", "#3366FF", "#3399CC", "#3399FF", "#33CC00", "#33CC33", "#33CC66", "#33CC99", "#33CCCC", "#33CCFF", "#6600CC", "#6600FF", "#6633CC", "#6633FF", "#66CC00", "#66CC33", "#9900CC", "#9900FF", "#9933CC", "#9933FF", "#99CC00", "#99CC33", "#CC0000", "#CC0033", "#CC0066", "#CC0099", "#CC00CC", "#CC00FF", "#CC3300", "#CC3333", "#CC3366", "#CC3399", "#CC33CC", "#CC33FF", "#CC6600", "#CC6633", "#CC9900", "#CC9933", "#CCCC00", "#CCCC33", "#FF0000", "#FF0033", "#FF0066", "#FF0099", "#FF00CC", "#FF00FF", "#FF3300", "#FF3333", "#FF3366", "#FF3399", "#FF33CC", "#FF33FF", "#FF6600", "#FF6633", "#FF9900", "#FF9933", "#FFCC00", "#FFCC33" ];
    function useColors() {
        if (typeof window !== "undefined" && window.process && (window.process.type === "renderer" || window.process.__nwjs)) {
            return true;
        }
        if (typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)) {
            return false;
        }
        return typeof document !== "undefined" && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance || typeof window !== "undefined" && window.console && (window.console.firebug || window.console.exception && window.console.table) || typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31 || typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/);
    }
    function formatArgs(args) {
        args[0] = (this.useColors ? "%c" : "") + this.namespace + (this.useColors ? " %c" : " ") + args[0] + (this.useColors ? "%c " : " ") + "+" + module.exports.humanize(this.diff);
        if (!this.useColors) {
            return;
        }
        var c = "color: " + this.color;
        args.splice(1, 0, c, "color: inherit");
        var index = 0;
        var lastC = 0;
        args[0].replace(/%[a-zA-Z%]/g, (function(match) {
            if (match === "%%") {
                return;
            }
            index++;
            if (match === "%c") {
                lastC = index;
            }
        }));
        args.splice(lastC, 0, c);
    }
    function log() {
        var _console;
        return (typeof console === "undefined" ? "undefined" : _typeof(console)) === "object" && console.log && (_console = console).log.apply(_console, arguments);
    }
    function save(namespaces) {
        try {
            if (namespaces) {
                exports.storage.setItem("debug", namespaces);
            } else {
                exports.storage.removeItem("debug");
            }
        } catch (error) {}
    }
    function load() {
        var r;
        try {
            r = exports.storage.getItem("debug");
        } catch (error) {}
        if (!r && typeof process !== "undefined" && "env" in process) {
            r = process.env.DEBUG;
        }
        return r;
    }
    function localstorage() {
        try {
            return localStorage;
        } catch (error) {}
    }
    module.exports = __webpack_require__(66)(exports);
    var formatters = module.exports.formatters;
    formatters.j = function(v) {
        try {
            return JSON.stringify(v);
        } catch (error) {
            return "[UnexpectedJSONParseError]: " + error.message;
        }
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    var tty = __webpack_require__(30);
    var util = __webpack_require__(1);
    exports.init = init;
    exports.log = log;
    exports.formatArgs = formatArgs;
    exports.save = save;
    exports.load = load;
    exports.useColors = useColors;
    exports.colors = [ 6, 2, 3, 4, 5, 1 ];
    try {
        var supportsColor = __webpack_require__(31);
        if (supportsColor && (supportsColor.stderr || supportsColor).level >= 2) {
            exports.colors = [ 20, 21, 26, 27, 32, 33, 38, 39, 40, 41, 42, 43, 44, 45, 56, 57, 62, 63, 68, 69, 74, 75, 76, 77, 78, 79, 80, 81, 92, 93, 98, 99, 112, 113, 128, 129, 134, 135, 148, 149, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 178, 179, 184, 185, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 214, 215, 220, 221 ];
        }
    } catch (error) {}
    exports.inspectOpts = Object.keys(process.env).filter((function(key) {
        return /^debug_/i.test(key);
    })).reduce((function(obj, key) {
        var prop = key.substring(6).toLowerCase().replace(/_([a-z])/g, (function(_, k) {
            return k.toUpperCase();
        }));
        var val = process.env[key];
        if (/^(yes|on|true|enabled)$/i.test(val)) {
            val = true;
        } else if (/^(no|off|false|disabled)$/i.test(val)) {
            val = false;
        } else if (val === "null") {
            val = null;
        } else {
            val = Number(val);
        }
        obj[prop] = val;
        return obj;
    }), {});
    function useColors() {
        return "colors" in exports.inspectOpts ? Boolean(exports.inspectOpts.colors) : tty.isatty(process.stderr.fd);
    }
    function formatArgs(args) {
        var name = this.namespace, useColors = this.useColors;
        if (useColors) {
            var c = this.color;
            var colorCode = "[3" + (c < 8 ? c : "8;5;" + c);
            var prefix = "  ".concat(colorCode, ";1m").concat(name, " [0m");
            args[0] = prefix + args[0].split("\n").join("\n" + prefix);
            args.push(colorCode + "m+" + module.exports.humanize(this.diff) + "[0m");
        } else {
            args[0] = getDate() + name + " " + args[0];
        }
    }
    function getDate() {
        if (exports.inspectOpts.hideDate) {
            return "";
        }
        return (new Date).toISOString() + " ";
    }
    function log() {
        return process.stderr.write(util.format.apply(util, arguments) + "\n");
    }
    function save(namespaces) {
        if (namespaces) {
            process.env.DEBUG = namespaces;
        } else {
            delete process.env.DEBUG;
        }
    }
    function load() {
        return process.env.DEBUG;
    }
    function init(debug) {
        debug.inspectOpts = {};
        var keys = Object.keys(exports.inspectOpts);
        for (var i = 0; i < keys.length; i++) {
            debug.inspectOpts[keys[i]] = exports.inspectOpts[keys[i]];
        }
    }
    module.exports = __webpack_require__(66)(exports);
    var formatters = module.exports.formatters;
    formatters.o = function(v) {
        this.inspectOpts.colors = this.useColors;
        return util.inspect(v, this.inspectOpts).replace(/\s*\n\s*/g, " ");
    };
    formatters.O = function(v) {
        this.inspectOpts.colors = this.useColors;
        return util.inspect(v, this.inspectOpts);
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    module.exports = (flag, argv) => {
        argv = argv || process.argv;
        const prefix = flag.startsWith("-") ? "" : flag.length === 1 ? "-" : "--";
        const pos = argv.indexOf(prefix + flag);
        const terminatorPos = argv.indexOf("--");
        return pos !== -1 && (terminatorPos === -1 ? true : pos < terminatorPos);
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.Speedometer = void 0;
    const utils_1 = __webpack_require__(6);
    class Speedometer {
        constructor(windowSize = 5) {
            this.windowSize = windowSize;
            this.values = [];
            this.values.push([ this.now(), 0 ]);
        }
        now() {
            return Date.now() / 1e3;
        }
        removeOldValues(start) {
            const index = this.values.findIndex(v => v[0] > start);
            const deleteUntil = index === -1 ? undefined : index - 1;
            this.values.splice(0, deleteUntil);
        }
        moment(index) {
            return this.values[index][0];
        }
        value(index) {
            return this.values[index][1];
        }
        speed(amount) {
            const now = this.now();
            this.values.push([ now, amount ]);
            const start = now - this.windowSize;
            this.removeOldValues(start);
            if (this.values.length < 2) {
                return 0;
            }
            let ratio;
            let duration;
            if (start <= this.values[0][0]) {
                ratio = (this.moment(1) - start) / (this.moment(1) - this.moment(0));
                duration = this.windowSize;
            } else {
                ratio = 1;
                duration = now - this.moment(0);
            }
            const sum = ratio * this.value(1) + utils_1.sumBy(this.values.slice(2), v => v[1]);
            return sum / duration;
        }
    }
    exports.Speedometer = Speedometer;
}, function(module, exports, __webpack_require__) {
    "use strict";
    const toBytes = s => [ ...s ].map(c => c.charCodeAt(0));
    const xpiZipFilename = toBytes("META-INF/mozilla.rsa");
    const oxmlContentTypes = toBytes("[Content_Types].xml");
    const oxmlRels = toBytes("_rels/.rels");
    module.exports = input => {
        const buf = input instanceof Uint8Array ? input : new Uint8Array(input);
        if (!(buf && buf.length > 1)) {
            return null;
        }
        const check = (header, options) => {
            options = Object.assign({
                offset: 0
            }, options);
            for (let i = 0; i < header.length; i++) {
                if (options.mask) {
                    if (header[i] !== (options.mask[i] & buf[i + options.offset])) {
                        return false;
                    }
                } else if (header[i] !== buf[i + options.offset]) {
                    return false;
                }
            }
            return true;
        };
        const checkString = (header, options) => check(toBytes(header), options);
        if (check([ 255, 216, 255 ])) {
            return {
                ext: "jpg",
                mime: "image/jpeg"
            };
        }
        if (check([ 137, 80, 78, 71, 13, 10, 26, 10 ])) {
            return {
                ext: "png",
                mime: "image/png"
            };
        }
        if (check([ 71, 73, 70 ])) {
            return {
                ext: "gif",
                mime: "image/gif"
            };
        }
        if (check([ 87, 69, 66, 80 ], {
            offset: 8
        })) {
            return {
                ext: "webp",
                mime: "image/webp"
            };
        }
        if (check([ 70, 76, 73, 70 ])) {
            return {
                ext: "flif",
                mime: "image/flif"
            };
        }
        if ((check([ 73, 73, 42, 0 ]) || check([ 77, 77, 0, 42 ])) && check([ 67, 82 ], {
            offset: 8
        })) {
            return {
                ext: "cr2",
                mime: "image/x-canon-cr2"
            };
        }
        if (check([ 73, 73, 42, 0 ]) || check([ 77, 77, 0, 42 ])) {
            return {
                ext: "tif",
                mime: "image/tiff"
            };
        }
        if (check([ 66, 77 ])) {
            return {
                ext: "bmp",
                mime: "image/bmp"
            };
        }
        if (check([ 73, 73, 188 ])) {
            return {
                ext: "jxr",
                mime: "image/vnd.ms-photo"
            };
        }
        if (check([ 56, 66, 80, 83 ])) {
            return {
                ext: "psd",
                mime: "image/vnd.adobe.photoshop"
            };
        }
        if (check([ 80, 75, 3, 4 ])) {
            if (check([ 109, 105, 109, 101, 116, 121, 112, 101, 97, 112, 112, 108, 105, 99, 97, 116, 105, 111, 110, 47, 101, 112, 117, 98, 43, 122, 105, 112 ], {
                offset: 30
            })) {
                return {
                    ext: "epub",
                    mime: "application/epub+zip"
                };
            }
            if (check(xpiZipFilename, {
                offset: 30
            })) {
                return {
                    ext: "xpi",
                    mime: "application/x-xpinstall"
                };
            }
            if (checkString("mimetypeapplication/vnd.oasis.opendocument.text", {
                offset: 30
            })) {
                return {
                    ext: "odt",
                    mime: "application/vnd.oasis.opendocument.text"
                };
            }
            if (checkString("mimetypeapplication/vnd.oasis.opendocument.spreadsheet", {
                offset: 30
            })) {
                return {
                    ext: "ods",
                    mime: "application/vnd.oasis.opendocument.spreadsheet"
                };
            }
            if (checkString("mimetypeapplication/vnd.oasis.opendocument.presentation", {
                offset: 30
            })) {
                return {
                    ext: "odp",
                    mime: "application/vnd.oasis.opendocument.presentation"
                };
            }
            if (check(oxmlContentTypes, {
                offset: 30
            }) || check(oxmlRels, {
                offset: 30
            })) {
                const sliced = buf.subarray(4, 4 + 2e3);
                const nextZipHeaderIndex = arr => arr.findIndex((el, i, arr) => arr[i] === 80 && arr[i + 1] === 75 && arr[i + 2] === 3 && arr[i + 3] === 4);
                const header2Pos = nextZipHeaderIndex(sliced);
                if (header2Pos !== -1) {
                    const slicedAgain = buf.subarray(header2Pos + 8, header2Pos + 8 + 1e3);
                    const header3Pos = nextZipHeaderIndex(slicedAgain);
                    if (header3Pos !== -1) {
                        const offset = 8 + header2Pos + header3Pos + 30;
                        if (checkString("word/", {
                            offset
                        })) {
                            return {
                                ext: "docx",
                                mime: "application/vnd.openxmlformats-officedocument.wordprocessingml.document"
                            };
                        }
                        if (checkString("ppt/", {
                            offset
                        })) {
                            return {
                                ext: "pptx",
                                mime: "application/vnd.openxmlformats-officedocument.presentationml.presentation"
                            };
                        }
                        if (checkString("xl/", {
                            offset
                        })) {
                            return {
                                ext: "xlsx",
                                mime: "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
                            };
                        }
                    }
                }
            }
        }
        if (check([ 80, 75 ]) && (buf[2] === 3 || buf[2] === 5 || buf[2] === 7) && (buf[3] === 4 || buf[3] === 6 || buf[3] === 8)) {
            return {
                ext: "zip",
                mime: "application/zip"
            };
        }
        if (check([ 117, 115, 116, 97, 114 ], {
            offset: 257
        })) {
            return {
                ext: "tar",
                mime: "application/x-tar"
            };
        }
        if (check([ 82, 97, 114, 33, 26, 7 ]) && (buf[6] === 0 || buf[6] === 1)) {
            return {
                ext: "rar",
                mime: "application/x-rar-compressed"
            };
        }
        if (check([ 31, 139, 8 ])) {
            return {
                ext: "gz",
                mime: "application/gzip"
            };
        }
        if (check([ 66, 90, 104 ])) {
            return {
                ext: "bz2",
                mime: "application/x-bzip2"
            };
        }
        if (check([ 55, 122, 188, 175, 39, 28 ])) {
            return {
                ext: "7z",
                mime: "application/x-7z-compressed"
            };
        }
        if (check([ 120, 1 ])) {
            return {
                ext: "dmg",
                mime: "application/x-apple-diskimage"
            };
        }
        if (check([ 51, 103, 112, 53 ]) || check([ 0, 0, 0 ]) && check([ 102, 116, 121, 112 ], {
            offset: 4
        }) && (check([ 109, 112, 52, 49 ], {
            offset: 8
        }) || check([ 109, 112, 52, 50 ], {
            offset: 8
        }) || check([ 105, 115, 111, 109 ], {
            offset: 8
        }) || check([ 105, 115, 111, 50 ], {
            offset: 8
        }) || check([ 109, 109, 112, 52 ], {
            offset: 8
        }) || check([ 77, 52, 86 ], {
            offset: 8
        }) || check([ 100, 97, 115, 104 ], {
            offset: 8
        }))) {
            return {
                ext: "mp4",
                mime: "video/mp4"
            };
        }
        if (check([ 77, 84, 104, 100 ])) {
            return {
                ext: "mid",
                mime: "audio/midi"
            };
        }
        if (check([ 26, 69, 223, 163 ])) {
            const sliced = buf.subarray(4, 4 + 4096);
            const idPos = sliced.findIndex((el, i, arr) => arr[i] === 66 && arr[i + 1] === 130);
            if (idPos !== -1) {
                const docTypePos = idPos + 3;
                const findDocType = type => [ ...type ].every((c, i) => sliced[docTypePos + i] === c.charCodeAt(0));
                if (findDocType("matroska")) {
                    return {
                        ext: "mkv",
                        mime: "video/x-matroska"
                    };
                }
                if (findDocType("webm")) {
                    return {
                        ext: "webm",
                        mime: "video/webm"
                    };
                }
            }
        }
        if (check([ 0, 0, 0, 20, 102, 116, 121, 112, 113, 116, 32, 32 ]) || check([ 102, 114, 101, 101 ], {
            offset: 4
        }) || check([ 102, 116, 121, 112, 113, 116, 32, 32 ], {
            offset: 4
        }) || check([ 109, 100, 97, 116 ], {
            offset: 4
        }) || check([ 119, 105, 100, 101 ], {
            offset: 4
        })) {
            return {
                ext: "mov",
                mime: "video/quicktime"
            };
        }
        if (check([ 82, 73, 70, 70 ])) {
            if (check([ 65, 86, 73 ], {
                offset: 8
            })) {
                return {
                    ext: "avi",
                    mime: "video/x-msvideo"
                };
            }
            if (check([ 87, 65, 86, 69 ], {
                offset: 8
            })) {
                return {
                    ext: "wav",
                    mime: "audio/x-wav"
                };
            }
            if (check([ 81, 76, 67, 77 ], {
                offset: 8
            })) {
                return {
                    ext: "qcp",
                    mime: "audio/qcelp"
                };
            }
        }
        if (check([ 48, 38, 178, 117, 142, 102, 207, 17, 166, 217 ])) {
            return {
                ext: "wmv",
                mime: "video/x-ms-wmv"
            };
        }
        if (check([ 0, 0, 1, 186 ]) || check([ 0, 0, 1, 179 ])) {
            return {
                ext: "mpg",
                mime: "video/mpeg"
            };
        }
        if (check([ 102, 116, 121, 112, 51, 103 ], {
            offset: 4
        })) {
            return {
                ext: "3gp",
                mime: "video/3gpp"
            };
        }
        for (let start = 0; start < 2 && start < buf.length - 16; start++) {
            if (check([ 73, 68, 51 ], {
                offset: start
            }) || check([ 255, 226 ], {
                offset: start,
                mask: [ 255, 226 ]
            })) {
                return {
                    ext: "mp3",
                    mime: "audio/mpeg"
                };
            }
            if (check([ 255, 228 ], {
                offset: start,
                mask: [ 255, 228 ]
            })) {
                return {
                    ext: "mp2",
                    mime: "audio/mpeg"
                };
            }
            if (check([ 255, 248 ], {
                offset: start,
                mask: [ 255, 252 ]
            })) {
                return {
                    ext: "mp2",
                    mime: "audio/mpeg"
                };
            }
            if (check([ 255, 240 ], {
                offset: start,
                mask: [ 255, 252 ]
            })) {
                return {
                    ext: "mp4",
                    mime: "audio/mpeg"
                };
            }
        }
        if (check([ 102, 116, 121, 112, 77, 52, 65 ], {
            offset: 4
        }) || check([ 77, 52, 65, 32 ])) {
            return {
                ext: "m4a",
                mime: "audio/m4a"
            };
        }
        if (check([ 79, 112, 117, 115, 72, 101, 97, 100 ], {
            offset: 28
        })) {
            return {
                ext: "opus",
                mime: "audio/opus"
            };
        }
        if (check([ 79, 103, 103, 83 ])) {
            if (check([ 128, 116, 104, 101, 111, 114, 97 ], {
                offset: 28
            })) {
                return {
                    ext: "ogv",
                    mime: "video/ogg"
                };
            }
            if (check([ 1, 118, 105, 100, 101, 111, 0 ], {
                offset: 28
            })) {
                return {
                    ext: "ogm",
                    mime: "video/ogg"
                };
            }
            if (check([ 127, 70, 76, 65, 67 ], {
                offset: 28
            })) {
                return {
                    ext: "oga",
                    mime: "audio/ogg"
                };
            }
            if (check([ 83, 112, 101, 101, 120, 32, 32 ], {
                offset: 28
            })) {
                return {
                    ext: "spx",
                    mime: "audio/ogg"
                };
            }
            if (check([ 1, 118, 111, 114, 98, 105, 115 ], {
                offset: 28
            })) {
                return {
                    ext: "ogg",
                    mime: "audio/ogg"
                };
            }
            return {
                ext: "ogx",
                mime: "application/ogg"
            };
        }
        if (check([ 102, 76, 97, 67 ])) {
            return {
                ext: "flac",
                mime: "audio/x-flac"
            };
        }
        if (check([ 77, 65, 67, 32 ])) {
            return {
                ext: "ape",
                mime: "audio/ape"
            };
        }
        if (check([ 35, 33, 65, 77, 82, 10 ])) {
            return {
                ext: "amr",
                mime: "audio/amr"
            };
        }
        if (check([ 37, 80, 68, 70 ])) {
            return {
                ext: "pdf",
                mime: "application/pdf"
            };
        }
        if (check([ 77, 90 ])) {
            return {
                ext: "exe",
                mime: "application/x-msdownload"
            };
        }
        if ((buf[0] === 67 || buf[0] === 70) && check([ 87, 83 ], {
            offset: 1
        })) {
            return {
                ext: "swf",
                mime: "application/x-shockwave-flash"
            };
        }
        if (check([ 123, 92, 114, 116, 102 ])) {
            return {
                ext: "rtf",
                mime: "application/rtf"
            };
        }
        if (check([ 0, 97, 115, 109 ])) {
            return {
                ext: "wasm",
                mime: "application/wasm"
            };
        }
        if (check([ 119, 79, 70, 70 ]) && (check([ 0, 1, 0, 0 ], {
            offset: 4
        }) || check([ 79, 84, 84, 79 ], {
            offset: 4
        }))) {
            return {
                ext: "woff",
                mime: "font/woff"
            };
        }
        if (check([ 119, 79, 70, 50 ]) && (check([ 0, 1, 0, 0 ], {
            offset: 4
        }) || check([ 79, 84, 84, 79 ], {
            offset: 4
        }))) {
            return {
                ext: "woff2",
                mime: "font/woff2"
            };
        }
        if (check([ 76, 80 ], {
            offset: 34
        }) && (check([ 0, 0, 1 ], {
            offset: 8
        }) || check([ 1, 0, 2 ], {
            offset: 8
        }) || check([ 2, 0, 2 ], {
            offset: 8
        }))) {
            return {
                ext: "eot",
                mime: "application/octet-stream"
            };
        }
        if (check([ 0, 1, 0, 0, 0 ])) {
            return {
                ext: "ttf",
                mime: "font/ttf"
            };
        }
        if (check([ 79, 84, 84, 79, 0 ])) {
            return {
                ext: "otf",
                mime: "font/otf"
            };
        }
        if (check([ 0, 0, 1, 0 ])) {
            return {
                ext: "ico",
                mime: "image/x-icon"
            };
        }
        if (check([ 0, 0, 2, 0 ])) {
            return {
                ext: "cur",
                mime: "image/x-icon"
            };
        }
        if (check([ 70, 76, 86, 1 ])) {
            return {
                ext: "flv",
                mime: "video/x-flv"
            };
        }
        if (check([ 37, 33 ])) {
            return {
                ext: "ps",
                mime: "application/postscript"
            };
        }
        if (check([ 253, 55, 122, 88, 90, 0 ])) {
            return {
                ext: "xz",
                mime: "application/x-xz"
            };
        }
        if (check([ 83, 81, 76, 105 ])) {
            return {
                ext: "sqlite",
                mime: "application/x-sqlite3"
            };
        }
        if (check([ 78, 69, 83, 26 ])) {
            return {
                ext: "nes",
                mime: "application/x-nintendo-nes-rom"
            };
        }
        if (check([ 67, 114, 50, 52 ])) {
            return {
                ext: "crx",
                mime: "application/x-google-chrome-extension"
            };
        }
        if (check([ 77, 83, 67, 70 ]) || check([ 73, 83, 99, 40 ])) {
            return {
                ext: "cab",
                mime: "application/vnd.ms-cab-compressed"
            };
        }
        if (check([ 33, 60, 97, 114, 99, 104, 62, 10, 100, 101, 98, 105, 97, 110, 45, 98, 105, 110, 97, 114, 121 ])) {
            return {
                ext: "deb",
                mime: "application/x-deb"
            };
        }
        if (check([ 33, 60, 97, 114, 99, 104, 62 ])) {
            return {
                ext: "ar",
                mime: "application/x-unix-archive"
            };
        }
        if (check([ 237, 171, 238, 219 ])) {
            return {
                ext: "rpm",
                mime: "application/x-rpm"
            };
        }
        if (check([ 31, 160 ]) || check([ 31, 157 ])) {
            return {
                ext: "Z",
                mime: "application/x-compress"
            };
        }
        if (check([ 76, 90, 73, 80 ])) {
            return {
                ext: "lz",
                mime: "application/x-lzip"
            };
        }
        if (check([ 208, 207, 17, 224, 161, 177, 26, 225 ])) {
            return {
                ext: "msi",
                mime: "application/x-msi"
            };
        }
        if (check([ 6, 14, 43, 52, 2, 5, 1, 1, 13, 1, 2, 1, 1, 2 ])) {
            return {
                ext: "mxf",
                mime: "application/mxf"
            };
        }
        if (check([ 71 ], {
            offset: 4
        }) && (check([ 71 ], {
            offset: 192
        }) || check([ 71 ], {
            offset: 196
        }))) {
            return {
                ext: "mts",
                mime: "video/mp2t"
            };
        }
        if (check([ 66, 76, 69, 78, 68, 69, 82 ])) {
            return {
                ext: "blend",
                mime: "application/x-blender"
            };
        }
        if (check([ 66, 80, 71, 251 ])) {
            return {
                ext: "bpg",
                mime: "image/bpg"
            };
        }
        if (check([ 0, 0, 0, 12, 106, 80, 32, 32, 13, 10, 135, 10 ])) {
            if (check([ 106, 112, 50, 32 ], {
                offset: 20
            })) {
                return {
                    ext: "jp2",
                    mime: "image/jp2"
                };
            }
            if (check([ 106, 112, 120, 32 ], {
                offset: 20
            })) {
                return {
                    ext: "jpx",
                    mime: "image/jpx"
                };
            }
            if (check([ 106, 112, 109, 32 ], {
                offset: 20
            })) {
                return {
                    ext: "jpm",
                    mime: "image/jpm"
                };
            }
            if (check([ 109, 106, 112, 50 ], {
                offset: 20
            })) {
                return {
                    ext: "mj2",
                    mime: "image/mj2"
                };
            }
        }
        if (check([ 70, 79, 82, 77, 0 ])) {
            return {
                ext: "aif",
                mime: "audio/aiff"
            };
        }
        if (checkString("<?xml ")) {
            return {
                ext: "xml",
                mime: "application/xml"
            };
        }
        if (check([ 66, 79, 79, 75, 77, 79, 66, 73 ], {
            offset: 60
        })) {
            return {
                ext: "mobi",
                mime: "application/x-mobipocket-ebook"
            };
        }
        if (check([ 102, 116, 121, 112 ], {
            offset: 4
        })) {
            if (check([ 109, 105, 102, 49 ], {
                offset: 8
            })) {
                return {
                    ext: "heic",
                    mime: "image/heif"
                };
            }
            if (check([ 109, 115, 102, 49 ], {
                offset: 8
            })) {
                return {
                    ext: "heic",
                    mime: "image/heif-sequence"
                };
            }
            if (check([ 104, 101, 105, 99 ], {
                offset: 8
            }) || check([ 104, 101, 105, 120 ], {
                offset: 8
            })) {
                return {
                    ext: "heic",
                    mime: "image/heic"
                };
            }
            if (check([ 104, 101, 118, 99 ], {
                offset: 8
            }) || check([ 104, 101, 118, 120 ], {
                offset: 8
            })) {
                return {
                    ext: "heic",
                    mime: "image/heic-sequence"
                };
            }
        }
        if (check([ 171, 75, 84, 88, 32, 49, 49, 187, 13, 10, 26, 10 ])) {
            return {
                ext: "ktx",
                mime: "image/ktx"
            };
        }
        return null;
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.DiscardDiskChunk = exports.BufferDiskChunk = exports.DiskChunk = void 0;
    const interval_intersection_1 = __webpack_require__(67);
    class DiskChunk {
        constructor(start, end) {
            this.start = start;
            this.end = end;
        }
        interval() {
            return [ this.start, this.end ];
        }
        intersection(other) {
            return interval_intersection_1.intervalIntersection(this.interval(), other.interval());
        }
        intersects(other) {
            return this.intersection(other) !== null;
        }
        includedIn(other) {
            return this.start >= other.start && this.end <= other.end;
        }
        cut(other) {
            const result = [];
            const intersection = this.intersection(other);
            if (intersection === null) {
                throw new Error("`other` must be an overlapping `DiskChunk`");
            }
            if (intersection[0] > this.start) {
                result.push(this.slice(this.start, intersection[0] - 1));
            }
            if (this.end > intersection[1]) {
                result.push(this.slice(intersection[1] + 1, this.end));
            }
            return result;
        }
    }
    exports.DiskChunk = DiskChunk;
    class BufferDiskChunk extends DiskChunk {
        constructor(buffer, offset, copy = true) {
            super(offset, offset + buffer.length - 1);
            if (copy) {
                this.buffer = Buffer.from(buffer);
            } else {
                this.buffer = buffer;
            }
        }
        data() {
            return this.buffer;
        }
        slice(start, end) {
            const startInBuffer = start - this.start;
            return new BufferDiskChunk(this.buffer.slice(startInBuffer, startInBuffer + end - start + 1), start, false);
        }
    }
    exports.BufferDiskChunk = BufferDiskChunk;
    class DiscardDiskChunk extends DiskChunk {
        constructor(offset, length) {
            super(offset, offset + length - 1);
        }
        data() {
            return Buffer.alloc(this.end - this.start + 1);
        }
        slice(start, end) {
            return new DiscardDiskChunk(start, end - start + 1);
        }
    }
    exports.DiscardDiskChunk = DiscardDiskChunk;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.getRanges = void 0;
    function* mapIterable(source, transform) {
        for (const value of source) {
            yield transform(value);
        }
    }
    async function getNotDiscardedIntervals(disk) {
        return notDiscardedIntervalsIterator(disk.getDiscardedChunks(), await disk.getCapacity());
    }
    function* notDiscardedIntervalsIterator(discardedChunks, capacity) {
        let lastStart = 0;
        for (const discardedChunk of discardedChunks) {
            yield [ lastStart, discardedChunk.start - 1 ];
            lastStart = discardedChunk.end + 1;
        }
        if (lastStart < capacity) {
            yield [ lastStart, capacity - 1 ];
        }
    }
    function* mergeIntervals(intervals) {
        let current;
        for (const interval of intervals) {
            if (current === undefined) {
                current = interval.slice();
            } else if (interval[0] > current[1] + 1) {
                yield current;
                current = interval.slice();
            } else {
                current[1] = interval[1];
            }
        }
        if (current !== undefined) {
            yield current;
        }
    }
    async function getRanges(disk, blockSize) {
        const intervals = await getNotDiscardedIntervals(disk);
        const blockSizedIntervals = mapIterable(intervals, chunk => [ Math.floor(chunk[0] / blockSize), Math.floor(chunk[1] / blockSize) ]);
        const mergedBlockSizedIntervals = mergeIntervals(blockSizedIntervals);
        return mapIterable(mergedBlockSizedIntervals, interval => {
            const offset = interval[0] * blockSize;
            const length = (interval[1] - interval[0] + 1) * blockSize;
            return {
                offset,
                length
            };
        });
    }
    exports.getRanges = getRanges;
}, function(module, exports, __webpack_require__) {
    var GUID = __webpack_require__(70);
    var GPT = __webpack_require__(68);
    var uint64 = __webpack_require__(69);
    function PartitionEntry(options) {
        if (!(this instanceof PartitionEntry)) {
            return new PartitionEntry(options);
        }
        options = options != null ? options : {};
        this.type = options.type || GUID.ZERO;
        this.guid = options.guid || GUID.ZERO;
        this.name = options.name || "";
        this.firstLBA = options.firstLBA || 0;
        this.lastLBA = options.lastLBA || 0;
        this.attr = options.attr || 0;
    }
    PartitionEntry.parse = function(buffer, offset) {
        return (new PartitionEntry).parse(buffer, offset);
    };
    PartitionEntry.prototype = {
        constructor: PartitionEntry,
        isEmpty() {
            return this.type.toString() === GUID.ZERO;
        },
        parse(buffer, offset) {
            offset = offset || 0;
            this.type = GUID.toString(buffer, offset + 0);
            this.guid = GUID.toString(buffer, offset + 16);
            this.firstLBA = uint64.readLE(buffer, offset + 32);
            this.lastLBA = uint64.readLE(buffer, offset + 40);
            this.attr = uint64.readLE(buffer, offset + 48);
            this.name = buffer.toString("ucs2", offset + 56, offset + GPT.TABLE_ENTRY_SIZE).replace(/\x00+/g, "");
            return this;
        },
        write(buffer, offset) {
            buffer = buffer || Buffer.alloc(GPT.TABLE_ENTRY_SIZE, 0);
            offset = offset || 0;
            GPT.GUID.write(this.type, buffer, offset + 0);
            GPT.GUID.write(this.guid, buffer, offset + 16);
            uint64.writeLE(buffer, this.firstLBA, offset + 32);
            uint64.writeLE(buffer, this.lastLBA, offset + 40);
            uint64.writeLE(buffer, this.attr, offset + 48);
            buffer.fill(0, offset + 56, offset + GPT.TABLE_ENTRY_SIZE);
            buffer.write(this.name, offset + 56, offset + GPT.TABLE_ENTRY_SIZE, "ucs2");
            return buffer;
        }
    };
    module.exports = PartitionEntry;
}, function(module, exports, __webpack_require__) {
    var CHS = __webpack_require__(48);
    function Partition(buffer, start, end) {
        if (!(this instanceof Partition)) return new Partition(buffer, start, end);
        if (buffer != null && !Buffer.isBuffer(buffer)) throw new TypeError("Argument must be a Buffer");
        this.status = 0;
        this.type = 0;
        this.sectors = 0;
        this.firstLBA = 0;
        this.firstCHS = new CHS;
        this.lastCHS = new CHS;
        if (buffer != null) {
            this.buffer = buffer.slice(start, end);
        }
    }
    Partition.EXTENDED = [ 5, 15, 133, 21, 31, 145, 155, 94, 95, 207, 213, 197 ];
    Partition.parse = function(buffer, start, end) {
        return new Partition(buffer, start, end);
    };
    Partition.isExtended = function(type) {
        return !!~Partition.EXTENDED.indexOf(type);
    };
    Partition.prototype = {
        constructor: Partition,
        get statusText() {
            switch (this.status) {
              case 128:
                return "active";
                break;

              case 0:
                return "inactive";
                break;

              default:
                return "invalid";
                break;
            }
        },
        get active() {
            return this.status === 128;
        },
        get inactive() {
            return this.status === 0;
        },
        get invalid() {
            return !this.active && !this.inactive;
        },
        get extended() {
            return Partition.isExtended(this.type);
        },
        get lastLBA() {
            return this.firstLBA + this.sectors;
        },
        byteOffset: function(blockSize) {
            blockSize = blockSize || 512;
            return this.firstLBA * blockSize;
        },
        byteSize: function(blockSize) {
            blockSize = blockSize || 512;
            return this.sectors * blockSize;
        },
        parse: function(buffer, start, end) {
            this.buffer = buffer.slice(start, end);
        },
        get buffer() {
            var buffer = new Buffer(16);
            buffer.fill(0);
            buffer.writeUInt8(this.status, 0);
            buffer.writeUInt8(this.type, 4);
            buffer.writeUInt32LE(this.firstLBA, 8);
            buffer.writeUInt32LE(this.sectors, 12);
            this.firstCHS.buffer.copy(buffer, 1);
            this.lastCHS.buffer.copy(buffer, 5);
            return buffer;
        },
        set buffer(value) {
            if (!Buffer.isBuffer(value)) throw new TypeError("Argument must be a Buffer");
            if (value.length < 16) {
                throw new SyntaxError("Partition entry size unacceptable:" + "expected 16 bytes, but got " + data.length);
            }
            this.status = value.readUInt8(0);
            this.type = value.readUInt8(4);
            this.firstLBA = value.readUInt32LE(8);
            this.sectors = value.readUInt32LE(12);
            this.firstCHS.buffer = value.slice(1, 4);
            this.lastCHS.buffer = value.slice(5, 8);
        }
    };
    module.exports = Partition;
}, function(module, exports) {
    function Code(buffer, start, end) {
        if (!(this instanceof Code)) return new Code(buffer, start, end);
        this.offset = start || 0;
        if (Buffer.isBuffer(buffer)) {
            this.data = buffer.slice(start, end);
        } else {
            this.data = new Buffer(446);
            this.data.fill(0);
        }
    }
    Code.prototype = {
        constructor: Code,
        get length() {
            return this.data.length;
        }
    };
    module.exports = Code;
}, function(module, exports, __webpack_require__) {
    var inherit = __webpack_require__(15);
    var MBR = __webpack_require__(14);
    function CLASSIC(buffer, start, end) {
        if (!(this instanceof CLASSIC)) return new CLASSIC(buffer, start, end);
        MBR.call(this, buffer, start, end);
    }
    CLASSIC.TABLE_OFFSET = 446;
    CLASSIC.PARTITION_ENTRIES = 4;
    CLASSIC.prototype = {
        constructor: CLASSIC,
        get buffer() {
            var buffer = MBR.createBuffer();
            var offset = this.tableOffset;
            for (var i = 0; i < this.code.length; i++) {
                this.code[i].data.copy(buffer, this.code[i].offset);
            }
            this.partitions[0].buffer.copy(buffer, offset);
            this.partitions[1].buffer.copy(buffer, offset += 16);
            this.partitions[2].buffer.copy(buffer, offset += 16);
            this.partitions[3].buffer.copy(buffer, offset += 16);
            return buffer;
        },
        set buffer(value) {
            if (!Buffer.isBuffer(value)) throw new TypeError("Value must be a Buffer");
            this.code = [ new MBR.Code(value, 0, 446) ];
            var i, count = this.partitionEntries;
            var offset = this.tableOffset;
            for (i = 0; i < count; i++) {
                this.partitions[i].buffer = value.slice(offset, offset += 16);
            }
        }
    };
    inherit(CLASSIC, MBR);
    module.exports = CLASSIC;
}, function(module, exports, __webpack_require__) {
    var inherit = __webpack_require__(15);
    var MBR = __webpack_require__(14);
    function MODERN(buffer, start, end) {
        if (!(this instanceof MODERN)) return new MODERN(buffer, start, end);
        this.physicalDrive = 128;
        this.timestamp = {
            seconds: 0,
            minutes: 0,
            hours: 0
        };
        this.signature = null;
        this.copyProtected = false;
        MBR.call(this, buffer, start, end);
    }
    MODERN.TABLE_OFFSET = 446;
    MODERN.PARTITION_ENTRIES = 4;
    MODERN.prototype = {
        constructor: MODERN,
        get buffer() {
            var buffer = MBR.createBuffer();
            for (var i = 0; i < this.code.length; i++) {
                this.code[i].data.copy(buffer, this.code[i].offset);
            }
            buffer[220] = this.physicalDrive;
            buffer[221] = this.timestamp.seconds;
            buffer[222] = this.timestamp.minutes;
            buffer[223] = this.timestamp.hours;
            if (this.code[1] && this.code[1].data.length === 216) {
                buffer.writeUInt32LE(this.signature, 440);
                this.copyProtected ? buffer.writeUInt16LE(23130, 444) : buffer.writeUInt16LE(0, 444);
            }
            var offset = this.tableOffset;
            this.partitions[0].buffer.copy(buffer, offset);
            this.partitions[1].buffer.copy(buffer, offset += 16);
            this.partitions[2].buffer.copy(buffer, offset += 16);
            this.partitions[3].buffer.copy(buffer, offset += 16);
            return buffer;
        },
        set buffer(value) {
            if (!Buffer.isBuffer(value)) throw new TypeError("Value must be a Buffer");
            this.physicalDrive = value.readUInt8(220);
            this.timestamp.seconds = value[221];
            this.timestamp.minutes = value[222];
            this.timestamp.hours = value[223];
            var marker = value.readUInt16LE(444);
            this.copyProtected = marker === 23130;
            this.signature = marker === 0 || this.copyProtected ? value.readUInt32LE(440) : null;
            var endOfCode = this.signature == null ? 446 : 440;
            this.code = [ new MBR.Code(value, 0, 218), new MBR.Code(value, 224, endOfCode) ];
            var i, count = this.partitionEntries;
            var offset = this.tableOffset;
            for (i = 0; i < count; i++) {
                this.partitions[i].buffer = value.slice(offset, offset += 16);
            }
        }
    };
    inherit(MODERN, MBR);
    module.exports = MODERN;
}, function(module, exports, __webpack_require__) {
    var inherit = __webpack_require__(15);
    var MBR = __webpack_require__(14);
    function AAP(buffer, start, end) {
        if (!(this instanceof AAP)) return new AAP(buffer, start, end);
        this.aap = new AAP.Record;
        MBR.call(this, buffer, start, end);
    }
    AAP.TABLE_OFFSET = 446;
    AAP.PARTITION_ENTRIES = 4;
    AAP.Record = __webpack_require__(135);
    AAP.prototype = {
        constructor: AAP,
        get buffer() {
            var buffer = MBR.createBuffer();
            var offset = this.tableOffset;
            for (var i = 0; i < this.code.length; i++) {
                this.code[i].data.copy(buffer, this.code[i].offset);
            }
            this.aap.buffer.copy(buffer, 430);
            this.partitions[0].buffer.copy(buffer, offset);
            this.partitions[1].buffer.copy(buffer, offset += 16);
            this.partitions[2].buffer.copy(buffer, offset += 16);
            this.partitions[3].buffer.copy(buffer, offset += 16);
            return buffer;
        },
        set buffer(value) {
            if (!Buffer.isBuffer(value)) throw new TypeError("Value must be a Buffer");
            this.code = [ new MBR.Code(value, 0, 427) ];
            this.aap.buffer = value.slice(430, 442);
            var i, count = this.partitionEntries;
            var offset = this.tableOffset;
            for (i = 0; i < count; i++) {
                this.partitions[i].buffer = value.slice(offset, offset += 16);
            }
        }
    };
    inherit(AAP, MBR);
    module.exports = AAP;
}, function(module, exports, __webpack_require__) {
    var CHS = __webpack_require__(48);
    function Record(buffer, start, end) {
        if (!(this instanceof Record)) return new Record(buffer, start, end);
        this.physicalDrive = 0;
        this.firstCHS = new CHS;
        this.partitionType = 0;
        this.lastCHS = new CHS;
        this.firstLBA = 0;
        this.sectors = 0;
        if (Buffer.isBuffer(buffer)) {
            this.buffer = buffer.slice(start, end);
        }
    }
    Record.prototype = {
        constructor: Record,
        get buffer() {
            var buffer = new Buffer(16);
            buffer.writeUInt8(this.physicalDrive, 0);
            buffer.writeUInt8(this.partitionType, 4);
            buffer.writeUInt32LE(this.firstLBA, 8);
            buffer.writeUInt32LE(this.sectors, 12);
            this.firstCHS.buffer.copy(buffer, 1);
            this.lastCHS.buffer.copy(buffer, 5);
            return buffer;
        },
        set buffer(value) {
            if (!Buffer.isBuffer(value)) throw new TypeError("Value must be a Buffer");
            this.physicalDrive = value.readUInt8(0);
            this.firstCHS.buffer = value.slice(1, 4);
            this.partitionType = value.readUInt8(4);
            this.lastCHS.buffer = value.slice(5, 8);
            this.firstLBA = value.readUInt32LE(8);
            this.sectors = value.readUInt32LE(12);
            return this;
        }
    };
    module.exports = Record;
}, function(module, exports, __webpack_require__) {
    var inherit = __webpack_require__(15);
    var MBR = __webpack_require__(14);
    function NEWLDR(buffer, start, end) {
        if (!(this instanceof NEWLDR)) return new NEWLDR(buffer, start, end);
        this.newldr = new NEWLDR.Record;
        this.aap = new MBR.AAP.Record;
        MBR.call(this, buffer, start, end);
    }
    NEWLDR.TABLE_OFFSET = 446;
    NEWLDR.PARTITION_ENTRIES = 4;
    NEWLDR.Record = __webpack_require__(137);
    NEWLDR.prototype = {
        constructor: NEWLDR,
        get buffer() {
            var buffer = MBR.createBuffer();
            var offset = this.tableOffset;
            for (var i = 0; i < this.code.length; i++) {
                this.code[i].data.copy(buffer, this.code[i].offset);
            }
            this.newldr.buffer.copy(buffer);
            this.aap.buffer.copy(buffer, 430);
            this.partitions[0].buffer.copy(buffer, offset);
            this.partitions[1].buffer.copy(buffer, offset += 16);
            this.partitions[2].buffer.copy(buffer, offset += 16);
            this.partitions[3].buffer.copy(buffer, offset += 16);
            return buffer;
        },
        set buffer(value) {
            if (!Buffer.isBuffer(value)) throw new TypeError("Value must be a Buffer");
            this.code = [ new MBR.Code(value, value[1], 428) ];
            this.newldr.buffer = value.slice(0, value[1]);
            this.aap.buffer = value.slice(430, 446);
            var i, count = this.partitionEntries;
            var offset = this.tableOffset;
            for (i = 0; i < count; i++) {
                this.partitions[i].buffer = value.slice(offset, offset += 16);
            }
        }
    };
    inherit(NEWLDR, MBR);
    module.exports = NEWLDR;
}, function(module, exports, __webpack_require__) {
    var CHS = __webpack_require__(48);
    function Record(buffer, start, end) {
        if (!(this instanceof Record)) return new Record(buffer, start, end);
        this.size = 22;
        this.physicalDrive = 0;
        this.firstCHS = new CHS;
        this.minDL = 0;
        this.firstLBA = 0;
        this.patchOffset = 0;
        this.checksum = 0;
        this.signature = "MSWIN4";
        if (Buffer.isBuffer(buffer)) {
            this.buffer = buffer.slice(start, end);
        }
    }
    Record.prototype = {
        constructor: Record,
        get buffer() {
            var buffer = new Buffer(30);
            buffer.fill(0);
            buffer[0] = 235;
            buffer.writeUInt8(this.size, 1);
            buffer.write("NEWLDR", 2, "ascii");
            buffer.writeUInt8(this.physicalDrive, 8);
            this.firstCHS.buffer.copy(buffer, 9);
            buffer.writeUInt8(this.minDL, 12);
            buffer.writeUInt32LE(this.firstLBA, 16);
            buffer.writeUInt16LE(this.patchOffset, 20);
            buffer.writeUInt16LE(this.checksum, 22);
            buffer.write(this.signature, 24, "ascii");
            return buffer;
        },
        set buffer(value) {
            if (!Buffer.isBuffer(value)) throw new TypeError("Value must be a Buffer");
            this.size = value.readUInt8(1);
            this.physicalDrive = value.readUInt8(8);
            this.firstCHS.buffer = value.slice(9, 12);
            this.minDL = value.readUInt8(12);
            this.firstLBA = value.readUInt32LE(16);
            this.patchOffset = value.readUInt16LE(20);
            this.checksum = value.readUInt16LE(22);
            this.signature = value.toString("ascii", 24);
        }
    };
    module.exports = Record;
}, function(module, exports, __webpack_require__) {
    var inherit = __webpack_require__(15);
    var MBR = __webpack_require__(14);
    function AST(buffer, start, end) {
        if (!(this instanceof AST)) return new AST(buffer, start, end);
        MBR.call(this, buffer, start, end);
    }
    AST.TABLE_OFFSET = 382;
    AST.PARTITION_ENTRIES = 8;
    AST.prototype = {
        constructor: AST,
        get buffer() {
            var buffer = MBR.createBuffer();
            var offset = this.tableOffset;
            for (var i = 0; i < this.code.length; i++) {
                this.code[i].data.copy(buffer, this.code[i].offset);
            }
            this.partitions[4].buffer.copy(buffer, offset);
            this.partitions[5].buffer.copy(buffer, offset += 16);
            this.partitions[6].buffer.copy(buffer, offset += 16);
            this.partitions[7].buffer.copy(buffer, offset += 16);
            this.partitions[0].buffer.copy(buffer, offset += 16);
            this.partitions[1].buffer.copy(buffer, offset += 16);
            this.partitions[2].buffer.copy(buffer, offset += 16);
            this.partitions[3].buffer.copy(buffer, offset += 16);
            return buffer;
        },
        set buffer(value) {
            if (!Buffer.isBuffer(value)) throw new TypeError("Value must be a Buffer");
            this.code = [ new MBR.Code(value, 0, 382) ];
            var i, count = 4;
            var offset = 446;
            for (i = 0; i < count; i++) {
                this.partitions[i].buffer = value.slice(offset, offset += 16);
            }
            count += count;
            offset = this.tableOffset;
            for (i = 4; i < count; i++) {
                this.partitions[i].buffer = value.slice(offset, offset += 16);
            }
        }
    };
    inherit(AST, MBR);
    module.exports = AST;
}, function(module, exports, __webpack_require__) {
    var inherit = __webpack_require__(15);
    var MBR = __webpack_require__(14);
    function DM(buffer, start, end) {
        if (!(this instanceof DM)) return new DM(buffer, start, end);
        MBR.call(this, buffer, start, end);
    }
    DM.TABLE_OFFSET = 254;
    DM.PARTITION_ENTRIES = 16;
    DM.prototype = {
        constructor: DM,
        get buffer() {
            var buffer = MBR.createBuffer();
            var offset = this.tableOffset;
            for (var i = 0; i < this.code.length; i++) {
                this.code[i].data.copy(buffer, this.code[i].offset);
            }
            for (var i = 4; i < DM.PARTITION_ENTRIES; i++) {
                this.partitions[i].buffer.copy(buffer, offset);
                offset += 16;
            }
            for (var i = 0; i < 4; i++) {
                this.partitions[i].buffer.copy(buffer, offset);
                offset += 16;
            }
            return buffer;
        },
        set buffer(value) {
            if (!Buffer.isBuffer(value)) throw new TypeError("Value must be a Buffer");
            this.code = [ new MBR.Code(value, 0, 254) ];
            var i, count = 4;
            var offset = 446;
            for (i = 0; i < count; i++) {
                this.partitions[i].buffer = value.slice(offset, offset += 16);
            }
            count *= 4;
            offset = this.tableOffset;
            for (i = 4; i < count; i++) {
                this.partitions[i].buffer = value.slice(offset, offset += 16);
            }
        }
    };
    inherit(DM, MBR);
    module.exports = DM;
}, function(module, exports) {
    module.exports = require("./modules/xxhash/build/Release/hash.node");
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.UsbbootScanner = exports.UsbbootDevice = exports.isUsbBootCapableUSBDevice = void 0;
    const usb = __webpack_require__(142);
    const _debug = __webpack_require__(49);
    const events_1 = __webpack_require__(9);
    const fs_1 = __webpack_require__(3);
    const Path = __webpack_require__(4);
    const util_1 = __webpack_require__(1);
    async function delay(ms) {
        await new Promise(resolve => {
            setTimeout(resolve, ms);
        });
    }
    function fromCallback(fn) {
        return new Promise((resolve, reject) => {
            fn((error, result) => {
                if (error == null) {
                    resolve(result);
                } else {
                    reject(error);
                }
            });
        });
    }
    const readFile = util_1.promisify(fs_1.readFile);
    const debug = _debug("node-raspberrypi-usbboot");
    const POLLING_INTERVAL_MS = 2e3;
    const TRANSFER_BLOCK_SIZE = 1024 ** 2;
    const NULL_BUFFER = Buffer.alloc(0);
    const BOOT_MESSAGE_BOOTCODE_LENGTH_SIZE = 4;
    const BOOT_MESSAGE_BOOTCODE_LENGTH_OFFSET = 0;
    const BOOT_MESSAGE_SIGNATURE_SIZE = 20;
    const FILE_MESSAGE_COMMAND_OFFSET = 0;
    const FILE_MESSAGE_COMMAND_SIZE = 4;
    const FILE_MESSAGE_FILE_NAME_OFFSET = FILE_MESSAGE_COMMAND_SIZE;
    const FILE_MESSAGE_FILE_NAME_SIZE = 256;
    const USB_REQUEST_CODE_GET_STATUS = 0;
    const USBBOOT_MESSAGE_MAX_BUFFER_LENGTH = 65535;
    const CONTROL_TRANSFER_INDEX_RIGHT_BIT_SHIFT = 16;
    const FILE_MESSAGE_SIZE = FILE_MESSAGE_COMMAND_SIZE + FILE_MESSAGE_FILE_NAME_SIZE;
    const RETURN_CODE_SUCCESS = 0;
    const RETURN_CODE_LENGTH = 4;
    const USB_CONTROL_TRANSFER_TIMEOUT_MS = 1e4;
    const USB_BULK_TRANSFER_TIMEOUT_MS = 1e4;
    const USB_ENDPOINT_INTERFACES_SOC_BCM2835 = 1;
    const USB_VENDOR_ID_BROADCOM_CORPORATION = 2652;
    const USB_PRODUCT_ID_BCM2708_BOOT = 10083;
    const USB_PRODUCT_ID_BCM2710_BOOT = 10084;
    const USB_VENDOR_ID_NETCHIP_TECHNOLOGY = 1317;
    const USB_PRODUCT_ID_POCKETBOOK_PRO_903 = 42149;
    const DEVICE_UNPLUG_TIMEOUT = 5e3;
    const READ_ERROR_DELAY = 100;
    var FileMessageCommand;
    (function(FileMessageCommand) {
        FileMessageCommand[FileMessageCommand["GetFileSize"] = 0] = "GetFileSize";
        FileMessageCommand[FileMessageCommand["ReadFile"] = 1] = "ReadFile";
        FileMessageCommand[FileMessageCommand["Done"] = 2] = "Done";
    })(FileMessageCommand || (FileMessageCommand = {}));
    const getCommand = fileMessageBuffer => {
        const command = fileMessageBuffer.readInt32LE(FILE_MESSAGE_COMMAND_OFFSET);
        if (!(command in FileMessageCommand)) {
            throw new Error(`Invalid file message command code: ${command}`);
        }
        return command;
    };
    const getFilename = fileMessageBuffer => {
        let end = fileMessageBuffer.indexOf(0, FILE_MESSAGE_FILE_NAME_OFFSET);
        if (end === -1) {
            end = fileMessageBuffer.length;
        }
        return fileMessageBuffer.slice(FILE_MESSAGE_FILE_NAME_OFFSET, end).toString("ascii");
    };
    const parseFileMessageBuffer = fileMessageBuffer => {
        let command = getCommand(fileMessageBuffer);
        const filename = getFilename(fileMessageBuffer);
        if (filename === "") {
            command = FileMessageCommand.Done;
        }
        return {
            command,
            filename
        };
    };
    const performControlTransfer = async (device, bmRequestType, bRequest, wValue, wIndex, dataOrLength) => {
        const previousTimeout = device.timeout;
        device.timeout = USB_CONTROL_TRANSFER_TIMEOUT_MS;
        const result = await fromCallback(callback => {
            device.controlTransfer(bmRequestType, bRequest, wValue, wIndex, dataOrLength, callback);
        });
        device.timeout = previousTimeout;
        return result;
    };
    exports.isUsbBootCapableUSBDevice = (idVendor, idProduct) => idVendor === USB_VENDOR_ID_BROADCOM_CORPORATION && (idProduct === USB_PRODUCT_ID_BCM2708_BOOT || idProduct === USB_PRODUCT_ID_BCM2710_BOOT);
    const isUsbBootCapableUSBDevice$ = device => exports.isUsbBootCapableUSBDevice(device.deviceDescriptor.idVendor, device.deviceDescriptor.idProduct);
    const isRaspberryPiInMassStorageMode = device => device.deviceDescriptor.idVendor === USB_VENDOR_ID_NETCHIP_TECHNOLOGY && device.deviceDescriptor.idProduct === USB_PRODUCT_ID_POCKETBOOK_PRO_903;
    const initializeDevice = device => {
        device.open();
        let interfaceNumber;
        let endpointNumber;
        if (device.configDescriptor.bNumInterfaces === USB_ENDPOINT_INTERFACES_SOC_BCM2835) {
            interfaceNumber = 0;
            endpointNumber = 1;
        } else {
            interfaceNumber = 1;
            endpointNumber = 3;
        }
        const iface = device.interface(interfaceNumber);
        iface.claim();
        const endpoint = iface.endpoint(endpointNumber);
        if (!(endpoint instanceof usb.OutEndpoint)) {
            throw new Error("endpoint is not an usb.OutEndpoint");
        }
        debug("Initialized device correctly", devicePortId(device));
        return {
            iface,
            endpoint
        };
    };
    const sendSize = async (device, size) => {
        await performControlTransfer(device, usb.LIBUSB_REQUEST_TYPE_VENDOR, USB_REQUEST_CODE_GET_STATUS, size & USBBOOT_MESSAGE_MAX_BUFFER_LENGTH, size >> CONTROL_TRANSFER_INDEX_RIGHT_BIT_SHIFT, NULL_BUFFER);
    };
    function* chunks(buffer, size) {
        for (let start = 0; start < buffer.length; start += size) {
            yield buffer.slice(start, start + size);
        }
    }
    const transfer = async (endpoint, chunk) => {
        endpoint.timeout = USB_BULK_TRANSFER_TIMEOUT_MS;
        for (let tries = 0; tries < 3; tries++) {
            if (tries > 0) {
                debug("Transfer stall, retrying");
            }
            try {
                await fromCallback(callback => {
                    endpoint.transfer(chunk, callback);
                });
                return;
            } catch (error) {
                if (error.errno === usb.LIBUSB_TRANSFER_STALL) {
                    continue;
                }
                throw error;
            }
        }
    };
    const epWrite = async (buffer, device, endpoint) => {
        debug("Sending buffer size", buffer.length);
        await sendSize(device, buffer.length);
        if (buffer.length > 0) {
            for (const chunk of chunks(buffer, TRANSFER_BLOCK_SIZE)) {
                debug("Sending chunk of size", chunk.length);
                await transfer(endpoint, chunk);
            }
        }
    };
    const epRead = async (device, bytesToRead) => await performControlTransfer(device, usb.LIBUSB_REQUEST_TYPE_VENDOR | usb.LIBUSB_ENDPOINT_IN, USB_REQUEST_CODE_GET_STATUS, bytesToRead & USBBOOT_MESSAGE_MAX_BUFFER_LENGTH, bytesToRead >> CONTROL_TRANSFER_INDEX_RIGHT_BIT_SHIFT, bytesToRead);
    const getDeviceId = device => `${device.busNumber}:${device.deviceAddress}`;
    const safeReadFile = async filename => {
        try {
            const {app, remote} = __webpack_require__(146);
            return await readFile(Path.join((app || remote.app).getAppPath(), "generated", __dirname.replace("node_modules", "modules"), "..", "blobs", filename));
        } catch (e) {}
    };
    const getFileBuffer = async filename => {
        let buffer = await safeReadFile(filename);
        if (buffer === undefined) {
            buffer = await safeReadFile(Path.join("raspberrypi", filename));
        }
        if (buffer === undefined) {
            debug("Can't read file", filename);
        }
        return buffer;
    };
    const createBootMessageBuffer = bootCodeBufferLength => {
        const bootMessageBufferSize = BOOT_MESSAGE_BOOTCODE_LENGTH_SIZE + BOOT_MESSAGE_SIGNATURE_SIZE;
        const bootMessageBuffer = Buffer.alloc(bootMessageBufferSize);
        bootMessageBuffer.writeInt32BE(bootCodeBufferLength, BOOT_MESSAGE_BOOTCODE_LENGTH_OFFSET);
        return bootMessageBuffer;
    };
    const secondStageBoot = async (device, endpoint) => {
        const bootcodeBuffer = await getFileBuffer("bootcode.bin");
        if (bootcodeBuffer === undefined) {
            throw new Error("Can't find bootcode.bin");
        }
        const bootMessage = createBootMessageBuffer(bootcodeBuffer.length);
        await epWrite(bootMessage, device, endpoint);
        debug(`Writing ${bootMessage.length} bytes`, devicePortId(device));
        await epWrite(bootcodeBuffer, device, endpoint);
        const data = await epRead(device, RETURN_CODE_LENGTH);
        const returnCode = data.readInt32LE(0);
        if (returnCode !== RETURN_CODE_SUCCESS) {
            throw new Error(`Couldn't write the bootcode, got return code ${returnCode} from device`);
        }
    };
    class UsbbootDevice extends events_1.EventEmitter {
        constructor(portId) {
            super();
            this.portId = portId;
            this._step = 0;
        }
        get progress() {
            return Math.round(this._step / UsbbootDevice.LAST_STEP * 100);
        }
        get step() {
            return this._step;
        }
        set step(step) {
            this._step = step;
            this.emit("progress", this.progress);
        }
    }
    exports.UsbbootDevice = UsbbootDevice;
    UsbbootDevice.LAST_STEP = 41;
    class UsbbootScanner extends events_1.EventEmitter {
        constructor() {
            super();
            this.usbbootDevices = new Map;
            this.attachedDeviceIds = new Set;
            this.boundAttachDevice = this.attachDevice.bind(this);
            this.boundDetachDevice = this.detachDevice.bind(this);
        }
        start() {
            debug("Waiting for BCM2835/6/7");
            usb.getDeviceList().map(this.boundAttachDevice);
            this.emit("ready");
            usb.on("attach", this.boundAttachDevice);
            usb.on("detach", this.boundDetachDevice);
            this.interval = setInterval(() => {
                usb.getDeviceList().forEach(this.boundAttachDevice);
            }, POLLING_INTERVAL_MS);
        }
        stop() {
            usb.removeListener("attach", this.boundAttachDevice);
            usb.removeListener("detach", this.boundDetachDevice);
            clearInterval(this.interval);
            this.usbbootDevices.clear();
        }
        step(device, step) {
            const usbbootDevice = this.getOrCreate(device);
            usbbootDevice.step = step;
            if (step === UsbbootDevice.LAST_STEP) {
                this.remove(device);
            }
        }
        get(device) {
            const key = devicePortId(device);
            return this.usbbootDevices.get(key);
        }
        getOrCreate(device) {
            const key = devicePortId(device);
            let usbbootDevice = this.usbbootDevices.get(key);
            if (usbbootDevice === undefined) {
                usbbootDevice = new UsbbootDevice(key);
                this.usbbootDevices.set(key, usbbootDevice);
                this.emit("attach", usbbootDevice);
            }
            return usbbootDevice;
        }
        remove(device) {
            const key = devicePortId(device);
            const usbbootDevice = this.usbbootDevices.get(key);
            if (usbbootDevice !== undefined) {
                this.usbbootDevices.delete(key);
                this.emit("detach", usbbootDevice);
            }
        }
        async attachDevice(device) {
            if (this.attachedDeviceIds.has(getDeviceId(device))) {
                return;
            }
            this.attachedDeviceIds.add(getDeviceId(device));
            if (isRaspberryPiInMassStorageMode(device) && this.usbbootDevices.has(devicePortId(device))) {
                this.step(device, 41);
                return;
            }
            if (!isUsbBootCapableUSBDevice$(device)) {
                return;
            }
            debug("Found serial number", device.deviceDescriptor.iSerialNumber);
            debug("port id", devicePortId(device));
            try {
                const {endpoint} = initializeDevice(device);
                if (device.deviceDescriptor.iSerialNumber === 0) {
                    debug("Sending bootcode.bin", devicePortId(device));
                    this.step(device, 0);
                    await secondStageBoot(device, endpoint);
                } else {
                    debug("Second stage boot server", devicePortId(device));
                    await this.fileServer(device, endpoint, 2);
                }
                device.close();
            } catch (error) {
                debug("error", error, devicePortId(device));
                this.remove(device);
            }
        }
        detachDevice(device) {
            this.attachedDeviceIds.delete(getDeviceId(device));
            if (!isUsbBootCapableUSBDevice$(device)) {
                return;
            }
            const step = device.deviceDescriptor.iSerialNumber === 0 ? 1 : 40;
            debug("detach", devicePortId(device), step);
            this.step(device, step);
            setTimeout(() => {
                const usbbootDevice = this.get(device);
                if (usbbootDevice !== undefined && usbbootDevice.step === step) {
                    debug("device", devicePortId(device), "did not reattached after", DEVICE_UNPLUG_TIMEOUT, "ms.");
                    this.remove(device);
                }
            }, DEVICE_UNPLUG_TIMEOUT);
        }
        async fileServer(device, endpoint, step) {
            while (true) {
                this.step(device, step);
                step += 1;
                let data;
                try {
                    data = await epRead(device, FILE_MESSAGE_SIZE);
                } catch (error) {
                    if (error.message === "LIBUSB_ERROR_NO_DEVICE" || error.message === "LIBUSB_ERROR_IO") {
                        break;
                    }
                    await delay(READ_ERROR_DELAY);
                    continue;
                }
                const message = parseFileMessageBuffer(data);
                debug("Received message", FileMessageCommand[message.command], message.filename, devicePortId(device));
                if (message.command === FileMessageCommand.GetFileSize || message.command === FileMessageCommand.ReadFile) {
                    const buffer = await getFileBuffer(message.filename);
                    if (buffer === undefined) {
                        debug(`Couldn't find ${message.filename}`, devicePortId(device));
                        await sendSize(device, 0);
                    } else {
                        if (message.command === FileMessageCommand.GetFileSize) {
                            await sendSize(device, buffer.length);
                        } else {
                            await epWrite(buffer, device, endpoint);
                        }
                    }
                } else if (message.command === FileMessageCommand.Done) {
                    break;
                }
            }
            debug("File server done", devicePortId(device));
            await delay(2e3);
            try {
                device.open();
            } catch (_a) {}
        }
    }
    exports.UsbbootScanner = UsbbootScanner;
    const devicePortId = device => {
        let result = `${device.busNumber}`;
        if (device.portNumbers !== undefined) {
            result += `-${device.portNumbers.join(".")}`;
        }
        return result;
    };
}, function(module, exports, __webpack_require__) {
    var binary = __webpack_require__(73);
    var path = __webpack_require__(4);
    var binding_path = binary.find(path.resolve(path.join(__dirname, "./package.json")));
    var usb = exports = module.exports = __webpack_require__(143);
    var events = __webpack_require__(9);
    var util = __webpack_require__(1);
    if (usb.INIT_ERROR) {
        console.warn("Failed to initialize libusb.");
        usb.Device = function() {
            throw new Error("Device cannot be instantiated directly.");
        };
        usb.Transfer = function() {
            throw new Error("Transfer cannot be instantiated directly.");
        };
        usb.setDebugLevel = function() {};
        usb.getDeviceList = function() {
            return [];
        };
        usb._enableHotplugEvents = function() {};
        usb._disableHotplugEvents = function() {};
    }
    Object.keys(events.EventEmitter.prototype).forEach((function(key) {
        exports[key] = events.EventEmitter.prototype[key];
    }));
    exports.findByIds = function(vid, pid) {
        var devices = usb.getDeviceList();
        for (var i = 0; i < devices.length; i++) {
            var deviceDesc = devices[i].deviceDescriptor;
            if (deviceDesc.idVendor == vid && deviceDesc.idProduct == pid) {
                return devices[i];
            }
        }
    };
    usb.Device.prototype.timeout = 1e3;
    usb.Device.prototype.open = function(defaultConfig) {
        this.__open();
        if (defaultConfig === false) return;
        this.interfaces = [];
        var len = this.configDescriptor.interfaces.length;
        for (var i = 0; i < len; i++) {
            this.interfaces[i] = new Interface(this, i);
        }
    };
    usb.Device.prototype.close = function() {
        this.__close();
        this.interfaces = null;
    };
    Object.defineProperty(usb.Device.prototype, "configDescriptor", {
        get: function() {
            return this._configDescriptor || (this._configDescriptor = this.__getConfigDescriptor());
        }
    });
    Object.defineProperty(usb.Device.prototype, "allConfigDescriptors", {
        get: function() {
            return this._allConfigDescriptors || (this._allConfigDescriptors = this.__getAllConfigDescriptors());
        }
    });
    Object.defineProperty(usb.Device.prototype, "parent", {
        get: function() {
            return this._parent || (this._parent = this.__getParent());
        }
    });
    usb.Device.prototype.interface = function(addr) {
        if (!this.interfaces) {
            throw new Error("Device must be open before searching for interfaces");
        }
        addr = addr || 0;
        for (var i = 0; i < this.interfaces.length; i++) {
            if (this.interfaces[i].interfaceNumber == addr) {
                return this.interfaces[i];
            }
        }
    };
    var SETUP_SIZE = usb.LIBUSB_CONTROL_SETUP_SIZE;
    usb.Device.prototype.controlTransfer = function(bmRequestType, bRequest, wValue, wIndex, data_or_length, callback) {
        var self = this;
        var isIn = !!(bmRequestType & usb.LIBUSB_ENDPOINT_IN);
        var wLength;
        if (isIn) {
            if (!(data_or_length >= 0)) {
                throw new TypeError("Expected size number for IN transfer (based on bmRequestType)");
            }
            wLength = data_or_length;
        } else {
            if (!Buffer.isBuffer(data_or_length)) {
                throw new TypeError("Expected buffer for OUT transfer (based on bmRequestType)");
            }
            wLength = data_or_length.length;
        }
        var buf = new Buffer(wLength + SETUP_SIZE);
        buf.writeUInt8(bmRequestType, 0);
        buf.writeUInt8(bRequest, 1);
        buf.writeUInt16LE(wValue, 2);
        buf.writeUInt16LE(wIndex, 4);
        buf.writeUInt16LE(wLength, 6);
        if (!isIn) {
            data_or_length.copy(buf, SETUP_SIZE);
        }
        var transfer = new usb.Transfer(this, 0, usb.LIBUSB_TRANSFER_TYPE_CONTROL, this.timeout, (function(error, buf, actual) {
            if (callback) {
                if (isIn) {
                    callback.call(self, error, buf.slice(SETUP_SIZE, SETUP_SIZE + actual));
                } else {
                    callback.call(self, error);
                }
            }
        }));
        try {
            transfer.submit(buf);
        } catch (e) {
            if (callback) {
                process.nextTick((function() {
                    callback.call(self, e);
                }));
            }
        }
        return this;
    };
    usb.Device.prototype.getStringDescriptor = function(desc_index, callback) {
        var langid = 1033;
        var length = 255;
        this.controlTransfer(usb.LIBUSB_ENDPOINT_IN, usb.LIBUSB_REQUEST_GET_DESCRIPTOR, usb.LIBUSB_DT_STRING << 8 | desc_index, langid, length, (function(error, buf) {
            if (error) return callback(error);
            callback(undefined, buf.toString("utf16le", 2));
        }));
    };
    usb.Device.prototype.setConfiguration = function(desired, cb) {
        var self = this;
        this.__setConfiguration(desired, (function(err) {
            if (!err) {
                this.interfaces = [];
                var len = this.configDescriptor.interfaces.length;
                for (var i = 0; i < len; i++) {
                    this.interfaces[i] = new Interface(this, i);
                }
            }
            cb.call(self, err);
        }));
    };
    function Interface(device, id) {
        this.device = device;
        this.id = id;
        this.altSetting = 0;
        this.__refresh();
    }
    Interface.prototype.__refresh = function() {
        this.descriptor = this.device.configDescriptor.interfaces[this.id][this.altSetting];
        this.interfaceNumber = this.descriptor.bInterfaceNumber;
        this.endpoints = [];
        var len = this.descriptor.endpoints.length;
        for (var i = 0; i < len; i++) {
            var desc = this.descriptor.endpoints[i];
            var c = desc.bEndpointAddress & usb.LIBUSB_ENDPOINT_IN ? InEndpoint : OutEndpoint;
            this.endpoints[i] = new c(this.device, desc);
        }
    };
    Interface.prototype.claim = function() {
        this.device.__claimInterface(this.id);
    };
    Interface.prototype.release = function(closeEndpoints, cb) {
        var self = this;
        if (typeof closeEndpoints == "function") {
            cb = closeEndpoints;
            closeEndpoints = null;
        }
        if (!closeEndpoints || this.endpoints.length == 0) {
            next();
        } else {
            var n = self.endpoints.length;
            self.endpoints.forEach((function(ep, i) {
                if (ep.pollActive) {
                    ep.once("end", (function() {
                        if (--n == 0) next();
                    }));
                    ep.stopPoll();
                } else {
                    if (--n == 0) next();
                }
            }));
        }
        function next() {
            self.device.__releaseInterface(self.id, (function(err) {
                if (!err) {
                    self.altSetting = 0;
                    self.__refresh();
                }
                cb.call(self, err);
            }));
        }
    };
    Interface.prototype.isKernelDriverActive = function() {
        return this.device.__isKernelDriverActive(this.id);
    };
    Interface.prototype.detachKernelDriver = function() {
        return this.device.__detachKernelDriver(this.id);
    };
    Interface.prototype.attachKernelDriver = function() {
        return this.device.__attachKernelDriver(this.id);
    };
    Interface.prototype.setAltSetting = function(altSetting, cb) {
        var self = this;
        this.device.__setInterface(this.id, altSetting, (function(err) {
            if (!err) {
                self.altSetting = altSetting;
                self.__refresh();
            }
            cb.call(self, err);
        }));
    };
    Interface.prototype.endpoint = function(addr) {
        for (var i = 0; i < this.endpoints.length; i++) {
            if (this.endpoints[i].address == addr) {
                return this.endpoints[i];
            }
        }
    };
    function Endpoint(device, descriptor) {
        this.device = device;
        this.descriptor = descriptor;
        this.address = descriptor.bEndpointAddress;
        this.transferType = descriptor.bmAttributes & 3;
    }
    util.inherits(Endpoint, events.EventEmitter);
    Endpoint.prototype.timeout = 0;
    Endpoint.prototype.makeTransfer = function(timeout, callback) {
        return new usb.Transfer(this.device, this.address, this.transferType, timeout, callback);
    };
    Endpoint.prototype.startPoll = function(nTransfers, transferSize, callback) {
        if (this.pollTransfers) {
            throw new Error("Polling already active");
        }
        nTransfers = nTransfers || 3;
        this.pollTransferSize = transferSize || this.descriptor.wMaxPacketSize;
        this.pollActive = true;
        this.pollPending = 0;
        var transfers = [];
        for (var i = 0; i < nTransfers; i++) {
            transfers[i] = this.makeTransfer(0, callback);
        }
        return transfers;
    };
    Endpoint.prototype.stopPoll = function(cb) {
        if (!this.pollTransfers) {
            throw new Error("Polling is not active.");
        }
        for (var i = 0; i < this.pollTransfers.length; i++) {
            try {
                this.pollTransfers[i].cancel();
            } catch (err) {
                this.emit("error", err);
            }
        }
        this.pollActive = false;
        if (cb) this.once("end", cb);
    };
    function InEndpoint(device, descriptor) {
        Endpoint.call(this, device, descriptor);
    }
    exports.InEndpoint = InEndpoint;
    util.inherits(InEndpoint, Endpoint);
    InEndpoint.prototype.direction = "in";
    InEndpoint.prototype.transfer = function(length, cb) {
        var self = this;
        var buffer = new Buffer(length);
        function callback(error, buf, actual) {
            cb.call(self, error, buffer.slice(0, actual));
        }
        try {
            this.makeTransfer(this.timeout, callback).submit(buffer);
        } catch (e) {
            process.nextTick((function() {
                cb.call(self, e);
            }));
        }
        return this;
    };
    InEndpoint.prototype.startPoll = function(nTransfers, transferSize) {
        var self = this;
        this.pollTransfers = InEndpoint.super_.prototype.startPoll.call(this, nTransfers, transferSize, transferDone);
        function transferDone(error, buf, actual) {
            if (!error) {
                self.emit("data", buf.slice(0, actual));
            } else if (error.errno != usb.LIBUSB_TRANSFER_CANCELLED) {
                self.emit("error", error);
                self.stopPoll();
            }
            if (self.pollActive) {
                startTransfer(this);
            } else {
                self.pollPending--;
                if (self.pollPending == 0) {
                    self.emit("end");
                }
            }
        }
        function startTransfer(t) {
            try {
                t.submit(new Buffer(self.pollTransferSize), transferDone);
            } catch (e) {
                self.emit("error", e);
                self.stopPoll();
            }
        }
        this.pollTransfers.forEach(startTransfer);
        self.pollPending = this.pollTransfers.length;
    };
    function OutEndpoint(device, descriptor) {
        Endpoint.call(this, device, descriptor);
    }
    exports.OutEndpoint = OutEndpoint;
    util.inherits(OutEndpoint, Endpoint);
    OutEndpoint.prototype.direction = "out";
    OutEndpoint.prototype.transfer = function(buffer, cb) {
        var self = this;
        if (!buffer) {
            buffer = new Buffer(0);
        } else if (!Buffer.isBuffer(buffer)) {
            buffer = new Buffer(buffer);
        }
        function callback(error, buf, actual) {
            if (cb) cb.call(self, error);
        }
        try {
            this.makeTransfer(this.timeout, callback).submit(buffer);
        } catch (e) {
            process.nextTick((function() {
                callback(e);
            }));
        }
        return this;
    };
    OutEndpoint.prototype.transferWithZLP = function(buf, cb) {
        if (buf.length % this.descriptor.wMaxPacketSize == 0) {
            this.transfer(buf);
            this.transfer(new Buffer(0), cb);
        } else {
            this.transfer(buf, cb);
        }
    };
    var hotplugListeners = 0;
    exports.on("newListener", (function(name) {
        if (name !== "attach" && name !== "detach") return;
        if (++hotplugListeners === 1) {
            usb._enableHotplugEvents();
        }
    }));
    exports.on("removeListener", (function(name) {
        if (name !== "attach" && name !== "detach") return;
        if (--hotplugListeners === 0) {
            usb._disableHotplugEvents();
        }
    }));
}, function(module, exports) {
    module.exports = require("./modules/@balena.io/usb/build/Release/usb_bindings.node");
}, function(module, exports, __webpack_require__) {
    exports.formatArgs = formatArgs;
    exports.save = save;
    exports.load = load;
    exports.useColors = useColors;
    exports.storage = localstorage();
    exports.colors = [ "#0000CC", "#0000FF", "#0033CC", "#0033FF", "#0066CC", "#0066FF", "#0099CC", "#0099FF", "#00CC00", "#00CC33", "#00CC66", "#00CC99", "#00CCCC", "#00CCFF", "#3300CC", "#3300FF", "#3333CC", "#3333FF", "#3366CC", "#3366FF", "#3399CC", "#3399FF", "#33CC00", "#33CC33", "#33CC66", "#33CC99", "#33CCCC", "#33CCFF", "#6600CC", "#6600FF", "#6633CC", "#6633FF", "#66CC00", "#66CC33", "#9900CC", "#9900FF", "#9933CC", "#9933FF", "#99CC00", "#99CC33", "#CC0000", "#CC0033", "#CC0066", "#CC0099", "#CC00CC", "#CC00FF", "#CC3300", "#CC3333", "#CC3366", "#CC3399", "#CC33CC", "#CC33FF", "#CC6600", "#CC6633", "#CC9900", "#CC9933", "#CCCC00", "#CCCC33", "#FF0000", "#FF0033", "#FF0066", "#FF0099", "#FF00CC", "#FF00FF", "#FF3300", "#FF3333", "#FF3366", "#FF3399", "#FF33CC", "#FF33FF", "#FF6600", "#FF6633", "#FF9900", "#FF9933", "#FFCC00", "#FFCC33" ];
    function useColors() {
        if (typeof window !== "undefined" && window.process && (window.process.type === "renderer" || window.process.__nwjs)) {
            return true;
        }
        if (typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)) {
            return false;
        }
        return typeof document !== "undefined" && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance || typeof window !== "undefined" && window.console && (window.console.firebug || window.console.exception && window.console.table) || typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31 || typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/);
    }
    function formatArgs(args) {
        args[0] = (this.useColors ? "%c" : "") + this.namespace + (this.useColors ? " %c" : " ") + args[0] + (this.useColors ? "%c " : " ") + "+" + module.exports.humanize(this.diff);
        if (!this.useColors) {
            return;
        }
        const c = "color: " + this.color;
        args.splice(1, 0, c, "color: inherit");
        let index = 0;
        let lastC = 0;
        args[0].replace(/%[a-zA-Z%]/g, match => {
            if (match === "%%") {
                return;
            }
            index++;
            if (match === "%c") {
                lastC = index;
            }
        });
        args.splice(lastC, 0, c);
    }
    exports.log = console.debug || console.log || (() => {});
    function save(namespaces) {
        try {
            if (namespaces) {
                exports.storage.setItem("debug", namespaces);
            } else {
                exports.storage.removeItem("debug");
            }
        } catch (error) {}
    }
    function load() {
        let r;
        try {
            r = exports.storage.getItem("debug");
        } catch (error) {}
        if (!r && typeof process !== "undefined" && "env" in process) {
            r = process.env.DEBUG;
        }
        return r;
    }
    function localstorage() {
        try {
            return localStorage;
        } catch (error) {}
    }
    module.exports = __webpack_require__(74)(exports);
    const {formatters} = module.exports;
    formatters.j = function(v) {
        try {
            return JSON.stringify(v);
        } catch (error) {
            return "[UnexpectedJSONParseError]: " + error.message;
        }
    };
}, function(module, exports, __webpack_require__) {
    const tty = __webpack_require__(30);
    const util = __webpack_require__(1);
    exports.init = init;
    exports.log = log;
    exports.formatArgs = formatArgs;
    exports.save = save;
    exports.load = load;
    exports.useColors = useColors;
    exports.colors = [ 6, 2, 3, 4, 5, 1 ];
    try {
        const supportsColor = __webpack_require__(31);
        if (supportsColor && (supportsColor.stderr || supportsColor).level >= 2) {
            exports.colors = [ 20, 21, 26, 27, 32, 33, 38, 39, 40, 41, 42, 43, 44, 45, 56, 57, 62, 63, 68, 69, 74, 75, 76, 77, 78, 79, 80, 81, 92, 93, 98, 99, 112, 113, 128, 129, 134, 135, 148, 149, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 178, 179, 184, 185, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 214, 215, 220, 221 ];
        }
    } catch (error) {}
    exports.inspectOpts = Object.keys(process.env).filter(key => /^debug_/i.test(key)).reduce((obj, key) => {
        const prop = key.substring(6).toLowerCase().replace(/_([a-z])/g, (_, k) => k.toUpperCase());
        let val = process.env[key];
        if (/^(yes|on|true|enabled)$/i.test(val)) {
            val = true;
        } else if (/^(no|off|false|disabled)$/i.test(val)) {
            val = false;
        } else if (val === "null") {
            val = null;
        } else {
            val = Number(val);
        }
        obj[prop] = val;
        return obj;
    }, {});
    function useColors() {
        return "colors" in exports.inspectOpts ? Boolean(exports.inspectOpts.colors) : tty.isatty(process.stderr.fd);
    }
    function formatArgs(args) {
        const {namespace: name, useColors} = this;
        if (useColors) {
            const c = this.color;
            const colorCode = "[3" + (c < 8 ? c : "8;5;" + c);
            const prefix = `  ${colorCode};1m${name} [0m`;
            args[0] = prefix + args[0].split("\n").join("\n" + prefix);
            args.push(colorCode + "m+" + module.exports.humanize(this.diff) + "[0m");
        } else {
            args[0] = getDate() + name + " " + args[0];
        }
    }
    function getDate() {
        if (exports.inspectOpts.hideDate) {
            return "";
        }
        return (new Date).toISOString() + " ";
    }
    function log(...args) {
        return process.stderr.write(util.format(...args) + "\n");
    }
    function save(namespaces) {
        if (namespaces) {
            process.env.DEBUG = namespaces;
        } else {
            delete process.env.DEBUG;
        }
    }
    function load() {
        return process.env.DEBUG;
    }
    function init(debug) {
        debug.inspectOpts = {};
        const keys = Object.keys(exports.inspectOpts);
        for (let i = 0; i < keys.length; i++) {
            debug.inspectOpts[keys[i]] = exports.inspectOpts[keys[i]];
        }
    }
    module.exports = __webpack_require__(74)(exports);
    const {formatters} = module.exports;
    formatters.o = function(v) {
        this.inspectOpts.colors = this.useColors;
        return util.inspect(v, this.inspectOpts).replace(/\s*\n\s*/g, " ");
    };
    formatters.O = function(v) {
        this.inspectOpts.colors = this.useColors;
        return util.inspect(v, this.inspectOpts);
    };
}, function(module, exports) {
    module.exports = require("electron");
}, function(module, exports, __webpack_require__) {
    "use strict";
    module.exports = __webpack_require__(148);
}, function(module, exports) {
    module.exports = require("./modules/mountutils/build/Release/MountUtils.node");
}, function(module, exports, __webpack_require__) {
    "use strict";
    module.exports = __webpack_require__(150);
}, function(module, exports, __webpack_require__) {
    const {promisify} = __webpack_require__(1);
    const bindings = __webpack_require__(76);
    exports.constants = __webpack_require__(51);
    const diskModule = __webpack_require__(151);
    let mounts = 0;
    function closeIfNoMountsLeft() {
        if (mounts === 0) {
            bindings.closeExt();
        }
    }
    exports.mount = function(disk, options, callback) {
        if (mounts === 0) {
            bindings.init();
        }
        mounts += 1;
        if (callback === undefined) {
            callback = options;
            options = {};
        }
        const offset = options.offset || 0;
        delete options.offset;
        const wrapper = new diskModule.DiskWrapper(disk, offset);
        const request = wrapper.request.bind(wrapper);
        bindings.mount(request, (function(err, filesystem) {
            if (err) {
                mounts -= 1;
                closeIfNoMountsLeft();
                callback(err);
                return;
            }
            const fs = __webpack_require__(152)(filesystem, options);
            fs.filesystem = filesystem;
            fs.trim = function(callback) {
                bindings.trim(filesystem, callback);
            };
            callback(null, fs);
        }));
    };
    exports.umount = function(fs, callback) {
        fs.closeAllFileDescriptors((function(err) {
            if (err) {
                callback(err);
                return;
            }
            bindings.umount(fs.filesystem, (function(err) {
                mounts -= 1;
                closeIfNoMountsLeft();
                callback(err);
            }));
        }));
    };
    const mountAsync = promisify(exports.mount);
    const umountAsync = promisify(exports.umount);
    exports.withMountedDisk = async function(disk, options, fn) {
        const fs = await mountAsync(disk, options || {});
        try {
            return await fn(fs);
        } finally {
            await umountAsync(fs);
        }
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    const constants = __webpack_require__(51);
    const promiseToCallback = (promise, callback, transform) => {
        promise.then(result => {
            const args = transform === undefined ? [] : transform(result);
            callback(null, ...args);
        }).catch(callback);
    };
    class DiskWrapper {
        constructor(disk, offset = 0) {
            this.disk = disk;
            this.offset = offset;
        }
        request(type, offset, length, buffer, fn, s, callback2) {
            const callback = err => {
                callback2(err, fn, s);
            };
            offset += this.offset;
            switch (type) {
              case constants.E2FS_BLK_OPEN:
              case constants.E2FS_BLK_CLOSE:
              case constants.E2FS_BLK_CACHE_READAHEAD:
                callback(null);
                break;

              case constants.E2FS_BLK_READ:
                promiseToCallback(this.disk.read(buffer, 0, buffer.length, offset), callback, ({bytesRead, buffer}) => [ bytesRead, buffer ]);
                break;

              case constants.E2FS_BLK_WRITE:
                promiseToCallback(this.disk.write(buffer, 0, buffer.length, offset), callback, ({bytesWritten, buffer}) => [ bytesWritten, buffer ]);
                break;

              case constants.E2FS_BLK_FLUSH:
                promiseToCallback(this.disk.flush(), callback);
                break;

              case constants.E2FS_BLK_DISCARD:
                promiseToCallback(this.disk.discard(offset, length), callback);
                break;

              case constants.E2FS_BLK_ZEROOUT:
                promiseToCallback(this.disk.write(Buffer.alloc(length), 0, length, offset).then(() => this.disk.discard(offset, length)), callback);
                break;

              default:
                console.warn("Unknown request type in DiskWrapper.request():", type);
                callback(constants.EINVAL);
            }
        }
    }
    exports.DiskWrapper = DiskWrapper;
}, function(module, exports, __webpack_require__) {
    "use strict";
    module.exports = function(filesystem, fsOptions) {
        const util = __webpack_require__(1);
        const pathModule = __webpack_require__(4);
        const binding = __webpack_require__(153)(filesystem, fsOptions);
        const fs = {};
        fs.closeAllFileDescriptors = binding.closeAllFileDescriptors;
        const Buffer = __webpack_require__(37).Buffer;
        const Stream = __webpack_require__(0).Stream;
        const EventEmitter = __webpack_require__(9);
        const FSReqWrap = binding.FSReqWrap;
        const FSEvent = process.binding("fs_event_wrap").FSEvent;
        const internalFS = __webpack_require__(155);
        const assertEncoding = internalFS.assertEncoding;
        const stringToFlags = internalFS.stringToFlags;
        const SyncWriteStream = internalFS.SyncWriteStream;
        const constants = {
            O_RDONLY: 0,
            O_WRONLY: 1,
            O_RDWR: 2,
            S_IFMT: 61440,
            S_IFREG: 32768,
            S_IFDIR: 16384,
            S_IFCHR: 8192,
            S_IFBLK: 24576,
            S_IFIFO: 4096,
            S_IFLNK: 40960,
            S_IFSOCK: 49152,
            O_CREAT: 64,
            O_EXCL: 128,
            O_NOCTTY: 256,
            O_TRUNC: 512,
            O_APPEND: 1024,
            O_DIRECTORY: 65536,
            O_NOATIME: 262144,
            O_NOFOLLOW: 131072,
            O_SYNC: 1052672,
            O_DIRECT: 16384,
            O_NONBLOCK: 2048,
            S_IRWXU: 448,
            S_IRUSR: 256,
            S_IWUSR: 128,
            S_IXUSR: 64,
            S_IRWXG: 56,
            S_IRGRP: 32,
            S_IWGRP: 16,
            S_IXGRP: 8,
            S_IRWXO: 7,
            S_IROTH: 4,
            S_IWOTH: 2,
            S_IXOTH: 1,
            F_OK: 0,
            R_OK: 4,
            W_OK: 2,
            X_OK: 1
        };
        Object.defineProperty(fs, "constants", {
            configurable: false,
            enumerable: true,
            value: constants
        });
        const Readable = Stream.Readable;
        const Writable = Stream.Writable;
        const kMinPoolSpace = 128;
        const kMaxLength = __webpack_require__(37).kMaxLength;
        const isWindows = process.platform === "win32";
        const DEBUG = process.env.NODE_DEBUG && /fs/.test(process.env.NODE_DEBUG);
        const errnoException = util._errnoException;
        pathModule._makeLong = function(path) {
            if (typeof path !== "string") return path;
            if (path.length === 0) {
                return "";
            }
            const resolvedPath = path;
            if (resolvedPath.length >= 3) {
                var code = resolvedPath.charCodeAt(0);
                if (code === 92) {
                    if (resolvedPath.charCodeAt(1) === 92) {
                        code = resolvedPath.charCodeAt(2);
                        if (code !== 63 && code !== 46) {
                            return "\\\\?\\UNC\\" + resolvedPath.slice(2);
                        }
                    }
                } else if (code >= 65 && code <= 90 || code >= 97 && code <= 122) {
                    if (resolvedPath.charCodeAt(1) === 58 && resolvedPath.charCodeAt(2) === 92) {
                        return "\\\\?\\" + resolvedPath;
                    }
                }
            }
            return path;
        };
        function getOptions(options, defaultOptions) {
            if (options === null || options === undefined || typeof options === "function") {
                return defaultOptions;
            }
            if (typeof options === "string") {
                defaultOptions = util._extend({}, defaultOptions);
                defaultOptions.encoding = options;
                options = defaultOptions;
            } else if (typeof options !== "object") {
                throw new TypeError('"options" must be a string or an object, got ' + typeof options + " instead.");
            }
            if (options.encoding !== "buffer") assertEncoding(options.encoding);
            return options;
        }
        function copyObject(source) {
            const target = {};
            for (const key in source) target[key] = source[key];
            return target;
        }
        function rethrow() {
            process.emitWarning("Calling an asynchronous function without callback is deprecated.", "DeprecationWarning", rethrow);
            if (DEBUG) {
                var backtrace = new Error;
                return function(err) {
                    if (err) {
                        backtrace.stack = err.name + ": " + err.message + backtrace.stack.substr(backtrace.name.length);
                        throw backtrace;
                    }
                };
            }
            return function(err) {
                if (err) {
                    throw err;
                }
            };
        }
        function maybeCallback(cb) {
            return typeof cb === "function" ? cb : rethrow();
        }
        function makeCallback(cb) {
            if (cb === undefined) {
                return rethrow();
            }
            if (typeof cb !== "function") {
                throw new TypeError('"callback" argument must be a function');
            }
            return function() {
                return cb.apply(null, arguments);
            };
        }
        function nullCheck(path, callback) {
            if (("" + path).indexOf("\0") !== -1) {
                var er = new Error("Path must be a string without null bytes");
                er.code = "ENOENT";
                if (typeof callback !== "function") throw er;
                process.nextTick(callback, er);
                return false;
            }
            return true;
        }
        function isFd(path) {
            return path >>> 0 === path;
        }
        fs.Stats = function(dev, mode, nlink, uid, gid, rdev, blksize, ino, size, blocks, atim_msec, mtim_msec, ctim_msec, birthtim_msec) {
            this.dev = dev;
            this.mode = mode;
            this.nlink = nlink;
            this.uid = uid;
            this.gid = gid;
            this.rdev = rdev;
            this.blksize = blksize;
            this.ino = ino;
            this.size = size;
            this.blocks = blocks;
            this.atime = new Date(atim_msec);
            this.mtime = new Date(mtim_msec);
            this.ctime = new Date(ctim_msec);
            this.birthtime = new Date(birthtim_msec);
        };
        binding.FSInitialize(fs.Stats);
        fs.Stats.prototype._checkModeProperty = function(property) {
            return (this.mode & constants.S_IFMT) === property;
        };
        fs.Stats.prototype.isDirectory = function() {
            return this._checkModeProperty(constants.S_IFDIR);
        };
        fs.Stats.prototype.isFile = function() {
            return this._checkModeProperty(constants.S_IFREG);
        };
        fs.Stats.prototype.isBlockDevice = function() {
            return this._checkModeProperty(constants.S_IFBLK);
        };
        fs.Stats.prototype.isCharacterDevice = function() {
            return this._checkModeProperty(constants.S_IFCHR);
        };
        fs.Stats.prototype.isSymbolicLink = function() {
            return this._checkModeProperty(constants.S_IFLNK);
        };
        fs.Stats.prototype.isFIFO = function() {
            return this._checkModeProperty(constants.S_IFIFO);
        };
        fs.Stats.prototype.isSocket = function() {
            return this._checkModeProperty(constants.S_IFSOCK);
        };
        [ "F_OK", "R_OK", "W_OK", "X_OK" ].forEach((function(key) {
            Object.defineProperty(fs, key, {
                enumerable: true,
                value: constants[key] || 0,
                writable: false
            });
        }));
        fs.access = function(path, mode, callback) {
            if (typeof mode === "function") {
                callback = mode;
                mode = fs.F_OK;
            } else if (typeof callback !== "function") {
                throw new TypeError('"callback" argument must be a function');
            }
            if (!nullCheck(path, callback)) return;
            mode = mode | 0;
            var req = new FSReqWrap;
            req.oncomplete = makeCallback(callback);
            binding.access(pathModule._makeLong(path), mode, req);
        };
        fs.accessSync = function(path, mode) {
            nullCheck(path);
            if (mode === undefined) mode = fs.F_OK; else mode = mode | 0;
            binding.access(pathModule._makeLong(path), mode);
        };
        fs.exists = function(path, callback) {
            if (!nullCheck(path, cb)) return;
            var req = new FSReqWrap;
            req.oncomplete = cb;
            binding.stat(pathModule._makeLong(path), req);
            function cb(err, stats) {
                if (callback) callback(err ? false : true);
            }
        };
        fs.existsSync = function(path) {
            try {
                nullCheck(path);
                binding.stat(pathModule._makeLong(path));
                return true;
            } catch (e) {
                return false;
            }
        };
        fs.readFile = function(path, options, callback) {
            callback = maybeCallback(arguments[arguments.length - 1]);
            options = getOptions(options, {
                flag: "r"
            });
            if (!nullCheck(path, callback)) return;
            var context = new ReadFileContext(callback, options.encoding);
            context.isUserFd = isFd(path);
            var req = new FSReqWrap;
            req.context = context;
            req.oncomplete = readFileAfterOpen;
            if (context.isUserFd) {
                process.nextTick((function() {
                    req.oncomplete(null, path);
                }));
                return;
            }
            binding.open(pathModule._makeLong(path), stringToFlags(options.flag || "r"), 438, req);
        };
        const kReadFileBufferLength = 8 * 1024;
        function ReadFileContext(callback, encoding) {
            this.fd = undefined;
            this.isUserFd = undefined;
            this.size = undefined;
            this.callback = callback;
            this.buffers = null;
            this.buffer = null;
            this.pos = 0;
            this.encoding = encoding;
            this.err = null;
        }
        ReadFileContext.prototype.read = function() {
            var buffer;
            var offset;
            var length;
            if (this.size === 0) {
                buffer = this.buffer = Buffer.allocUnsafeSlow(kReadFileBufferLength);
                offset = 0;
                length = kReadFileBufferLength;
            } else {
                buffer = this.buffer;
                offset = this.pos;
                length = this.size - this.pos;
            }
            var req = new FSReqWrap;
            req.oncomplete = readFileAfterRead;
            req.context = this;
            binding.read(this.fd, buffer, offset, length, -1, req);
        };
        ReadFileContext.prototype.close = function(err) {
            var req = new FSReqWrap;
            req.oncomplete = readFileAfterClose;
            req.context = this;
            this.err = err;
            if (this.isUserFd) {
                process.nextTick((function() {
                    req.oncomplete(null);
                }));
                return;
            }
            binding.close(this.fd, req);
        };
        function readFileAfterOpen(err, fd) {
            var context = this.context;
            if (err) {
                context.callback(err);
                return;
            }
            context.fd = fd;
            var req = new FSReqWrap;
            req.oncomplete = readFileAfterStat;
            req.context = context;
            binding.fstat(fd, req);
        }
        function readFileAfterStat(err, st) {
            var context = this.context;
            if (err) return context.close(err);
            var size = context.size = st.isFile() ? st.size : 0;
            if (size === 0) {
                context.buffers = [];
                context.read();
                return;
            }
            if (size > kMaxLength) {
                err = new RangeError("File size is greater than possible Buffer: " + `0x${kMaxLength.toString(16)} bytes`);
                return context.close(err);
            }
            context.buffer = Buffer.allocUnsafeSlow(size);
            context.read();
        }
        function readFileAfterRead(err, bytesRead) {
            var context = this.context;
            if (err) return context.close(err);
            if (bytesRead === 0) return context.close();
            context.pos += bytesRead;
            if (context.size !== 0) {
                if (context.pos === context.size) context.close(); else context.read();
            } else {
                context.buffers.push(context.buffer.slice(0, bytesRead));
                context.read();
            }
        }
        function readFileAfterClose(err) {
            var context = this.context;
            var buffer = null;
            var callback = context.callback;
            if (context.err) return callback(context.err);
            if (context.size === 0) buffer = Buffer.concat(context.buffers, context.pos); else if (context.pos < context.size) buffer = context.buffer.slice(0, context.pos); else buffer = context.buffer;
            if (err) return callback(err, buffer);
            if (context.encoding) {
                return tryToString(buffer, context.encoding, callback);
            }
            callback(null, buffer);
        }
        function tryToString(buf, encoding, callback) {
            var e = null;
            try {
                buf = buf.toString(encoding);
            } catch (err) {
                e = err;
            }
            callback(e, buf);
        }
        function tryStatSync(fd, isUserFd) {
            var threw = true;
            var st;
            try {
                st = fs.fstatSync(fd);
                threw = false;
            } finally {
                if (threw && !isUserFd) fs.closeSync(fd);
            }
            return st;
        }
        function tryCreateBuffer(size, fd, isUserFd) {
            var threw = true;
            var buffer;
            try {
                buffer = Buffer.allocUnsafe(size);
                threw = false;
            } finally {
                if (threw && !isUserFd) fs.closeSync(fd);
            }
            return buffer;
        }
        function tryReadSync(fd, isUserFd, buffer, pos, len) {
            var threw = true;
            var bytesRead;
            try {
                bytesRead = fs.readSync(fd, buffer, pos, len);
                threw = false;
            } finally {
                if (threw && !isUserFd) fs.closeSync(fd);
            }
            return bytesRead;
        }
        fs.readFileSync = function(path, options) {
            options = getOptions(options, {
                flag: "r"
            });
            var isUserFd = isFd(path);
            var fd = isUserFd ? path : fs.openSync(path, options.flag || "r", 438);
            var st = tryStatSync(fd, isUserFd);
            var size = st.isFile() ? st.size : 0;
            var pos = 0;
            var buffer;
            var buffers;
            if (size === 0) {
                buffers = [];
            } else {
                buffer = tryCreateBuffer(size, fd, isUserFd);
            }
            var bytesRead;
            if (size !== 0) {
                do {
                    bytesRead = tryReadSync(fd, isUserFd, buffer, pos, size - pos);
                    pos += bytesRead;
                } while (bytesRead !== 0 && pos < size);
            } else {
                do {
                    buffer = Buffer.allocUnsafe(8192);
                    bytesRead = tryReadSync(fd, isUserFd, buffer, 0, 8192);
                    if (bytesRead !== 0) {
                        buffers.push(buffer.slice(0, bytesRead));
                    }
                    pos += bytesRead;
                } while (bytesRead !== 0);
            }
            if (!isUserFd) fs.closeSync(fd);
            if (size === 0) {
                buffer = Buffer.concat(buffers, pos);
            } else if (pos < size) {
                buffer = buffer.slice(0, pos);
            }
            if (options.encoding) buffer = buffer.toString(options.encoding);
            return buffer;
        };
        fs.close = function(fd, callback) {
            var req = new FSReqWrap;
            req.oncomplete = makeCallback(callback);
            binding.close(fd, req);
        };
        fs.closeSync = function(fd) {
            return binding.close(fd);
        };
        function modeNum(m, def) {
            if (typeof m === "number") return m;
            if (typeof m === "string") return parseInt(m, 8);
            if (def) return modeNum(def);
            return undefined;
        }
        fs.open = function(path, flags, mode, callback_) {
            var callback = makeCallback(arguments[arguments.length - 1]);
            mode = modeNum(mode, 438);
            if (!nullCheck(path, callback)) return;
            var req = new FSReqWrap;
            req.oncomplete = callback;
            binding.open(pathModule._makeLong(path), stringToFlags(flags), mode, req);
        };
        fs.openSync = function(path, flags, mode) {
            mode = modeNum(mode, 438);
            nullCheck(path);
            return binding.open(pathModule._makeLong(path), stringToFlags(flags), mode);
        };
        var readWarned = false;
        fs.read = function(fd, buffer, offset, length, position, callback) {
            if (!(buffer instanceof Buffer)) {
                if (!readWarned) {
                    readWarned = true;
                    process.emitWarning("fs.read's legacy String interface is deprecated. Use the Buffer " + "API as mentioned in the documentation instead.", "DeprecationWarning");
                }
                const cb = arguments[4];
                const encoding = arguments[3];
                assertEncoding(encoding);
                position = arguments[2];
                length = arguments[1];
                buffer = Buffer.allocUnsafe(length);
                offset = 0;
                callback = function(err, bytesRead) {
                    if (!cb) return;
                    if (err) return cb(err);
                    if (bytesRead > 0) {
                        tryToStringWithEnd(buffer, encoding, bytesRead, cb);
                    } else {
                        cb(err, "", bytesRead);
                    }
                };
            }
            if (length === 0) {
                return process.nextTick((function() {
                    callback && callback(null, 0, buffer);
                }));
            }
            function wrapper(err, bytesRead) {
                callback && callback(err, bytesRead || 0, buffer);
            }
            var req = new FSReqWrap;
            req.oncomplete = wrapper;
            binding.read(fd, buffer, offset, length, position, req);
        };
        function tryToStringWithEnd(buf, encoding, end, callback) {
            var e;
            try {
                buf = buf.toString(encoding, 0, end);
            } catch (err) {
                e = err;
            }
            callback(e, buf, end);
        }
        var readSyncWarned = false;
        fs.readSync = function(fd, buffer, offset, length, position) {
            var legacy = false;
            var encoding;
            if (!(buffer instanceof Buffer)) {
                if (!readSyncWarned) {
                    readSyncWarned = true;
                    process.emitWarning("fs.readSync's legacy String interface is deprecated. Use the " + "Buffer API as mentioned in the documentation instead.", "DeprecationWarning");
                }
                legacy = true;
                encoding = arguments[3];
                assertEncoding(encoding);
                position = arguments[2];
                length = arguments[1];
                buffer = Buffer.allocUnsafe(length);
                offset = 0;
            }
            if (length === 0) {
                if (legacy) {
                    return [ "", 0 ];
                } else {
                    return 0;
                }
            }
            var r = binding.read(fd, buffer, offset, length, position);
            if (!legacy) {
                return r;
            }
            var str = r > 0 ? buffer.toString(encoding, 0, r) : "";
            return [ str, r ];
        };
        fs.write = function(fd, buffer, offset, length, position, callback) {
            function wrapper(err, written) {
                callback(err, written || 0, buffer);
            }
            var req = new FSReqWrap;
            req.oncomplete = wrapper;
            if (buffer instanceof Buffer) {
                callback = maybeCallback(callback || position || length || offset);
                if (typeof offset !== "number") {
                    offset = 0;
                }
                if (typeof length !== "number") {
                    length = buffer.length - offset;
                }
                if (typeof position !== "number") {
                    position = null;
                }
                return binding.writeBuffer(fd, buffer, offset, length, position, req);
            }
            if (typeof buffer !== "string") buffer += "";
            if (typeof position !== "function") {
                if (typeof offset === "function") {
                    position = offset;
                    offset = null;
                } else {
                    position = length;
                }
                length = "utf8";
            }
            callback = maybeCallback(position);
            return binding.writeString(fd, buffer, offset, length, req);
        };
        fs.writeSync = function(fd, buffer, offset, length, position) {
            if (buffer instanceof Buffer) {
                if (position === undefined) position = null;
                if (typeof offset !== "number") offset = 0;
                if (typeof length !== "number") length = buffer.length - offset;
                return binding.writeBuffer(fd, buffer, offset, length, position);
            }
            if (typeof buffer !== "string") buffer += "";
            if (offset === undefined) offset = null;
            return binding.writeString(fd, buffer, offset, length, position);
        };
        fs.rename = function(oldPath, newPath, callback) {
            callback = makeCallback(callback);
            if (!nullCheck(oldPath, callback)) return;
            if (!nullCheck(newPath, callback)) return;
            var req = new FSReqWrap;
            req.oncomplete = callback;
            binding.rename(pathModule._makeLong(oldPath), pathModule._makeLong(newPath), req);
        };
        fs.renameSync = function(oldPath, newPath) {
            nullCheck(oldPath);
            nullCheck(newPath);
            return binding.rename(pathModule._makeLong(oldPath), pathModule._makeLong(newPath));
        };
        fs.truncate = function(path, len, callback) {
            if (typeof path === "number") {
                return fs.ftruncate(path, len, callback);
            }
            if (typeof len === "function") {
                callback = len;
                len = 0;
            } else if (len === undefined) {
                len = 0;
            }
            callback = maybeCallback(callback);
            fs.open(path, "r+", (function(er, fd) {
                if (er) return callback(er);
                var req = new FSReqWrap;
                req.oncomplete = function oncomplete(er) {
                    fs.close(fd, (function(er2) {
                        callback(er || er2);
                    }));
                };
                binding.ftruncate(fd, len, req);
            }));
        };
        fs.truncateSync = function(path, len) {
            if (typeof path === "number") {
                return fs.ftruncateSync(path, len);
            }
            if (len === undefined) {
                len = 0;
            }
            var fd = fs.openSync(path, "r+");
            var ret;
            try {
                ret = fs.ftruncateSync(fd, len);
            } finally {
                fs.closeSync(fd);
            }
            return ret;
        };
        fs.ftruncate = function(fd, len, callback) {
            if (typeof len === "function") {
                callback = len;
                len = 0;
            } else if (len === undefined) {
                len = 0;
            }
            var req = new FSReqWrap;
            req.oncomplete = makeCallback(callback);
            binding.ftruncate(fd, len, req);
        };
        fs.ftruncateSync = function(fd, len) {
            if (len === undefined) {
                len = 0;
            }
            return binding.ftruncate(fd, len);
        };
        fs.rmdir = function(path, callback) {
            callback = maybeCallback(callback);
            if (!nullCheck(path, callback)) return;
            var req = new FSReqWrap;
            req.oncomplete = callback;
            binding.rmdir(pathModule._makeLong(path), req);
        };
        fs.rmdirSync = function(path) {
            nullCheck(path);
            return binding.rmdir(pathModule._makeLong(path));
        };
        fs.fdatasync = function(fd, callback) {
            var req = new FSReqWrap;
            req.oncomplete = makeCallback(callback);
            binding.fdatasync(fd, req);
        };
        fs.fdatasyncSync = function(fd) {
            return binding.fdatasync(fd);
        };
        fs.fsync = function(fd, callback) {
            var req = new FSReqWrap;
            req.oncomplete = makeCallback(callback);
            binding.fsync(fd, req);
        };
        fs.fsyncSync = function(fd) {
            return binding.fsync(fd);
        };
        fs.mkdir = function(path, mode, callback) {
            if (typeof mode === "function") callback = mode;
            callback = makeCallback(callback);
            if (!nullCheck(path, callback)) return;
            var req = new FSReqWrap;
            req.oncomplete = callback;
            binding.mkdir(pathModule._makeLong(path), modeNum(mode, 511), req);
        };
        fs.mkdirSync = function(path, mode) {
            nullCheck(path);
            return binding.mkdir(pathModule._makeLong(path), modeNum(mode, 511));
        };
        fs.readdir = function(path, options, callback) {
            callback = makeCallback(typeof options === "function" ? options : callback);
            options = getOptions(options, {});
            if (!nullCheck(path, callback)) return;
            var req = new FSReqWrap;
            req.oncomplete = callback;
            binding.readdir(pathModule._makeLong(path), options.encoding, req);
        };
        fs.readdirSync = function(path, options) {
            options = getOptions(options, {});
            nullCheck(path);
            return binding.readdir(pathModule._makeLong(path), options.encoding);
        };
        fs.fstat = function(fd, callback) {
            var req = new FSReqWrap;
            req.oncomplete = makeCallback(callback);
            binding.fstat(fd, req);
        };
        fs.lstat = function(path, callback) {
            callback = makeCallback(callback);
            if (!nullCheck(path, callback)) return;
            var req = new FSReqWrap;
            req.oncomplete = callback;
            binding.lstat(pathModule._makeLong(path), req);
        };
        fs.stat = function(path, callback) {
            callback = makeCallback(callback);
            if (!nullCheck(path, callback)) return;
            var req = new FSReqWrap;
            req.oncomplete = callback;
            binding.stat(pathModule._makeLong(path), req);
        };
        fs.fstatSync = function(fd) {
            return binding.fstat(fd);
        };
        fs.lstatSync = function(path) {
            nullCheck(path);
            return binding.lstat(pathModule._makeLong(path));
        };
        fs.statSync = function(path) {
            nullCheck(path);
            return binding.stat(pathModule._makeLong(path));
        };
        fs.readlink = function(path, options, callback) {
            callback = makeCallback(typeof options === "function" ? options : callback);
            options = getOptions(options, {});
            if (!nullCheck(path, callback)) return;
            var req = new FSReqWrap;
            req.oncomplete = callback;
            binding.readlink(pathModule._makeLong(path), options.encoding, req);
        };
        fs.readlinkSync = function(path, options) {
            options = getOptions(options, {});
            nullCheck(path);
            return binding.readlink(pathModule._makeLong(path), options.encoding);
        };
        function preprocessSymlinkDestination(path, type, linkPath) {
            if (!isWindows) {
                return path;
            } else if (type === "junction") {
                path = pathModule.resolve(linkPath, "..", path);
                return pathModule._makeLong(path);
            } else {
                return ("" + path).replace(/\//g, "\\");
            }
        }
        fs.symlink = function(target, path, type_, callback_) {
            var type = typeof type_ === "string" ? type_ : null;
            var callback = makeCallback(arguments[arguments.length - 1]);
            if (!nullCheck(target, callback)) return;
            if (!nullCheck(path, callback)) return;
            var req = new FSReqWrap;
            req.oncomplete = callback;
            binding.symlink(preprocessSymlinkDestination(target, type, path), pathModule._makeLong(path), type, req);
        };
        fs.symlinkSync = function(target, path, type) {
            type = typeof type === "string" ? type : null;
            nullCheck(target);
            nullCheck(path);
            return binding.symlink(preprocessSymlinkDestination(target, type, path), pathModule._makeLong(path), type);
        };
        fs.link = function(existingPath, newPath, callback) {
            callback = makeCallback(callback);
            if (!nullCheck(existingPath, callback)) return;
            if (!nullCheck(newPath, callback)) return;
            var req = new FSReqWrap;
            req.oncomplete = callback;
            binding.link(pathModule._makeLong(existingPath), pathModule._makeLong(newPath), req);
        };
        fs.linkSync = function(existingPath, newPath) {
            nullCheck(existingPath);
            nullCheck(newPath);
            return binding.link(pathModule._makeLong(existingPath), pathModule._makeLong(newPath));
        };
        fs.unlink = function(path, callback) {
            callback = makeCallback(callback);
            if (!nullCheck(path, callback)) return;
            var req = new FSReqWrap;
            req.oncomplete = callback;
            binding.unlink(pathModule._makeLong(path), req);
        };
        fs.unlinkSync = function(path) {
            nullCheck(path);
            return binding.unlink(pathModule._makeLong(path));
        };
        fs.fchmod = function(fd, mode, callback) {
            var req = new FSReqWrap;
            req.oncomplete = makeCallback(callback);
            binding.fchmod(fd, modeNum(mode), req);
        };
        fs.fchmodSync = function(fd, mode) {
            return binding.fchmod(fd, modeNum(mode));
        };
        if (constants.O_SYMLINK !== undefined) {
            fs.lchmod = function(path, mode, callback) {
                callback = maybeCallback(callback);
                fs.open(path, constants.O_WRONLY | constants.O_SYMLINK, (function(err, fd) {
                    if (err) {
                        callback(err);
                        return;
                    }
                    fs.fchmod(fd, mode, (function(err) {
                        fs.close(fd, (function(err2) {
                            callback(err || err2);
                        }));
                    }));
                }));
            };
            fs.lchmodSync = function(path, mode) {
                var fd = fs.openSync(path, constants.O_WRONLY | constants.O_SYMLINK);
                var err, err2, ret;
                try {
                    ret = fs.fchmodSync(fd, mode);
                } catch (er) {
                    err = er;
                }
                try {
                    fs.closeSync(fd);
                } catch (er) {
                    err2 = er;
                }
                if (err || err2) throw err || err2;
                return ret;
            };
        }
        fs.chmod = function(path, mode, callback) {
            callback = makeCallback(callback);
            if (!nullCheck(path, callback)) return;
            var req = new FSReqWrap;
            req.oncomplete = callback;
            binding.chmod(pathModule._makeLong(path), modeNum(mode), req);
        };
        fs.chmodSync = function(path, mode) {
            nullCheck(path);
            return binding.chmod(pathModule._makeLong(path), modeNum(mode));
        };
        if (constants.O_SYMLINK !== undefined) {
            fs.lchown = function(path, uid, gid, callback) {
                callback = maybeCallback(callback);
                fs.open(path, constants.O_WRONLY | constants.O_SYMLINK, (function(err, fd) {
                    if (err) {
                        callback(err);
                        return;
                    }
                    fs.fchown(fd, uid, gid, callback);
                }));
            };
            fs.lchownSync = function(path, uid, gid) {
                var fd = fs.openSync(path, constants.O_WRONLY | constants.O_SYMLINK);
                return fs.fchownSync(fd, uid, gid);
            };
        }
        fs.fchown = function(fd, uid, gid, callback) {
            var req = new FSReqWrap;
            req.oncomplete = makeCallback(callback);
            binding.fchown(fd, uid, gid, req);
        };
        fs.fchownSync = function(fd, uid, gid) {
            return binding.fchown(fd, uid, gid);
        };
        fs.chown = function(path, uid, gid, callback) {
            callback = makeCallback(callback);
            if (!nullCheck(path, callback)) return;
            var req = new FSReqWrap;
            req.oncomplete = callback;
            binding.chown(pathModule._makeLong(path), uid, gid, req);
        };
        fs.chownSync = function(path, uid, gid) {
            nullCheck(path);
            return binding.chown(pathModule._makeLong(path), uid, gid);
        };
        function toUnixTimestamp(time) {
            if (typeof time === "string" && +time == time) {
                return +time;
            }
            if (typeof time === "number") {
                if (!Number.isFinite(time) || time < 0) {
                    return Date.now() / 1e3;
                }
                return time;
            }
            if (util.isDate(time)) {
                return time.getTime() / 1e3;
            }
            throw new Error("Cannot parse time: " + time);
        }
        fs._toUnixTimestamp = toUnixTimestamp;
        fs.utimes = function(path, atime, mtime, callback) {
            callback = makeCallback(callback);
            if (!nullCheck(path, callback)) return;
            var req = new FSReqWrap;
            req.oncomplete = callback;
            binding.utimes(pathModule._makeLong(path), toUnixTimestamp(atime), toUnixTimestamp(mtime), req);
        };
        fs.utimesSync = function(path, atime, mtime) {
            nullCheck(path);
            atime = toUnixTimestamp(atime);
            mtime = toUnixTimestamp(mtime);
            binding.utimes(pathModule._makeLong(path), atime, mtime);
        };
        fs.futimes = function(fd, atime, mtime, callback) {
            atime = toUnixTimestamp(atime);
            mtime = toUnixTimestamp(mtime);
            var req = new FSReqWrap;
            req.oncomplete = makeCallback(callback);
            binding.futimes(fd, atime, mtime, req);
        };
        fs.futimesSync = function(fd, atime, mtime) {
            atime = toUnixTimestamp(atime);
            mtime = toUnixTimestamp(mtime);
            binding.futimes(fd, atime, mtime);
        };
        function writeAll(fd, isUserFd, buffer, offset, length, position, callback_) {
            var callback = maybeCallback(arguments[arguments.length - 1]);
            fs.write(fd, buffer, offset, length, position, (function(writeErr, written) {
                if (writeErr) {
                    if (isUserFd) {
                        callback(writeErr);
                    } else {
                        fs.close(fd, (function() {
                            callback(writeErr);
                        }));
                    }
                } else {
                    if (written === length) {
                        if (isUserFd) {
                            callback(null);
                        } else {
                            fs.close(fd, callback);
                        }
                    } else {
                        offset += written;
                        length -= written;
                        if (position !== null) {
                            position += written;
                        }
                        writeAll(fd, isUserFd, buffer, offset, length, position, callback);
                    }
                }
            }));
        }
        fs.writeFile = function(path, data, options, callback) {
            callback = maybeCallback(arguments[arguments.length - 1]);
            options = getOptions(options, {
                encoding: "utf8",
                mode: 438,
                flag: "w"
            });
            const flag = options.flag || "w";
            if (isFd(path)) {
                writeFd(path, true);
                return;
            }
            fs.open(path, flag, options.mode, (function(openErr, fd) {
                if (openErr) {
                    callback(openErr);
                } else {
                    writeFd(fd, false);
                }
            }));
            function writeFd(fd, isUserFd) {
                var buffer = data instanceof Buffer ? data : Buffer.from("" + data, options.encoding || "utf8");
                var position = /a/.test(flag) ? null : 0;
                writeAll(fd, isUserFd, buffer, 0, buffer.length, position, callback);
            }
        };
        fs.writeFileSync = function(path, data, options) {
            options = getOptions(options, {
                encoding: "utf8",
                mode: 438,
                flag: "w"
            });
            const flag = options.flag || "w";
            var isUserFd = isFd(path);
            var fd = isUserFd ? path : fs.openSync(path, flag, options.mode);
            if (!(data instanceof Buffer)) {
                data = Buffer.from("" + data, options.encoding || "utf8");
            }
            var offset = 0;
            var length = data.length;
            var position = /a/.test(flag) ? null : 0;
            try {
                while (length > 0) {
                    var written = fs.writeSync(fd, data, offset, length, position);
                    offset += written;
                    length -= written;
                    if (position !== null) {
                        position += written;
                    }
                }
            } finally {
                if (!isUserFd) fs.closeSync(fd);
            }
        };
        fs.appendFile = function(path, data, options, callback) {
            callback = maybeCallback(arguments[arguments.length - 1]);
            options = getOptions(options, {
                encoding: "utf8",
                mode: 438,
                flag: "a"
            });
            options = copyObject(options);
            if (!options.flag || isFd(path)) options.flag = "a";
            fs.writeFile(path, data, options, callback);
        };
        fs.appendFileSync = function(path, data, options) {
            options = getOptions(options, {
                encoding: "utf8",
                mode: 438,
                flag: "a"
            });
            options = copyObject(options);
            if (!options.flag || isFd(path)) options.flag = "a";
            fs.writeFileSync(path, data, options);
        };
        function FSWatcher() {
            EventEmitter.call(this);
            var self = this;
            this._handle = new FSEvent;
            this._handle.owner = this;
            this._handle.onchange = function(status, eventType, filename) {
                if (status < 0) {
                    self._handle.close();
                    const error = !filename ? errnoException(status, "Error watching file for changes:") : errnoException(status, `Error watching file ${filename} for changes:`);
                    error.filename = filename;
                    self.emit("error", error);
                } else {
                    self.emit("change", eventType, filename);
                }
            };
        }
        util.inherits(FSWatcher, EventEmitter);
        FSWatcher.prototype.start = function(filename, persistent, recursive, encoding) {
            nullCheck(filename);
            var err = this._handle.start(pathModule._makeLong(filename), persistent, recursive, encoding);
            if (err) {
                this._handle.close();
                const error = errnoException(err, `watch ${filename}`);
                error.filename = filename;
                throw error;
            }
        };
        FSWatcher.prototype.close = function() {
            this._handle.close();
        };
        fs.watch = function(filename, options, listener) {
            nullCheck(filename);
            if (typeof options === "function") {
                listener = options;
            }
            options = getOptions(options, {});
            options = copyObject(options);
            if (options.persistent === undefined) options.persistent = true;
            if (options.recursive === undefined) options.recursive = false;
            const watcher = new FSWatcher;
            watcher.start(filename, options.persistent, options.recursive, options.encoding);
            if (listener) {
                watcher.addListener("change", listener);
            }
            return watcher;
        };
        function emitStop(self) {
            self.emit("stop");
        }
        function StatWatcher() {
            EventEmitter.call(this);
            var self = this;
            this._handle = new binding.StatWatcher;
            var oldStatus = -1;
            this._handle.onchange = function(current, previous, newStatus) {
                if (oldStatus === -1 && newStatus === -1 && current.nlink === previous.nlink) return;
                oldStatus = newStatus;
                self.emit("change", current, previous);
            };
            this._handle.onstop = function() {
                process.nextTick(emitStop, self);
            };
        }
        util.inherits(StatWatcher, EventEmitter);
        StatWatcher.prototype.start = function(filename, persistent, interval) {
            nullCheck(filename);
            this._handle.start(pathModule._makeLong(filename), persistent, interval);
        };
        StatWatcher.prototype.stop = function() {
            this._handle.stop();
        };
        const statWatchers = new Map;
        fs.watchFile = function(filename, options, listener) {
            nullCheck(filename);
            filename = pathModule.resolve(filename);
            var stat;
            var defaults = {
                interval: 5007,
                persistent: true
            };
            if (options !== null && typeof options === "object") {
                options = util._extend(defaults, options);
            } else {
                listener = options;
                options = defaults;
            }
            if (typeof listener !== "function") {
                throw new Error('"watchFile()" requires a listener function');
            }
            stat = statWatchers.get(filename);
            if (stat === undefined) {
                stat = new StatWatcher;
                stat.start(filename, options.persistent, options.interval);
                statWatchers.set(filename, stat);
            }
            stat.addListener("change", listener);
            return stat;
        };
        fs.unwatchFile = function(filename, listener) {
            nullCheck(filename);
            filename = pathModule.resolve(filename);
            var stat = statWatchers.get(filename);
            if (stat === undefined) return;
            if (typeof listener === "function") {
                stat.removeListener("change", listener);
            } else {
                stat.removeAllListeners("change");
            }
            if (stat.listenerCount("change") === 0) {
                stat.stop();
                statWatchers.delete(filename);
            }
        };
        const nextPartRe = isWindows ? /(.*?)(?:[/\\]+|$)/g : /(.*?)(?:[/]+|$)/g;
        const splitRootRe = isWindows ? /^(?:[a-zA-Z]:|[\\/]{2}[^\\/]+[\\/][^\\/]+)?[\\/]*/ : /^[/]*/;
        function encodeRealpathResult(result, options, err) {
            if (!options || !options.encoding || options.encoding === "utf8" || err) return result;
            const asBuffer = Buffer.from(result);
            if (options.encoding === "buffer") {
                return asBuffer;
            } else {
                return asBuffer.toString(options.encoding);
            }
        }
        fs.realpathSync = function realpathSync(p, options) {
            options = getOptions(options, {});
            nullCheck(p);
            p = p.toString("utf8");
            p = pathModule.resolve(p);
            const seenLinks = {};
            const knownHard = {};
            const cache = options[internalFS.realpathCacheKey];
            const original = p;
            const maybeCachedResult = cache && cache.get(p);
            if (maybeCachedResult) {
                return maybeCachedResult;
            }
            var pos;
            var current;
            var base;
            var previous;
            start();
            function start() {
                var m = splitRootRe.exec(p);
                pos = m[0].length;
                current = m[0];
                base = m[0];
                previous = "";
                if (isWindows && !knownHard[base]) {
                    fs.lstatSync(base);
                    knownHard[base] = true;
                }
            }
            while (pos < p.length) {
                nextPartRe.lastIndex = pos;
                var result = nextPartRe.exec(p);
                previous = current;
                current += result[0];
                base = previous + result[1];
                pos = nextPartRe.lastIndex;
                if (knownHard[base] || cache && cache.get(base) === base) {
                    continue;
                }
                var resolvedLink;
                const maybeCachedResolved = cache && cache.get(base);
                if (maybeCachedResolved) {
                    resolvedLink = maybeCachedResolved;
                } else {
                    var stat = fs.lstatSync(base);
                    if (!stat.isSymbolicLink()) {
                        knownHard[base] = true;
                        continue;
                    }
                    let linkTarget = null;
                    let id;
                    if (!isWindows) {
                        id = `${stat.dev.toString(32)}:${stat.ino.toString(32)}`;
                        if (seenLinks.hasOwnProperty(id)) {
                            linkTarget = seenLinks[id];
                        }
                    }
                    if (linkTarget === null) {
                        fs.statSync(base);
                        linkTarget = fs.readlinkSync(base);
                    }
                    resolvedLink = pathModule.resolve(previous, linkTarget);
                    if (cache) cache.set(base, resolvedLink);
                    if (!isWindows) seenLinks[id] = linkTarget;
                }
                p = pathModule.resolve(resolvedLink, p.slice(pos));
                start();
            }
            if (cache) cache.set(original, p);
            return encodeRealpathResult(p, options);
        };
        fs.realpath = function realpath(p, options, callback) {
            callback = maybeCallback(typeof options === "function" ? options : callback);
            options = getOptions(options, {});
            if (!nullCheck(p, callback)) return;
            p = p.toString("utf8");
            p = pathModule.resolve(p);
            const seenLinks = {};
            const knownHard = {};
            var pos;
            var current;
            var base;
            var previous;
            start();
            function start() {
                var m = splitRootRe.exec(p);
                pos = m[0].length;
                current = m[0];
                base = m[0];
                previous = "";
                if (isWindows && !knownHard[base]) {
                    fs.lstat(base, (function(err) {
                        if (err) return callback(err);
                        knownHard[base] = true;
                        LOOP();
                    }));
                } else {
                    process.nextTick(LOOP);
                }
            }
            function LOOP() {
                if (pos >= p.length) {
                    return callback(null, encodeRealpathResult(p, options));
                }
                nextPartRe.lastIndex = pos;
                var result = nextPartRe.exec(p);
                previous = current;
                current += result[0];
                base = previous + result[1];
                pos = nextPartRe.lastIndex;
                if (knownHard[base]) {
                    return process.nextTick(LOOP);
                }
                return fs.lstat(base, gotStat);
            }
            function gotStat(err, stat) {
                if (err) return callback(err);
                if (!stat.isSymbolicLink()) {
                    knownHard[base] = true;
                    return process.nextTick(LOOP);
                }
                let id;
                if (!isWindows) {
                    id = `${stat.dev.toString(32)}:${stat.ino.toString(32)}`;
                    if (seenLinks.hasOwnProperty(id)) {
                        return gotTarget(null, seenLinks[id], base);
                    }
                }
                fs.stat(base, (function(err) {
                    if (err) return callback(err);
                    fs.readlink(base, (function(err, target) {
                        if (!isWindows) seenLinks[id] = target;
                        gotTarget(err, target);
                    }));
                }));
            }
            function gotTarget(err, target, base) {
                if (err) return callback(err);
                var resolvedLink = pathModule.resolve(previous, target);
                gotResolvedLink(resolvedLink);
            }
            function gotResolvedLink(resolvedLink) {
                p = pathModule.resolve(resolvedLink, p.slice(pos));
                start();
            }
        };
        fs.mkdtemp = function(prefix, options, callback) {
            callback = makeCallback(typeof options === "function" ? options : callback);
            options = getOptions(options, {});
            if (!prefix || typeof prefix !== "string") throw new TypeError("filename prefix is required");
            if (!nullCheck(prefix, callback)) {
                return;
            }
            var req = new FSReqWrap;
            req.oncomplete = callback;
            binding.mkdtemp(prefix + "XXXXXX", options.encoding, req);
        };
        fs.mkdtempSync = function(prefix, options) {
            if (!prefix || typeof prefix !== "string") throw new TypeError("filename prefix is required");
            options = getOptions(options, {});
            nullCheck(prefix);
            return binding.mkdtemp(prefix + "XXXXXX", options.encoding);
        };
        var pool;
        function allocNewPool(poolSize) {
            pool = Buffer.allocUnsafe(poolSize);
            pool.used = 0;
        }
        fs.createReadStream = function(path, options) {
            return new ReadStream(path, options);
        };
        util.inherits(ReadStream, Readable);
        fs.ReadStream = ReadStream;
        function ReadStream(path, options) {
            if (!(this instanceof ReadStream)) return new ReadStream(path, options);
            options = copyObject(getOptions(options, {}));
            if (options.highWaterMark === undefined) options.highWaterMark = 64 * 1024;
            Readable.call(this, options);
            this.path = path;
            this.fd = options.fd === undefined ? null : options.fd;
            this.flags = options.flags === undefined ? "r" : options.flags;
            this.mode = options.mode === undefined ? 438 : options.mode;
            this.start = options.start;
            this.end = options.end;
            this.autoClose = options.autoClose === undefined ? true : options.autoClose;
            this.pos = undefined;
            this.bytesRead = 0;
            if (this.start !== undefined) {
                if (typeof this.start !== "number") {
                    throw new TypeError('"start" option must be a Number');
                }
                if (this.end === undefined) {
                    this.end = Infinity;
                } else if (typeof this.end !== "number") {
                    throw new TypeError('"end" option must be a Number');
                }
                if (this.start > this.end) {
                    throw new Error('"start" option must be <= "end" option');
                }
                this.pos = this.start;
            }
            if (typeof this.fd !== "number") this.open();
            this.on("end", (function() {
                if (this.autoClose) {
                    this.destroy();
                }
            }));
        }
        fs.FileReadStream = fs.ReadStream;
        ReadStream.prototype.open = function() {
            var self = this;
            fs.open(this.path, this.flags, this.mode, (function(er, fd) {
                if (er) {
                    if (self.autoClose) {
                        self.destroy();
                    }
                    self.emit("error", er);
                    return;
                }
                self.fd = fd;
                self.emit("open", fd);
                self.read();
            }));
        };
        ReadStream.prototype._read = function(n) {
            if (typeof this.fd !== "number") return this.once("open", (function() {
                this._read(n);
            }));
            if (this.destroyed) return;
            if (!pool || pool.length - pool.used < kMinPoolSpace) {
                allocNewPool(this._readableState.highWaterMark);
            }
            var thisPool = pool;
            var toRead = Math.min(pool.length - pool.used, n);
            var start = pool.used;
            if (this.pos !== undefined) toRead = Math.min(this.end - this.pos + 1, toRead);
            if (toRead <= 0) return this.push(null);
            var self = this;
            fs.read(this.fd, pool, pool.used, toRead, this.pos, onread);
            if (this.pos !== undefined) this.pos += toRead;
            pool.used += toRead;
            function onread(er, bytesRead) {
                if (er) {
                    if (self.autoClose) {
                        self.destroy();
                    }
                    self.emit("error", er);
                } else {
                    var b = null;
                    if (bytesRead > 0) {
                        self.bytesRead += bytesRead;
                        b = thisPool.slice(start, start + bytesRead);
                    }
                    self.push(b);
                }
            }
        };
        ReadStream.prototype.destroy = function() {
            if (this.destroyed) return;
            this.destroyed = true;
            this.close();
        };
        ReadStream.prototype.close = function(cb) {
            var self = this;
            if (cb) this.once("close", cb);
            if (this.closed || typeof this.fd !== "number") {
                if (typeof this.fd !== "number") {
                    this.once("open", close);
                    return;
                }
                return process.nextTick(() => this.emit("close"));
            }
            this.closed = true;
            close();
            function close(fd) {
                fs.close(fd || self.fd, (function(er) {
                    if (er) self.emit("error", er); else self.emit("close");
                }));
                self.fd = null;
            }
        };
        fs.createWriteStream = function(path, options) {
            return new WriteStream(path, options);
        };
        util.inherits(WriteStream, Writable);
        fs.WriteStream = WriteStream;
        function WriteStream(path, options) {
            if (!(this instanceof WriteStream)) return new WriteStream(path, options);
            options = copyObject(getOptions(options, {}));
            Writable.call(this, options);
            this.path = path;
            this.fd = options.fd === undefined ? null : options.fd;
            this.flags = options.flags === undefined ? "w" : options.flags;
            this.mode = options.mode === undefined ? 438 : options.mode;
            this.start = options.start;
            this.autoClose = options.autoClose === undefined ? true : !!options.autoClose;
            this.pos = undefined;
            this.bytesWritten = 0;
            if (this.start !== undefined) {
                if (typeof this.start !== "number") {
                    throw new TypeError('"start" option must be a Number');
                }
                if (this.start < 0) {
                    throw new Error('"start" must be >= zero');
                }
                this.pos = this.start;
            }
            if (options.encoding) this.setDefaultEncoding(options.encoding);
            if (typeof this.fd !== "number") this.open();
            this.once("finish", (function() {
                if (this.autoClose) {
                    this.close();
                }
            }));
        }
        fs.FileWriteStream = fs.WriteStream;
        WriteStream.prototype.open = function() {
            fs.open(this.path, this.flags, this.mode, function(er, fd) {
                if (er) {
                    if (this.autoClose) {
                        this.destroy();
                    }
                    this.emit("error", er);
                    return;
                }
                this.fd = fd;
                this.emit("open", fd);
            }.bind(this));
        };
        WriteStream.prototype._write = function(data, encoding, cb) {
            if (!(data instanceof Buffer)) return this.emit("error", new Error("Invalid data"));
            if (typeof this.fd !== "number") return this.once("open", (function() {
                this._write(data, encoding, cb);
            }));
            var self = this;
            fs.write(this.fd, data, 0, data.length, this.pos, (function(er, bytes) {
                if (er) {
                    if (self.autoClose) {
                        self.destroy();
                    }
                    return cb(er);
                }
                self.bytesWritten += bytes;
                cb();
            }));
            if (this.pos !== undefined) this.pos += data.length;
        };
        function writev(fd, chunks, position, callback) {
            function wrapper(err, written) {
                callback(err, written || 0, chunks);
            }
            const req = new FSReqWrap;
            req.oncomplete = wrapper;
            binding.writeBuffers(fd, chunks, position, req);
        }
        WriteStream.prototype._writev = function(data, cb) {
            if (typeof this.fd !== "number") return this.once("open", (function() {
                this._writev(data, cb);
            }));
            const self = this;
            const len = data.length;
            const chunks = new Array(len);
            var size = 0;
            for (var i = 0; i < len; i++) {
                var chunk = data[i].chunk;
                chunks[i] = chunk;
                size += chunk.length;
            }
            writev(this.fd, chunks, this.pos, (function(er, bytes) {
                if (er) {
                    self.destroy();
                    return cb(er);
                }
                self.bytesWritten += bytes;
                cb();
            }));
            if (this.pos !== undefined) this.pos += size;
        };
        WriteStream.prototype.destroy = ReadStream.prototype.destroy;
        WriteStream.prototype.close = ReadStream.prototype.close;
        WriteStream.prototype.destroySoon = WriteStream.prototype.end;
        Object.defineProperty(fs, "SyncWriteStream", {
            configurable: true,
            writable: true,
            value: SyncWriteStream
        });
        return fs;
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    const bindings = __webpack_require__(76);
    const constants = __webpack_require__(51);
    const queue = __webpack_require__(154);
    const fs = __webpack_require__(3);
    const util = __webpack_require__(1);
    function getCallback(req) {
        if (!req || typeof req.oncomplete !== "function") {
            throw new Error("A callback is required.");
        }
        return req.oncomplete.bind(req);
    }
    module.exports = function(filesystem, options) {
        options = options || {};
        const MAX_FD = options.MAX_FD || 1024;
        const openFiles = new Array(MAX_FD);
        function getFd() {
            for (let i = 0; i < MAX_FD; i++) {
                if (openFiles[i] === undefined) {
                    return i;
                }
            }
            return -1;
        }
        function getFile(fd, callback) {
            const file = openFiles[fd];
            if (file === undefined) {
                const error = new Error("bad file descriptor");
                error.errno = 9;
                error.code = "EBADF";
                callback(error);
                return null;
            }
            return file;
        }
        const exports = {};
        exports.FSReqWrap = function() {};
        let Stats;
        exports.FSInitialize = function(s) {
            Stats = s;
        };
        exports.access = function(path, mode, req) {
            const callback = getCallback(req);
            const X = fs.constants.S_IXUSR | fs.constants.S_IXGRP | fs.constants.S_IXOTH;
            stat(path, (function(err, stats) {
                if (err) {
                    callback(err);
                    return;
                }
                if ((mode & fs.constants.X_OK) !== 0 && (stats.mode & X) === 0) {
                    const error = new Error(`permission denied, access '${path}'`);
                    error.errno = 13;
                    error.code = "EACCES";
                    callback(error);
                    return;
                }
                callback(null);
            }));
        };
        exports.chmod = function(path, mode, req) {
            const callback = getCallback(req);
            open(path, "r", 0, (function(err, fd) {
                if (err) {
                    callback(err);
                    return;
                }
                fchmod(fd, mode, (function(err) {
                    if (err) {
                        callback(err);
                        return;
                    }
                    close(fd, callback);
                }));
            }));
        };
        exports.chown = function(path, uid, gid, req) {
            const callback = getCallback(req);
            open(path, "r", 0, (function(err, fd) {
                if (err) {
                    callback(err);
                    return;
                }
                fchown(fd, uid, gid, (function(err) {
                    if (err) {
                        callback(err);
                        return;
                    }
                    close(fd, callback);
                }));
            }));
        };
        const close = function(fd, callback) {
            const file = getFile(fd, callback);
            if (file === null) {
                return;
            }
            queue.addOperation(bindings.close, [ file.file, file.flags, function(err) {
                if (err) {
                    callback(err);
                    return;
                }
                delete openFiles[fd];
                callback(null);
            } ]);
        };
        exports.close = function(fd, req) {
            close(fd, getCallback(req));
        };
        const fchmod = function(fd, mode, callback) {
            const file = getFile(fd, callback);
            if (file === null) {
                return;
            }
            queue.addOperation(bindings.fchmod, [ file.file, file.flags, mode, callback ]);
        };
        exports.fchmod = function(fd, mode, req) {
            fchmod(fd, mode, getCallback(req));
        };
        const fchown = function(fd, uid, gid, callback) {
            const file = getFile(fd, callback);
            if (file === null) {
                return;
            }
            queue.addOperation(bindings.fchown, [ file.file, file.flags, uid, gid, callback ]);
        };
        exports.fchown = function(fd, uid, gid, req) {
            fchown(fd, uid, gid, getCallback(req));
        };
        exports.fdatasync = function() {
            throw new Error("Unimplemented");
        };
        const fstat = function(fd, callback) {
            const file = getFile(fd, callback);
            if (file === null) {
                return;
            }
            queue.addOperation(bindings.fstat_, [ file.file, file.flags, Stats, callback ]);
        };
        exports.fstat = function(fd, req) {
            fstat(fd, getCallback(req));
        };
        exports.fsync = function() {
            throw new Error("Unimplemented");
        };
        exports.ftruncate = function() {
            throw new Error("Unimplemented");
        };
        exports.futimes = function() {
            throw new Error("Unimplemented");
        };
        exports.link = function() {
            throw new Error("Unimplemented");
        };
        exports.lstat = function() {
            throw new Error("Unimplemented");
        };
        exports.mkdir = function(path, mode, req) {
            queue.addOperation(bindings.mkdir, [ filesystem, path, mode, getCallback(req) ]);
        };
        exports.mkdtemp = function() {
            throw new Error("Unimplemented");
        };
        const open = function(path, flags, mode, callback) {
            if (!path.startsWith("/")) {
                path = "/" + path;
            }
            queue.addOperation(bindings.open, [ filesystem, path, flags, mode, function(err, file) {
                if (err) {
                    callback(err);
                    return;
                }
                const fd = getFd();
                if (fd === -1) {
                    const error = new Error("Too many open files");
                    error.errno = 24;
                    error.code = "EMFILE";
                    callback(error);
                    return;
                }
                openFiles[fd] = {
                    file,
                    flags
                };
                callback(null, fd);
            } ]);
        };
        exports.open = function(path, flags, mode, req) {
            open(path, flags, mode, getCallback(req));
        };
        exports.read = function(fd, buffer, offset, length, position, req) {
            const callback = getCallback(req);
            const file = getFile(fd, callback);
            if (file === null) {
                return;
            }
            queue.addOperation(bindings.read, [ file.file, file.flags, buffer, offset, length, typeof position !== "number" ? -1 : position, callback ]);
        };
        exports.readdir = function(path, encoding, req) {
            queue.addOperation(bindings.readdir, [ filesystem, path, function(err, filenames) {
                const callback = getCallback(req);
                if (err) {
                    callback(err);
                    return;
                }
                if (encoding === undefined) {
                    encoding = "utf8";
                }
                if (encoding !== "buffer") {
                    filenames = filenames.map((function(buf) {
                        return buf.toString(encoding);
                    }));
                }
                callback(null, filenames);
            } ]);
        };
        exports.readlink = function() {
            throw new Error("Unimplemented");
        };
        exports.rename = function() {
            throw new Error("Unimplemented");
        };
        exports.rmdir = function(path, req) {
            queue.addOperation(bindings.rmdir, [ filesystem, path, getCallback(req) ]);
        };
        const stat = function(path, callback) {
            open(path, "r", 0, (function(err, fd) {
                if (err) {
                    callback(err);
                    return;
                }
                fstat(fd, (function(err, stats) {
                    if (err) {
                        callback(err);
                        return;
                    }
                    close(fd, (function(err) {
                        if (err) {
                            callback(err);
                            return;
                        }
                        callback(null, stats);
                    }));
                }));
            }));
        };
        exports.stat = function(path, req) {
            stat(path, getCallback(req));
        };
        exports.StatWatcher = function() {
            throw new Error("Unimplemented");
        };
        exports.symlink = function() {
            throw new Error("Unimplemented");
        };
        exports.unlink = function(path, req) {
            queue.addOperation(bindings.unlink_, [ filesystem, path, getCallback(req) ]);
        };
        exports.utimes = function() {
            throw new Error("Unimplemented");
        };
        exports.writeBuffer = function(fd, buffer, offset, length, position, req) {
            const callback = getCallback(req);
            const file = getFile(fd, callback);
            if (file === null) {
                return;
            }
            queue.addOperation(bindings.write, [ file.file, file.flags, buffer, offset, length, position, callback ]);
        };
        exports.writeBuffers = function() {
            throw new Error("Unimplemented");
        };
        exports.writeString = function(fd, string, position, enc, req) {
            const buffer = Buffer.from(string, enc);
            exports.writeBuffer(fd, buffer, 0, buffer.length, position, req);
        };
        exports.closeAllFileDescriptors = function(callback) {
            const fds = [];
            openFiles.forEach((function(file, fd) {
                if (file !== undefined) {
                    fds.push(fd);
                }
            }));
            const closeNext = function() {
                if (fds.length) {
                    const fd = fds.pop();
                    close(fd, (function(err) {
                        if (err) {
                            callback(err);
                            return;
                        }
                        closeNext();
                    }));
                } else {
                    callback(null);
                }
            };
            closeNext();
        };
        return exports;
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    let running = false;
    const queue = [];
    function run() {
        if (queue.length === 0) {
            running = false;
            return;
        }
        running = true;
        const {method, args} = queue.shift();
        const cb = args.pop();
        method(...args, (err, result) => {
            cb(err, result);
            run();
        });
    }
    exports.addOperation = function(method, args) {
        queue.push({
            method,
            args
        });
        if (!running) {
            run();
        }
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    const Buffer = __webpack_require__(37).Buffer;
    const Writable = __webpack_require__(0).Writable;
    const fs = __webpack_require__(3);
    const util = __webpack_require__(1);
    const constants = process.binding("constants").fs;
    const O_APPEND = constants.O_APPEND | 0;
    const O_CREAT = constants.O_CREAT | 0;
    const O_EXCL = constants.O_EXCL | 0;
    const O_RDONLY = constants.O_RDONLY | 0;
    const O_RDWR = constants.O_RDWR | 0;
    const O_SYNC = constants.O_SYNC | 0;
    const O_TRUNC = constants.O_TRUNC | 0;
    const O_WRONLY = constants.O_WRONLY | 0;
    function assertEncoding(encoding) {
        if (encoding && !Buffer.isEncoding(encoding)) {
            throw new Error(`Unknown encoding: ${encoding}`);
        }
    }
    exports.assertEncoding = assertEncoding;
    function stringToFlags(flag) {
        if (typeof flag === "number") {
            return flag;
        }
        switch (flag) {
          case "r":
            return O_RDONLY;

          case "rs":
          case "sr":
            return O_RDONLY | O_SYNC;

          case "r+":
            return O_RDWR;

          case "rs+":
          case "sr+":
            return O_RDWR | O_SYNC;

          case "w":
            return O_TRUNC | O_CREAT | O_WRONLY;

          case "wx":
          case "xw":
            return O_TRUNC | O_CREAT | O_WRONLY | O_EXCL;

          case "w+":
            return O_TRUNC | O_CREAT | O_RDWR;

          case "wx+":
          case "xw+":
            return O_TRUNC | O_CREAT | O_RDWR | O_EXCL;

          case "a":
            return O_APPEND | O_CREAT | O_WRONLY;

          case "ax":
          case "xa":
            return O_APPEND | O_CREAT | O_WRONLY | O_EXCL;

          case "a+":
            return O_APPEND | O_CREAT | O_RDWR;

          case "ax+":
          case "xa+":
            return O_APPEND | O_CREAT | O_RDWR | O_EXCL;
        }
        throw new Error("Unknown file open flag: " + flag);
    }
    exports.stringToFlags = stringToFlags;
    function SyncWriteStream(fd, options) {
        Writable.call(this);
        options = options || {};
        this.fd = fd;
        this.readable = false;
        this.autoClose = options.autoClose === undefined ? true : options.autoClose;
        this.on("end", () => this._destroy());
    }
    util.inherits(SyncWriteStream, Writable);
    SyncWriteStream.prototype._write = function(chunk, encoding, cb) {
        fs.writeSync(this.fd, chunk, 0, chunk.length);
        cb();
        return true;
    };
    SyncWriteStream.prototype._destroy = function() {
        if (this.fd === null) return;
        if (this.autoClose) fs.closeSync(this.fd);
        this.fd = null;
        return true;
    };
    SyncWriteStream.prototype.destroySoon = SyncWriteStream.prototype.destroy = function() {
        this._destroy();
        this.emit("close");
        return true;
    };
    exports.SyncWriteStream = SyncWriteStream;
    exports.realpathCacheKey = Symbol("realpathCacheKey");
}, function(module, exports, __webpack_require__) {
    var events = __webpack_require__(9), streams = __webpack_require__(0), fifolock = __webpack_require__(157), S = __webpack_require__(25), _ = __webpack_require__(21);
    exports.createFileSystem = function(volume, opts, cb) {
        if (typeof opts === "function") {
            cb = opts;
            opts = null;
        }
        opts = _.extend({
            ro: false,
            noatime: true,
            modmode: 73,
            umask: "umask" in process ? process.umask() : 18,
            uid: "getuid" in process ? process.getuid() : 0,
            gid: "getgid" in process ? process.getgid() : 0
        }, opts);
        if (!volume.writeSectors) opts.ro = true;
        if (opts.ro) opts.noatime = true;
        var fs = new events.EventEmitter, vol = null, dir = __webpack_require__(160), c = __webpack_require__(77), q = fifolock();
        var GROUP = _.log.level < _.log.INFO ? q.TRANSACTION_WRAPPER.bind({
            postAcquire: function(proceed) {
                _.log(_.log.DBG, "=== Starting GROUP ===");
                proceed();
            },
            preRelease: function(finish) {
                _.log(_.log.DBG, "=== Finishing GROUP ===");
                finish();
            }
        }) : q.TRANSACTION_WRAPPER;
        q.acquire((function(unlock) {
            var d = _.allocBuffer(volume.sectorSize);
            volume.readSectors(0, d, (function(e) {
                if (e) fs.emit("error", e); else {
                    try {
                        init(d);
                    } catch (e) {
                        fs.emit("error", e);
                        unlock();
                        return;
                    }
                    fs.emit("ready");
                }
                unlock();
            }));
        }));
        if (cb) fs.on("error", cb).on("ready", cb.bind(null, null));
        function init(bootSector) {
            vol = __webpack_require__(161).init(volume, opts, bootSector);
            fs._dirIterator = dir.iterator.bind(dir);
            var entryInfoByPath = {}, baseEntry = {
                _refs: 0,
                _record: function() {
                    entryInfoByPath[this.path] = this;
                    if (this.parent) this.parent.retain();
                    return this;
                },
                retain: function() {
                    if (!this._refs) this._record();
                    this._refs += 1;
                    return this;
                },
                release: function() {
                    this._refs -= 1;
                    if (!this._refs) this._rescind();
                },
                _rescind: function() {
                    if (this.parent) this.parent.release();
                    delete entryInfoByPath[this.path];
                }
            };
            fs._createSharedEntry = function(path, entry, chain, parent) {
                return _.extend(Object.create(baseEntry), {
                    _refs: 0,
                    path,
                    entry,
                    chain,
                    parent
                }).retain();
            };
            fs._createSharedEntry("/", {
                Attr: {
                    directory: true
                }
            }, vol.rootDirectoryChain);
            fs._sharedEntryForSteps = function(steps, opts, cb) {
                var path = steps.join("/") || "/", name = steps.pop(), info = entryInfoByPath[path];
                if (info) cb(null, info.retain()); else fs._sharedEntryForSteps(steps, {}, (function(e, parentInfo) {
                    if (e) cb(e); else if (!parentInfo.entry.Attr.directory) cb(S.err.NOTDIR()); else dir.findInDirectory(vol, parentInfo.chain, name, opts, (function(e, entry) {
                        if (e && !opts.prepareForCreate) cb(e); else if (e) cb(e, {
                            missingChild: _.extend(entry, {
                                name
                            }),
                            parent: parentInfo
                        }); else cb(null, fs._createSharedEntry(path, entry, vol.chainForCluster(entry._firstCluster), parentInfo));
                    }));
                }));
            };
            fs._updateEntry = dir.updateEntry.bind(dir, vol);
            fs._makeStat = dir.makeStat.bind(dir, vol);
            fs._addFile = dir.addFile.bind(dir, vol);
            fs._initDir = dir.init.bind(dir, vol);
        }
        var fileDescriptors = [ null, null, null ];
        fs.open = function(path, flags, mode, cb, _n_) {
            if (typeof mode === "function") {
                _n_ = cb;
                cb = mode;
                mode = 438;
            }
            cb = GROUP(cb, (function() {
                var _fd = {
                    flags: null,
                    entry: null,
                    chain: null,
                    pos: 0
                }, f = _.parseFlags(flags);
                if (vol.opts.ro && (f.write || f.create || f.truncate)) return _.delayedCall(cb, S.err.ROFS()); else _fd.flags = f;
                fs._sharedEntryForSteps(_.absoluteSteps(path), {
                    prepareForCreate: f.create
                }, (function(e, info) {
                    if (e && !(e.code === "NOENT" && f.create && info)) cb(e); else if (e) fs._addFile(info.parent.chain, info.missingChild, {
                        dir: f._openDir
                    }, (function(e, newEntry, newChain) {
                        if (e) cb(e); else finish(fs._createSharedEntry(_.absolutePath(path), newEntry, newChain, info.parent));
                    })); else if (info && f.exclusive) cb(S.err.EXIST()); else if (info.entry.Attr.directory && !f._openDir) cb(S.err.ISDIR()); else if (f.write && info.entry.Attr.readonly) cb(S.err.ACCES()); else finish(info);
                    function finish(fileInfo) {
                        var fd = fileDescriptors.push(_fd) - 1;
                        _fd.info = fileInfo;
                        _fd.entry = fileInfo.entry;
                        _fd.chain = fileInfo.chain;
                        if (f.append) _fd.pos = _fd.entry._size;
                        if (f._openDir) _fd.chain.cacheAdvice = "WILLNEED";
                        if (f.truncate && _fd.entry._size) fs.ftruncate(fd, 0, (function(e) {
                            cb(e, fd);
                        }), "_nested_"); else _.delayedCall(cb, null, fd);
                    }
                }));
            }), _n_ === "_nested_");
        };
        fs.fstat = function(fd, cb, _n_) {
            cb = GROUP(cb, (function() {
                var _fd = fileDescriptors[fd];
                if (!_fd || !_fd.flags.read) _.delayedCall(cb, S.err.BADF()); else _.delayedCall(cb, null, fs._makeStat(_fd.entry));
            }), _n_ === "_nested_");
        };
        fs.futimes = function(fd, atime, mtime, cb, _n_) {
            cb = GROUP(cb, (function() {
                var _fd = fileDescriptors[fd];
                if (!_fd || !_fd.flags.write) _.delayedCall(cb, S.err.BADF()); else fs._updateEntry(_fd.entry, {
                    atime: atime || true,
                    mtime: mtime || true
                }, cb);
            }), _n_ === "_nested_");
        };
        fs.fchmod = function(fd, mode, cb, _n_) {
            cb = GROUP(cb, (function() {
                var _fd = fileDescriptors[fd];
                if (!_fd || !_fd.flags.write) _.delayedCall(cb, S.err.BADF()); else {
                    mode &= S._I._chmoddable;
                    if (_fd.entry.Attr.directory) mode |= S._I.FDIR; else if (!_fd.entry.Attr.volume_id) mode |= S._I.FREG;
                    fs._updateEntry(_fd.entry, {
                        mode
                    }, cb);
                }
            }), _n_ === "_nested_");
        };
        fs.read = function(fd, buf, off, len, pos, cb, _n_) {
            cb = GROUP(cb, (function() {
                var _fd = fileDescriptors[fd];
                if (!_fd || !_fd.flags.read) _.delayedCall(cb, S.err.BADF());
                var _pos = pos === null ? _fd.pos : pos, _len = Math.min(len, _fd.entry._size - _pos), _buf = buf.slice(off, off + _len);
                _fd.chain.readFromPosition(_pos, _buf, (function(e, bytes, slice) {
                    if (_.workaroundTessel380) _buf.copy(buf, off);
                    _fd.pos = _pos + bytes;
                    if (e || vol.opts.noatime) finish(e); else fs._updateEntry(_fd.entry, {
                        atime: true
                    }, finish);
                    function finish(e) {
                        cb(e, bytes, buf);
                    }
                }));
            }), _n_ === "_nested_");
        };
        fs._readdir = function(fd, cb, _n_) {
            cb = GROUP(cb, (function() {
                var _fd = fileDescriptors[fd];
                if (!_fd || !_fd.flags.read) _.delayedCall(cb, S.err.BADF()); else {
                    var entryNames = [], getNextEntry = fs._dirIterator(_fd.chain);
                    function processNext() {
                        getNextEntry((function(e, d) {
                            if (e) cb(e); else if (!d && !entryNames.length) cb(null, entryNames); else if (!d) cb(null, entryNames.sort()); else {
                                if (d._name !== "." && d._name !== "..") entryNames.push(d._name);
                                processNext();
                            }
                        }));
                    }
                    processNext();
                }
            }), _n_ === "_nested_");
        };
        fs._mkdir = function(fd, cb, _n_) {
            cb = GROUP(cb, (function() {
                var _fd = fileDescriptors[fd];
                if (!_fd || !_fd.flags.write) _.delayedCall(cb, S.err.BADF()); else fs._initDir(_fd.info, cb);
            }), _n_ === "_nested_");
        };
        fs.write = function(fd, buf, off, len, pos, cb, _n_) {
            cb = GROUP(cb, (function() {
                var _fd = fileDescriptors[fd];
                if (!_fd || !_fd.flags.write) _.delayedCall(cb, S.err.BADF());
                var _pos = pos === null || _fd.flags.append ? _fd.pos : pos, _buf = buf.slice(off, off + len);
                if (_pos > _fd.entry._size) {
                    var padLen = _pos - _fd.entry._size, padBuf = _.allocBuffer(padLen + _buf.length);
                    padBuf.fill(0, 0, padLen);
                    _buf.copy(padBuf, padLen);
                    _pos = _fd.entry._size;
                    _buf = padBuf;
                }
                _fd.chain.writeToPosition(_pos, _buf, (function(e) {
                    _fd.pos = _pos + len;
                    var newSize = Math.max(_fd.entry._size, _fd.pos), newInfo = {
                        size: newSize,
                        _touch: true
                    };
                    fs._updateEntry(_fd.entry, newInfo, (function(ee) {
                        cb(e || ee, len, buf);
                    }));
                }));
            }), _n_ === "_nested_");
        };
        fs.ftruncate = function(fd, len, cb, _n_) {
            cb = GROUP(cb, (function() {
                var _fd = fileDescriptors[fd];
                if (!_fd || !_fd.flags.write) _.delayedCall(cb, S.err.BADF());
                var newStats = {
                    size: len,
                    _touch: true
                };
                if (len === _fd.entry._size) _.delayedCall(cb); else if (len < _fd.entry._size) fs._updateEntry(_fd.entry, newStats, (function(e) {
                    if (e) cb(e); else _fd.chain.truncate(Math.ceil(len / _fd.chain.sectorSize), cb);
                })); else _fd.chain.writeToPosition(_fd.entry._size, _.allocBuffer(len - _fd.entry._size, 0), (function(e) {
                    if (e) cb(e); else fs._updateEntry(_fd.entry, newStats, cb);
                }));
            }), _n_ === "_nested_");
        };
        fs._fadviseSync = function(fd, off, len, advice) {
            if (off !== 0 || len !== 0) throw Error("Cache advise can currently be given only for whole file!");
            var _fd = fileDescriptors[fd];
            if (!_fd) throw S.err.BADF(); else _fd.chain.cacheAdvice = advice;
        };
        fs.fsync = function(fd, cb) {
            var _fd = fileDescriptors[fd];
            if (!_fd) _.delayedCall(cb, S.err.BADF()); else _.delayedCall(cb);
        };
        fs.close = function(fd, cb) {
            var _fd = fileDescriptors[fd];
            if (!_fd) _.delayedCall(cb, S.err.BADF()); else setTimeout(_fd.info.release.bind(_fd.info), 500), 
            _.delayedCall(cb, fileDescriptors[fd] = null);
        };
        var workaroundTessel436;
        try {
            new __webpack_require__(0).Readable({
                encoding: "utf8"
            });
            new streams.Readable({
                encoding: "utf8"
            });
        } catch (e) {
            workaroundTessel436 = true;
        }
        function _createStream(StreamType, path, opts) {
            if (workaroundTessel436 && "encoding" in opts) {
                console.warn("Tessel does not currently support encoding option for Readable streams, discarding!");
                delete opts.encoding;
            }
            var fd = opts.fd !== null ? opts.fd : "_opening_", pos = opts.start, stream = new StreamType(opts);
            if (fd === "_opening_") fs.open(path, opts.flags, opts.mode, (function(e, _fd) {
                if (e) {
                    fd = "_open_error_";
                    stream.emit("error", e);
                } else {
                    fd = _fd;
                    fs._fadviseSync(fd, 0, 0, "SEQUENTIAL");
                    stream.emit("open", fd);
                }
            }));
            function autoClose(tombstone) {
                if (opts.autoClose) fs.close(fd, (function(e) {
                    if (e) stream.emit("error", e); else stream.emit("close");
                }));
                fd = tombstone;
            }
            if (StreamType === streams.Readable) {
                stream._read = function(n) {
                    var buf;
                    n = Math.min(n, opts.end - pos);
                    if (fd === "_opening_") stream.once("open", (function() {
                        stream._read(n);
                    })); else if (pos > opts.end) stream.push(null); else if (n > 0) buf = _.allocBuffer(n), 
                    fs.read(fd, buf, 0, n, pos, (function(e, n, d) {
                        if (e) {
                            autoClose("_read_error_");
                            stream.emit("error", e);
                        } else stream.push(n ? d.slice(0, n) : null);
                    })), pos += n; else stream.push(null);
                };
                stream.once("end", (function() {
                    autoClose("_ended_");
                }));
            } else if (StreamType === streams.Writable) {
                stream.bytesWritten = 0;
                stream._write = function(data, _enc, cb) {
                    if (fd === "_opening_") stream.once("open", (function() {
                        stream._write(data, null, cb);
                    })); else fs.write(fd, data, 0, data.length, pos, (function(e, n) {
                        if (e) {
                            autoClose("_write_error_");
                            cb(e);
                        } else {
                            stream.bytesWritten += n;
                            cb();
                        }
                    })), pos += data.length;
                };
                stream.once("finish", (function() {
                    autoClose("_finished_");
                }));
            }
            return stream;
        }
        fs.createReadStream = function(path, opts) {
            return _createStream(streams.Readable, path, _.extend({
                start: 0,
                end: Infinity,
                flags: "r",
                mode: 438,
                encoding: null,
                fd: null,
                autoClose: true
            }, opts));
        };
        fs.createWriteStream = function(path, opts) {
            return _createStream(streams.Writable, path, _.extend({
                start: 0,
                flags: "w",
                mode: 438,
                fd: null,
                autoClose: true
            }, opts, {
                decodeStrings: true,
                objectMode: false
            }));
        };
        function _fdOperation(path, opts, fn, cb) {
            cb = GROUP(cb, (function() {
                opts.advice || (opts.advice = "NORMAL");
                fs.open(path, opts.flag, (function(e, fd) {
                    if (e) cb(e); else fs._fadviseSync(fd, 0, 0, opts.advice), fn(fd, (function() {
                        var ctx = this, args = arguments;
                        fs.close(fd, (function(closeErr) {
                            cb.apply(ctx, args);
                        }), "_nested_");
                    }));
                }), "_nested_");
            }));
        }
        fs.stat = fs.lstat = function(path, cb) {
            _fdOperation(path, {
                flag: "r"
            }, (function(fd, cb) {
                fs.fstat(fd, cb, "_nested_");
            }), cb);
        };
        fs.exists = function(path, cb) {
            fs.stat(path, (function(err) {
                cb(err ? false : true);
            }));
        };
        fs.readFile = function(path, opts, cb) {
            if (typeof opts === "function") {
                cb = opts;
                opts = {};
            }
            opts.flag || (opts.flag = "r");
            opts.advice || (opts.advice = "NOREUSE");
            _fdOperation(path, opts, (function(fd, cb) {
                fs.fstat(fd, (function(e, stat) {
                    if (e) return cb(e); else {
                        var buffer = _.allocBuffer(stat.size);
                        fs.read(fd, buffer, 0, buffer.length, null, (function(e) {
                            if (e) cb(e); else cb(null, opts.encoding ? buffer.toString(opts.encoding) : buffer);
                        }), "_nested_");
                    }
                }), "_nested_");
            }), cb);
        };
        fs.writeFile = function(path, data, opts, cb) {
            if (typeof opts === "function") {
                cb = opts;
                opts = {};
            }
            opts.flag || (opts.flag = "w");
            opts.advice || (opts.advice = "NOREUSE");
            _fdOperation(path, opts, (function(fd, cb) {
                if (typeof data === "string") data = _.bufferFrom(data, opts.encoding || "utf8");
                fs.write(fd, data, 0, data.length, null, (function(e) {
                    cb(e);
                }), "_nested_");
            }), cb);
        };
        fs.appendFile = function(path, data, opts, cb) {
            if (typeof opts === "function") {
                cb = opts;
                opts = {};
            }
            opts.flag || (opts.flag = "a");
            fs.writeFile(path, data, opts, cb);
        };
        fs.truncate = function(path, len, cb) {
            _fdOperation(path, {
                flag: "r+"
            }, (function(fd, cb) {
                fs.ftruncate(fd, len, cb, "_nested_");
            }), cb);
        };
        fs.readdir = function(path, cb) {
            _fdOperation(path, {
                flag: "\\r"
            }, (function(fd, cb) {
                fs._readdir(fd, cb, "_nested_");
            }), cb);
        };
        fs.mkdir = function(path, mode, cb) {
            if (typeof mode === "function") {
                cb = mode;
                mode = 511;
            }
            _fdOperation(path, {
                flag: "\\wx"
            }, (function(fd, cb) {
                fs._mkdir(fd, cb, "_nested_");
            }), cb);
        };
        fs.utimes = function(path, atime, mtime, cb) {
            _fdOperation(path, {
                flag: "r+"
            }, (function(fd, cb) {
                fs.futimes(fd, atime, mtime, cb, "_nested_");
            }), cb);
        };
        fs.chmod = fs.lchmod = function(path, mode, cb) {
            _fdOperation(path, {
                flag: "\\r+"
            }, (function(fd, cb) {
                fs.fchmod(fd, mode, cb, "_nested_");
            }), cb);
        };
        fs.chown = fs.lchown = function(path, uid, gid, cb) {
            _fdOperation(path, {
                flag: "\\r+"
            }, (function(fd, cb) {
                fs.fchown(fd, uid, gid, cb, "_nested_");
            }), cb);
        };
        fs.link = function(src, dst, cb) {
            _.delayedCall(cb, S.err.NOSYS());
        };
        fs.symlink = function(src, dst, type, cb) {
            if (typeof type === "function") {
                cb = type;
                type = null;
            }
            _.delayedCall(cb, S.err.NOSYS());
        };
        fs.readlink = function(path, cb) {
            _fdOperation(path, {
                flag: "\\r"
            }, (function(fd, cb) {
                cb(S.err.INVAL());
            }), cb);
        };
        fs.realpath = function(path, cache, cb) {
            if (typeof cache === "function") {
                cb = cache;
                cache = null;
            }
            if (cache) _.delayedCall(cb, S.err.NOSYS()); else _fdOperation(path, {
                flag: "\\r"
            }, (function(fd, cb) {
                cb(null, _.absolutePath(path));
            }), cb);
        };
        fs.fchown = function(fd, uid, gid, cb, _n_) {
            cb = GROUP(cb, (function() {
                var _fd = fileDescriptors[fd];
                if (!_fd || !_fd.flags.write) _.delayedCall(cb, S.err.BADF()); else _.delayedCall(cb, S.err.NOSYS());
            }), _n_ === "_nested_");
        };
        return fs;
    };
}, function(module, exports) {
    module.exports = function SerialQueue() {
        var q = {}, tasks = [];
        function runNext() {
            tasks[0]((function() {
                tasks.shift();
                if (tasks.length) runNext();
            }));
        }
        q.acquire = function(fn) {
            var len = tasks.push(fn);
            if (len === 1) process.nextTick(runNext);
        };
        q.TRANSACTION_WRAPPER = function(cb, proceed, nested) {
            if (nested) return process.nextTick(proceed), cb;
            var _releaseQueue;
            if ("postAcquire" in this) proceed = this.postAcquire.bind(q, proceed);
            q.acquire((function(releaseQueue) {
                _releaseQueue = releaseQueue;
                proceed();
            }));
            var capturedCB, finish = "preRelease" in this ? this.preRelease.bind(q, _finish) : _finish;
            function _finish() {
                capturedCB();
                _releaseQueue();
            }
            return function() {
                capturedCB = Function.prototype.apply.bind(cb, this, arguments);
                finish.call(null, Array.prototype.slice.call(arguments, 0), this);
            };
        };
        return q;
    };
}, function(module, exports) {
    var _ = {};
    function truncatedReadUInt32BE(buffer, offset) {
        var availableBytes = buffer.length - offset;
        if (availableBytes >= 4) {
            return buffer.readUInt32BE(offset);
        } else if (availableBytes === 3) {
            var first = buffer.readUInt16BE(offset);
            var second = buffer.readUInt8(offset + 2);
            return (first << 8) + second << 8 >>> 0;
        } else if (availableBytes === 2) {
            return buffer.readUInt16BE(offset) << 16 >>> 0;
        } else if (availableBytes === 1) {
            return buffer.readUInt8(offset) << 24 >>> 0;
        } else if (availableBytes <= 0) {
            return 0;
        }
    }
    function truncatedWriteUInt32BE(buffer, offset, data) {
        var availableBytes = buffer.length - offset;
        if (availableBytes >= 4) {
            buffer.writeUInt32BE(data, offset);
        } else if (availableBytes === 3) {
            buffer.writeUInt16BE(data >>> 16, offset);
            buffer.writeUInt8(data >>> 8 & 255, offset + 2);
        } else if (availableBytes === 2) {
            buffer.writeUInt16BE(data >>> 16, offset);
        } else if (availableBytes === 1) {
            buffer.writeUInt8(data >>> 24, offset);
        }
    }
    function newBuffer(size) {
        if (Buffer.alloc) {
            return Buffer.alloc(size);
        } else {
            return new Buffer(size);
        }
    }
    function extend(obj) {
        Array.prototype.slice.call(arguments, 1).forEach((function(ext) {
            Object.keys(ext).forEach((function(key) {
                obj[key] = ext[key];
            }));
        }));
        return obj;
    }
    function addField(ctr, f) {
        if ("width" in f) {
            ctr.bits = (ctr.bits || 0) + f.width;
            while (ctr.bits > 7) {
                ctr.bytes += 1;
                ctr.bits -= 8;
            }
        } else if (!ctr.bits) {
            ctr.bytes += f.size;
        } else {
            throw Error("Improperly aligned bitfield before field: " + f.name);
        }
        return ctr;
    }
    function arrayizeField(f, count) {
        var f2 = typeof count === "number" ? extend({
            name: f.name,
            field: f,
            valueFromBytes: function(buf, off) {
                off || (off = {
                    bytes: 0,
                    bits: 0
                });
                var arr = new Array(count);
                for (var idx = 0, len = arr.length; idx < len; idx += 1) {
                    arr[idx] = f.valueFromBytes(buf, off);
                }
                return arr;
            },
            bytesFromValue: function(arr, buf, off) {
                arr || (arr = new Array(count));
                buf || (buf = newBuffer(this.size));
                off || (off = {
                    bytes: 0,
                    bits: 0
                });
                for (var idx = 0, len = Math.min(arr.length, count); idx < len; idx += 1) {
                    f.bytesFromValue(arr[idx], buf, off);
                }
                while (idx++ < count) addField(off, f);
                return buf;
            }
        }, "width" in f ? {
            width: f.width * count
        } : {
            size: f.size * count
        }) : f;
        f2.pack = f2.bytesFromValue;
        f2.unpack = f2.valueFromBytes;
        return f2;
    }
    _.struct = function(name, fields, count) {
        if (typeof name !== "string") {
            count = fields;
            fields = name;
            name = null;
        }
        var _size = {
            bytes: 0,
            bits: 0
        }, _padsById = Object.create(null), fieldsObj = fields.reduce((function(obj, f, i) {
            if ("_padTo" in f) {
                f._id || (f._id = "id" + Math.random().toFixed(20).slice(2));
                var _f = _padsById[f._id] = _size.bits ? {
                    width: 8 * (f._padTo - _size.bytes) - _size.bits
                } : {
                    size: f._padTo - _size.bytes
                };
                if (_f.width < 0 || _f.size < 0) {
                    var xtraMsg = _size.bits ? " and " + _size.bits + " bits" : "";
                    throw Error("Invalid .padTo(" + f._padTo + ") field, struct is already " + _size.bytes + " byte(s)" + xtraMsg + "!");
                }
                f = _f;
            } else if (f._hoistFields) Object.keys(f._hoistFields).forEach((function(name) {
                var _f = Object.create(f._hoistFields[name]);
                if ("width" in _f) _f.offset = {
                    bytes: _f.offset.bytes + _size.bytes,
                    bits: _f.offset.bits
                }; else _f.offset += _size.bytes;
                obj[name] = _f;
            })); else if (f.name) {
                f = Object.create(f);
                f.offset = "width" in f ? {
                    bytes: _size.bytes,
                    bits: _size.bits
                } : _size.bytes, obj[f.name] = f;
            }
            addField(_size, f);
            return obj;
        }), {});
        if (_size.bits) throw Error("Improperly aligned bitfield at end of struct: " + name);
        return arrayizeField({
            valueFromBytes: function(buf, off) {
                off || (off = {
                    bytes: 0,
                    bits: 0
                });
                var obj = new Object;
                fields.forEach((function(f) {
                    if ("_padTo" in f) return addField(off, _padsById[f._id]);
                    var value = f.valueFromBytes(buf, off);
                    if (f.name) obj[f.name] = value; else if (typeof value === "object") extend(obj, value);
                }));
                return obj;
            },
            bytesFromValue: function(obj, buf, off) {
                obj || (obj = {});
                buf || (buf = newBuffer(this.size));
                off || (off = {
                    bytes: 0,
                    bits: 0
                });
                fields.forEach((function(f) {
                    if ("_padTo" in f) return addField(off, _padsById[f._id]);
                    var value = f.name ? obj[f.name] : obj;
                    f.bytesFromValue(value, buf, off);
                }));
                return buf;
            },
            _hoistFields: !name ? fieldsObj : null,
            fields: fieldsObj,
            size: _size.bytes,
            name
        }, count);
    };
    _.padTo = function(off) {
        return {
            _padTo: off
        };
    };
    var FULL = 4294967295;
    function bitfield(name, width, count) {
        width || (width = 1);
        if (width > 24) throw Error("Bitfields support a maximum width of 24 bits.");
        var impl = this, mask = FULL >>> 32 - width;
        return arrayizeField({
            valueFromBytes: function(buf, off) {
                off || (off = {
                    bytes: 0,
                    bits: 0
                });
                var end = (off.bits || 0) + width, word = truncatedReadUInt32BE(buf, off.bytes) || 0, over = word >>> 32 - end;
                addField(off, this);
                return impl.b2v.call(this, over & mask);
            },
            bytesFromValue: function(val, buf, off) {
                val = impl.v2b.call(this, val || 0);
                off || (off = {
                    bytes: 0,
                    bits: 0
                });
                var end = (off.bits || 0) + width, word = truncatedReadUInt32BE(buf, off.bytes) || 0, zero = mask << 32 - end, over = (val & mask) << 32 - end;
                word &= ~zero;
                word |= over;
                word >>>= 0;
                truncatedWriteUInt32BE(buf, off.bytes, word);
                addField(off, this);
                return buf;
            },
            width,
            name
        }, count);
    }
    function swapBits(n, w) {
        var o = 0;
        while (w--) {
            o <<= 1;
            o |= n & 1;
            n >>>= 1;
        }
        return o;
    }
    _.bool = function(name, count) {
        return bitfield.call({
            b2v: function(b) {
                return Boolean(b);
            },
            v2b: function(v) {
                return v ? FULL : 0;
            }
        }, name, 1, count);
    };
    _.ubit = bitfield.bind({
        b2v: function(b) {
            return b;
        },
        v2b: function(v) {
            return v;
        }
    });
    _.ubitLE = bitfield.bind({
        b2v: function(b) {
            return swapBits(b, this.width);
        },
        v2b: function(v) {
            return swapBits(v, this.width);
        }
    });
    _.sbit = bitfield.bind({
        b2v: function(b) {
            var m = 1 << this.width - 1, s = b & m;
            return s ? -(b &= ~m) : b;
        },
        v2b: function(v) {
            var m = 1 << this.width - 1, s = v < 0;
            return s ? -v | m : v;
        }
    });
    function bytefield(name, size, count) {
        if (typeof name !== "string") {
            count = size;
            size = name;
            name = null;
        }
        size = typeof size === "number" ? size : 1;
        var impl = this;
        return arrayizeField({
            valueFromBytes: function(buf, off) {
                off || (off = {
                    bytes: 0,
                    bits: 0
                });
                var val = buf.slice(off.bytes, off.bytes + this.size);
                addField(off, this);
                return impl.b2v.call(this, val);
            },
            bytesFromValue: function(val, buf, off) {
                off || (off = {
                    bytes: 0
                });
                buf || (buf = newBuffer(this.size));
                var blk = buf.slice(off.bytes, off.bytes + this.size), len = impl.vTb.call(this, val, blk);
                if (len < blk.length) blk.fill(0, len);
                addField(off, this);
                return buf;
            },
            size,
            name
        }, count);
    }
    function swapBytesPairs(fromBuffer, toBuffer) {
        toBuffer = toBuffer || fromBuffer;
        var l = fromBuffer.length;
        for (var i = 1; i < l; i += 2) {
            var a = fromBuffer[i - 1];
            toBuffer[i - 1] = fromBuffer[i];
            toBuffer[i] = a;
        }
        return toBuffer;
    }
    _.byte = bytefield.bind({
        b2v: function(b) {
            return b;
        },
        vTb: function(v, b) {
            if (!v) return 0;
            v.copy(b);
            return v.length;
        }
    });
    _.char = bytefield.bind({
        b2v: function(b) {
            var v = b.toString("utf8"), z = v.indexOf("\0");
            return ~z ? v.slice(0, z) : v;
        },
        vTb: function(v, b) {
            v || (v = "");
            return b.write(v, "utf8");
        }
    });
    _.char16le = bytefield.bind({
        b2v: function(b) {
            var v = b.toString("utf16le"), z = v.indexOf("\0");
            return ~z ? v.slice(0, z) : v;
        },
        vTb: function(v, b) {
            v || (v = "");
            return b.write(v, "utf16le");
        }
    });
    _.char16be = bytefield.bind({
        b2v: function(b) {
            var temp = newBuffer(b.length);
            swapBytesPairs(b, temp);
            var v = temp.toString("utf16le"), z = v.indexOf("\0");
            return ~z ? v.slice(0, z) : v;
        },
        vTb: function(v, b) {
            v || (v = "");
            var len = b.write(v, "utf16le");
            swapBytesPairs(b);
            return len;
        }
    });
    function standardField(sig, size) {
        var read = "read" + sig, dump = "write" + sig;
        size || (size = +sig.match(/\d+/)[0] >> 3);
        return function(name, count) {
            if (typeof name !== "string") {
                count = name;
                name = null;
            }
            return arrayizeField({
                valueFromBytes: function(buf, off) {
                    off || (off = {
                        bytes: 0
                    });
                    var val = buf[read](off.bytes);
                    addField(off, this);
                    return val;
                },
                bytesFromValue: function(val, buf, off) {
                    val || (val = 0);
                    buf || (buf = newBuffer(this.size));
                    off || (off = {
                        bytes: 0
                    });
                    buf[dump](val, off.bytes);
                    addField(off, this);
                    return buf;
                },
                size,
                name
            }, count);
        };
    }
    _.float32 = standardField("FloatBE", 4);
    _.float64 = standardField("DoubleBE", 8);
    _.float32le = standardField("FloatLE", 4);
    _.float64le = standardField("DoubleLE", 8);
    _.uint8 = standardField("UInt8");
    _.uint16 = standardField("UInt16BE");
    _.uint32 = standardField("UInt32BE");
    _.uint16le = standardField("UInt16LE");
    _.uint32le = standardField("UInt32LE");
    _.int8 = standardField("Int8");
    _.int16 = standardField("Int16BE");
    _.int32 = standardField("Int32BE");
    _.int16le = standardField("Int16LE");
    _.int32le = standardField("Int32LE");
    _.derive = function(orig, pack, unpack) {
        return function(name, count) {
            if (typeof name !== "string") {
                count = name;
                name = null;
            }
            return arrayizeField(extend({
                valueFromBytes: function(buf, off) {
                    return unpack(orig.valueFromBytes(buf, off));
                },
                bytesFromValue: function(val, buf, off) {
                    return orig.bytesFromValue(pack(val), buf, off);
                },
                name
            }, "width" in orig ? {
                width: orig.width
            } : {
                size: orig.size
            }), count);
        };
    };
    module.exports = _;
}, function(module, exports) {
    module.exports = function(obj) {
        Array.prototype.slice.call(arguments, 1).forEach((function(ext) {
            if (ext) Object.keys(ext).forEach((function(key) {
                obj[key] = ext[key];
            }));
        }));
        return obj;
    };
}, function(module, exports, __webpack_require__) {
    var S = __webpack_require__(25), _ = __webpack_require__(21);
    var dir = exports;
    dir.iterator = function(dirChain, opts) {
        opts || (opts = {});
        var cache = {
            buffer: null,
            n: null
        };
        function getSectorBuffer(n, cb) {
            if (cache.n === n) cb(null, cache.buffer); else cache.n = cache.buffer = null, dirChain.readSectors(n, _.allocBuffer(dirChain.sectorSize), (function(e, d) {
                if (e) cb(e); else if (!d) return cb(null, null); else {
                    cache.n = n;
                    cache.buffer = d;
                    getSectorBuffer(n, cb);
                }
            }));
        }
        var secIdx = 0, off = {
            bytes: 0
        }, long = null;
        function getNextEntry(cb) {
            if (off.bytes >= dirChain.sectorSize) {
                secIdx += 1;
                off.bytes -= dirChain.sectorSize;
            }
            var entryPos = {
                chain: dirChain,
                sector: secIdx,
                offset: off.bytes
            };
            getSectorBuffer(secIdx, (function(e, buf) {
                if (e) return cb(S.err.IO()); else if (!buf) return cb(null, null, entryPos);
                var entryIdx = off.bytes, signalByte = buf[entryIdx];
                if (signalByte === S.entryDoneFlag) return cb(null, null, entryPos); else if (signalByte === S.entryFreeFlag) {
                    off.bytes += S.dirEntry.size;
                    long = null;
                    if (opts.includeFree) return cb(null, {
                        _free: true,
                        _pos: entryPos
                    }, entryPos); else return getNextEntry(cb);
                }
                var attrByte = buf[entryIdx + S.dirEntry.fields.Attr.offset], entryType = attrByte === S.longDirFlag ? S.longDirEntry : S.dirEntry_simple;
                var entry = entryType.valueFromBytes(buf, off);
                entry._pos = entryPos;
                _.log(_.log.DBG, "entry:", entry, secIdx, entryIdx);
                if (entryType === S.longDirEntry) {
                    var firstEntry;
                    if (entry.Ord & S.lastLongFlag) {
                        firstEntry = true;
                        entry.Ord &= ~S.lastLongFlag;
                        long = {
                            name: -1,
                            sum: entry.Chksum,
                            _rem: entry.Ord - 1,
                            _arr: []
                        };
                    }
                    if (firstEntry || long && entry.Chksum === long.sum && entry.Ord === long._rem--) {
                        var S_lde_f = S.longDirEntry.fields, namepart = entry.Name1;
                        if (entry.Name1.length === S_lde_f.Name1.size / 2) {
                            namepart += entry.Name2;
                            if (entry.Name2.length === S_lde_f.Name2.size / 2) {
                                namepart += entry.Name3;
                            }
                        }
                        long._arr.push(namepart);
                        if (!long._rem) {
                            long.name = long._arr.reverse().join("");
                            delete long._arr;
                            delete long._rem;
                        }
                    } else long = null;
                } else if ((attrByte & 8) === 0) {
                    var bestName = null;
                    if (long && long.name) {
                        var pos = entryIdx + S.dirEntry.fields["Name"].offset, sum = _.checksumName(buf, pos);
                        if (sum === long.sum) bestName = long.name;
                    }
                    if (!bestName) {
                        if (signalByte === S.entryIsE5Flag) entry.Name.filename = "å" + entry.Name.filename.slice(1);
                        var nam = entry.Name.filename.replace(/ +$/, ""), ext = entry.Name.extension.replace(/ +$/, "");
                        bestName = ext ? nam + "." + ext : nam;
                    }
                    entry._name = bestName;
                    var _entryBuffer = buf.slice(off.bytes - S.dirEntry.size, off.bytes);
                    entry._full = function() {
                        var _entry = S.dirEntry.valueFromBytes(_entryBuffer);
                        _.extend(entry, _entry);
                        entry._size = entry.FileSize;
                        entry._firstCluster = (entry.FstClusHI << 16) + entry.FstClusLO;
                        return entry;
                    };
                    long = null;
                    return cb(null, entry, entryPos);
                } else long = null;
                getNextEntry(cb);
            }));
        }
        function iter(cb) {
            getNextEntry(cb);
            return iter;
        }
        return iter;
    };
    function _updateEntry(vol, entry, newStats) {
        if ("size" in newStats) entry._size = entry.FileSize = newStats.size;
        if ("_touch" in newStats) newStats.archive = newStats.atime = newStats.mtime = true;
        if ("archive" in newStats) entry.Attr.archive = true;
        var _now;
        function applyDate(d, prefix, timeToo, tenthToo) {
            if (d === true) d = _now || (_now = new Date);
            entry[prefix + "Date"] = {
                year: d.getFullYear() - 1980,
                month: d.getMonth() + 1,
                day: d.getDate()
            };
            if (timeToo) {
                entry[prefix + "Time"] = {
                    hours: d.getHours(),
                    minutes: d.getMinutes(),
                    seconds_2: d.getSeconds() >>> 1
                };
                if (tenthToo) {
                    var msec = d.getSeconds() % 2 * 1e3 + d.getMilliseconds();
                    entry[prefix + "TimeTenth"] = Math.floor(msec / 100);
                }
            }
        }
        if ("ctime" in newStats) applyDate(newStats.ctime, "Crt", true, true);
        if ("mtime" in newStats) applyDate(newStats.mtime, "Wrt", true);
        if ("atime" in newStats) applyDate(newStats.atime, "LstAcc");
        if ("mode" in newStats) {
            entry.Attr.directory = newStats.mode & S._I.FDIR ? true : false;
            entry.Attr.volume_id = newStats.mode & S._I.FREG ? false : true;
            if (vol.opts.modmode === 73) {
                entry.Attr.archive = newStats.mode & S._I.XUSR ? true : false;
                entry.Attr.system = newStats.mode & S._I.XGRP ? true : false;
                entry.Attr.hidden = newStats.mode & S._I.XOTH ? true : false;
                entry.Attr.readonly = newStats.mode & S._I.WUSR ? false : true;
            } else if (vol.opts.modmode === 3584) {
                entry.Attr.archive = newStats.mode & S._I.SVTX ? true : false;
                entry.Attr.system = newStats.mode & S._I.SGID ? true : false;
                entry.Attr.hidden = newStats.mode & S._I.SUID ? true : false;
                entry.Attr.readonly = newStats.mode & S._I.WUSR || newStats.mode & S._I.WGRP || newStats.mode & S._I.WOTH ? false : true;
            }
        }
        if ("firstCluster" in newStats) {
            entry.FstClusLO = newStats.firstCluster & 65535;
            entry.FstClusHI = newStats.firstCluster >>> 16;
            entry._firstCluster = newStats.firstCluster;
        }
        return entry;
    }
    dir.makeStat = function(vol, entry) {
        var stats = {};
        stats.isFile = function() {
            return !entry.Attr.volume_id && !entry.Attr.directory;
        };
        stats.isDirectory = function() {
            return entry.Attr.directory;
        };
        stats.isBlockDevice = function() {
            return false;
        };
        stats.isCharacterDevice = function() {
            return false;
        };
        stats.isSymbolicLink = function() {
            return false;
        };
        stats.isFIFO = function() {
            return false;
        };
        stats.isSocket = function() {
            return false;
        };
        stats.size = entry.FileSize;
        stats.blksize = vol._sectorsPerCluster * vol._sectorSize;
        stats.blocks = Math.ceil(stats.size / stats.blksize) || 1;
        stats.nlink = 1;
        stats.mode = S._I.RUSR | S._I.RGRP | S._I.ROTH;
        if (!entry.Attr.readonly) stats.mode |= S._I.WUSR | S._I.WGRP | S._I.WOTH;
        if (entry.Attr.directory) stats.mode |= S._I.FDIR; else if (!entry.Attr.volume_id) stats.mode |= S._I.FREG;
        if (vol.opts.modmode === 73) {
            if (entry.Attr.archive) stats.mode |= S._I.XUSR;
            if (entry.Attr.system) stats.mode |= S._I.XGRP;
            if (entry.Attr.hidden) stats.mode |= S._I.XOTH;
        } else if (vol.opts.modmode === 3584) {
            if (entry.Attr.archive) stats.mode |= S._I.SVTX;
            if (entry.Attr.system) stats.mode |= S._I.SGID;
            if (entry.Attr.hidden) stats.mode |= S._I.SUID;
        }
        stats.mode &= ~vol.opts.umask;
        stats.uid = vol.opts.uid;
        stats.gid = vol.opts.gid;
        function extractDate(prefix) {
            var date = entry[prefix + "Date"], time = entry[prefix + "Time"] || {
                hours: 0,
                minutes: 0,
                seconds_2: 0
            }, secs = time.seconds_2 * 2, sect = entry[prefix + "TimeTenth"] || 0;
            if (sect > 100) {
                secs += 1;
                sect -= 100;
            }
            return new Date(date.year + 1980, date.month - 1, date.day, time.hours, time.minutes, secs, sect * 100);
        }
        stats.atime = extractDate("LstAcc");
        stats.mtime = extractDate("Wrt");
        stats.ctime = extractDate("Crt");
        entry = {
            Attr: _.extend({}, entry.Attr)
        };
        return stats;
    };
    dir.init = function(vol, dirInfo, cb) {
        var dirChain = dirInfo.chain, isRootDir = "numSectors" in dirChain, initialCluster = _.allocBuffer(dirChain.sectorSize * vol._sectorsPerCluster), entriesOffset = {
            bytes: 0
        };
        initialCluster.fill(0);
        function writeEntry(name, clusterNum) {
            while (name.length < 8) name += " ";
            S.dirEntry.bytesFromValue(_updateEntry(vol, {
                Name: {
                    filename: name,
                    extension: "   "
                },
                Attr: {
                    directory: true
                }
            }, {
                firstCluster: clusterNum,
                _touch: true,
                ctime: true
            }), initialCluster, entriesOffset);
        }
        if (!isRootDir) {
            writeEntry(".", dirChain.firstCluster);
            writeEntry("..", dirInfo.parent.chain.firstCluster);
        }
        dirChain.writeToPosition(0, initialCluster, cb);
    };
    dir.addFile = function(vol, dirChain, entryInfo, opts, cb) {
        if (typeof opts === "function") {
            cb = opts;
            opts = {};
        }
        var name = entryInfo.name, entries = [], mainEntry;
        entries.push(mainEntry = {
            Name: _.shortname(name),
            Attr: {
                directory: opts.dir || false
            },
            _name: name
        });
        if (true) {
            var workaroundTessel427 = "￿".length !== 1;
            if (workaroundTessel427) throw Error("Your JS runtime does not have proper Unicode string support. (If Tessel, is your firmware up-to-date?)");
            var S_lde_f = S.longDirEntry.fields, ENTRY_CHUNK_LEN = (S_lde_f.Name1.size + S_lde_f.Name2.size + S_lde_f.Name3.size) / 2, partialLen = name.length % ENTRY_CHUNK_LEN, paddingNeeded = partialLen && ENTRY_CHUNK_LEN - partialLen;
            if (paddingNeeded--) name += "\0";
            while (paddingNeeded-- > 0) name += "￿";
            var off = 0, ord = 1;
            while (off < name.length) entries.push({
                Ord: ord++,
                Name1: name.slice(off, off += S_lde_f.Name1.size / 2),
                Attr_raw: S.longDirFlag,
                Chksum: null,
                Name2: name.slice(off, off += S_lde_f.Name2.size / 2),
                Name3: name.slice(off, off += S_lde_f.Name3.size / 2)
            });
            entries[entries.length - 1].Ord |= S.lastLongFlag;
        }
        if (entryInfo.tail) {
            var name = mainEntry.Name.filename, suffix = "~" + entryInfo.tail, endIdx = name.indexOf(" "), sufIdx = ~endIdx ? Math.min(endIdx, name.length - suffix.length) : name.length - suffix.length;
            if (sufIdx < 0) return cb(S.err.NAMETOOLONG());
            mainEntry.Name.filename = name.slice(0, sufIdx) + suffix + name.slice(sufIdx + suffix.length);
            _.log(_.log.DBG, "Shortname amended to:", mainEntry.Name);
        }
        vol.allocateInFAT(dirChain.firstCluster || 2, (function(e, fileCluster) {
            if (e) return cb(e);
            var nameBuf = S.dirEntry.fields["Name"].bytesFromValue(mainEntry.Name), nameSum = _.checksumName(nameBuf);
            _updateEntry(vol, mainEntry, {
                firstCluster: fileCluster,
                size: 0,
                ctime: true,
                _touch: true
            });
            mainEntry._pos = _.adjustedPos(vol, entryInfo.target, S.dirEntry.size * (entries.length - 1));
            entries.slice(1).forEach((function(entry) {
                entry.Chksum = nameSum;
            }));
            entries.reverse();
            if (entryInfo.lastEntry) entries.push({});
            var entriesData = _.allocBuffer(S.dirEntry.size * entries.length), dataOffset = {
                bytes: 0
            };
            entries.forEach((function(entry) {
                var entryType = "Ord" in entry ? S.longDirEntry : S.dirEntry;
                entryType.bytesFromValue(entry, entriesData, dataOffset);
            }));
            _.log(_.log.DBG, "Writing", entriesData.length, "byte directory entry", mainEntry, "into", dirChain.toJSON(), "at", entryInfo.target);
            dirChain.writeToPosition(entryInfo.target, entriesData, (function(e) {
                if (e) cb(e); else cb(null, mainEntry, vol.chainForCluster(fileCluster, dirChain));
            }));
        }));
    };
    dir.findInDirectory = function(vol, dirChain, name, opts, cb) {
        var matchName = name.toUpperCase(), tailName = opts.prepareForCreate ? _.shortname(name) : null, maxTail = 0;
        function processNext(next) {
            next = next((function(e, d, entryPos) {
                if (e) cb(e); else if (!d) cb(S.err.NOENT(), {
                    tail: maxTail,
                    target: entryPos,
                    lastEntry: true
                }); else if (d._free) processNext(next); else if (d._name.toUpperCase() === matchName) return cb(null, d._full()); else if (!opts.prepareForCreate) processNext(next); else {
                    var dNum = 1, dName = d.Name.filename, dTail = dName.match(/(.*)~(\d+)/);
                    if (dTail) {
                        dNum = +dTail[2];
                        dName = dTail[1];
                    }
                    if (tailName.extension === d.Name.extension && tailName.filename.indexOf(dName) === 0) {
                        maxTail = Math.max(dNum + 1, maxTail);
                    }
                    processNext(next);
                }
            }));
        }
        processNext(dir.iterator(dirChain, {
            includeFree: 0 && false
        }));
    };
    dir.updateEntry = function(vol, entry, newStats, cb) {
        if (!entry._pos || !entry._pos.chain) throw Error("Entry source unknown!");
        var entryPos = entry._pos, newEntry = _updateEntry(vol, entry, newStats), data = S.dirEntry.bytesFromValue(newEntry);
        _.log(_.log.DBG, "UPDATING ENTRY", newStats, newEntry, entryPos, data);
        entryPos.chain.writeToPosition(entryPos, data, cb);
    };
}, function(module, exports, __webpack_require__) {
    var S = __webpack_require__(25), c = __webpack_require__(77), $ = __webpack_require__(162), _ = __webpack_require__(21);
    exports.init = function(volume, opts, bootSector) {
        if (bootSector[510] !== 85 || bootSector[511] !== 170) throw Error("Invalid volume signature!");
        var isFAT16 = bootSector.readUInt16LE(S.boot16.fields["FATSz16"].offset), bootStruct = isFAT16 ? S.boot16 : S.boot32, BS = bootStruct.valueFromBytes(bootSector);
        _.log(_.log.DBG, "Boot sector info:", BS);
        bootSector = null;
        if (!BS.BytsPerSec) throw Error("This looks like an ExFAT volume! (unsupported)"); else if (BS.BytsPerSec !== volume.sectorSize) throw Error("Sector size mismatch with FAT table.");
        var FATSz = isFAT16 ? BS.FATSz16 : BS.FATSz32, rootDirSectors = Math.ceil(BS.RootEntCnt * 32 / BS.BytsPerSec), firstDataSector = BS.ResvdSecCnt + BS.NumFATs * FATSz + rootDirSectors, totSec = BS.TotSec16 ? BS.TotSec16 : BS.TotSec32, dataSec = totSec - firstDataSector, countofClusters = Math.floor(dataSec / BS.SecPerClus);
        if (totSec > volume.numSectors) throw Error("Volume size mismatch!");
        var fatType;
        if (countofClusters < 4085) {
            fatType = "fat12";
        } else if (countofClusters < 65525) {
            fatType = "fat16";
        } else {
            fatType = "fat32";
        }
        _.log(_.log.DBG, "rootDirSectors", rootDirSectors, "firstDataSector", firstDataSector, "countofClusters", countofClusters, "=>", fatType);
        var vol = {};
        vol.opts = opts;
        vol._sectorSize = BS.BytsPerSec;
        vol._sectorsPerCluster = BS.SecPerClus;
        vol._firstSectorOfCluster = function(n) {
            return firstDataSector + (n - 2) * vol._sectorsPerCluster;
        };
        vol._makeCache = function() {
            return $.wrapDriver(volume);
        };
        vol._readSectors = function(cache, secNum, dest, cb) {
            if (typeof dest === "function") {
                cb = dest;
                dest = _.allocBuffer(vol._sectorSize);
            }
            _.log(_.log.DBG, "vol._readSectors", secNum, dest.length);
            if (secNum < volume.numSectors) cache.readSectors(secNum, dest, (function(e) {
                cb(e, dest);
            })); else throw Error("Invalid sector number!");
        };
        vol._writeSectors = function(cache, secNum, data, cb) {
            _.log(_.log.DBG, "vol._writeSectors", secNum, data.length);
            if (data.length % volume.sectorSize) throw Error("Buffer length not a multiple of sector size"); else if (opts.ro) throw Error("Read-only filesystem"); else if (secNum < volume.numSectors) cache.writeSectors(secNum, data, cb); else throw Error("Invalid sector number!");
        };
        function fatInfoForCluster(n) {
            var entryStruct = S.fatField[fatType], FATOffset = fatType === "fat12" ? Math.floor(n / 2) * entryStruct.size : n * entryStruct.size, SecNum = BS.ResvdSecCnt + Math.floor(FATOffset / BS.BytsPerSec);
            EntOffset = FATOffset % BS.BytsPerSec;
            return {
                sector: SecNum - BS.ResvdSecCnt,
                offset: EntOffset,
                struct: entryStruct
            };
        }
        var fatChain = c.sectorChain(vol, BS.ResvdSecCnt, FATSz);
        fatChain.cacheAdvice = "RANDOM";
        vol.fetchFromFAT = function(clusterNum, cb) {
            var info = fatInfoForCluster(clusterNum);
            fatChain.readFromPosition(info, info.struct.size, (function(e, n, d) {
                if (e) return cb(e);
                var status = info.struct.valueFromBytes(d), prefix;
                if (fatType === "fat12") {
                    if (clusterNum % 2) {
                        status = (status.field1ab << 4) + status.field1c;
                    } else {
                        status = (status.field0a << 8) + status.field0bc;
                    }
                } else if (fatType === "fat32") {
                    status &= 268435455;
                }
                var prefix = S.fatPrefix[fatType];
                if (status === S.fatStat.free) cb(null, "free"); else if (status === S.fatStat._undef) cb(null, "-invalid-"); else if (status > prefix + S.fatStat.eofMin) cb(null, "eof"); else if (status === prefix + S.fatStat.bad) cb(null, "bad"); else if (status > prefix + S.fatStat.rsvMin) cb(null, "reserved"); else cb(null, status);
            }));
        };
        vol.storeToFAT = function(clusterNum, status, cb) {
            if (typeof status === "string") {
                status = S.fatStat[status];
                status += S.fatPrefix[fatType];
            }
            var info = fatInfoForCluster(clusterNum);
            if (fatType === "fat12") fatChain.readFromPosition(info, info.struct.size, (function(e, n, d) {
                var value = info.struct.valueFromBytes(d);
                if (clusterNum % 2) {
                    value.field1ab = status >>> 4;
                    value.field1c = status & 15;
                } else {
                    value.field0a = status >>> 8;
                    value.field0bc = status & 255;
                }
                var entry = info.struct.bytesFromValue(value);
                fatChain.writeToPosition(info, entry, cb);
            })); else {
                var entry = info.struct.bytesFromValue(status);
                fatChain.writeToPosition(info, entry, cb);
            }
        };
        vol.allocateInFAT = function(hint, cb) {
            if (typeof hint === "function") {
                cb = hint;
                hint = 2;
            }
            function searchForFreeCluster(num, cb) {
                if (num < countofClusters) vol.fetchFromFAT(num, (function(e, status) {
                    if (e) cb(e); else if (status === "free") cb(null, num); else searchForFreeCluster(num + 1, cb);
                })); else cb(S.err.NOSPC());
            }
            searchForFreeCluster(hint, (function(e, clusterNum) {
                if (e) cb(e); else vol.storeToFAT(clusterNum, "eof", cb.bind(null, null, clusterNum));
            }));
        };
        vol.rootDirectoryChain = isFAT16 ? c.sectorChain(vol, firstDataSector - rootDirSectors, rootDirSectors) : c.clusterChain(vol, BS.RootClus);
        vol.rootDirectoryChain.cacheAdvice = "WILLNEED";
        vol.chainForCluster = c.clusterChain.bind(c, vol);
        vol.chainFromJSON = function(d) {
            return "numSectors" in d ? c.sectorChain(vol, d.firstSector, d.numSectors) : c.clusterChain(vol, d.firstCluster);
        };
        return vol;
    };
}, function(module, exports, __webpack_require__) {
    var _ = __webpack_require__(21);
    exports.wrapDriver = function(volume, opts) {
        opts = _.extend({
            maxSectors: 2048
        }, opts);
        var cache = {}, advice = "NORMAL", secSize = volume.sectorSize;
        function _freezeBuffer(b) {
            var f = _.allocBuffer(b.length);
            b.copy(f);
            return f;
        }
        function addToCache(i, data) {
            if (advice === "SEQUENTIAL" || advice === "NOREUSE") return;
            data = _freezeBuffer(data);
            cache[i] = data;
            while (data.length > secSize) {
                data = data.slice(secSize);
                cache[++i] = data;
            }
            Object.keys(cache).sort().slice(opts.maxSectors).forEach((function(x) {
                delete cache[x];
            }));
            _.log(_.log.DBG, "Cache now contains:", Object.keys(cache).join(","));
        }
        return {
            sectorSize: volume.sectorSize,
            numSectors: volume.numSectors,
            advice: function(val) {
                if (!arguments.length) return advice; else advice = val;
                if (advice === "SEQUENTIAL" || advice === "NOREUSE") cache = {};
                return this;
            },
            readSectors: function(i, dest, cb) {
                if (i in cache && dest.length === secSize) {
                    cache[i].copy(dest);
                    setImmediate(cb);
                } else volume.readSectors(i, dest, (function(e) {
                    if (e) cb(e); else addToCache(i, dest), cb();
                }));
            },
            writeSectors: !volume.writeSectors ? null : function(i, data, cb) {
                volume.writeSectors(i, data, (function(e) {
                    if (e) cb(e); else addToCache(i, data), cb();
                }));
            }
        };
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    function _typeof(obj) {
        if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
            _typeof = function _typeof(obj) {
                return typeof obj;
            };
        } else {
            _typeof = function _typeof(obj) {
                return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
            };
        }
        return _typeof(obj);
    }
    exports.log = log;
    exports.formatArgs = formatArgs;
    exports.save = save;
    exports.load = load;
    exports.useColors = useColors;
    exports.storage = localstorage();
    exports.colors = [ "#0000CC", "#0000FF", "#0033CC", "#0033FF", "#0066CC", "#0066FF", "#0099CC", "#0099FF", "#00CC00", "#00CC33", "#00CC66", "#00CC99", "#00CCCC", "#00CCFF", "#3300CC", "#3300FF", "#3333CC", "#3333FF", "#3366CC", "#3366FF", "#3399CC", "#3399FF", "#33CC00", "#33CC33", "#33CC66", "#33CC99", "#33CCCC", "#33CCFF", "#6600CC", "#6600FF", "#6633CC", "#6633FF", "#66CC00", "#66CC33", "#9900CC", "#9900FF", "#9933CC", "#9933FF", "#99CC00", "#99CC33", "#CC0000", "#CC0033", "#CC0066", "#CC0099", "#CC00CC", "#CC00FF", "#CC3300", "#CC3333", "#CC3366", "#CC3399", "#CC33CC", "#CC33FF", "#CC6600", "#CC6633", "#CC9900", "#CC9933", "#CCCC00", "#CCCC33", "#FF0000", "#FF0033", "#FF0066", "#FF0099", "#FF00CC", "#FF00FF", "#FF3300", "#FF3333", "#FF3366", "#FF3399", "#FF33CC", "#FF33FF", "#FF6600", "#FF6633", "#FF9900", "#FF9933", "#FFCC00", "#FFCC33" ];
    function useColors() {
        if (typeof window !== "undefined" && window.process && (window.process.type === "renderer" || window.process.__nwjs)) {
            return true;
        }
        if (typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)) {
            return false;
        }
        return typeof document !== "undefined" && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance || typeof window !== "undefined" && window.console && (window.console.firebug || window.console.exception && window.console.table) || typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31 || typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/);
    }
    function formatArgs(args) {
        args[0] = (this.useColors ? "%c" : "") + this.namespace + (this.useColors ? " %c" : " ") + args[0] + (this.useColors ? "%c " : " ") + "+" + module.exports.humanize(this.diff);
        if (!this.useColors) {
            return;
        }
        var c = "color: " + this.color;
        args.splice(1, 0, c, "color: inherit");
        var index = 0;
        var lastC = 0;
        args[0].replace(/%[a-zA-Z%]/g, (function(match) {
            if (match === "%%") {
                return;
            }
            index++;
            if (match === "%c") {
                lastC = index;
            }
        }));
        args.splice(lastC, 0, c);
    }
    function log() {
        var _console;
        return (typeof console === "undefined" ? "undefined" : _typeof(console)) === "object" && console.log && (_console = console).log.apply(_console, arguments);
    }
    function save(namespaces) {
        try {
            if (namespaces) {
                exports.storage.setItem("debug", namespaces);
            } else {
                exports.storage.removeItem("debug");
            }
        } catch (error) {}
    }
    function load() {
        var r;
        try {
            r = exports.storage.getItem("debug");
        } catch (error) {}
        if (!r && typeof process !== "undefined" && "env" in process) {
            r = process.env.DEBUG;
        }
        return r;
    }
    function localstorage() {
        try {
            return localStorage;
        } catch (error) {}
    }
    module.exports = __webpack_require__(78)(exports);
    var formatters = module.exports.formatters;
    formatters.j = function(v) {
        try {
            return JSON.stringify(v);
        } catch (error) {
            return "[UnexpectedJSONParseError]: " + error.message;
        }
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    var tty = __webpack_require__(30);
    var util = __webpack_require__(1);
    exports.init = init;
    exports.log = log;
    exports.formatArgs = formatArgs;
    exports.save = save;
    exports.load = load;
    exports.useColors = useColors;
    exports.colors = [ 6, 2, 3, 4, 5, 1 ];
    try {
        var supportsColor = __webpack_require__(31);
        if (supportsColor && (supportsColor.stderr || supportsColor).level >= 2) {
            exports.colors = [ 20, 21, 26, 27, 32, 33, 38, 39, 40, 41, 42, 43, 44, 45, 56, 57, 62, 63, 68, 69, 74, 75, 76, 77, 78, 79, 80, 81, 92, 93, 98, 99, 112, 113, 128, 129, 134, 135, 148, 149, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 178, 179, 184, 185, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 214, 215, 220, 221 ];
        }
    } catch (error) {}
    exports.inspectOpts = Object.keys(process.env).filter((function(key) {
        return /^debug_/i.test(key);
    })).reduce((function(obj, key) {
        var prop = key.substring(6).toLowerCase().replace(/_([a-z])/g, (function(_, k) {
            return k.toUpperCase();
        }));
        var val = process.env[key];
        if (/^(yes|on|true|enabled)$/i.test(val)) {
            val = true;
        } else if (/^(no|off|false|disabled)$/i.test(val)) {
            val = false;
        } else if (val === "null") {
            val = null;
        } else {
            val = Number(val);
        }
        obj[prop] = val;
        return obj;
    }), {});
    function useColors() {
        return "colors" in exports.inspectOpts ? Boolean(exports.inspectOpts.colors) : tty.isatty(process.stderr.fd);
    }
    function formatArgs(args) {
        var name = this.namespace, useColors = this.useColors;
        if (useColors) {
            var c = this.color;
            var colorCode = "[3" + (c < 8 ? c : "8;5;" + c);
            var prefix = "  ".concat(colorCode, ";1m").concat(name, " [0m");
            args[0] = prefix + args[0].split("\n").join("\n" + prefix);
            args.push(colorCode + "m+" + module.exports.humanize(this.diff) + "[0m");
        } else {
            args[0] = getDate() + name + " " + args[0];
        }
    }
    function getDate() {
        if (exports.inspectOpts.hideDate) {
            return "";
        }
        return (new Date).toISOString() + " ";
    }
    function log() {
        return process.stderr.write(util.format.apply(util, arguments) + "\n");
    }
    function save(namespaces) {
        if (namespaces) {
            process.env.DEBUG = namespaces;
        } else {
            delete process.env.DEBUG;
        }
    }
    function load() {
        return process.env.DEBUG;
    }
    function init(debug) {
        debug.inspectOpts = {};
        var keys = Object.keys(exports.inspectOpts);
        for (var i = 0; i < keys.length; i++) {
            debug.inspectOpts[keys[i]] = exports.inspectOpts[keys[i]];
        }
    }
    module.exports = __webpack_require__(78)(exports);
    var formatters = module.exports.formatters;
    formatters.o = function(v) {
        this.inspectOpts.colors = this.useColors;
        return util.inspect(v, this.inspectOpts).replace(/\s*\n\s*/g, " ");
    };
    formatters.O = function(v) {
        this.inspectOpts.colors = this.useColors;
        return util.inspect(v, this.inspectOpts);
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.ProgressBlockWriteStream = exports.BlockWriteStream = void 0;
    const direct_io_1 = __webpack_require__(29);
    const _debug = __webpack_require__(26);
    const stream_1 = __webpack_require__(0);
    const constants_1 = __webpack_require__(5);
    const errors_1 = __webpack_require__(8);
    const progress_1 = __webpack_require__(13);
    const utils_1 = __webpack_require__(6);
    const debug = _debug("etcher:writer:block-write-stream");
    class BlockWriteStream extends stream_1.Writable {
        constructor({destination, highWaterMark, delayFirstBuffer = false, maxRetries = 5}) {
            super({
                objectMode: true,
                highWaterMark
            });
            this.bytesWritten = 0;
            this.position = 0;
            this.destination = destination;
            this.delayFirstBuffer = delayFirstBuffer;
            this.maxRetries = maxRetries;
        }
        async writeBuffer(buffer, position) {
            let retries = 0;
            while (true) {
                try {
                    await this.destination.write(buffer, 0, buffer.length, position);
                    return;
                } catch (error) {
                    if (errors_1.isTransientError(error)) {
                        if (retries < this.maxRetries) {
                            retries += 1;
                            await utils_1.delay(constants_1.RETRY_BASE_TIMEOUT * retries);
                            continue;
                        }
                        error.code = "EUNPLUGGED";
                    }
                    throw error;
                }
            }
        }
        async __write(buffer) {
            const unlock = await buffer.rlock();
            debug("_write", buffer.length, this.position, this.bytesWritten);
            try {
                if (this.delayFirstBuffer && this.firstBuffer === undefined) {
                    this.firstBuffer = direct_io_1.getAlignedBuffer(buffer.length, buffer.alignment);
                    buffer.copy(this.firstBuffer);
                } else {
                    await this.writeBuffer(buffer, this.position);
                    this.bytesWritten += buffer.length;
                }
                this.position += buffer.length;
            } finally {
                unlock();
            }
        }
        _write(buffer, _encoding, callback) {
            utils_1.asCallback(this.__write(buffer), callback);
        }
        async __final() {
            debug("_final");
            if (this.firstBuffer) {
                try {
                    await this.writeBuffer(this.firstBuffer, 0);
                    this.bytesWritten += this.firstBuffer.length;
                } catch (error) {
                    this.destroy();
                    throw error;
                }
            }
        }
        _final(callback) {
            utils_1.asCallback(this.__final(), callback);
        }
    }
    exports.BlockWriteStream = BlockWriteStream;
    exports.ProgressBlockWriteStream = progress_1.makeClassEmitProgressEvents(BlockWriteStream, "bytesWritten", "bytesWritten");
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.clean = void 0;
    const child_process_1 = __webpack_require__(52);
    const _debug = __webpack_require__(26);
    const fs_1 = __webpack_require__(3);
    const os_1 = __webpack_require__(11);
    const tmp_1 = __webpack_require__(28);
    const utils_1 = __webpack_require__(6);
    const debug = _debug("etcher-sdk:diskpart");
    const DISKPART_DELAY = 2e3;
    const DISKPART_RETRIES = 5;
    const PATTERN = /PHYSICALDRIVE(\d+)/i;
    const execFileAsync = async (command, args = [], options = {}) => await new Promise((resolve, reject) => {
        child_process_1.execFile(command, args, options, (error, stdout, stderr) => {
            if (error) {
                reject(error);
            } else {
                resolve({
                    stdout,
                    stderr
                });
            }
        });
    });
    const runDiskpart = async commands => {
        if (os_1.platform() !== "win32") {
            return;
        }
        await tmp_1.withTmpFile(false, async file => {
            await fs_1.promises.writeFile(file.path, commands.join("\r\n"));
            const {stdout, stderr} = await execFileAsync("diskpart", [ "/s", file.path ]);
            debug("stdout:", stdout);
            debug("stderr:", stderr);
        });
    };
    exports.clean = async device => {
        if (os_1.platform() !== "win32") {
            return;
        }
        const match = device.match(PATTERN);
        if (match === null) {
            throw new Error(`Invalid device: "${device}"`);
        }
        debug("clean", device);
        const deviceId = match.pop();
        let errorCount = 0;
        while (errorCount <= DISKPART_RETRIES) {
            try {
                await runDiskpart([ `select disk ${deviceId}`, "clean", "rescan" ]);
                return;
            } catch (error) {
                errorCount += 1;
                if (errorCount <= DISKPART_RETRIES) {
                    await utils_1.delay(DISKPART_DELAY);
                } else {
                    throw new Error(`Couldn't clean the drive, ${error.message} (code ${error.code})`);
                }
            }
        }
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    const {exec} = __webpack_require__(52);
    const fs = __webpack_require__(3);
    const path = __webpack_require__(4);
    const util = __webpack_require__(1);
    const InvalidPathError = function(message) {
        Error.captureStackTrace(this, this.constructor);
        this.name = "InvalidPathError";
        this.message = message || "";
    };
    util.inherits(InvalidPathError, Error);
    const NoMatchError = function(message) {
        Error.captureStackTrace(this, this.constructor);
        this.name = "NoMatchError";
        this.message = message || "";
    };
    util.inherits(NoMatchError, Error);
    function mapOutput(stdout, filter, mapping, coefficient = 1) {
        const parsed = stdout.trim().split("\n").slice(1).map(line => line.trim().split(/\s+(?=[\d/])/));
        let filtered = parsed.filter(filter);
        if (filtered.length === 0) {
            throw new NoMatchError;
        }
        filtered = filtered[0];
        return {
            diskPath: filtered[mapping.diskPath],
            free: parseInt(filtered[mapping.free], 10) * coefficient,
            size: parseInt(filtered[mapping.size], 10) * coefficient
        };
    }
    function check(cmd, filter, mapping, coefficient = 1) {
        return new Promise((resolve, reject) => {
            exec(cmd, (error, stdout) => {
                if (error) {
                    reject(error);
                }
                try {
                    resolve(mapOutput(stdout, filter, mapping, coefficient));
                } catch (error2) {
                    reject(error2);
                }
            });
        });
    }
    function checkWin32(directoryPath) {
        if (directoryPath.charAt(1) !== ":") {
            return new Promise((resolve, reject) => {
                reject(new InvalidPathError(`The following path is invalid (should be X:\\...): ${directoryPath}`));
            });
        }
        return check("wmic logicaldisk get size,freespace,caption", driveData => {
            const driveLetter = driveData[0];
            return directoryPath.startsWith(driveLetter);
        }, {
            diskPath: 0,
            free: 1,
            size: 2
        });
    }
    function checkUnix(directoryPath) {
        if (!path.normalize(directoryPath).startsWith(path.sep)) {
            return new Promise((resolve, reject) => {
                reject(new InvalidPathError(`The following path is invalid (should start by ${path.sep}): ${directoryPath}`));
            });
        }
        return check(`df -Pk "${module.exports.getFirstExistingParentPath(directoryPath)}"`, () => true, {
            diskPath: 5,
            free: 3,
            size: 1
        }, 1024);
    }
    module.exports = process.platform === "win32" ? checkWin32 : checkUnix;
    module.exports.getFirstExistingParentPath = directoryPath => {
        let parentDirectoryPath = directoryPath;
        let parentDirectoryFound = fs.existsSync(parentDirectoryPath);
        while (!parentDirectoryFound) {
            parentDirectoryPath = path.normalize(parentDirectoryPath + "/..");
            parentDirectoryFound = fs.existsSync(parentDirectoryPath);
        }
        return parentDirectoryPath;
    };
    module.exports.InvalidPathError = InvalidPathError;
    module.exports.NoMatchError = NoMatchError;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.configure = void 0;
    const balena_image_fs_1 = __webpack_require__(36);
    const partitioninfo_1 = __webpack_require__(33);
    const util_1 = __webpack_require__(1);
    const configure_1 = __webpack_require__(169);
    const copy_1 = __webpack_require__(172);
    const MBR_LAST_PRIMARY_PARTITION = 4;
    const ACTIONS = {
        configure: configure_1.execute,
        copy: copy_1.execute
    };
    const executeOperation = async (operation, disk) => await ACTIONS[operation.command](operation, disk);
    const getPartitionIndex = partition => {
        if (typeof partition === "number") {
            return partition;
        }
        if (typeof partition.logical === "number") {
            return partition.logical + MBR_LAST_PRIMARY_PARTITION;
        }
        if (typeof partition.primary === "number") {
            return partition.primary;
        }
        throw new Error(`Invalid partition: ${partition}`);
    };
    const getDiskDeviceType = async disk => {
        const partitions = await partitioninfo_1.getPartitions(disk);
        for (const partition of partitions.partitions) {
            if (partition.type === 14) {
                const deviceType = await balena_image_fs_1.interact(disk, partition.index, async fs => {
                    try {
                        return await util_1.promisify(fs.readFile)("/device-type.json");
                    } catch (error) {
                        return undefined;
                    }
                });
                if (deviceType) {
                    return JSON.parse(deviceType.toString());
                }
            }
        }
    };
    exports.configure = async (disk, options = {}) => {
        var _a, _b, _c, _d, _e;
        console.log("options", options);
        const deviceType = await getDiskDeviceType(disk);
        console.log("device type read from disk image:\n", JSON.stringify(deviceType, null, 4));
        let operations = (_b = (_a = deviceType === null || deviceType === void 0 ? void 0 : deviceType.configuration) === null || _a === void 0 ? void 0 : _a.operations) !== null && _b !== void 0 ? _b : [];
        operations = JSON.parse(JSON.stringify(operations));
        const config = (_c = deviceType === null || deviceType === void 0 ? void 0 : deviceType.configuration) === null || _c === void 0 ? void 0 : _c.config;
        if (config) {
            operations.push({
                command: "configure",
                partition: config.partition,
                data: options.config
            });
        }
        operations = operations.filter(operation => {
            if (operation.when !== undefined) {
                for (const key in operation.when) {
                    if (options[key] !== operations.when[key]) {
                        return false;
                    }
                }
            }
            return true;
        });
        for (const operation of operations) {
            if (operation.partition !== undefined) {
                operation.partition = getPartitionIndex(operation.partition);
            }
            if (((_d = operation.to) === null || _d === void 0 ? void 0 : _d.partition) !== undefined) {
                operation.to.partition = getPartitionIndex(operation.to.partition);
            }
            if (((_e = operation.from) === null || _e === void 0 ? void 0 : _e.partition) !== undefined) {
                operation.from.partition = getPartitionIndex(operation.from.partition);
            }
            await executeOperation(operation, disk);
        }
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.execute = void 0;
    const balena_image_fs_1 = __webpack_require__(36);
    const outdent_1 = __webpack_require__(170);
    const util_1 = __webpack_require__(1);
    const nmWifiConfig = (index, options) => {
        let config = outdent_1.outdent`
		[connection]
		id=balena-wifi-${pad(index)}
		type=wifi

		[wifi]
		hidden=true
		mode=infrastructure
		ssid=${options.wifiSsid}

		[ipv4]
	`;
        if (options.routeMetric) {
            config += outdent_1.outdent`

			route-metric=${options.routeMetric}
		`;
        }
        if (options.ip && options.netmask && options.gateway) {
            config += outdent_1.outdent`

			method=manual
			address1=${options.ip}/${options.netmask},${options.gateway}
		`;
        } else {
            config += outdent_1.outdent`

			method=auto
		`;
        }
        config += outdent_1.outdent`


		[ipv6]
		addr-gen-mode=stable-privacy
		method=auto
	`;
        if (options.wifiKey) {
            config += outdent_1.outdent`


			[wifi-security]
			auth-alg=open
			key-mgmt=wpa-psk
			psk=${options.wifiKey}
		`;
        }
        console.log("network config file:\n", config);
        return config;
    };
    const createNetworkConfigFiles = networks => ({
        ethernet: networks.map(n => n.configuration).filter(n => !!n),
        wifi: networks.filter(n => !!n.wifiSsid).map((network, index) => nmWifiConfig(index + 1, network))
    });
    const pad = num => `${num}`.padStart(2, "0");
    exports.execute = async (operation, disk) => {
        if (!operation.data) {
            throw new Error("config.json data missing from operation options");
        }
        if (!operation.partition) {
            throw new Error("partition information missing from operation options");
        }
        const {wifiSsid, wifiKey, ip, netmask, gateway, routeMetric, network, ...config} = operation.data;
        const networks = [ {
            wifiSsid,
            wifiKey,
            ip,
            netmask,
            gateway,
            routeMetric
        }, ...network ];
        const networkConfigFiles = createNetworkConfigFiles(networks);
        await balena_image_fs_1.interact(disk, operation.partition, async fs => {
            const writeFileAsync = util_1.promisify(fs.writeFile);
            await writeFileAsync("/config.json", JSON.stringify(config));
            let index;
            for (index = 0; index < networkConfigFiles.ethernet.length; index++) {
                await writeFileAsync(`/system-connections/connection-${pad(index + 1)}`, networkConfigFiles.ethernet[index]);
            }
            for (index = 0; index < networkConfigFiles.wifi.length; index++) {
                await writeFileAsync(`/system-connections/connection-${pad(index + 1)}`, networkConfigFiles.wifi[index]);
            }
        });
    };
}, function(module, __webpack_exports__, __webpack_require__) {
    "use strict";
    __webpack_require__.r(__webpack_exports__);
    (function(module) {
        __webpack_require__.d(__webpack_exports__, "outdent", (function() {
            return defaultOutdent;
        }));
        function noop() {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
        }
        function createWeakMap() {
            if (typeof WeakMap !== "undefined") {
                return new WeakMap;
            } else {
                return fakeSetOrMap();
            }
        }
        function fakeSetOrMap() {
            return {
                add: noop,
                delete: noop,
                get: noop,
                set: noop,
                has: function(k) {
                    return false;
                }
            };
        }
        var hop = Object.prototype.hasOwnProperty;
        var has = function(obj, prop) {
            return hop.call(obj, prop);
        };
        function extend(target, source) {
            for (var prop in source) {
                if (has(source, prop)) {
                    target[prop] = source[prop];
                }
            }
            return target;
        }
        var reLeadingNewline = /^[ \t]*(?:\r\n|\r|\n)/;
        var reTrailingNewline = /(?:\r\n|\r|\n)[ \t]*$/;
        var reStartsWithNewlineOrIsEmpty = /^(?:[\r\n]|$)/;
        var reDetectIndentation = /(?:\r\n|\r|\n)([ \t]*)(?:[^ \t\r\n]|$)/;
        var reOnlyWhitespaceWithAtLeastOneNewline = /^[ \t]*[\r\n][ \t\r\n]*$/;
        function _outdentArray(strings, firstInterpolatedValueSetsIndentationLevel, options) {
            var indentationLevel = 0;
            var match = strings[0].match(reDetectIndentation);
            if (match) {
                indentationLevel = match[1].length;
            }
            var reSource = "(\\r\\n|\\r|\\n).{0," + indentationLevel + "}";
            var reMatchIndent = new RegExp(reSource, "g");
            if (firstInterpolatedValueSetsIndentationLevel) {
                strings = strings.slice(1);
            }
            var newline = options.newline, trimLeadingNewline = options.trimLeadingNewline, trimTrailingNewline = options.trimTrailingNewline;
            var normalizeNewlines = typeof newline === "string";
            var l = strings.length;
            var outdentedStrings = strings.map((function(v, i) {
                v = v.replace(reMatchIndent, "$1");
                if (i === 0 && trimLeadingNewline) {
                    v = v.replace(reLeadingNewline, "");
                }
                if (i === l - 1 && trimTrailingNewline) {
                    v = v.replace(reTrailingNewline, "");
                }
                if (normalizeNewlines) {
                    v = v.replace(/\r\n|\n|\r/g, (function(_) {
                        return newline;
                    }));
                }
                return v;
            }));
            return outdentedStrings;
        }
        function concatStringsAndValues(strings, values) {
            var ret = "";
            for (var i = 0, l = strings.length; i < l; i++) {
                ret += strings[i];
                if (i < l - 1) {
                    ret += values[i];
                }
            }
            return ret;
        }
        function isTemplateStringsArray(v) {
            return has(v, "raw") && has(v, "length");
        }
        function createInstance(options) {
            var arrayAutoIndentCache = createWeakMap();
            var arrayFirstInterpSetsIndentCache = createWeakMap();
            function outdent(stringsOrOptions) {
                var values = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    values[_i - 1] = arguments[_i];
                }
                if (isTemplateStringsArray(stringsOrOptions)) {
                    var strings = stringsOrOptions;
                    var firstInterpolatedValueSetsIndentationLevel = (values[0] === outdent || values[0] === defaultOutdent) && reOnlyWhitespaceWithAtLeastOneNewline.test(strings[0]) && reStartsWithNewlineOrIsEmpty.test(strings[1]);
                    var cache = firstInterpolatedValueSetsIndentationLevel ? arrayFirstInterpSetsIndentCache : arrayAutoIndentCache;
                    var renderedArray = cache.get(strings);
                    if (!renderedArray) {
                        renderedArray = _outdentArray(strings, firstInterpolatedValueSetsIndentationLevel, options);
                        cache.set(strings, renderedArray);
                    }
                    if (values.length === 0) {
                        return renderedArray[0];
                    }
                    var rendered = concatStringsAndValues(renderedArray, firstInterpolatedValueSetsIndentationLevel ? values.slice(1) : values);
                    return rendered;
                } else {
                    return createInstance(extend(extend({}, options), stringsOrOptions || {}));
                }
            }
            var fullOutdent = extend(outdent, {
                string: function(str) {
                    return _outdentArray([ str ], false, options)[0];
                }
            });
            return fullOutdent;
        }
        var defaultOutdent = createInstance({
            trimLeadingNewline: true,
            trimTrailingNewline: true
        });
        __webpack_exports__["default"] = defaultOutdent;
        if (true) {
            try {
                module.exports = defaultOutdent;
                Object.defineProperty(defaultOutdent, "__esModule", {
                    value: true
                });
                defaultOutdent.default = defaultOutdent;
                defaultOutdent.outdent = defaultOutdent;
            } catch (e) {}
        }
    }).call(this, __webpack_require__(171)(module));
}, function(module, exports) {
    module.exports = function(originalModule) {
        if (!originalModule.webpackPolyfill) {
            var module = Object.create(originalModule);
            if (!module.children) module.children = [];
            Object.defineProperty(module, "loaded", {
                enumerable: true,
                get: function() {
                    return module.l;
                }
            });
            Object.defineProperty(module, "id", {
                enumerable: true,
                get: function() {
                    return module.i;
                }
            });
            Object.defineProperty(module, "exports", {
                enumerable: true
            });
            module.webpackPolyfill = 1;
        }
        return module;
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.execute = void 0;
    const balena_image_fs_1 = __webpack_require__(36);
    const copy = async (sourceFs, sourcePath, destinationFs, destinationPath) => {
        const readStream = sourceFs.createReadStream(`/${sourcePath}`);
        const writeStream = destinationFs.createWriteStream(`/${destinationPath}`);
        await new Promise((resolve, reject) => {
            readStream.on("error", reject).pipe(writeStream).on("error", reject).on("close", resolve);
        });
    };
    exports.execute = async (operation, disk) => {
        var _a, _b;
        const source = (_a = operation === null || operation === void 0 ? void 0 : operation.from) === null || _a === void 0 ? void 0 : _a.partition;
        const destination = (_b = operation === null || operation === void 0 ? void 0 : operation.to) === null || _b === void 0 ? void 0 : _b.partition;
        if (source === undefined || destination === undefined) {
            throw new Error("copy operation needs from and to properties");
        }
        await balena_image_fs_1.interact(disk, source, async sourceFs => {
            if (source === destination) {
                await copy(sourceFs, operation.from.path, sourceFs, operation.to.path);
            } else {
                await balena_image_fs_1.interact(disk, destination, async destinationFs => {
                    await copy(sourceFs, operation.from.path, destinationFs, operation.to.path);
                });
            }
        });
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.Scanner = exports.adapters = void 0;
    const adapters = __webpack_require__(174);
    exports.adapters = adapters;
    const scanner_1 = __webpack_require__(184);
    Object.defineProperty(exports, "Scanner", {
        enumerable: true,
        get: function() {
            return scanner_1.Scanner;
        }
    });
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    const tslib_1 = __webpack_require__(22);
    tslib_1.__exportStar(__webpack_require__(39), exports);
    tslib_1.__exportStar(__webpack_require__(175), exports);
    tslib_1.__exportStar(__webpack_require__(181), exports);
    tslib_1.__exportStar(__webpack_require__(182), exports);
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.BlockDeviceAdapter = void 0;
    const _debug = __webpack_require__(26);
    const drivelist_1 = __webpack_require__(176);
    const block_device_1 = __webpack_require__(38);
    const utils_1 = __webpack_require__(6);
    const adapter_1 = __webpack_require__(39);
    const debug = _debug("etcher-sdk:block-device-adapter");
    const SCAN_INTERVAL = 1e3;
    const USBBOOT_RPI_COMPUTE_MODULE_NAMES = [ "0001", "RPi-MSD- 0001", "File-Stor Gadget", "Linux File-Stor_Gadget", "Linux File-Stor Gadget", "Linux File-Stor Gadget USB Device", "Linux File-Stor Gadget Media" ];
    function looksLikeComputeModule(description) {
        for (const name of USBBOOT_RPI_COMPUTE_MODULE_NAMES) {
            if (description.startsWith(name)) {
                return true;
            }
        }
        return false;
    }
    function driveKey(drive) {
        return [ drive.device, drive.size, drive.description, drive.mountpoints.map(m => m.path).sort().join(",") ].join("|");
    }
    class BlockDeviceAdapter extends adapter_1.Adapter {
        constructor({includeSystemDrives = () => false, unmountOnSuccess = false, write = false, direct = true}) {
            super();
            this.drives = new Map;
            this.running = false;
            this.ready = false;
            this.includeSystemDrives = includeSystemDrives;
            this.unmountOnSuccess = unmountOnSuccess;
            this.oWrite = write;
            this.oDirect = direct;
        }
        start() {
            this.running = true;
            this.scanLoop();
        }
        stop() {
            this.running = false;
            this.ready = false;
            this.drives.clear();
        }
        async scanLoop() {
            while (this.running) {
                await this.scan();
                if (!this.ready) {
                    this.ready = true;
                    this.emit("ready");
                }
                await utils_1.delay(SCAN_INTERVAL);
            }
        }
        async scan() {
            const drives = await this.listDrives();
            if (this.running) {
                const oldDevices = new Set(this.drives.keys());
                const newDevices = new Set(drives.keys());
                for (const removed of utils_1.difference(oldDevices, newDevices)) {
                    this.emit("detach", this.drives.get(removed));
                    this.drives.delete(removed);
                }
                for (const added of utils_1.difference(newDevices, oldDevices)) {
                    const drive = drives.get(added);
                    const blockDevice = new block_device_1.BlockDevice({
                        drive,
                        unmountOnSuccess: this.unmountOnSuccess,
                        write: this.oWrite,
                        direct: this.oDirect
                    });
                    this.emit("attach", blockDevice);
                    this.drives.set(added, blockDevice);
                }
            }
        }
        async listDrives() {
            let drives;
            const result = new Map;
            try {
                drives = await drivelist_1.list();
            } catch (error) {
                debug(error);
                this.emit("error", error);
                return result;
            }
            for (const drive of drives) {
                if (!(drive.busType !== "RAID" && !drive.error && (this.includeSystemDrives() || !drive.isSystem) && typeof drive.size === "number" && !drive.isVirtual)) {
                    continue;
                }
                const displayName = /PhysicalDrive/i.test(drive.device) && drive.mountpoints.length ? drive.mountpoints.map(m => m.path).join(", ") : drive.device;
                const resultDrive = {
                    ...drive,
                    displayName
                };
                if (looksLikeComputeModule(resultDrive.description)) {
                    resultDrive.description = "Compute Module";
                    resultDrive.icon = "raspberrypi";
                    resultDrive.isSystem = false;
                }
                result.set(driveKey(drive), resultDrive);
            }
            return result;
        }
    }
    exports.BlockDeviceAdapter = BlockDeviceAdapter;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.list = void 0;
    const bindings = __webpack_require__(177);
    const os_1 = __webpack_require__(11);
    const lsblk_1 = __webpack_require__(178);
    const drivelistBindings = bindings;
    function bindingsList() {
        return new Promise((resolve, reject) => {
            drivelistBindings.list((error, drives) => {
                if (error != null) {
                    reject(error);
                } else {
                    resolve(drives);
                }
            });
        });
    }
    function handleApfs(disks) {
        const apfs = [];
        const other = [];
        for (const disk of disks) {
            if (disk.description === "AppleAPFSMedia") {
                apfs.push(disk);
            } else {
                other.push(disk);
            }
        }
        for (const disk of apfs) {
            const source = other.find(d => d.devicePath === disk.devicePath && !d.isVirtual);
            if (source !== undefined) {
                source.mountpoints.push(...disk.mountpoints);
                disk.isVirtual = true;
            }
        }
    }
    async function list() {
        const plat = os_1.platform();
        if (plat === "win32") {
            return await bindingsList();
        } else if (plat === "darwin") {
            const disks = await bindingsList();
            handleApfs(disks);
            return disks;
        } else if (plat === "linux") {
            return await lsblk_1.lsblk();
        }
        throw new Error(`Your OS is not supported by this module: ${os_1.platform()}`);
    }
    exports.list = list;
}, function(module, exports) {
    module.exports = require("./modules/drivelist/build/Release/drivelist.node");
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.lsblk = void 0;
    const child_process_1 = __webpack_require__(52);
    const fs_1 = __webpack_require__(3);
    const path_1 = __webpack_require__(4);
    const util_1 = __webpack_require__(1);
    const json_1 = __webpack_require__(179);
    const pairs_1 = __webpack_require__(180);
    const execFileAsync = util_1.promisify(child_process_1.execFile);
    const DISK_PATH_DIR = "/dev/disk/by-path/";
    let SUPPORTS_JSON = true;
    async function getDevicePaths() {
        const mapping = new Map;
        for (const filename of await fs_1.promises.readdir(DISK_PATH_DIR)) {
            const linkPath = path_1.join(DISK_PATH_DIR, filename);
            let link;
            try {
                link = await fs_1.promises.readlink(linkPath);
            } catch (error) {
                continue;
            }
            const devicePath = path_1.resolve(DISK_PATH_DIR, link);
            mapping.set(devicePath, linkPath);
        }
        return mapping;
    }
    async function addDevicePaths(devices) {
        const devicePaths = await getDevicePaths();
        for (const device of devices) {
            device.devicePath = devicePaths.get(device.device) || null;
        }
    }
    async function getOutput(command, ...args) {
        const {stdout} = await execFileAsync(command, args);
        return stdout;
    }
    async function lsblkJSON() {
        return json_1.parse(await getOutput("lsblk", "--bytes", "--all", "--json", "--paths", "--output-all"));
    }
    async function lsblkPairs() {
        return pairs_1.parse(await getOutput("lsblk", "--bytes", "--all", "--pairs"));
    }
    async function $lsblk() {
        if (SUPPORTS_JSON) {
            try {
                return await lsblkJSON();
            } catch (error) {
                SUPPORTS_JSON = false;
            }
        }
        return await lsblkPairs();
    }
    async function lsblk() {
        const drives = await $lsblk();
        try {
            await addDevicePaths(drives);
        } catch (error) {}
        return drives;
    }
    exports.lsblk = lsblk;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.parse = exports.transform = void 0;
    const path_1 = __webpack_require__(4);
    function getMountpoints(children) {
        return children.filter(child => child.mountpoint).map(child => ({
            path: child.mountpoint,
            label: child.label || child.partlabel
        }));
    }
    function getDescription(device) {
        const description = [ device.label || "", device.vendor || "", device.model || "" ];
        if (device.children) {
            let subLabels = device.children.filter(c => c.label && c.label !== device.label || c.mountpoint).map(c => c.label || c.mountpoint);
            subLabels = Array.from(new Set(subLabels));
            if (subLabels.length) {
                description.push(`(${subLabels.join(", ")})`);
            }
        }
        return description.join(" ").replace(/\s+/g, " ").trim();
    }
    function resolveDeviceName(name) {
        if (!name) {
            return null;
        }
        if (!path_1.posix.isAbsolute(name)) {
            return path_1.posix.resolve("/dev", name);
        }
        return name;
    }
    function transform(data) {
        return data.blockdevices.map(device => Object.assign({}, device, {
            name: resolveDeviceName(device.name),
            kname: resolveDeviceName(device.kname)
        })).filter(device => !device.name.startsWith("/dev/loop") && !device.name.startsWith("/dev/sr") && !device.name.startsWith("/dev/ram")).map(device => {
            const isVirtual = device.subsystems ? /^(block)$/i.test(device.subsystems) : null;
            const isSCSI = device.tran ? /^(sata|scsi|ata|ide|pci)$/i.test(device.tran) : null;
            const isUSB = device.tran ? /^(usb)$/i.test(device.tran) : null;
            const isReadOnly = Number(device.ro) === 1;
            const isRemovable = Number(device.rm) === 1 || Number(device.hotplug) === 1 || Boolean(isVirtual);
            return {
                enumerator: "lsblk:json",
                busType: (device.tran || "UNKNOWN").toUpperCase(),
                busVersion: null,
                device: device.name,
                devicePath: null,
                raw: device.kname || device.name,
                description: getDescription(device),
                error: null,
                size: Number(device.size) || null,
                blockSize: Number(device["phy-sec"]) || 512,
                logicalBlockSize: Number(device["log-sec"]) || 512,
                mountpoints: device.children ? getMountpoints(device.children) : getMountpoints([ device ]),
                isReadOnly,
                isSystem: !isRemovable && !isVirtual,
                isVirtual,
                isRemovable,
                isCard: null,
                isSCSI,
                isUSB,
                isUAS: null
            };
        });
    }
    exports.transform = transform;
    function parse(stdout) {
        return transform(JSON.parse(stdout));
    }
    exports.parse = parse;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.parse = void 0;
    function parseLsblkLine(line) {
        const data = {};
        let offset = 0;
        let key = "";
        let value = "";
        const keyChar = /[^"=]/;
        const whitespace = /\s+/;
        const escape = "\\";
        let state = "key";
        while (offset < line.length) {
            if (state === "key") {
                while (keyChar.test(line[offset])) {
                    key += line[offset];
                    offset += 1;
                }
                if (line[offset] === "=") {
                    state = "value";
                    offset += 1;
                }
            } else if (state === "value") {
                if (line[offset] !== '"') {
                    throw new Error(`Expected '"', saw "${line[offset]}"`);
                }
                offset += 1;
                while (line[offset - 1] === escape || line[offset - 1] !== escape && line[offset] !== '"') {
                    value += line[offset];
                    offset += 1;
                }
                if (line[offset] !== '"') {
                    throw new Error(`Expected '"', saw "${line[offset]}"`);
                }
                offset += 1;
                data[key.toLowerCase()] = value.trim();
                key = "";
                value = "";
                state = "space";
            } else if (state === "space") {
                while (whitespace.test(line[offset])) {
                    offset += 1;
                }
                state = "key";
            } else {
                throw new Error(`Undefined state "${state}"`);
            }
        }
        return data;
    }
    function parseLsblk(output) {
        return output.trim().split(/\r?\n/g).map(parseLsblkLine);
    }
    function consolidate(devices) {
        const primaries = devices.filter(device => device.type === "disk" && !device.name.startsWith("ram") && !device.name.startsWith("sr"));
        return primaries.map(device => Object.assign({}, device, {
            mountpoints: devices.filter(child => [ "disk", "part" ].includes(child.type) && child.mountpoint && child.name.startsWith(device.name)).map(child => ({
                path: child.mountpoint,
                label: child.label
            }))
        }));
    }
    function getDescription(device) {
        const description = [ device.label || "", device.vendor || "", device.model || "" ];
        if (device.mountpoints.length) {
            let subLabels = device.mountpoints.filter(c => c.label && c.label !== device.label || c.path).map(c => c.label || c.path);
            subLabels = Array.from(new Set(subLabels));
            if (subLabels.length) {
                description.push(`(${subLabels.join(", ")})`);
            }
        }
        return description.join(" ").replace(/\s+/g, " ").trim();
    }
    function parse(stdout) {
        const devices = consolidate(parseLsblk(stdout));
        return devices.map(device => {
            const isVirtual = device.subsystems ? /^block$/i.test(device.subsystems) : null;
            const isSCSI = device.tran ? /^(?:sata|scsi|ata|ide|pci)$/i.test(device.tran) : null;
            const isUSB = device.tran ? /^usb$/i.test(device.tran) : null;
            const isReadOnly = Number(device.ro) === 1;
            const isRemovable = Number(device.rm) === 1 || Number(device.hotplug) === 1 || Boolean(isVirtual);
            return {
                enumerator: "lsblk:pairs",
                busType: (device.tran || "UNKNOWN").toUpperCase(),
                busVersion: null,
                device: "/dev/" + device.name,
                devicePath: null,
                raw: "/dev/" + device.name,
                description: getDescription(device) || device.name,
                error: null,
                size: Number(device.size) || null,
                blockSize: Number(device["phy-sec"]) || 512,
                logicalBlockSize: Number(device["log-sec"]) || 512,
                mountpoints: device.mountpoints,
                isReadOnly,
                isSystem: !isRemovable && !isVirtual,
                isVirtual,
                isRemovable,
                isCard: null,
                isSCSI,
                isUSB,
                isUAS: null
            };
        });
    }
    exports.parse = parse;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.UsbbootDeviceAdapter = void 0;
    const lazy_1 = __webpack_require__(35);
    const usbboot_1 = __webpack_require__(80);
    const adapter_1 = __webpack_require__(39);
    class UsbbootDeviceAdapter extends adapter_1.Adapter {
        constructor() {
            super();
            this.drives = new Map;
            const rpiUsbboot = lazy_1.getRaspberrypiUsbboot();
            if (rpiUsbboot !== undefined) {
                this.scanner = new rpiUsbboot.UsbbootScanner;
                this.scanner.on("attach", this.onAttach.bind(this));
                this.scanner.on("detach", this.onDetach.bind(this));
                this.scanner.on("ready", this.emit.bind(this, "ready"));
                this.scanner.on("error", this.emit.bind(this, "error"));
            } else {
                console.warn("node-raspberrypi-usbboot not available");
                setImmediate(this.emit.bind(this, "ready"));
            }
        }
        start() {
            var _a, _b;
            (_b = (_a = this.scanner) === null || _a === void 0 ? void 0 : _a.start) === null || _b === void 0 ? void 0 : _b.call(_a);
        }
        stop() {
            var _a, _b;
            (_b = (_a = this.scanner) === null || _a === void 0 ? void 0 : _a.stop) === null || _b === void 0 ? void 0 : _b.call(_a);
        }
        onAttach(device) {
            let drive = this.drives.get(device);
            if (drive === undefined) {
                drive = new usbboot_1.UsbbootDrive(device);
                this.drives.set(device, drive);
            }
            this.emit("attach", drive);
        }
        onDetach(device) {
            const drive = this.drives.get(device);
            this.drives.delete(device);
            this.emit("detach", drive);
        }
    }
    exports.UsbbootDeviceAdapter = UsbbootDeviceAdapter;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.DriverlessDeviceAdapter = void 0;
    const process_1 = __webpack_require__(43);
    const lazy_1 = __webpack_require__(35);
    const driverless_1 = __webpack_require__(81);
    const utils_1 = __webpack_require__(6);
    const adapter_1 = __webpack_require__(39);
    const SCAN_INTERVAL = 1e3;
    class DriverlessDeviceAdapter$ extends adapter_1.Adapter {
        constructor() {
            super(...arguments);
            this.drives = new Map;
            this.running = false;
            this.ready = false;
        }
        start() {
            this.running = true;
            this.scanLoop();
        }
        stop() {
            this.running = false;
            this.ready = false;
            this.drives.clear();
        }
        async scanLoop() {
            if (this.listDriverlessDevices === undefined) {
                this.listDriverlessDevices = (await Promise.resolve().then(() => __webpack_require__(183))).listDriverlessDevices;
            }
            while (this.running) {
                this.scan();
                if (!this.ready) {
                    this.ready = true;
                    this.emit("ready");
                }
                await utils_1.delay(SCAN_INTERVAL);
            }
        }
        scan() {
            let drives;
            try {
                drives = this.listDrives();
            } catch (error) {
                return;
            }
            if (this.running) {
                const oldDevices = new Set(this.drives.keys());
                const newDevices = new Set(drives.keys());
                for (const removed of utils_1.difference(oldDevices, newDevices)) {
                    this.emit("detach", this.drives.get(removed));
                    this.drives.delete(removed);
                }
                for (const added of utils_1.difference(newDevices, oldDevices)) {
                    const drive = drives.get(added);
                    const driverlessDevice = new driverless_1.DriverlessDevice(drive);
                    this.emit("attach", driverlessDevice);
                    this.drives.set(added, driverlessDevice);
                }
            }
        }
        listDrives() {
            var _a;
            const isUsbBootCapableUSBDevice = (_a = lazy_1.getRaspberrypiUsbboot()) === null || _a === void 0 ? void 0 : _a.isUsbBootCapableUSBDevice;
            const result = new Map;
            if (isUsbBootCapableUSBDevice == null) {
                return result;
            }
            const devices = this.listDriverlessDevices();
            for (const device of devices) {
                if (isUsbBootCapableUSBDevice(device.vid, device.pid)) {
                    result.set(device.did, device);
                }
            }
            return result;
        }
    }
    exports.DriverlessDeviceAdapter = process_1.platform === "win32" ? DriverlessDeviceAdapter$ : undefined;
}, function(module, exports) {
    module.exports = {};
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.Scanner = void 0;
    const debug_ = __webpack_require__(26);
    const events_1 = __webpack_require__(9);
    const debug = debug_("etcher-sdk:scanner");
    class Scanner extends events_1.EventEmitter {
        constructor(adapters) {
            super();
            this.adapters = adapters;
            this.drives = new Set;
            this.adapters.forEach(adapter => {
                adapter.on("attach", this.onAttach.bind(this));
                adapter.on("detach", this.onDetach.bind(this));
                adapter.on("error", this.emit.bind(this, "error"));
            });
        }
        onAttach(drive) {
            this.drives.add(drive);
            this.emit("attach", drive);
        }
        onDetach(drive) {
            this.drives.delete(drive);
            this.emit("detach", drive);
        }
        getBy(field, value) {
            for (const drive of this.drives) {
                if (drive[field] === value) {
                    return drive;
                }
            }
        }
        start() {
            debug("start");
            let notReady = this.adapters.length;
            return new Promise(resolve => {
                this.adapters.forEach(adapter => {
                    adapter.on("ready", () => {
                        notReady -= 1;
                        if (notReady === 0) {
                            this.emit("ready");
                            resolve();
                        }
                    });
                    adapter.start();
                });
            });
        }
        stop() {
            debug("stop");
            this.drives.clear();
            this.adapters.forEach(adapter => {
                adapter.stop();
            });
        }
    }
    exports.Scanner = Scanner;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.BZip2Source = void 0;
    const unbzip2Stream = __webpack_require__(82);
    const compressed_source_1 = __webpack_require__(17);
    const source_destination_1 = __webpack_require__(7);
    class BZip2Source extends compressed_source_1.CompressedSource {
        createTransform() {
            return unbzip2Stream();
        }
        async getSize() {
            const size = await this.getSizeFromPartitionTable();
            if (size !== undefined) {
                return {
                    size,
                    isEstimated: true
                };
            }
        }
    }
    exports.BZip2Source = BZip2Source;
    BZip2Source.mimetype = "application/x-bzip2";
    source_destination_1.SourceDestination.register(BZip2Source);
}, function(module, exports) {
    function Bzip2Error(message) {
        this.name = "Bzip2Error";
        this.message = message;
        this.stack = (new Error).stack;
    }
    Bzip2Error.prototype = new Error;
    var message = {
        Error: function(message) {
            throw new Error(message);
        }
    };
    var bzip2 = {};
    bzip2.Bzip2Error = Bzip2Error;
    bzip2.crcTable = [ 0, 79764919, 159529838, 222504665, 319059676, 398814059, 445009330, 507990021, 638119352, 583659535, 797628118, 726387553, 890018660, 835552979, 1015980042, 944750013, 1276238704, 1221641927, 1167319070, 1095957929, 1595256236, 1540665371, 1452775106, 1381403509, 1780037320, 1859660671, 1671105958, 1733955601, 2031960084, 2111593891, 1889500026, 1952343757, 2552477408, 2632100695, 2443283854, 2506133561, 2334638140, 2414271883, 2191915858, 2254759653, 3190512472, 3135915759, 3081330742, 3009969537, 2905550212, 2850959411, 2762807018, 2691435357, 3560074640, 3505614887, 3719321342, 3648080713, 3342211916, 3287746299, 3467911202, 3396681109, 4063920168, 4143685023, 4223187782, 4286162673, 3779000052, 3858754371, 3904687514, 3967668269, 881225847, 809987520, 1023691545, 969234094, 662832811, 591600412, 771767749, 717299826, 311336399, 374308984, 453813921, 533576470, 25881363, 88864420, 134795389, 214552010, 2023205639, 2086057648, 1897238633, 1976864222, 1804852699, 1867694188, 1645340341, 1724971778, 1587496639, 1516133128, 1461550545, 1406951526, 1302016099, 1230646740, 1142491917, 1087903418, 2896545431, 2825181984, 2770861561, 2716262478, 3215044683, 3143675388, 3055782693, 3001194130, 2326604591, 2389456536, 2200899649, 2280525302, 2578013683, 2640855108, 2418763421, 2498394922, 3769900519, 3832873040, 3912640137, 3992402750, 4088425275, 4151408268, 4197601365, 4277358050, 3334271071, 3263032808, 3476998961, 3422541446, 3585640067, 3514407732, 3694837229, 3640369242, 1762451694, 1842216281, 1619975040, 1682949687, 2047383090, 2127137669, 1938468188, 2001449195, 1325665622, 1271206113, 1183200824, 1111960463, 1543535498, 1489069629, 1434599652, 1363369299, 622672798, 568075817, 748617968, 677256519, 907627842, 853037301, 1067152940, 995781531, 51762726, 131386257, 177728840, 240578815, 269590778, 349224269, 429104020, 491947555, 4046411278, 4126034873, 4172115296, 4234965207, 3794477266, 3874110821, 3953728444, 4016571915, 3609705398, 3555108353, 3735388376, 3664026991, 3290680682, 3236090077, 3449943556, 3378572211, 3174993278, 3120533705, 3032266256, 2961025959, 2923101090, 2868635157, 2813903052, 2742672763, 2604032198, 2683796849, 2461293480, 2524268063, 2284983834, 2364738477, 2175806836, 2238787779, 1569362073, 1498123566, 1409854455, 1355396672, 1317987909, 1246755826, 1192025387, 1137557660, 2072149281, 2135122070, 1912620623, 1992383480, 1753615357, 1816598090, 1627664531, 1707420964, 295390185, 358241886, 404320391, 483945776, 43990325, 106832002, 186451547, 266083308, 932423249, 861060070, 1041341759, 986742920, 613929101, 542559546, 756411363, 701822548, 3316196985, 3244833742, 3425377559, 3370778784, 3601682597, 3530312978, 3744426955, 3689838204, 3819031489, 3881883254, 3928223919, 4007849240, 4037393693, 4100235434, 4180117107, 4259748804, 2310601993, 2373574846, 2151335527, 2231098320, 2596047829, 2659030626, 2470359227, 2550115596, 2947551409, 2876312838, 2788305887, 2733848168, 3165939309, 3094707162, 3040238851, 2985771188 ];
    bzip2.array = function(bytes) {
        var bit = 0, byte = 0;
        var BITMASK = [ 0, 1, 3, 7, 15, 31, 63, 127, 255 ];
        return function(n) {
            var result = 0;
            while (n > 0) {
                var left = 8 - bit;
                if (n >= left) {
                    result <<= left;
                    result |= BITMASK[left] & bytes[byte++];
                    bit = 0;
                    n -= left;
                } else {
                    result <<= n;
                    result |= (bytes[byte] & BITMASK[n] << 8 - n - bit) >> 8 - n - bit;
                    bit += n;
                    n = 0;
                }
            }
            return result;
        };
    };
    bzip2.simple = function(srcbuffer, stream) {
        var bits = bzip2.array(srcbuffer);
        var size = bzip2.header(bits);
        var ret = false;
        var bufsize = 1e5 * size;
        var buf = new Int32Array(bufsize);
        do {
            ret = bzip2.decompress(bits, stream, buf, bufsize);
        } while (!ret);
    };
    bzip2.header = function(bits) {
        this.byteCount = new Int32Array(256);
        this.symToByte = new Uint8Array(256);
        this.mtfSymbol = new Int32Array(256);
        this.selectors = new Uint8Array(32768);
        if (bits(8 * 3) != 4348520) message.Error("No magic number found");
        var i = bits(8) - 48;
        if (i < 1 || i > 9) message.Error("Not a BZIP archive");
        return i;
    };
    bzip2.decompress = function(bits, stream, buf, bufsize, streamCRC) {
        var MAX_HUFCODE_BITS = 20;
        var MAX_SYMBOLS = 258;
        var SYMBOL_RUNA = 0;
        var SYMBOL_RUNB = 1;
        var GROUP_SIZE = 50;
        var crc = 0 ^ -1;
        for (var h = "", i = 0; i < 6; i++) h += bits(8).toString(16);
        if (h == "177245385090") {
            var finalCRC = bits(32) | 0;
            if (finalCRC !== streamCRC) message.Error("Error in bzip2: crc32 do not match");
            bits(null);
            return null;
        }
        if (h != "314159265359") message.Error("eek not valid bzip data");
        var crcblock = bits(32) | 0;
        if (bits(1)) message.Error("unsupported obsolete version");
        var origPtr = bits(24);
        if (origPtr > bufsize) message.Error("Initial position larger than buffer size");
        var t = bits(16);
        var symTotal = 0;
        for (i = 0; i < 16; i++) {
            if (t & 1 << 15 - i) {
                var k = bits(16);
                for (j = 0; j < 16; j++) {
                    if (k & 1 << 15 - j) {
                        this.symToByte[symTotal++] = 16 * i + j;
                    }
                }
            }
        }
        var groupCount = bits(3);
        if (groupCount < 2 || groupCount > 6) message.Error("another error");
        var nSelectors = bits(15);
        if (nSelectors == 0) message.Error("meh");
        for (var i = 0; i < groupCount; i++) this.mtfSymbol[i] = i;
        for (var i = 0; i < nSelectors; i++) {
            for (var j = 0; bits(1); j++) if (j >= groupCount) message.Error("whoops another error");
            var uc = this.mtfSymbol[j];
            for (var k = j - 1; k >= 0; k--) {
                this.mtfSymbol[k + 1] = this.mtfSymbol[k];
            }
            this.mtfSymbol[0] = uc;
            this.selectors[i] = uc;
        }
        var symCount = symTotal + 2;
        var groups = [];
        var length = new Uint8Array(MAX_SYMBOLS), temp = new Uint16Array(MAX_HUFCODE_BITS + 1);
        var hufGroup;
        for (var j = 0; j < groupCount; j++) {
            t = bits(5);
            for (var i = 0; i < symCount; i++) {
                while (true) {
                    if (t < 1 || t > MAX_HUFCODE_BITS) message.Error("I gave up a while ago on writing error messages");
                    if (!bits(1)) break;
                    if (!bits(1)) t++; else t--;
                }
                length[i] = t;
            }
            var minLen, maxLen;
            minLen = maxLen = length[0];
            for (var i = 1; i < symCount; i++) {
                if (length[i] > maxLen) maxLen = length[i]; else if (length[i] < minLen) minLen = length[i];
            }
            hufGroup = groups[j] = {};
            hufGroup.permute = new Int32Array(MAX_SYMBOLS);
            hufGroup.limit = new Int32Array(MAX_HUFCODE_BITS + 1);
            hufGroup.base = new Int32Array(MAX_HUFCODE_BITS + 1);
            hufGroup.minLen = minLen;
            hufGroup.maxLen = maxLen;
            var base = hufGroup.base;
            var limit = hufGroup.limit;
            var pp = 0;
            for (var i = minLen; i <= maxLen; i++) for (var t = 0; t < symCount; t++) if (length[t] == i) hufGroup.permute[pp++] = t;
            for (i = minLen; i <= maxLen; i++) temp[i] = limit[i] = 0;
            for (i = 0; i < symCount; i++) temp[length[i]]++;
            pp = t = 0;
            for (i = minLen; i < maxLen; i++) {
                pp += temp[i];
                limit[i] = pp - 1;
                pp <<= 1;
                base[i + 1] = pp - (t += temp[i]);
            }
            limit[maxLen] = pp + temp[maxLen] - 1;
            base[minLen] = 0;
        }
        for (var i = 0; i < 256; i++) {
            this.mtfSymbol[i] = i;
            this.byteCount[i] = 0;
        }
        var runPos, count, symCount, selector;
        runPos = count = symCount = selector = 0;
        while (true) {
            if (!symCount--) {
                symCount = GROUP_SIZE - 1;
                if (selector >= nSelectors) message.Error("meow i'm a kitty, that's an error");
                hufGroup = groups[this.selectors[selector++]];
                base = hufGroup.base;
                limit = hufGroup.limit;
            }
            i = hufGroup.minLen;
            j = bits(i);
            while (true) {
                if (i > hufGroup.maxLen) message.Error("rawr i'm a dinosaur");
                if (j <= limit[i]) break;
                i++;
                j = j << 1 | bits(1);
            }
            j -= base[i];
            if (j < 0 || j >= MAX_SYMBOLS) message.Error("moo i'm a cow");
            var nextSym = hufGroup.permute[j];
            if (nextSym == SYMBOL_RUNA || nextSym == SYMBOL_RUNB) {
                if (!runPos) {
                    runPos = 1;
                    t = 0;
                }
                if (nextSym == SYMBOL_RUNA) t += runPos; else t += 2 * runPos;
                runPos <<= 1;
                continue;
            }
            if (runPos) {
                runPos = 0;
                if (count + t > bufsize) message.Error("Boom.");
                uc = this.symToByte[this.mtfSymbol[0]];
                this.byteCount[uc] += t;
                while (t--) buf[count++] = uc;
            }
            if (nextSym > symTotal) break;
            if (count >= bufsize) message.Error("I can't think of anything. Error");
            i = nextSym - 1;
            uc = this.mtfSymbol[i];
            for (var k = i - 1; k >= 0; k--) {
                this.mtfSymbol[k + 1] = this.mtfSymbol[k];
            }
            this.mtfSymbol[0] = uc;
            uc = this.symToByte[uc];
            this.byteCount[uc]++;
            buf[count++] = uc;
        }
        if (origPtr < 0 || origPtr >= count) message.Error("I'm a monkey and I'm throwing something at someone, namely you");
        var j = 0;
        for (var i = 0; i < 256; i++) {
            k = j + this.byteCount[i];
            this.byteCount[i] = j;
            j = k;
        }
        for (var i = 0; i < count; i++) {
            uc = buf[i] & 255;
            buf[this.byteCount[uc]] |= i << 8;
            this.byteCount[uc]++;
        }
        var pos = 0, current = 0, run = 0;
        if (count) {
            pos = buf[origPtr];
            current = pos & 255;
            pos >>= 8;
            run = -1;
        }
        count = count;
        var copies, previous, outbyte;
        while (count) {
            count--;
            previous = current;
            pos = buf[pos];
            current = pos & 255;
            pos >>= 8;
            if (run++ == 3) {
                copies = current;
                outbyte = previous;
                current = -1;
            } else {
                copies = 1;
                outbyte = current;
            }
            while (copies--) {
                crc = (crc << 8 ^ this.crcTable[(crc >> 24 ^ outbyte) & 255]) & 4294967295;
                stream(outbyte);
            }
            if (current != previous) run = 0;
        }
        crc = (crc ^ -1) >>> 0;
        if ((crc | 0) != (crcblock | 0)) message.Error("Error in bzip2: crc32 do not match");
        if (streamCRC === null) streamCRC = 0;
        streamCRC = (crc ^ (streamCRC << 1 | streamCRC >>> 31)) & 4294967295;
        return streamCRC;
    };
    module.exports = bzip2;
}, function(module, exports) {
    var BITMASK = [ 0, 1, 3, 7, 15, 31, 63, 127, 255 ];
    module.exports = function bitIterator(nextBuffer) {
        var bit = 0, byte = 0;
        var bytes = nextBuffer();
        var f = function(n) {
            if (n === null && bit != 0) {
                bit = 0;
                byte++;
                return;
            }
            var result = 0;
            while (n > 0) {
                if (byte >= bytes.length) {
                    byte = 0;
                    bytes = nextBuffer();
                }
                var left = 8 - bit;
                if (bit === 0 && n > 0) f.bytesRead++;
                if (n >= left) {
                    result <<= left;
                    result |= BITMASK[left] & bytes[byte++];
                    bit = 0;
                    n -= left;
                } else {
                    result <<= n;
                    result |= (bytes[byte] & BITMASK[n] << 8 - n - bit) >> 8 - n - bit;
                    bit += n;
                    n = 0;
                }
            }
            return result;
        };
        f.bytesRead = 0;
        return f;
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.DmgSource = void 0;
    const udif_1 = __webpack_require__(189);
    const source_destination_1 = __webpack_require__(7);
    const source_source_1 = __webpack_require__(24);
    const block_transform_stream_1 = __webpack_require__(45);
    const constants_1 = __webpack_require__(5);
    const errors_1 = __webpack_require__(8);
    const shared_1 = __webpack_require__(19);
    const sparse_transform_stream_1 = __webpack_require__(198);
    class DmgSource extends source_source_1.SourceSource {
        constructor(source) {
            super(source);
        }
        async canCreateReadStream() {
            return true;
        }
        async canCreateSparseReadStream() {
            return true;
        }
        async createReadStream({start = 0, end, alignment, numBuffers} = {}) {
            if (start !== 0) {
                throw new errors_1.NotCapable;
            }
            const stream = await this.image.createReadStream(end);
            return block_transform_stream_1.BlockTransformStream.alignIfNeeded(stream, alignment, numBuffers);
        }
        async createSparseReadStream({alignment, numBuffers} = {}) {
            const blocks = await this.getBlocks();
            const stream = Object.assign(await this.image.createSparseReadStream(), {
                blocks
            });
            if (alignment !== undefined) {
                const transform = new sparse_transform_stream_1.ProgressSparseTransformStream({
                    blocks,
                    chunkSize: constants_1.CHUNK_SIZE,
                    alignment,
                    numBuffers
                });
                stream.on("error", transform.emit.bind(transform, "error"));
                stream.pipe(transform);
                return transform;
            } else {
                return stream;
            }
        }
        async getBlocks() {
            const result = [];
            for (const blk of this.image.resourceFork.blkx) {
                const childBlocks = blk.map.blocks.filter(b => DmgSource.mappedBlockTypes.includes(b.type));
                if (childBlocks.length === 0) {
                    continue;
                }
                let checksumType;
                let checksum;
                if (blk.map.checksum.type === udif_1.CHECKSUM_TYPE.CRC32) {
                    checksumType = "crc32";
                    checksum = blk.map.checksum.value;
                }
                const blocks = [];
                result.push({
                    checksumType,
                    checksum,
                    blocks
                });
                let lastBlock;
                for (const childBlk of childBlocks) {
                    const offset = (blk.map.sectorNumber + childBlk.sectorNumber) * udif_1.SECTOR_SIZE;
                    const length = childBlk.sectorCount * udif_1.SECTOR_SIZE;
                    if (lastBlock === undefined) {
                        lastBlock = {
                            offset,
                            length
                        };
                    } else if (lastBlock.offset + lastBlock.length === offset) {
                        lastBlock.length += length;
                    } else {
                        blocks.push(lastBlock);
                        lastBlock = {
                            offset,
                            length
                        };
                    }
                }
                blocks.push(lastBlock);
            }
            return result;
        }
        async _getMetadata() {
            const blocks = await this.getBlocks();
            const blockmappedSize = shared_1.blocksLength(blocks);
            const compressedSize = (await this.source.getMetadata()).size;
            const size = await this.image.getUncompressedSize();
            return {
                blocks,
                blockmappedSize,
                compressedSize,
                size
            };
        }
        async _open() {
            await super._open();
            this.image = new udif_1.Image({
                size: (await this.source.getMetadata()).size,
                createReadStream: async (start, end) => await this.source.createReadStream({
                    start,
                    end
                })
            });
            await this.image.ready;
        }
    }
    exports.DmgSource = DmgSource;
    DmgSource.mappedBlockTypes = [ udif_1.BLOCK.ZEROFILL, udif_1.BLOCK.RAW, udif_1.BLOCK.UDCO, udif_1.BLOCK.UDZO, udif_1.BLOCK.UDBZ, udif_1.BLOCK.LZFSE ];
    DmgSource.requiresRandomReadableSource = true;
    DmgSource.mimetype = "application/x-apple-diskimage";
    source_destination_1.SourceDestination.register(DmgSource);
}, function(module, exports, __webpack_require__) {
    "use strict";
    var __createBinding = this && this.__createBinding || (Object.create ? function(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        Object.defineProperty(o, k2, {
            enumerable: true,
            get: function() {
                return m[k];
            }
        });
    } : function(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    });
    var __exportStar = this && this.__exportStar || function(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) __createBinding(exports, m, p);
    };
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    __exportStar(__webpack_require__(83), exports);
    __exportStar(__webpack_require__(84), exports);
    __exportStar(__webpack_require__(55), exports);
    __exportStar(__webpack_require__(16), exports);
    __exportStar(__webpack_require__(85), exports);
    __exportStar(__webpack_require__(86), exports);
    __exportStar(__webpack_require__(89), exports);
    __exportStar(__webpack_require__(90), exports);
    __exportStar(__webpack_require__(40), exports);
    __exportStar(__webpack_require__(41), exports);
}, function(module, exports, __webpack_require__) {
    var Plist = __webpack_require__(27);
    var sax = __webpack_require__(87);
    var depth = 0;
    var state = [];
    var values = [];
    var keys = [];
    var textContent = "";
    function isStruct(name) {
        return name === "dict" || name === "array" || name === "set";
    }
    function isValue(name) {
        return name === "string" || name === "integer" || name === "real" || name === "true" || name === "false" || name === "null" || name === "data" || name === "date";
    }
    function reset() {
        depth = 0;
        state = [];
        values = [];
        key = "";
        textContent = "";
    }
    function pushValue() {
        switch (state[0]) {
          case "true":
            values.unshift(true);
            break;

          case "false":
            values.unshift(false);
            break;

          case "null":
            values.unshift(null);
            break;

          case "string":
            values.unshift(textContent.trim());
            break;

          case "integer":
            values.unshift(+textContent.trim());
            break;

          case "real":
            values.unshift(+textContent.trim());
            break;

          case "data":
            values.unshift(Buffer.from(textContent.trim(), "base64"));
            break;

          case "date":
            values.unshift(new Date(textContent.trim()));
            break;
        }
    }
    function popValue() {
        switch (state[0]) {
          case "dict":
            values[1][keys.shift()] = values.shift();
            break;

          case "array":
            values[1].push(values.shift());
            break;

          case "set":
            values[1].add(values.shift());
            break;
        }
    }
    var parser = sax.parser(true);
    parser.onopentag = tag => {
        if (tag.name === "plist") {
            if (tag.attributes.version !== "1.0") {
                reset();
                parser.reset();
                throw new Error(`Unsupported version "${tag.attributes.version}"`);
            }
            return;
        }
        state.unshift(tag.name);
        if (tag.name === "dict" || tag.name === "array" || tag.name === "set") {
            depth++;
            switch (tag.name) {
              case "dict":
                values.unshift({});
                break;

              case "array":
                values.unshift([]);
                break;

              case "set":
                values.unshift(new Set);
                break;
            }
        }
    };
    parser.ontext = text => {
        if (state[0] === "key" || isValue(state[0])) textContent += text;
    };
    parser.onclosetag = name => {
        if (name === "plist") return;
        if (state[0] === "key") {
            keys.unshift(textContent.trim());
            textContent = "";
            state.shift();
            return;
        }
        if (isValue(name)) {
            pushValue();
            textContent = "";
            state.shift();
            if (isStruct(state[0])) {
                popValue();
            }
        } else if (isStruct(name)) {
            state.shift();
            depth--;
            if (isStruct(state[0])) {
                popValue();
            }
        } else {
            throw new Error(`Unexpected closing state for "${name}"`);
        }
    };
    parser.onend = () => {
        if (depth) {
            var msg = `Unbalanced structure, remaining depth of ${depth}`;
            reset();
            parser.reset();
            throw new Error(msg);
        }
    };
    function parse(buffer, offset, length) {
        offset = offset || 0;
        length = length || buffer.length - offset;
        if (buffer.indexOf(Plist.SIGNATURE_XML, offset) !== offset) {
            throw new Error(`Invalid property list signature at offset 0x${offset.toString(16)}`);
        }
        var xml = Buffer.isBuffer(buffer) ? buffer.toString("utf8", offset, offset + length) : offset === 0 ? buffer : buffer.slice(offset, offset + length);
        parser.write(xml).close();
        var data = values[0];
        reset();
        return data;
    }
    module.exports = parse;
}, function(module, exports) {
    module.exports = require("string_decoder");
}, function(module, exports, __webpack_require__) {
    var Plist = __webpack_require__(27);
    var getType = __webpack_require__(193);
    const INDENT = "  ";
    const EOL = "\n";
    const BASE64_WIDTH = 48 * 2;
    const ENTITY_PATTERN = /<|>|"|'|&/g;
    const ENTITIES = {
        "<": "&lt;",
        ">": "&gt;",
        '"': "&quot;",
        "'": "&apos;",
        "&": "&amp;"
    };
    function encodeEntities(str) {
        return str ? str.replace(ENTITY_PATTERN, char => ENTITIES[char]) : "";
    }
    function encodeData(value, depth) {
        var indent = INDENT.repeat(depth);
        var block = indent + "<data>" + EOL;
        var data = value.toString("base64");
        var offset = 0;
        while (offset < data.length) {
            block += indent + data.slice(offset, offset += BASE64_WIDTH) + EOL;
        }
        return block + indent + "</data>" + EOL;
    }
    function encodeString(value, depth) {
        return INDENT.repeat(depth) + `<string>${encodeEntities(value)}</string>` + EOL;
    }
    function encodeBoolean(value, depth) {
        return INDENT.repeat(depth) + (value ? `<true/>` : "<false/>") + EOL;
    }
    function encodeNumber(value, depth) {
        return INDENT.repeat(depth) + (Math.round(value) === value ? `<integer>${encodeEntities(value.toString())}</integer>` : `<real>${encodeEntities(value.toString())}</real>`) + EOL;
    }
    function encodeDate(value, depth) {
        return INDENT.repeat(depth) + `<date>${value.toJSON()}</date>` + EOL;
    }
    function encodeKey(value, depth) {
        return INDENT.repeat(depth) + `<key>${encodeEntities(value)}</key>` + EOL;
    }
    function encodeDict(value, depth) {
        var indent = INDENT.repeat(depth);
        var output = indent + "<dict>" + EOL;
        var keys = Object.keys(value);
        for (var i = 0; i < keys.length; i++) {
            output += encodeKey(keys[i], depth + 1);
            output += encodeObject(value[keys[i]], depth + 1);
        }
        return output + indent + "</dict>" + EOL;
    }
    function encodeMap(value, depth) {
        var indent = INDENT.repeat(depth);
        var output = indent + "<dict>" + EOL;
        value.forEach((value, key) => {
            output += encodeKey(keys, depth + 1);
            output += encodeObject(value, depth + 1);
        });
        return output + indent + "</dict>" + EOL;
    }
    function encodeSet(value, depth) {
        var indent = INDENT.repeat(depth);
        var output = indent + "<array>" + EOL;
        value.forEach(value => {
            output += encodeObject(value, depth + 1);
        });
        return output + indent + "</array>" + EOL;
    }
    function encodeArray(value, depth) {
        var indent = INDENT.repeat(depth);
        var output = indent + "<array>" + EOL;
        for (var i = 0; i < value.length; i++) {
            output += encodeObject(value[i], depth + 1);
        }
        return output + indent + "</array>" + EOL;
    }
    function encodeObject(value, depth) {
        var type = getType(value);
        depth = depth || 0;
        switch (type) {
          case "arraybufferview":
            return encodeData(Buffer.from(value.buffer, value.byteOffset, value.byteLength), depth);

          case "arraybuffer":
            return encodeData(Buffer.from(value), depth);

          case "buffer":
            return encodeData(value, depth);

          case "array":
            return encodeArray(value, depth);

          case "set":
            return encodeSet(value, depth);

          case "object":
            return encodeDict(value, depth);

          case "map":
            return encodeMap(value, depth);

          case "number":
            return encodeNumber(value, depth);

          case "bigint":
            return encodeNumber(value, depth);

          case "string":
            return encodeString(value, depth);

          case "symbol":
            return encodeString(value.description, depth);

          case "boolean":
            return encodeBoolean(value, depth);

          case "date":
            return encodeDate(value, depth);
        }
        throw new Error(`Unknown data type "${type}"`);
    }
    function encode(data, buffer, offset) {
        return `<?xml version="1.0" encoding="UTF-8"?>\n<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">\n<plist version="1.0">\n${encodeObject(data)}\n</plist>\n`;
    }
    module.exports = encode;
}, function(module, exports) {
    module.exports = function getTypeOf(value) {
        if (value === null) return "null";
        var type = typeof value;
        var isPrimitive = type == "undefined" || type == "number" || type == "bigint" || type == "string" || type == "boolean" || type == "symbol";
        if (isPrimitive) return type;
        if (Buffer.isBuffer(value)) return "buffer";
        if (Array.isArray(value)) return "array";
        if (ArrayBuffer.isView(value)) return "arraybufferview";
        if (value instanceof Number) return "number";
        if (value instanceof Boolean) return "boolean";
        if (value instanceof ArrayBuffer) return "arraybuffer";
        if (value instanceof Date) return "date";
        if (value instanceof Set) return "set";
        if (value instanceof Map) return "map";
        return type;
    };
}, function(module, exports, __webpack_require__) {
    var Plist = __webpack_require__(27);
    var {readBigInt64BE, readBigUInt64BE} = __webpack_require__(88);
    function readPrimitive(objInfo) {
        switch (objInfo) {
          case 0:
            return null;

          case 8:
            return false;

          case 9:
            return true;

          case 15:
            return undefined;
        }
    }
    function readInt(context, buffer, offset) {
        var objInfo = buffer[context.offset + offset] & 15;
        var length = 1 << objInfo;
        switch (length) {
          case 1:
            return buffer.readUInt8(context.offset + offset + 1);

          case 2:
            return buffer.readUInt16BE(context.offset + offset + 1);

          case 4:
            return buffer.readUInt32BE(context.offset + offset + 1);

          case 8:
            return Number(readBigInt64BE(buffer, context.offset + offset + 1));

          case 16:
            return Number((readBigInt64BE(buffer, context.offset + offset + 1) << 64n) + readBigUInt64BE(buffer, context.offset + offset + 1 + 8));

          default:
            throw new Error(`${length} byte integers not supported`);
        }
    }
    function readReal(context, buffer, offset) {
        var objInfo = buffer[context.offset + offset] & 15;
        var length = 1 << objInfo;
        switch (length) {
          case 4:
            return buffer.readFloatBE(context.offset + offset + 1);

          case 8:
            return buffer.readDoubleBE(context.offset + offset + 1);

          default:
            throw new Error(`${length} byte reals not supported`);
        }
    }
    function readDate(context, buffer, offset) {
        var objInfo = buffer[context.offset + offset] & 15;
        offset += 1;
        var seconds = buffer.readDoubleBE(context.offset + offset);
        return new Date(Plist.EPOCH + seconds * 1e3);
    }
    function readData(context, buffer, offset) {
        var objInfo = buffer[context.offset + offset] & 15;
        var length = objInfo !== 15 ? objInfo : -1;
        offset += 1;
        if (length === -1) {
            length = readInt(context, buffer, offset);
            offset += 1 + (1 << (buffer[context.offset + offset] & 15));
        }
        var data = Buffer.alloc(length);
        var start = context.offset + offset;
        var end = start + length;
        buffer.copy(data, 0, start, end);
        return data;
    }
    function readAscii(context, buffer, offset) {
        var objInfo = buffer[context.offset + offset] & 15;
        var length = objInfo !== 15 ? objInfo : -1;
        offset += 1;
        if (length === -1) {
            length = readInt(context, buffer, offset);
            offset += 1 + (1 << (buffer[context.offset + offset] & 15));
        }
        var start = context.offset + offset;
        var end = start + length;
        return buffer.toString("ascii", start, end);
    }
    function readUnicode(context, buffer, offset) {
        var objInfo = buffer[context.offset + offset] & 15;
        var length = objInfo !== 15 ? objInfo : -1;
        offset += 1;
        if (length === -1) {
            length = readInt(context, buffer, offset);
            offset += 1 + (1 << (buffer[context.offset + offset] & 15));
        }
        var start = context.offset + offset;
        var end = start + length * 2;
        var chars = Buffer.alloc(length * 2);
        buffer.copy(chars, 0, start, end);
        return chars.swap16().toString("utf16le");
    }
    function readUID(context, buffer, offset) {
        var objInfo = buffer[context.offset + offset] & 15;
        var length = objInfo + 1;
        offset += 1;
        var start = context.offset + offset;
        var end = start + length;
        return buffer.toString("hex", start, end);
    }
    function readArray(context, buffer, offset) {
        var objInfo = buffer[context.offset + offset] & 15;
        var length = objInfo !== 15 ? objInfo : -1;
        offset += 1;
        if (length === -1) {
            length = readInt(context, buffer, offset);
            offset += 1 + (1 << (buffer[context.offset + offset] & 15));
        }
        var array = [];
        var objRef = null;
        for (var i = 0; i < length; i++) {
            objRef = buffer.readUIntBE(context.offset + offset + i * context.objectRefSize, context.objectRefSize);
            array.push(readObject(context, buffer, objRef));
        }
        return array;
    }
    function readSet(context, buffer, offset) {
        var objInfo = buffer[context.offset + offset] & 15;
        var length = objInfo !== 15 ? objInfo : -1;
        offset += 1;
        if (length === -1) {
            length = readInt(context, buffer, offset);
            offset += 1 + (1 << (buffer[context.offset + offset] & 15));
        }
        var set = new Set;
        var objRef = null;
        for (var i = 0; i < length; i++) {
            objRef = buffer.readUIntBE(offset + i * context.objectRefSize, context.objectRefSize);
            set.add(readObject(context, buffer, objRef));
        }
        return set;
    }
    function readDict(context, buffer, offset) {
        var objInfo = buffer[context.offset + offset] & 15;
        var length = objInfo !== 15 ? objInfo : -1;
        offset += 1;
        if (length === -1) {
            length = readInt(context, buffer, offset);
            offset += 1 + (1 << (buffer[context.offset + offset] & 15));
        }
        var dict = {};
        var keys = [];
        var objRef = null;
        for (var i = 0; i < length; i++) {
            objRef = buffer.readUIntBE(context.offset + offset + i * context.objectRefSize, context.objectRefSize);
            keys.push(readObject(context, buffer, objRef));
        }
        var values = [];
        for (var i = 0; i < length; i++) {
            objRef = buffer.readUIntBE(context.offset + offset + (i + length) * context.objectRefSize, context.objectRefSize);
            values.push(readObject(context, buffer, objRef));
        }
        for (var i = 0; i < length; i++) {
            dict[keys[i]] = values[i];
        }
        return dict;
    }
    function readObject(context, buffer, objRef) {
        var offset = context.offsetTable.readUIntBE(objRef * context.offsetIntSize, context.offsetIntSize);
        var marker = buffer[context.offset + offset];
        var objType = (marker & 240) >>> 4;
        var objInfo = marker & 15;
        switch (objType) {
          case 0:
            return readPrimitive(objInfo);

          case 1:
            return readInt(context, buffer, offset);

          case 2:
            return readReal(context, buffer, offset);

          case 3:
            return readDate(context, buffer, offset);

          case 4:
            return readData(context, buffer, offset);

          case 5:
            return readAscii(context, buffer, offset);

          case 6:
            return readUnicode(context, buffer, offset);

          case 8:
            return readUID(context, buffer, offset);

          case 10:
            return readArray(context, buffer, offset);

          case 12:
            return readSet(context, buffer, offset);

          case 13:
            return readDict(context, buffer, offset);
        }
        throw new Error(`Unknown type marker 0b${marker.toString(2)}`);
    }
    function decode(buffer, offset, length) {
        offset = offset || 0;
        length = length || buffer.length - offset;
        if (buffer.indexOf(Plist.SIGNATURE_BINARY, offset) !== offset) {
            throw new Error(`Invalid property list signature at offset 0x${offset.toString(16)}`);
        }
        var trailerOffset = offset + length - 32;
        var context = {
            offset,
            length,
            trailerOffset,
            sortVersion: buffer[trailerOffset + 5],
            offsetIntSize: buffer[trailerOffset + 6],
            objectRefSize: buffer[trailerOffset + 7],
            objectCount: Number(readBigUInt64BE(buffer, trailerOffset + 8)),
            rootObject: Number(readBigUInt64BE(buffer, trailerOffset + 16)),
            offsetTableOffset: Number(readBigUInt64BE(buffer, trailerOffset + 24)),
            offsetTable: null
        };
        context.offsetTable = buffer.slice(offset + context.offsetTableOffset, offset + context.offsetTableOffset + context.objectCount * context.offsetIntSize);
        return readObject(context, buffer, context.rootObject);
    }
    module.exports = decode;
}, function(module, exports, __webpack_require__) {
    var Plist = __webpack_require__(27);
    var {writeBigInt64BE, writeBigUInt64BE} = __webpack_require__(88);
    const PRIMITIVE = 0;
    const INT = 1;
    const REAL = 2;
    const DATE = 3;
    const DATA = 4;
    const ASCII = 5;
    const UNICODE = 6;
    const UUID = 8;
    const ARRAY = 10;
    const SET = 12;
    const DICT = 13;
    function bits(value, clamp = 0) {
        var bits = Math.ceil(Math.log2(Math.abs(value) + 1));
        return Math.max(clamp, 1 << Math.ceil(Math.log2(bits)));
    }
    function signedBits(value, clamp = 0) {
        var bits = Math.ceil(Math.log2(Math.abs(value)));
        return Math.max(clamp, 1 << Math.ceil(Math.log2(bits))) * 2;
    }
    function getTypeof(value) {
        if (value === null) return "null";
        if (Buffer.isBuffer(value)) return "buffer";
        if (Array.isArray(value)) return "array";
        if (ArrayBuffer.isView(value)) return "arraybufferview";
        if (value instanceof Number) return "number";
        if (value instanceof String) return "string";
        if (value instanceof Boolean) return "boolean";
        if (value instanceof Map) return "map";
        if (value instanceof Set) return "set";
        if (value instanceof ArrayBuffer) return "arraybuffer";
        return typeof value;
    }
    function isPrimitiveType(type) {
        return type == "null" || type == "undefined" || type == "boolean" || type == "number" || type == "bigint" || type == "string" || type == "date";
    }
    function getValueSet(value) {
        var values = new Set;
        var objects = new Set;
        var queue = [ value ];
        while (queue.length) {
            let value = queue.shift();
            let type = getTypeof(value);
            if (isPrimitiveType(type)) {
                values.add(value);
            } else if (type == "object") {
                objects.add(value);
                Object.keys(value).forEach(key => {
                    values.add(key);
                    queue.push(value[key]);
                });
            } else if (type == "array" || type == "arraybufferview") {
                objects.add(value);
                value.forEach(item => {
                    queue.push(item);
                });
            } else if (type == "map") {
                objects.add(value);
                for (let [key, item] of value) {
                    queue.push(key);
                    queue.push(item);
                }
            } else if (type == "set") {
                objects.add(value);
                for (let item of value) {
                    queue.push(item);
                }
            } else if (type == "buffer" || type == "arraybuffer") {
                values.add(value);
            } else {
                throw new Error(`Unsupported value type "${type}"`);
            }
        }
        return [ ...values ].concat([ ...objects ].reverse());
    }
    function encode(value, buffer, offset) {
        offset = offset || 0;
        var values = getValueSet(value);
        var objectCount = values.length;
        var refSize = bits(objectCount, 8) / 8;
        var offsets = new Array(objectCount);
        var state = {
            offsets,
            objectCount,
            refSize
        };
        offset += buffer.write("bplist00", offset, "bplist00".length, "ascii");
        for (let i = 0; i < objectCount; i++) {
            offsets[i] = offset;
            offset = encodeValue(values, i, state, buffer, offset);
        }
        var tableOffset = offset;
        var offsetSize = bits(tableOffset, 8) / 8;
        var offsetTable = Buffer.alloc(objectCount * offsetSize);
        for (let i = 0; i < objectCount; i++) {
            let dataOffset = offsets[i];
            offset = buffer.writeUIntBE(dataOffset, offset, offsetSize);
        }
        offset = buffer.writeUIntBE(0, offset, 6);
        offset = buffer.writeUInt8(offsetSize, offset);
        offset = buffer.writeUInt8(refSize, offset);
        offset = writeBigUInt64BE(buffer, BigInt(objectCount), offset);
        offset = writeBigUInt64BE(buffer, BigInt(objectCount - 1), offset);
        offset = writeBigUInt64BE(buffer, BigInt(tableOffset), offset);
        return offset;
    }
    function encodeArray(values, index, state, buffer, offset) {
        var list = values[index];
        var length = list.length;
        var objInfo = length > 14 ? 15 : length;
        offset = buffer.writeUInt8(ARRAY << 4 | objInfo, offset);
        offset = objInfo == 15 ? encodeInt(length, buffer, offset) : offset;
        for (var i = 0; i < list.length; i++) {
            let objRef = values.indexOf(list[i]);
            if (objRef == -1) throw new Error(`Attempt to encode unknown object`);
            offset = buffer.writeUIntBE(objRef, offset, state.refSize);
        }
        return offset;
    }
    function encodeSet(values, index, state, buffer, offset) {
        var list = [ ...values[index] ];
        var length = list.length;
        var objInfo = length > 14 ? 15 : length;
        offset = buffer.writeUInt8(SET << 4 | objInfo, offset);
        offset = objInfo == 15 ? encodeInt(length, buffer, offset) : offset;
        for (var i = 0; i < list.length; i++) {
            let objRef = values.indexOf(list[i]);
            if (objRef == -1) throw new Error(`Attempt to encode unknown object`);
            offset = buffer.writeUIntBE(objRef, offset, state.refSize);
        }
        return offset;
    }
    function encodeMap(values, index, state, buffer, offset) {
        var map = values[index];
        var length = map.size;
        var objInfo = length > 14 ? 15 : length;
        offset = buffer.writeUInt8(DICT << 4 | objInfo, offset);
        offset = objInfo == 15 ? encodeInt(length, buffer, offset) : offset;
        for (let [key, value] of map) {
            let keyRef = values.indexOf(key);
            if (keyRef == -1) throw new Error(`Attempt to encode object with unknown key`);
            offset = buffer.writeUIntBE(keyRef, offset, state.refSize);
        }
        for (let [key, value] of map) {
            let objRef = values.indexOf(value);
            if (objRef == -1) throw new Error(`Attempt to encode unknown object`);
            offset = buffer.writeUIntBE(objRef, offset, state.refSize);
        }
        return offset;
    }
    function encodeDict(values, index, state, buffer, offset) {
        var dict = values[index];
        var keys = Object.keys(dict);
        var length = keys.length;
        var objInfo = length > 14 ? 15 : length;
        offset = buffer.writeUInt8(DICT << 4 | objInfo, offset);
        offset = objInfo == 15 ? encodeInt(length, buffer, offset) : offset;
        for (let i = 0; i < length; i++) {
            let keyRef = values.indexOf(keys[i]);
            if (keyRef == -1) throw new Error(`Attempt to encode object with unknown key`);
            offset = buffer.writeUIntBE(keyRef, offset, state.refSize);
        }
        for (let i = 0; i < length; i++) {
            let objRef = values.indexOf(dict[keys[i]]);
            if (objRef == -1) throw new Error(`Attempt to encode unknown object`);
            offset = buffer.writeUIntBE(objRef, offset, state.refSize);
        }
        return offset;
    }
    function encodeValue(values, index, state, buffer, offset) {
        var type = getTypeof(values[index]);
        switch (type) {
          case "null":
          case "undefined":
          case "boolean":
            return encodeBoolean(values[index], buffer, offset);

          case "number":
          case "bigint":
            return encodeNumber(values[index], buffer, offset);

          case "date":
            return encodeDate(values[index], buffer, offset);

          case "string":
            return encodeString(values[index], buffer, offset);

          case "buffer":
            return encodeBlob(values[index], buffer, offset);

          case "arraybuffer":
            return encodeBlob(Buffer.from(values[index]), buffer, offset);

          case "array":
          case "arraybufferview":
            return encodeArray(values, index, state, buffer, offset);

          case "set":
            return encodeSet(values, index, state, buffer, offset);

          case "map":
            return encodeMap(values, index, state, buffer, offset);

          case "object":
            return encodeDict(values, index, state, buffer, offset);

          default:
            throw new Error(`Invalid value type "${type}"`);
        }
    }
    function encodeBoolean(value, buffer, offset) {
        switch (value) {
          case undefined:
          case null:
            return buffer.writeUInt8(PRIMITIVE << 4 | 0, offset);

          case false:
            return buffer.writeUInt8(PRIMITIVE << 4 | 8, offset);

          case true:
            return buffer.writeUInt8(PRIMITIVE << 4 | 9, offset);

          default:
            throw new Error(`Invalid primitive value "${value}"`);
        }
    }
    function encodeNumber(value, buffer, offset) {
        var shouldFloat = Math.abs(Number(value)) > Number.MAX_SAFE_INTEGER || !Number.isFinite(value) || Math.round(value) != value;
        return shouldFloat ? encodeReal(value, buffer, offset) : encodeInt(value, buffer, offset);
    }
    function encodeInt(value, buffer, offset) {
        var size = Math.abs(Number(value)) <= Number.MAX_SAFE_INTEGER ? signedBits(Number(value), 8) : 128;
        offset = buffer.writeUInt8(INT << 4 | Math.log2(size / 8), offset);
        switch (size) {
          case 8:
            offset = buffer.writeInt8(Number(value), offset);
            break;

          case 16:
            offset = buffer.writeInt16BE(Number(value), offset);
            break;

          case 32:
            offset = buffer.writeInt32BE(Number(value), offset);
            break;

          case 64:
            offset = writeBigInt64BE(buffer, BigInt(value), offset);
            break;

          case 128:
            offset = writeBigInt64BE(buffer, BigInt(value) >> 64n, offset);
            offset = writeBigUInt64BE(buffer, BigInt(value) & 0xFFFFFFFFFFFFFFFFn, offset);
            break;

          default:
            throw new Error(`${size} bit integers not supported`);
        }
        return offset;
    }
    function encodeReal(value, buffer, offset) {
        var size = Math.abs(Number(value)) <= Number.MAX_SAFE_INTEGER ? bits(Number(value), 32) : 64;
        if (size > 64) {
            throw new Error(`${size} bit reals not supported`);
        }
        offset = buffer.writeUInt8(REAL << 4 | Math.log2(size / 8), offset);
        switch (size) {
          case 32:
            offset = buffer.writeFloatBE(Number(value), offset);
            break;

          case 64:
            offset = buffer.writeDoubleBE(Number(value), offset);
            break;
        }
        return offset;
    }
    function encodeDate(value, buffer, offset) {
        var time = value.getTime() / 1e3 - Plist.EPOCH;
        offset = buffer.writeUInt8(DATE << 4 | DATE, offset);
        offset = buffer.writeDoubleBE(time, offset);
        return offset;
    }
    function encodeString(value, buffer, offset) {
        var isUUID = /^[A-F0-9]{8}(-[A-F0-9]{4}){3}-[A-F0-9]{12}$/i.test(value);
        if (isUUID) return encodeUID(value, buffer, offset);
        var length = Buffer.byteLength(value);
        var isUnicode = length != value.length || !/^[\x00-\x7F]+$/.test(value);
        var marker = isUnicode ? UNICODE : ASCII;
        var objInfo = length > 14 ? 15 : length;
        offset = buffer.writeUInt8(marker << 4 | objInfo, offset);
        offset = objInfo == 15 ? encodeInt(length, buffer, offset) : offset;
        offset += buffer.write(value, offset, length, isUnicode ? "utf16le" : "ascii");
        return offset;
    }
    function encodeUID(value, buffer, offset) {
        var length = 15;
        offset = buffer.writeUInt8(UUID << 4 | length, offset);
        offset += buffer.write(value.slice(0, 8), offset, 8, "hex");
        offset += buffer.write(value.slice(9, 13), offset, 4, "hex");
        offset += buffer.write(value.slice(14, 18), offset, 4, "hex");
        offset += buffer.write(value.slice(19, 23), offset, 4, "hex");
        offset += buffer.write(value.slice(24, 36), offset, 12, "hex");
        return offset;
    }
    function encodeBlob(value, buffer, offset) {
        var length = value.length || Buffer.byteLength(value);
        var objInfo = length > 14 ? 15 : length;
        offset = buffer.writeUInt8(DATA << 4 | objInfo, offset);
        offset = objInfo == 15 ? encodeInt(length, buffer, offset) : offset;
        offset += value.copy(buffer, offset, 0, length);
        return offset;
    }
    module.exports = encode;
}, function(module, exports, __webpack_require__) {
    const ADC = __webpack_require__(56);
    var windowOffset = 0;
    var windowSize = 65535 + 67;
    const window = new Uint8Array(windowSize);
    function getWindow(position) {
        return window[(position + windowOffset) % windowSize];
    }
    function setWindow(position, value) {
        windowOffset = windowOffset % windowSize === 0 ? 0 : windowOffset;
        return window[(position + windowOffset) % windowSize] = value;
    }
    function decodeData(window, buffer, position) {
        var length = ADC.getChunkLength(buffer[position]);
        var data = Buffer.allocUnsafe(length);
        var offset = windowSize - data.length;
        position += 1;
        windowOffset += length;
        buffer.copy(data, 0, position);
        for (var i = 0; i < length; i++) {
            setWindow(offset + i, buffer[position++]);
        }
        return data;
    }
    function decodeRunlength(window, buffer, position) {
        var length = ADC.getChunkLength(buffer[position]);
        var offset = ADC.getOffset(buffer, position);
        var data = Buffer.allocUnsafe(length);
        var slidePosition = windowSize - data.length;
        windowOffset += length;
        for (var i = 0; i < length; i++) {
            data[i] = setWindow(slidePosition, getWindow(slidePosition - offset - 1));
            slidePosition++;
        }
        return data;
    }
    function decompress(buffer) {
        var chunks = [];
        var chunkType = ADC.CHUNK_UNKNOWN;
        var position = 0;
        var length = 0;
        windowOffset = 0;
        while (position < buffer.length) {
            chunkType = ADC.getChunkType(buffer[position]);
            length = ADC.getSequenceLength(buffer[position]);
            switch (chunkType) {
              case ADC.CHUNK_DATA:
                chunks.push(decodeData(window, buffer, position));
                break;

              case ADC.CHUNK_THREE:
                chunks.push(decodeRunlength(window, buffer, position));
                break;

              case ADC.CHUNK_TWO:
                chunks.push(decodeRunlength(window, buffer, position));
                break;

              default:
                throw new Error("Unknown chunk type 0x" + buffer[position].toString(16) + " at " + position);
            }
            position += length;
        }
        return Buffer.concat(chunks);
    }
    decompress.decode = decodeData;
    decompress.runLength = decodeRunlength;
    module.exports = decompress;
}, function(module, exports, __webpack_require__) {
    var ADC = __webpack_require__(56);
    var Stream = __webpack_require__(0);
    var inherit = __webpack_require__(15);
    function Decompressor(options) {
        if (!(this instanceof Decompressor)) {
            return new Decompressor(options);
        }
        Stream.Transform.call(this, options);
        this._window = new Uint8Array(65535 + 67);
        this._chunks = [];
        this._bytes = 0;
    }
    Decompressor.prototype = {
        constructor: Decompressor,
        _decode(chunk, next) {
            if (this._bytes > 0) {
                this._chunks.push(chunk);
                chunk = Buffer.concat(this._chunks);
                this._chunks.length = 0;
                this._bytes = 0;
            }
            var chunks = [];
            var chunkType = ADC.CHUNK_UNKNOWN;
            var position = 0;
            var length = 0;
            while (position < chunk.length) {
                chunkType = ADC.getChunkType(chunk[position]);
                length = ADC.getSequenceLength(chunk[position]);
                if (position + length > chunk.length) {
                    break;
                }
                switch (chunkType) {
                  case ADC.CHUNK_DATA:
                    chunks.push(ADC.decompress.decode(this._window, chunk, position));
                    break;

                  case ADC.CHUNK_THREE:
                    chunks.push(ADC.decompress.runLength(this._window, chunk, position));
                    break;

                  case ADC.CHUNK_TWO:
                    chunks.push(ADC.decompress.runLength(this._window, chunk, position));
                    break;

                  default:
                    return next(new Error("Unknown chunk type 0x" + chunk[position].toString(16) + " at " + position));
                }
                position += length;
            }
            if (chunk.length - position) {
                chunk = chunk.slice(position);
                this._chunks.push(chunk);
                this._bytes += chunk.length;
            }
            next(null, Buffer.concat(chunks));
        },
        _transform(chunk, encoding, next) {
            this._decode(chunk, next);
        },
        _flush(done) {
            this._decode(Buffer.allocUnsafe(0), done);
        }
    };
    inherit(Decompressor, Stream.Transform);
    module.exports = Decompressor;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.ProgressSparseTransformStream = exports.SparseTransformStream = void 0;
    const stream_1 = __webpack_require__(0);
    const aligned_lockable_buffer_1 = __webpack_require__(12);
    const progress_1 = __webpack_require__(13);
    const utils_1 = __webpack_require__(6);
    class SparseTransformStream extends stream_1.Transform {
        constructor({blocks, chunkSize, alignment, numBuffers = 2}) {
            super({
                objectMode: true,
                highWaterMark: numBuffers - 1
            });
            this.position = 0;
            this.bytesWritten = 0;
            this.blocks = blocks;
            this.alignedReadableState = new aligned_lockable_buffer_1.AlignedReadableState(chunkSize, alignment, numBuffers);
        }
        async __transform(chunk) {
            this.position = chunk.position;
            let buffer = this.alignedReadableState.getCurrentBuffer();
            const unlock = await buffer.lock();
            try {
                if (chunk.buffer.length < buffer.length) {
                    buffer = buffer.slice(0, chunk.buffer.length);
                }
                chunk.buffer.copy(buffer);
            } finally {
                unlock();
            }
            this.push({
                position: chunk.position,
                buffer
            });
            this.bytesWritten += chunk.buffer.length;
            this.position += chunk.buffer.length;
        }
        _transform(chunk, _encoding, callback) {
            utils_1.asCallback(this.__transform(chunk), callback);
        }
    }
    exports.SparseTransformStream = SparseTransformStream;
    exports.ProgressSparseTransformStream = progress_1.makeClassEmitProgressEvents(SparseTransformStream, "bytesWritten", "position");
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.GZipSource = void 0;
    const zlib_1 = __webpack_require__(18);
    const compressed_source_1 = __webpack_require__(17);
    const source_destination_1 = __webpack_require__(7);
    const ISIZE_LENGTH = 4;
    class GZipSource extends compressed_source_1.CompressedSource {
        createTransform() {
            return zlib_1.createGunzip();
        }
        async getSize() {
            const sizeFromPartitionTable = await this.getSizeFromPartitionTable();
            if (await this.source.canRead()) {
                const sourceMetadata = await this.source.getMetadata();
                if (sourceMetadata.size !== undefined) {
                    const {buffer} = await this.source.read(Buffer.allocUnsafe(ISIZE_LENGTH), 0, ISIZE_LENGTH, sourceMetadata.size - ISIZE_LENGTH);
                    const sizeFromFooter = buffer.readUInt32LE(0);
                    return {
                        size: Math.max(sizeFromFooter, sizeFromPartitionTable || 0),
                        isEstimated: true
                    };
                }
            } else if (sizeFromPartitionTable !== undefined) {
                return {
                    size: sizeFromPartitionTable,
                    isEstimated: true
                };
            }
        }
    }
    exports.GZipSource = GZipSource;
    GZipSource.mimetype = "application/gzip";
    source_destination_1.SourceDestination.register(GZipSource);
}, function(module, exports, __webpack_require__) {
    "use strict";
    var utils = __webpack_require__(10);
    var bind = __webpack_require__(92);
    var Axios = __webpack_require__(201);
    var mergeConfig = __webpack_require__(103);
    var defaults = __webpack_require__(95);
    function createInstance(defaultConfig) {
        var context = new Axios(defaultConfig);
        var instance = bind(Axios.prototype.request, context);
        utils.extend(instance, Axios.prototype, context);
        utils.extend(instance, context);
        return instance;
    }
    var axios = createInstance(defaults);
    axios.Axios = Axios;
    axios.create = function create(instanceConfig) {
        return createInstance(mergeConfig(axios.defaults, instanceConfig));
    };
    axios.Cancel = __webpack_require__(104);
    axios.CancelToken = __webpack_require__(215);
    axios.isCancel = __webpack_require__(94);
    axios.all = function all(promises) {
        return Promise.all(promises);
    };
    axios.spread = __webpack_require__(216);
    module.exports = axios;
    module.exports.default = axios;
}, function(module, exports, __webpack_require__) {
    "use strict";
    var utils = __webpack_require__(10);
    var buildURL = __webpack_require__(93);
    var InterceptorManager = __webpack_require__(202);
    var dispatchRequest = __webpack_require__(203);
    var mergeConfig = __webpack_require__(103);
    function Axios(instanceConfig) {
        this.defaults = instanceConfig;
        this.interceptors = {
            request: new InterceptorManager,
            response: new InterceptorManager
        };
    }
    Axios.prototype.request = function request(config) {
        if (typeof config === "string") {
            config = arguments[1] || {};
            config.url = arguments[0];
        } else {
            config = config || {};
        }
        config = mergeConfig(this.defaults, config);
        if (config.method) {
            config.method = config.method.toLowerCase();
        } else if (this.defaults.method) {
            config.method = this.defaults.method.toLowerCase();
        } else {
            config.method = "get";
        }
        var chain = [ dispatchRequest, undefined ];
        var promise = Promise.resolve(config);
        this.interceptors.request.forEach((function unshiftRequestInterceptors(interceptor) {
            chain.unshift(interceptor.fulfilled, interceptor.rejected);
        }));
        this.interceptors.response.forEach((function pushResponseInterceptors(interceptor) {
            chain.push(interceptor.fulfilled, interceptor.rejected);
        }));
        while (chain.length) {
            promise = promise.then(chain.shift(), chain.shift());
        }
        return promise;
    };
    Axios.prototype.getUri = function getUri(config) {
        config = mergeConfig(this.defaults, config);
        return buildURL(config.url, config.params, config.paramsSerializer).replace(/^\?/, "");
    };
    utils.forEach([ "delete", "get", "head", "options" ], (function forEachMethodNoData(method) {
        Axios.prototype[method] = function(url, config) {
            return this.request(utils.merge(config || {}, {
                method,
                url
            }));
        };
    }));
    utils.forEach([ "post", "put", "patch" ], (function forEachMethodWithData(method) {
        Axios.prototype[method] = function(url, data, config) {
            return this.request(utils.merge(config || {}, {
                method,
                url,
                data
            }));
        };
    }));
    module.exports = Axios;
}, function(module, exports, __webpack_require__) {
    "use strict";
    var utils = __webpack_require__(10);
    function InterceptorManager() {
        this.handlers = [];
    }
    InterceptorManager.prototype.use = function use(fulfilled, rejected) {
        this.handlers.push({
            fulfilled,
            rejected
        });
        return this.handlers.length - 1;
    };
    InterceptorManager.prototype.eject = function eject(id) {
        if (this.handlers[id]) {
            this.handlers[id] = null;
        }
    };
    InterceptorManager.prototype.forEach = function forEach(fn) {
        utils.forEach(this.handlers, (function forEachHandler(h) {
            if (h !== null) {
                fn(h);
            }
        }));
    };
    module.exports = InterceptorManager;
}, function(module, exports, __webpack_require__) {
    "use strict";
    var utils = __webpack_require__(10);
    var transformData = __webpack_require__(204);
    var isCancel = __webpack_require__(94);
    var defaults = __webpack_require__(95);
    function throwIfCancellationRequested(config) {
        if (config.cancelToken) {
            config.cancelToken.throwIfRequested();
        }
    }
    module.exports = function dispatchRequest(config) {
        throwIfCancellationRequested(config);
        config.headers = config.headers || {};
        config.data = transformData(config.data, config.headers, config.transformRequest);
        config.headers = utils.merge(config.headers.common || {}, config.headers[config.method] || {}, config.headers);
        utils.forEach([ "delete", "get", "head", "post", "put", "patch", "common" ], (function cleanHeaderConfig(method) {
            delete config.headers[method];
        }));
        var adapter = config.adapter || defaults.adapter;
        return adapter(config).then((function onAdapterResolution(response) {
            throwIfCancellationRequested(config);
            response.data = transformData(response.data, response.headers, config.transformResponse);
            return response;
        }), (function onAdapterRejection(reason) {
            if (!isCancel(reason)) {
                throwIfCancellationRequested(config);
                if (reason && reason.response) {
                    reason.response.data = transformData(reason.response.data, reason.response.headers, config.transformResponse);
                }
            }
            return Promise.reject(reason);
        }));
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    var utils = __webpack_require__(10);
    module.exports = function transformData(data, headers, fns) {
        utils.forEach(fns, (function transform(fn) {
            data = fn(data, headers);
        }));
        return data;
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    var utils = __webpack_require__(10);
    module.exports = function normalizeHeaderName(headers, normalizedName) {
        utils.forEach(headers, (function processHeader(value, name) {
            if (name !== normalizedName && name.toUpperCase() === normalizedName.toUpperCase()) {
                headers[normalizedName] = value;
                delete headers[name];
            }
        }));
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    var createError = __webpack_require__(96);
    module.exports = function settle(resolve, reject, response) {
        var validateStatus = response.config.validateStatus;
        if (!validateStatus || validateStatus(response.status)) {
            resolve(response);
        } else {
            reject(createError("Request failed with status code " + response.status, response.config, null, response.request, response));
        }
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    var isAbsoluteURL = __webpack_require__(208);
    var combineURLs = __webpack_require__(209);
    module.exports = function buildFullPath(baseURL, requestedURL) {
        if (baseURL && !isAbsoluteURL(requestedURL)) {
            return combineURLs(baseURL, requestedURL);
        }
        return requestedURL;
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    module.exports = function isAbsoluteURL(url) {
        return /^([a-z][a-z\d\+\-\.]*:)?\/\//i.test(url);
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    module.exports = function combineURLs(baseURL, relativeURL) {
        return relativeURL ? baseURL.replace(/\/+$/, "") + "/" + relativeURL.replace(/^\/+/, "") : baseURL;
    };
}, function(module, exports, __webpack_require__) {
    if (typeof process === "undefined" || process.type === "renderer") {
        module.exports = __webpack_require__(211);
    } else {
        module.exports = __webpack_require__(213);
    }
}, function(module, exports, __webpack_require__) {
    exports = module.exports = __webpack_require__(102);
    exports.log = log;
    exports.formatArgs = formatArgs;
    exports.save = save;
    exports.load = load;
    exports.useColors = useColors;
    exports.storage = "undefined" != typeof chrome && "undefined" != typeof chrome.storage ? chrome.storage.local : localstorage();
    exports.colors = [ "#0000CC", "#0000FF", "#0033CC", "#0033FF", "#0066CC", "#0066FF", "#0099CC", "#0099FF", "#00CC00", "#00CC33", "#00CC66", "#00CC99", "#00CCCC", "#00CCFF", "#3300CC", "#3300FF", "#3333CC", "#3333FF", "#3366CC", "#3366FF", "#3399CC", "#3399FF", "#33CC00", "#33CC33", "#33CC66", "#33CC99", "#33CCCC", "#33CCFF", "#6600CC", "#6600FF", "#6633CC", "#6633FF", "#66CC00", "#66CC33", "#9900CC", "#9900FF", "#9933CC", "#9933FF", "#99CC00", "#99CC33", "#CC0000", "#CC0033", "#CC0066", "#CC0099", "#CC00CC", "#CC00FF", "#CC3300", "#CC3333", "#CC3366", "#CC3399", "#CC33CC", "#CC33FF", "#CC6600", "#CC6633", "#CC9900", "#CC9933", "#CCCC00", "#CCCC33", "#FF0000", "#FF0033", "#FF0066", "#FF0099", "#FF00CC", "#FF00FF", "#FF3300", "#FF3333", "#FF3366", "#FF3399", "#FF33CC", "#FF33FF", "#FF6600", "#FF6633", "#FF9900", "#FF9933", "#FFCC00", "#FFCC33" ];
    function useColors() {
        if (typeof window !== "undefined" && window.process && window.process.type === "renderer") {
            return true;
        }
        if (typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/)) {
            return false;
        }
        return typeof document !== "undefined" && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance || typeof window !== "undefined" && window.console && (window.console.firebug || window.console.exception && window.console.table) || typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31 || typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/);
    }
    exports.formatters.j = function(v) {
        try {
            return JSON.stringify(v);
        } catch (err) {
            return "[UnexpectedJSONParseError]: " + err.message;
        }
    };
    function formatArgs(args) {
        var useColors = this.useColors;
        args[0] = (useColors ? "%c" : "") + this.namespace + (useColors ? " %c" : " ") + args[0] + (useColors ? "%c " : " ") + "+" + exports.humanize(this.diff);
        if (!useColors) return;
        var c = "color: " + this.color;
        args.splice(1, 0, c, "color: inherit");
        var index = 0;
        var lastC = 0;
        args[0].replace(/%[a-zA-Z%]/g, (function(match) {
            if ("%%" === match) return;
            index++;
            if ("%c" === match) {
                lastC = index;
            }
        }));
        args.splice(lastC, 0, c);
    }
    function log() {
        return "object" === typeof console && console.log && Function.prototype.apply.call(console.log, console, arguments);
    }
    function save(namespaces) {
        try {
            if (null == namespaces) {
                exports.storage.removeItem("debug");
            } else {
                exports.storage.debug = namespaces;
            }
        } catch (e) {}
    }
    function load() {
        var r;
        try {
            r = exports.storage.debug;
        } catch (e) {}
        if (!r && typeof process !== "undefined" && "env" in process) {
            r = process.env.DEBUG;
        }
        return r;
    }
    exports.enable(load());
    function localstorage() {
        try {
            return window.localStorage;
        } catch (e) {}
    }
}, function(module, exports) {
    var s = 1e3;
    var m = s * 60;
    var h = m * 60;
    var d = h * 24;
    var y = d * 365.25;
    module.exports = function(val, options) {
        options = options || {};
        var type = typeof val;
        if (type === "string" && val.length > 0) {
            return parse(val);
        } else if (type === "number" && isNaN(val) === false) {
            return options.long ? fmtLong(val) : fmtShort(val);
        }
        throw new Error("val is not a non-empty string or a valid number. val=" + JSON.stringify(val));
    };
    function parse(str) {
        str = String(str);
        if (str.length > 100) {
            return;
        }
        var match = /^((?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|years?|yrs?|y)?$/i.exec(str);
        if (!match) {
            return;
        }
        var n = parseFloat(match[1]);
        var type = (match[2] || "ms").toLowerCase();
        switch (type) {
          case "years":
          case "year":
          case "yrs":
          case "yr":
          case "y":
            return n * y;

          case "days":
          case "day":
          case "d":
            return n * d;

          case "hours":
          case "hour":
          case "hrs":
          case "hr":
          case "h":
            return n * h;

          case "minutes":
          case "minute":
          case "mins":
          case "min":
          case "m":
            return n * m;

          case "seconds":
          case "second":
          case "secs":
          case "sec":
          case "s":
            return n * s;

          case "milliseconds":
          case "millisecond":
          case "msecs":
          case "msec":
          case "ms":
            return n;

          default:
            return undefined;
        }
    }
    function fmtShort(ms) {
        if (ms >= d) {
            return Math.round(ms / d) + "d";
        }
        if (ms >= h) {
            return Math.round(ms / h) + "h";
        }
        if (ms >= m) {
            return Math.round(ms / m) + "m";
        }
        if (ms >= s) {
            return Math.round(ms / s) + "s";
        }
        return ms + "ms";
    }
    function fmtLong(ms) {
        return plural(ms, d, "day") || plural(ms, h, "hour") || plural(ms, m, "minute") || plural(ms, s, "second") || ms + " ms";
    }
    function plural(ms, n, name) {
        if (ms < n) {
            return;
        }
        if (ms < n * 1.5) {
            return Math.floor(ms / n) + " " + name;
        }
        return Math.ceil(ms / n) + " " + name + "s";
    }
}, function(module, exports, __webpack_require__) {
    var tty = __webpack_require__(30);
    var util = __webpack_require__(1);
    exports = module.exports = __webpack_require__(102);
    exports.init = init;
    exports.log = log;
    exports.formatArgs = formatArgs;
    exports.save = save;
    exports.load = load;
    exports.useColors = useColors;
    exports.colors = [ 6, 2, 3, 4, 5, 1 ];
    try {
        var supportsColor = __webpack_require__(31);
        if (supportsColor && supportsColor.level >= 2) {
            exports.colors = [ 20, 21, 26, 27, 32, 33, 38, 39, 40, 41, 42, 43, 44, 45, 56, 57, 62, 63, 68, 69, 74, 75, 76, 77, 78, 79, 80, 81, 92, 93, 98, 99, 112, 113, 128, 129, 134, 135, 148, 149, 160, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 178, 179, 184, 185, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 214, 215, 220, 221 ];
        }
    } catch (err) {}
    exports.inspectOpts = Object.keys(process.env).filter((function(key) {
        return /^debug_/i.test(key);
    })).reduce((function(obj, key) {
        var prop = key.substring(6).toLowerCase().replace(/_([a-z])/g, (function(_, k) {
            return k.toUpperCase();
        }));
        var val = process.env[key];
        if (/^(yes|on|true|enabled)$/i.test(val)) val = true; else if (/^(no|off|false|disabled)$/i.test(val)) val = false; else if (val === "null") val = null; else val = Number(val);
        obj[prop] = val;
        return obj;
    }), {});
    function useColors() {
        return "colors" in exports.inspectOpts ? Boolean(exports.inspectOpts.colors) : tty.isatty(process.stderr.fd);
    }
    exports.formatters.o = function(v) {
        this.inspectOpts.colors = this.useColors;
        return util.inspect(v, this.inspectOpts).split("\n").map((function(str) {
            return str.trim();
        })).join(" ");
    };
    exports.formatters.O = function(v) {
        this.inspectOpts.colors = this.useColors;
        return util.inspect(v, this.inspectOpts);
    };
    function formatArgs(args) {
        var name = this.namespace;
        var useColors = this.useColors;
        if (useColors) {
            var c = this.color;
            var colorCode = "[3" + (c < 8 ? c : "8;5;" + c);
            var prefix = "  " + colorCode + ";1m" + name + " " + "[0m";
            args[0] = prefix + args[0].split("\n").join("\n" + prefix);
            args.push(colorCode + "m+" + exports.humanize(this.diff) + "[0m");
        } else {
            args[0] = getDate() + name + " " + args[0];
        }
    }
    function getDate() {
        if (exports.inspectOpts.hideDate) {
            return "";
        } else {
            return (new Date).toISOString() + " ";
        }
    }
    function log() {
        return process.stderr.write(util.format.apply(util, arguments) + "\n");
    }
    function save(namespaces) {
        if (null == namespaces) {
            delete process.env.DEBUG;
        } else {
            process.env.DEBUG = namespaces;
        }
    }
    function load() {
        return process.env.DEBUG;
    }
    function init(debug) {
        debug.inspectOpts = {};
        var keys = Object.keys(exports.inspectOpts);
        for (var i = 0; i < keys.length; i++) {
            debug.inspectOpts[keys[i]] = exports.inspectOpts[keys[i]];
        }
    }
    exports.enable(load());
}, function(module, exports) {
    module.exports = require("../package.json");
}, function(module, exports, __webpack_require__) {
    "use strict";
    var Cancel = __webpack_require__(104);
    function CancelToken(executor) {
        if (typeof executor !== "function") {
            throw new TypeError("executor must be a function.");
        }
        var resolvePromise;
        this.promise = new Promise((function promiseExecutor(resolve) {
            resolvePromise = resolve;
        }));
        var token = this;
        executor((function cancel(message) {
            if (token.reason) {
                return;
            }
            token.reason = new Cancel(message);
            resolvePromise(token.reason);
        }));
    }
    CancelToken.prototype.throwIfRequested = function throwIfRequested() {
        if (this.reason) {
            throw this.reason;
        }
    };
    CancelToken.source = function source() {
        var cancel;
        var token = new CancelToken((function executor(c) {
            cancel = c;
        }));
        return {
            token,
            cancel
        };
    };
    module.exports = CancelToken;
}, function(module, exports, __webpack_require__) {
    "use strict";
    module.exports = function spread(callback) {
        return function wrap(arr) {
            return callback.apply(null, arr);
        };
    };
}, function(module, exports) {
    module.exports = require("querystring");
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.BalenaS3Source = void 0;
    const axios_1 = __webpack_require__(42);
    const http_1 = __webpack_require__(91);
    const source_destination_1 = __webpack_require__(7);
    const zip_1 = __webpack_require__(105);
    class BalenaS3Source extends source_destination_1.SourceDestination {
        constructor(bucket, deviceType, version, host = "s3.amazonaws.com") {
            super();
            this.bucket = bucket;
            this.deviceType = deviceType;
            this.version = version;
            this.host = host;
            this.names = [ "balena", "resin" ];
            this.ready = this.prepare();
        }
        async prepare() {
            this.name = await this.getName();
            this.rawSource = new http_1.Http({
                url: this.getUrl(`image/${this.name}.img`)
            });
            this.zipSource = new zip_1.ZipSource(new http_1.Http({
                url: this.getUrl(`image/${this.name}.img.zip`),
                avoidRandomAccess: true
            }));
        }
        async getName() {
            for (const name of this.names) {
                try {
                    await axios_1.default({
                        method: "head",
                        url: this.getUrl(`image/${name}.img`)
                    });
                    return name;
                } catch (error) {
                    if (error.response.status !== 404) {
                        throw error;
                    }
                }
            }
            throw new Error("Could not find image");
        }
        async canCreateReadStream() {
            return true;
        }
        async canRead() {
            return true;
        }
        getUrl(path) {
            return `https://${this.bucket}.${this.host}/images/${this.deviceType}/${encodeURIComponent(this.version)}/${path}`;
        }
        async read(buffer, bufferOffset, length, sourceOffset) {
            await this.ready;
            return await this.rawSource.read(buffer, bufferOffset, length, sourceOffset);
        }
        async createReadStream(options = {}) {
            await this.ready;
            return await this.zipSource.createReadStream(options);
        }
        async _getMetadata() {
            await this.ready;
            return await this.zipSource.getMetadata();
        }
        async _open() {
            await this.ready;
            await Promise.all([ this.rawSource.open(), await this.zipSource.open() ]);
        }
        async _close() {
            await this.ready;
            await Promise.all([ this.zipSource.close(), await this.rawSource.close() ]);
        }
    }
    exports.BalenaS3Source = BalenaS3Source;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    const tslib_1 = __webpack_require__(22);
    tslib_1.__exportStar(__webpack_require__(106), exports);
    tslib_1.__exportStar(__webpack_require__(61), exports);
    tslib_1.__exportStar(__webpack_require__(223), exports);
    tslib_1.__exportStar(__webpack_require__(110), exports);
    tslib_1.__exportStar(__webpack_require__(111), exports);
    tslib_1.__exportStar(__webpack_require__(62), exports);
    tslib_1.__exportStar(__webpack_require__(224), exports);
    tslib_1.__exportStar(__webpack_require__(225), exports);
}, function(module, exports, __webpack_require__) {
    var helper = __webpack_require__(59);
    var xml2js = __webpack_require__(108);
    function validateOptions(userOptions) {
        var options = helper.copyOptions(userOptions);
        helper.ensureSpacesExists(options);
        return options;
    }
    module.exports = function(xml, userOptions) {
        var options, js, json, parentKey;
        options = validateOptions(userOptions);
        js = xml2js(xml, options);
        parentKey = "compact" in options && options.compact ? "_parent" : "parent";
        if ("addParent" in options && options.addParent) {
            json = JSON.stringify(js, (function(k, v) {
                return k === parentKey ? "_" : v;
            }), options.spaces);
        } else {
            json = JSON.stringify(js, null, options.spaces);
        }
        return json.replace(/\u2028/g, "\\u2028").replace(/\u2029/g, "\\u2029");
    };
}, function(module, exports, __webpack_require__) {
    var js2xml = __webpack_require__(109);
    module.exports = function(json, options) {
        if (json instanceof Buffer) {
            json = json.toString();
        }
        var js = null;
        if (typeof json === "string") {
            try {
                js = JSON.parse(json);
            } catch (e) {
                throw new Error("The JSON structure is invalid");
            }
        } else {
            js = json;
        }
        return js2xml(js, options);
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.FilterStream = void 0;
    const crypto_1 = __webpack_require__(20);
    const debug_1 = __webpack_require__(49);
    const stream_1 = __webpack_require__(0);
    const chunk_1 = __webpack_require__(61);
    const read_range_1 = __webpack_require__(62);
    const debug = debug_1.debug("blockmap:filterstream");
    class FilterStream extends stream_1.Transform {
        constructor(blockMap, verify = true, generateChecksums = false, chunkSize = 64 * 1024) {
            super({
                readableObjectMode: true
            });
            this.blockMap = blockMap;
            this.verify = verify;
            this.generateChecksums = generateChecksums;
            this.chunkSize = chunkSize;
            this.rangesRead = 0;
            this.rangesVerified = 0;
            this.blocksRead = 0;
            this.bytesRead = 0;
            this.blocksWritten = 0;
            this.bytesWritten = 0;
            this.position = 0;
            this._chunks = [];
            this._bytes = 0;
            if (verify && generateChecksums) {
                throw new Error("verify and generateChecksums options are mutually exclusive");
            }
            this.ranges = this._getByteRangesFromBlockMap();
            this.currentRange = this.ranges.shift();
            debug("range:next", this.currentRange);
            if (verify || generateChecksums) {
                this._hash = crypto_1.createHash(this.blockMap.checksumType);
            }
        }
        _getByteRangesFromBlockMap() {
            return this.blockMap.ranges.map(range => new read_range_1.ReadRange(range, this.blockMap.blockSize));
        }
        _verifyRange() {
            if (this._hash === undefined || this.currentRange === undefined) {
                return;
            }
            const digest = this._hash.digest("hex");
            debug("verify:checksum", this.currentRange.checksum);
            debug("verify:digest  ", digest);
            this._hash = crypto_1.createHash(this.blockMap.checksumType);
            if (this.verify && this.currentRange.checksum !== digest) {
                const error = new read_range_1.ReadRangeError(`Invalid checksum for range [${this.currentRange.startLBA},${this.currentRange.endLBA}], bytes ${this.currentRange.start}-${this.currentRange.end}`, this.currentRange, digest);
                this.emit("error", error);
                return;
            }
            if (this.generateChecksums) {
                this.currentRange.range.checksum = digest;
            } else {
                this.rangesVerified++;
            }
        }
        _rangeInChunk(chunk) {
            if (this.currentRange === undefined) {
                return false;
            }
            const rangeStart = this.currentRange.start + this.currentRange.offset;
            const isRangeInChunk = rangeStart >= this.position && rangeStart < this.position + chunk.length;
            debug("range-in-chunk", isRangeInChunk);
            return isRangeInChunk;
        }
        _transformBlock(chunk, next) {
            let start = 0;
            let end = 0;
            let length = 0;
            let block;
            while (this.currentRange && this._rangeInChunk(chunk)) {
                start = this.currentRange.start + this.currentRange.offset - this.position;
                end = start + this.currentRange.length - this.currentRange.offset;
                debug("slice", start, "-", end);
                block = new chunk_1.Chunk(chunk.slice(start, end), this.currentRange.start + this.currentRange.offset);
                if (end > chunk.length) {
                    length = chunk.length - start;
                    debug("chunk:partial", length);
                    if (length % this.blockMap.blockSize !== 0) {
                        debug("chunk:buffer", "length < block size");
                        this._chunks.push(block.buffer);
                        this._bytes += block.length;
                        this.position += chunk.length - block.length;
                        return process.nextTick(next);
                    }
                }
                this.currentRange.offset += block.length;
                this.bytesWritten += block.length;
                this.blocksWritten += block.length / this.blockMap.blockSize;
                debug("push", block.position, block.position / this.blockMap.blockSize, block);
                this.push(block);
                if (this._hash !== undefined) {
                    this._hash.update(block.buffer);
                }
                if (this.currentRange.length === this.currentRange.offset) {
                    this._verifyRange();
                    this.rangesRead++;
                    this.currentRange = this.currentRange = this.ranges.shift();
                    debug("range:next", this.currentRange);
                }
            }
            this.position += chunk.length;
            process.nextTick(next);
        }
        _transform(chunk, _encoding, next) {
            debug("position", this.position);
            debug("chunk", chunk.length, chunk);
            this.bytesRead += chunk.length;
            this.blocksRead += chunk.length / this.blockMap.blockSize;
            if (this.currentRange === undefined) {
                debug("no current range");
                this.position += chunk.length;
                return process.nextTick(next);
            }
            if (!this._rangeInChunk(chunk)) {
                debug("chunk:ignore");
                this.position += chunk.length;
                return process.nextTick(next);
            }
            if (this._bytes && this._bytes < this.chunkSize) {
                debug("chunk:buffer", "not enough bytes");
                this._chunks.push(chunk);
                this._bytes += chunk.length;
                return process.nextTick(next);
            }
            if (this._bytes) {
                debug("chunk:concat", this._bytes + chunk.length);
                this._chunks.push(chunk);
                this._bytes += chunk.length;
                chunk = Buffer.concat(this._chunks, this._bytes);
                this._chunks = [];
                this._bytes = 0;
            }
            this._transformBlock(chunk, next);
        }
        _flush(done) {
            if (this._bytes) {
                const chunk = Buffer.concat(this._chunks, this._bytes);
                this._chunks = [];
                this._bytes = 0;
                this._transformBlock(chunk, done);
            } else {
                done();
            }
        }
    }
    exports.FilterStream = FilterStream;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.ReadStream = void 0;
    const tslib_1 = __webpack_require__(22);
    const crypto_1 = __webpack_require__(20);
    const debug_1 = __webpack_require__(49);
    const fs_1 = __webpack_require__(3);
    const stream_1 = __webpack_require__(0);
    const chunk_1 = __webpack_require__(61);
    const read_range_1 = __webpack_require__(62);
    const debug = debug_1.debug("blockmap:readstream");
    class ReadStream extends stream_1.Readable {
        constructor(fdOrReadFn, blockMap, verify = true, generateChecksums = false, start = 0, end = Infinity, chunkSize = 64 * 1024) {
            super({
                objectMode: true
            });
            this.blockMap = blockMap;
            this.verify = verify;
            this.generateChecksums = generateChecksums;
            this.start = start;
            this.end = end;
            this.chunkSize = chunkSize;
            this.rangesRead = 0;
            this.rangesVerified = 0;
            this.blocksRead = 0;
            this.bytesRead = 0;
            this.position = 0;
            if (verify && generateChecksums) {
                throw new Error("verify and generateChecksums options are mutually exclusive");
            }
            if (start < 0) {
                throw new Error("Start must not be negative");
            }
            if (start > end) {
                throw new Error("Start must be less or equal to end");
            }
            if (verify || generateChecksums) {
                this._hash = crypto_1.createHash(blockMap.checksumType);
            }
            this.ranges = this._prepareRanges();
            if (typeof fdOrReadFn === "number") {
                this.readFn = (buf, offset, length, position) => new Promise((resolve, reject) => {
                    fs_1.read(fdOrReadFn, buf, offset, length, position, (error, bytesRead, buffer) => {
                        if (error) {
                            reject(error);
                        } else {
                            resolve({
                                bytesRead,
                                buffer
                            });
                        }
                    });
                });
            } else {
                this.readFn = fdOrReadFn;
            }
        }
        _prepareRanges() {
            return this.blockMap.ranges.map(range => {
                const readRange = new read_range_1.ReadRange(range, this.blockMap.blockSize);
                readRange.start += this.start;
                readRange.end += this.start;
                return readRange;
            }).filter(readRange => readRange.end <= this.end + this.start);
        }
        _verifyRange() {
            if (this.currentRange === undefined || this._hash === undefined) {
                return;
            }
            const digest = this._hash.digest("hex");
            debug("verify:checksum", this.currentRange.checksum);
            debug("verify:digest  ", digest);
            this._hash = crypto_1.createHash(this.blockMap.checksumType);
            if (this.verify && this.currentRange.checksum !== digest) {
                const error = new read_range_1.ReadRangeError(`Invalid checksum for range [${this.currentRange.startLBA},${this.currentRange.endLBA}], bytes ${this.currentRange.start}-${this.currentRange.end}`, this.currentRange, digest);
                this.emit("error", error);
            }
            if (this.generateChecksums) {
                this.currentRange.range.checksum = digest;
            } else {
                this.rangesVerified++;
            }
        }
        _readBlock() {
            return tslib_1.__awaiter(this, void 0, void 0, (function*() {
                if (this.currentRange === undefined) {
                    return;
                }
                const length = Math.min(this.currentRange.length - this.currentRange.offset, this.chunkSize);
                const position = this.currentRange.start + this.currentRange.offset;
                const chunk = new chunk_1.Chunk(Buffer.allocUnsafe(length), position);
                debug("read-block:position", position);
                debug("read-block:length", length);
                try {
                    const {bytesRead} = yield this.readFn(chunk.buffer, 0, length, position);
                    if (bytesRead !== length) {
                        throw new Error(`Bytes read mismatch: ${bytesRead} != ${length}`);
                    }
                    this.currentRange.offset += bytesRead;
                    this.blocksRead += bytesRead / this.blockMap.blockSize;
                    this.bytesRead += bytesRead;
                    this.position += bytesRead;
                    debug("read-block:blocksRead", this.blocksRead);
                    if (this._hash !== undefined) {
                        this._hash.update(chunk.buffer);
                    }
                    this.push(chunk);
                } catch (error) {
                    this.emit("error", error);
                }
            }));
        }
        _advanceRange() {
            return tslib_1.__awaiter(this, void 0, void 0, (function*() {
                if (this.ranges.length > 0) {
                    this.currentRange = this.ranges.shift();
                    this.rangesRead++;
                    debug("read:range %O", this.currentRange);
                    yield this._readBlock();
                } else {
                    this.push(null);
                }
            }));
        }
        _read() {
            return tslib_1.__awaiter(this, void 0, void 0, (function*() {
                if (this.currentRange === undefined) {
                    yield this._advanceRange();
                } else if (this.currentRange.offset === this.currentRange.length) {
                    this._verifyRange();
                    yield this._advanceRange();
                } else {
                    yield this._readBlock();
                }
            }));
        }
    }
    exports.ReadStream = ReadStream;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.withOpenFile = void 0;
    const tslib_1 = __webpack_require__(22);
    const fs = __webpack_require__(3);
    function open(filename) {
        return new Promise((resolve, reject) => {
            fs.open(filename, "r", (error, fd) => {
                if (error) {
                    reject(error);
                } else {
                    resolve(fd);
                }
            });
        });
    }
    function close(fd) {
        return new Promise((resolve, reject) => {
            fs.close(fd, error => {
                if (error) {
                    reject(error);
                } else {
                    resolve();
                }
            });
        });
    }
    function withOpenFile(filename, fn) {
        return tslib_1.__awaiter(this, void 0, void 0, (function*() {
            const fd = yield open(filename);
            try {
                yield fn(fd);
            } finally {
                yield close(fd);
            }
        }));
    }
    exports.withOpenFile = withOpenFile;
}, function(module, exports, __webpack_require__) {
    var fs = __webpack_require__(3);
    var zlib = __webpack_require__(18);
    var fd_slicer = __webpack_require__(227);
    var crc32 = __webpack_require__(229);
    var util = __webpack_require__(1);
    var EventEmitter = __webpack_require__(9).EventEmitter;
    var Transform = __webpack_require__(0).Transform;
    var PassThrough = __webpack_require__(0).PassThrough;
    var Writable = __webpack_require__(0).Writable;
    exports.open = open;
    exports.fromFd = fromFd;
    exports.fromBuffer = fromBuffer;
    exports.fromRandomAccessReader = fromRandomAccessReader;
    exports.dosDateTimeToDate = dosDateTimeToDate;
    exports.validateFileName = validateFileName;
    exports.ZipFile = ZipFile;
    exports.Entry = Entry;
    exports.RandomAccessReader = RandomAccessReader;
    function open(path, options, callback) {
        if (typeof options === "function") {
            callback = options;
            options = null;
        }
        if (options == null) options = {};
        if (options.autoClose == null) options.autoClose = true;
        if (options.lazyEntries == null) options.lazyEntries = false;
        if (options.decodeStrings == null) options.decodeStrings = true;
        if (options.validateEntrySizes == null) options.validateEntrySizes = true;
        if (options.strictFileNames == null) options.strictFileNames = false;
        if (callback == null) callback = defaultCallback;
        fs.open(path, "r", (function(err, fd) {
            if (err) return callback(err);
            fromFd(fd, options, (function(err, zipfile) {
                if (err) fs.close(fd, defaultCallback);
                callback(err, zipfile);
            }));
        }));
    }
    function fromFd(fd, options, callback) {
        if (typeof options === "function") {
            callback = options;
            options = null;
        }
        if (options == null) options = {};
        if (options.autoClose == null) options.autoClose = false;
        if (options.lazyEntries == null) options.lazyEntries = false;
        if (options.decodeStrings == null) options.decodeStrings = true;
        if (options.validateEntrySizes == null) options.validateEntrySizes = true;
        if (options.strictFileNames == null) options.strictFileNames = false;
        if (callback == null) callback = defaultCallback;
        fs.fstat(fd, (function(err, stats) {
            if (err) return callback(err);
            var reader = fd_slicer.createFromFd(fd, {
                autoClose: true
            });
            fromRandomAccessReader(reader, stats.size, options, callback);
        }));
    }
    function fromBuffer(buffer, options, callback) {
        if (typeof options === "function") {
            callback = options;
            options = null;
        }
        if (options == null) options = {};
        options.autoClose = false;
        if (options.lazyEntries == null) options.lazyEntries = false;
        if (options.decodeStrings == null) options.decodeStrings = true;
        if (options.validateEntrySizes == null) options.validateEntrySizes = true;
        if (options.strictFileNames == null) options.strictFileNames = false;
        var reader = fd_slicer.createFromBuffer(buffer, {
            maxChunkSize: 65536
        });
        fromRandomAccessReader(reader, buffer.length, options, callback);
    }
    function fromRandomAccessReader(reader, totalSize, options, callback) {
        if (typeof options === "function") {
            callback = options;
            options = null;
        }
        if (options == null) options = {};
        if (options.autoClose == null) options.autoClose = true;
        if (options.lazyEntries == null) options.lazyEntries = false;
        if (options.decodeStrings == null) options.decodeStrings = true;
        var decodeStrings = !!options.decodeStrings;
        if (options.validateEntrySizes == null) options.validateEntrySizes = true;
        if (options.strictFileNames == null) options.strictFileNames = false;
        if (callback == null) callback = defaultCallback;
        if (typeof totalSize !== "number") throw new Error("expected totalSize parameter to be a number");
        if (totalSize > Number.MAX_SAFE_INTEGER) {
            throw new Error("zip file too large. only file sizes up to 2^52 are supported due to JavaScript's Number type being an IEEE 754 double.");
        }
        reader.ref();
        var eocdrWithoutCommentSize = 22;
        var maxCommentSize = 65535;
        var bufferSize = Math.min(eocdrWithoutCommentSize + maxCommentSize, totalSize);
        var buffer = newBuffer(bufferSize);
        var bufferReadStart = totalSize - buffer.length;
        readAndAssertNoEof(reader, buffer, 0, bufferSize, bufferReadStart, (function(err) {
            if (err) return callback(err);
            for (var i = bufferSize - eocdrWithoutCommentSize; i >= 0; i -= 1) {
                if (buffer.readUInt32LE(i) !== 101010256) continue;
                var eocdrBuffer = buffer.slice(i);
                var diskNumber = eocdrBuffer.readUInt16LE(4);
                if (diskNumber !== 0) {
                    return callback(new Error("multi-disk zip files are not supported: found disk number: " + diskNumber));
                }
                var entryCount = eocdrBuffer.readUInt16LE(10);
                var centralDirectoryOffset = eocdrBuffer.readUInt32LE(16);
                var commentLength = eocdrBuffer.readUInt16LE(20);
                var expectedCommentLength = eocdrBuffer.length - eocdrWithoutCommentSize;
                if (commentLength !== expectedCommentLength) {
                    return callback(new Error("invalid comment length. expected: " + expectedCommentLength + ". found: " + commentLength));
                }
                var comment = decodeStrings ? decodeBuffer(eocdrBuffer, 22, eocdrBuffer.length, false) : eocdrBuffer.slice(22);
                if (!(entryCount === 65535 || centralDirectoryOffset === 4294967295)) {
                    return callback(null, new ZipFile(reader, centralDirectoryOffset, totalSize, entryCount, comment, options.autoClose, options.lazyEntries, decodeStrings, options.validateEntrySizes, options.strictFileNames));
                }
                var zip64EocdlBuffer = newBuffer(20);
                var zip64EocdlOffset = bufferReadStart + i - zip64EocdlBuffer.length;
                readAndAssertNoEof(reader, zip64EocdlBuffer, 0, zip64EocdlBuffer.length, zip64EocdlOffset, (function(err) {
                    if (err) return callback(err);
                    if (zip64EocdlBuffer.readUInt32LE(0) !== 117853008) {
                        return callback(new Error("invalid zip64 end of central directory locator signature"));
                    }
                    var zip64EocdrOffset = readUInt64LE(zip64EocdlBuffer, 8);
                    var zip64EocdrBuffer = newBuffer(56);
                    readAndAssertNoEof(reader, zip64EocdrBuffer, 0, zip64EocdrBuffer.length, zip64EocdrOffset, (function(err) {
                        if (err) return callback(err);
                        if (zip64EocdrBuffer.readUInt32LE(0) !== 101075792) {
                            return callback(new Error("invalid zip64 end of central directory record signature"));
                        }
                        entryCount = readUInt64LE(zip64EocdrBuffer, 32);
                        centralDirectoryOffset = readUInt64LE(zip64EocdrBuffer, 48);
                        return callback(null, new ZipFile(reader, centralDirectoryOffset, totalSize, entryCount, comment, options.autoClose, options.lazyEntries, decodeStrings, options.validateEntrySizes, options.strictFileNames));
                    }));
                }));
                return;
            }
            callback(new Error("end of central directory record signature not found"));
        }));
    }
    util.inherits(ZipFile, EventEmitter);
    function ZipFile(reader, centralDirectoryOffset, fileSize, entryCount, comment, autoClose, lazyEntries, decodeStrings, validateEntrySizes, strictFileNames) {
        var self = this;
        EventEmitter.call(self);
        self.reader = reader;
        self.reader.on("error", (function(err) {
            emitError(self, err);
        }));
        self.reader.once("close", (function() {
            self.emit("close");
        }));
        self.readEntryCursor = centralDirectoryOffset;
        self.fileSize = fileSize;
        self.entryCount = entryCount;
        self.comment = comment;
        self.entriesRead = 0;
        self.autoClose = !!autoClose;
        self.lazyEntries = !!lazyEntries;
        self.decodeStrings = !!decodeStrings;
        self.validateEntrySizes = !!validateEntrySizes;
        self.strictFileNames = !!strictFileNames;
        self.isOpen = true;
        self.emittedError = false;
        if (!self.lazyEntries) self._readEntry();
    }
    ZipFile.prototype.close = function() {
        if (!this.isOpen) return;
        this.isOpen = false;
        this.reader.unref();
    };
    function emitErrorAndAutoClose(self, err) {
        if (self.autoClose) self.close();
        emitError(self, err);
    }
    function emitError(self, err) {
        if (self.emittedError) return;
        self.emittedError = true;
        self.emit("error", err);
    }
    ZipFile.prototype.readEntry = function() {
        if (!this.lazyEntries) throw new Error("readEntry() called without lazyEntries:true");
        this._readEntry();
    };
    ZipFile.prototype._readEntry = function() {
        var self = this;
        if (self.entryCount === self.entriesRead) {
            setImmediate((function() {
                if (self.autoClose) self.close();
                if (self.emittedError) return;
                self.emit("end");
            }));
            return;
        }
        if (self.emittedError) return;
        var buffer = newBuffer(46);
        readAndAssertNoEof(self.reader, buffer, 0, buffer.length, self.readEntryCursor, (function(err) {
            if (err) return emitErrorAndAutoClose(self, err);
            if (self.emittedError) return;
            var entry = new Entry;
            var signature = buffer.readUInt32LE(0);
            if (signature !== 33639248) return emitErrorAndAutoClose(self, new Error("invalid central directory file header signature: 0x" + signature.toString(16)));
            entry.versionMadeBy = buffer.readUInt16LE(4);
            entry.versionNeededToExtract = buffer.readUInt16LE(6);
            entry.generalPurposeBitFlag = buffer.readUInt16LE(8);
            entry.compressionMethod = buffer.readUInt16LE(10);
            entry.lastModFileTime = buffer.readUInt16LE(12);
            entry.lastModFileDate = buffer.readUInt16LE(14);
            entry.crc32 = buffer.readUInt32LE(16);
            entry.compressedSize = buffer.readUInt32LE(20);
            entry.uncompressedSize = buffer.readUInt32LE(24);
            entry.fileNameLength = buffer.readUInt16LE(28);
            entry.extraFieldLength = buffer.readUInt16LE(30);
            entry.fileCommentLength = buffer.readUInt16LE(32);
            entry.internalFileAttributes = buffer.readUInt16LE(36);
            entry.externalFileAttributes = buffer.readUInt32LE(38);
            entry.relativeOffsetOfLocalHeader = buffer.readUInt32LE(42);
            if (entry.generalPurposeBitFlag & 64) return emitErrorAndAutoClose(self, new Error("strong encryption is not supported"));
            self.readEntryCursor += 46;
            buffer = newBuffer(entry.fileNameLength + entry.extraFieldLength + entry.fileCommentLength);
            readAndAssertNoEof(self.reader, buffer, 0, buffer.length, self.readEntryCursor, (function(err) {
                if (err) return emitErrorAndAutoClose(self, err);
                if (self.emittedError) return;
                var isUtf8 = (entry.generalPurposeBitFlag & 2048) !== 0;
                entry.fileName = self.decodeStrings ? decodeBuffer(buffer, 0, entry.fileNameLength, isUtf8) : buffer.slice(0, entry.fileNameLength);
                var fileCommentStart = entry.fileNameLength + entry.extraFieldLength;
                var extraFieldBuffer = buffer.slice(entry.fileNameLength, fileCommentStart);
                entry.extraFields = [];
                var i = 0;
                while (i < extraFieldBuffer.length - 3) {
                    var headerId = extraFieldBuffer.readUInt16LE(i + 0);
                    var dataSize = extraFieldBuffer.readUInt16LE(i + 2);
                    var dataStart = i + 4;
                    var dataEnd = dataStart + dataSize;
                    if (dataEnd > extraFieldBuffer.length) return emitErrorAndAutoClose(self, new Error("extra field length exceeds extra field buffer size"));
                    var dataBuffer = newBuffer(dataSize);
                    extraFieldBuffer.copy(dataBuffer, 0, dataStart, dataEnd);
                    entry.extraFields.push({
                        id: headerId,
                        data: dataBuffer
                    });
                    i = dataEnd;
                }
                entry.fileComment = self.decodeStrings ? decodeBuffer(buffer, fileCommentStart, fileCommentStart + entry.fileCommentLength, isUtf8) : buffer.slice(fileCommentStart, fileCommentStart + entry.fileCommentLength);
                entry.comment = entry.fileComment;
                self.readEntryCursor += buffer.length;
                self.entriesRead += 1;
                if (entry.uncompressedSize === 4294967295 || entry.compressedSize === 4294967295 || entry.relativeOffsetOfLocalHeader === 4294967295) {
                    var zip64EiefBuffer = null;
                    for (var i = 0; i < entry.extraFields.length; i++) {
                        var extraField = entry.extraFields[i];
                        if (extraField.id === 1) {
                            zip64EiefBuffer = extraField.data;
                            break;
                        }
                    }
                    if (zip64EiefBuffer == null) {
                        return emitErrorAndAutoClose(self, new Error("expected zip64 extended information extra field"));
                    }
                    var index = 0;
                    if (entry.uncompressedSize === 4294967295) {
                        if (index + 8 > zip64EiefBuffer.length) {
                            return emitErrorAndAutoClose(self, new Error("zip64 extended information extra field does not include uncompressed size"));
                        }
                        entry.uncompressedSize = readUInt64LE(zip64EiefBuffer, index);
                        index += 8;
                    }
                    if (entry.compressedSize === 4294967295) {
                        if (index + 8 > zip64EiefBuffer.length) {
                            return emitErrorAndAutoClose(self, new Error("zip64 extended information extra field does not include compressed size"));
                        }
                        entry.compressedSize = readUInt64LE(zip64EiefBuffer, index);
                        index += 8;
                    }
                    if (entry.relativeOffsetOfLocalHeader === 4294967295) {
                        if (index + 8 > zip64EiefBuffer.length) {
                            return emitErrorAndAutoClose(self, new Error("zip64 extended information extra field does not include relative header offset"));
                        }
                        entry.relativeOffsetOfLocalHeader = readUInt64LE(zip64EiefBuffer, index);
                        index += 8;
                    }
                }
                if (self.decodeStrings) {
                    for (var i = 0; i < entry.extraFields.length; i++) {
                        var extraField = entry.extraFields[i];
                        if (extraField.id === 28789) {
                            if (extraField.data.length < 6) {
                                continue;
                            }
                            if (extraField.data.readUInt8(0) !== 1) {
                                continue;
                            }
                            var oldNameCrc32 = extraField.data.readUInt32LE(1);
                            if (crc32.unsigned(buffer.slice(0, entry.fileNameLength)) !== oldNameCrc32) {
                                continue;
                            }
                            entry.fileName = decodeBuffer(extraField.data, 5, extraField.data.length, true);
                            break;
                        }
                    }
                }
                if (self.validateEntrySizes && entry.compressionMethod === 0) {
                    var expectedCompressedSize = entry.uncompressedSize;
                    if (entry.isEncrypted()) {
                        expectedCompressedSize += 12;
                    }
                    if (entry.compressedSize !== expectedCompressedSize) {
                        var msg = "compressed/uncompressed size mismatch for stored file: " + entry.compressedSize + " != " + entry.uncompressedSize;
                        return emitErrorAndAutoClose(self, new Error(msg));
                    }
                }
                if (self.decodeStrings) {
                    if (!self.strictFileNames) {
                        entry.fileName = entry.fileName.replace(/\\/g, "/");
                    }
                    var errorMessage = validateFileName(entry.fileName, self.validateFileNameOptions);
                    if (errorMessage != null) return emitErrorAndAutoClose(self, new Error(errorMessage));
                }
                self.emit("entry", entry);
                if (!self.lazyEntries) self._readEntry();
            }));
        }));
    };
    ZipFile.prototype.openReadStream = function(entry, options, callback) {
        var self = this;
        var relativeStart = 0;
        var relativeEnd = entry.compressedSize;
        if (callback == null) {
            callback = options;
            options = {};
        } else {
            if (options.decrypt != null) {
                if (!entry.isEncrypted()) {
                    throw new Error("options.decrypt can only be specified for encrypted entries");
                }
                if (options.decrypt !== false) throw new Error("invalid options.decrypt value: " + options.decrypt);
                if (entry.isCompressed()) {
                    if (options.decompress !== false) throw new Error("entry is encrypted and compressed, and options.decompress !== false");
                }
            }
            if (options.decompress != null) {
                if (!entry.isCompressed()) {
                    throw new Error("options.decompress can only be specified for compressed entries");
                }
                if (!(options.decompress === false || options.decompress === true)) {
                    throw new Error("invalid options.decompress value: " + options.decompress);
                }
            }
            if (options.start != null || options.end != null) {
                if (entry.isCompressed() && options.decompress !== false) {
                    throw new Error("start/end range not allowed for compressed entry without options.decompress === false");
                }
                if (entry.isEncrypted() && options.decrypt !== false) {
                    throw new Error("start/end range not allowed for encrypted entry without options.decrypt === false");
                }
            }
            if (options.start != null) {
                relativeStart = options.start;
                if (relativeStart < 0) throw new Error("options.start < 0");
                if (relativeStart > entry.compressedSize) throw new Error("options.start > entry.compressedSize");
            }
            if (options.end != null) {
                relativeEnd = options.end;
                if (relativeEnd < 0) throw new Error("options.end < 0");
                if (relativeEnd > entry.compressedSize) throw new Error("options.end > entry.compressedSize");
                if (relativeEnd < relativeStart) throw new Error("options.end < options.start");
            }
        }
        if (!self.isOpen) return callback(new Error("closed"));
        if (entry.isEncrypted()) {
            if (options.decrypt !== false) return callback(new Error("entry is encrypted, and options.decrypt !== false"));
        }
        self.reader.ref();
        var buffer = newBuffer(30);
        readAndAssertNoEof(self.reader, buffer, 0, buffer.length, entry.relativeOffsetOfLocalHeader, (function(err) {
            try {
                if (err) return callback(err);
                var signature = buffer.readUInt32LE(0);
                if (signature !== 67324752) {
                    return callback(new Error("invalid local file header signature: 0x" + signature.toString(16)));
                }
                var fileNameLength = buffer.readUInt16LE(26);
                var extraFieldLength = buffer.readUInt16LE(28);
                var localFileHeaderEnd = entry.relativeOffsetOfLocalHeader + buffer.length + fileNameLength + extraFieldLength;
                var decompress;
                if (entry.compressionMethod === 0) {
                    decompress = false;
                } else if (entry.compressionMethod === 8) {
                    decompress = options.decompress != null ? options.decompress : true;
                } else {
                    return callback(new Error("unsupported compression method: " + entry.compressionMethod));
                }
                var fileDataStart = localFileHeaderEnd;
                var fileDataEnd = fileDataStart + entry.compressedSize;
                if (entry.compressedSize !== 0) {
                    if (fileDataEnd > self.fileSize) {
                        return callback(new Error("file data overflows file bounds: " + fileDataStart + " + " + entry.compressedSize + " > " + self.fileSize));
                    }
                }
                var readStream = self.reader.createReadStream({
                    start: fileDataStart + relativeStart,
                    end: fileDataStart + relativeEnd
                });
                var endpointStream = readStream;
                if (decompress) {
                    var destroyed = false;
                    var inflateFilter = zlib.createInflateRaw();
                    readStream.on("error", (function(err) {
                        setImmediate((function() {
                            if (!destroyed) inflateFilter.emit("error", err);
                        }));
                    }));
                    readStream.pipe(inflateFilter);
                    if (self.validateEntrySizes) {
                        endpointStream = new AssertByteCountStream(entry.uncompressedSize);
                        inflateFilter.on("error", (function(err) {
                            setImmediate((function() {
                                if (!destroyed) endpointStream.emit("error", err);
                            }));
                        }));
                        inflateFilter.pipe(endpointStream);
                    } else {
                        endpointStream = inflateFilter;
                    }
                    endpointStream.destroy = function() {
                        destroyed = true;
                        if (inflateFilter !== endpointStream) inflateFilter.unpipe(endpointStream);
                        readStream.unpipe(inflateFilter);
                        readStream.destroy();
                    };
                }
                callback(null, endpointStream);
            } finally {
                self.reader.unref();
            }
        }));
    };
    function Entry() {}
    Entry.prototype.getLastModDate = function() {
        return dosDateTimeToDate(this.lastModFileDate, this.lastModFileTime);
    };
    Entry.prototype.isEncrypted = function() {
        return (this.generalPurposeBitFlag & 1) !== 0;
    };
    Entry.prototype.isCompressed = function() {
        return this.compressionMethod === 8;
    };
    function dosDateTimeToDate(date, time) {
        var day = date & 31;
        var month = (date >> 5 & 15) - 1;
        var year = (date >> 9 & 127) + 1980;
        var millisecond = 0;
        var second = (time & 31) * 2;
        var minute = time >> 5 & 63;
        var hour = time >> 11 & 31;
        return new Date(year, month, day, hour, minute, second, millisecond);
    }
    function validateFileName(fileName) {
        if (fileName.indexOf("\\") !== -1) {
            return "invalid characters in fileName: " + fileName;
        }
        if (/^[a-zA-Z]:/.test(fileName) || /^\//.test(fileName)) {
            return "absolute path: " + fileName;
        }
        if (fileName.split("/").indexOf("..") !== -1) {
            return "invalid relative path: " + fileName;
        }
        return null;
    }
    function readAndAssertNoEof(reader, buffer, offset, length, position, callback) {
        if (length === 0) {
            return setImmediate((function() {
                callback(null, newBuffer(0));
            }));
        }
        reader.read(buffer, offset, length, position, (function(err, bytesRead) {
            if (err) return callback(err);
            if (bytesRead < length) {
                return callback(new Error("unexpected EOF"));
            }
            callback();
        }));
    }
    util.inherits(AssertByteCountStream, Transform);
    function AssertByteCountStream(byteCount) {
        Transform.call(this);
        this.actualByteCount = 0;
        this.expectedByteCount = byteCount;
    }
    AssertByteCountStream.prototype._transform = function(chunk, encoding, cb) {
        this.actualByteCount += chunk.length;
        if (this.actualByteCount > this.expectedByteCount) {
            var msg = "too many bytes in the stream. expected " + this.expectedByteCount + ". got at least " + this.actualByteCount;
            return cb(new Error(msg));
        }
        cb(null, chunk);
    };
    AssertByteCountStream.prototype._flush = function(cb) {
        if (this.actualByteCount < this.expectedByteCount) {
            var msg = "not enough bytes in the stream. expected " + this.expectedByteCount + ". got only " + this.actualByteCount;
            return cb(new Error(msg));
        }
        cb();
    };
    util.inherits(RandomAccessReader, EventEmitter);
    function RandomAccessReader() {
        EventEmitter.call(this);
        this.refCount = 0;
    }
    RandomAccessReader.prototype.ref = function() {
        this.refCount += 1;
    };
    RandomAccessReader.prototype.unref = function() {
        var self = this;
        self.refCount -= 1;
        if (self.refCount > 0) return;
        if (self.refCount < 0) throw new Error("invalid unref");
        self.close(onCloseDone);
        function onCloseDone(err) {
            if (err) return self.emit("error", err);
            self.emit("close");
        }
    };
    RandomAccessReader.prototype.createReadStream = function(options) {
        var start = options.start;
        var end = options.end;
        if (start === end) {
            var emptyStream = new PassThrough;
            setImmediate((function() {
                emptyStream.end();
            }));
            return emptyStream;
        }
        var stream = this._readStreamForRange(start, end);
        var destroyed = false;
        var refUnrefFilter = new RefUnrefFilter(this);
        stream.on("error", (function(err) {
            setImmediate((function() {
                if (!destroyed) refUnrefFilter.emit("error", err);
            }));
        }));
        refUnrefFilter.destroy = function() {
            stream.unpipe(refUnrefFilter);
            refUnrefFilter.unref();
            stream.destroy();
        };
        var byteCounter = new AssertByteCountStream(end - start);
        refUnrefFilter.on("error", (function(err) {
            setImmediate((function() {
                if (!destroyed) byteCounter.emit("error", err);
            }));
        }));
        byteCounter.destroy = function() {
            destroyed = true;
            refUnrefFilter.unpipe(byteCounter);
            refUnrefFilter.destroy();
        };
        return stream.pipe(refUnrefFilter).pipe(byteCounter);
    };
    RandomAccessReader.prototype._readStreamForRange = function(start, end) {
        throw new Error("not implemented");
    };
    RandomAccessReader.prototype.read = function(buffer, offset, length, position, callback) {
        var readStream = this.createReadStream({
            start: position,
            end: position + length
        });
        var writeStream = new Writable;
        var written = 0;
        writeStream._write = function(chunk, encoding, cb) {
            chunk.copy(buffer, offset + written, 0, chunk.length);
            written += chunk.length;
            cb();
        };
        writeStream.on("finish", callback);
        readStream.on("error", (function(error) {
            callback(error);
        }));
        readStream.pipe(writeStream);
    };
    RandomAccessReader.prototype.close = function(callback) {
        setImmediate(callback);
    };
    util.inherits(RefUnrefFilter, PassThrough);
    function RefUnrefFilter(context) {
        PassThrough.call(this);
        this.context = context;
        this.context.ref();
        this.unreffedYet = false;
    }
    RefUnrefFilter.prototype._flush = function(cb) {
        this.unref();
        cb();
    };
    RefUnrefFilter.prototype.unref = function(cb) {
        if (this.unreffedYet) return;
        this.unreffedYet = true;
        this.context.unref();
    };
    var cp437 = "\0☺☻♥♦♣♠•◘○◙♂♀♪♫☼►◄↕‼¶§▬↨↑↓→←∟↔▲▼ !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~⌂ÇüéâäàåçêëèïîìÄÅÉæÆôöòûùÿÖÜ¢£¥₧ƒáíóúñÑªº¿⌐¬½¼¡«»░▒▓│┤╡╢╖╕╣║╗╝╜╛┐└┴┬├─┼╞╟╚╔╩╦╠═╬╧╨╤╥╙╘╒╓╫╪┘┌█▄▌▐▀αßΓπΣσµτΦΘΩδ∞φε∩≡±≥≤⌠⌡÷≈°∙·√ⁿ²■ ";
    function decodeBuffer(buffer, start, end, isUtf8) {
        if (isUtf8) {
            return buffer.toString("utf8", start, end);
        } else {
            var result = "";
            for (var i = start; i < end; i++) {
                result += cp437[buffer[i]];
            }
            return result;
        }
    }
    function readUInt64LE(buffer, offset) {
        var lower32 = buffer.readUInt32LE(offset);
        var upper32 = buffer.readUInt32LE(offset + 4);
        return upper32 * 4294967296 + lower32;
    }
    var newBuffer;
    if (typeof Buffer.allocUnsafe === "function") {
        newBuffer = function(len) {
            return Buffer.allocUnsafe(len);
        };
    } else {
        newBuffer = function(len) {
            return new Buffer(len);
        };
    }
    function defaultCallback(err) {
        if (err) throw err;
    }
}, function(module, exports, __webpack_require__) {
    var fs = __webpack_require__(3);
    var util = __webpack_require__(1);
    var stream = __webpack_require__(0);
    var Readable = stream.Readable;
    var Writable = stream.Writable;
    var PassThrough = stream.PassThrough;
    var Pend = __webpack_require__(228);
    var EventEmitter = __webpack_require__(9).EventEmitter;
    exports.createFromBuffer = createFromBuffer;
    exports.createFromFd = createFromFd;
    exports.BufferSlicer = BufferSlicer;
    exports.FdSlicer = FdSlicer;
    util.inherits(FdSlicer, EventEmitter);
    function FdSlicer(fd, options) {
        options = options || {};
        EventEmitter.call(this);
        this.fd = fd;
        this.pend = new Pend;
        this.pend.max = 1;
        this.refCount = 0;
        this.autoClose = !!options.autoClose;
    }
    FdSlicer.prototype.read = function(buffer, offset, length, position, callback) {
        var self = this;
        self.pend.go((function(cb) {
            fs.read(self.fd, buffer, offset, length, position, (function(err, bytesRead, buffer) {
                cb();
                callback(err, bytesRead, buffer);
            }));
        }));
    };
    FdSlicer.prototype.write = function(buffer, offset, length, position, callback) {
        var self = this;
        self.pend.go((function(cb) {
            fs.write(self.fd, buffer, offset, length, position, (function(err, written, buffer) {
                cb();
                callback(err, written, buffer);
            }));
        }));
    };
    FdSlicer.prototype.createReadStream = function(options) {
        return new ReadStream(this, options);
    };
    FdSlicer.prototype.createWriteStream = function(options) {
        return new WriteStream(this, options);
    };
    FdSlicer.prototype.ref = function() {
        this.refCount += 1;
    };
    FdSlicer.prototype.unref = function() {
        var self = this;
        self.refCount -= 1;
        if (self.refCount > 0) return;
        if (self.refCount < 0) throw new Error("invalid unref");
        if (self.autoClose) {
            fs.close(self.fd, onCloseDone);
        }
        function onCloseDone(err) {
            if (err) {
                self.emit("error", err);
            } else {
                self.emit("close");
            }
        }
    };
    util.inherits(ReadStream, Readable);
    function ReadStream(context, options) {
        options = options || {};
        Readable.call(this, options);
        this.context = context;
        this.context.ref();
        this.start = options.start || 0;
        this.endOffset = options.end;
        this.pos = this.start;
        this.destroyed = false;
    }
    ReadStream.prototype._read = function(n) {
        var self = this;
        if (self.destroyed) return;
        var toRead = Math.min(self._readableState.highWaterMark, n);
        if (self.endOffset != null) {
            toRead = Math.min(toRead, self.endOffset - self.pos);
        }
        if (toRead <= 0) {
            self.destroyed = true;
            self.push(null);
            self.context.unref();
            return;
        }
        self.context.pend.go((function(cb) {
            if (self.destroyed) return cb();
            var buffer = new Buffer(toRead);
            fs.read(self.context.fd, buffer, 0, toRead, self.pos, (function(err, bytesRead) {
                if (err) {
                    self.destroy(err);
                } else if (bytesRead === 0) {
                    self.destroyed = true;
                    self.push(null);
                    self.context.unref();
                } else {
                    self.pos += bytesRead;
                    self.push(buffer.slice(0, bytesRead));
                }
                cb();
            }));
        }));
    };
    ReadStream.prototype.destroy = function(err) {
        if (this.destroyed) return;
        err = err || new Error("stream destroyed");
        this.destroyed = true;
        this.emit("error", err);
        this.context.unref();
    };
    util.inherits(WriteStream, Writable);
    function WriteStream(context, options) {
        options = options || {};
        Writable.call(this, options);
        this.context = context;
        this.context.ref();
        this.start = options.start || 0;
        this.endOffset = options.end == null ? Infinity : +options.end;
        this.bytesWritten = 0;
        this.pos = this.start;
        this.destroyed = false;
        this.on("finish", this.destroy.bind(this));
    }
    WriteStream.prototype._write = function(buffer, encoding, callback) {
        var self = this;
        if (self.destroyed) return;
        if (self.pos + buffer.length > self.endOffset) {
            var err = new Error("maximum file length exceeded");
            err.code = "ETOOBIG";
            self.destroy();
            callback(err);
            return;
        }
        self.context.pend.go((function(cb) {
            if (self.destroyed) return cb();
            fs.write(self.context.fd, buffer, 0, buffer.length, self.pos, (function(err, bytes) {
                if (err) {
                    self.destroy();
                    cb();
                    callback(err);
                } else {
                    self.bytesWritten += bytes;
                    self.pos += bytes;
                    self.emit("progress");
                    cb();
                    callback();
                }
            }));
        }));
    };
    WriteStream.prototype.destroy = function() {
        if (this.destroyed) return;
        this.destroyed = true;
        this.context.unref();
    };
    util.inherits(BufferSlicer, EventEmitter);
    function BufferSlicer(buffer, options) {
        EventEmitter.call(this);
        options = options || {};
        this.refCount = 0;
        this.buffer = buffer;
        this.maxChunkSize = options.maxChunkSize || Number.MAX_SAFE_INTEGER;
    }
    BufferSlicer.prototype.read = function(buffer, offset, length, position, callback) {
        var end = position + length;
        var delta = end - this.buffer.length;
        var written = delta > 0 ? delta : length;
        this.buffer.copy(buffer, offset, position, end);
        setImmediate((function() {
            callback(null, written);
        }));
    };
    BufferSlicer.prototype.write = function(buffer, offset, length, position, callback) {
        buffer.copy(this.buffer, position, offset, offset + length);
        setImmediate((function() {
            callback(null, length, buffer);
        }));
    };
    BufferSlicer.prototype.createReadStream = function(options) {
        options = options || {};
        var readStream = new PassThrough(options);
        readStream.destroyed = false;
        readStream.start = options.start || 0;
        readStream.endOffset = options.end;
        readStream.pos = readStream.endOffset || this.buffer.length;
        var entireSlice = this.buffer.slice(readStream.start, readStream.pos);
        var offset = 0;
        while (true) {
            var nextOffset = offset + this.maxChunkSize;
            if (nextOffset >= entireSlice.length) {
                if (offset < entireSlice.length) {
                    readStream.write(entireSlice.slice(offset, entireSlice.length));
                }
                break;
            }
            readStream.write(entireSlice.slice(offset, nextOffset));
            offset = nextOffset;
        }
        readStream.end();
        readStream.destroy = function() {
            readStream.destroyed = true;
        };
        return readStream;
    };
    BufferSlicer.prototype.createWriteStream = function(options) {
        var bufferSlicer = this;
        options = options || {};
        var writeStream = new Writable(options);
        writeStream.start = options.start || 0;
        writeStream.endOffset = options.end == null ? this.buffer.length : +options.end;
        writeStream.bytesWritten = 0;
        writeStream.pos = writeStream.start;
        writeStream.destroyed = false;
        writeStream._write = function(buffer, encoding, callback) {
            if (writeStream.destroyed) return;
            var end = writeStream.pos + buffer.length;
            if (end > writeStream.endOffset) {
                var err = new Error("maximum file length exceeded");
                err.code = "ETOOBIG";
                writeStream.destroyed = true;
                callback(err);
                return;
            }
            buffer.copy(bufferSlicer.buffer, writeStream.pos, 0, buffer.length);
            writeStream.bytesWritten += buffer.length;
            writeStream.pos = end;
            writeStream.emit("progress");
            callback();
        };
        writeStream.destroy = function() {
            writeStream.destroyed = true;
        };
        return writeStream;
    };
    BufferSlicer.prototype.ref = function() {
        this.refCount += 1;
    };
    BufferSlicer.prototype.unref = function() {
        this.refCount -= 1;
        if (this.refCount < 0) {
            throw new Error("invalid unref");
        }
    };
    function createFromBuffer(buffer, options) {
        return new BufferSlicer(buffer, options);
    }
    function createFromFd(fd, options) {
        return new FdSlicer(fd, options);
    }
}, function(module, exports) {
    module.exports = Pend;
    function Pend() {
        this.pending = 0;
        this.max = Infinity;
        this.listeners = [];
        this.waiting = [];
        this.error = null;
    }
    Pend.prototype.go = function(fn) {
        if (this.pending < this.max) {
            pendGo(this, fn);
        } else {
            this.waiting.push(fn);
        }
    };
    Pend.prototype.wait = function(cb) {
        if (this.pending === 0) {
            cb(this.error);
        } else {
            this.listeners.push(cb);
        }
    };
    Pend.prototype.hold = function() {
        return pendHold(this);
    };
    function pendHold(self) {
        self.pending += 1;
        var called = false;
        return onCb;
        function onCb(err) {
            if (called) throw new Error("callback called twice");
            called = true;
            self.error = self.error || err;
            self.pending -= 1;
            if (self.waiting.length > 0 && self.pending < self.max) {
                pendGo(self, self.waiting.shift());
            } else if (self.pending === 0) {
                var listeners = self.listeners;
                self.listeners = [];
                listeners.forEach(cbListener);
            }
        }
        function cbListener(listener) {
            listener(self.error);
        }
    }
    function pendGo(self, fn) {
        fn(pendHold(self));
    }
}, function(module, exports, __webpack_require__) {
    var Buffer = __webpack_require__(37).Buffer;
    var CRC_TABLE = [ 0, 1996959894, 3993919788, 2567524794, 124634137, 1886057615, 3915621685, 2657392035, 249268274, 2044508324, 3772115230, 2547177864, 162941995, 2125561021, 3887607047, 2428444049, 498536548, 1789927666, 4089016648, 2227061214, 450548861, 1843258603, 4107580753, 2211677639, 325883990, 1684777152, 4251122042, 2321926636, 335633487, 1661365465, 4195302755, 2366115317, 997073096, 1281953886, 3579855332, 2724688242, 1006888145, 1258607687, 3524101629, 2768942443, 901097722, 1119000684, 3686517206, 2898065728, 853044451, 1172266101, 3705015759, 2882616665, 651767980, 1373503546, 3369554304, 3218104598, 565507253, 1454621731, 3485111705, 3099436303, 671266974, 1594198024, 3322730930, 2970347812, 795835527, 1483230225, 3244367275, 3060149565, 1994146192, 31158534, 2563907772, 4023717930, 1907459465, 112637215, 2680153253, 3904427059, 2013776290, 251722036, 2517215374, 3775830040, 2137656763, 141376813, 2439277719, 3865271297, 1802195444, 476864866, 2238001368, 4066508878, 1812370925, 453092731, 2181625025, 4111451223, 1706088902, 314042704, 2344532202, 4240017532, 1658658271, 366619977, 2362670323, 4224994405, 1303535960, 984961486, 2747007092, 3569037538, 1256170817, 1037604311, 2765210733, 3554079995, 1131014506, 879679996, 2909243462, 3663771856, 1141124467, 855842277, 2852801631, 3708648649, 1342533948, 654459306, 3188396048, 3373015174, 1466479909, 544179635, 3110523913, 3462522015, 1591671054, 702138776, 2966460450, 3352799412, 1504918807, 783551873, 3082640443, 3233442989, 3988292384, 2596254646, 62317068, 1957810842, 3939845945, 2647816111, 81470997, 1943803523, 3814918930, 2489596804, 225274430, 2053790376, 3826175755, 2466906013, 167816743, 2097651377, 4027552580, 2265490386, 503444072, 1762050814, 4150417245, 2154129355, 426522225, 1852507879, 4275313526, 2312317920, 282753626, 1742555852, 4189708143, 2394877945, 397917763, 1622183637, 3604390888, 2714866558, 953729732, 1340076626, 3518719985, 2797360999, 1068828381, 1219638859, 3624741850, 2936675148, 906185462, 1090812512, 3747672003, 2825379669, 829329135, 1181335161, 3412177804, 3160834842, 628085408, 1382605366, 3423369109, 3138078467, 570562233, 1426400815, 3317316542, 2998733608, 733239954, 1555261956, 3268935591, 3050360625, 752459403, 1541320221, 2607071920, 3965973030, 1969922972, 40735498, 2617837225, 3943577151, 1913087877, 83908371, 2512341634, 3803740692, 2075208622, 213261112, 2463272603, 3855990285, 2094854071, 198958881, 2262029012, 4057260610, 1759359992, 534414190, 2176718541, 4139329115, 1873836001, 414664567, 2282248934, 4279200368, 1711684554, 285281116, 2405801727, 4167216745, 1634467795, 376229701, 2685067896, 3608007406, 1308918612, 956543938, 2808555105, 3495958263, 1231636301, 1047427035, 2932959818, 3654703836, 1088359270, 936918e3, 2847714899, 3736837829, 1202900863, 817233897, 3183342108, 3401237130, 1404277552, 615818150, 3134207493, 3453421203, 1423857449, 601450431, 3009837614, 3294710456, 1567103746, 711928724, 3020668471, 3272380065, 1510334235, 755167117 ];
    if (typeof Int32Array !== "undefined") {
        CRC_TABLE = new Int32Array(CRC_TABLE);
    }
    function ensureBuffer(input) {
        if (Buffer.isBuffer(input)) {
            return input;
        }
        var hasNewBufferAPI = typeof Buffer.alloc === "function" && typeof Buffer.from === "function";
        if (typeof input === "number") {
            return hasNewBufferAPI ? Buffer.alloc(input) : new Buffer(input);
        } else if (typeof input === "string") {
            return hasNewBufferAPI ? Buffer.from(input) : new Buffer(input);
        } else {
            throw new Error("input must be buffer, number, or string, received " + typeof input);
        }
    }
    function bufferizeInt(num) {
        var tmp = ensureBuffer(4);
        tmp.writeInt32BE(num, 0);
        return tmp;
    }
    function _crc32(buf, previous) {
        buf = ensureBuffer(buf);
        if (Buffer.isBuffer(previous)) {
            previous = previous.readUInt32BE(0);
        }
        var crc = ~~previous ^ -1;
        for (var n = 0; n < buf.length; n++) {
            crc = CRC_TABLE[(crc ^ buf[n]) & 255] ^ crc >>> 8;
        }
        return crc ^ -1;
    }
    function crc32() {
        return bufferizeInt(_crc32.apply(null, arguments));
    }
    crc32.signed = function() {
        return _crc32.apply(null, arguments);
    };
    crc32.unsigned = function() {
        return _crc32.apply(null, arguments) >>> 0;
    };
    module.exports = crc32;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.getFileStreamFromZipStream = void 0;
    const unzip = __webpack_require__(231);
    const constants_1 = __webpack_require__(5);
    exports.getFileStreamFromZipStream = async (zipStream, match) => await new Promise((resolve, reject) => {
        let found = false;
        zipStream.on("error", reject);
        const unzipper = unzip.Parse();
        unzipper.on("error", reject);
        zipStream.pipe(unzipper);
        unzipper.on("entry", entry => {
            if (!found && entry.type === "File" && match(entry.path)) {
                found = true;
                if (entry.size !== undefined) {
                    entry.compressedSize = unzipper.unzipStream.parsedEntity.compressedSize;
                }
                entry.on("end", () => {
                    zipStream.unpipe(unzipper);
                });
                resolve(entry);
            } else {
                entry.autodrain();
            }
        });
        zipStream.on("end", () => {
            if (!found) {
                reject(new Error(constants_1.NO_MATCHING_FILE_MSG));
            }
        });
    });
}, function(module, exports, __webpack_require__) {
    "use strict";
    exports.Parse = __webpack_require__(232);
    exports.Extract = __webpack_require__(240);
}, function(module, exports, __webpack_require__) {
    var Transform = __webpack_require__(0).Transform;
    var util = __webpack_require__(1);
    var UnzipStream = __webpack_require__(112);
    function ParserStream(opts) {
        if (!(this instanceof ParserStream)) {
            return new ParserStream(opts);
        }
        var transformOpts = opts || {};
        Transform.call(this, {
            readableObjectMode: true
        });
        this.opts = opts || {};
        this.unzipStream = new UnzipStream(this.opts);
        var self = this;
        this.unzipStream.on("entry", (function(entry) {
            self.push(entry);
        }));
        this.unzipStream.on("error", (function(error) {
            self.emit("error", error);
        }));
    }
    util.inherits(ParserStream, Transform);
    ParserStream.prototype._transform = function(chunk, encoding, cb) {
        this.unzipStream.write(chunk, encoding, cb);
    };
    ParserStream.prototype._flush = function(cb) {
        var self = this;
        this.unzipStream.end((function() {
            process.nextTick((function() {
                self.emit("close");
            }));
            cb();
        }));
    };
    ParserStream.prototype.on = function(eventName, fn) {
        if (eventName === "entry") {
            return Transform.prototype.on.call(this, "data", fn);
        }
        return Transform.prototype.on.call(this, eventName, fn);
    };
    ParserStream.prototype.drainAll = function() {
        this.unzipStream.drainAll();
        return this.pipe(new Transform({
            objectMode: true,
            transform: function(d, e, cb) {
                cb();
            }
        }));
    };
    module.exports = ParserStream;
}, function(module, exports, __webpack_require__) {
    var Chainsaw = __webpack_require__(234);
    var EventEmitter = __webpack_require__(9).EventEmitter;
    var Buffers = __webpack_require__(236);
    var Vars = __webpack_require__(237);
    var Stream = __webpack_require__(0).Stream;
    exports = module.exports = function(bufOrEm, eventName) {
        if (Buffer.isBuffer(bufOrEm)) {
            return exports.parse(bufOrEm);
        }
        var s = exports.stream();
        if (bufOrEm && bufOrEm.pipe) {
            bufOrEm.pipe(s);
        } else if (bufOrEm) {
            bufOrEm.on(eventName || "data", (function(buf) {
                s.write(buf);
            }));
            bufOrEm.on("end", (function() {
                s.end();
            }));
        }
        return s;
    };
    exports.stream = function(input) {
        if (input) return exports.apply(null, arguments);
        var pending = null;
        function getBytes(bytes, cb, skip) {
            pending = {
                bytes,
                skip,
                cb: function(buf) {
                    pending = null;
                    cb(buf);
                }
            };
            dispatch();
        }
        var offset = null;
        function dispatch() {
            if (!pending) {
                if (caughtEnd) done = true;
                return;
            }
            if (typeof pending === "function") {
                pending();
            } else {
                var bytes = offset + pending.bytes;
                if (buffers.length >= bytes) {
                    var buf;
                    if (offset == null) {
                        buf = buffers.splice(0, bytes);
                        if (!pending.skip) {
                            buf = buf.slice();
                        }
                    } else {
                        if (!pending.skip) {
                            buf = buffers.slice(offset, bytes);
                        }
                        offset = bytes;
                    }
                    if (pending.skip) {
                        pending.cb();
                    } else {
                        pending.cb(buf);
                    }
                }
            }
        }
        function builder(saw) {
            function next() {
                if (!done) saw.next();
            }
            var self = words((function(bytes, cb) {
                return function(name) {
                    getBytes(bytes, (function(buf) {
                        vars.set(name, cb(buf));
                        next();
                    }));
                };
            }));
            self.tap = function(cb) {
                saw.nest(cb, vars.store);
            };
            self.into = function(key, cb) {
                if (!vars.get(key)) vars.set(key, {});
                var parent = vars;
                vars = Vars(parent.get(key));
                saw.nest((function() {
                    cb.apply(this, arguments);
                    this.tap((function() {
                        vars = parent;
                    }));
                }), vars.store);
            };
            self.flush = function() {
                vars.store = {};
                next();
            };
            self.loop = function(cb) {
                var end = false;
                saw.nest(false, (function loop() {
                    this.vars = vars.store;
                    cb.call(this, (function() {
                        end = true;
                        next();
                    }), vars.store);
                    this.tap(function() {
                        if (end) saw.next(); else loop.call(this);
                    }.bind(this));
                }), vars.store);
            };
            self.buffer = function(name, bytes) {
                if (typeof bytes === "string") {
                    bytes = vars.get(bytes);
                }
                getBytes(bytes, (function(buf) {
                    vars.set(name, buf);
                    next();
                }));
            };
            self.skip = function(bytes) {
                if (typeof bytes === "string") {
                    bytes = vars.get(bytes);
                }
                getBytes(bytes, (function() {
                    next();
                }));
            };
            self.scan = function find(name, search) {
                if (typeof search === "string") {
                    search = new Buffer(search);
                } else if (!Buffer.isBuffer(search)) {
                    throw new Error("search must be a Buffer or a string");
                }
                var taken = 0;
                pending = function() {
                    var pos = buffers.indexOf(search, offset + taken);
                    var i = pos - offset - taken;
                    if (pos !== -1) {
                        pending = null;
                        if (offset != null) {
                            vars.set(name, buffers.slice(offset, offset + taken + i));
                            offset += taken + i + search.length;
                        } else {
                            vars.set(name, buffers.slice(0, taken + i));
                            buffers.splice(0, taken + i + search.length);
                        }
                        next();
                        dispatch();
                    } else {
                        i = Math.max(buffers.length - search.length - offset - taken, 0);
                    }
                    taken += i;
                };
                dispatch();
            };
            self.peek = function(cb) {
                offset = 0;
                saw.nest((function() {
                    cb.call(this, vars.store);
                    this.tap((function() {
                        offset = null;
                    }));
                }));
            };
            return self;
        }
        var stream = Chainsaw.light(builder);
        stream.writable = true;
        var buffers = Buffers();
        stream.write = function(buf) {
            buffers.push(buf);
            dispatch();
        };
        var vars = Vars();
        var done = false, caughtEnd = false;
        stream.end = function() {
            caughtEnd = true;
        };
        stream.pipe = Stream.prototype.pipe;
        Object.getOwnPropertyNames(EventEmitter.prototype).forEach((function(name) {
            stream[name] = EventEmitter.prototype[name];
        }));
        return stream;
    };
    exports.parse = function parse(buffer) {
        var self = words((function(bytes, cb) {
            return function(name) {
                if (offset + bytes <= buffer.length) {
                    var buf = buffer.slice(offset, offset + bytes);
                    offset += bytes;
                    vars.set(name, cb(buf));
                } else {
                    vars.set(name, null);
                }
                return self;
            };
        }));
        var offset = 0;
        var vars = Vars();
        self.vars = vars.store;
        self.tap = function(cb) {
            cb.call(self, vars.store);
            return self;
        };
        self.into = function(key, cb) {
            if (!vars.get(key)) {
                vars.set(key, {});
            }
            var parent = vars;
            vars = Vars(parent.get(key));
            cb.call(self, vars.store);
            vars = parent;
            return self;
        };
        self.loop = function(cb) {
            var end = false;
            var ender = function() {
                end = true;
            };
            while (end === false) {
                cb.call(self, ender, vars.store);
            }
            return self;
        };
        self.buffer = function(name, size) {
            if (typeof size === "string") {
                size = vars.get(size);
            }
            var buf = buffer.slice(offset, Math.min(buffer.length, offset + size));
            offset += size;
            vars.set(name, buf);
            return self;
        };
        self.skip = function(bytes) {
            if (typeof bytes === "string") {
                bytes = vars.get(bytes);
            }
            offset += bytes;
            return self;
        };
        self.scan = function(name, search) {
            if (typeof search === "string") {
                search = new Buffer(search);
            } else if (!Buffer.isBuffer(search)) {
                throw new Error("search must be a Buffer or a string");
            }
            vars.set(name, null);
            for (var i = 0; i + offset <= buffer.length - search.length + 1; i++) {
                for (var j = 0; j < search.length && buffer[offset + i + j] === search[j]; j++) ;
                if (j === search.length) break;
            }
            vars.set(name, buffer.slice(offset, offset + i));
            offset += i + search.length;
            return self;
        };
        self.peek = function(cb) {
            var was = offset;
            cb.call(self, vars.store);
            offset = was;
            return self;
        };
        self.flush = function() {
            vars.store = {};
            return self;
        };
        self.eof = function() {
            return offset >= buffer.length;
        };
        return self;
    };
    function decodeLEu(bytes) {
        var acc = 0;
        for (var i = 0; i < bytes.length; i++) {
            acc += Math.pow(256, i) * bytes[i];
        }
        return acc;
    }
    function decodeBEu(bytes) {
        var acc = 0;
        for (var i = 0; i < bytes.length; i++) {
            acc += Math.pow(256, bytes.length - i - 1) * bytes[i];
        }
        return acc;
    }
    function decodeBEs(bytes) {
        var val = decodeBEu(bytes);
        if ((bytes[0] & 128) == 128) {
            val -= Math.pow(256, bytes.length);
        }
        return val;
    }
    function decodeLEs(bytes) {
        var val = decodeLEu(bytes);
        if ((bytes[bytes.length - 1] & 128) == 128) {
            val -= Math.pow(256, bytes.length);
        }
        return val;
    }
    function words(decode) {
        var self = {};
        [ 1, 2, 4, 8 ].forEach((function(bytes) {
            var bits = bytes * 8;
            self["word" + bits + "le"] = self["word" + bits + "lu"] = decode(bytes, decodeLEu);
            self["word" + bits + "ls"] = decode(bytes, decodeLEs);
            self["word" + bits + "be"] = self["word" + bits + "bu"] = decode(bytes, decodeBEu);
            self["word" + bits + "bs"] = decode(bytes, decodeBEs);
        }));
        self.word8 = self.word8u = self.word8be;
        self.word8s = self.word8bs;
        return self;
    }
}, function(module, exports, __webpack_require__) {
    var Traverse = __webpack_require__(235);
    var EventEmitter = __webpack_require__(9).EventEmitter;
    module.exports = Chainsaw;
    function Chainsaw(builder) {
        var saw = Chainsaw.saw(builder, {});
        var r = builder.call(saw.handlers, saw);
        if (r !== undefined) saw.handlers = r;
        saw.record();
        return saw.chain();
    }
    Chainsaw.light = function ChainsawLight(builder) {
        var saw = Chainsaw.saw(builder, {});
        var r = builder.call(saw.handlers, saw);
        if (r !== undefined) saw.handlers = r;
        return saw.chain();
    };
    Chainsaw.saw = function(builder, handlers) {
        var saw = new EventEmitter;
        saw.handlers = handlers;
        saw.actions = [];
        saw.chain = function() {
            var ch = Traverse(saw.handlers).map((function(node) {
                if (this.isRoot) return node;
                var ps = this.path;
                if (typeof node === "function") {
                    this.update((function() {
                        saw.actions.push({
                            path: ps,
                            args: [].slice.call(arguments)
                        });
                        return ch;
                    }));
                }
            }));
            process.nextTick((function() {
                saw.emit("begin");
                saw.next();
            }));
            return ch;
        };
        saw.pop = function() {
            return saw.actions.shift();
        };
        saw.next = function() {
            var action = saw.pop();
            if (!action) {
                saw.emit("end");
            } else if (!action.trap) {
                var node = saw.handlers;
                action.path.forEach((function(key) {
                    node = node[key];
                }));
                node.apply(saw.handlers, action.args);
            }
        };
        saw.nest = function(cb) {
            var args = [].slice.call(arguments, 1);
            var autonext = true;
            if (typeof cb === "boolean") {
                var autonext = cb;
                cb = args.shift();
            }
            var s = Chainsaw.saw(builder, {});
            var r = builder.call(s.handlers, s);
            if (r !== undefined) s.handlers = r;
            if ("undefined" !== typeof saw.step) {
                s.record();
            }
            cb.apply(s.chain(), args);
            if (autonext !== false) s.on("end", saw.next);
        };
        saw.record = function() {
            upgradeChainsaw(saw);
        };
        [ "trap", "down", "jump" ].forEach((function(method) {
            saw[method] = function() {
                throw new Error("To use the trap, down and jump features, please " + "call record() first to start recording actions.");
            };
        }));
        return saw;
    };
    function upgradeChainsaw(saw) {
        saw.step = 0;
        saw.pop = function() {
            return saw.actions[saw.step++];
        };
        saw.trap = function(name, cb) {
            var ps = Array.isArray(name) ? name : [ name ];
            saw.actions.push({
                path: ps,
                step: saw.step,
                cb,
                trap: true
            });
        };
        saw.down = function(name) {
            var ps = (Array.isArray(name) ? name : [ name ]).join("/");
            var i = saw.actions.slice(saw.step).map((function(x) {
                if (x.trap && x.step <= saw.step) return false;
                return x.path.join("/") == ps;
            })).indexOf(true);
            if (i >= 0) saw.step += i; else saw.step = saw.actions.length;
            var act = saw.actions[saw.step - 1];
            if (act && act.trap) {
                saw.step = act.step;
                act.cb();
            } else saw.next();
        };
        saw.jump = function(step) {
            saw.step = step;
            saw.next();
        };
    }
}, function(module, exports) {
    module.exports = Traverse;
    function Traverse(obj) {
        if (!(this instanceof Traverse)) return new Traverse(obj);
        this.value = obj;
    }
    Traverse.prototype.get = function(ps) {
        var node = this.value;
        for (var i = 0; i < ps.length; i++) {
            var key = ps[i];
            if (!Object.hasOwnProperty.call(node, key)) {
                node = undefined;
                break;
            }
            node = node[key];
        }
        return node;
    };
    Traverse.prototype.set = function(ps, value) {
        var node = this.value;
        for (var i = 0; i < ps.length - 1; i++) {
            var key = ps[i];
            if (!Object.hasOwnProperty.call(node, key)) node[key] = {};
            node = node[key];
        }
        node[ps[i]] = value;
        return value;
    };
    Traverse.prototype.map = function(cb) {
        return walk(this.value, cb, true);
    };
    Traverse.prototype.forEach = function(cb) {
        this.value = walk(this.value, cb, false);
        return this.value;
    };
    Traverse.prototype.reduce = function(cb, init) {
        var skip = arguments.length === 1;
        var acc = skip ? this.value : init;
        this.forEach((function(x) {
            if (!this.isRoot || !skip) {
                acc = cb.call(this, acc, x);
            }
        }));
        return acc;
    };
    Traverse.prototype.deepEqual = function(obj) {
        if (arguments.length !== 1) {
            throw new Error("deepEqual requires exactly one object to compare against");
        }
        var equal = true;
        var node = obj;
        this.forEach((function(y) {
            var notEqual = function() {
                equal = false;
                return undefined;
            }.bind(this);
            if (!this.isRoot) {
                if (typeof node !== "object") return notEqual();
                node = node[this.key];
            }
            var x = node;
            this.post((function() {
                node = x;
            }));
            var toS = function(o) {
                return Object.prototype.toString.call(o);
            };
            if (this.circular) {
                if (Traverse(obj).get(this.circular.path) !== x) notEqual();
            } else if (typeof x !== typeof y) {
                notEqual();
            } else if (x === null || y === null || x === undefined || y === undefined) {
                if (x !== y) notEqual();
            } else if (x.__proto__ !== y.__proto__) {
                notEqual();
            } else if (x === y) {} else if (typeof x === "function") {
                if (x instanceof RegExp) {
                    if (x.toString() != y.toString()) notEqual();
                } else if (x !== y) notEqual();
            } else if (typeof x === "object") {
                if (toS(y) === "[object Arguments]" || toS(x) === "[object Arguments]") {
                    if (toS(x) !== toS(y)) {
                        notEqual();
                    }
                } else if (x instanceof Date || y instanceof Date) {
                    if (!(x instanceof Date) || !(y instanceof Date) || x.getTime() !== y.getTime()) {
                        notEqual();
                    }
                } else {
                    var kx = Object.keys(x);
                    var ky = Object.keys(y);
                    if (kx.length !== ky.length) return notEqual();
                    for (var i = 0; i < kx.length; i++) {
                        var k = kx[i];
                        if (!Object.hasOwnProperty.call(y, k)) {
                            notEqual();
                        }
                    }
                }
            }
        }));
        return equal;
    };
    Traverse.prototype.paths = function() {
        var acc = [];
        this.forEach((function(x) {
            acc.push(this.path);
        }));
        return acc;
    };
    Traverse.prototype.nodes = function() {
        var acc = [];
        this.forEach((function(x) {
            acc.push(this.node);
        }));
        return acc;
    };
    Traverse.prototype.clone = function() {
        var parents = [], nodes = [];
        return function clone(src) {
            for (var i = 0; i < parents.length; i++) {
                if (parents[i] === src) {
                    return nodes[i];
                }
            }
            if (typeof src === "object" && src !== null) {
                var dst = copy(src);
                parents.push(src);
                nodes.push(dst);
                Object.keys(src).forEach((function(key) {
                    dst[key] = clone(src[key]);
                }));
                parents.pop();
                nodes.pop();
                return dst;
            } else {
                return src;
            }
        }(this.value);
    };
    function walk(root, cb, immutable) {
        var path = [];
        var parents = [];
        var alive = true;
        return function walker(node_) {
            var node = immutable ? copy(node_) : node_;
            var modifiers = {};
            var state = {
                node,
                node_,
                path: [].concat(path),
                parent: parents.slice(-1)[0],
                key: path.slice(-1)[0],
                isRoot: path.length === 0,
                level: path.length,
                circular: null,
                update: function(x) {
                    if (!state.isRoot) {
                        state.parent.node[state.key] = x;
                    }
                    state.node = x;
                },
                delete: function() {
                    delete state.parent.node[state.key];
                },
                remove: function() {
                    if (Array.isArray(state.parent.node)) {
                        state.parent.node.splice(state.key, 1);
                    } else {
                        delete state.parent.node[state.key];
                    }
                },
                before: function(f) {
                    modifiers.before = f;
                },
                after: function(f) {
                    modifiers.after = f;
                },
                pre: function(f) {
                    modifiers.pre = f;
                },
                post: function(f) {
                    modifiers.post = f;
                },
                stop: function() {
                    alive = false;
                }
            };
            if (!alive) return state;
            if (typeof node === "object" && node !== null) {
                state.isLeaf = Object.keys(node).length == 0;
                for (var i = 0; i < parents.length; i++) {
                    if (parents[i].node_ === node_) {
                        state.circular = parents[i];
                        break;
                    }
                }
            } else {
                state.isLeaf = true;
            }
            state.notLeaf = !state.isLeaf;
            state.notRoot = !state.isRoot;
            var ret = cb.call(state, state.node);
            if (ret !== undefined && state.update) state.update(ret);
            if (modifiers.before) modifiers.before.call(state, state.node);
            if (typeof state.node == "object" && state.node !== null && !state.circular) {
                parents.push(state);
                var keys = Object.keys(state.node);
                keys.forEach((function(key, i) {
                    path.push(key);
                    if (modifiers.pre) modifiers.pre.call(state, state.node[key], key);
                    var child = walker(state.node[key]);
                    if (immutable && Object.hasOwnProperty.call(state.node, key)) {
                        state.node[key] = child.node;
                    }
                    child.isLast = i == keys.length - 1;
                    child.isFirst = i == 0;
                    if (modifiers.post) modifiers.post.call(state, child);
                    path.pop();
                }));
                parents.pop();
            }
            if (modifiers.after) modifiers.after.call(state, state.node);
            return state;
        }(root).node;
    }
    Object.keys(Traverse.prototype).forEach((function(key) {
        Traverse[key] = function(obj) {
            var args = [].slice.call(arguments, 1);
            var t = Traverse(obj);
            return t[key].apply(t, args);
        };
    }));
    function copy(src) {
        if (typeof src === "object" && src !== null) {
            var dst;
            if (Array.isArray(src)) {
                dst = [];
            } else if (src instanceof Date) {
                dst = new Date(src);
            } else if (src instanceof Boolean) {
                dst = new Boolean(src);
            } else if (src instanceof Number) {
                dst = new Number(src);
            } else if (src instanceof String) {
                dst = new String(src);
            } else {
                dst = Object.create(Object.getPrototypeOf(src));
            }
            Object.keys(src).forEach((function(key) {
                dst[key] = src[key];
            }));
            return dst;
        } else return src;
    }
}, function(module, exports) {
    module.exports = Buffers;
    function Buffers(bufs) {
        if (!(this instanceof Buffers)) return new Buffers(bufs);
        this.buffers = bufs || [];
        this.length = this.buffers.reduce((function(size, buf) {
            return size + buf.length;
        }), 0);
    }
    Buffers.prototype.push = function() {
        for (var i = 0; i < arguments.length; i++) {
            if (!Buffer.isBuffer(arguments[i])) {
                throw new TypeError("Tried to push a non-buffer");
            }
        }
        for (var i = 0; i < arguments.length; i++) {
            var buf = arguments[i];
            this.buffers.push(buf);
            this.length += buf.length;
        }
        return this.length;
    };
    Buffers.prototype.unshift = function() {
        for (var i = 0; i < arguments.length; i++) {
            if (!Buffer.isBuffer(arguments[i])) {
                throw new TypeError("Tried to unshift a non-buffer");
            }
        }
        for (var i = 0; i < arguments.length; i++) {
            var buf = arguments[i];
            this.buffers.unshift(buf);
            this.length += buf.length;
        }
        return this.length;
    };
    Buffers.prototype.copy = function(dst, dStart, start, end) {
        return this.slice(start, end).copy(dst, dStart, 0, end - start);
    };
    Buffers.prototype.splice = function(i, howMany) {
        var buffers = this.buffers;
        var index = i >= 0 ? i : this.length - i;
        var reps = [].slice.call(arguments, 2);
        if (howMany === undefined) {
            howMany = this.length - index;
        } else if (howMany > this.length - index) {
            howMany = this.length - index;
        }
        for (var i = 0; i < reps.length; i++) {
            this.length += reps[i].length;
        }
        var removed = new Buffers;
        var bytes = 0;
        var startBytes = 0;
        for (var ii = 0; ii < buffers.length && startBytes + buffers[ii].length < index; ii++) {
            startBytes += buffers[ii].length;
        }
        if (index - startBytes > 0) {
            var start = index - startBytes;
            if (start + howMany < buffers[ii].length) {
                removed.push(buffers[ii].slice(start, start + howMany));
                var orig = buffers[ii];
                var buf0 = new Buffer(start);
                for (var i = 0; i < start; i++) {
                    buf0[i] = orig[i];
                }
                var buf1 = new Buffer(orig.length - start - howMany);
                for (var i = start + howMany; i < orig.length; i++) {
                    buf1[i - howMany - start] = orig[i];
                }
                if (reps.length > 0) {
                    var reps_ = reps.slice();
                    reps_.unshift(buf0);
                    reps_.push(buf1);
                    buffers.splice.apply(buffers, [ ii, 1 ].concat(reps_));
                    ii += reps_.length;
                    reps = [];
                } else {
                    buffers.splice(ii, 1, buf0, buf1);
                    ii += 2;
                }
            } else {
                removed.push(buffers[ii].slice(start));
                buffers[ii] = buffers[ii].slice(0, start);
                ii++;
            }
        }
        if (reps.length > 0) {
            buffers.splice.apply(buffers, [ ii, 0 ].concat(reps));
            ii += reps.length;
        }
        while (removed.length < howMany) {
            var buf = buffers[ii];
            var len = buf.length;
            var take = Math.min(len, howMany - removed.length);
            if (take === len) {
                removed.push(buf);
                buffers.splice(ii, 1);
            } else {
                removed.push(buf.slice(0, take));
                buffers[ii] = buffers[ii].slice(take);
            }
        }
        this.length -= removed.length;
        return removed;
    };
    Buffers.prototype.slice = function(i, j) {
        var buffers = this.buffers;
        if (j === undefined) j = this.length;
        if (i === undefined) i = 0;
        if (j > this.length) j = this.length;
        var startBytes = 0;
        for (var si = 0; si < buffers.length && startBytes + buffers[si].length <= i; si++) {
            startBytes += buffers[si].length;
        }
        var target = new Buffer(j - i);
        var ti = 0;
        for (var ii = si; ti < j - i && ii < buffers.length; ii++) {
            var len = buffers[ii].length;
            var start = ti === 0 ? i - startBytes : 0;
            var end = ti + len >= j - i ? Math.min(start + (j - i) - ti, len) : len;
            buffers[ii].copy(target, ti, start, end);
            ti += end - start;
        }
        return target;
    };
    Buffers.prototype.pos = function(i) {
        if (i < 0 || i >= this.length) throw new Error("oob");
        var l = i, bi = 0, bu = null;
        for (;;) {
            bu = this.buffers[bi];
            if (l < bu.length) {
                return {
                    buf: bi,
                    offset: l
                };
            } else {
                l -= bu.length;
            }
            bi++;
        }
    };
    Buffers.prototype.get = function get(i) {
        var pos = this.pos(i);
        return this.buffers[pos.buf].get(pos.offset);
    };
    Buffers.prototype.set = function set(i, b) {
        var pos = this.pos(i);
        return this.buffers[pos.buf].set(pos.offset, b);
    };
    Buffers.prototype.indexOf = function(needle, offset) {
        if ("string" === typeof needle) {
            needle = new Buffer(needle);
        } else if (needle instanceof Buffer) {} else {
            throw new Error("Invalid type for a search string");
        }
        if (!needle.length) {
            return 0;
        }
        if (!this.length) {
            return -1;
        }
        var i = 0, j = 0, match = 0, mstart, pos = 0;
        if (offset) {
            var p = this.pos(offset);
            i = p.buf;
            j = p.offset;
            pos = offset;
        }
        for (;;) {
            while (j >= this.buffers[i].length) {
                j = 0;
                i++;
                if (i >= this.buffers.length) {
                    return -1;
                }
            }
            var char = this.buffers[i][j];
            if (char == needle[match]) {
                if (match == 0) {
                    mstart = {
                        i,
                        j,
                        pos
                    };
                }
                match++;
                if (match == needle.length) {
                    return mstart.pos;
                }
            } else if (match != 0) {
                i = mstart.i;
                j = mstart.j;
                pos = mstart.pos;
                match = 0;
            }
            j++;
            pos++;
        }
    };
    Buffers.prototype.toBuffer = function() {
        return this.slice();
    };
    Buffers.prototype.toString = function(encoding, start, end) {
        return this.slice(start, end).toString(encoding);
    };
}, function(module, exports) {
    module.exports = function(store) {
        function getset(name, value) {
            var node = vars.store;
            var keys = name.split(".");
            keys.slice(0, -1).forEach((function(k) {
                if (node[k] === undefined) node[k] = {};
                node = node[k];
            }));
            var key = keys[keys.length - 1];
            if (arguments.length == 1) {
                return node[key];
            } else {
                return node[key] = value;
            }
        }
        var vars = {
            get: function(name) {
                return getset(name);
            },
            set: function(name, value) {
                return getset(name, value);
            },
            store: store || {}
        };
        return vars;
    };
}, function(module, exports, __webpack_require__) {
    var Transform = __webpack_require__(0).Transform;
    var util = __webpack_require__(1);
    function MatcherStream(patternDesc, matchFn) {
        if (!(this instanceof MatcherStream)) {
            return new MatcherStream;
        }
        Transform.call(this);
        var p = typeof patternDesc === "object" ? patternDesc.pattern : patternDesc;
        this.pattern = Buffer.isBuffer(p) ? p : Buffer.from(p);
        this.requiredLength = this.pattern.length;
        if (patternDesc.requiredExtraSize) this.requiredLength += patternDesc.requiredExtraSize;
        this.data = new Buffer("");
        this.bytesSoFar = 0;
        this.matchFn = matchFn;
    }
    util.inherits(MatcherStream, Transform);
    MatcherStream.prototype.checkDataChunk = function(ignoreMatchZero) {
        var enoughData = this.data.length >= this.requiredLength;
        if (!enoughData) {
            return;
        }
        var matchIndex = this.data.indexOf(this.pattern, ignoreMatchZero ? 1 : 0);
        if (matchIndex >= 0 && matchIndex + this.requiredLength > this.data.length) {
            if (matchIndex > 0) {
                var packet = this.data.slice(0, matchIndex);
                this.push(packet);
                this.bytesSoFar += matchIndex;
                this.data = this.data.slice(matchIndex);
            }
            return;
        }
        if (matchIndex === -1) {
            var packetLen = this.data.length - this.requiredLength + 1;
            var packet = this.data.slice(0, packetLen);
            this.push(packet);
            this.bytesSoFar += packetLen;
            this.data = this.data.slice(packetLen);
            return;
        }
        if (matchIndex > 0) {
            var packet = this.data.slice(0, matchIndex);
            this.data = this.data.slice(matchIndex);
            this.push(packet);
            this.bytesSoFar += matchIndex;
        }
        var finished = this.matchFn ? this.matchFn(this.data, this.bytesSoFar) : true;
        if (finished) {
            this.data = new Buffer("");
            return;
        }
        return true;
    };
    MatcherStream.prototype._transform = function(chunk, encoding, cb) {
        this.data = Buffer.concat([ this.data, chunk ]);
        var firstIteration = true;
        while (this.checkDataChunk(!firstIteration)) {
            firstIteration = false;
        }
        cb();
    };
    MatcherStream.prototype._flush = function(cb) {
        if (this.data.length > 0) {
            var firstIteration = true;
            while (this.checkDataChunk(!firstIteration)) {
                firstIteration = false;
            }
        }
        if (this.data.length > 0) {
            this.push(this.data);
            this.data = null;
        }
        cb();
    };
    module.exports = MatcherStream;
}, function(module, exports, __webpack_require__) {
    "use strict";
    var stream = __webpack_require__(0);
    var inherits = __webpack_require__(1).inherits;
    function Entry() {
        if (!(this instanceof Entry)) {
            return new Entry;
        }
        stream.PassThrough.call(this);
        this.path = null;
        this.type = null;
        this.isDirectory = false;
    }
    inherits(Entry, stream.PassThrough);
    Entry.prototype.autodrain = function() {
        return this.pipe(new stream.Transform({
            transform: function(d, e, cb) {
                cb();
            }
        }));
    };
    module.exports = Entry;
}, function(module, exports, __webpack_require__) {
    var fs = __webpack_require__(3);
    var path = __webpack_require__(4);
    var util = __webpack_require__(1);
    var mkdirp = __webpack_require__(241);
    var Transform = __webpack_require__(0).Transform;
    var UnzipStream = __webpack_require__(112);
    function Extract(opts) {
        if (!(this instanceof Extract)) return new Extract(opts);
        Transform.call(this);
        this.opts = opts || {};
        this.unzipStream = new UnzipStream;
        this.unfinishedEntries = 0;
        this.afterFlushWait = false;
        this.createdDirectories = {};
        var self = this;
        this.unzipStream.on("entry", this._processEntry.bind(this));
        this.unzipStream.on("error", (function(error) {
            self.emit("error", error);
        }));
    }
    util.inherits(Extract, Transform);
    Extract.prototype._transform = function(chunk, encoding, cb) {
        this.unzipStream.write(chunk, encoding, cb);
    };
    Extract.prototype._flush = function(cb) {
        var self = this;
        var allDone = function() {
            process.nextTick((function() {
                self.emit("close");
            }));
            cb();
        };
        this.unzipStream.end((function() {
            if (self.unfinishedEntries > 0) {
                self.afterFlushWait = true;
                return self.on("await-finished", allDone);
            }
            allDone();
        }));
    };
    Extract.prototype._processEntry = function(entry) {
        var self = this;
        var destPath = path.join(this.opts.path, entry.path);
        var directory = entry.isDirectory ? destPath : path.dirname(destPath);
        this.unfinishedEntries++;
        var writeFileFn = function() {
            var pipedStream = fs.createWriteStream(destPath);
            pipedStream.on("close", (function() {
                self.unfinishedEntries--;
                self._notifyAwaiter();
            }));
            pipedStream.on("error", (function(error) {
                self.emit("error", error);
            }));
            entry.pipe(pipedStream);
        };
        if (this.createdDirectories[directory] || directory === ".") {
            return writeFileFn();
        }
        mkdirp(directory, (function(err) {
            if (err) return self.emit("error", err);
            self.createdDirectories[directory] = true;
            if (entry.isDirectory) {
                self.unfinishedEntries--;
                self._notifyAwaiter();
                return;
            }
            writeFileFn();
        }));
    };
    Extract.prototype._notifyAwaiter = function() {
        if (this.afterFlushWait && this.unfinishedEntries === 0) {
            this.emit("await-finished");
            this.afterFlushWait = false;
        }
    };
    module.exports = Extract;
}, function(module, exports, __webpack_require__) {
    var path = __webpack_require__(4);
    var fs = __webpack_require__(3);
    var _0777 = parseInt("0777", 8);
    module.exports = mkdirP.mkdirp = mkdirP.mkdirP = mkdirP;
    function mkdirP(p, opts, f, made) {
        if (typeof opts === "function") {
            f = opts;
            opts = {};
        } else if (!opts || typeof opts !== "object") {
            opts = {
                mode: opts
            };
        }
        var mode = opts.mode;
        var xfs = opts.fs || fs;
        if (mode === undefined) {
            mode = _0777;
        }
        if (!made) made = null;
        var cb = f || function() {};
        p = path.resolve(p);
        xfs.mkdir(p, mode, (function(er) {
            if (!er) {
                made = made || p;
                return cb(null, made);
            }
            switch (er.code) {
              case "ENOENT":
                if (path.dirname(p) === p) return cb(er);
                mkdirP(path.dirname(p), opts, (function(er, made) {
                    if (er) cb(er, made); else mkdirP(p, opts, cb, made);
                }));
                break;

              default:
                xfs.stat(p, (function(er2, stat) {
                    if (er2 || !stat.isDirectory()) cb(er, made); else cb(null, made);
                }));
                break;
            }
        }));
    }
    mkdirP.sync = function sync(p, opts, made) {
        if (!opts || typeof opts !== "object") {
            opts = {
                mode: opts
            };
        }
        var mode = opts.mode;
        var xfs = opts.fs || fs;
        if (mode === undefined) {
            mode = _0777;
        }
        if (!made) made = null;
        p = path.resolve(p);
        try {
            xfs.mkdirSync(p, mode);
            made = made || p;
        } catch (err0) {
            switch (err0.code) {
              case "ENOENT":
                made = sync(path.dirname(p), opts, made);
                sync(p, opts, made);
                break;

              default:
                var stat;
                try {
                    stat = xfs.statSync(p);
                } catch (err1) {
                    throw err0;
                }
                if (!stat.isDirectory()) throw err0;
                break;
            }
        }
        return made;
    };
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.SingleUseStreamSource = void 0;
    const source_destination_1 = __webpack_require__(7);
    const errors_1 = __webpack_require__(8);
    const stream_limiter_1 = __webpack_require__(32);
    class SingleUseStreamSource extends source_destination_1.SourceDestination {
        constructor(stream) {
            super();
            this.stream = stream;
            this.used = false;
        }
        async canCreateReadStream() {
            return !this.used;
        }
        async createReadStream({start = 0, end} = {}) {
            if (this.used) {
                throw new errors_1.NotCapable("Single use source stream already used");
            }
            if (start !== 0) {
                throw new errors_1.NotCapable("Can't seek in a single use stream");
            }
            let stream = this.stream;
            if (end !== undefined) {
                stream = new stream_limiter_1.StreamLimiter(stream, end + 1);
            }
            this.used = true;
            return stream;
        }
    }
    exports.SingleUseStreamSource = SingleUseStreamSource;
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports.XzSource = void 0;
    const lzma_native_1 = __webpack_require__(244);
    const util_1 = __webpack_require__(1);
    const compressed_source_1 = __webpack_require__(17);
    const source_destination_1 = __webpack_require__(7);
    const parseFileIndexAsync = util_1.promisify(lzma_native_1.parseFileIndex);
    class XzSource extends compressed_source_1.CompressedSource {
        createTransform() {
            return lzma_native_1.createDecompressor();
        }
        async getSize() {
            if (!await this.source.canRead()) {
                const sizeFromPartitionTable = await this.getSizeFromPartitionTable();
                if (sizeFromPartitionTable !== undefined) {
                    return {
                        size: sizeFromPartitionTable,
                        isEstimated: true
                    };
                }
                return;
            }
            const {size} = await this.source.getMetadata();
            if (size === undefined) {
                return;
            }
            const {uncompressedSize} = await parseFileIndexAsync({
                fileSize: size,
                read: async (count, offset, callback) => {
                    try {
                        const readResult = await this.source.read(Buffer.allocUnsafe(count), 0, count, offset);
                        callback(null, readResult.buffer);
                    } catch (error) {
                        callback(error);
                    }
                }
            });
            return {
                size: uncompressedSize,
                isEstimated: false
            };
        }
    }
    exports.XzSource = XzSource;
    XzSource.mimetype = "application/x-xz";
    source_destination_1.SourceDestination.register(XzSource);
}, function(module, exports, __webpack_require__) {
    (function() {
        "use strict";
        var stream = __webpack_require__(0);
        var assert = __webpack_require__(101);
        var fs = __webpack_require__(3);
        var util = __webpack_require__(1);
        var nodePreGyp = __webpack_require__(73);
        var path = __webpack_require__(4);
        var binding_path = nodePreGyp.find(path.resolve(path.join(__dirname, "./package.json")));
        var native = __webpack_require__(245);
        Object.assign(exports, native);
        exports.version = "6.0.1";
        var Stream = exports.Stream;
        Stream.curAsyncStreamsCount = 0;
        Stream.prototype.getStream = function(options) {
            options = options || {};
            return new JSLzmaStream(this, options);
        };
        class JSLzmaStream extends stream.Transform {
            constructor(nativeStream, options) {
                super(options);
                this.nativeStream = nativeStream;
                this.synchronous = options.synchronous || !native.asyncCodeAvailable ? true : false;
                this.chunkCallbacks = [];
                this.totalIn_ = 0;
                this.totalOut_ = 0;
                this._writingLastChunk = false;
                this._isFinished = false;
                if (!this.synchronous) {
                    Stream.curAsyncStreamsCount++;
                    var oldCleanup = this.cleanup;
                    var countedCleanup = false;
                    this.cleanup = () => {
                        if (countedCleanup === false) {
                            Stream.curAsyncStreamsCount--;
                            countedCleanup = true;
                        }
                        oldCleanup.call(this);
                    };
                }
                this.once("error-cleanup", this.cleanup);
                this.nativeStream.bufferHandler = (buf, processedChunks, err, totalIn, totalOut) => {
                    if (totalIn !== null) {
                        this.totalIn_ = totalIn;
                        this.totalOut_ = totalOut;
                    }
                    setImmediate(() => {
                        if (err) {
                            this.push(null);
                            this.emit("error-cleanup", err);
                            this.emit("error", err);
                            return;
                        }
                        if (totalIn !== null) {
                            this.emit("progress", {
                                totalIn: this.totalIn_,
                                totalOut: this.totalOut_
                            });
                        }
                        if (typeof processedChunks === "number") {
                            assert.ok(processedChunks <= this.chunkCallbacks.length);
                            var chunkCallbacks = this.chunkCallbacks.splice(0, processedChunks);
                            while (chunkCallbacks.length > 0) chunkCallbacks.shift().call(this);
                        } else if (buf === null) {
                            if (this._writingLastChunk) {
                                this.push(null);
                            } else {
                                this._isFinished = true;
                                if (this.nativeStream && this.nativeStream._restart) {
                                    this.nativeStream._restart();
                                } else {
                                    this.push(null);
                                }
                            }
                        } else {
                            this.push(buf);
                        }
                    });
                };
                if (typeof options.bufsize !== "undefined") {
                    this.bufsize = options.bufsize;
                }
            }
            get bufsize() {
                return this.setBufsize(null);
            }
            set bufsize(n) {
                if (typeof n !== "number" || n <= 0) {
                    throw new TypeError("bufsize must be a positive number");
                }
                return this.setBufsize(n);
            }
            totalIn() {
                return this.totalIn_;
            }
            totalOut() {
                return this.totalOut_;
            }
            cleanup() {
                if (this.nativeStream) {
                    this.nativeStream.resetUnderlying();
                }
                this.nativeStream = null;
            }
            _transform(chunk, encoding, callback) {
                if (!this.nativeStream) return;
                var possibleEndIndex = bufferIndexOfYZ(chunk);
                if (possibleEndIndex !== -1) {
                    possibleEndIndex += 2;
                    if (possibleEndIndex !== chunk.length) {
                        this._transform(chunk.slice(0, possibleEndIndex), encoding, () => {
                            this._transform(chunk.slice(possibleEndIndex), encoding, callback);
                        });
                        return;
                    }
                }
                if (this._isFinished && chunk) {
                    chunk = skipLeadingZeroes(chunk);
                    if (chunk.length > 0) {
                        this._isFinished = false;
                    }
                }
                if (chunk && chunk.length === 0) {
                    return callback();
                }
                this.chunkCallbacks.push(callback);
                try {
                    this.nativeStream.code(chunk, !this.synchronous);
                } catch (e) {
                    this.emit("error-cleanup", e);
                    this.emit("error", e);
                }
            }
            _writev(chunks, callback) {
                chunks = chunks.map(chunk => chunk.chunk);
                this._write(Buffer.concat(chunks), null, callback);
            }
            _flush(callback) {
                this._writingLastChunk = true;
                if (this._isFinished) {
                    this.cleanup();
                    callback(null);
                    return;
                }
                this._transform(null, null, (function() {
                    this.cleanup();
                    callback.apply(this, arguments);
                }));
            }
        }
        Object.getOwnPropertyNames(native.Stream.prototype).forEach((function(key) {
            if (typeof native.Stream.prototype[key] !== "function" || key === "constructor") return;
            JSLzmaStream.prototype[key] = function() {
                return this.nativeStream[key].apply(this.nativeStream, arguments);
            };
        }));
        Stream.prototype.rawEncoder = function(options) {
            return this.rawEncoder_(options.filters || []);
        };
        Stream.prototype.rawDecoder = function(options) {
            return this.rawDecoder_(options.filters || []);
        };
        Stream.prototype.easyEncoder = function(options) {
            var preset = options.preset || exports.PRESET_DEFAULT;
            var check = options.check || exports.CHECK_CRC32;
            if (typeof options.threads !== "undefined" && options.threads !== null) {
                return this.mtEncoder_(Object.assign({
                    preset,
                    filters: null,
                    check
                }, options));
            } else {
                return this.easyEncoder_(preset, check);
            }
        };
        Stream.prototype.streamEncoder = function(options) {
            var filters = options.filters || [];
            var check = options.check || exports.CHECK_CRC32;
            if (typeof options.threads !== "undefined" && options.threads !== null) {
                return this.mtEncoder_(Object.assign({
                    preset: null,
                    filters,
                    check
                }, options));
            } else {
                return this.streamEncoder_(filters, check);
            }
        };
        Stream.prototype.streamDecoder = function(options) {
            this._initOptions = options;
            this._restart = function() {
                this.resetUnderlying();
                this.streamDecoder(this._initOptions);
            };
            return this.streamDecoder_(options.memlimit || null, options.flags || 0);
        };
        Stream.prototype.autoDecoder = function(options) {
            this._initOptions = options;
            this._restart = function() {
                this.resetUnderlying();
                this.autoDecoder(this._initOptions);
            };
            return this.autoDecoder_(options.memlimit || null, options.flags || 0);
        };
        Stream.prototype.aloneDecoder = function(options) {
            return this.aloneDecoder_(options.memlimit || null);
        };
        var createStream = exports.createStream = function(coder, options) {
            if ([ "number", "object" ].indexOf(typeof coder) !== -1 && !options) {
                options = coder;
                coder = null;
            }
            if (parseInt(options) === parseInt(options)) options = {
                preset: parseInt(options)
            };
            coder = coder || "easyEncoder";
            options = options || {};
            var stream = new Stream;
            stream[coder](options);
            if (options.memlimit) stream.memlimitSet(options.memlimit);
            return stream.getStream(options);
        };
        exports.createCompressor = function(options) {
            return createStream("easyEncoder", options);
        };
        exports.createDecompressor = function(options) {
            return createStream("autoDecoder", options);
        };
        exports.crc32 = function(input, encoding, presetCRC32) {
            if (typeof encoding === "number") {
                presetCRC32 = encoding;
                encoding = null;
            }
            if (typeof input === "string") input = Buffer.from(input, encoding);
            return exports.crc32_(input, presetCRC32 || 0);
        };
        exports.Compressor = function(preset, options) {
            options = Object.assign({}, options);
            if (preset) options.preset = preset;
            return createStream("easyEncoder", options);
        };
        exports.Decompressor = function(options) {
            return createStream("autoDecoder", options);
        };
        function singleStringCoding(stream, string, on_finish, on_progress) {
            on_progress = on_progress || function() {};
            on_finish = on_finish || function() {};
            if (!Buffer.isBuffer(string)) string = Buffer.from(string);
            var deferred = {}, failed = false;
            stream.once("error", (function(err) {
                failed = true;
                on_finish(null, err);
            }));
            deferred.promise = new Promise((function(resolve, reject) {
                deferred.resolve = resolve;
                deferred.reject = reject;
            }));
            deferred.promise.catch(noop);
            stream.once("error", (function(e) {
                deferred.reject(e);
            }));
            var buffers = [];
            stream.on("data", (function(b) {
                buffers.push(b);
            }));
            stream.once("end", (function() {
                var result = Buffer.concat(buffers);
                if (!failed) {
                    on_progress(1);
                    on_finish(result);
                }
                if (deferred) deferred.resolve(result);
            }));
            on_progress(0);
            stream.end(string);
            if (deferred) return deferred.promise;
        }
        exports.LZMA = function() {
            return {
                compress: function(string, mode, on_finish, on_progress) {
                    var opt = {};
                    if (parseInt(mode) === parseInt(mode) && mode >= 1 && mode <= 9) opt.preset = parseInt(mode);
                    var stream = createStream("aloneEncoder", opt);
                    return singleStringCoding(stream, string, on_finish, on_progress);
                },
                decompress: function(byte_array, on_finish, on_progress) {
                    var stream = createStream("autoDecoder");
                    return singleStringCoding(stream, byte_array, on_finish, on_progress);
                },
                worker: function() {
                    return null;
                }
            };
        };
        exports.compress = function(string, opt, on_finish) {
            if (typeof opt === "function") {
                on_finish = opt;
                opt = {};
            }
            var stream = createStream("easyEncoder", opt);
            return singleStringCoding(stream, string, on_finish);
        };
        exports.decompress = function(string, opt, on_finish) {
            if (typeof opt === "function") {
                on_finish = opt;
                opt = {};
            }
            var stream = createStream("autoDecoder", opt);
            return singleStringCoding(stream, string, on_finish);
        };
        if (util.promisify) {
            exports.compress[util.promisify.custom] = exports.compress;
            exports.decompress[util.promisify.custom] = exports.decompress;
        }
        exports.isXZ = function(buf) {
            return buf && buf.length >= 6 && buf[0] === 253 && buf[1] === 55 && buf[2] === 122 && buf[3] === 88 && buf[4] === 90 && buf[5] === 0;
        };
        exports.parseFileIndex = function(options, callback) {
            if (typeof options !== "object") {
                throw new TypeError("parseFileIndex needs an options object");
            }
            var p = new native.IndexParser;
            if (typeof options.fileSize !== "number") {
                throw new TypeError("parseFileeIndex needs options.fileSize");
            }
            if (typeof options.read !== "function") {
                throw new TypeError("parseFileIndex needs a read callback");
            }
            p.init(options.fileSize, options.memlimit || 0);
            p.read_cb = function(count, offset) {
                var inSameTick = true;
                var bytesRead = count;
                options.read(count, offset, (function(err, buffer) {
                    if (Buffer.isBuffer(err)) {
                        buffer = err;
                        err = null;
                    }
                    if (err) {
                        if (typeof callback === "undefined") {
                            throw err;
                        }
                        return callback(err, null);
                    }
                    p.feed(buffer);
                    bytesRead = buffer.length;
                    if (inSameTick) {
                        return;
                    }
                    var info;
                    try {
                        info = p.parse();
                    } catch (e) {
                        return callback(e, null);
                    }
                    if (info !== true) {
                        return callback(null, cleanupIndexInfo(info));
                    }
                }));
                inSameTick = false;
                return bytesRead;
            };
            var info;
            try {
                info = p.parse();
            } catch (e) {
                if (typeof callback !== "undefined") {
                    callback(e, null);
                    return;
                }
                throw e;
            }
            if (info !== true) {
                info = cleanupIndexInfo(info);
                if (typeof callback !== "undefined" && info !== true) {
                    callback(null, info);
                }
                return info;
            }
        };
        exports.parseFileIndexFD = function(fd, callback) {
            return fs.fstat(fd, (function(err, stats) {
                if (err) {
                    return callback(err, null);
                }
                exports.parseFileIndex({
                    fileSize: stats.size,
                    read: function(count, offset, cb) {
                        var buffer = Buffer.allocUnsafe(count);
                        fs.read(fd, buffer, 0, count, offset, (function(err, bytesRead, buffer) {
                            if (err) {
                                return cb(err, null);
                            }
                            if (bytesRead !== count) {
                                return cb(new Error("Truncated file!"), null);
                            }
                            cb(null, buffer);
                        }));
                    }
                }, callback);
            }));
        };
        function cleanupIndexInfo(info) {
            var checkFlags = info.checks;
            info.checks = [];
            for (var i = 0; i < exports.CHECK_ID_MAX; i++) {
                if (checkFlags & 1 << i) info.checks.push(i);
            }
            return info;
        }
        function skipLeadingZeroes(buffer) {
            var i;
            for (i = 0; i < buffer.length; i++) {
                if (buffer[i] !== 0) break;
            }
            return buffer.slice(i);
        }
        function bufferIndexOfYZ(chunk) {
            if (!chunk) {
                return -1;
            }
            if (chunk.indexOf) {
                return chunk.indexOf("YZ");
            }
            var i;
            for (i = 0; i < chunk.length - 1; i++) {
                if (chunk[i] === 89 && chunk[i + 1] === 90) {
                    return i;
                }
            }
            return -1;
        }
        function noop() {}
    })();
}, function(module, exports) {
    module.exports = require("./modules/lzma-native/binding-v6.0.1-n-api-linux-x64/lzma_native.node");
}, function(module, exports, __webpack_require__) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    const tslib_1 = __webpack_require__(22);
    tslib_1.__exportStar(__webpack_require__(34), exports);
    tslib_1.__exportStar(__webpack_require__(50), exports);
    tslib_1.__exportStar(__webpack_require__(53), exports);
    tslib_1.__exportStar(__webpack_require__(19), exports);
}, function(module, exports, __webpack_require__) {
    "use strict";
    const Defaults = __webpack_require__(113), Client = __webpack_require__(248), Server = __webpack_require__(251), util = __webpack_require__(1);
    class IPC {
        constructor() {
            Object.defineProperties(this, {
                config: {
                    enumerable: true,
                    writable: true,
                    value: new Defaults
                },
                connectTo: {
                    enumerable: true,
                    writable: false,
                    value: connect
                },
                connectToNet: {
                    enumerable: true,
                    writable: false,
                    value: connectNet
                },
                disconnect: {
                    enumerable: true,
                    writable: false,
                    value: disconnect
                },
                serve: {
                    enumerable: true,
                    writable: false,
                    value: serve
                },
                serveNet: {
                    enumerable: true,
                    writable: false,
                    value: serveNet
                },
                of: {
                    enumerable: true,
                    writable: true,
                    value: {}
                },
                server: {
                    enumerable: true,
                    writable: true,
                    configurable: true,
                    value: false
                },
                log: {
                    enumerable: true,
                    writable: false,
                    value: log
                }
            });
        }
    }
    function log(...args) {
        if (this.config.silent) {
            return;
        }
        for (let i = 0, count = args.length; i < count; i++) {
            if (typeof args[i] != "object") {
                continue;
            }
            args[i] = util.inspect(args[i], {
                depth: this.config.logDepth,
                colors: this.config.logInColor
            });
        }
        this.config.logger(args.join(" "));
    }
    function disconnect(id) {
        if (!this.of[id]) {
            return;
        }
        this.of[id].explicitlyDisconnected = true;
        this.of[id].off("*", "*");
        if (this.of[id].socket) {
            if (this.of[id].socket.destroy) {
                this.of[id].socket.destroy();
            }
        }
        delete this.of[id];
    }
    function serve(path, callback) {
        if (typeof path == "function") {
            callback = path;
            path = false;
        }
        if (!path) {
            this.log("Server path not specified, so defaulting to", "ipc.config.socketRoot + ipc.config.appspace + ipc.config.id", this.config.socketRoot + this.config.appspace + this.config.id);
            path = this.config.socketRoot + this.config.appspace + this.config.id;
        }
        if (!callback) {
            callback = emptyCallback;
        }
        this.server = new Server(path, this.config, log);
        this.server.on("start", callback);
    }
    function emptyCallback() {}
    function serveNet(host, port, UDPType, callback) {
        if (typeof host == "number") {
            callback = UDPType;
            UDPType = port;
            port = host;
            host = false;
        }
        if (typeof host == "function") {
            callback = host;
            UDPType = false;
            host = false;
            port = false;
        }
        if (!host) {
            this.log("Server host not specified, so defaulting to", "ipc.config.networkHost", this.config.networkHost);
            host = this.config.networkHost;
        }
        if (host.toLowerCase() == "udp4" || host.toLowerCase() == "udp6") {
            callback = port;
            UDPType = host.toLowerCase();
            port = false;
            host = this.config.networkHost;
        }
        if (typeof port == "string") {
            callback = UDPType;
            UDPType = port;
            port = false;
        }
        if (typeof port == "function") {
            callback = port;
            UDPType = false;
            port = false;
        }
        if (!port) {
            this.log("Server port not specified, so defaulting to", "ipc.config.networkPort", this.config.networkPort);
            port = this.config.networkPort;
        }
        if (typeof UDPType == "function") {
            callback = UDPType;
            UDPType = false;
        }
        if (!callback) {
            callback = emptyCallback;
        }
        this.server = new Server(host, this.config, log, port);
        if (UDPType) {
            this.server[UDPType] = true;
            if (UDPType === "udp4" && host === "::1") {
                this.server.path = "127.0.0.1";
            }
        }
        this.server.on("start", callback);
    }
    function connect(id, path, callback) {
        if (typeof path == "function") {
            callback = path;
            path = false;
        }
        if (!callback) {
            callback = emptyCallback;
        }
        if (!id) {
            this.log("Service id required", "Requested service connection without specifying service id. Aborting connection attempt");
            return;
        }
        if (!path) {
            this.log("Service path not specified, so defaulting to", "ipc.config.socketRoot + ipc.config.appspace + id", (this.config.socketRoot + this.config.appspace + id).data);
            path = this.config.socketRoot + this.config.appspace + id;
        }
        if (this.of[id]) {
            if (!this.of[id].socket.destroyed) {
                this.log("Already Connected to", id, "- So executing success without connection");
                callback();
                return;
            }
            this.of[id].socket.destroy();
        }
        this.of[id] = new Client(this.config, this.log);
        this.of[id].id = id;
        this.of[id].path = path;
        this.of[id].connect();
        callback(this);
    }
    function connectNet(id, host, port, callback) {
        if (!id) {
            this.log("Service id required", "Requested service connection without specifying service id. Aborting connection attempt");
            return;
        }
        if (typeof host == "number") {
            callback = port;
            port = host;
            host = false;
        }
        if (typeof host == "function") {
            callback = host;
            host = false;
            port = false;
        }
        if (!host) {
            this.log("Server host not specified, so defaulting to", "ipc.config.networkHost", this.config.networkHost);
            host = this.config.networkHost;
        }
        if (typeof port == "function") {
            callback = port;
            port = false;
        }
        if (!port) {
            this.log("Server port not specified, so defaulting to", "ipc.config.networkPort", this.config.networkPort);
            port = this.config.networkPort;
        }
        if (typeof callback == "string") {
            UDPType = callback;
            callback = false;
        }
        if (!callback) {
            callback = emptyCallback;
        }
        if (this.of[id]) {
            if (!this.of[id].socket.destroyed) {
                this.log("Already Connected to", id, "- So executing success without connection");
                callback();
                return;
            }
            this.of[id].socket.destroy();
        }
        this.of[id] = new Client(this.config, this.log);
        this.of[id].id = id;
        this.of[id].path = host;
        this.of[id].port = port;
        this.of[id].connect();
        callback(this);
    }
    module.exports = IPC;
}, function(module, exports, __webpack_require__) {
    "use strict";
    const net = __webpack_require__(114), tls = __webpack_require__(115), EventParser = __webpack_require__(116), Message = __webpack_require__(117), fs = __webpack_require__(3), Queue = __webpack_require__(249);
    let Events = __webpack_require__(63);
    if (process.version[1] > 4) {
        Events = __webpack_require__(118);
    }
    let eventParser = new EventParser;
    class Client extends Events {
        constructor(config, log) {
            super();
            Object.assign(this, {
                Client,
                config,
                queue: new Queue,
                socket: false,
                connect,
                emit,
                log,
                retriesRemaining: config.maxRetries || 0,
                explicitlyDisconnected: false
            });
            eventParser = new EventParser(this.config);
        }
    }
    function emit(type, data) {
        this.log("dispatching event to ", this.id, this.path, " : ", type, ",", data);
        let message = new Message;
        message.type = type;
        message.data = data;
        if (this.config.rawBuffer) {
            message = new Buffer(type, this.config.encoding);
        } else {
            message = eventParser.format(message);
        }
        if (!this.config.sync) {
            this.socket.write(message);
            return;
        }
        this.queue.add(syncEmit.bind(this, message));
    }
    function syncEmit(message) {
        this.log("dispatching event to ", this.id, this.path, " : ", message);
        this.socket.write(message);
    }
    function connect() {
        let client = this;
        client.log("requested connection to ", client.id, client.path);
        if (!this.path) {
            client.log("\n\n######\nerror: ", client.id, " client has not specified socket path it wishes to connect to.");
            return;
        }
        const options = {};
        if (!client.port) {
            client.log("Connecting client on Unix Socket :", client.path);
            options.path = client.path;
            if (process.platform === "win32" && !client.path.startsWith("\\\\.\\pipe\\")) {
                options.path = options.path.replace(/^\//, "");
                options.path = options.path.replace(/\//g, "-");
                options.path = `\\\\.\\pipe\\${options.path}`;
            }
            client.socket = net.connect(options);
        } else {
            options.host = client.path;
            options.port = client.port;
            if (client.config.interface.localAddress) {
                options.localAddress = client.config.interface.localAddress;
            }
            if (client.config.interface.localPort) {
                options.localPort = client.config.interface.localPort;
            }
            if (client.config.interface.family) {
                options.family = client.config.interface.family;
            }
            if (client.config.interface.hints) {
                options.hints = client.config.interface.hints;
            }
            if (client.config.interface.lookup) {
                options.lookup = client.config.interface.lookup;
            }
            if (!client.config.tls) {
                client.log("Connecting client via TCP to", options);
                client.socket = net.connect(options);
            } else {
                client.log("Connecting client via TLS to", client.path, client.port, client.config.tls);
                if (client.config.tls.private) {
                    client.config.tls.key = fs.readFileSync(client.config.tls.private);
                }
                if (client.config.tls.public) {
                    client.config.tls.cert = fs.readFileSync(client.config.tls.public);
                }
                if (client.config.tls.trustedConnections) {
                    if (typeof client.config.tls.trustedConnections === "string") {
                        client.config.tls.trustedConnections = [ client.config.tls.trustedConnections ];
                    }
                    client.config.tls.ca = [];
                    for (let i = 0; i < client.config.tls.trustedConnections.length; i++) {
                        client.config.tls.ca.push(fs.readFileSync(client.config.tls.trustedConnections[i]));
                    }
                }
                Object.assign(client.config.tls, options);
                client.socket = tls.connect(client.config.tls);
            }
        }
        client.socket.setEncoding(this.config.encoding);
        client.socket.on("error", (function(err) {
            client.log("\n\n######\nerror: ", err);
            client.publish("error", err);
        }));
        client.socket.on("connect", (function connectionMade() {
            client.publish("connect");
            client.retriesRemaining = client.config.maxRetries;
            client.log("retrying reset");
        }));
        client.socket.on("close", (function connectionClosed() {
            client.log("connection closed", client.id, client.path, client.retriesRemaining, "tries remaining of", client.config.maxRetries);
            if (client.config.stopRetrying || client.retriesRemaining < 1 || client.explicitlyDisconnected) {
                client.publish("disconnect");
                client.log(client.config.id, "exceeded connection rety amount of", " or stopRetrying flag set.");
                client.socket.destroy();
                client.publish("destroy");
                client = undefined;
                return;
            }
            setTimeout(function retryTimeout() {
                client.retriesRemaining--;
                client.connect();
            }.bind(null, client), client.config.retry);
            client.publish("disconnect");
        }));
        client.socket.on("data", (function(data) {
            client.log("## received events ##");
            if (client.config.rawBuffer) {
                client.publish("data", new Buffer(data, client.config.encoding));
                if (!client.config.sync) {
                    return;
                }
                client.queue.next();
                return;
            }
            if (!this.ipcBuffer) {
                this.ipcBuffer = "";
            }
            data = this.ipcBuffer += data;
            if (data.slice(-1) != eventParser.delimiter || data.indexOf(eventParser.delimiter) == -1) {
                client.log("Messages are large, You may want to consider smaller messages.");
                return;
            }
            this.ipcBuffer = "";
            const events = eventParser.parse(data);
            const eCount = events.length;
            for (let i = 0; i < eCount; i++) {
                let message = new Message;
                message.load(events[i]);
                client.log("detected event", message.type, message.data);
                client.publish(message.type, message.data);
            }
            if (!client.config.sync) {
                return;
            }
            client.queue.next();
        }));
    }
    module.exports = Client;
}, function(module, exports) {
    function Queue(asStack) {
        Object.defineProperties(this, {
            add: {
                enumerable: true,
                writable: false,
                value: addToQueue
            },
            next: {
                enumerable: true,
                writable: false,
                value: run
            },
            clear: {
                enumerable: true,
                writable: false,
                value: clearQueue
            },
            contents: {
                enumerable: false,
                get: getQueue,
                set: setQueue
            },
            autoRun: {
                enumerable: true,
                writable: true,
                value: true
            },
            stop: {
                enumerable: true,
                writable: true,
                value: false
            }
        });
        var queue = [];
        var running = false;
        var stop = false;
        function clearQueue() {
            queue = [];
            return queue;
        }
        function getQueue() {
            return queue;
        }
        function setQueue(val) {
            queue = val;
            return queue;
        }
        function addToQueue() {
            for (var i in arguments) {
                queue.push(arguments[i]);
            }
            if (!running && !this.stop && this.autoRun) {
                this.next();
            }
        }
        function run() {
            running = true;
            if (queue.length < 1 || this.stop) {
                running = false;
                return;
            }
            queue.shift().bind(this)();
        }
    }
    module.exports = Queue;
}, function(module, exports, __webpack_require__) {
    "use strict";
    class EventPubSub {
        constructor(scope) {
            this._events_ = {};
            this.publish = this.trigger = this.emit;
            this.subscribe = this.on;
            this.unSubscribe = this.off;
        }
        on(type, handler, once) {
            if (!handler) {
                throw new ReferenceError("handler not defined.");
            }
            if (!this._events_[type]) {
                this._events_[type] = [];
            }
            if (once) {
                handler._once_ = once;
            }
            this._events_[type].push(handler);
            return this;
        }
        once(type, handler) {
            return this.on(type, handler, true);
        }
        off(type, handler) {
            if (!this._events_[type]) {
                return this;
            }
            if (!handler) {
                throw new ReferenceError('handler not defined. if you wish to remove all handlers from the event please pass "*" as the handler');
            }
            if (handler == "*") {
                delete this._events_[type];
                return this;
            }
            const handlers = this._events_[type];
            while (handlers.includes(handler)) {
                handlers.splice(handlers.indexOf(handler), 1);
            }
            if (handlers.length < 1) {
                delete this._events_[type];
            }
            return this;
        }
        emit(type, ...args) {
            if (!this._events_[type]) {
                return this.emit$(type, ...args);
            }
            const handlers = this._events_[type];
            const onceHandled = [];
            for (let handler of handlers) {
                handler.apply(this, args);
                if (handler._once_) {
                    onceHandled.push(handler);
                }
            }
            for (let handler of onceHandled) {
                this.off(type, handler);
            }
            return this.emit$(type, ...args);
        }
        emit$(type, ...args) {
            if (!this._events_["*"]) {
                return this;
            }
            const catchAll = this._events_["*"];
            for (let handler of catchAll) {
                handler.call(this, type, ...args);
            }
            return this;
        }
    }
    module.exports = EventPubSub;
}, function(module, exports, __webpack_require__) {
    "use strict";
    const net = __webpack_require__(114), tls = __webpack_require__(115), fs = __webpack_require__(3), dgram = __webpack_require__(252), EventParser = __webpack_require__(116), Message = __webpack_require__(117);
    let Events = __webpack_require__(63);
    if (process.version[1] > 4) {
        Events = __webpack_require__(118);
    }
    let eventParser = new EventParser;
    class Server extends Events {
        constructor(path, config, log, port) {
            super();
            Object.assign(this, {
                config,
                path,
                port,
                udp4: false,
                udp6: false,
                log,
                server: false,
                sockets: [],
                emit,
                broadcast
            });
            eventParser = new EventParser(this.config);
            this.on("close", serverClosed.bind(this));
        }
        onStart(socket) {
            this.trigger("start", socket);
        }
        stop() {
            this.server.close();
        }
        start() {
            if (!this.path) {
                this.log("Socket Server Path not specified, refusing to start");
                return;
            }
            if (this.config.unlink) {
                fs.unlink(this.path, startServer.bind(this));
            } else {
                startServer.bind(this)();
            }
        }
    }
    function emit(socket, type, data) {
        this.log("dispatching event to socket", " : ", type, data);
        let message = new Message;
        message.type = type;
        message.data = data;
        if (this.config.rawBuffer) {
            this.log(this.config.encoding);
            message = new Buffer(type, this.config.encoding);
        } else {
            message = eventParser.format(message);
        }
        if (this.udp4 || this.udp6) {
            if (!socket.address || !socket.port) {
                this.log("Attempting to emit to a single UDP socket without supplying socket address or port. Redispatching event as broadcast to all connected sockets");
                this.broadcast(type, data);
                return;
            }
            this.server.write(message, socket);
            return;
        }
        socket.write(message);
    }
    function broadcast(type, data) {
        this.log("broadcasting event to all known sockets listening to ", this.path, " : ", this.port ? this.port : "", type, data);
        let message = new Message;
        message.type = type;
        message.data = data;
        if (this.config.rawBuffer) {
            message = new Buffer(type, this.config.encoding);
        } else {
            message = eventParser.format(message);
        }
        if (this.udp4 || this.udp6) {
            for (let i = 1, count = this.sockets.length; i < count; i++) {
                this.server.write(message, this.sockets[i]);
            }
        } else {
            for (let i = 0, count = this.sockets.length; i < count; i++) {
                this.sockets[i].write(message);
            }
        }
    }
    function serverClosed() {
        for (let i = 0, count = this.sockets.length; i < count; i++) {
            let socket = this.sockets[i];
            let destroyedSocketId = false;
            if (socket) {
                if (socket.readable) {
                    continue;
                }
            }
            if (socket.id) {
                destroyedSocketId = socket.id;
            }
            this.log("socket disconnected", destroyedSocketId.toString());
            if (socket && socket.destroy) {
                socket.destroy();
            }
            this.sockets.splice(i, 1);
            this.publish("socket.disconnected", socket, destroyedSocketId);
            return;
        }
    }
    function gotData(socket, data, UDPSocket) {
        let sock = this.udp4 || this.udp6 ? UDPSocket : socket;
        if (this.config.rawBuffer) {
            data = new Buffer(data, this.config.encoding);
            this.publish("data", data, sock);
            return;
        }
        if (!this.ipcBuffer) {
            this.ipcBuffer = "";
        }
        data = this.ipcBuffer += data;
        if (data.slice(-1) != eventParser.delimiter || data.indexOf(eventParser.delimiter) == -1) {
            this.log("Messages are large, You may want to consider smaller messages.");
            return;
        }
        this.ipcBuffer = "";
        data = eventParser.parse(data);
        while (data.length > 0) {
            let message = new Message;
            message.load(data.shift());
            if (message.data && message.data.id) {
                sock.id = message.data.id;
            }
            this.log("received event of : ", message.type, message.data);
            this.publish(message.type, message.data, sock);
        }
    }
    function socketClosed(socket) {
        this.publish("close", socket);
    }
    function serverCreated(socket) {
        this.sockets.push(socket);
        if (socket.setEncoding) {
            socket.setEncoding(this.config.encoding);
        }
        this.log("## socket connection to server detected ##");
        socket.on("close", socketClosed.bind(this));
        socket.on("error", function(err) {
            this.log("server socket error", err);
            this.publish("error", err);
        }.bind(this));
        socket.on("data", gotData.bind(this, socket));
        socket.on("message", function(msg, rinfo) {
            if (!rinfo) {
                return;
            }
            this.log("Received UDP message from ", rinfo.address, rinfo.port);
            let data;
            if (this.config.rawSocket) {
                data = new Buffer(msg, this.config.encoding);
            } else {
                data = msg.toString();
            }
            socket.emit("data", data, rinfo);
        }.bind(this));
        this.publish("connect", socket);
        if (this.config.rawBuffer) {
            return;
        }
    }
    function startServer() {
        this.log("starting server on ", this.path, this.port ? `:${this.port}` : "");
        if (!this.udp4 && !this.udp6) {
            this.log("starting TLS server", this.config.tls);
            if (!this.config.tls) {
                this.server = net.createServer(serverCreated.bind(this));
            } else {
                startTLSServer.bind(this)();
            }
        } else {
            this.server = dgram.createSocket(this.udp4 ? "udp4" : "udp6");
            this.server.write = UDPWrite.bind(this);
            this.server.on("listening", function UDPServerStarted() {
                serverCreated.bind(this)(this.server);
            }.bind(this));
        }
        this.server.on("error", function(err) {
            this.log("server error", err);
            this.publish("error", err);
        }.bind(this));
        this.server.maxConnections = this.config.maxConnections;
        if (!this.port) {
            this.log("starting server as", "Unix || Windows Socket");
            if (process.platform === "win32") {
                this.path = this.path.replace(/^\//, "");
                this.path = this.path.replace(/\//g, "-");
                this.path = `\\\\.\\pipe\\${this.path}`;
            }
            this.server.listen(this.path, this.onStart.bind(this));
            return;
        }
        if (!this.udp4 && !this.udp6) {
            this.log("starting server as", this.config.tls ? "TLS" : "TCP");
            this.server.listen(this.port, this.path, this.onStart.bind(this));
            return;
        }
        this.log("starting server as", this.udp4 ? "udp4" : "udp6");
        this.server.bind(this.port, this.path);
        this.onStart({
            address: this.path,
            port: this.port
        });
    }
    function startTLSServer() {
        this.log("starting TLS server", this.config.tls);
        if (this.config.tls.private) {
            this.config.tls.key = fs.readFileSync(this.config.tls.private);
        } else {
            this.config.tls.key = fs.readFileSync(`${__dirname}/../local-node-ipc-certs/private/server.key`);
        }
        if (this.config.tls.public) {
            this.config.tls.cert = fs.readFileSync(this.config.tls.public);
        } else {
            this.config.tls.cert = fs.readFileSync(`${__dirname}/../local-node-ipc-certs/server.pub`);
        }
        if (this.config.tls.dhparam) {
            this.config.tls.dhparam = fs.readFileSync(this.config.tls.dhparam);
        }
        if (this.config.tls.trustedConnections) {
            if (typeof this.config.tls.trustedConnections === "string") {
                this.config.tls.trustedConnections = [ this.config.tls.trustedConnections ];
            }
            this.config.tls.ca = [];
            for (let i = 0; i < this.config.tls.trustedConnections.length; i++) {
                this.config.tls.ca.push(fs.readFileSync(this.config.tls.trustedConnections[i]));
            }
        }
        this.server = tls.createServer(this.config.tls, serverCreated.bind(this));
    }
    function UDPWrite(message, socket) {
        let data = new Buffer(message, this.config.encoding);
        this.server.send(data, 0, data.length, socket.port, socket.address, (function(err, bytes) {
            if (err) {
                this.log("error writing data to socket", err);
                this.publish("error", (function(err) {
                    this.publish("error", err);
                }));
            }
        }));
    }
    module.exports = Server;
}, function(module, exports) {
    module.exports = require("dgram");
}, function(module, __webpack_exports__, __webpack_require__) {
    "use strict";
    __webpack_require__.r(__webpack_exports__);
    var build = __webpack_require__(64);
    var tmp = __webpack_require__(28);
    var node_ipc = __webpack_require__(2);
    var external_os_ = __webpack_require__(11);
    var source_destination = __webpack_require__(23);
    const HUMAN_FRIENDLY = {
        ENOENT: {
            title: error => `No such file or directory: ${error.path}`,
            description: () => "The file you're trying to access doesn't exist"
        },
        EPERM: {
            title: () => "You're not authorized to perform this operation",
            description: () => "Please ensure you have necessary permissions for this task"
        },
        EACCES: {
            title: () => "You don't have access to this resource",
            description: () => "Please ensure you have necessary permissions to access this resource"
        },
        ENOMEM: {
            title: () => "Your system ran out of memory",
            description: () => "Please make sure your system has enough available memory for this task"
        }
    };
    function getUserFriendlyMessageProperty(error, property) {
        var _a, _b;
        if (typeof error.code !== "string") {
            return undefined;
        }
        return (_b = (_a = HUMAN_FRIENDLY[error.code]) === null || _a === void 0 ? void 0 : _a[property]) === null || _b === void 0 ? void 0 : _b.call(_a, error);
    }
    function isBlank(s) {
        if (typeof s === "number") {
            s = s.toString();
        }
        return (s !== null && s !== void 0 ? s : "").trim() === "";
    }
    function getTitle(error) {
        const codeTitle = getUserFriendlyMessageProperty(error, "title");
        if (codeTitle !== undefined) {
            return codeTitle;
        }
        const message = error.message;
        if (!isBlank(message)) {
            return message;
        }
        const code = error.code;
        if (!isBlank(code)) {
            return `Error code: ${code}`;
        }
        return "An error ocurred";
    }
    function getDescription(error) {
        if (!isBlank(error.description)) {
            return error.description;
        }
        const codeDescription = getUserFriendlyMessageProperty(error, "description");
        if (codeDescription !== undefined) {
            return codeDescription;
        }
        if (error.stack) {
            return error.stack;
        }
        return JSON.stringify(error, null, 2);
    }
    function createError(options) {
        if (isBlank(options.title)) {
            throw new Error(`Invalid error title: ${options.title}`);
        }
        const error = new Error(options.title);
        error.description = options.description;
        if (options.report === false) {
            error.report = false;
        }
        if (options.code !== undefined) {
            error.code = options.code;
        }
        return error;
    }
    function createUserError(options) {
        return createError({
            title: options.title,
            description: options.description,
            report: false,
            code: options.code
        });
    }
    function toJSON(error) {
        return {
            name: error.name,
            message: error.message,
            description: error.description,
            stack: error.stack,
            report: error.report,
            code: error.code,
            syscall: error.syscall,
            errno: error.errno,
            stdout: error.stdout,
            stderr: error.stderr,
            device: error.device
        };
    }
    function fromJSON(json) {
        return Object.assign(new Error(json.message), json);
    }
    const SUCCESS = 0;
    const GENERAL_ERROR = 1;
    const VALIDATION_ERROR = 2;
    const CANCELLED = 3;
    var axios = __webpack_require__(42);
    var axios_default = __webpack_require__.n(axios);
    function isValidPercentage(percentage) {
        return typeof percentage === "number" && percentage >= 0 && percentage <= 100;
    }
    function percentageToFloat(percentage) {
        if (!isValidPercentage(percentage)) {
            throw createError({
                title: `Invalid percentage: ${percentage}`
            });
        }
        return percentage / 100;
    }
    async function getConfig(configUrl) {
        configUrl = configUrl !== null && configUrl !== void 0 ? configUrl : "https://balena.io/etcher/static/config.json";
        const response = await axios_default.a.get(configUrl, {
            responseType: "json"
        });
        return response.data;
    }
    async function delay(duration) {
        await new Promise(resolve => {
            setTimeout(resolve, duration);
        });
    }
    node_ipc["config"].id = process.env.IPC_CLIENT_ID;
    node_ipc["config"].socketRoot = process.env.IPC_SOCKET_ROOT;
    node_ipc["config"].silent = true;
    node_ipc["config"].stopRetrying = 0;
    const DISCONNECT_DELAY = 100;
    const IPC_SERVER_ID = process.env.IPC_SERVER_ID;
    function log(message) {
        node_ipc["of"][IPC_SERVER_ID].emit("log", message);
    }
    async function terminate(exitCode) {
        node_ipc["disconnect"](IPC_SERVER_ID);
        await Object(tmp["cleanupTmpFiles"])(Date.now());
        process.nextTick(() => {
            process.exit(exitCode || SUCCESS);
        });
    }
    async function handleError(error) {
        node_ipc["of"][IPC_SERVER_ID].emit("error", toJSON(error));
        await delay(DISCONNECT_DELAY);
        await terminate(GENERAL_ERROR);
    }
    async function writeAndValidate({source, destinations, verify, autoBlockmapping, decompressFirst, onProgress, onFail}) {
        const {sourceMetadata, failures, bytesWritten} = await build["multiWrite"].decompressThenFlash({
            source,
            destinations,
            onFail,
            onProgress,
            verify,
            trim: autoBlockmapping,
            numBuffers: Math.min(2 + (destinations.length - 1) * 32, 256, Math.floor(Object(external_os_["totalmem"])() / 1024 ** 2 / 8)),
            decompressFirst
        });
        const result = {
            bytesWritten,
            devices: {
                failed: failures.size,
                successful: destinations.length - failures.size
            },
            errors: [],
            sourceMetadata
        };
        for (const [destination, error] of failures) {
            const err = error;
            const drive = destination;
            err.device = drive.device;
            err.description = drive.description;
            result.errors.push(err);
        }
        return result;
    }
    node_ipc["connectTo"](IPC_SERVER_ID, () => {
        Object(tmp["cleanupTmpFiles"])(Date.now() - 60 * 60 * 1e3);
        process.once("uncaughtException", handleError);
        process.once("SIGINT", async () => {
            await terminate(SUCCESS);
        });
        process.once("SIGTERM", async () => {
            await terminate(SUCCESS);
        });
        node_ipc["of"][IPC_SERVER_ID].on("error", async () => {
            await terminate(SUCCESS);
        });
        node_ipc["of"][IPC_SERVER_ID].on("disconnect", async () => {
            await terminate(SUCCESS);
        });
        node_ipc["of"][IPC_SERVER_ID].on("write", async options => {
            const onProgress = state => {
                node_ipc["of"][IPC_SERVER_ID].emit("state", state);
            };
            let exitCode = SUCCESS;
            const onAbort = async () => {
                log("Abort");
                node_ipc["of"][IPC_SERVER_ID].emit("abort");
                await delay(DISCONNECT_DELAY);
                await terminate(exitCode);
            };
            const onSkip = async () => {
                log("Skip validation");
                node_ipc["of"][IPC_SERVER_ID].emit("skip");
                await delay(DISCONNECT_DELAY);
                await terminate(exitCode);
            };
            node_ipc["of"][IPC_SERVER_ID].on("cancel", onAbort);
            node_ipc["of"][IPC_SERVER_ID].on("skip", onSkip);
            const onFail = (destination, error) => {
                node_ipc["of"][IPC_SERVER_ID].emit("fail", {
                    device: destination.drive,
                    error: toJSON(error)
                });
            };
            const destinations = options.destinations.map(d => d.device);
            const imagePath = options.image.path;
            log(`Image: ${imagePath}`);
            log(`Devices: ${destinations.join(", ")}`);
            log(`Umount on success: ${options.unmountOnSuccess}`);
            log(`Validate on success: ${options.validateWriteOnSuccess}`);
            log(`Auto blockmapping: ${options.autoBlockmapping}`);
            log(`Decompress first: ${options.decompressFirst}`);
            const dests = options.destinations.map(destination => new build["sourceDestination"].BlockDevice({
                drive: destination,
                unmountOnSuccess: options.unmountOnSuccess,
                write: true,
                direct: true
            }));
            const {SourceType} = options;
            try {
                let source;
                if (options.image.drive) {
                    source = new source_destination["BlockDevice"]({
                        drive: options.image.drive,
                        direct: !options.autoBlockmapping
                    });
                } else {
                    if (SourceType === source_destination["File"].name) {
                        source = new source_destination["File"]({
                            path: imagePath
                        });
                    } else {
                        source = new source_destination["Http"]({
                            url: imagePath,
                            avoidRandomAccess: true
                        });
                    }
                }
                const results = await writeAndValidate({
                    source,
                    destinations: dests,
                    verify: options.validateWriteOnSuccess,
                    autoBlockmapping: options.autoBlockmapping,
                    decompressFirst: options.decompressFirst,
                    onProgress,
                    onFail
                });
                log(`Finish: ${results.bytesWritten}`);
                results.errors = results.errors.map(error => toJSON(error));
                node_ipc["of"][IPC_SERVER_ID].emit("done", {
                    results
                });
                await delay(DISCONNECT_DELAY);
                await terminate(exitCode);
            } catch (error) {
                log(`Error: ${error.message}`);
                exitCode = GENERAL_ERROR;
                node_ipc["of"][IPC_SERVER_ID].emit("error", toJSON(error));
            }
        });
        node_ipc["of"][IPC_SERVER_ID].on("connect", () => {
            log(`Successfully connected to IPC server: ${IPC_SERVER_ID}, socket root ${node_ipc["config"].socketRoot}`);
            node_ipc["of"][IPC_SERVER_ID].emit("ready", {});
        });
    });
} ]);